{{Utilisateur:EDUCA33E/LiveRC/Navigation}}
{{Archives|[[Discussion MediaWiki:Gadget-LiveRC.js/Archive 1|Archive 1]]}}

== Ce que l'on stocke dans le LiveRCParam.js ==

Hello {{sourire}},

Je n'ai pas le temps de me pencher là-dessus cette semaine, mais pour ne pas oublier : il faudrait faire du ménage dans le LiveRCParam.js et n'y écrire que les options qui ne sont pas identiques aux valeurs par défaut.
Actuellement, tout est écrit, du coup les mises à jour ne sont pas propagées {{=/}}.

Tant que j'y suis, une idée d'optim était de stocker dans ce fichier les messages système utilisés : on évite complètement la requête HTTP pour les messages et chaque extension de LiveRC peut stocker ses propres messages système en sus de ceux utilisés par le LiveRC de base.

Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 18 mars 2011 à 21:52 (CET)
:J'y avais pensé lors de la mise en place du système.
:Mais il y a un sérieux écueil : Comment faire pour distinguer une variable originale (issue de [[User:EDUCA33E/LiveRC.js]]) et une variable personnalisée (issue de [[Special:MyPage/LiveRCparam.js|User:<Pseudo>/LiveRCparam.js]]) ? Les deux ont par définition le même nom, et une fois le LiveRCparam chargé, il est impossible de savoir si on a affaire à une variable personnalisée ou non. Lors de la sauvegarde de la config perso, on ne peut donc pas définir quelles variables sont à personnaliser et lesquelles ne le sont pas, c'est la raison pour laquelle l'ensemble des variables est sauvegardée.
:Pour le problème de la propagation des mises à jour, ce n'est pas vraiment un problème :
:*Les variables susceptibles d'être implémentées (par exemple <tt>lrcParams</tt>) sont enregistrées sous la forme <tt>lrcParams["Index"] = "Valeur";</tt>, on peut donc ajouter une entrée à <tt>lrcParams</tt>, celle ci sera alors prise en compte.
:*Pour les autres variables par contre (liste de bandeaux, de modèles d'avertissement, résumés de blanchiment), l'Array est entièrement recréée, ce qui donne à chacun la possibilité de supprimer les entrées qu'il ne veut pas ou dont il n'a pas besoin. S'ensuit fatalement que si un modèle de bandeau est ajouté au code principal, il ne sera pas pris en compte. Les seules solutions pour avoir ces éventuelles nouvelles entrées consiste donc à blanchir le LiveRCparam (manuellement ou via le bouton {{Touche|RAZ}}) et refaire la personnalisation, ou à les ajouter "manuellement" dans l'interface de personnalisation.
:Je ne vois pas de solutions probante pour avoir un meilleur système, mais si tu trouves je suis preneur.
:<hr/>
:Pour les messages systèmes, c'est pas si simple. On peut effectivement sauvegarder des messages système dans une Array du LiveRCparam (sous la première forme, qui autorise à en ajouter d'autres ultérieurement). Mais si tous les messages nécessaires n'y sont pas (extensions), il faudra quand même passer par une requête, et ce tant que la config avec tous les messages système nécessaires ne sera pas sauvegardée, ce qui limite le gain éventuel (au lieu de 20 messages, on n'en requerra qu'un ou deux, mais le temps sera grosso-modo identique).
:A ce compte-là, il faudrait alors sauvegarder TOUS les messages système (avec la requête complète donc)
:* au premier lancement de LiveRC si il manque des messages, il faudrait alors enjoindre l'utilisateur à sauvegarder sa config pour lui éviter la requête par la suite (ou procéder à une édition automatique, mais j'imagine que ça va faire grincer des dents... on peut éventuellement le faire après une pop-up d'avertissement)
:* à chaque changement de config, en refaisant la requête complète à ce moment-là (pour tenir compte des éventuels changements dans les messages système)
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 18 mars 2011 à 22:44 (CET)
::* « comment faire pour distinguer une variable originale [...] et une variable personnalisée » : ben la variable personnalisée n'a pas la même valeur que la variable originale… j'ai manqué une subtilité ? Il suffirait de stocker les valeurs par défaut dans un objet différent de celui qui est utilisé pour l'affichage, de cloner cet objet pour l'affichage et de ne modifier que le clone avec le LiveRCParam. Lors de la sauvegarde, on ne garde que ce qui a changé entre le clone et l'original.
::* Pour les mises à jour, le problème est réel : regarde celle que j'ai faite aujourd'hui (0.4.6b) : j'ai ajouté une infobulle qui manquait, mais tous ceux qui ont un LiveRCParam ne vont pas en bénéficier {{=/}}. Même problème avec ma dernière contribution (0.4.6) : une option a changé de description… sauf que les utilisateurs ne le savent pas {{=/}} {{=/}}.
::* Pour les bandeaux et modèles, je n'y avais pas pensé, je vais y réfléchir un peu.
::* Pour les messages systèmes, tu as tout bon {{clin}}. Je vois le truc comme une procédure d'installation :
::** premier lancement de LiveRC ⇒ popup pour créer le LiveRCParam et récupération des messages systèmes ''utiles''
::** mise à jour de LiveRC nécessitant un nouveau message système ⇒ popup, récupération, ''etc''.
::** changement d'un message système utilisé par LiveRC ⇒ on simule une mise à jour de LiveRC
::** installation d'une extension ⇒ modification du LiveRCParam de toutes façons, donc récupération des messages système au passage.
::Et non, effectivement, pas de requête automatique… au pire, si l'utilisateur refuse, on se rabat sur la requête complète (coûteuse) à chaque lancement, mais là il ne peut plus reprocher les problèmes de perf aux développeurs.
::Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 18 mars 2011 à 23:37 (CET)
:::# Ça veut dire qu'il faut doubler le nombre de variables. Ouch ! Y'en a déjà un paquet...
:::# Si, ils l'auront, une fois que tu l'auras mis dans la variable appropriée (cf. message sur ta pdd). Les tooltips font partie de la première sorte de variables, où chaque entrée de l'Array est personnalisée indépendamment des autres (regarde ton LiveRCparam, à la section <tt>lang_tooltip</tt>).
:::Messages système : on peut tout aussi bien regrouper les deux premiers points en requérant TOUS les messages systèmes. A partir du moment où ça n'a lieu que lors du premier lancement, ça n'est pas très pénalisant. A partir de là, les seules mises à jour nécessaires (avec requête donc, complète ou non) seraient effectuées :
:::* Lors d'une sauvegarde de la config (requête complète)
:::* Si un message système est manquant (nouvelle extension mediawiki par exemple, cas assez rare) (requête du/des message(s) manquant(s) )
:::Les deux requêtes (complète ou non) pourraient tout à fait être effectuées par la même fonction.
:::En passant, je pense que malgré le fait que la mise à jour passerait par le module de personnalisation, les messages systèmes ne devraient pas être personnalisables (bien qu'ils le seront de toutes manières directement via le LiveRCparam).
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 18 mars 2011 à 23:54 (CET)
::::# Pas forcément : si on stocke ça dans un objet (tableau associatif), ça fait deux objets au lieu d'un, c'est raisonnable {{sourire}}.
::::# Je crois à la lecture de ma PdD que tu viens de voir le problème {{clin}}.
::::Le problème de récupérer ''tous'' les messages système (avec les css, js…, ''etc.'' — en gros ce que j'ai viré dans la 0.4.6), c'est que recopié dans le LiveRCParam ou pas, c'est le même coût : les navigateurs ne permettent pas de purger le cache de façon sélective (sans même parler de quand tu changes de machine). Donc il faudrait faire la grosse requête pour l'API ou pour le LiveRCParam, c'est trop coûteux.
::::D'accord sur la « non personnalisation » (à moins que quelqu'un réclame, mais bon {{clin}}), ça risque vite de rendre les options impraticables. — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 19 mars 2011 à 00:23 (CET)
:::::Grosse requête pour le LiveRCparam ? Mais de quoi tu parles ? De la requête <tt>LiveRC_ManageParams_GetOldParamsOldid()</tt>/ <tt>LiveRC_ManageParams_GetOldParams()</tt> ? 
:::::Celle-ci est en asynchrone et n'est pas nécessaire au démarrage de LiveRC. Elle ne sert que pour connaître les extensions déjà installées, au niveau de l'affichage du menu de personnalisation. Donc dans l'optique où on effectue la requête complète (en éliminant après la requête API initiale les messages les plus lourds, .js et .css) qu'elle soit longue n'a donc pas d'incidence sur le chargement. Au pire, il est possible de stocker ces messages sur une autre page (mais ça complique un peu la sauvegarde), voire peut-être modifier la façon dont sont stockés les différentes variables pour mettre les extensions dans une section spécifique (section 0 ?), ce qui raccourcirait la requête, celle-ci n'étant plus impactée par ce qui se trouve ou pas dans les autres sections.
:::::Après, la page où sont stockés les messages est en cache, donc le temps de chargement ne joue plus tellement.
:::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 19 mars 2011 à 01:36 (CET)
::::::Bon, j'ai commencé à plancher sur la sauvegarde des messages système :
::::::* Nouvelle variable [[Utilisateur:Dr Brains/LiveRC.js/Miroir#Autres variables personnalisables|<tt>lrcNeededMessages</tt>]], contenant les messages nécessaires (assurant la possibilité à des extensions d'en ajouter d'autres
::::::* Nouvelle fonction [[Utilisateur:Dr Brains/LiveRC.js/Miroir#Allmessages|<tt>LiveMessages()</tt>]] assurant le lancement de la requête (avec tri si c'est le premier appel ou requête "complète" (<tt>lrcNeededMessages</tt>) sinon)
::::::* Ajout des Messages dans la fonction [[Utilisateur:Dr Brains/LiveRC.js/Miroir#Module de gestion des variables|<tt>LiveRC_ManageParams_CreateNewParamPage()</tt>]].
::::::Tout cela fonctionne correctement, à un petit détail près : lors de la sauvegarde de la config, j'appelle <tt>LiveMessages(false)</tt>, le <tt>false</tt> ayant pour effet d'inclure tous les messages nécessaires dans la requête (et pas seulement les manquants) et de lancer la requête en mode synchrone. Cette deuxième particularité ne fonctionne pas, aussi si d'aventure un message système était modifié ([http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/LiveRCparam.js&diff=next&oldid=63360656]), la mise à jour ne s'effectue pas, la page étant sauvée avant la fin de la requête. Là où ça devient comique, c'est que si on refait une sauvegarde (la requête ayant théoriquement fini de mettre à jour les messages), ça ne fonctionne toujours pas.
::::::Il doit y avoir quelque chose que je fais mal, mais je ne vois pas quoi. Un avis sur la question ?
::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 19 mars 2011 à 17:34 (CET)
:::::::Bon, je n'ai pas pu régler le pb alors j'ai fait autrement. Je récapitule :
:::::::* Nouvelle variable [[Utilisateur:Dr Brains/LiveRC.js/Miroir#Autres variables personnalisables|<tt>lrcNeededMessages</tt>]], contenant les messages nécessaires (assurant la possibilité à des extensions d'en ajouter d'autres)
:::::::* Nouvelle fonction [[Utilisateur:Dr Brains/LiveRC.js/Miroir#Allmessages|<tt>LiveMessages()</tt>]] assurant le lancement de la requête (avec tri si c'est le premier appel ou requête "complète" sinon)
:::::::* Ajout d'un bouton supplémentaire {{Touche|Messages système}} dans le menu de personnalisation pour les sysops (droit "edituserjs") lié à une nouvelle fonction qui met à jour tous les messages utilisés. Ceux-ci sont sauvegardés dans la page [[User:EDUCA33E/LiveRC/Messages.js]] (chargée au démarrage pour tous, évidemment).
:::::::Avec ce nouveau système, ce sont les sysops qui ont donc la charge de mettre à jour la liste de messages sur une page commune. Ils mettent à jour non seulement les messages standards utilisés (leur <tt>lrcNeededMessages</tt>) mais également ceux définis dans la page et qu'ils n'utilisent pas (ajoutés par des extensions qu'ils n'utilisent pas forcément au moment de la mise à jour, mais qu'ils ont quand même stockés dans la variable <tt>lrcMediawikiMessages</tt>).
:::::::Dans le cas où une nouvelle extension apparaît, nécessitant des messages non sauvegardés, la requête au démarrage de LiveRC est lancée, ce qui permet à tous de bénéficier de l'extension sans qu'il y ait eu de mise à jour. Par la suite, pour effectuer la mise à jour, il suffit qu'un sysop 
:::::::* charge cette extension et fasse une mise à jour de la page
:::::::* ou ajoute les messages manuellement. 
:::::::De cette manière les autres sysops qui n'ont pas forcément chargé l'extension en question pourront mettre à jour à leur tour. Cela signifie que tout sysop faisant une mise à jour '''doit avoir rechargé son cache il y a peu''', sans quoi il risque d'effacer des variables (ce qui en soi n'est pas très grave puisqu'une requête permet de pallier à une telle absence, mais quand même...).
:::::::Vous pouvez tester ma [[Utilisateur:Dr Brains/LiveRC.js|Version perso]], histoire de voir si il n'y a pas de bug qui m'auraient échappé. Je transfèrerai ensuite sur la version courante.
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 19 mars 2011 à 21:59 (CET)
::::::::Suite à la mise en place du préchargement par Orlodrim (cf plus bas), j'ai implémenté cette amélioration que j'avais dans les tuyaux.
::::::::Cela apporte deux améliorations :
::::::::* possibilité de se passer complètement de la requête des messages système, ceux-ci étant préchargé via une [[utilisateur:EDUCA33E/LiveRC/Messages.js|sous-page]]
::::::::* facilité pour les extensions d'ajouter un message système à la liste (Array <tt>lrcNeededMessages</tt>)
::::::::La liste peut être mise à jour par n'importe quel sysop via bouton supplémentaire dans le menu de personnalisation.
::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 26 avril 2011 à 02:41 (CEST)
:::::::::Bravo ! {{sourire}}. Il y aurait encore un gain si chacun gardait une copie dans son LiveRCParam.js : puisque celui-ci est de toutes façons chargé, on aurait une requête en moins. — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 26 avril 2011 à 19:52 (CEST)
:::::::::Certes, mais dans le LiveRCparam, des utilisateurs seraient tentés de les personnaliser, ce qu'il ne faut pas. En étant dans une sous-page .js appartenant à EDUCA33E, ces variables sont protégées, tout en étant facilement mises à jour par n'importe quel sysop.
:::::::::Tu parles de la requête php consistant à charger la page [[Utilisateur:EDUCA33E/LiveRC/Messages.js]] ? Si c'est juste ça, je ne pense pas que ce soit un pb, d'une part parce qu'elle est en cache, d'autre part parce que de toutes manières le temps de chargement est négligeable comparé aux autres requêtes effectuées en Ajax.
:::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 26 avril 2011 à 20:47 (CEST)

== Y voir un peu plus clair dans les pdD des vandales multi-récidivistes ==

Bonjour, peut-on envisager de mettre un titre de section devant les messages d'avertissement, histoire d'y voir plus claire sur les pdD des vandales multi-récidivistes? Merci. [[Utilisateur:Nakor|Nakor]] ([[Discussion utilisateur:Nakor|d]]) 18 mars 2011 à 22:10 (CET)
:Il faudrait peut-être modifier les modèles directement, non ?
:Certains incluent déjà un titre, et ça permettrait de ne pas régler le problème que pour LiveRC (on pose aussi des modèles à la main).
:Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 18 mars 2011 à 23:40 (CET)
::Effectivement merci. [[Utilisateur:Nakor|Nakor]] ([[Discussion utilisateur:Nakor|d]]) 19 mars 2011 à 00:16 (CET)
:::Pensez dans ce cas à utiliser la syntaxe <code><nowiki><h2>...</h2></nowiki></code> et non <code><nowiki>==...==</nowiki></code> pour éviter que le lien « modifier » de la section ne conduise à l'édition du modèle (et non de la page où il est apposé). Cordialement, --[[Utilisateur:Lgd|Lgd]] ([[Discussion utilisateur:Lgd|d]]) 19 mars 2011 à 06:09 (CET)

== Avertissements et listes de suivis ==

Bonjour,

Il y a quelques temps, j'ai coché dans mes préférences l'option permettant d'ajouter les pages que je créée à ma liste de suivi. Pratique. Et surtout, si je le souhaite, je peux annuler le suivi en décochant un case. Mais le problème vient de LRC : lorsque je laisse un avertissement quelconque à une IP, hop, sa PDD est ajoutée à ma watchlist. Je dois donc retirer par dizaines de PDD d'utilisateurs auxquels j'ai juste laissé un premier avertissement. Y aurait-il moyen de court-circuiter l'ajout uniquement avec LiveRC ? Merci --'''<font face="sans-serif">[[Discussion Utilisateur:Pic-Sou|{{vert|Pic}}]][[Utilisateur:Pic-Sou|-]][[Spécial:Contributions/Pic-Sou|{{bleu|Sou}}]]</font>''' 20 mars 2011 à 12:51 (CET)

==LiveRC vs [[Spécial:Modifications récentes]]==
Bonjour, aujourd'hui, j'ai comparé l'évolution des modifications et j'ai remarqué qu'il y a une bonne différence entre les deux pages. En effet, beaucoup de changement apparaissent sur Modifications récentes mais pas LiveRC. Est-ce moi le problème ou mes paramètres ou un problème dans LiveRC.
Merci,
[[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 25 mars 2011 à 19:26 (CET)
:LiveRc ne montre les logs (journaux) que si la case idoine est cochée.
:Sinon, ce devrait être identique, à ceci près que pour une page donné, seule la dernière modif apparaît sur LiveRC (d'ailleurs cela pourrait être optionnel de garder TOUTES les modifs, à voir).
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 25 mars 2011 à 19:45 (CET)
::J'aimerais t'en parler sur le IRC des patrouilleurs si tu as quelques minutes. Amicalement,[[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 27 mars 2011 à 05:39 (CEST)

== Deux requêtes pour amélioration ==

Bonjour, j'ai deux améliorations à suggérer : 
* Serait-il possible que la fonction "Pause" soit associée à un raccourci clavier ? 
* Serait-il possible d'ajouter la fonction "suivre l'article" à l'ensemble des opérations disponibles lorsqu'on visualise un diff ? 

Merci d'avance, --[[Utilisateur:Maurilbert|M<span class="romain">aurilbert</span>]] [[Discussion Utilisateur:Maurilbert|''<font face="Times">(discuter)</font>'']] 26 mars 2011 à 18:10 (CET)

== Préchargement des diff ==

Bonjour,

J'ai implémenté un préchargement des diff lorsqu'on clique sur "Suivant" (ainsi, l'affichage est instantané si on les examine dans l'ordre). Vous pouvez tester sur [[Utilisateur:Orlodrim/LiveRC.js]]. S'il n'y a pas de bugs et pas d'objections, je reporterai ça dans la version principale.

[[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 26 mars 2011 à 21:01 (CET)
:Mmh, l'idée est intéressante, mais demande plus ample optimisation. Au vu du code (sans avoir testé, donc), j'ai quelques questions/remarques :
:* fonction <tt>getRC()</tt> : pourquoi y coller un <tt>goNext(2);</tt> ? Quel est le but ? Si il s'agit juste de mettre à jour <tt>lrcAllLinesSeen</tt>, autant le faire directement. Cet endroit-ci du code n'étant par ailleurs pas particulièrement le plus approprié, amha
:* fonction <tt>getRevision()</tt> : 
:** la ligne <tt>  lrcLines[lineUID] = {tr1: tr1, title: title, user: user, revid: revid, oldid: oldid, state: state};</tt> gagnerait à être remplacée par un simple <tt>lrcLines[lineUID] = rc;</tt>
:** le hook ( <tt>LiveRC_RunHooks("AfterRC", {id:tr1.id, rc:rc});</tt> ) devrait rester la dernière ligne de code de la fonction.
:* <tt>wpajax</tt> : les gros changements effectués sur cette fonction centrale devraient être testés sur tous les navigateurs.
:En attente d'explications/éclaircissements, cordialement, 
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 26 mars 2011 à 22:42 (CET)
::* Seul le diff suivant un diff prévisualisé est préchargé. Il peut être nécessaire de faire un préchargement à deux moments : clic sur "Suivant" et ajout de nouvelles lignes (mais seulement si toutes les précédentes ont été prévisualisées). Si les lignes étaient ajoutées directement, il suffirait de tester au début de getRC si toutes les lignes sont déjà vues et si oui, appeler preload à la première ligne ajoutée. Mais comme les lignes ne sont ajoutées qu'après l'exécution d'une requête, il faut différer. La variable lrcAllLinesSeen n'est utile qu'entre ces deux instants (appel de getRC et affichage de la première ligne).<br />Par ailleurs, déterminer s'il existe une ligne déjà vue n'est pas immédiat, j'ai donc utilisé le code existant de goNext en mettant un argument dont la signification est la suivante : mode = 0 -> afficher le premier diff non vu et précharger le suivant, mode = 1 -> précharger le premier diff non vu, mode = 2 -> tester s'il existe un diff non vu et mettre à jour lrcAllLinesSeen si ce n'est pas le cas.
::* getRevision
::**Oui
::**Non, car le hook peut supprimer la ligne, auquel cas la fonction de préchargement ne doit pas être appelée et lrcAllLinesSeen ne doit pas être mis à false.
::*Je vais vérifier pour ceux que j'ai sous la main, mais je ne peux pas tout tester, notamment Safari (c'est pour ça que je demande ici...).
::[[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 26 mars 2011 à 23:34 (CET)
:::Argh, après réflexion, je viens de comprendre qu'il y a une potentiellement grosse faille dans ce système : une ligne de diff peut être supprimée '''après''' un éventuel préchargement. Exemple :
:::* Situation initiale : toutes les lignes ont été visualisées, pas de prévisualisation préchargée.
:::* Deux RC apparaissent
:::* clic sur {{Touche|Suivant}} : prévisualisation (avec requête) de la première et préchargement de la deuxième
:::* pendant le temps que prend la vérification du diff, Salebot ou un autre patrouilleur annule la deuxième modif et une autre requête RC aboutit : la deuxième modif est supprimée des RC et est remplacée par le revert
:::* clic sur {{Touche|Suivant}}
:::Que se passe-t-il ?
:::Visualise-t-on l'ancienne modif préchargée (comportement fautif) ou prévisualise-t-on (avec requête) le revert (comportement normal) ?
:::Le problème est identique dans le cas où la ligne serait supprimée
:::* par une extension LiveRC (rapport au hook qui doit être en dernier)
:::* par l'utilisateur lui-même si il clique sur une des croix de la barre d'options ou la croix de la ligne RC
:::Pour pallier à ce défaut, il faudrait, dans la fonction <tt>goNext()</tt> 
:::# vérifier la première ligne de diff non vérifiée : 
:::#* si elle correspond à une requête préchargée, lancer la prévisualisation du diff préchargé
:::#* sinon, lancer la prévisualisation en mode classique
:::# vérifier la ligne de diff non vérifiée suivante (si elle existe) et lancer son préchargement
:::J'ai l'impression que ce n'est pas le cas actuellement <s>( il manque un "else" après le test <tt>if(ln.title && ln.revid && ln.oldid){</tt> )</s><small>Non, c'est plus compliqué que ça</small>
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 27 mars 2011 à 00:13 (CET)
::::Si une ligne est supprimée parce que l'article est à nouveau modifié, alors je ne fais rien, volontairement. J'ai fait en sorte qu'il y ait au plus ''un'' appel à la fonction de préchargement pour chaque ligne effectivement visualisée. Ça n'entraîne pas de bug : quand la ligne n'a pas été préchargée, elle est chargée normalement. [[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 27 mars 2011 à 00:28 (CET)
::::NB : le test "if (ln.title && ln.revid && ln.oldid)" est temporaire, il est là parce que tous les cas ne sont pas encore gérés (seules les lignes correspondant à des diff peuvent être préchargées pour l'instant). Mais je ne pense pas qu'il manque quelque chose. [[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 27 mars 2011 à 00:36 (CET)
:::::En fait, j'ai du mal à comprendre comment tu fais pour récupérer le résultat du préchargement. Je suppose que la solution se trouve dans les modifications apportées à <tt>wpajax</tt>, peut-être liée à la variable <tt>.state</tt>, mais je n'ai pas encore percé toutes les subtilités du procédé. Je regarderai ça demain, après une bonne nuit de sommeil.
:::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 27 mars 2011 à 05:08 (CEST)
:Bon, un mois après, je n'ai toujours pas eu / pris le temps de jeter un coup d'œil au code… {{=/}}.
:Par contre, là, je viens de tester est mon commentaire sera tout simplement « <big><big>Purée c'est génial ! Ça change la vie ce truc !</big> C'est toute ma vision de la patrouille en temps réel qui est chamboulée {{mdr}} </big> ». Voila.
:Je ne sais pas s'il y a eu beaucoup de tests, mais mon à priori sur la question sans avoir vérifié le code est extrêmement favorable… vivement l'intégration que tout le monde en profite ! — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 25 avril 2011 à 08:26 (CEST)
::J'avais complètement oublié. J'ai testé avec Firefox 3.0-3.6, IE 8, Opera et Chrome. La compatibilité avec Konqueror a été cassée par une modification antérieure, je n'ai pas essayé de réparer. C'est mis à jour (désactivable dans les options si besoin). [[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 25 avril 2011 à 11:09 (CEST)

== firebug ==

Hello !

Alors je n'ai pas vérifié d'où cela venait exactement mais... lorsque la connexion internet saute, ajax essaye et réessaye de charger les pages, je me suis retrouvé avec 25000 erreurs JavaScript (d'après firebug) qui ne cessait d'amplifier alors même que j'avais retrouvé ma connexion. Problème résolu en rafraîchissant la page, donc pas important en soit, mais je le signale au cas où. [[User:Micthev|<u>''Micthev''</u>]] <sup>([[User talk:Micthev|<small>discuter</small>]])</sup> 12 avril 2011 à 14:21 (CEST)
:C'est normal (enfin presque).
:Le timeout de la recherche RC est mis à jour à la fin de la requête (fin de la fonction <tt>getRC()</tt> ). Mais il arrivait qu'un bug durant une requête fasse planter le programme avant et le rafraichissement ne se faisait alors plus. c'est pourquoi un timeout "de sécurité" est ajouté au début de la requête (début de la fonction <tt>liveRC()</tt> ). Ce timeout fait 5 secondes de plus que le timeout "normal", ce qui fait qu'il ne s'active que si celui de fin de fonction n'est pas atteint (le traitement d'une requête RC atteint rarement voire jamais 5 secondes, sauf connexion super lente).
:Mais c'est vrai qu'en cas de perte de la connexion, une requête est ainsi lancée régulièrement, aboutissant à chaque fois à une erreur (jusqu'à retrouver la connexion, en théorie. Ce qui t'est arrivé n'est donc pas complètement normal).
:On pourrait éviter cela en mettant un compteur sur ce premier timeout : au bout de X requêtes effectuées sans succès, on coche automatiquement la case '''pause''', ce qui bascule sur un timeout moins lourd (au délai plus cout mais ne lançant pas de requête). Ce sera alors à l'utilisateur de la décocher lorsque la connexion sera revenue.
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 12 avril 2011 à 14:44 (CEST)
::Cela pourrait en effet être une solution. Ce n'est pas dérangeant en soit mais je me suis aperçu de ce bogue et c'est bien connu que c'est en corrigeant multitude de petits bogues qu'on frôle la perfection {{clin}}. [[User:Micthev|<u>''Micthev''</u>]] <sup>([[User talk:Micthev|<small>discuter</small>]])</sup> 12 avril 2011 à 15:10 (CEST)
:::{{Fait}} '''[http://fr.wikipedia.org/w/index.php?title=Utilisateur:EDUCA33E/LiveRC.js&diff=64769172&oldid=64696764 Fait]'''. J'ai défini la limite à 4 requêtes. A la 5{{e}}, ça se met automatiquement en pause.
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 27 avril 2011 à 18:27 (CEST)
:::: Merci [[User:Micthev|<u>''Micthev''</u>]] <sup>([[User talk:Micthev|<small>discuter</small>]])</sup> 27 avril 2011 à 18:30 (CEST)

== Thème « Vector » pour LiveRC ==
Bonjour,
J'ai créé un thème pour LiveRC, qui fournit une meilleure intégration à Vector (c'est-à-dire le dernier thème de Wikipedia). Une capture d'écran est disponible <span class="plainlinks">[http://pix.toile-libre.org/upload/original/1298575502.png ici]</span>. Pour l'utiliser, il suffit d'ajouter le texte suivant à votre [[Spécial:Ma page/vector.css|vector.css]] :

<source lang="css">
/* Début du thème LiveRC */

.page-Utilisateur_EDUCA33E_LiveRC #content {
	padding: 0;
	border: 1px solid #a7d7f9;
	background: white;
	margin-right: 0;
	padding-top: 5px;
	padding-bottom: 5px;
	position: relative;
	top: -41px;
	border-right: none;
	z-index: 500;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #p-logo a {
	background: url('http://upload.wikimedia.org/wikipedia/commons/thumb/b/b2/LiveRC.svg/135px-LiveRC.svg.png') no-repeat !important;
	margin-left: 11px;
	margin-top: 15px;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #mw-page-base {
	background-position: 0 -4px;
	background-color: #f6f6f6;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #content *:not(td):not(input):not(select) {
	border-left: none !important;
	border-right: none !important;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #tabRC {
	border: 1px solid #ccccda !important;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #content td[width="25%"] {
	border: none;
	padding-top: 10px;
	padding-bottom: 10px;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #content td[width="25%"] sup {
	vertical-align: middle;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #mw-head-base, #livePreviewTitle u, .page-Utilisateur_EDUCA33E_LiveRC #top, .page-Utilisateur_EDUCA33E_LiveRC #topbar, .page-Utilisateur_EDUCA33E_LiveRC #siteSub, .page-Utilisateur_EDUCA33E_LiveRC #sitesub, .page-Utilisateur_EDUCA33E_LiveRC #contentSub, .page-Utilisateur_EDUCA33E_LiveRC #subtitle, .page-Utilisateur_EDUCA33E_LiveRC #RealTitleBanner, .page-Utilisateur_EDUCA33E_LiveRC #RealTitle, .page-Utilisateur_EDUCA33E_LiveRC #p-cactions, .page-Utilisateur_EDUCA33E_LiveRC #left-navigation, .page-Utilisateur_EDUCA33E_LiveRC #right-navigation, .page-Utilisateur_EDUCA33E_LiveRC #subpages, .page-Utilisateur_EDUCA33E_LiveRC #footer, .page-Utilisateur_EDUCA33E_LiveRC #firstHeading {
	display: none !important;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #bodyContent {
	background: none;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #bodyContent > table, #livePreviewTitle, #divLivePreview, #livePreview, #livePreviewFoot {
	border: none !important;
	background: none !important;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #livePreview {
	border-bottom: 1px solid #ccccda !important;
}
 
#livePreviewFoot {
	padding: 10px;
	padding-bottom: 15px;
}
 
#livePreviewTitle table {
	margin-bottom: 5px;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #bodyContent > table tbody *, .page-Utilisateur_EDUCA33E_LiveRC #bodyContent > table tbody {
	background: none;
}
 
.page-Utilisateur_EDUCA33E_LiveRC #bodyContent li {
	list-style: none;
}
 
.page-Utilisateur_EDUCA33E_LiveRC a[title="Supprimer les lignes de blanchiment"] {
	color: #eeeeee !important;
}
 
.page-Utilisateur_EDUCA33E_LiveRC table[rules="all"] + div, #tsInit {
	background: none !important;
	border: none !important;
	font-size: 10px !important;
	padding-left: 18px;
}
 
.page-Utilisateur_EDUCA33E_LiveRC table[rules="all"] + div small {
	font-size: inherit;
}
 
.page-Utilisateur_EDUCA33E_LiveRC table[rules="all"] + div + ul {
	padding: 0;
	margin: 0;
}

/* Fin du thème LiveRC */
</source>

Qu'en pensez-vous ? <span style="display: inline-block">[[Discussion utilisateur:Marin M.|Marin <span style="font-size: 7px; display: inline-block; line-height: 7px; position: relative; top: 2px">27/02<br />13:36</span>]]</span>
:L'affichage des titres dans la fenêtre de prévisualisation bug.. Impossible de voir le titre de l'article en question :/ Marc-André Beauchamp 27 février 2011 à 21:21 (CET)
::{{Fait}} Corrigé. <span style="display: inline-block">[[Discussion utilisateur:Marin M.|Marin <span style="font-size: 7px; display: inline-block; line-height: 7px; position: relative; top: 2px">16/04<br />15:59</span>]]</span>

== Option pour faire une requête aux admins ==

Depuis le [[Utilisateur:EDUCA33E/LiveRC/ToDo|ToDo]] : 
{| rules="all" class="creator" style="border:1px solid grey;width:100%"
{{DevList
  |progress=0
  |sujet=Faire une requête aux administrateurs quand on en est pas un
  |par=[[Utilisateur:Jmskobalt|Jmskobalt]] ; [[Utilisateur:Acer11|Acer11]]
}}
|}

J'ai commencé à travailler cette option. A priori, [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/LiveRC.js&oldid=64769172&diff=64840904 cela fonctionne]. Mais, s'agissant de messages pré-formatés, il manque l'essentiel : les modèles.

Or donc, il faudrait créer les modèles relatifs à 
* une [[Wikipédia:demande de suppression immédiate|demande de suppression immédiate]], 
* une [[Wikipédia:demande de protection de page|demande de protection de page]]
* <s>une [[Wikipédia:demande de purge d'historique|demande de purge d'historique]], </s>
* une [[Wikipédia:Requête aux administrateurs|demande de blocage]]
* autres ?

Ces modèles ne comporteront que deux paramètres, nommés respectivement '''user''' et '''page''' <s>(ça va poser un petit problème pour une [[Wikipédia:demande de purge d'historique|demande de purge d'historique]], vu qu'on est censé indiquer quelle(s) version(s) masquer. Si quelqu'un a une idée, je suis preneur).</s>

A vos brouillons !

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 29 avril 2011 à 22:59 (CEST)
:Les demandes automatiques de purge d'historique sont déjà implémentées dans [[Discussion utilisateur:Arkanosis/xpatrol.js|xpatrol]]… mais il y a un peu plus de paramètres que simplement (user, page).
:Au passage, si le format des requêtes automatiques de LiveRC sur [[WP:DPH]] pouvait être le même que celui des requêtes d'xpatrol, j'apprécierais beaucoup : j'ai toujours en projet le pendant admin des requêtes automatiques (le traitement automatique de celles-ci).
:Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 29 avril 2011 à 23:09 (CEST)
::Les purges d'historiques posent un problème pour la récupération de paramètres. Vu l'endroit ou se trouvera le formulaire (à la suite des liens en bas à gauche dans la barre de prévisualisation), on n'a pas accès aux N° de versions de début et de fin de copyvio. Pour cela, il faudrait voir à faire une version "spéciale" qui fonctionnerait à partir de la prévisualisation de l'historique, mais ce serait lourd et, à vrai dire, LiveRC n'est pas l'outil idéal pour faire la chasse au copyvio. 
::Ce qu'il est possible, en revanche, c'est que lorsqu'un patrouilleur voit une modif qui est visiblement un copyvio, c'est de de reverter avec comme motif "copyvio", puis de faire une demande de purge. Sans avoir les N° de versions à purger ni le site copié, on peut supposer que l'admin qui traitera la requête regardera l'historique, verra le revert du patrouilleur (le même qui a posé la demande de purge) et masquera la/les versions juste avant. Ca demandera juste un peu plus de boulot pour le traitement.
::La solution alternative est de laisser tomber la purge d'historique (ou de voir ça par le biais d'une autre fonction façon "xpatrol intégré à LiveRC") et se concentrer sur les autres types de requêtes. Mais ce serait dommage amha.
::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 29 avril 2011 à 23:33 (CEST)
:::« xpatrol intégré à LiveRC », pourquoi pas {{clin}} Mais comme tu le notes très justement, le cas du revert pour copyvio juste après son ajout est « assez » simple (c'est relatif, hein {{clin}}) et ce que l'admin aurait à faire, LiveRC pourrait le faire à sa place… on a déjà le oldId… il faudrait juste récupérer les autres ids avec la requête qui va bien {{sourire}}.
:::Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 29 avril 2011 à 23:49 (CEST)
::::Après discussion avec {{U|Lomita}} sur IRC, je crois que je vais traiter les demandes de purge séparément dans une autre fonction. Des cases à cocher dans la prévisualisation de l'historique indiqueront quelles versions sont à masquer, et un champ de texte permettra de rentrer le site copié (trouvé via une recherche google dans un autre onglet). Après ne reste plus qu'à faire la requête, avec le modèle qui va bien, peut-être le même que celui de xpatrol, à voir (demain).
::::Donc...
::::Il faut créer les modèles pour les autres types de requêtes. A vos propositions !
::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 avril 2011 à 00:06 (CEST)
:::::Si je savais comment faire, ce serait bien volontiers, car c'est vraiment quelque chose qui nous simplifiera la vie {{sourire}}. — [[Utilisateur:Jules78120|<span style="color:#008000">Jules78120</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 30 avril 2011 à 12:34 (CEST)
::::::Une requête d'administrateur : serait-il possible de conserver des titres de section cliquables depuis la liste de suivi ? Dans le cas des purges d'historiques, [http://fr.wikipedia.org/w/index.php?title=Wikip%C3%A9dia%3ADemande_de_purge_d%27historique&action=historysubmit&diff=64808773&oldid=64808577 xpatrol a la désagréable habitude de laisser sa publicité dans la boîte de résumé], ce qui oblige à aller sur la page, puis dans le sommaire pour enfin arriver à la requête. Alors qu'une mention de nouvelle section n'oblige qu'à faire un clic sur la flèche depuis la LS pour arriver à la requête.
::::::Un truc de feignant, mais de feignant cherchant à être efficace et rapide à l'exécution. {{sourire}}
::::::Merci d'y penser ! <b>[[Utilisateur:Trizek|Trizek]] <sup><small>[[Discussion Utilisateur:Trizek|bla]]</small></sup></b>  30 avril 2011 à 13:53 (CEST)
:::::::Pour ça, je crois qu'il suffirait de ne pas mettre de résumé de modif, Mediawiki mettra alors automatiquement « '' {{Bleu|→}} <span class="autocomment" >Titre de section</span> : nouvelle section'' »
:::::::Exemple de messages : [[Utilisateur:Dr Brains/Bac à Sable]], pour les besoins de l'exemple, je n'ai utilisé qu'un modèle avec un switch et un paramètre '''type''', mais dans la version définitive, il faut un modèle par type de message.
:::::::Je me rends compte qu'un paramètre "raison" ne serait peut-être pas du luxe...
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 avril 2011 à 14:10 (CEST)
::::::::Cool, merci ! <b>[[Utilisateur:Trizek|Trizek]] <sup><small>[[Discussion Utilisateur:Trizek|bla]]</small></sup></b>  3 mai 2011 à 18:18 (CEST)
:::::::J'aurais dit quelque chose comme:
:::::::Bonjour, la suppression de cet article est demandée : motif. Merci, <nowiki>~~~~</nowiki>
:::::::Bonjour, la semi-protection de cet article est demandée : motif. Merci, <nowiki>~~~~</nowiki>
:::::::Bonjour, il faudrait bloquer X : motif. Merci, <nowiki>~~~~</nowiki>
:::::::[[image:Start-here.svg|13px|Discut'|link=Discussion utilisateur:Frakir]] [[Utilisateur:Frakir|Frakir]] 15 mai 2011 à 23:53 (CEST)
::::::::Voilà ce que ça donne : [[Utilisateur:EDUCA33E/LiveRC/Modèles]].
::::::::Ma version perso est a priori opérationnelle (il ne reste que l'édition elle-même à tester, le reste fonctionne nickel). Les raisons de suppression/blocage/protection (sélectionnables par les patrouilleurs) sont directement issues des messages prédéfinis des pages spéciales liées : [[Mediawiki:deletereason-dropdown]], [[Mediawiki:ipbreason-dropdown]] et [[Mediawiki:protect-dropdown]].
:::::::::Il serait plus préférable de faire les requêtes de demande de blocage via [[Wikipédia:Vandalisme en cours]]. Cordialement. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 19 mai 2011 à 19:36 (CEST)
::::::::::+1 superjuju : [http://fr.wikipedia.org/w/index.php?title=Wikip%C3%A9dia:Requ%C3%AAte_aux_administrateurs&diff=65880706&oldid=65878345] : ça me met le message sur WP:RA, alors qu'il le faudrait sur [[WP:VC]]. Sinon, bravo {{bravo}}. Amclt, — [[Utilisateur:Jules78120|<span style="color:#008000">Jules78120</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 30 mai 2011 à 16:34 (CEST)
:::::::::::C'est ce qui était prévu. Mais [[WP:VC]] est organisé en sous-pages (ce qui pourrait changer). 
:::::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 mai 2011 à 16:40 (CEST)

== LDS ==

Question conne car option qui existe peut être mais que je n'ai pas trouvé... Serait-il possible d'avoir un genre de case à cocher pour mettre l'article où l'on a effectué la révocation en liste de suivi ? [[User:Micthev|<u>''Micthev''</u>]] <sup>([[User talk:Micthev|<small>discuter</small>]])</sup> 1 mai 2011 à 00:44 (CEST)

== Mise sur pause automatique ==

Depuis quelques semaines, je remarque que mon LiveRC se met sur pause sans que je clique consciemment sur le bouton pause. Est-ce normal? Est-ce une nouvelle option? Merci de votre aide. Amicalement, [[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 16 mai 2011 à 18:22 (CEST)
: Même problème, même question. Et ràs dans la console d'erreurs… --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 16 mai 2011 à 20:24 (CEST)
::cf. [[#firebug]]
::Vous avez des pb de connexion ?
::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 mai 2011 à 21:36 (CEST)
:::J'avoue qu'aujourd'hui, à l'endroit où j'étais, ma connexion n'était pas la plus rapide... Mais il me semble que ça date d'avant le 27 avril. Pas sûr. Je vais essayer de cerner plus clairement les circonstances dans lesquelles ça arrive. Bonne journée, [[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 16 mai 2011 à 23:05 (CEST)
::::Peut-être en rallongeant le délai cela règlerait-il le pb. Le timeout "de sécurité" qui est à l'origine de votre soucis est réglé sur "Timeout normal" + 5 secondes. Peut-être que 10 ou 15 secondes serait mieux.
::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 mai 2011 à 23:17 (CEST)
::::Je suis sur le canal irc de liverc, p-ê pourrait-on en parler live? [[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 16 mai 2011 à 23:20 (CEST)

== Nouvelle extension ==



Je vous présente [[Utilisateur:Dr Brains/LiveRC/HotCatsMulti.js]], qui comme son nom l'indique, est le petit frère de [[Mediawiki:Gadget-HotCatsMulti.js|HotCatsMulti]].

Cette extension permet de rajouter une ou plusieurs catégories lors de la prévisualisation d'un article dans LiveRC.

Elle est disponible dans le panneau de configuration de LiveRC, dans l'onglet "Extensions"

Have fun !

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 29 mai 2011 à 21:51 (CEST)

== Nouvelle extension (bis) ==

Je vous présente [[Utilisateur:Dr Brains/LiveRC/BandeauPortail.js]], qui comme son nom l'indique, est le petit frère de [[Mediawiki:Gadget-BandeauxPortails.js|BandeauxPortails]].

Cette extension permet de rajouter un ou plusieurs bandeaux de portail lors de la prévisualisation d'un article dans LiveRC.

Elle est disponible dans le panneau de configuration de LiveRC, dans l'onglet "Extensions"

Have fun !

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 mai 2011 à 17:23 (CEST)
:Bonjour. Pourrais-tu me dire s'il existe une manière de ne plus faire apparaître l'avertissement de portail manquant dans un article, ainsi que la non-catégorisation si possible ? Lorsque je patrouille, c'est pour lutter contre le vandalisme et non faire de la wikification en masse alors ces informations m'irritent les yeux. :-) --[[User:Laurent_Nguyen|Laurent N.]]<sup><small> &#91;[[Discussion Utilisateur:Laurent_Nguyen|D]]&#93;</small></sup> 1 juin 2011 à 21:49 (CEST)
::C'est très simple. Tu vas dans le panel de configuration (icône avec la clé et le tournevis), tu cliques sur l'onglet {{Touche|Icônes}}, puis tu cherches ceux correspondants à ces deux icônes (les deux premières je crois). Tu peux les modifier comme tu veux, et notamment les supprimer totalement. Ensuite, tu n'as plus qu'à cliquer sur {{Touche|Valider}} pour mettre à jour ta configuration.
::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 1 juin 2011 à 22:04 (CEST)
:::Super, ça marche. Merci beaucoup. Je me rappelle maintenant que tu m'avais aidé pour virer avec la même méthode la notification "ébauche" dont je voyais encore moins l'intérêt car je ne vois pas ce qu'un patrouilleur peut bien faire de cette information. --[[User:Laurent_Nguyen|Laurent N.]]<sup><small> &#91;[[Discussion Utilisateur:Laurent_Nguyen|D]]&#93;</small></sup> 1 juin 2011 à 22:30 (CEST)

== Petite fonctionnalité supplémentaire ==

Bonjour, 

je viens d'ajouter une fonctionnalité à LiveRC, qui avait été demandée par {{u|Sapindnoel}} dans le [[User:EDUCA33E/LiveRC/ToDo|Todo]] :

Dans la liste des révoqués (celle de gauche) ainsi qu'à côté de chaque "icône" '''<sup style="color:red">(X révoc)</sup>''' dans les RC se trouve à présent un petit lien {{Bleu|+}} qui permet d'afficher/masquer la liste des pages où l'utilisateur a été révoqué, avec un lien vers chaque article et chaque diff.

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 9 juin 2011 à 15:26 (CEST)
:{{Merci}}--[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 9 juin 2011 à 16:34 (CEST)
::Et {{bravo}} (une fois de plus). — [[Utilisateur:Jules78120|<span style="color:#008000">Jules78120</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 14 juin 2011 à 09:36 (CEST)

== Salut ==

Bonjour, je bidouille un peu le code source de liveRC pour l'adapter un peu à mes préférences, et le code modifié ([[User:Lilyu/LiveRC3.js]]) fonctionne sur [[User:EDUCA33E/LiveRC]]. Mais une partie du code est de l'html présent sur [[User:EDUCA33E/LiveRC]], je l'ai donc copié sur [[User:Lilyu/LiveRC3]] pour pouvoir aussi le modifier un peu. [http://fr.wikipedia.org/w/index.php?title=Utilisateur%3ALilyu%2FLiveRC3.js&action=historysubmit&diff=66298457&oldid=66295253 J'ai fait les modifications qui me semblaient nécessaires], mais il doit y avoir autre chose, car liveRC ne se lance pas sur [[User:Lilyu/LiveRC3]] (mais il marche sur [[User:EDUCA33E/LiveRC]] )

Au passage, j'en étais resté à la version 0.3.7, et passer brutalement à la 0.4.6 a été de longues minutes de choc mêlées de "oh" et de "ouaaaaaaaaah génial !". Bon boulot ! {{sourire}} ----[[Utilisateur:Lilyu|Lilyu]] ([[Discussion Utilisateur:Lilyu|Répondre]]) 12 juin 2011 à 05:46 (CEST)
:huh ? Myst me dit que ça marche quand il importe mon .js et va sur [[User:EDUCA33E/LiveRC]] et [[User:Lilyu/LiveRC3]]. J'ai fait le test avec un autre comtpe utilisateur, et ça marche aussi. Mais Lilyu qui va sur [[User:Lilyu/LiveRC3]], ne démarre pas LiveRC... J'en perd mon ouzbek --[[Utilisateur:Lilyu|Lilyu]] ([[Discussion Utilisateur:Lilyu|Répondre]]) 12 juin 2011 à 07:34 (CEST)
::ok, j'ai identifié le pb, un conflit avec mon vector.js :) 
::Bon c'est pas grave, mais j'ai bien fait de poster quand même ici. Sans quelqu'un d'autre pour tester et me dire que ça marchait, j'aurais pas trouvé l'origine de mon pb :) --[[Utilisateur:Lilyu|Lilyu]] ([[Discussion Utilisateur:Lilyu|Répondre]]) 12 juin 2011 à 07:57 (CEST)
Pour te faciliter les choses, j'ai mis en paramètre la page où se lance le script.
<br/>A présent, tu peux mettre dans ton common/vector/monobook js :
<pre>
LiveRC_PageTitle = "Lilyu/LiveRC3";

importScript('User:EDUCA33E/LiveRC.js');
</pre>
<br/>ou en effectuant [http://fr.wikipedia.org/w/index.php?title=Utilisateur:EDUCA33E/LiveRC.js&diff=66301233&oldid=66209507 ces modifs] sur ton script : 
<pre>
LiveRC_PageTitle = "Lilyu/LiveRC3";

importScript('User:Lilyu/LiveRC3.js');
</pre>
<br/>'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 12 juin 2011 à 09:21 (CEST)
:sympa merci :) oui c'est une solution plus élégante ^^
:Je vais faire la modif, ça me permettra de garder le LiveRC normal pour se lancer sur Utilisateur:EDUCA33E/LiveRC (pour garder une référence), et une version custom sur une autre page.
:Je fais surtout des modifes cosmétiques (cf [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Lilyu/LiveRC3.js&diff=prev&oldid=66303174 liste de mes modifs]) , pour compenser ma vue de taupe ^^ [http://img221.imageshack.us/img221/4221/livercscreen.png screenshot].
:J'ai déplacé le bouton SUIVANT dans le coin en haut à droite, je vois pas de raison de faire des traversée de diagonale d'écran à chaque fois que je veux revert. Et j'ai ajouté un bouton qui supprime plusieurs types de lignes de diff en même temps. Ma prochaine modif sera peut-être de faire un changement de couleur en haut quelque part pour avertir que le diff visualisé est pas dans l'espace encyclopédique (user page ou talk page).
:Par contre, je suis pas du toute programmeuse, je copie/colle du code jusqu'à ce que ça face ce que je veux {{mdr}}
:PS: Ce bouton SUIVANT est une idée géniale !!! ----[[Utilisateur:Lilyu|Lilyu]] ([[Discussion Utilisateur:Lilyu|Répondre]]) 12 juin 2011 à 11:21 (CEST)
:: L’initiative est bonne. On pourrait ainsi rajouter un bouton « LiveRC pour personnes malvoyantes ». 
:: <small>HS : Ton image sur ta page utilisateur m'a fait rire. {{clin}}</small>.
:: --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 12 juin 2011 à 11:31 (CEST)
:::PS : tu peux aussi utiliser la fonction « zoom » (Ctrl+roulette) de ton navigateur. [http://nsa20.casimages.com/img/2011/06/12/110612114132225187.jpg Illustration sur User:EDUCA33E/LiveRC.js]. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 12 juin 2011 à 11:38 (CEST)

== Gestion liste de contacts ==

Bonjour,

une nouvelle version de LiveRC viens d'être mise en ligne intégrant [http://fr.wikipedia.org/w/index.php?title=Utilisateur:EDUCA33E/LiveRC/ToDo&diff=next&oldid=67253482 une fonctionnalité demandée ici] qui améliore la gestion de la liste de contacts.

Parmi les changements apportés :
* la liste de contact est exclusivement gérée par la liste de suivi. L'ancienne variable <code>lstContact</code> mise à jour dans le LiveRCparam est obsolète, de même que la gestion via cookies (il y avait une fonction relative à cela mais je ne sais si elle a jamais été fonctionnelle). Avantage : personne ne peut savoir qui vous suivez ; inconvénient : ajoute des pages à votre Liste de suivi.
* La gestion globale de la liste de contact se fait via le menu de paramétrage, à l'onglet '''Contacts'''. Il est possible d'ajouter/enlever des contacts puis de cliquer sur {{Touche|OK}} pour valider (le bouton {{Touche|Valider}} en haut ne sert pas à ça, cet onglet est indépendant des autres).
* Il reste possible, dans chaque ligne RC, de suivre ou de ne plus suivre un utilisateur, en cliquant sur le W.
* J'ai intégré un fork de l'extension [[Utilisateur:Orlodrim/LRCWatchButton.js]], qui ajoute dans la colonne de gauche, à côté du lien {{Bleu|LiveRC}}, un lien permettant de (ne plus) suivre un utilisateur (ce lien n'apparait que si l'on se trouve sur un page utilisateur ou une page de discussion utilisateur).

Toute remarque/suggestion est bien sûr bienvenue.

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 15 juillet 2011 à 12:17 (CEST)

== Plantage ==

Bonjour, notre outil se comporte bizarrement aujourd'hui : [http://nsa27.casimages.com/img/2011/07/25/110725010712108260.png Illustration]. <br />
À corriger d'urgence, si possible. Cordialement. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 25 juillet 2011 à 13:01 (CEST)
:Et merde. Tu as rechargé le cache, je suppose ?
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 25 juillet 2011 à 13:33 (CEST)
:: Même problème, j'allais laisser un message. J'ai aussi tenté deux fois de recharger le cache, mais ça n'y change rien… Cordialement --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 25 juillet 2011 à 13:36 (CEST)
:::OK, j'ai reverté mes dernières modifs, ce qui devrait régler le pb. J'ai dû me planter quelque part. Des tests plus poussés semblent s'imposer avant mise en prod.
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 25 juillet 2011 à 13:38 (CEST)
::::Merci, c'est beaucoup mieux maintenant. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 25 juillet 2011 à 13:57 (CEST)

== Les suggestions diverses ==

Bonjour à tous !

Je regardais le todo de LiveRC, et je suis retombé sur les suggestions diverses. Le truc, c'est qu'après environ deux secondes de très intense réflexion, je me suis dit que toutes ces améliorations nécessitaient (quand même) d'en discuter.

Je les résume donc :
{{quote|Créer la page wgPageName+'/ChangeLog' et déplacer les ChangeLog du script vers cette page|{{u|TiChou}}}}
{{quote|Convenir de la licence de LiveRC et l'indiquer dans les en-têtes de /LiveRC et de /LiveRC.js|{{u|TiChou}}}}
{{quote|À étudier : TWINKLE|{{u|EDUCA33E}}}}
{{quote|Factoriser le code et voir le problème de fuite mémoire|{{u|Argos42}}}}
{{quote|Déplacer LiveRC dans l'espace Wikipédia et le script dans MediaWiki:|{{u|Pic-Sou}}}}

Je pense qu'il serait bien d'en discuter plus amplement. Qu'en pense-vous ?

Cordialement --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 28 juillet 2011 à 11:04 (CEST)
:* "ChangeLog" : Je ne sais pas trop quelle est l'idée derrière, il faudrait demander des précisions à TiChou
:* Licence : faut voir avec tous les auteurs, et en particulier avec EDUCA33E. pour ma part, je laisse mes contribs dans le domaine public donc je me conformerai à ce qui sera choisi.
:* TWINKLE : une grosse partie est déjà faite via les demandes aux sysop. Il manquerait juste une fonction pour lancer une PàS mais je ne crois pas que ce soit vraiment le boulot des patrouilleurs.
:* code et fuite mémoire : c'est déjà en partie fait. Il faudrait voir avec un spécialiste de l'optimisation ({{u|Od1n}} ?) pour aller plus loin
:* déplacer : pour le code, c'est facilement faisable de la déplacer dans [[MediaWiki:Gadget-LiveRC.js]] (et cette présente page de discussion avec). Pour la page LiveRC, le pb est que [[Wikipédia:LiveRC]] existe déjà et est pas mal liée.
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 28 juillet 2011 à 12:50 (CEST)
::Merci pour tes réponses. Pour le ns, les redirections existent… --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 28 juillet 2011 à 12:55 (CEST)
:::Migrations du code en '''<code>Mediawiki:</code>''' et des autres pages en '''<code>Wikipédia:LiveRC/</code>''' effectuées. Il reste probablement un paquet de liens à corriger dans les sous-pages de [[Wikipédia:LiveRC]] mais a priori ça fonctionne quand même.
:::Accessoirement, LiveRC est désormais sélectionnable dans les [[Spécial:préférences##preftab-8|préférences]], à la section "Outils avancés".
:::Désolé si il y eu quelques désagréments durant la transition.
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 28 juillet 2011 à 15:43 (CEST)
::::Aucun problème ; dès que j'ai vu ta première modif, j'ai coupé LiveRC, et j'ai purgé le cache à la fin.
::::Est-ce qu'il est aussi possible d'obtenir le gadget avec obtenir("LiveRC"); ? --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 28 juillet 2011 à 16:08 (CEST)
:::::Oui, et même mieux puisque tu peux le sélectionner dans les préférences.
:::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 28 juillet 2011 à 16:14 (CEST)
::::::J'ai mis à jour la doc (en français seulement, faut pas oublier les anglais, les allemands et autres). Qu'est-ce qu'on fait pour la licence et la fuite de mémoire ? --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 28 juillet 2011 à 16:30 (CEST)
:::::::Ben pour la licence, faut voir avec les autres auteurs, et en particulier avec {{u|EDUCA33E}}. Pour la fuite mémoire, ça doit pouvoir attendre un peu.
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 28 juillet 2011 à 18:25 (CEST)
::::::::<small>(vite fait en passant) </small> Pour la licence, j'ai l'habitude de mettre ce que je code sous licence MIT/X11, ce qui est suffisamment permissif pour être compatible une licence qui l'est moins (BSD, Apache, GPL), si un autre développeur le souhaitait. Ma contribution à ce script étant, somme toute, assez limitée, je n'aurais pas de problème non plus à la placer dans le domaine public, si c'était l'orientation qui venait à être choisie par les autres. <small>(et je repars aussi vite — désolé, pas le temps pour jeter un coup d'œil à la mémoire ; mais recycler les requêtes http et regrouper celles concernant les modèles serait une piste à explorer)</small> Amicalement — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 29 juillet 2011 à 23:21 (CEST)
:Bonjour, à tous... 
:Tout d'abord, Super taff de chacun. Désolé de ne plus pouvoir participer actuellement.
:En ce qui concerne la licence, laquelle rapporte le plus d'argent ??? A défaut, si vous ne savez pas (ou ne répondez pas dans les délais) des licences telles que MIT/X11 - domaine public.. me conviennent parfaitement...
:Encore merci à tous pour vos corrections, améliorations et évolutions !! [[User:EDUCA33E|Educa33]][[User Talk:EDUCA33E|<sup style="color:darkorange">e</sup>]] 23 août 2011 à 03:50 (CEST)

== Plusieurs problèmes... ==

Bonjour, je signale plusieurs problèmes sur lesquels je viens de tomber et qui sont assez problématiques :
* Primo (le pire !) depuis que j'ai désactivé certaines extensions somme toute assez peu utiles pour moi, comme HotCats ou BandeauxPortails, LiveRC ne fonctionne tout simplement pas ! Le logo LiveRC remplace celui de Wikipédia, et puis plus rien ne se passe, même le titre Wikipédia:LiveRC reste présent… Dans ma console d'erreurs, je vois quatre erreurs, dont la première est présente en triple :
 Erreur : jsAlert is not defined
 Fichier Source : http://pl.wikipedia.org/w/index.php?action=raw&ctype=text/javascript&title=Wikipedysta%3ANux%2FSearchBox.js
 Ligne : 58
 
 Erreur : lrcBandeauPortailVariables is not defined
 Fichier Source : http://fr.wikipedia.org/w/index.php?title=User:Pic-Sou/LiveRCparam.js&action=raw&ctype=text/javascript
 Ligne : 523

Et quelques avertissements liés à mon LiveRCparam.js du type :
 Avertissement : « important » attendu, mais « ie » trouvé.  « ; » ou « } » attendus pour terminer une déclaration, mais « ie » trouvé.  Déclaration abandonnée.
 Fichier Source : http://fr.wikipedia.org/w/index.php?title=Discussion_MediaWiki:Gadget-LiveRC.js&action=edit&section=new
 Ligne : 1
* Secundo, je me disais que les vandales devaient être en vacances depuis un bout de temps, puis que je ne voyais presque plus d'icônes Test0, Test1 et caetera depuis quelques temps, accolées aux noms d’utilisateurs. Raté, c'est UserWarningsExtension.js qui ne marche plus. Il faudrait y remédier…
* Tertio, toujours à propos de UserWarningsExtension.js, j'ai l'impression que l'interface d'édition des paramètres de LiveRC ne gère pas tous les paramètres de l'extension, notamment la possibilité de régler les couleurs des liens (pratique pour savoir qu'un utilisateur n'a pas de page de discussion) ou le temps au bout duquel les messages deviennent caducs…
* Quarto (et après c'est fini, promis ! {{clin}}, j'ai remarqué que lors que l'on désactivait une extension, tout le balayage du LiveRCparam.js ne se faisait pas correctement. Par exemple, j'ai beau avoir désactivé HotCats et BandeauxPortails, il reste encore dans [[User:Pic-Sou/LiveRCparam.js]] le code suivant (en boîte déroulante) :
{{Boîte déroulante/début|titre=encore dans mon LiveRCparam.js…}}
<source lang="javascript">
  // Paramètres de HotCats
lrcHotCatsVariables["suggestion_delay"] = 200;
lrcHotCatsVariables["list_size"] = 10;
lrcHotCatsVariables["list_items"] = 50;
lrcHotCatsVariables["Minoredit"] = 1;
lrcHotCatsVariables["Watchthis"] = -1;
lrcHotCatsVariables["exists_size"] = 20;
lrcHotCatsVariables["exists_yes"] = 'http://upload.wikimedia.org/wikipedia/commons/thumb/b/be/P_yes.svg/20px-P_yes.svg.png';
lrcHotCatsVariables["exists_no"] = 'http://upload.wikimedia.org/wikipedia/commons/thumb/4/42/P_no.svg/20px-P_no.svg.png';
lrcHotCatsVariables["docURL"] = 'http://fr.wikipedia.org/wiki/Projet:JavaScript/Notices/HotCatsMulti#Fonctionnement';
lrcHotCatsVariables["list_down"] = false;
lrcHotCatsVariables["autocommit"] = true;
lrcHotCatsVariables["AutoMulti"] = false;
lrcHotCatsVariables["ShowLegend"] = false;
lrcHotCatsVariables["ShowInline"] = false;
lrcHotCatsVariables["SkipRecap"] = false;
lrcHotCatsVariables["DebugMode"] = false;
 
  // Textes de HotCats
lrcHotCatsText["MultiLinkText"] = '(±)';
lrcHotCatsText["MultiLinkTitle"] = 'Modifier plusieurs catégories';
lrcHotCatsText["MultiInputOK"] = 'Valider';
lrcHotCatsText["MultiInputCancel"] = 'Annuler';
lrcHotCatsText["Minoredit"] = 'Édition mineure';
lrcHotCatsText["Watchthis"] = 'Suivre cette page';
lrcHotCatsText["RadioDefault"] = 'Défaut';
lrcHotCatsText["RadioYes"] = 'Oui';
lrcHotCatsText["RadioNo"] = 'Non';
lrcHotCatsText["LabelText"] = 'Légende';
lrcHotCatsText["LabelTitle"] = 'Voir la page d\'aide (nouvelle fenêtre)';
lrcHotCatsText["DefaultSortText"] = '(D)';
lrcHotCatsText["DefaultSortTitle"] = 'Ajouter/modifier/supprimer la clef de tri principale';
lrcHotCatsText["RemoveLinkText"] = '(–)';
lrcHotCatsText["RemoveLinkTitle"] = 'Supprimer la catégorie';
lrcHotCatsText["RemoveConfirm"] = 'Voulez-vous vraiment supprimer la catégorie';
lrcHotCatsText["ModifyLinkText"] = '(±)';
lrcHotCatsText["ModifyLinkTitle"] = 'Modifier la catégorie';
lrcHotCatsText["AddLinkText"] = '(+)';
lrcHotCatsText["AddLinkTitle"] = 'Ajouter une catégorie';
lrcHotCatsText["Exists_YesTitle"] = 'Cette catégorie existe.';
lrcHotCatsText["Exists_NoTitle"] = 'Cette catégorie n\'existe pas.';
lrcHotCatsText["ParentTitle"] = 'Suggérer les catégories-mères';
lrcHotCatsText["ParentText"] = '↑';
lrcHotCatsText["DaughterTitle"] = 'Suggérer les catégories-filles';
lrcHotCatsText["DaughterText"] = '↓';
lrcHotCatsText["InputOK"] = 'OK';
lrcHotCatsText["InputCancel"] = 'Annuler';
lrcHotCatsText["RecapTitle"] = 'Récapitulatif :';
lrcHotCatsText["RecapRemove"] = 'Catégories à supprimer';
lrcHotCatsText["RecapModify"] = 'Catégories à modifier';
lrcHotCatsText["RecapAdd"] = 'Catégories à ajouter';
lrcHotCatsText["RecapSort"] = 'Clef de tri globale';
lrcHotCatsText["ResumeScript"] = '[[Projet:JavaScript/Notices/HotCatsMulti|HotCatsMulti]] : ';
lrcHotCatsText["AlertProblem1"] = 'Impossible de trouver la catégorie « $1 » - elle est peut-être incluse via un modèle.';
lrcHotCatsText["AlertProblem2"] = 'La catégorie « $1 » est déjà présente.';
lrcHotCatsText["AlertProblem3"] = 'Plusieurs occurrences de la catégorie « $1 » trouvées.';
lrcHotCatsText["NoCatTemplate"] = 'à catégoriser';
 
  // Paramètres de BandeauPortail
lrcBandeauPortailVariables["suggestion_delay"] = 200;
lrcBandeauPortailVariables["list_size"] = 5;
lrcBandeauPortailVariables["list_items"] = 10;
lrcBandeauPortailVariables["Minoredit"] = 1;
lrcBandeauPortailVariables["Watchthis"] = -1;
lrcBandeauPortailVariables["list_down"] = false;
lrcBandeauPortailVariables["autocommit"] = true;
 
  // Textes de BandeauPortail
lrcBandeauPortailText["RemoveLinkText"] = '(–)';
lrcBandeauPortailText["RemoveLinkTitle"] = 'Supprimer le bandeau';
lrcBandeauPortailText["RemoveConfirm"] = 'Voulez-vous vraiment supprimer le bandeau';
lrcBandeauPortailText["AddLinkText"] = '(+)';
lrcBandeauPortailText["AddLinkTitle"] = 'Ajouter un bandeau';
lrcBandeauPortailText["InputOK"] = 'OK';
lrcBandeauPortailText["InputCancel"] = 'Annuler';
lrcBandeauPortailText["ModifyLinkText"] = '(±)';
lrcBandeauPortailText["ModifyLinkTitle"] = 'Modifier les bandeaux';
</source>
{{Boîte déroulante/fin}}

Est-ce qu'un développeur aurait la solution à ces problèmes ? Merci d'avance… --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 5 août 2011 à 10:02 (CEST)
:Depuis quand constates-tu les problèmes ? --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 5 août 2011 à 10:11 (CEST)
::Le premier depuis que j'ai viré les extensions inutiles ([http://fr.wikipedia.org/w/index.php?title=Utilisateur:Pic-Sou/LiveRCparam.js&diff=68116951&oldid=67623355]), et donc le quatrième aussi ; le second et le troisième, je ne sais pas exactement mais ça doit bien faire un bon mois, voire plus… --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 5 août 2011 à 10:14 (CEST)
:::J'ai eu un problème similaire il y a plus d'un semestre suite à des erreurs que j’ai commis involontairement. Le plus simple est de faire un rapport d'erreur [[Projet:JavaScript/Rapporter un bug|ici]]. Amicalement. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 5 août 2011 à 10:20 (CEST)
::::Je vais m'en occuper. En attendant, tu devrais remettre les extensions que tu as enlevées.
::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 5 août 2011 à 11:43 (CEST)
:::::J'ai corrigé le LiveRC pour qu'il intègre dans le LiveRCparam des tests <code>try{ ... }catch(e){ ... }</code> qui éviteront l'erreur d'une Array non définie.
:::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 5 août 2011 à 12:14 (CEST)
::::::LiveRC remarche, mais je pense qu'il faudrait revoir la suppression des paramètres d'une extension après qu'elloe ait été désactivée… Et UserWarningsExtension est toujours out… {{=(}} --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 5 août 2011 à 19:20 (CEST)
:::::::Pour UserWarningsExtension, il faudrait voir avec Orlodrim, son créateur. J'hésite un peu à venir y fourrer mon nez (même si ça m'est déjà arrivé).
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 5 août 2011 à 21:07 (CEST)
::::::::Je ne trouve pas de problème. Pour moi, les icônes apparaissent normalement, y compris en utilisant ta configuration. De plus, tu dis que les icônes pour Salebot apparaissent, or la détection se fait de la même façon pour toutes les autres.
::::::::Il y a peu de vandalisme, c'est sûrement la seule raison. Je rappelle que l'icône s'affiche seulement si l'utilisateur a eu un avertissement de Salebot ou par LiveRC dans les 24 heures précédentes (délai par défaut). Pour les avertissements LiveRC, cela ne représente que 10-15 modifications par jour à cette période.
::::::::Tu peux vérifier si l'extension est active en augmentant le délai à un mois et en mettant une icône pour l'expression régulière ".*" dans la configuration. Si ça n'a aucun effet ou si ça ne marche que partiellement (c'est-à-dire qu'il manque une icône pour des utilisateurs dont la page de discussion a été modifiée au cours du mois précédent), signale-le moi.
::::::::[[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 6 août 2011 à 18:33 (CEST)
:::::::::T'as raison, c'est juste que les vandales sont en vacances… {{lol}} Par contre, je serais favorable à ce que l'on puisse régler les paramètres de UserWarningsExtension par l'interface de gestion des paramètres. Excuse-moi de t'avoir dérangé pour rien… Cordialement --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 6 août 2011 à 19:54 (CEST)
::::::::::Ça devrait marcher maintenant. [[Utilisateur:Orlodrim|Orlodrim]] <sup><small>&#91;[[Discussion Utilisateur:Orlodrim|discuter]]&#93;</small></sup> 6 août 2011 à 22:20 (CEST)
:::::::::::ça m'a l'air bon… par contre, je ne suis pas convaincu de l'utilité d'avoir deux pages pour les paramètres. Pourrais-tu les fusionner ? Cordialement --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 6 août 2011 à 22:31 (CEST)
::::::::::::Non. Les paramètres sont en nombre définis, tandis que les couples regexp/icônes peuvent évoluer (on peut en ajouter/retirer comme on veut). On ne peut dont pas fusionner les deux.
::::::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 6 août 2011 à 22:34 (CEST)

== Nouvelle extension (ter) ==

[[Utilisateur:Dr Brains/LiveRC/CategoryRCExtension.js|CategoryRCExtension]], sélectionnable dans le menu de personnalisation de LiveRC, permet désormais de ne surveiller que les pages appartenant à une ou plusieurs catégories (typiquement des catégories du style '''Catégorie:Portail:XXXX/Articles liés''' mais ce n'est pas obligatoire).

Il est possible de modifier en live les catégories surveillées via un menu spécial ainsi que les catégories "par défaut" via le menu de personnalisation.

Have fun !!

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 7 août 2011 à 14:39 (CEST)
:Merci beaucoup docteur. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 7 août 2011 à 14:41 (CEST)
::Pas mal ! Un moyen de régler la {{guil|profondeur}}, c'est-à-dire jusqu'à combien de catégories filles on descend ? --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 7 août 2011 à 19:29 (CEST)
:::Non. En fait on filtre au niveau des catégories que la page contient, lors de l'affichage des lignes RC. Si elle contient une des catégories choisies rien ne se passe, sinon, la ligne est supprimée.
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup> Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 7 août 2011 à 21:28 (CEST)

== ToDo vs. suggestions ==

Bonjour. Je serais favorable à un renommage de Todo en suggestions. Après tout, rien n'oblige les développeurs à suivre les propositions, et certaines sont rejetées. Ce n'est donc pas {{guil|à faire}}. --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 8 août 2011 à 19:28 (CEST)
:Ou alors effectuer une scission, d'un côté une page de suggestions, de l'autre des trucs "à faire" ?
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 8 août 2011 à 19:30 (CEST)
::{{bien vu}} --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 8 août 2011 à 19:37 (CEST)

== Petite erreur ==

Bonsoir, il semble qu'il y ait un soucis dans l'affichage des liens vers un filtre qui a été déclenché. Actuellement, LiveRC affiche:
 <nowiki>Déclenchement du filtre [[Special:AbuseLog/36|36]]: R3R (action : Avertir l’utilisateur)</nowiki>
or, ce lien pointe vers la 36{{e}} entrée du [[Special:AbuseLog|Journal des filtrages]] et non vers le filtre 36 (qui aurait eu pour lien <nowiki>[[Special:AbuseFilter/36|36]]</nowiki>). Cordialement, [[Utilisateur:Linedwell|Linedwell]] <sup><small>&#91;[[Discussion utilisateur:Linedwell|discuter]]&#93;</small></sup> 14 août 2011 à 20:40 (CEST)
:C'est corrigé pour la prochaine version (cf ci-dessous).
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 août 2011 à 15:37 (CEST)

== LiveRC version 0.5 en préparation ==

Une nouvelle version de LiveRC est en préparation. Les changements au niveau des fonctionnalités sont minimes, mais ceux au niveau de l'interface sont importants. Des changements sont à apporter à la fois à [[MediaWiki:Gadget-LiveRC.js]], [[MediaWiki:Gadget-LiveRC.css]], et à [[Wikipédia:LiveRC]]

# L'interface de LiveRC est masquée par défaut. C'est le javascript qui l'affiche. Du coup, il est possible d'afficher par défaut la documentation (en transclusion, ce qui imposera de la protéger pour éviter les surprises)
# L'interface de LiveRC est désormais sortie de la page, en <code>position:absolute</code>. Un bouton en haut à gauche permet de basculer entre LiveRC (en mode plein écran) et l'interface "normale" de Mediawiki (avec la doc et les différents liens).
# Outre ce bouton, cinq autres boutons prennent place en haut à gauche et disparaissent de la barre de contrôle :
## Un bouton permet d'afficher/Masquer le tchat. Il ne se trouve plus au niveau de la barre de contrôle mais en haut à gauche. Le tchat quant à lui est en <code>position:fixed</code> en bas de l'écran. 
## Un bouton pour afficher/masquer les listes de suivi. Celles-ci apparaissent en <code>position:fixed</code> en bas de l'écran;
## Un bouton pour afficher/masquer le footer de LiveRC (partie avec les icônes et les liens utiles). Celle-ci apparaît en <code>position:fixed</code> en bas de l'écran;
## Un bouton pour afficher/masquer la prévisualisation (la barre de liens de la prévisualisation reste visible). Celle-ci conserve la place qui était la sienne auparavant;
## Un bouton pour afficher/masquer le panneau de configuration. Celui-ci conserve la place qui était la sienne auparavant;
#L'interface normale de LiveRC (la partie en <code>position:absolute</code>) reçoit un style "padding-bottom" pour ne pas être masquée par les cadres en <code>position:fixed</code> qui peuvent apparaître en bas de l'écran.
# La barre de titre de LiveRC reçoit l'horloge (todo : permettre un décalage horaire), qui disparaît donc du logo
# La barre de contrôle 
#* est déplacée juste sous la barre de titre de LiveRC
#* perd des boutons qui sont désormais situés en haut à gauche de l'écran (en <code>position:fixed</code>)
#* récupère les boutons de l'historique de prévisualisation, juste devant le bouton {{Touche|Suivant}}. Celui-ci disparaît donc de la barre de titre de prévisualisation;
#* est désormais affichée en pleine largeur et dispose donc de plus de place pour des boutons d'extension (lesquels peuvent aussi être ajoutés en haut à gauche)


Pour tester cette nouvelle interface :
# désactiver LiveRC
# ajouter à son [[Special:Mypage/common.js|common.js]] le code '''<code>importScript('User:Dr Brains/LiveRC.js');</code>'''
# aller sur la page [[User:Dr_Brains/LiveRC/Test]]
# recharger le cache du navigateur

J'ai testé sous Firefox sans soucis, sur Monobook comme sur Vector. Je ne sais pas ce que cela donne avec d'autres navigateurs.

Il reste encore des trucs à arranger : mieux définir les couleurs, les boutons, etc... Cette nouvelle version n'est pas prête à être déployée, aussi toute suggestion est donc la bienvenue. N'hésitez pas à dire ce que vous pensez des changements apportés.

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 août 2011 à 15:37 (CEST)
:Merci du signalement. En effet, la BETA ne marche pas sur Chrome. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 16 août 2011 à 15:59 (CEST)
::Corrigé. Les styles CSS n'étaient pas chargés. '''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 août 2011 à 16:12 (CEST)
:::C'est assez bien, mais :
:::* Les boutons en haut pour afficher/masquer les différentes zones sont difficilement visibles ;
:::* Il n'y a pas les infobulles sur les liens et icônes ;
:::* Il n'y a aucun moyen de quitter LiveRC, ce qui peut-être assez gênant…
:::Sinon, je signale aussi un point qui me paraît assez important, il s'agit du clic sur les liens d'une page prévisualisée : cliquer dessus ferme LiveRC… Y a-t-il moyen de faire en sorte que ça s'affiche en preview ?
:::Bravo encore pour tes modification… quand pense-tu que la nouvelle version sera utilisable ?
:::Cordialement --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 16 août 2011 à 20:54 (CEST)
::::Dans l'ordre :
::::# Le design n'est pas encore définitif. Je vais voir si je trouve d'autres icônes, ou je peux aussi en créer d'autres. Je réfléchit par ailleurs à faire de l'interface LiveRC un modèle ([[Wikipédia:LiveRC/Interface]]), que l'on pourra personnaliser en l'incluant dans une autre page (et en réglant la variable qui va bien pour prendre en compte la page). Ceci devrait permettre de personnaliser facilement ces icônes, justement. Mais c'est embryonnaire pour l'instant. Je réfléchis également sur d'autres aspects liés au style, tels les cadres gris actuellement en vigueur mais aussi l'effet "vert" au survol des lignes RC sur cette nouvelle version. Tout ceci peut (et va probablement) évoluer.
::::# En théorie, si. Lesquels exactement n'ont pas de libellé ?
::::# Si tu parles de la disparition de l'interface normale de Mediawiki, un clic sur l'un des boutons en haut à gauche permet de la retrouver (d'où l'intérêt d'insérer aussi la documentation de LiveRC {{clin}} ). On peut donc quitter LiveRC si on le souhaites (ou alors j'ai pas compris la question ?).
::::# Si. L'extension [[User:Dr Brains/LiveRC/PreviewAllLinksExtension.js]] est faite pour toi. Il est vrai qu'elle n'est pas disponible dans les options. Il faudra que je la rajoute (après avoir testé qu'elle marche toujours avec la nouvelle interface).
::::# Pas avant un moment. Le basculement d'une version à l'autre nécessitant des modifications profondes de l'interface de LiveRC, la rendant probablement difficilement compatible avec les anciennes version du script. En tenant compte que peut-être d'autres wikis utilisent LiveRC en utilisant la version courante, il va falloir qu'eux aussi fassent évoluer leur interface. Du coup, il convient que le changement soit fait d'un coup, une fois que le design de l'interface sera fixé. Après, cela dépend du nombre de gens qui testent la nouvelle interface, des retours que j'en ai, de l'aide éventuelle d'autres développeurs, etc...
::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 août 2011 à 21:14 (CEST)
:::::OK. Pour les manques d'infobulles, je pense surtout aux icônes en haut à gauche. Et pour quitter LiveRC, à la disparition de l'apparence normale…
:::::Sinon, un autre point, c'est la sobriété. Les couleur d'avant étaient… plus claires… Là, c'est la nuit. Un thème plus "à la vector" serait je pense mieux… --[[Utilisateur:Pic-Sou|Pic-Sou]] ([[Discussion utilisateur:Pic-Sou|d]]) 16 août 2011 à 22:11 (CEST)
::::::Pour ma part les couleurs de la fenêtre principale me conviennent (étant donné qu'elles n'ont pas changé) et je trouve que la surbrillance en vert de la ligne actuellement survolée ajoute un certain confort. Les nouveaux boutons quant à eux me laissent assez froid, je ne saurait dire pourquoi, mais je n'aime pas. Pour finir, le fait que désormais LiveRC fonctionne en plein écran (au lieu d'être intégré dans l'interface MediaWiki) ne me plait pas non plus (peut-être parce que j'utilise un écran large et que donc avoir LiveRC sur toute la largeur de mon écran, c'est un peu trop). En bref, le seul ajout  qui pour le moment me plait plutôt bien – à la fois pour le plaisir de l'œil et pour le confort – c'est la surbrillance de la ligne survolée. C'était le quart d'heure de Linedwell le ronchon/nostalgique {{=)}}. [[Utilisateur:Linedwell|Linedwell]] <sup><small>&#91;[[Discussion utilisateur:Linedwell|discuter]]&#93;</small></sup> 17 août 2011 à 09:02 (CEST)
:::::::Bon, après une semaine de boulot supplémentaire, je pense être arrivé à ce que je voulais. 
:::::::Le nouveau script se trouve sur la page [[MediaWiki:Gadget-LiveRC.js/Dev.js]], et donc disponible avec le code '''{{Rouge|<code>obtenir('LiveRC.js/Dev');</code>}}''' (penser à désactiver la version normale de LiveRC). La page de test est [[User:Dr_Brains/LiveRC/Test]].
:::::::Je laisse le soin à ceux que ça intéresse de découvrir la nouvelle interface. Toute suggestion/remarque/critique est évidemment ardemment souhaité. 
:::::::Je pense que cette version pourrait être mise en production d'ici à ce W-E, c'est donc le moment de le dire si vous pensez qu'il y a un truc qui ne va vraiment pas.
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 24 août 2011 à 17:34 (CEST)
::::::::C'est farpaitement farpait. Manque juste les infobulles sur les icônes. Cordialement --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 24 août 2011 à 22:52 (CEST)
::::::::De quelles icônes tu parles ? 
::::::::(Je me demande si il en faudrait pas sur les boutons, les cases à cocher et les menus déroulants de la barre de contrôle des RC. Des avis ?)
::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 24 août 2011 à 23:27 (CEST)
:::::::::En haut à gauche, les icônes pour afficher/masquer chaque morceau de LiveRC. Et oui, je suis favorable à leur généralisation… --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 24 août 2011 à 23:32 (CEST)
::::::::::Heu. Ben si y a des infobulles sur ces boutons. Tu parles bien de ça (copié-collé depuis la page de lancement, sans les styles CSS) :
::::::::::<span id="LiveRCTchatButtonOn" width="3px"><!--
            --><span class="OnButton">[[File:Mercury bw.png|32px|alt=Masquer le tchat|Masquer le tchat]]</span><!--
          --></span><!--
          --><span id="LiveRCTchatButtonOff" ><!--
            --><span class="OffButton">[[File:Mercury bw.png|32px|alt=Afficher le tchat|Afficher le tchat]]</span><!--
          --></span><!--
          --> <!--
          --><span id="LiveRCConfigButtonOn" ><!--
            --><span class="OnButton">[[File:Folder-system.png|32px|alt=Configuration|Masquer le panneau de configuration]]<!--
            --></span><!--
          --></span><!--
          --> <!--
          --><span id="LiveRCConfigButtonOff" ><!--
            --><span class="OffButton">[[File:Folder-system.png|32px|alt=Configuration|Afficher le panneau de configuration]]<!--
            --></span><!--
          --></span><!--
          --> <!--
          --><span id="LiveRCButtonOn" ><!--
            --><span class="OnButton">[[File:Exaile bw.png|32px|alt=Masquer LiveRC|Masquer LiveRC]] </span><!--
            --> <!--
            --><span id="LiveRCRCTableButtonOn" ><!--
              --><span class="OnButton">[[File:Config-date.png|25px|alt=Masquer les modifications|Masquer les modifications]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCRCTableButtonOff" ><!--
              --><span class="OffButton">[[File:Config-date.png|25px|alt=Afficher les modifications|Afficher les modifications]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCPreviewButtonOn" ><!--
              --><span class="OnButton">[[File:Preferences-desktop-screensaver.png|25px|alt=Masquer la prévisualisation|Masquer la prévisualisation]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCPreviewButtonOff" ><!--
              --><span class="OffButton">[[File:Preferences-desktop-screensaver.png|25px|alt=Afficher la prévisualisation|Afficher la prévisualisation]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCFollowButtonOn" ><!--
              --><span class="OnButton">[[File:Folder-favorites.png|25px|alt=Masquer les listes|Masquer les listes]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCFollowButtonOff" ><!--
              --><span class="OffButton">[[File:Folder-favorites.png|25px|alt=Afficher les listes|Afficher les listes]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCFooterButtonOn" ><!--
              --><span class="OnButton">[[File:Help-browser.png|25px|alt=Aide|Masquer l'aide]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCFooterButtonOff" ><!--
              --><span class="OffButton">[[File:Help-browser.png|25px|alt=Aide|Afficher l'aide]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCHistoryButtonOn" ><!--
              --><span class="OnButton">[[File:File-manager.png|25px|alt=Historique des prévisualisations|Masquer l'historique des prévisualisations]]<!--
              --></span><!--
            --></span><!--
            --> <!--
            --><span id="LiveRCHistoryButtonOff" ><!--
              --><span class="OffButton">[[File:File-manager.png|25px|alt=Historique des prévisualisations|Afficher l'historique des prévisualisations]]<!--
              --></span><!--
            --></span><!--
          --></span><!--
          --><span id="LiveRCButtonOff"><!--
              --><span class="OffButton">[[File:Exaile bw.png|32px|alt=Afficher LiveRC|Afficher LiveRC]]<!--
            --></span><!--
          --></span>
::::::::::Il y a des infobulles.
::::::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 24 août 2011 à 23:37 (CEST)
:::::::::::Bon bah ça doit venir de chez moi… --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 25 août 2011 à 08:31 (CEST)
::::::::::::Ouais ! Vive la nouvelle mise à jour ! --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 30 août 2011 à 08:42 (CEST)

== Nouvelle version ==

Salut,

Merci pour cette nouvelle version {{bravo}}, design ! Quelques questions cependant :
* Est-il possible de rendre le rouge des révocs plus fort ; toutes les couleurs sont un peu passées et pastel, ce qui rend moins facile la visualisation…
* Peux-tu éventuellement rajouter une option qui permette de remettre la fenêtre de prévisualisation au-dessus des lignes ?
*:+1 --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 30 août 2011 à 14:26 (CEST)
* C'est moi ou la police des prévisualisation est plus petite qu'avant ?
*:Même chose de mon coté {{triste}} --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 30 août 2011 à 14:26 (CEST)
* Ça, c'est plus une remarque qu'une question : C'est un peu sombre, quand, même, avec tout en gris… Et moins agréable, je trouve, pour la prévisualisation…

Merci bien {{clin}}, — [[Utilisateur:Jules78120|<span style="color:#008000">Jules</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 30 août 2011 à 08:46 (CEST)
:Je signale un détail au passage : il n'y a pas moyen d'apposer un modèle de bienvenutage sans le subster. Peut-on régler ça ? --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 30 août 2011 à 13:30 (CEST)
::<s>Ah ! Et les vielles RC restent, et la barre de défilement ne remonte pas automatiquement ! --[[Discussion utilisateur:Pic-Sou|Pic]][[Utilisateur:Pic-Sou|-]][[Special:Contributions/Pic-Sou|Sou]] 30 août 2011 à 13:31 (CEST)</s>
:::Bonjour,
:::dans un premier temps, je suis en train de me battre pour que cette nouvelle version marche avec cette #%!@&§ d'Internet Explorer (deux bugs non résolus pour le moment).
:::Sinon, Pour les différents styles, cela peut être modifié par CSS en modifiant votre [[Special:Mypage/LiveRCparam.css|LiveRCparam.css]]. Vous pouvez prendre exemple sur [[Mediawiki:Gadget-LiveRC.css]] pour la syntaxe.
:::Pour la fenêtre de prévisualisation au dessus des RC, c'est pas possible pour le moment.
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 août 2011 à 14:35 (CEST)
::::Merci pour ta réponse ; j'ai réussi à changer la couleur de fond, mais n'ai pas trouvé pour la police. Si quelqu'un sait ce qu'il faut modifier… {{Dr}} Brain, bon courage pour IE. — [[Utilisateur:Jules78120|<span style="color:#008000">Jules</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 30 août 2011 à 15:11 (CEST)
: Tout va bien sur Firefox, hormis le fait qu'il m'ait fallu augmenter la taille des caractères, parce que sinon, c'était illisible (mais ce sont peut-être mes yeux qui sont fatigués). Par contre sur Safari, ça fonctionne pareil, mais... il y a en haut un message en rouge qui dit : '''Version 0.5.0''' Vous utilisez la version '''0.5.0''' de LiveRC, qui est obsolète. Veuillez recharger le cache de votre navigateur pour utiliser la dernière version. Le gras est de moi. Etrange ? Par ailleurs, peut-on désactiver quelque part le surlignement vert quand la souris passe sur une ligne, je ne vois pas trop à quoi ça sert, et c'est plus gênant qu'utile. Pour le reste, faut s'habituer, mais ça devrait le faire. --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 30 août 2011 à 17:09 (CEST)
:: J'ai trouvé où modifier la taille des caractères pour les régler via LiveRCparam.css, ça rend l'usage plus confortable, et évite d'avoir de plus gros caractères dans tous les onglets de FF. Une bonne chose de faite, par contre, le surlignement vert, je ne sais pas (encore ?) comment le changer. --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 30 août 2011 à 19:44 (CEST)
:::Pour la plupart, ça correspond à des <code>:hover</code>. Exemple pour les RC : 
<source lang=CSS>
#tabRC tr:hover { 
    background-color:#A0D010 !important; 
}
#tabRC tr:hover td, #tabRC tr:hover th { 
    background-color:#A0D010 !important; 
}
#tabRC tr:hover td:hover, #tabRC tr:hover th:hover { 
    background-color:#A0F010 !important; 
}
</source>
:::Il faut que tu mettes la même couleur que normalement, voire pas de couleur ( <code>background:none !important;</code> ).
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 août 2011 à 19:51 (CEST)

Ce que je vois au premier coup d'œil :
* Points positifs :
** Ça occupe tout l'écran
** Le diff reste à sa place en bas de l'écran au lieu de se balader partout
** Le surlignage de la ligne courante est du meilleur effet
* Points négatifs
** Les infobulles sur les boutons du haut ne fonctionnent pas chez moi (cf. Pic-Sou)
** Les caractères sont trop petits (cf. les autres)
** L'intégration des popups semble avoir été cassée
Si ce dernier point ne gêne que moi, je m'en occuperai quand j'aurai le temps {{clin}}.

Bravo et merci ! — [[Utilisateur:Arkanosis|Arkanosis]] <sup>[[Discussion Utilisateur:Arkanosis|✉]]</sup> 30 août 2011 à 20:06 (CEST)

:* Pour les infobulles des boutons, j'avoue que je ne comprends pas. Celles-ci sont directement ajoutées au [{{fullurl:Wikipédia:LiveRC|action=edit}} wikitexte].
:* Il semblerait. Il faut vous mettre d'accord sur les valeurs qui vont bien et j'agrandirai ça.
:* C'est sans doute du au fait que l'interface n'est plus dans le "bodyContent".
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 30 août 2011 à 20:25 (CEST)
:: Perso je vois les infobulles, le pb de la taille des caractères est réglée (chacun peut choisir le sien en fonction de son acuité visuelle), les popups, je ne sais pas ce que c'est... le surlignage plaît à l'un mais pas à l'autre {{sourire}}, et rien ne change si je remplace le background color par none, mais c'est un détail (et certainement un pb d'interface chaise-clavier, il y a si longtemps que je n'ai pas mis le nez dans une feuille de style..), le reste va bien, quel travail tu as fait ! --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 30 août 2011 à 20:30 (CEST)
:::Pas trouvé pour la taille de police {{triste}}. — [[Utilisateur:Jules78120|<span style="color:#008000">Jules</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 30 août 2011 à 20:51 (CEST)
::::[[Utilisateur:Theoliane/LiveRCparam.css |Copie-colle]] ceci, celui devrait aller. De mon coté aussi c'est nettement mieux pour mes pauvres yeux myopes {{triste}}. --[[Utilisateur:Superjuju10|Superjuju10]] <sup>[[Discussion utilisateur:Superjuju10|Auboisement à votre écoute]]</sup> 30 août 2011 à 21:06 (CEST)
:::::{{fait}}. Merci. — [[Utilisateur:Jules78120|<span style="color:#008000">Jules</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 31 août 2011 à 09:52 (CEST)

Pitié, enlevons le surlignage en vert. Sinon comme dit ci-dessus y'a quand même des avantages dont le fullscreen). Il serait aussi bon de rajouter un title ou alt, je sais plus, aux boutons pour que leur fonction s'affiche au survol de la souris [[Utilisateur:Argos42|<span style="color: blue">Argos</span>]] -  [[Discussion utilisateur:Argos42|<span style="color: blue;">oO</span>]] 10 septembre 2011 à 23:54 (CEST)
:C'est vrai qu'en vert c'est peut-être (un peu) trop flashy. Quelque chose de plus sobre conviendrait mieux. Du gris ? Ou peut-être ne faire ressortir que la bordure ?
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 11 septembre 2011 à 00:01 (CEST)

== Bug ==

Salut,

La nouvelle version de LiveRC est super, sauf pour moi. Tout s'affiche... sauf les RC. Figurez-vous que c'est pas si pratique que ça..! Je suis sur Mac et j'utilise Mozzila Firefox ou Safari. Sur aucun des deux cela ne fonctionne. 

@Dr Brains : J'ai bien lu ton message. Merci de ses conseils mais je suis bien incapable de créer une extension, n'ayant pas assez de connaissances en Java.

Merci beaucoup. Je vais essayer de voir si j'arrive à m'en sortir, mais c'est pas gagné...

<big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 31 août 2011 à 11:51 (CEST)
:Avec Firefox, est-ce que tu as des erreurs (Outils >> Console d'erreur) ?
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 août 2011 à 13:15 (CEST)
:: Ah ben ça alors, c'est étrange. Je suis aussi sur Mac (version Tiger de MacOSX, machine qui a 4 ans maintenant..), et je n'ai aucun pb avec Firefox 3.6.20 (au passage, Dr Brains, polices et surlignement ayant été réglés, tout baigne). Mais aucun non plus sur Safari 4.1.3. sauf qu'il me signale que j'utilise la version 0.5.0. qui est obsolète.... ce qui ne l'empêche pas de fonctionner tout à fait normalement. --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 31 août 2011 à 14:31 (CEST)
:::Aucun bug dans la console d'erreur. <big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 31 août 2011 à 14:32 (CEST)
::::Quand tu cliques sur le bouton [[File:Config-date.png|25px|alt=Afficher les modifications|Afficher les modifications]] en haut à gauche ça ne fait rien ?
::::T'as bien coché la case "RC" dans le menu ?
::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 août 2011 à 14:36 (CEST)
:::::Theoliane : avec Safari 5.0, je n'ai pas ton pb de version obsolète. Tu pourrais faire une capture d'écran ?
:::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 août 2011 à 16:22 (CEST)
:::::: J'en ai mise une [http://sites.google.com/site/armoiredetheoliane/images là] j'espère que tu pourras y accéder, parce que je n'ai pas trop l'habitude de google sites... --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 31 août 2011 à 16:52 (CEST)
:::::::Oula. C'est pas normal que tu aies la phrase deux fois tout en ayant le N° colorié en vert. Tu n'aurais pas sélectionné le gadget '''et''' mis LiveRC dans ton monobook ?
:::::::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 août 2011 à 16:58 (CEST)
:::::: Alors là, c'est sous Vector en plus, et comme c'est mon second compte (celui qui édite, pas celui qui fait de la maintenance qui utilise Safari) je n'y utilise pas LiveRC habituellement, je l'ai lancé pour tester, donc, je vérifie ce que tu dis.. J'ai tournicoté le truc dans tous les sens, supprimant la mention de LiveRC dans le monobook, en gardant le gadget, j'ai fait l'inverse, et j'ai toujours la mention en rouge, avec aussi plusieurs instances de LiveRC dans la colonne de gaudhe sous ''contribuer''... Mais c'est pas grave, d'abord, ça ne gêne pas le fonctionnement, et surtout, je ne m'en sers pas sous Safari, donc, pas la peine de se prendre la tête avec ça, c'est véniel, et je crains qu'à force de faire 36 essais, ça finisse par ne plus fonctionner du tout... Donc, j'en reste là sans soucis. Merci du temps que tu prends à me répondre. --[[Utilisateur:Theoliane|Theoliane]] ([[Discussion utilisateur:Theoliane|d]]) 31 août 2011 à 17:02 (CEST)
:::::::@ Dr Brains : La case RC est coché. Quand je clique sur [[File:Config-date.png|25px|alt=Afficher les modifications|Afficher les modifications]], le rectangle gris est remplacé par le bouquin ouvert de Wiki. Je comprends que la fenètre de diff est fermé. Merci. <big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 31 août 2011 à 19:18 (CEST)
{{RI|:::::::}}Bon, après de gros efforts, la V 0.5 est à présent fonctionnelle avec IE (merci beaucoup à {{U|Od1n}} pour son aide).

Althiphika : c'est quoi que tu appelles "le bouquin ouvert de Wiki" ?

'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 31 août 2011 à 21:41 (CEST)
:Capture d'écran : 
[[Fichier:Althiphika002.JPG|thumb|left|le fameux bouquin ouvert de wiki.]] J'ai en permanence le logo de LiveRC qui tourne, mais rien de plus. Tu veux une capture vidéo?<big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 1 septembre 2011 à 17:27 (CEST)
::Et quand t'es là et que tu cliques sur [[File:Config-date.png|25px|alt=Afficher les modifications|Afficher les modifications]], il ne se passe rien ?
::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 1 septembre 2011 à 17:38 (CEST)
[[Fichier:Althiphika003.jpg|thumb|right|voila ce que je vois quand je clique dessus. <big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 1 septembre 2011 à 18:23 (CEST)]]
:::Bizarre. La barre de menu s'affiche (c'est normal), l'icône devient verte (c'est normal aussi), mais les RC ne viennent pas. Le fait que l'icône reste animé signifie qu'il y a un problème au cours de la requête mais je ne vois pas bien ce que ça pourrait être si tu n'as pas d'erreur javascript dans la console. C'est quoi ce navigateur ?
:::'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 1 septembre 2011 à 18:27 (CEST)
::::Je n'en sais rien, mais ce n'est pas la première fois. Mais c'est juste de puis qu'on est passé sur la 0.5. Je peux toujours marcher sur l'ancienne version, j'ai le script, mais bon, c'est pénible... <big>''[[Utilisateur:Althiphika|<span style="color:#8000FF;">Althiphika</span>]]'' [[Discussion Utilisateur:Althiphika|<span style="color:#FF8000;"><small>Ψ</small>Ψ<small>Ψ</small></span>]]</big> 1 septembre 2011 à 19:58 (CEST)

== Version old-school ==
Bonsoir, j'aimais beaucoup la sobriété de l'ancienne version et je me demande si une alternative "moins flashy" pourrait être développée un jour (en option), sans barre verte, ni logos multicolores et avec une police agréable ? Ca permettrai de ne pas rester avec l'ancienne version et de continuer à bénéficier des améliorations futures. [[image:Start-here.svg|13px|Discut'|link=Discussion utilisateur:Frakir]] [[Utilisateur:Frakir|Frakir]] 11 septembre 2011 à 00:18 (CEST)
:Salut. Quand tu auras le temps, Dr Brains, tu penseras à nous également, pour une option qui permettrait de mettre la fenêtre de prévisualisation au-dessus, les lignes RC en dessous ? Merci et bon dimanche {{clin}}. — [[Utilisateur:Jules78120|<span style="color:#008000">Jules</span>]] <sup>([[Discussion utilisateur:Jules78120|<span style="color:#ffa500">'''Discuter !'''</span>]])</sup> 11 septembre 2011 à 09:44 (CEST)

== Montrer les changements faits dans la liste de suivi ==

Bonjour, il semble que l'option "Montrer les changements faits dans la liste de suivi" ne marche pas. En effet je ne vois pas passer les changements faits aux pages que je suis si elles sont faites par des utilisateurs confirmés quand je ne regarde que "IP seules + débutants". ~~
:Ça me l'avais fait à un moment. En re-sauvegardant mes options (mon <code>/LiveRCparam.js</code>) ça avait réglé le pb.
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 16 septembre 2011 à 19:52 (CEST)

== Icônes test ==

Bonjour,
J'aimerais savoir si c'est moi qui a changé les paramètres (j'ai tout effacé mes paramètres personnels pour passer à la nouvelle version de LiveRC) ou si c'est quelquechose qui n'a pas fait le saut dans cette version mais j'aimais bien les icônes qui indiquait les bandeaux test qu'avait reçu une personne. Est-il possible de les ravoir? Si oui, comment? Merci d'avance pour votre aide, [[Utilisateur:Letartean|Letartean]] ([[Discussion utilisateur:Letartean|d]]) 17 septembre 2011 à 14:20 (CEST)
:Il s'agit d'une extension. A voir dans le menu de configuration si elle n'est pas décochée.
:'''⇨&nbsp;[[Utilisateur:Dr Brains|D<sup>r</sup>&nbsp;Brains]]&nbsp;''<sup>∞&nbsp;[[Discussion utilisateur:Dr Brains|Consultation]]&nbsp;∞</sup>''''' 17 septembre 2011 à 14:25 (CEST)