UserWarningsExtension.js est une extension pour [[WP:LRC|LiveRC]]. Elle permet d'identifier par une icône les utilisateurs ayant reçu un avertissement récent.

Cette extension fonctionne en analysant le résumé des modifications effectuées sur la page de discussion. La détection est donc limitée aux avertissements laissés par Salebot, avec LiveRC, ou à condition que le nom du modèle soit présent dans le résumé.

== Utilisation ==

L'extension est disponible dans le menu de configuration de LiveRC.

Dans la configuration standard, les utilisateurs ayant reçu un avertissement sont identifiés par les icônes suivantes (s'il y en a plusieurs, seul le dernier est pris en compte) :
*[[Fichier:Salebot small icon.png|16px]] : avertissement laissé par Salebot
*[[Fichier:LiveRC Test0.png|16px]] : {{m|test 0}} ou {{m|test :)}}
*[[Fichier:LiveRC Test1.png|16px]] : {{m|test 1}}
*[[Fichier:LiveRC Test2.png|16px]] : {{m|test 2}}
*[[Fichier:LiveRC Test3.png|16px]] : {{m|test 3}}
*[[Fichier:LiveRC Spam.png|16px]] : {{m|spammeur}}

== Personnalisation ==

La personnalisation est maintenant possible directement dans LiveRC, ce qui suit décrit l'ancienne méthode en éditant directement LiveRCparam.js.
{{À actualiser}}

Plusieurs variables peuvent être définies dans [[Spécial:Ma page/LiveRCparam.js|LiveRCparam.js]] pour :
* personnaliser les messages gérés ;
* changer le délai avant que les avertissements soient considérés comme caducs ;
* changer la couleur du lien de l'utilisateur selon l'état de sa page de discussion.

=== Messages ===

La variable lrcXUWMessages peut être redéfinie pour gérer d'autres messages en suivant l'exemple ci-dessous. Pour chaque message, les paramètres suivants doivent être définis :
* tooltip : description textuelle de l'avertissement ;
* regex : une expression régulière pour détecter l'avertissement dans le résumé de modification (casse ignorée) ;
* image : icône 16x16 affichée lorsque cet avertissement est détecté.

Exemple :
<source lang="javascript">
lrcXUWMessages = [
  {tooltip: "Averti : test 1", regex: "test ?1", image: "http://upload.wikimedia.org/wikipedia/commons/5/5d/LiveRC_Test1.png"},
  {tooltip: "Averti : test 2", regex: "test ?2", image: "http://upload.wikimedia.org/wikipedia/commons/7/78/LiveRC_Test2.png"},
  {tooltip: "Averti : test 3", regex: "test ?3", image: "http://upload.wikimedia.org/wikipedia/commons/7/7b/LiveRC_Test3.png"}
];
</source>

=== Délai ===
La variable lrcXUWDelay donne le délai en millisecondes. Par défaut, elle vaut 24 * 3600 * 1000 (un jour), soit {{unité|86400000|ms}}.

Utilisation :
<source lang="javascript">
lrcXUWMessages = 86400000;
</source>

=== Couleur du lien de l'utilisateur ===

Les trois variables suivantes peuvent être définies :
* lrcXUWColorNoTalk : couleur du lien quand la page de discussion n'existe pas ;
* lrcXUWColorRecentTalk : couleur du lien quand la page de discussion a été modifiée pendant le délai de détection, sans qu'un avertissement soit détecté ;
* lrcXUWColorRecentWarning : couleur du lien quand un avertissement a été détecté.

Exemple :
<source lang="javascript">
lrcXUWColorNoTalk = "#606060";
lrcXUWColorRecentTalk = "#0060ff";
lrcXUWColorRecentWarning = "red";
</source>