'''iKiwi''' est un script à importer dans son [[Special:Mypage/common.js|common.js]] pour disposer de fonctionnalités supplémentaires.

== Installation ==

Pour installer iKiwi, il suffit d'ajouter la ligne suivante dans son [[Special:Mypage/common.js|common.js]].

<source lang="javascript">
importScript('User:Arkanosis/iKiwi.js');
</source>

Pour être prévenu des mises à jour, pensez à placer cette page de documentation dans votre liste de suivi : elle est mise à jour à chaque nouvel ajout de fonctionnalité.

== Fonctionnalités ==

''Attention'', les fonctionnalités qui ne sont pas listées ci-dessous ne sont pas encore considérées comme stables, utilisez-les uniquement si vous êtes sûr de vous.

=== Activées par défaut ===

* iKiwi ajoute un lien ''iKiwi'' pour rapatrier automatiquement les liens interwikis présents sur une autre version d'un article (la version anglophone, par exemple) dans sa version francophone.
* iKiwi ajoute des liens aux sous-pages du [[Projet:Interwikification]] pour déclencher automatiquement l'ajout de liens interwikis

=== À activer par l'utilisateur ===

''Rien pour l'instant''

=== Options ===

* '''iKiwiDistantWikis''' : wikis sur lesquels récupérer les liens interWikis (par défaut : les onze plus gros wikis — à remplacer par un tableau contenant ''de'', ''pl''... ; le premier wiki est celui sélectionné par défaut)
* '''iKiwiWatchMain''' : ajoute les articles modifiés (avec iKiwi) dans la liste de suivi
* '''iKiwiWatchOthers''' : ajoute toutes les pages modifiées (avec iKiwi) dans la liste de suivi
* '''iKiwiDisplayPanel''' : affiche iKiwi en haut de chaque page (activé par défaut)
:'''''Note''''' : si cette option est désactivée, iKiwi n'est utilisable que depuis les sous-pages du [[Projet:Interwikification]]

=== Exemple de configuration d'Kiwi dans un common.js ===

<source lang="javascript">

// Options
var iKiwiDistantWikis = ['de', 'en']; // Récupérer les liens interWikis sur la Wikipédia germanophone et sur l'anglophone uniquement (par défaut sur l'anglophone)
var iKiwiWatchMain = true; // Ajoute les articles modifiés avec iKiwi dans la liste de suivi
var iKiwiWatchOthers = true; // Ajoute toutes les pages modifiées avec iKiwi dans la liste de suivi
var iKiwiDisplayPanel = false; // Cache iKiwi ; l'outil n'est utilisable qu'à partir de [[P:IW]]

// Activation d'iKiwi
importScript('User:Arkanosis/iKiwi.js');

</source>

== Compatibilité ==

iKiwi a été testé avec les thèmes monobook et vector, sous Firefox > 1.5, sous Chrome et sous Opera mini.
Il semblerait qu'il ne fonctionne pas sous Internet Explorer ni sous Konqueror.<ref>Si vous avez testé avec un autre navigateur, votre retour d'expérience est le bienvenu.</ref>

== Support ==

Le support d'iKiwi est assuré sur [[Discussion utilisateur:Arkanosis|la page de discussion d'Arkanosis]].

== Historique des versions ==

* 0.6 — 19 mars 2011 : compatibilité avec les dernières mises à jour de sécurité, suggestions de titres basées sur de l'apprentissage, il n'y a plus besoin d'installer iKiwi sur les wikis distants
* 0.5 — 25 septembre 2010 : normalisation et traduction des titres, choix automatique de la langue distante sur les sous-pages du [[Projet:Interwikification]]
* 0.4 — 15 mars 2010 : internationalisation, récupération automatique des interWikis de ja:, nl:, pt:, ru:, sv:, récupération automatique des interWikis ''depuis'' de:, en:
* 0.3 — 11 mars 2010 : suivi des redirections sur le wiki distant
* 0.2 — 10 mars 2010 : récupération automatique des interWikis de de:, es:, it: et pl:, aperçu automatique, gestion des sous-pages du [[Projet:Interwikification]]
* 0.1 — 17 février 2010 (première version) : récupération automatique des interWikis de en:

== Nouvelles fonctionnalités prévues pour les prochaines versions ==

Les fonctionnalités suivantes sont prévues pour les prochaines versions d'iKiwi :

* Court terme
** Nom des articles distants selon [[P:IW]] et déclenchement automatique sur le wiki distant
** Internationalisation de base pour tous les wikis supportés — '''votre aide est la bienvenue'''
** Utilisation des interWikis déjà présents (le cas échéant) pour déterminer la page distante par défaut
* Moyen terme
** Parcours automatique des articles à wikifier listés par {{u'|DSisyphBot}}
** Ajout des interWikis fr: sur les wikis distants
** Affichage des résultats de recherche lorsque la page distante n'existe pas
* Long terme
** Navigation « naturelle » sur le wiki distant
** Autocomplétion du nom de l'article distant

Vous pouvez suggérer l'ajout d'autres fonctionnalités sur [[Discussion utilisateur:Arkanosis|la page de discussion d'Arkanosis]].

== Remerciements ==

Les personnes suivantes ont contribué à l'amélioration d'iKiwi :
* {{u'|Dr Brains}} : test des toutes premières versions et conseils avisés, suivi des interwikis déjà présents
* {{u'|Sisyph}} : tests avec différents navigateurs, rapports de bugs, suggestions
* {{u'|Sebleouf}} : tests et suggestions

== Notes ==

<references />