'''xpatrol''' est un script à importer dans son [[Spécial:Ma page/common.js|common.js]] pour disposer de fonctionnalités supplémentaires.

== Installation ==

Pour installer xpatrol, il suffit d'ajouter la ligne suivante dans son [[Spécial:Ma page/common.js|common.js]].

<source lang="javascript">
importScript('User:Arkanosis/xpatrol.js');
</source>

Pour être prévenu des mises à jour, pensez à placer cette page de documentation dans votre liste de suivi : elle est mise à jour à chaque nouvel ajout de fonctionnalité.

== Fonctionnalités ==

''Attention'', les fonctionnalités qui ne sont pas listées ci-dessous ne sont pas encore considérées comme stables, utilisez-les uniquement si vous êtes sûr de vous.

=== Activées par défaut ===

* xpatrol modifie le lien ''Marquer comme relue'' des pages de diff pour qu'un clic sur celui-ci effectue le marquage sans changer de page.
*:Cette fonctionnalité n'est disponible que pour les [[Aide:Statuts_des_utilisateurs#Utilisateur_autopatrolled|utilisateurs autopatrolled]].
* xpatrol ajoute la fonctionnalité ''Masquer les pages blanchies'' sur la page [[Spécial:Nouvelles pages]]
* xpatrol ajoute la fonctionnalité ''Masquer les pages non blanchies'' sur la page [[Spécial:Nouvelles pages]]
* xpatrol ajoute la fonctionnalité ''Masquer les pages supprimées'' sur la page [[Spécial:Journal du filtre antiabus]]
* xpatrol ajoute des liens vers l'historique des articles et vers leurs journaux sur la page [[Spécial:Journal du filtre antiabus]]

=== À activer par l'utilisateur ===

* xpatrol permet de blanchir une page rapidement
*:Cette fonction n'est disponible que pour les [[Aide:Statuts_des_utilisateurs#Utilisateur_autoconfirmed|utilisateurs autoconfirmed]].
*:Elle est activée par l'option xpatrolEnableClear
* xpatrol permet d'ajouter rapidement un bandeau (parmi une sélection de bandeaux actuellement figée<ref>Si un bandeau vous manque, vous pouvez demander son ajout, ou motiver l'auteur pour que la sélection soit configurable (facile)</ref>)
*:'''''Attention''''' : il n'y a pas encore de ''feedback'' sur l'ajout d'un bandeau : le bandeau ajouté ne s'affiche pas après l'ajout ; il ne faut '''surtout pas''' l'ajouter plusieurs fois.
*:Elle est activée par l'option xpatrolEnableBanner

<references />

=== Options ===

* '''xpatrolEnableClear''': active la fonctionnalité de blanchiment
* '''xpatrolEnableBanner''': active la fonctionnalité d'ajout de bandeau
* '''xpatrolWatchMain''': ajoute les articles modifiés (avec xpatrol) dans la liste de suivi
* '''xpatrolWatchOthers''': ajoute toutes les pages modifiées (avec xpatrol) dans la liste de suivi

=== Exemple de configuration de xpatrol dans un monobook.js ===

<source lang="javascript">

// Options
xpatrolEnableClear = true; // Active la fonctionnalité de blanchiment de page
xpatrolEnableBanner = true; // Active la fonctionnalité d'ajout de bandeau
xpatrolWatchMain = true;   // Ajoute les articles blanchis dans la liste de suivi
xpatrolWatchOthers = true; // Ajoute toutes les pages blanchies dans la liste de suivi

// Activation de xpatrol
importScript('User:Arkanosis/xpatrol.js');

</source>

== Support ==

Le support de xpatrol est assuré sur [[Discussion utilisateur:Arkanosis|la page de discussion d'Arkanosis]].

== Historique des versions ==

* 15 mars 2011 : possibilité de masquer les nouvelles pages non blanchies sur [[Spécial:Nouvelles pages]]
* 30 mars 2010 : possibilité de masquer les pages supprimées sur [[Spécial:Journal du filtre antiabus]]
* 18 mars 2010 : ajout de liens vers l'historique et le journal de chaque article affiché sur [[Spécial:Journal du filtre antiabus]]
* 24 janvier 2010 : la fonctionnalité d'ajout de bandeaux est considérée stable, possibilité de ré-afficher les pages blanchies après les avoir masquées, sur [[Spécial:Nouvelles pages]]
* 2 décembre 2009 : intégration de la fonctionnalité de blanchiment de page
* 27 novembre 2009 : possibilité de masquer les nouvelles pages blanchies sur [[Spécial:Nouvelles pages]]
* 26 novembre 2009 : fonctionnalité de blanchiment automatique d'un article (non activée par défaut)
* 10 novembre 2009 (première version) : ''Marquer comme n'étant pas un vandalisme'' ne nécessite plus de changer de page

== Nouvelles fonctionnalités prévues pour les prochaines versions ==

Les fonctionnalités suivantes sont prévues pour les prochaines versions de xpatrol :

* Enregistrement de l'état (affiché / masqué) des pages blanchies sur [[Spécial:Nouvelles pages]] dans un cookie
* ''Feedback'' lors de l'ajout rapide de bandeaux sur un article
* Ajout rapide de bandeaux sur des sections, plutôt que sur l'article entier
* Configurabilité des motifs de blanchiment et des bandeaux disponibles
* Restauration rapide d'une ancienne version d'une page (avec commentaire automatique)
* Annulation d'une modification ''qui n'est pas la dernière'' (ou de plusieurs)
* Demande de purge d'historique automatique sur [[Wikipédia:Demande_de_purge_d'historique|la page dédiée]] lors d'une violation des droits d'auteur
* Avertissement contextualisé automatique sur la page de discussion d'un contributeur

Vous pouvez suggérer l'ajout d'autres fonctionnalités sur [[Discussion utilisateur:Arkanosis|la page de discussion d'Arkanosis]].

== Remerciements ==

Les personnes suivantes ont contribué à l'amélioration de xpatrol :
* {{u'|Linedwell}} : corrections de fautes d'orthographe
* {{u'|Dr Brains}} : possibilité de ré-afficher les pages blanchies après les avoir masquées, sur [[Spécial:Nouvelles pages]]
* {{u'|Anaemaeth}} : rapport de bug
* {{u'|Loreleil}} : rapport de bug