{{:Utilisateur:Dr Brains/onglets}}
[[Image:Demo GlobalManager JS.png|thumb|500px|Aperçu de la page .js]]
<big>'''[[Utilisateur:Dr Brains/GlobalManager.js|GlobalManager]]'''</big> est un [[Javascript|script]] qui permet de gérer une liste de codes [[Javascript]] à la manière des gadgets. [http://en.wikipedia.org/w/index.php?title=User:Jitse_Niesen/Client-side_preferences/Main.js&oldid=88607798 Idée et code original]

Une fois installé, les pages de skin personnelles .js accueillent un menu permettant d'ajouter ou retirer un code à l'aide de simples cases à cocher.

La liste des scripts proposés est totalement configurable en suivant les indications ci-dessous.

== Utilisation ==

=== Fonctionnement ===

GlobalManager ajoute deux liens au-dessus de chaque page
<ref>L'endroit où les liens s'affichent dépend de l'habillage actif :
* Monobook, Moderne, Vector, Chick, Mon Interface, Simple : dans les liens personnels.
* Bleu de Cologne, Nostalgia, Standard : au sommet de la page.
</ref> :
* Un lien vers la page du manager (pour la configuration),
* Un lien vers la page personnelle .js, 

<references />


Ainsi, depuis n'importe quelle page, par le biais de simples cases à cocher (ou décocher), GlobalManager permet d'insérer un script (via un tag <nowiki><script></nowiki> ) dans sa page personnelle .js

==== Remarques ====

Ce script est facilement exportable et devrait marcher sur tout site utilisant Mediawiki.

Une configuration plus poussée est à effectuer si les skins du site diffèrent de ceux de Wikipédia (voir dans le code les parties personnalisables).

=== Habillage ===

GlobalManager permet de gérer des scripts ou des feuilles de styles sur tous les habillages disponibles et fonctionne avec les habillages :
* "Bleu de Cologne" 
* "Moderne"
* "Monobook"
* "Nostalgie"
* "Poussin"
* "Standard"
* "Vector"
* "Simple"
* "Mon Interface"

=== Navigateur ===

* Mozilla Firefox 3.5 : OK
* Google Chrome 3 : OK
* Opera 10 : OK
* Internet Explorer 8 : OK.

== Installation ==

La méthode ci-dessous explique l'installation pour Monobook. C'est exactement la même méthode pour les autres skins.

Pour installer ce gestionnaire :

'''1.''' Copiez [[Discussion utilisateur:Dr Brains/GlobalManager.js#CODE SOURCE|ce code]] dans [[Spécial:MyPage/GlobalManager.js|Utilisateur:<votre nom>/GlobalManager.js]],<ref>Vous pouvez aussi copier le code de la [[Utilisateur:Dr Brains/GlobalManager.js|page associée]], vous vous retrouverez avec les scripts que j'utilise (ou que je teste) déjà installés. Lisez leur [http://fr.wikipedia.org/w/index.php?title=Sp%C3%A9cial:Index/Dr_Brains/&namespace=3 documentation] ou la page [[Utilisateur:Dr Brains/Scripts]] pour savoir ce qu'ils font.</ref><br>
'''2.''' Si nécessaire, configurez les paramètres comme expliqué ci-dessous. <br>
'''3.''' Copiez le code suivant dans votre page [[Spécial:MyPage/monobook.js|Utilisateur:<VotreNom>/monobook.js]] en remplaçant MY_NAME par votre pseudo (x2) : <br>
{| style="border:1px dotted red;"
|
<syntaxhighlight lang=javascript>
//DebutSectionAuto : Cette section est produite par le script [[Utilisateur:MY_NAME/GlobalManager.js]]
//ConfigSectionAuto

document.write('<script type="text/javascript" src="http://fr.wikipedia.org/w' + 
               '/index.php?title=Utilisateur:MY_NAME/GlobalManager.js&action=raw&ctype=text/javascript"></script>');

//FinSectionAuto
</syntaxhighlight>
|}
'''4.''' Rechargez le cache de votre navigateur et le script devrait s'activer, <br>
'''5.''' Configurer les définitions comme expliqué ci-dessous. <br>
<references />

=== Remarques ===

Une fois installé pour un skin, il est très facile d'installer ce gestionnaire pour les autres : <br>
En effet, il s'active et édite la page sur laquelle se trouve l'utilisateur, même si ce n'est pas la page liée au skin actif. <br>
Il suffit donc de se rendre sur la page [[Spécial:MyPage/modern.js|modern.js]] ou [[Spécial:MyPage/vector.css|vector.css]] pour y installer les gadgets voulus et le script gestionnaire par la même occasion.

Il est à noter cependant que le script ne gère pas bien les pages inexistantes, c'est à dire que si vous allez sur la page [[Spécial:MyPage/standard.js|Utilisateur:<votre nom>/standard.js]] alors qu'elle n'a pas encore été créée, un message d'erreur s'affiche : {{Citation|Il y a eu un problème avec la requête.}}.<br>
Dans ce cas, créez simplement la page, ajoutez {{Citation|{{coloré|red|<nowiki>//</nowiki>}}}} (.js) ou {{Citation|{{coloré|red|<nowiki>/**/</nowiki>}}}}(.css), publiez et rechargez le cache de votre navigateur.

Le nom du site courant et celui du site où sont stockés les codes sont gérés par deux variables différentes, ce qui permet de bénéficier de ces codes sur différents sites. Il est par exemple possible d'avoir GlobalManager et les différentes pages de code ici sur fr, et d'en bénéficier sur un autre site, simplement en copiant le code ci-dessus dans son monobook sur le site extérieur. Cependant, il faut noter que l'environnement (javascript en particulier) peut être différent et les codes qui marchent ici peuvent ne pas fonctionner ailleurs (voir par exemple [[:en:User:Dr Brains/Utilities.js]], créé pour assurer la compatibilité des codes fr avec en.wikipedia ou d'autres).

== Configuration ==

Il y a plusieurs parties personnalisables dans le script. Dans l'ordre d'apparition dans le code :
# La définition des codes [[Javascript]]
# La définition des skins supportés sur le site
# La définition des paramètres personnels
# La définition des textes

Hormis les skins supportés, ces personnalisations se font à l'aide de fonction au nom prédéterminé :
* '''<tt>GlobalManager_LangCustom()</tt>''' pour les textes
* '''<tt>GlobalManager_UserCustom()</tt>''' pour les paramètres personnels (
* '''<tt>GlobalManager_GetUserScripts()</tt>''' pour déterminer la liste des codes

Ces fonctions sont à inscrire directement dans la page [[Special:Mypage/monobook.js|monobook.js]] (ou [[Special:Mypage/vector.js|vector.js]], ou autre suivant l'habillage sélectionné dans les [[Spécial:préférences|préférences]].

=== 1 : Définition des script ===
Chaque script ou sous-titre de section est défini par quatre variables :
* '''<tt>GlobalManager_ScriptType</tt>''', qui définit le type de définition, 1 si il s'agit d'un script, 2 à 6 si il s'agit d'un titre de section.
* '''<tt>GlobalManager_ScriptText</tt>''', qui définit le texte d'explication du script ou le contenu du titre de section (en [[HTML]]).
* '''<tt>GlobalManager_ScriptId</tt>''', qui défini l'ID (identifiant) du script. Celui-ci doit être différent pour chaque script, idéalement, il vaut mieux utiliser le nom de la page. Si il s'agit d'un titre de section, ce paramètre ne sert à rien mais doit tout de même être défini.
* '''<tt>GlobalManager_ScriptPage</tt>''', qui définit le titre de la page où est stocké le script, les éventuels espaces remplacés par des underscores. Si il s'agit d'un titre de section, ce paramètre ne sert à rien mais doit tout de même être défini.

'''<big>IMPORTANT</big>''' : l'ordre de définition des scripts est inverse de l'ordre d'insertion dans la page .js : le dernier script défini sera le premier inséré. 

Ces définitions doivent prendre place à l'intérieur d'un fonction nommée '''<tt>GlobalManager_GetUserScripts()</tt>''', sans quoi ce sont les scripts définis dans la fonction '''<tt>GlobalManager_GetDefaultScripts()</tt>''' qui sont pris en compte.

==== Exemples ====

* Définition d'un script ou d'un titre de section :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>

function GlobalManager_GetUserScripts(){ // Début de la fonction

/* Définition d'un titre de section */
    GlobalManager_ScriptType.push(4);
    GlobalManager_ScriptText.push('Scripts opérationnels');
    GlobalManager_ScriptId.push('');
    GlobalManager_ScriptPage.push('');

/* Définition d'un script */
    GlobalManager_ScriptType.push(1);
    GlobalManager_ScriptText.push('Modifications récentes en temps réel.');
    GlobalManager_ScriptId.push('LiveRC');
    GlobalManager_ScriptPage.push('Utilisateur:EDUCA33E/LiveRC.js');

} // Fin de la fonction
</source></div>

=== 2 : Définition des skins ===

Les habillages disponibles sont listés dans une variable de type Array. Ils y sont ajoutés via la méthode <tt>.push()</tt>. Pour modifier cette liste, il suffit donc d'ajouter ou retirer un élément de la liste.

Définition actuelle pour Wikipédia :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
// Liste des skins disponibles
var GlobalManager_RunningSkins = new Array(); 
GlobalManager_RunningSkins.push('monobook');
GlobalManager_RunningSkins.push('chick');
GlobalManager_RunningSkins.push('simple');
GlobalManager_RunningSkins.push('myskin');
GlobalManager_RunningSkins.push('modern');
GlobalManager_RunningSkins.push('vector');
GlobalManager_RunningSkins.push('cologneblue');
GlobalManager_RunningSkins.push('nostalgia');
GlobalManager_RunningSkins.push('standard');
</source></div>
 
=== 2 : Définition des paramètres ===
Les paramètres personnels correspondent à :
* '''<tt>GlobalManager_LangFrom</tt>''' : la langue du wiki où se trouvent les scripts et le GlobalManager
* '''<tt>GlobalManager_URLFrom</tt>''' et '''<tt>GlobalManager_URLBisFrom</tt>''' : le début des addresses du wiki où se trouvent les scripts et le GlobalManager
* '''<tt>GlobalManager_HomePage</tt>''' : Le titre de la page où se trouve le GlobalManager
* '''<tt>GlobalManager_Resume</tt>''' : Le résumé de modification, utilisé lors de la mise à jour. 
* '''<tt>GlobalManager_CommStart</tt>''', '''<tt>GlobalManager_CommPlus</tt>''', '''<tt>GlobalManager_CommConfig</tt>''', '''<tt>GlobalManager_CommEnd</tt>''',  : Les commentaires insérés dans la page mise à jour :
** '''<tt>GlobalManager_CommStart</tt>''' correspond au début de la section mise à jour par le GlobalManager
** '''<tt>GlobalManager_CommEnd</tt>''' correspond au début de la section mise à jour par le GlobalManager
** '''<tt>GlobalManager_CommConfig</tt>''' indique la ligne de configuration, où sont listés les ID des scripts déjà installés
** '''<tt>GlobalManager_CommPlus</tt>''' est un commentaire supplémentaire ajouté après le commentaire du début.

Paramètres pour {{u|Dr Brains}} :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
// Langue du wiki d'origine
    GlobalManager_LangFrom = 'fr';
 
// Adresses du wiki d'origine
    GlobalManager_URLFrom = 'http://fr.wikipedia.org/wiki/';
    GlobalManager_URLBisFrom = 'http://fr.wikipedia.org/w/index.php?title=';
 
// Page du GlobalManager
    GlobalManager_HomePage = 'User:Dr_Brains/GlobalManager.js';
 
// Résumé de modification
    GlobalManager_Resume = 'Mise à jour avec [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
 
// Commentaires d'édition
    GlobalManager_CommStart = '//DebutSectionAuto'
    GlobalManager_CommPlus = ' : Cette section est produite par le script [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
    GlobalManager_CommConfig = '//ConfigSectionAuto';
    GlobalManager_CommEnd = '//FinSectionAuto';
</source></div>

Ces paramètres peuvent être modifié via une fonction nommée '''<tt>GlobalManager_UserCustom()</tt>'''. 

==== Exemple ====
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
function GlobalManager_UserCustom(){ // Début de la fonction

/* Langue du wiki d'origine */
    GlobalManager_LangFrom = 'en';
 
/* Adresses du wiki d'origine */
    GlobalManager_URLFrom = 'http://en.wikipedia.org/wiki/';
    GlobalManager_URLBisFrom = 'http://en.wikipedia.org/w/index.php?title=';
 
/* Page du GlobalManager */
    GlobalManager_HomePage = 'User:VOTRE_NOM_ICI/GlobalManager.js';
 
/* Résumé de modification */
    GlobalManager_Resume = 'Mise à jour avec [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
 
/* Commentaires d'édition */
    GlobalManager_CommStart = '//DebutSectionAuto'
    GlobalManager_CommPlus = ' : Cette section est produite automatiquement par un script';
    GlobalManager_CommConfig = '//ConfigSectionAuto';
    GlobalManager_CommEnd = '//FinSectionAuto';

} // Fin de la fonction
</source></div>

=== Exemple d'installation configurée ===

Installation configurée pour l'utilisateur "JohnDoe", sur en.wikipedia, dans la page [[:en:User:JohnDoe/GlobalManager.js]] et ayant tous ses scripts sur en.wikipedia.

<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>

function GlobalManager_LangCustom(){ // Début de la fonction textes
    GlobalManager_Text_SelectScripts = "Select scripts to be added on page : ";
    GlobalManager_Text_Help = "Help";
    GlobalManager_Text_InputOK = "Create script";
    GlobalManager_Text_Hide = "[Hide]";
    GlobalManager_Text_Show = "[Show]";
    GlobalManager_Text_Import = "Importing scripts : ";
    GlobalManager_Text_Edit = "Editing page : ";
    GlobalManager_Text_Save = "Saving page : ";
    GlobalManager_Text_OK = "OK";

} // Fin de la fonction textes

function GlobalManager_UserCustom(){ // Début de la fonction paramètres personnels

/* Langue du wiki d'origine */
    GlobalManager_LangFrom = 'en';
 
/* Adresses du wiki d'origine */
    GlobalManager_URLFrom = 'http://en.wikipedia.org/wiki/';
    GlobalManager_URLBisFrom = 'http://en.wikipedia.org/w/index.php?title=';
 
/* Page du GlobalManager */
    GlobalManager_HomePage = 'User:JohnDoe/GlobalManager.js';
 
/* Résumé de modification */
    GlobalManager_Resume = 'Updated with [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
 
/* Commentaires d'édition */
    GlobalManager_CommStart = '//StartAuto'
    GlobalManager_CommPlus = ' : This section is updated automatically with [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
    GlobalManager_CommConfig = '//ConfigAuto';
    GlobalManager_CommEnd = '//EndAuto';

} // Fin de la fonction paramètres personnels

function GlobalManager_GetUserScripts(){ // Début de la fonction scripts personnels

    GlobalManager_ScriptType.push(4);
    GlobalManager_ScriptText.push('Working Scripts');
    GlobalManager_ScriptId.push('');
    GlobalManager_ScriptPage.push('');

    GlobalManager_ScriptType.push(1);
    GlobalManager_ScriptText.push('Real-time recent changes.');
    GlobalManager_ScriptId.push('LiveRC');
    GlobalManager_ScriptPage.push('User:EDUCA33E/LiveRC.js');

    GlobalManager_ScriptType.push(4);
    GlobalManager_ScriptText.push('Test scripts');
    GlobalManager_ScriptId.push('');
    GlobalManager_ScriptPage.push('');

    GlobalManager_ScriptType.push(1);
    GlobalManager_ScriptText.push('Scripts on test');
    GlobalManager_ScriptId.push('MySandbox');
    GlobalManager_ScriptPage.push('User:JohnDoe/MySandbox.js');

} // Fin de la fonction scripts personnels


document.write('<script type="text/javascript" src="http://fr.wikipedia.org/w' + 
               '/index.php?title=User:Dr_Brains/GlobalManager.js&action=raw&ctype=text/javascript"></script>');

</source></div>

Le monobook.js ou le vector.js de l'utilisateur JohnDoe (sur tous les wiki qu'il souhaite) étant complété avec le code suivant (les scripts ou codes ajoutés avant ou après les commentaires ne seront pas modifiés lors de la mise à jour) :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
//StartAuto : This section is updated automatically with [[en:User:JohnDoe/GlobalManager.js]]
//ConfigAuto

document.write('<script type="text/javascript" src="http://en.wikipedia.org/w' + 
               '/index.php?title=User:JohnDoe/GlobalManager.js&action=raw&ctype=text/javascript"></script>');

//EndAuto
</source></div>

Remarque : l'environnement javascript des différents wiki, la présence ou non de fonctions nécessaires à leur fonctionnement peut affecter leur bon fonctionnement, voir par exemple [[en:User:Dr Brains/Utilities.js]], destinées à solutionner ce problème.