{{:Utilisateur:Dr Brains/onglets}}

<poem><big>'''[[Utilisateur:Dr Brains/MenuClicDroit.js|MenuClicDroit]]'''</big> est un script procurant un menu contextuel (clic droit n'importe où dans la page) rassemblant tous les liens utiles à la navigation. <br />Il est également possible de rajouter de nombreux liens dans des menus déroulants. L'aspect du menu est largement configurable.
La navigation pouvant s'effectuer sans avoir besoin d'autre menu, un mode plein écran (désactivable) est également disponible.</poem>

* Depuis la version 0.5, un nouveau menu s'affiche lors de l'édition reprenant tous les éléments indispensables. Là encore, il est possible d'ajouter facilement des items.
* Depuis la version 0.6, le menu est déplaçable à volonté sur la page.
* Depuis la version 0.7, un nouveau menu permet de modifier les paramètres sans avoir à éditer le code. Les options choisies sont enregistrées sur cookie.
* Depuis la version 0.8, le script fonctionne sur tous les habillages disponibles sur Wikipédia.

==Fonctionnement==
{{Boîte déroulante début|largeur=90%|alignB=center|couleurFondT=#aaaaaa|titre=Aperçu des menus ([[Discussion utilisateur:Dr Brains/MenuClicDroit.js#CODE SOURCE|Version 0.9bêta]])}}
<table width=100%" align="center" style="margin:1em;background-color:transparent;padding:1em;">
<tr >
<td width="50%" style="padding-right:5em;text-align:center;">
'''Menus standards'''<br/>
[[Image:Demo script MenuClicDroit.png|right|upright=2|thumb|Aperçu du menu contextuel normal sur Firefox.]]
</td>
<td width="50%" style="padding-left:2em;text-align:center;">
'''Menus en cours d'édition'''<br/>
[[Image:Demo script MenuClicDroit Edition.png|left|upright=3|thumb|Aperçu des menus crées en cours d'édition sur Firefox.]]
</td>
</tr>
</table>
{{Boîte déroulante fin}}
=== Fonctions ===                                                                                                           
Un clic droit sur une page fait apparaître un petit menu contextuel ouvrant d'autres menus entièrement mobiles et facilitant la navigation.<ref>A noter que, hormis les menus déroulants personnalisables, le script ne crée pas les liens mais duplique ceux présents dans les différents menus de l'interface. <br />Il est donc totalement compatible avec les gadgets ajoutant des liens, panneaux ou onglets, à la condition d'être appelé après dans la page .js.</ref><br/>
* Le menu Navigation comprend : 
** Les liens de la barre de gauche
** Les liens d'action (onglets)
** Les liens personnels                                                                                     
** trois listes déroulantes où des liens supplémentaires peuvent êtres ajoutés à volonté
** une liste déroulante de liens favoris : trois liens permettent d'ajouter la page courante, de retirer un ou plusieurs favoris ou de vider complètement la liste (enregistrée sur un cookie)
* Un menu "Options" permet de modifier à volonté l'affichage sans avoir à éditer le code :
** Mode plein écran
** Taille des menus
** Couleurs des menus et du texte
** Bordures des menus
** Taille et style de la police
* Durant l'édition, d'autres menus sont disponibles comprenant :
** une copie de la barre d'outil<ref>D'autres boutons peuvent êtres ajoutés</ref>
** Un lien permettant de modifier la taille de la zone de modification  
** Un lien permettant d'ajouter des balises  
** Des caractères spéciaux à insérer (même principe que [[MediaWiki:Edittools]])
** Des liens permettant de remplir le résumé de modification (dérivé du gadget [[MediaWiki:Gadget-ResumeDeluxe.js|ResumeDeluxe]])
** Les boutons permettant de prévisualiser et publier la modification.<ref>Le fait d'avoir deux zones de résumé posant problème, celle-ci a été supprimée de sa position originale pour n'être présente que dans le menu contextuel.</ref>

Les menus sont déplaçables à volonté dans la page par simple cliquer-glisser <u>, ils sont fixes lors d'un scroll et leur position et leur état sont conservés d'une page à l'autre<u><ref>Version 0.9 bêta seulement, ne fonctionne pas encore avec Internet Explorer.</ref>

Hormis ceux qui proviennent des liens originaux de l'interface, la totalité des textes sont modifiables en éditant  la partie personnalisable du [[Discussion utilisateur:Dr Brains/MenuClicDroit.js#CODE SOURCE|code source]].<br/>
<br />

<references />

=== Tests ===

====Navigateurs====
                                                                                                         
* Mozilla Firefox 3.5 : OK                                                                               
* Internet Explorer 8  : OK
* Google Chrome 3.0 : OK
* Opera 10.0 : Ne marche pas

====Habillages====
                                                                            
* Monobook : OK                                                                               
* Vector : OK                                                                            
* Modern : OK                                                                          
* Myskin : OK
* Simple : OK
* Chick : OK

* Nostalgia, Standard et Cologneblue : 
Le script marche mais la récupération des liens existants s'avère compliquée du fait qu'ils ne sont pas groupés et qu'ils sont mélangés.<br/>
La plupart des liens utiles sont quand même intégrés au menu.

==Installation==

Copier/coller simplement le [[Discussion utilisateur:Dr Brains/MenuClicDroit.js#CODE SOURCE|code source]] ci-dessous dans votre [[Special:MyPage/monobook.js|monobook.js]], [[Special:MyPage/vector.js|vector.js]] ou [[Special:MyPage/modern.js|modern.js]] suivant l'habillage choisi

==Personnalisation==
La personnalisation du script s'effectue dans le script, dans la zone définie comme {{Citation|PARTIE PERSONNALISABLE}}. Elle est divisée en plusieurs parties.
=== Paramètres ===

Depuis la version 0.7, la plupart des paramètres d'affichage sont modifiables sans éditer le code via un menu "Options".
<source lang=javascript>
var UrlSite = "http://fr.wikipedia.org/wiki/"
var UrlSiteBis = "http://fr.wikipedia.org/w/index.php?title="
var UrlSiteTer = "http://fr.wikipedia.org"
 
var DoubleClicEdit = true;            // Édition par double-clic (monobook uniquement, ne marche pas avec Internet Explorer, utiliser la fonction présente dans les préférences)
var PopUp = true;                     // Activation des pop-up de confirmation
 
var Alignt = "center";                // alignement du texte (avec IE, les menus déroulants sont toujours alignés à gauche) 
 
// Décalages en X (largeur) et Y (hauteur) entre le coin haut gauche du menu principal 
// et la position de la souris lors du clic droit (désactivé sur IE)
var OffsetX = 0;                      
var OffsetY = -150; 
</source>

=== Textes ===

Tous les textes présents sur les divers menus sont modifiables en éditant une série de variables.

<source lang=javascript>
////////////////////////////////////////////////////////////////////////////////////////////////// Textes
 
////////////////////////////////////////////////////////////////////////// Menu Principal et expressions standards
 
var MenuTextCloseAll = "TOUT FERMER";
var MenuTextOpenAll = "TOUT OUVRIR";
var MenuTextClose = "FERMER";
var MenuTextClosePop = "Cliquer pour fermer le menu";
var MenuTextMove = "DÉPLACER";
var MenuTextMovePop = "Cliquer pour déplacer le menu";
var MenuTextNavig = "NAVIGATION";
var MenuTextNavigOpen = "Cliquer pour ouvrir le menu Navigation";
var MenuEditTextEdit = "ÉDITION";
var MenuTextModifOpen = "Cliquer pour ouvrir le menu Édition";
var MenuEditTextSubmit = "PUBLICATION";
var MenuTextPublierOpen = "Cliquer pour ouvrir le menu Publication";
var MenuTextOption = "OPTIONS";
var MenuTextOptionOpen = "Cliquer pour ouvrir le menu Options";
var MenuTextCloseAllPop = "Cliquer pour fermer tous les menus";
var MenuTextOpenAllPop = "Cliquer pour ouvrir tous les menus";

////////////////////////////////////////////////////////////////////////// Menu Navigation
var MenuTextLast = "Page précédente";
var MenuTextLastPop = "Revenir à la page précédente de l'historique du navigateur";
var MenuTextNextPop = "Revenir à la page suivante de l'historique du navigateur";
var MenuTextNext = "Page suivante";
var MenuTextSearchPop = "Rechercher dans Wikipédia";
var MenuTextButton1 = "Lire";
var MenuTextButton1Pop  = "Aller vers une page portant exactement ce nom si elle existe";
var MenuTextButton2 = "Consulter";
var MenuTextButton2Pop = "Rechercher les pages comportant ce texte";
var MenuTextspecial = "pages spéciales";
var MenuTextActions = "ACTIONS";
var MenuTextActionBis = "autres actions";
var MenuTextPerso = "LIENS PERSONNELS";
var MenuTextAdd = "Ajouter";
var MenuTextAddPop = "Cliquer pour ajouter la page courante aux favoris";
var MenuTextSupprAll = "RAZ";
var MenuTextSupprAllPop = "Cliquer pour vider les favoris";
var MenuTextSuppr1 = "Supprimer";        
var MenuTextSuppr1Pop = "Cliquer pour supprimer une page précise des favoris";
var MenuTextFav = "favoris";
var MenuTextLang = "autres langues";
var MenuTextProjects = "autres projets";
var MenuTextNavigBis = "autres liens utiles";

////////////////////////////////////////////////////////////////////////// Menu Favoris
 
var Suppr1Fav1 = "La liste de favoris contient les pages suivantes :";
var Suppr1Fav2 = "Quelle page souhaitez-vous supprimer de la liste ?";
var Suppr1Fav3 = "(indiquer seulement le numéro)";
var Suppr1FavNone = "Vous n\'avez aucun favoris.";
var Suppr1FavThis = "Voulez-vous vraiment supprimer des favoris la page : ";
var SupprAllFav = "Voulez-vous vraiment effacer la liste de favoris ?";
 
////////////////////////////////////////////////////////////////////////// Menu Édition
 

var MenuEditTextTaille = "Taille de la zone d\'édition";
var MenuEditTextTailleTer = "Cliquer pour modifier la taille de la zone d\'édition";
var MenuEditTextTailleBis = "Nombre de lignes pour la zone d\édition ?";
var MenuEditTextBalise = "Insérer Balises"
var MenuEditTextBaliseTer = "Cliquer pour insérer une balise quelconque";
var MenuEditTextBaliseBis = "Nom de la balise ? \nExemple : ";                 
 
////////////////////////////////////////////////////////////////////////// Menu Publication
 
var MenuEditTextSubmitBis = "Ajouter dans la boîte de résumé";
 
////////////////////////////////////////////////////////////////////////// Menu Options
 
var MenuTextOptionReload = "Attention, cette action va entraîner le rechargement de la page.\nLes modifications apportées ne seront pas enregistrées.\nContinuer ?";

var MenuTextOptionAffichage = "Affichage : ";
var MenuTextOptionPleinEcran = "Plein Écran";
var MenuTextOptionPleinEcranPop = "Cliquer pour afficher la page en plein écran";
var MenuTextOptionNoPleinEcran = "Normal";
var MenuTextOptionNoPleinEcranPop = "Cliquer pour revenir à l\'affichage normal";
var MenuTextOptionbgColor = "Fond cadres : ";
var MenuTextOptionbgColorPop = "Cliquer pour définir la couleur de fond des cadres";
var bgColorDefine = "Définir la couleur de fond des cadres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionbdColor = "Bordures : ";
var MenuTextOptionbdColorPop = "Cliquer pour définir la couleur des bordures";
var bdColorDefine = "Définir la couleur des bordures (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionTColor = "Fond titres : ";
var MenuTextOptionTColorPop = "Cliquer pour définir la couleur de fond des titres";
var TColorDefine = "Définir la couleur de fond des titres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionTtColor = "Texte titres : ";
var MenuTextOptionTtColorPop = "Cliquer pour définir la couleur du texte des titres";
var TtColorDefine = "Définir la couleur du texte des titres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionlienColor = "Texte : ";
var MenuTextOptionlienColorPop = "Cliquer pour définir la couleur du texte";
var lienColorDefine = "Définir la couleur du texte (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionselColor = "Survol : ";
var MenuTextOptionselColorPop = "Cliquer pour définir la couleur des éléments survolés";
var selColorDefine = "Définir la couleur des éléments survolés (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionMDColor = "Menus déroulants : ";
var MenuTextOptionMDColorPop = "Cliquer pour définir la couleur des menus déroulants";
var MDColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionLineColor = "Lignes : ";
var MenuTextOptionLineColorPop = "Cliquer pour définir la couleur des lignes horizontales";
var LineColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionBaseTaille = "Largeur du menu principal : ";
var MenuTextOptionBaseTaillePop = "Cliquer pour définir la largeur du menu principal";
var BaseTailleDefine = "Définir la taille du menu principal (en pixels).\nTaille actuelle : "; 
var MenuTextOptionbgTaille = "Largeur du menu Navigation : ";
var MenuTextOptionbgTaillePop = "Cliquer pour définir la largeur du menu Navigation";
var bgTailleDefine = "Définir la taille du menu Navigation (en pixels).\nTaille actuelle : ";
var MenuTextOptionListeTaille = "Largeur du menu Favoris : ";
var MenuTextOptionListeTaillePop = "Cliquer pour définir la largeur du menu Favoris";
var ListeTailleDefine = "Définir la taille du menu Favoris (en pixels).\nTaille actuelle : ";
var MenuTextOptionModifTaille = "Largeur du menu d\'Édition : ";
var MenuTextOptionModifTaillePop = "Cliquer pour définir la largeur du menu d\'édition";
var ModifTailleDefine = "Définir la taille du menu d\'Édition (en pixels).\nTaille actuelle : ";
var MenuTextOptionOptionsTaille = "Largeur du menu Options : ";
var MenuTextOptionOptionsTaillePop = "Cliquer pour définir la largeur du menu d\'options";
var OptionsTailleDefine = "Définir la taille du menu d\'Options (en pixels).\nTaille actuelle : ";
var MenuTextOptionTitreTaille = "Taille des titres : ";
var MenuTextOptionTitreTaillePop = "Cliquer pour définir la taille des titres";
var TitreTailleDefine = "Définir la taille du texte des titres (en pixels).\nTaille actuelle : ";
var MenuTextOptionfontTaille = "Taille du texte : ";
var MenuTextOptionfontTaillePop = "Cliquer pour définir la taille du texte";
var fontTailleDefine = "Définir la taille du texte (en pixels).\nTaille actuelle : ";
var MenuTextOptionbdTaille = "Taille des bordures : ";
var MenuTextOptionbdTaillePop = "Cliquer pour définir la taille des bordures";
var bdTailleDefine = "Définir la taille des bordures (en pixels).\nTaille actuelle : ";
var MenuTextOptionStylebd = "Style des bordures : ";
var MenuTextOptionStylebdPop = "Cliquer pour définir le style des bordures";
var StylebdDefine = "Définir le style des bordures.\nStyle actuel : ";
var MenuTextOptionStylepolice = "Police : ";
var MenuTextOptionStylepolicePop = "Cliquer pour définir la police";
var StylepoliceDefine = "Définir la police.\nPolice actuelle : ";
var MenuTextOptionOpacity = "Opacité : ";
var MenuTextOptionOpacityPop = "Cliquer pour définir l\'opacité";
var OpacityDefine = "Définir l\'opacité des menus.\nOpacité actuelle : ";

var MenuTextOptionFix = "Fixer les menus";
var MenuTextOptionFixPop = "Cliquer pour enregistrer la position actuelle des menus";
var MenuTextPositionFix = "Réordonner les menus";
var MenuTextPositionFixPop = "Cliquer pour revenir à la position initiale des menus";
var MenuTextOptionRaz = "Rétablir les valeurs par défaut";
var MenuTextOptionRazPop = "Cliquer pour rétablir les valeurs par défaut";
</source>

=== Ajouter des liens dans les menus === 
==== Variables utiles pour les liens ====
Ces variables sont utilisables comme n'importe quel mot magique wiki afin de créer tous les liens possibles et imaginables. Elles peuvent être réutilisées n'importe où dans le script.

* BASEPAGENAME    : Page courante sans l'espace de noms
* FULLPAGENAME    : Page courante
* TALKPAGENAME    : Page de discussion associée
* SUBJECTPAGENAME : Page principale associée
* NAMESPACENAME   : Espace de noms (en anglais)
* NAMESPACENUMBER : N° Espace de noms
* CURRENTUSER     : Utilisateur courant (votre pseudo. Ne pas confondre avec UTILISATEUR ci-dessous)
* SYSOP           : Teste si l'utilisateur est sysop ( présence de l'onglet "supprimer" ou "restaurer" ). Si c'est le cas, SYSOP est vrai
* DISCUSSION      : Teste si la page est une page de discussion ( présence de l'onglet "nouvelle section" ). Si c'est le cas, DISCUSSION est vrai
* UTILISATEUR     : Teste si la page courante est une page utilisateur et renvoie son pseudonyme. Si ce n'est pas le cas, UTILISATEUR est faux

==== Syntaxe ====

Trois menus (éléments HTML <nowiki><select></nowiki>) sont totalement configurables.

Pour ajouter une ligne, créer trois instances supplémentaires : menuMACHINtexte[x],  menuMACHINlien[x] et menuMACHINtarget[x] 
Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                  

Exemple de menu :     
<source lang=javascript>
menuTRUCtexte[X] = "Mon lien"                       // Texte  
menuTRUClien[X] = UrlSite + "Spécial:MyPage"        // Page cible (on peut utiliser UrlSite, UrlSiteBis une des variables ci-dessus ou bien taper l'adresse complète)
menuTRUCtarget[X] = "_self"                         // Ouverture : _self = même fenêtre (défaut), _blank = nouvelle fenêtre  

menuTRUCtexte[X]= "Sous-titre"                                                                                            
menuTRUClien[X]= ""                                 // Si pas de lien, insertion d'un sous-titre                                           
menuTRUCtarget[X]= ""                                                                                             

menuTRUCtexte[X]= "";
menuTRUClien[X]= "Vide";                            // Si lien mais pas de texte, l'instance n'est pas prise en compte
menuTRUCtarget[X]="";

</source>

Voir aussi dans le code de la page le menu Pages Spéciales qui est déjà bien fourni et peut servir d'exemple.

=== Ajouter des boutons ===
Il est possible d'ajouter des boutons à la manière des gadgets [[MediaWiki:Gadget-DeluxeBar.js|DeluxeBar]] ou [[MediaWiki:Gadget-AjoutBoutonSource.js|AjoutBoutonSource]]. Il est à noter que ceux-ci sont compatibles avec ce script.

Pour ajouter une icône à la barre d'outils, créer cinq instances supplémentaires<br/>
Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).

Exemple :
<source lang=javascript>
menutoolbardébut[X] = "";            // Code inséré avant la sélection.
menutoolbarfin[X] = "";              // Code inséré après la sélection
menutoolbarcomm[X] = "";             // Information au survol de la souris
menutoolbarimage[X] = "";            // URL de l'image
menutoolbarimageId[X] = "";          // Id du bouton (attention, pas d'espace, de tiret ou autres caractères spéciaux)
menutoolbarimagePosition[X] = "";    // Début ou Fin : Position de l'image par rapport à celles qui y sont déjà ( Début par défaut)
</source>


{{Boîte déroulante début|titre=Galerie d'icônes}}

Liste issue de [[Commons:MediaWiki edit toolbar]]<br/>

'''Boutons standards''' <br/>
<gallery perrow="20" widths="25" heights="25">
File:Button bold.png
File:Button italic.png
File:Button link.png
File:Button extlink.png
File:Button headline.png
File:Button image.png
File:Button media.png
File:Button math.png
File:Nowiki_icon.png
File:Button sig.png
File:Button hr.png
File:Button insert table.png
</gallery>
<br/>
'''Émoticônes'''
<gallery perrow="20" widths="25" heights="25">
File:Smilies Alien wow.png
File:Smilies Alien wink.png
File:Smilies Alien whatface.png
File:Smilies Alien whaaa.png
File:Smilies Alien weap.png
File:Smilies Alien unhappy.png
File:Smilies Alien sorry.png
File:Smilies Alien sleepy.png
File:Smilies Alien sick.png
File:Smilies Alien sad.png
File:Smilies Alien red.png
File:Smilies Alien KO.png
File:Smilies Alien huh.png
File:Smilies Alien huf.png
File:Smilies Alien GRRR.png
File:Smilies Alien green.png
File:Smilies Alien droling.png
File:Smilies Alien doof.png
File:Smilies Alien disapointed.png
File:Smilies Alien depressive.png
File:Smilies Alien cry.png
File:Smilies Alien cool.png
File:Smilies Alien big eyes.png
File:Smilies Alien aaah.png
</gallery>
<br/>
'''Autres boutons''' <br>
<gallery perrow="20" widths="25" heights="25">
File:Blending blue button background.png
File:Search button bckg.png
File:Button ref adv.png
File:Button reflink advanced 2.png
File:Button more.png
File:Button reflink advanced 3.png
File:Button sig zh.png
File:Wiki-button-bold-be.png
File:Wiki-button-italic-be.png
File:Wiki-button-link-be.png
File:Button bold ukr.png
File:Button italic ukr.png
File:Button internal link ukr.png
File:Button base.png
File:Button support.png
File:Button partial support.png
File:Button oppose.png
File:Button neutral.png
File:Button delete.png
File:Button keep.png
File:Button comment vote.png
File:Button opinion.png
File:Button question2.png
File:Button wait.png
File:Button comment.png
File:Button check.png
File:Button fait.png
File:Button question.png
File:Button aviso.png
File:Button aviso borrado.png
File:Button done.png
File:Button not done.png]]
File:Button note.png
File:Button exclamation.png
File:Button exclamation 1.png
File:Button exclamation 2.png
File:Button info.png
File:Bouton Vandale0.png
File:Bouton Vandale1.png
File:Bouton Vandale2.png
File:Bouton Vandale3.png
File:Bouton Vandale4.png
File:Btn infotexto.png
File:Btn plus.png
File:Btn toolbar commentaire.png
File:Puls da aiutare.png
File:Btn toolbar liste.png
File:Btn toolbar enum.png
File:Btn toolbar gallery.png
File:Btn toolbar rayer.png
File:Button (B).png
File:Button (S).png
File:Button acute accent.png
File:Button advanced image.png
File:Button align left.png
File:Button align right.png
File:Button multicol.png
File:Button quotes.png
File:Button quotes 2.png
File:Button Anführung.png
File:Button big.png
File:Button big 2.png
File:Button bigger.png
File:Button smaller.png
File:Button blockquote.png
File:Button boldru.png
File:Button box center low list.png
File:Button 00%.png
File:Button 100%.PNG
File:Button 100%.png
File:Button 25%.png
File:Button 50%.png
File:Button 75%.png
File:Button Answer to Life.png
File:Button anular voto.png
File:Button Aop.png
File:Button archivar biblio.png
File:Button archivo borrar.png
File:Button array.png
File:Button arrow right.png
File:Button av-img.png
File:Button barrer.png
File:Button bienvenido.png
File:Button biocitas.png
File:Button blocage.png
File:Button breve.png
File:Button broom.png
File:Button BY.png
File:Button case.png
File:Button category.png
File:Button category02.png
File:Button category03.png
File:Button category04.png
File:Button category alt.png
File:Button category link.png
File:Button center.png
File:Button chapitre.png
File:Button cite book.png
File:Button cite news.png
File:Button cite web.png
File:Button city silhouette.png
File:Button class text.png
File:Button code.png
File:Button code1.png
File:Button comillas latinas.png
File:Button context.png
File:Button contexto.png
File:Button copy edit.png
File:Button copy vio.png
File:Button copy vio plagio.png
File:Button copyvio.png
File:Button crocs.png
File:Button croix bleue.png
File:Button Crystal mai.png
File:Button dagger.png
File:Button definition list.png
File:Button desambig.png
File:Button dicc.png
File:Button disambig small.png
File:Button dot1.PNG
File:Button easy cite.png
File:Button easy cite  pl.png
File:Button encrypted.png
File:Button enter.png
File:Button ER.png
File:Button examine.png
File:Button fairuse.png
File:Button find.png
File:Button flamme.png
File:Button fuente primaria.png
File:Button fuente.png
File:Button fusion.png
File:Button gallery.png
File:Button gfdl.png
File:Button gif.png
File:Button Globe.png
File:Button gnu.png
File:Button grec.png
File:Button guillemet.png
File:Button halt.png
File:Button head A1.png
File:Button head A2.png
File:Button head A3.png
File:Button head A4.png
File:Button head A5.png
File:Button headline2.png
File:Button headline3.png
File:Button hide comment.png
File:Button hr halfwidth.png
File:Button image left.png
File:Button image right.png
File:Button include.png
File:Button includeonly.png
File:Button includeonly green.png
File:Button indevelopment.png
File:Button interprojet.png
File:Button invalid template.png
File:Button IP.png
File:Button ip partagée.png
File:Button IPA.png
File:Button italicru.png
File:Button justice.png
File:Button justify.png
File:Button Kat.png
File:Button de.png
File:Button en.png
File:Button l en.png
File:Button l fr.png
File:Button fr.png
File:Button l la.png
File:Button l ln.png
File:Button l nl.png
File:Button latinas.png
File:Button Lettrine S.png
File:Button link to Wikipedia.png
File:Button linkautor.png
File:Button Link DifferentName.png
File:Button merge articles.png
File:Button mini stub.png
File:Button miss signature.png
File:Button mort.png
File:Button mysignature.png
File:Button nav.png
File:Button nbsp.png
File:Button nbsp 1.png
File:Button nbsp bold.png
File:Button no include.png
File:Button no license.png
File:Button no neutral.png
File:Button no source.png
File:Button no source no license.png
File:Button nogifs.png
File:Button noinclude.png
File:Button noinclude1.png
File:Button noinclude green.png
File:Button Nuvola apps edu lang.png
File:Button Nuvola apps edu phi.png
File:Button Nuvola apps ksirc.png
File:Button oeil.png
File:Button out relevancy.png
File:Button P template.png
File:Button paragraphe 1.png
File:Button paragraphe 2.png
File:Button paragraphe 3.png
File:Button paragraphe 4.png
File:Button paragraphe 5.png
File:Button paragraphe 6.png
File:Button pd.png
File:Button petit.png
File:Button plantilla.png
File:Button plume.png
File:Button poeme.png
File:Button polytonique.png
File:Button pre.png]
File:Button preview.png
File:Button problematic.png
File:Button publication.png
File:Button S yellow.png
File:Button Telephone receiver.png
File:Jadernyhrib-button.png
File:Pulsdx.png
File:Button1.PNG
File:Button radio activite.png
File:Button recherche ip.png
File:Button redir.png
File:Button redirect.png
File:Button ref.png
File:Button ref a.png
File:Button ref b.png
File:Button references.png
File:Button references2.png
File:Button references alt.png
File:Button reflink.png
File:Button refs.png
File:Button removed.png
File:Button replace.png
File:Button request deletion.png
File:Button rfacomment.png
File:Button romain.png
File:Button save changes.png
File:Button shifting.png
File:Button sig (zh).png
File:Button small.png
File:Button small 2.png
File:Button small text.png
File:Button smiley.png
File:Button smiley2.png
File:Button smiley face grin.png
File:Button smiley face smile.png
File:Button source.png
File:Button source jv.png
File:Button span 2.png
File:Button stop.png
File:Button strike.png
File:Button stub.png
File:Button Sub.png
File:Button sub 2.png
File:Button sub letter.png
File:Button sub link.png
File:Button substitute.png
File:Button sup 2.png
File:Button sup letter.png
File:Button tab.png
File:Button tachar.png
File:Button talk.png
File:Button template alt.png
File:Button template tl.png
File:Button templatelink.png
File:Button thinsp.png
File:Button titre.png
File:Button transwiki.png
File:Button travaux.png
File:Button uncorrect.png
File:Button underline.png
File:Button user.png
File:Button user talk.png
File:Button uses.png
File:Button verse.png
File:Button vote biblio.png
File:Button vote deletion.png
File:Button welcome.png
File:Button welcome ip.png
File:Buttonrefvs8.png
File:ButtonSpam.png
File:Bv icon.png
File:Bvip icon.png
File:Category icon.png
File:Cs icon.png
File:Deletereason.png
File:Deletewarn1.png
File:Deletewarn2.png
File:Deletewarn3.png
File:Deletewarn4.png
File:Nonnotable.png
File:NonsenseDelete.png
File:Notes&Ref icone.png
File:Pulsante-cancut.png
File:Pulsante editwar.png
File:Pulsante grazie.png
File:Pulsante nPOV.png
File:Pulsante spam.png
File:Pulsante tl.png
File:Quotes-Lithuanian.png
File:Seealso.png
File:Sharp button.png
File:Sister icon.png
File:TableCell.png
File:TableEnd.png
File:TableRow.png
File:TableStart.png
File:Template button.png
File:Testwarn1.png
File:Testwarn2.png
File:Testwarn3.png
File:Testwarn4.png
File:Tt icon.png
File:Userwarntest.png
File:Uw1.png
File:Uw2.png
File:Uw3.png
File:Vjazyce-button.png
File:Warn1.png
File:Warn2.png
File:Warn3.png
File:Warn4.png
File:Warncreate1.png
File:Warncreate2.png
File:Warncreate3.png
File:Warncreate4.png
File:Wiki c copy.gif
File:Wiki test.GIF
File:Wiki vand.gif
File:WP-icon.png
File:EXPBT0.png
File:EXPBT1.png
File:EXPBT2.png
File:EXPBT2-o.png
File:EXPBT3.png
File:Button unreferenced.png
File:Button hoşgeldin.png
File:A titulus.png
File:O titulus.png
File:E titulus.png
File:U titulus.png
File:I titulus.png
File:Q titulus.png
File:SmallcapsButton.png
File:Button wiktionary.png
File:Button Tool commons.png
File:Button commons.png
File:Button wikibooks.png
File:Button wikificare.png
File:Button wikification.png
File:Button wikimedia.png
File:Button wikipedia.png
File:Button wikiquote.png
File:Button wikisource.png
File:Button wikiversity.png
File:Button wn.png
File:Button wikt new.png
File:Button wiktionnaire.png
File:Button tournesol.png
File:Btn toolbar par.png
File:Btn toolbar tt.png
File:Button add media.png
File:Button mp3.png
File:Button AP.PNG
File:Button centered equation.PNG
File:Button apostrophe.PNG
File:Button plainlinks.png
File:1c9ff4afd5be.jpg
File:Accent-button-bg.png
File:Bold icon.png
File:Bouton bienvenu.png
File:Bouton Faut sourcer.png
File:Bouton sourcer.png
File:Bouton Vandale2-.png
File:Bouton Vandale2+.png
File:Br.png
File:Break-button-bg.png
File:Broken conversation button.png
File:BTA-0.png
File:BTA-1.png
File:BTA-2.png
File:BTA-3.png
File:Button §.png
File:Button accueilA.png
File:Button accueilB.png
File:Button align.gif
File:Button API ‿.png
File:Button API ː.png
File:Button API ɑ.png
File:Button API ɔ.png
File:Button API ɛ.png
File:Button API ʃ.png
File:Button API ə.png
File:Button API ɥ.png
File:Button API ɲ.png
File:Button API ŋ.png
File:Button API ø.png
File:Button API œ.png
File:Button API ʁ.png
File:Button API tilde.png
File:Button API ʒ.png
File:Button API ʔ.png
File:Button arabic.png
File:Button article connexe.png
File:Button article de qualite.png
File:Button article détaillé.png
File:Button atelier graphique.PNG
File:Button attendre.png
File:Button badlang.png
File:Button beer.png
File:Button bienvenue.png
File:Button BienvenueIP-BVIP.png
File:Button black copyright.png
File:Button boldga.PNG
File:Button bombe.png
File:Button bon article.png
File:Button br.png
File:Button breve 1.png
File:Button broom cat.png
File:Button broom R.png
File:Button broom2.png
File:Button broom3.png
File:Button brrm.png
File:Button bvcp.png
File:Button category plus.png
File:Button category venn.png
File:Button cite journal.png
File:Button clipboard bold.gif
File:Button clipboard category.gif
File:Button clipboard definition.gif
File:Button clipboard Dlink.gif
File:Button clipboard enum.gif
File:Button clipboard example.gif
File:Button clipboard fact.gif
File:Button clipboard faktstructure.gif
File:Button clipboard Flink.gif
File:Button clipboard headline.gif
File:Button clipboard image.gif]
File:Button clipboard indent.gif
File:Button clipboard information.gif
File:Button clipboard latex operation.gif
File:Button clipboard math.gif
File:Button clipboard mathdisplay.gif
File:Button clipboard mathematical text.gif
File:Button clipboard parameter.gif
File:Button clipboard subheading.gif
File:Button clipboard task.gif
File:Button clipboard template.gif
File:Button clipboard valign.gif
File:Button comment2.png
File:Button commentlow.png
File:Button commentuser.png
File:Button conserver.png
File:Button conserver2.png
File:Button copyvio author.png
File:Button copyvio discuss.png
File:Button copyvio discuss P.png
File:Button cross.png
File:Button cuisine.png
File:Button décès.png
File:Button defaultsort.png
File:Button div.png
File:Button easy cite pl.png
File:Button ébauche.png
File:Button ébauche2.png
File:Button éclair.png
File:Button éclair author.png
File:Button ellipsis.png
File:Button enum.gif
File:Button Equestrian.png
File:Button ext link.png
File:Button fact.png
File:Button fait2.png
File:Button fett.png
File:Button filter definition.gif
File:Button filter example.gif
File:Button filter fact.gif
File:Button filter task.gif
File:Button flag of France.png
File:Button flagicon.png
File:Button font color.png
File:Button formatnum.png
File:Button Fractur OCR.png
File:Button fusionner.png
File:Button gâteau.png
File:Button h2p.png
File:Button h3p.png
File:Button h4p.png
File:Button haut parleur.png
File:Button headline.gif
File:Button helicopter.png
File:Button hellip.png
File:Button hide wiki tag.png
File:Button IFilm.png
File:Button indention.gif
File:Button int link.png
File:Button interwiki.png
File:Button IPers.png
File:Button iran.png
File:Button isbn.PNG
File:Button Korean Ro.png
File:Button kursiv.png
File:Button lauriers.png
File:Button lazy.gif
File:Button lienjournal.png
File:Button lienweb.png
File:Button ligne tableau.png
File:Button marker.png
File:Button mdash.png
File:Button meteo.png
File:Button micro stub.png
File:Button Na.png
File:Button naissance.png
File:Button ndash.png
File:Button neutre.png
File:Button neutre2.png
File:Button nnbsp.png
File:Button no death.png
File:Button non.png
File:Button no-red.png
File:Button nowcommons.png
File:Button npov.png
File:Button ns-basics.png
File:Button number 0.png
File:Button number 1.png
File:Button number 2.png
File:Button number 3.png
File:Button Nuvola apps gaim.png
File:Button NW.png
File:Button ocr.png
File:Button onlyinclude green.png
File:Button oppose vote.png
File:Button Overline.png
File:Button page locked.png
File:Button pagename.png]
File:Button parameter.png
File:Button pict comment.png
File:Button pict info.png
File:Button pict neutral.png
File:Button portail.png
File:Button principal large.png
File:Button prononciation.png
File:Button question author.png
File:Button question2-autor.png
File:Button recycler.png
File:Button recycling.png
File:Button redir rtl.png
File:Button redirect-hr.png
File:Button rediriger.png
File:Button ref inscription.png
File:Button referencesR.png
File:Button reg trademark.png
File:Button renommer.png
File:Button reticence.png
File:Button rouge.png
File:Button rugby.png
File:Button rugby 1.png
File:Button russie.png
File:Button S italic.png
File:Button S yellow author.png
File:Button see also.png
File:Button sekcje.png
File:Button shouldbesvg.png
File:Button sig2.png
File:Button smiley3.png
File:Button snooker.png
File:Button soccer.png
File:Button sorterbar.png
File:Button source-srce.png]
File:Button spam2.png
File:Button star.png
File:Button star better.png
File:Button STFW.png
File:Button Subheadline.gif
File:Button subst template.gif
File:Button supp.png
File:Button support vote.png
File:Button suppr.png]
File:Button supprimer.png
File:Button syntaxe-stax.png
File:Button tableau.png
File:Button template.gif
File:Button template alt2.png
File:Button tgk-gh maj.png
File:Button tgk-gh min.png
File:Button tgk-h maj.png
File:Button tgk-h min.png
File:Button tgk-ii maj.png
File:Button tgk-ii min.png
File:Button tgk-j maj.png
File:Button tgk-j min.png
File:Button tgk-q maj.png
File:Button tgk-q min.png
File:Button tgk-uu maj.png
File:Button tgk-uu min.png
File:Button thinsp2.png
File:Button tidyman.png
File:Button Tongue.png
File:Button traité.png
File:Button traitéconserver.png
File:Button traitésupprimer.png
File:Button tuti.png
File:Button unsigned.png
File:Button userandarticle.png
File:Button vandale.png
File:Button verrou.png
File:Button videogame.png
File:Button voting waiting.png
File:Button vva.png
File:Button web.png
File:Button with Celsius degree.png
File:Button with wikinumber character.png
File:Button Wr.png
File:Button XD.PNG
File:Button zdroj.png
File:Button zoom in.png
File:Button zoom out.png
File:Button-attachment.gif
File:Buttonbezpodpisu.png
File:Buttoncopyvio.png
File:Buttoncopyvioporuseniprav.png
File:Buttonexperimenty.png
File:Buttonexperimenty2.png
File:Buttonexperimenty2o.PNG
File:Buttonnahled.png
File:Buttonsablona.png
File:C pt.png
File:Cancelled process button.png
File:C-cantilly.png
File:CE icon.png
File:Center.png
File:Code-button-bg.png
File:Comment-button-bg.png
File:CR icon.png
File:Curlybrackets-button-bg.png
File:Del-button-bg.png
File:Dotpng-button-bg.png
File:Emdash-button-bg.png
File:Endash-button-bg.png
File:Enwpsource-button-bg.png
File:Exp0.png
File:Exp3.png
File:EXPBT3-o.png
File:External link icon.png
File:Grin-button-bg.png
File:Headline icon.png
File:H-line icon.png
File:Image icon.png
File:Interwiki-button-bg.png
File:IPA-delta.png
File:IPA-gamma-palatal.png
File:IPA-gamma-velar.png
File:IPA-g-palatal.png
File:IPA-l-palatal.png
File:IPA-m-labiodental.png
File:IPA-stress.png
File:IPA-theta.png
File:Italic icon.png
File:Keep tidy button.png
File:Knop bijvoeglijk naamwoord.png
File:Knop bijwoord.png
File:Knop etymologie.png
File:Knop lettergrepen.png
File:Knop mannelijk.png
File:Knop meervoud.png
File:Knop niet-GB.png
File:Knop onzijdig.png
File:Knop paginanaam.png
File:Knop vrouwelijk.png
File:Knop vrouwelijk-mannelijk.png
File:Knop werkwoord.png
File:Knop zelfstandig naamwoord.png
File:Marco1.png
File:Math icon.png
File:Mbutton.png
File:Media icon.png
File:Memo button.png
File:Mifirma.jpg
File:Nbsp-button-bg.png
File:Negritaycursiva.png
File:Noincluido.png
File:Noincluído.png
File:Nowiki icon.png
File:Nuvola-Multimedia01.png
File:Oppose vote button.png
File:Pipe-button-bg.png
File:Q icon.png
File:Quotationmarks-button-bg.png
File:Redirect-button-bg.png
File:Ref-button-bg.png
File:Smile-button-bg.png
File:Spam1.png
File:Spam2.png
File:Spam3.png
File:Spam4.png
File:Sub-button-bg.png
File:Subst-button-bg.png
File:Sup-button-bg.png
File:Support vote button.png
File:TableHeading.png
File:Topdown.jpg
File:Topdown.png
File:Topdown1.png
File:UP-done.png
File:UP-failed.png
File:UP-moved.png
File:Userbox.jpg
File:Userbox.png
File:Vote choice button.png
File:Wiki promo.GIF
File:Wikiamg.gif
File:Wikifier1-button-bg.png
File:Wikifier2-button-bg.png
File:WikiOP.GIF
File:Wikipedia-button-logo.PNG
File:WikiProject Council toolbar icon.png
File:Wikitor.GIF
File:WNB.jpg
</gallery>
{{Boîte déroulante fin}}

=== Ajouter des caractères à insérer ===
<poem>
Pour ajouter un symbole, créer deux instances supplémentaires
Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).
Attention, les symboles HTML ou assimilés (div, span, nowiki, includeonly, noinclude, etc...) ne sont pas permis.
Il est préférable d'en faire des boutons (voir paragraphe précédent) ou d'utiliser le lien "Insérer une Balise".</poem>

Exemple :
<source lang=javascript>
menutoolbardébut[X] = "{{subst:";  // Code inséré avant la sélection.
menutoolbarfin[X] = "}}";          // Code inséré après la sélection
</source>

Si les deux variables sont vides, une ligne horizontale est insérée.

=== Ajouter des résumés de modification ===
<poem>
Pour ajouter un résumé, créer simplement une instance supplémentaire.
Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).
A priori, tous les symboles sont autorisés.</poem> 

Exemple :
<source lang=javascript>
menuresumetexte[X] = "Suppression vandalisme";
</source>

==CODE SOURCE==
===Version en développement===
*[[Utilisateur:Dr_Brains/MenuClicDroit_Dev.js|MenuClicDroit.js : Version 0.9 bêta]] : Ne fonctionne pas (encore) avec Internet Explorer. Testé sur Monobook uniquement.

===Version stable===
*[http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=46310347  MenuClicDroit.js : Version 0.8]

===Anciennes versions===
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45942812 MenuClicDroit.js : Version 0.7]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45898553 MenuClicDroit.js : Version 0.6]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45888715 MenuClicDroit.js : Version 0.5]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45852507 MenuClicDroit.js : Version 0.4]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45789854 MenuClicDroit.js : Version 0.3]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45786622 MenuClicDroit.js : Version 0.2]
* [http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/MenuClicDroit.js&oldid=45778912 MenuClicDroit.js : Version 0.1]