{{Utilisateur:Dr Brains/onglets}}

'''<big>[[Utilisateur:Dr Brains/WatchUsers.js]]</big>''' est un gadget javascript permettant de suivre les modification d'un ou plusieurs utilisateurs donnés. La liste des utilisateurs suivis est stockée dans un cookie.

== Installation ==

Ajouter à votre page [[Special:Mypage/monobook.js|monobook.js]], [[Special:Mypage/vector.js|vector.js]], ou autre suivant l'habillage sélectionné dans les [[Special:préférences|préférences]] le code suivant :

<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
importScript('Utilisateur:Dr Brains/WatchUsers.js');
</source></div>

== Personnalisation ==

Deux fonctions sont prévues pour permettre de personnaliser les différentes variables (voir le début du code source) :
# '''<tt>WatchUsers_LangCustom()</tt>''' : cette fonction devrait n'être utilisée que globalement, dans le cadre de la traduction des textes. Elle écrase les variables par défaut.
# '''<tt>WatchUsers_UserCustom()</tt>''' : cette fonction peut être utilisée par chaque utilisateur. Elle écrase les variables par défaut ou les personnalisations faites via <tt>WatchUsers_LangCustom()</tt>.

Ces fonctions sont à créer sur la même page que la fonction d'installation, avant ou après celle-ci (ça n'a pas d'importance).

;Exemple de personnalisation :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
importScript('Utilisateur:Dr Brains/WatchUsers.js');

function WatchUsers_UserCustom(){
     WatchUsers_Text_Title = "<b>Suivi des boulets :</b> "
     WatchUsers_Text_WatchUser = "Suivre le boulet « $1 » ";
     WatchUsers_Text_WatchNewUser = "Suivre un boulet";
     WatchUsers_Text_Hide = "(Enroulade)";
     WatchUsers_Text_Show = "(Déroulade)";

     WatchUsers_Delay = 25;
     WatchUsers_EnablePreview = false;
}
</source></div>


Une variable particulière est la variable '''<tt>WatchUsers_Text_Format</tt>''', qui détermine le format des lignes de modifications. Dans cette variable sont contenu des mots-clefs qui représentent les différents éléments de la ligne. Ces mots clefs peuvent être arrangés voire supprimés à volonté.

Valeur par défaut : <source lang=javascript>"$PAGE$ ($DIFF$|$HIST$)&nbsp;|&nbsp;«&nbsp;$COMMENT$&nbsp;»&nbsp;|&nbsp;$TIME$$LAST$"</source>
* '''<tt>$PAGE$</tt>''' représente le lien vers la page modifiée
* '''<tt>$DIFF$</tt>''' représente le lien vers le diff de la modification
* '''<tt>$HIST$</tt>''' représente le lien vers l'historique de la page modifiée
* '''<tt>$COMMENT$</tt>''' représente le commentaire de modification
* '''<tt>$TIME$</tt>''' représente la date et l'heure de modification
* '''<tt>$LAST$</tt>''' explicite si cette modification est la dernière modification de la page


Remarque : via ces fonctions, il est également possible d'importer une feuille de style différente de la [[Utilisateur:Dr Brains/WatchUsers.css|feuille de style par défaut]]

; Exemple :
<div style="border:1px dashed green;margin:0.5em;padding:0.5em;"><source lang=javascript>
importScript('Utilisateur:Dr Brains/WatchUsers.js');

function WatchUsers_UserCustom(){
     importStylesheet('Utilisateur:MACHIN/WatchUsers.css');

     WatchUsers_Text_Title = "<b>Suivi des boulets :</b> "
     WatchUsers_Text_WatchUser = "Suivre le boulet « $1 » ";
     WatchUsers_Text_WatchNewUser = "Suivre un boulet";
     WatchUsers_Text_Hide = "(Enroulade)";
     WatchUsers_Text_Show = "(Déroulade)";

     WatchUsers_Delay = 25;
     WatchUsers_EnablePreview = false;
}
</source></div>