Script en provenance de [[Utilisateur:Seb35/advancedResearch.js]] et documentation venant de [[Utilisateur:Seb35/Scripts]]

== Remplacement de la zone de recherche par une recherche avancée ==
''Fonctionne avec MediaWiki 1.6a - Opera - Firefox - IE'' - Ce script permet de remplacer la zone de recherche (boutons ''Consulter'' et ''Rechercher'') par une zone permettant de rechercher sur tous les wikis Wikimedia (Wikipédias, Wiktionnaires, Commons, etc) dans toutes les langues soit en allant directement à l'article (équivalent du bouton ''Consulter''), soit de rechercher avec le moteur de recherche de MediaWiki (bouton ''Rechercher''), soit de rechercher sur un wiki spécifique avec Google, soit sur toutes les Wikipédias avec Google, soit de rechercher un mot sur Google, soit de rechercher un texte avec Google (pour les copyrights). Il y a plusieurs raccourcis des espaces de nom (ex : ''c:'' ou ''cat:'' pour ''Catégorie:'', ''u:'' pour ''Utilisateur:'', ''article/pàs'' pour aller à la page de PàS correspondant à ''article'', etc). On peut ouvrir la page soit dans un onglet externe (par défaut), soit dans le même onglet.

Si vous utilisez plutôt Firefox ou IE, il faut faire un peu de présentation sous IE, car les boutons sont tout petits, et changer les paramètres d'ouverture d'une fenêtre sous Firefox et IE.

=== (Petit) mémo d'utilisation ===
* Boutons :
** ''l'' (lire) équivaut à ''Consulter''
** ''w'' (wikipédia) équivaut à ''Rechercher''
** ''g'' (google) recherche avec Google restreint au site wiki sélectionné ou inscrit dans la langue
** ''c'' (copyright) recherche intégralement le texte sur tout le Web
** ''r'' (reset) au premier appui : efface la recherche, au deuxième : remet la langue sur français et au troisième : efface la langue de la zone de texte
* Syntaxe des langues :
** La "langue" all (tout en anglais) s'utilise uniquement avec Google pour rechercher sur toutes les Wikipédias
** Accès direct aux Wikipédias française (par défaut), anglaise ou allemande
** Projets de langue unique : ''c'' ou ''commons'', ''f'' ou ''fondation'' ou ''foundation'', ''m'' ou ''meta'', ''mw'' ou ''mediawiki'' pour MediaWiki.org, ''s'' ou ''species''
** Projets multilingues : ''ISO.wp'' pour Wikipédia, ''ISO.b'', ''ISO.n'', ''ISO.q'', ''ISO.s'', ''ISO.wikt'' correspondants aux noms interwikis
** Pour les différentes langues du projet en cours (paramétré par la variable urlproject, voir ci-après) : ''ISO''
* Syntaxe de recherche :<br />Syntaxe générale : ''(Préfixe de moteur):(Préfixe simple):(Recherche)(Postfixe simple)(Postfixe final)
** Préfixes de changement de moteur de recherche : ''g:'' pour rechercher sur Google restreint au projet sélectionné, ''gg:'' pour Google sur le Web entier, ''imdb:'' sur [[Internet Movie Database|IMDb]], ''l:'' pour LuMriX, ''h:'' pour l'historique, ''e:'' pour éditer, ''pi:'' pour [[Special:Prefixindex]], ''lp:'' pour l'historique des actions sur la page, ''lu:'' pour l'historique des actions d'un utilisateur
** Postfixes final : ''-'' pour les pages liées, ''--'' pour le suivi des liens
** Préfixes simples : ''c:'' ou ''cat:'' pour ''Catégorie:'', ''m:'' pour ''Modèle:'', ''mw:'' pour ''MediaWiki:'', ''p:'' pour ''Portail:'', ''u:'' pour ''Utilisateur:'', ''w:'' pour ''Project:'' (correspond à Wikipédia, Wiktionnaire, etc) ; ces préfixes peuvent être précédés de ''d'' pour la page de discussion (ex : ''d:'' pour ''Discuter:'', ''dc:'', ''dm:'', etc)
** Postfixes simples : ''/pas'' ou ''/pàs'', ''/pav'' ou ''/pàv'', ''/lann'', ''/ias'' ou ''/iàs'', ''/c'' pour les contributions (marquer uniquement le nom d'utilisateur sans u:), ''/css'' pour le css perso, ''/js'' pour le js perso
* Case à cocher : ouvre la page dans le même onglet si cochée, dans un autre si non cochée
* Liste exhaustive des wikis : sélectionner ''autre langue'', inscrire ''liste'' et cliquer sur ''l''
* Liste des préfixes ISO : sélectionner ''autre langue'', inscrire ''639'' (pour ISO-639) et cliquer sur ''l''
* Article au hasard : taper ''#'' avec éventuellement le nom complet d'un namespace ou ''redirect''
* Article courant : ''_'' qui s'utilise uniquement avec des préfixes ou postfixes sans aucun autre mot (risque d'ambiguïté avec l'espace des noms d'articles)
* Article courant sans l'espace de nom : ''__'', même remarque que précédemment
* Page d'accueil d'un wiki ou de Google : laisser la zone de recherche vide et cliquer sur ''l'' pour la page d'accueil d'un wiki, et sur ''g'' ou ''c'' pour la page d'accueil de Google

=== Paramétrage en fonction du wiki ===

Pour paramétrer la boîte de recherche en fonction du wiki et de vos préférences, il faut changer les variables suivantes avant la ligne document.write(...);

En fonction du wiki sur lequel on installe le script :
* <code>urlproject='wikibooks.org';</code> - nom du projet principal, par défaut 'wikipedia.org'
* <code>namespaces=/^(?:(?:Discuter|(?:Discussion(?: |_))?(?:Utilisateur|Wikipédia)):)?(.+)/i;</code> - nom des namespaces du wiki, si vous avez besoin d'aide demandez-moi, car ceci est important sur un wiki, par défaut pour les wikis en français
* <code>regextitle=/(?:modification de )?(.+)(?: \(section\))?/i;</code> - regex pour extraire le titre, si vous avez besoin d'aide demandez-moi, par défaut pour les wikis en français

En fonction des préférences :
* <code>lang0='fi';</code> - langue de recherche du projet principal, peut être 'null' pour meta ou commons, par défaut 'fr'
** <code>lang1='hu';lang2='ru';</code> - langues associées au deux autres langues rapides, par défaut 'en' et 'de'
* <code>lang0project='wikibooks.org';</code> - projet associé à la langue 0, par défaut urlproject
** <code>lang1='wikibooks.org';lang2='wikisource.org';</code> - projets associés aux langues 1 et 2, par défaut 'wikipedia.org' et 'wikipedia.org'
* <code>lang0name='fi';</code> - nom de la langue affiché, de préférence court (2 lettres) par manque de place
** <code>lang1='hu';lang2='ru';</code> - noms des langues 1 et 2 affichées
* <code>shortcuts=...;</code> - permet de personnaliser les raccourcis, utile surtout pour les non-francophones pour qui m: ne s'associe pas au raccourci modèle:, il faut faire un tableau sur le même modèle que dans le code

==== Exemples ====
Exemple 1 : Wikilivres francophone
:urlproject='wikibooks.org';

Exemple 2 : Wiktionary avec liens vers Wiktionnaire et Wikisanakirja
:urlproject='wiktionary.org';
:lang0='en';lang0name='en';
:lang1='fr';lang1name='fr';
:lang2='fi';lang2name='fi';

Exemple 3 : Meta avec liens vers Wikipédia, Wiktionary et Species
:urlproject='wikipedia.org';
:lang0='fr';  lang0name='fr';
:lang1='en';  lang1name='en';lang1project='wiktionary.org';
:lang2='null';lang2name='sp';lang2project='species.wikimedia.org';
:namespaces=/^(?:(?:User|Meta|.....) ?(?:talk)?:)?(.+)/i;
:/(?:Editing )?(.+)(?: \(section\))?/i;