/* *********************************************************************

;Fonction :

permet de rechercher dans les messages système ([[Special:Allmessages]]) par mot-clefs (Expressions régulières)

;Installation :

obtenir('AllmessagesDeluxe');


{{Projet:JavaScript/Script|AllmessagesDeluxe}}
************************************************************************* */

//<source lang=javascript><pre><nowiki>

////////////////////////////////////////// LANCEMENT ///////////////////////////////////////////

if(wgCanonicalSpecialPageName=="Allmessages"){
    var AllmessagesDeluxe_GetMessagesOK = false;
    var AllmessagesDeluxe_CreatePanelOK = false;
    var AllmessagesDeluxe_messagesTitles = new Array();
    var AllmessagesDeluxe_messagesContents = new Array();
    AllmessagesDeluxe_GetMessages();
    addOnloadHook(AllmessagesDeluxe_CreatePanel);
}

////////////////////////////////////////// REQUÊTE DES MESSAGES SYSTÈME ///////////////////////////////////////////

function AllmessagesDeluxe_GetMessages(){
      var AdresseRequete = wgServer + wgScriptPath + "/api.php?format=xml&action=query&meta=allmessages"
      var NouvelleRequete = sajax_init_object();
      NouvelleRequete.open("GET", AdresseRequete, true);
      NouvelleRequete.onreadystatechange = function() {
            if(NouvelleRequete.readyState != 4) return;
            var AllmessagesDeluxe_XML = NouvelleRequete.responseXML; 
            var AllMessages = AllmessagesDeluxe_XML.getElementsByTagName("message");
            for(var a=0;a<AllMessages.length;a++){
                  var MessageTitle = AllMessages[a].getAttribute("name");
                  var TextNode = AllMessages[a].firstChild;
                  if(TextNode){
                        var MessageContent = TextNode.nodeValue;
                  }else{
                        var MessageContent = "";
                  }
                  AllmessagesDeluxe_messagesTitles.push(MessageTitle);
                  AllmessagesDeluxe_messagesContents.push(MessageContent); 
            }
            AllmessagesDeluxe_GetMessagesOK = true;
            if(AllmessagesDeluxe_CreatePanelOK) AllmessagesDeluxe_EnableForm();
      }
      NouvelleRequete.send(null);
}

////////////////////////////////////////// ACTIVATION DU BOUTON "APPLIQUER" ///////////////////////////////////////////

function AllmessagesDeluxe_EnableForm(){
      var Button = document.getElementById("AllmessagesDeluxe_Button");
      if(Button){
            Button.value = "Appliquer";
            Button.disabled = "";
      }
}

////////////////////////////////////////// MODIFICATION DU FORMULAIRE DE RECHERCHE ///////////////////////////////////////////

function AllmessagesDeluxe_CreatePanel(){
    var Form = document.getElementById("mw-allmessages-form");
    if(!Form) return;

    var FieldsetForm = Form.getElementsByTagName('fieldset')[0];
    var LegendForm = Form.getElementsByTagName('legend')[0];
    var InputForm = Form.getElementsByTagName('input')[0];
    var TableForm = Form.getElementsByTagName('table')[0];
     LegendForm.parentNode.removeChild(LegendForm);
    InputForm.parentNode.removeChild(InputForm);
    TableForm.parentNode.removeChild(TableForm);
    FieldsetForm.parentNode.removeChild(FieldsetForm);
    Form.parentNode.insertBefore(FieldsetForm, Form);
    FieldsetForm.appendChild(LegendForm);
    var Table = document.createElement('table');
    Table.style.width = "100%";
    FieldsetForm.appendChild(Table);
    var TbodyTable = document.createElement('tbody');
    Table.appendChild(TbodyTable);
    var TrTable = document.createElement('tr');
    TbodyTable.appendChild(TrTable);
    var TdOne = document.createElement('td');
    TdOne.style.width = "50%";
    var TdTwo = document.createElement('td');
    TdTwo.style.width = "50%";
    TrTable.appendChild(TdOne);
    TrTable.appendChild(TdTwo);
    Form.parentNode.removeChild(Form);
    TdOne.appendChild(Form);
    Form.appendChild(InputForm);
    Form.appendChild(TableForm);
    var NewForm = document.createElement('form');
    NewForm.id="DeluxeSearchForm";
    NewForm.method = "post" ;
    NewForm.onsubmit = function () {
        AllmessagesDeluxe_CheckPanel();
        return false; 
    } ;

    TdTwo.appendChild(NewForm);
    var NewFormContent = ''
        + '<table style="with:100%;">'
        + '<tbody>'
        + '<tr>'
        + '<td colspan="2" style="text-align:center;text-weight:bold;" >'
        + '<label for="DeluxeSearchForm" >Rechercher par mot-clef</label>'
        + '</td>'
        + '</tr>'
        + '<tr>'
        + '<td style="text-align:right;">'
        + '<label for="SearchInTitle" >Dans le titre du message : </label>'
        + '</td>'
        + '<td>'
        + '<input id="SearchInTitle" type="text" value=""  />'
        + '</td>'
        + '</tr>'
        + '<tr>'
        + '<td style="text-align:right;">'
        + '<label for="SearchInMessage" >Dans le contenu du message : </label>'
        + '</td>'
        + '<td>'
        + '<textarea id="SearchInMessage" value=""  ></textarea>'
        + '</td>'
        + '</tr>'
        + '<tr>'
        + '<td>'
        + '</td>'
        + '<td>'
        + '<input id="AllmessagesDeluxe_Button" type="button" value="Appliquer (veuillez patienter)" disabled="disabled" '
        + 'onclick="AllmessagesDeluxe_CheckPanel();" onselect="AllmessagesDeluxe_CheckPanel();" />'
        + '</td>'
        + '</tr>'
        + '</tbody>'
        + '</table>';
    NewForm.innerHTML = NewFormContent;
    AllmessagesDeluxe_CreatePanelOK = true;
    if(AllmessagesDeluxe_GetMessagesOK) AllmessagesDeluxe_EnableForm();
}

////////////////////////////////////////// VÉRIFICATION DU FORMULAIRE DE RECHERCHE ///////////////////////////////////////////

function AllmessagesDeluxe_CheckPanel(){
    var MessageInput = document.getElementById('SearchInMessage').value;
    var TitleInput = document.getElementById('SearchInTitle').value;
    if((!MessageInput)&&(!TitleInput)) return;
    AllmessagesDeluxe_CheckMessages(MessageInput, TitleInput);
}

////////////////////////////////////////// RECHERCHE DES MOT-CLEFS DANS LES MESSAGES ///////////////////////////////////////////

function AllmessagesDeluxe_CheckMessages(MessageInput, TitleInput){
    var RegExpContent = false;
    var RegExpTitle = false;

    var TitleArray = new Array();
    var MatchedTitleArray = new Array();
    var ContentArray = new Array();

    if(MessageInput) RegExpContent = new RegExp(MessageInput, "g");
    if(TitleInput) RegExpTitle = new RegExp(TitleInput, "g");

    for(var a=0;a<AllmessagesDeluxe_messagesTitles.length;a++){
        var MessageTitle = AllmessagesDeluxe_messagesTitles[a];
        var MessageContent = AllmessagesDeluxe_messagesContents[a];

        if(RegExpContent&&RegExpTitle){
            if(MessageTitle.match(RegExpTitle)&&MessageContent.match(RegExpContent)){
                TitleArray.push(MessageTitle);
                MatchedTitleArray.push(AllmessagesDeluxe_CheckMatches(MessageTitle, RegExpTitle));
                ContentArray.push(AllmessagesDeluxe_CheckMatches(MessageContent, RegExpContent));
            }
        }else if(RegExpContent){
            if(MessageContent.match(RegExpContent)){
                TitleArray.push(MessageTitle);
                MatchedTitleArray.push(MessageTitle);
                ContentArray.push(AllmessagesDeluxe_CheckMatches(MessageContent, RegExpContent));
            }
        }else if(RegExpTitle){
            if(MessageTitle.match(RegExpTitle)){
                TitleArray.push(MessageTitle);
                MatchedTitleArray.push(AllmessagesDeluxe_CheckMatches(MessageTitle, RegExpTitle));
                ContentArray.push(AllmessagesDeluxe_CheckMatches(MessageContent));
            }
        }
    }
    AllmessagesDeluxe_UpDateTable(TitleArray, MatchedTitleArray, ContentArray, false);
}

////////////////////////////////////////// SURLIGNAGE ///////////////////////////////////////////

function AllmessagesDeluxe_CheckMatches(Text, Reg){
    Text = Text.replace(/\</g,"&lt;").replace(/\>/g,"&gt;");
    var Before = "<span style=\"background-color:#FFAAAA;border:1px dotted red;\">";
    var After = "</span>";
    if(Reg){
        var Matches = Text.match(Reg);
        Text = Text.replace(Reg, "TRALALA");
        for(var a=0;a<Matches.length;a++){
            Text = Text.replace(/TRALALA/, Before+Matches[a]+After);
        }
    } 
    return Text;  
}

////////////////////////////////////////// AFFICHAGE DES RÉSULTATS ///////////////////////////////////////////

function AllmessagesDeluxe_UpDateTable(Titles, MatchedTitles,Contents){
    var Table = document.getElementById("mw-allmessagestable");
    if(!Table) return;
    var TableHead = Table.getElementsByTagName('thead')[0];
    var TableBody = Table.getElementsByTagName('tbody')[0];
    while(TableHead.firstChild){ TableHead.removeChild(TableHead.firstChild);}
    while(TableBody.firstChild){ TableBody.removeChild(TableBody.firstChild);}
    TableHead.innerHTML = '<tr><th>Nom du message </th><th>Message actuel</th></tr>';
    for(var a=0;a<Titles.length;a++){
        var NewTR = document.createElement('tr');
        var TdTitle = document.createElement('td');
        TdTitle.innerHTML = '<a href="'+wgServer+wgArticlePath.split('$1').join(wgFormattedNamespaces[8]+":"+Titles[a])+'" >'+MatchedTitles[a]+'</a>';
        var TdContent = document.createElement('td');
        TdContent.innerHTML = Contents[a];
        NewTR.appendChild(TdTitle);
        NewTR.appendChild(TdContent);
        TableBody.appendChild(NewTR);
    }
}

//</nowiki></pre></source>