/* 
Gestionnaire de scripts .js du [[Projet:JavaScript]]

Documentation : [[Discussion MediaWiki:Gadget-DeveloppementJavaScript.js]]


<noinclude>
{{Projet:JavaScript/Script|DeveloppementJavaScript}}
[[Catégorie:Projet:JavaScript/Développement|!]]
</noinclude>
*/

// <pre><nowiki>
// //////////////////////////////////////////////////////////// PARTIE PERSONNALISABLE : PARAMÈTRES

// Liste des skins disponibles
var DeveloppementJavaScript_RunningSkins = new Array(); 
DeveloppementJavaScript_RunningSkins.push('monobook');
DeveloppementJavaScript_RunningSkins.push('chick');
DeveloppementJavaScript_RunningSkins.push('simple');
DeveloppementJavaScript_RunningSkins.push('myskin');
DeveloppementJavaScript_RunningSkins.push('modern');
DeveloppementJavaScript_RunningSkins.push('vector');
DeveloppementJavaScript_RunningSkins.push('cologneblue');
DeveloppementJavaScript_RunningSkins.push('nostalgia');
DeveloppementJavaScript_RunningSkins.push('standard');

// Page du DeveloppementJavaScript
var DeveloppementJavaScript_HomePage = 'MediaWiki:Gadget-DeveloppementJavaScript.js';

// Page d'aide
var DeveloppementJavaScript_HelpPage = 'Discussion MediaWiki:Gadget-DeveloppementJavaScript.js';

// Page où sont listés les scripts
var DeveloppementJavaScript_ListPage = 'Projet:JavaScript/Développement/ListeDesScripts.js';

// Résumé de modification
var DeveloppementJavaScript_Resume = 'Mise à jour avec [['+DeveloppementJavaScript_HomePage+']]';

// Commentaires d'édition
var DeveloppementJavaScript_CommStart = '//DeveloppementJavaScript_DebutSection'
var DeveloppementJavaScript_CommPlus = ' : Cette section est produite par le script [['+DeveloppementJavaScript_HomePage+']]';
var DeveloppementJavaScript_CommConfig = '//DeveloppementJavaScript_ConfigSection';
var DeveloppementJavaScript_CommScript = '// *********************************************** Importation de [[';
var DeveloppementJavaScript_CommEnd = '//DeveloppementJavaScript_FinSection\n';

// //////////////////////////////////////////////////////////// PARTIE PERSONNALISABLE : TEXTES

var DeveloppementJavaScript_Text_SelectScripts = "Sélectionner les scripts à ajouter à la page : ";
var DeveloppementJavaScript_Text_Help = "Documentation";
var DeveloppementJavaScript_Text_InputOK = "Générer le script";
var DeveloppementJavaScript_Text_Hide = "[Masquer]";
var DeveloppementJavaScript_Text_Show = "[Afficher]";
var DeveloppementJavaScript_Text_Check = "Vérification des options";
var DeveloppementJavaScript_Text_Import = "Importation du script : ";
var DeveloppementJavaScript_Text_Edit = "Édition de la page : ";
var DeveloppementJavaScript_Text_Save = "Sauvegarde de la page : ";
var DeveloppementJavaScript_Text_OK = "OK";
var DeveloppementJavaScript_Text_SelectAll = "Tous";
var DeveloppementJavaScript_Text_SelectNone = "Aucun";
var DeveloppementJavaScript_Text_DoEditConfirm = "Êtes vous sûr de vouloir ajouter ces scripts ?";
var DeveloppementJavaScript_Text_UpdateText = "Mettre à jour un script partagé";
var DeveloppementJavaScript_Text_UpdateConfirm = "Êtes vous sûr de vouloir mettre à jour le script « $1 »";

// //////////////////////////////////////////////////////////// FIN DE LA PARTIE PERSONNALISABLE


// //////////////////////////////////////////////////////////// VARIABLES GLOBALES NON PERSONNALISABLES


////////////////////////// PAGES .JS

var DeveloppementJavaScript_RunningPages = new Array();
for(var a=0;a<DeveloppementJavaScript_RunningSkins.length;a++){
      DeveloppementJavaScript_RunningPages.push(wgFormattedNamespaces[2] + ':' + wgUserName.replace(/ /g, "_") + '/' + DeveloppementJavaScript_RunningSkins[a] + '.js');
}
var DeveloppementJavaScript_CurrentRunningPage = wgFormattedNamespaces[2] + ':' + wgUserName.replace(/ /g, "_") + '/' + skin + '.js';


////////////////////////// DÉFINITION DES SCRIPTS


var DeveloppementJavaScript_ScriptType = new Array();
var DeveloppementJavaScript_ScriptText = new Array();
var DeveloppementJavaScript_ScriptPage = new Array();
var DeveloppementJavaScript_ScriptId  =  new Array();

// Scripts par défaut (message d'erreur)
function DeveloppementJavaScript_GetDefaultScripts(){
    DeveloppementJavaScript_ScriptType.push(4);
    DeveloppementJavaScript_ScriptText.push('<a href="'+wgServer+wgArticlePath.split('$1').join(DeveloppementJavaScript_ListPage)+'">Fonction <tt>DeveloppementJavaScript_GetScripts()</tt> non définie</a>');
    DeveloppementJavaScript_ScriptPage.push('');
    DeveloppementJavaScript_ScriptId.push('');
}

// //////////////////////////////////////////////////////////// IMPORTATION DE LA LISTE DE SCRIPTS DU PROJET

importScript(DeveloppementJavaScript_ListPage);

// //////////////////////////////////////////////////////////// IMPORTATION DES STYLES CSS

importStylesheet('MediaWiki:Gadget-DeveloppementJavaScript.css');

// //////////////////////////////////////////////////////////// FONCTIONS


////////////////////////// LANCEMENT

var DeveloppementJavaScript_Running = 0;
addOnloadHook(DeveloppementJavaScript_AddLinks);


////////////////////////// AJOUT DES LIENS

function DeveloppementJavaScript_AddLinks(){
    if(DeveloppementJavaScript_Running==1) return;
    DeveloppementJavaScript_Running = 1;
    if(typeof(DeveloppementJavaScript_LangCustom)=="function")DeveloppementJavaScript_LangCustom();
    if(typeof(DeveloppementJavaScript_UserCustom)=="function")DeveloppementJavaScript_UserCustom();
    if(typeof(DeveloppementJavaScript_GetScripts)=="function"){
        DeveloppementJavaScript_GetScripts();
    }else{
        DeveloppementJavaScript_GetDefaultScripts();
    }
    if((skin == "monobook")||(skin == "vector")||(skin == "modern") ||(skin == "chick")||(skin == "myskin")||(skin == "simple")){
        var ManagerLinks = "<li id=\"DJS_ScriptListLink\" >"
                         + "<a href=" + wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_ListPage) + ">DeveloppementJavaScript</a>"
                         + "</li>"
                         + "<li id=\"DJS_JsPageLink\" >"
                         + "<a href=" + wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_CurrentRunningPage)  + ">" + skin + ".js</a>"
                         + "</li>";
       var conteneurDiv = document.getElementById("p-personal");
       if(!conteneurDiv) return;
       var conteneur = conteneurDiv.getElementsByTagName('ul')[0];
       conteneur.innerHTML = conteneur.innerHTML + ManagerLinks ;
    }else if((skin == "cologneblue")||(skin == "standard" )||(skin == "nostalgia" )){
        var ManagerLinks = "<small><center>"
                         + "<a href=" + wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_ListPage) + ">DeveloppementJavaScript</a> • "
                         + "<a href=" + wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_CurrentRunningPage)  + ">" + skin + ".js</a>"
                         + "</center></small>";
        var ManagerlinkDiv = document.createElement("div");
        ManagerlinkDiv.id = "DJS_ManagerLinks";
        ManagerlinkDiv.innerHTML = ManagerLinks;
        var contentNode = document.getElementById("article");
        if(!contentNode) return;
        contentNode.insertBefore(ManagerlinkDiv, contentNode.firstChild);
    }
    if((wgAction=="view")||(wgAction=="purge")){
        for(var p=0;p<DeveloppementJavaScript_RunningPages.length;p++){
            if(wgPageName == DeveloppementJavaScript_RunningPages[p]) DeveloppementJavaScript_GetConfig();
        }
    }
}


////////////////////////// ANALYSE CONFIG ACTUELLE

var DeveloppementJavaScript_InstalledScriptIds = new Array();

function DeveloppementJavaScript_GetConfig(){
   var Adresse = wgServer + wgScript + "?title=" + wgPageName.replace(/&/g, "%26") + '&oldid='+wgCurRevisionId+'&action=raw';
   var RequeteEdition = sajax_init_object();
   RequeteEdition.open("GET", Adresse, true);
   RequeteEdition.onreadystatechange = function() {
      if( RequeteEdition.readyState != 4 )  return;
      var Resultat = RequeteEdition.responseText;
      if(Resultat.indexOf(DeveloppementJavaScript_CommConfig)!=-1)
      var Configuration = Resultat.split(DeveloppementJavaScript_CommConfig)[1].split('\n')[0];
      if(Configuration){
         for(var a=0;a<DeveloppementJavaScript_ScriptType.length;a++){
            if(DeveloppementJavaScript_ScriptType[a]==1){
               if(Configuration.indexOf('setup-'+DeveloppementJavaScript_ScriptId[a]+'.js')!=-1){
                  DeveloppementJavaScript_InstalledScriptIds[a] = ' checked="checked" ';
               }else{
                  DeveloppementJavaScript_InstalledScriptIds[a] = '';
               }
            }else{
               DeveloppementJavaScript_InstalledScriptIds[a] = '';
            }
         }
      }else{
         for(var a=0;a<DeveloppementJavaScript_ScriptType.length;a++){
            DeveloppementJavaScript_InstalledScriptIds[a] = '';
         }
      }
      DeveloppementJavaScript_CreateForm();
   }
   RequeteEdition.send(null);
}


////////////////////////// CRÉATION TABLEAU DE SÉLECTION

function DeveloppementJavaScript_CreateForm(){
   var DivRepere = document.getElementById('siteNotice');
   if(!DivRepere) return;
 
   var Form = document.createElement('div');
   DivRepere.parentNode.insertBefore(Form, DivRepere);
   DivRepere.style.display = 'none';

   var OKInput = '<p>'
               + '<input type="button" class="DeveloppementJavaScript_Input" '
               + 'onclick="DeveloppementJavaScript_CreateNewScript();" '
               + 'onselect="DeveloppementJavaScript_CreateNewScript();" '
               + 'value="'+DeveloppementJavaScript_Text_InputOK+'" />'
               + '</p>';

   var UpdateSelect = '<p><select id="DeveloppementJavaScript_UpdateSelect" >'
                    + '<option value="'+DeveloppementJavaScript_Text_UpdateText+'" selected="selected" disabled="disabled" >'+DeveloppementJavaScript_Text_UpdateText+'</option>';
   for(var c=0;c<DeveloppementJavaScript_ScriptType.length;c++){
      if(DeveloppementJavaScript_ScriptType[c] == 1){
         UpdateSelect += '<option id="'+DeveloppementJavaScript_ScriptId[c]+'" value="'+DeveloppementJavaScript_ScriptPage[c]+'" name="'+DeveloppementJavaScript_ScriptPage[c]+'" >'+DeveloppementJavaScript_ScriptPage[c]+'</option>';
      }
   }
         UpdateSelect += '</select>'
                       + '<input type="button" class="DeveloppementJavaScript_Input" '
                       + 'onclick="DeveloppementJavaScript_UpdateClick();" '
                       + 'onselect="DeveloppementJavaScript_UpdateClick();" '
                       + 'value="'+DeveloppementJavaScript_Text_UpdateText+'" />'
                       + '</p>';

   var FormContent = '<fieldset id="DeveloppementJavaScript_Fieldset" >'
                   +'<legend>'
                   + '<span style="font-size:120%;">'+DeveloppementJavaScript_Text_SelectScripts
                   + '<b>' + wgPageName.replace(/_/g," ") + '</b> '
                   + '<sup><small>'
                   + '<a href=\"' + wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_HelpPage)  +'\">('+DeveloppementJavaScript_Text_Help+')</a>'
                   + '</small></sup>'
                   + ' <a id=\"DeveloppementJavaScript_ToggleLink\" href=\"javascript:DeveloppementJavaScript_Toggle();\">'+DeveloppementJavaScript_Text_Hide+'</a>'
                   + '</span>'
                   + '</legend>'
                   + '<div id=\"DeveloppementJavaScript_ScriptList\">'
                   + '<table style=\"float:right;clear:right;\">'
                   + '<tr><td>'
                   + '<div style=\"background:#EEE;\">'
                   + '<center><h5>Scripts JS</h5></center>'
                   + '<div style=\"font-size: 95%;background-color: white;color: black;border-collapse: collapse;border: 1px solid #aaa;padding: 0 .8em .3em .5em;\"><ul>'
                   + '<li><b><a href=' + wgServer + wgArticlePath.split('$1').join('') + DeveloppementJavaScript_CurrentRunningPage + '>' + skin + '</a></b></li>';
   for(var b=0;b<DeveloppementJavaScript_RunningPages.length;b++){
      if(DeveloppementJavaScript_RunningPages[b]!=DeveloppementJavaScript_CurrentRunningPage)
      FormContent += '<li>'
                   + '<a href=' + wgServer + wgArticlePath.split('$1').join('') + DeveloppementJavaScript_RunningPages[b] + '>' 
                   + DeveloppementJavaScript_RunningSkins[b] 
                   + '</a>'
                   + '</li>' ;
   }
   FormContent += '</ul></div></div>'
                + '</td></tr>'
                + '</table>'
                + '<form id="DeveloppementJavaScript_Form">' + OKInput;
   var HeadLineCount = 0
   for(var c=0;c<DeveloppementJavaScript_ScriptType.length;c++){
      if(DeveloppementJavaScript_ScriptType[c] == 1){
         FormContent += '<input type=\"checkbox\" '
                      + 'id=\"DJS_'+DeveloppementJavaScript_ScriptId[c]+'\" '
                      + DeveloppementJavaScript_InstalledScriptIds[c]+' ></input>&nbsp;'
                      + '<b><a href=\"'+ wgServer + wgArticlePath.split('$1').join(DeveloppementJavaScript_ScriptPage[c])+'\" '
                      + 'title=\"'+DeveloppementJavaScript_ScriptPage[c]+'\" >'
                      + DeveloppementJavaScript_ScriptId[c]
                      + '</a></b> : '+DeveloppementJavaScript_ScriptText[c]+'<br\/>';
      }else{
         FormContent += '<h'+DeveloppementJavaScript_ScriptType[c]+' id="DJS_headline_'+HeadLineCount+'">'
                      + '<span class="mw-headline">'
                      + DeveloppementJavaScript_ScriptText[c]
                      + '</span>'
                      + '&nbsp;'
                      + '<small><a href="javascript:DeveloppementJavaScript_CheckAll('+HeadLineCount+', true);">'+DeveloppementJavaScript_Text_SelectAll+'</a></small>'
                      + '&nbsp;'
                      + '<small><a href="javascript:DeveloppementJavaScript_CheckAll('+HeadLineCount+', false);">'+DeveloppementJavaScript_Text_SelectNone+'</a></small>'
                      +'</h'+DeveloppementJavaScript_ScriptType[c]+'>';
                      HeadLineCount++
      }
   }
   FormContent += OKInput + UpdateSelect + '</form><div id="DeveloppementJavaScript_Running"></div></div></fieldset>';

   Form.innerHTML = FormContent;
   DeveloppementJavaScript_Toggle();
}


////////////////////////// ANALYSE CONFIG DEMANDÉE

var DeveloppementJavaScript_ScriptsListPage = new Array();
var DeveloppementJavaScript_ScriptsListId = new Array();

function DeveloppementJavaScript_CreateNewScript(){
     var Form = document.getElementById('DeveloppementJavaScript_Form');
     var ControlElement = document.getElementById('DeveloppementJavaScript_Running');
     if((!Form)||(!ControlElement)) return;
     var Inputs = Form.getElementsByTagName("input");
     for(var a=0;a<Inputs.length;a++){
         Inputs[a].disabled = "disabled";
     }
     ControlElement.innerHTML = '<b>* '+DeveloppementJavaScript_Text_Check+'</b><br/>';
     for(var d=0;d<DeveloppementJavaScript_ScriptId.length;d++){
          if(DeveloppementJavaScript_ScriptId[d]=='') continue;
          var Input = document.getElementById("DJS_"+DeveloppementJavaScript_ScriptId[d]);
          if(!Input) continue;
          if(Input.checked){
               DeveloppementJavaScript_ScriptsListPage[DeveloppementJavaScript_ScriptsListPage.length] = DeveloppementJavaScript_ScriptPage[d];
               DeveloppementJavaScript_ScriptsListId[DeveloppementJavaScript_ScriptsListId.length] = DeveloppementJavaScript_ScriptId[d];
          }
     }
     DeveloppementJavaScript_GetScript(0);
}


////////////////////////// IMPORTATION PAGE JS

var DeveloppementJavaScript_NewScript = '';
var DeveloppementJavaScript_NewScriptConfig = DeveloppementJavaScript_CommStart + DeveloppementJavaScript_CommPlus + '\n' +DeveloppementJavaScript_CommConfig;

function DeveloppementJavaScript_GetScript(Position){
     var Script = DeveloppementJavaScript_ScriptsListPage[Position];
     if(!Script){
          DeveloppementJavaScript_NewScriptConfig += '\n\n';
          DeveloppementJavaScript_NewScript += DeveloppementJavaScript_CommEnd ;
          if(Position==0){
               DeveloppementJavaScript_SaveNewScript();
          }else if(confirm(DeveloppementJavaScript_Text_DoEditConfirm)){
               DeveloppementJavaScript_SaveNewScript();
          }else{
               window.location.reload();
          }
          return;
     }
     var ControlElement = document.getElementById('DeveloppementJavaScript_Running');
     ControlElement.innerHTML += '<b>* '+DeveloppementJavaScript_Text_Import + Script + '</b>';

     var AdresseOldid = wgServer + wgScriptPath + '/api.php?format=xml&action=query&prop=revisions&rvprop=ids|user|timestamp&titles='+Script.replace(/&/g, "%26");
     var RequeteOldid = sajax_init_object();
     RequeteOldid.open("GET", AdresseOldid, true);
     RequeteOldid.onreadystatechange = function() {
          if( RequeteOldid.readyState != 4 ) return;
          var Oldid = "cur";
          var User = false;
          var TimeStamp = false;
          var ObjetXML = RequeteOldid.responseXML;
          if(ObjetXML){
               var LastRevision = ObjetXML.getElementsByTagName('rev')[0];
               if(LastRevision){
                    Oldid = LastRevision.getAttribute('revid');
                    User = LastRevision.getAttribute('user');
                    TimeStamp = DeveloppementJavaScript_ManageTimestamp(LastRevision.getAttribute('timestamp'));
               }
          }
          TimeStamp = ( TimeStamp ? TimeStamp : "" ); 
          ControlElement.innerHTML += ' (Oldid : <b>' + Oldid + '</b>' + ( User ? ', par <b>'+User+'</b>' : "" )  + ', le <b>'+TimeStamp+'</b>)<br/>';
          var AdresseRaw = wgServer + wgScript + '?title=' + Script.replace(/&/g, "%26") + '&action=raw&oldid=' + Oldid;
          var RequeteRaw = sajax_init_object();
          RequeteRaw.open("GET", AdresseRaw, true);
          RequeteRaw.onreadystatechange = function() {
               if( RequeteRaw.readyState != 4 ) return;
               var Resultat = RequeteRaw.responseText;
               DeveloppementJavaScript_NewScriptConfig += ' setup-'+DeveloppementJavaScript_ScriptsListId[Position]+'.js ';
               DeveloppementJavaScript_NewScript += DeveloppementJavaScript_CommScript+DeveloppementJavaScript_ScriptsListPage[Position]+']] (oldid : '+Oldid+ ( User ? ', par [['+wgFormattedNamespaces[2]+':'+User+']]' : "" ) + ', le '+TimeStamp+')\n\n';
               DeveloppementJavaScript_NewScript += Resultat + '\n\n';
               DeveloppementJavaScript_GetScript((Position+1));
          }
          RequeteRaw.send(null);
     }
     RequeteOldid.send(null);
}


////////////////////////// ÉDITION/SAUVEGARDE PAGE .JS

function DeveloppementJavaScript_SaveNewScript(){
     var ControlElement = document.getElementById('DeveloppementJavaScript_Running');
     ControlElement.innerHTML += '<b>* '+DeveloppementJavaScript_Text_Edit + wgPageName.replace(/_/g, " ") + '</b><br/>';
     var Adresse = wgServer + wgScript + "?title=" + wgPageName.replace(/&/g, "%26") + '&action=edit';
     var RequeteEdition = sajax_init_object(); 
     RequeteEdition.open("GET", Adresse, true);
     RequeteEdition.onreadystatechange = function() {
          if( RequeteEdition.readyState != 4 )  return;
          var Temp = document.createElement('div');
          Temp.style.display = 'none';
          document.body.insertBefore(Temp, document.body.firstChild);
          Temp.innerHTML = RequeteEdition.responseText;  
          var ContenuTextarea = document.getElementById('wpTextbox1').value;
          if((ContenuTextarea.indexOf(DeveloppementJavaScript_CommStart)!=-1)&&(ContenuTextarea.indexOf(DeveloppementJavaScript_CommEnd)!=-1)){
               var Before = ContenuTextarea.split(DeveloppementJavaScript_CommStart)[0];
               var After = ContenuTextarea.split(DeveloppementJavaScript_CommEnd)[1];
               var TexteFinal = Before+DeveloppementJavaScript_NewScriptConfig+DeveloppementJavaScript_NewScript+After;
          }else{
               var TexteFinal = DeveloppementJavaScript_NewScriptConfig+DeveloppementJavaScript_NewScript+ContenuTextarea;
          }
          ControlElement.innerHTML += '<b>* '+ DeveloppementJavaScript_Text_Save + wgPageName.replace(/_/g, " ") + '</b><br/>';
          var AdressePublication = document.getElementById("editform").action; 
          var boundary = '--------123xyz';
          var data = '';
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpTextbox1"\n\n' 
                + TexteFinal + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSummary"\n\n' 
                + DeveloppementJavaScript_Resume + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSection"\n\n' 
                + document.editform.wpSection.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpStarttime"\n\n' 
                + document.editform.wpStarttime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEdittime"\n\n' 
                + document.editform.wpEdittime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEditToken"\n\n' 
                + document.editform.wpEditToken.value + '\n'
          var RequetePublication = sajax_init_object();
          RequetePublication.open('POST', AdressePublication, true);
          RequetePublication.setRequestHeader('Content-Type', 'multipart/form-data; boundary='+boundary);
          RequetePublication.onreadystatechange = function(){
               if (RequetePublication.readyState != 4) return;
               Temp.innerHTML = RequetePublication.responseText;                     
               if(!Temp.getElementsByTagName('textarea')[0]){
                    ControlElement.innerHTML += '<b><big>'+DeveloppementJavaScript_Text_OK+'</big></b>';
                    window.location.reload();
               }else{
                    DeveloppementJavaScript_SaveNewScript();
              }
          }
          RequetePublication.send(data + '--' + boundary);
     }
     RequeteEdition.send(null);
}

function DeveloppementJavaScript_UpdateClick(){
     var Select = document.getElementById("DeveloppementJavaScript_UpdateSelect");
     var ScriptName = false;
     var ScriptId = false;
     var Options = Select.getElementsByTagName('option');
     for(var a=1;a<Options.length;a++){
          if(Options[a].selected){ 
               ScriptName = Options[a].value; 
               ScriptId = Options[a].id; 
          }
     }
     if(!ScriptName || !ScriptId ) return;
     var Input = document.getElementById('DJS_'+ScriptId);
     if(!Input.checked){
          alert("Ce script n'est pas installé");
          return;
     }
     if(ScriptName.indexOf(wgFormattedNamespaces[8] +":")!=-1 && wgUserGroups.indexOf("sysop")==-1){
          alert("Vous n'avez pas le statut nécessaire pour éditer une page de l'espace de noms « " + wgFormattedNamespaces[8] + " »");
          return;
     }
     DeveloppementJavaScript_UpdatePage(ScriptName);
}

function DeveloppementJavaScript_UpdatePage(ScriptName){
     if(!confirm(DeveloppementJavaScript_Text_UpdateConfirm.split('$1').join(ScriptName)) ) return;
     var ControlElement = document.getElementById('DeveloppementJavaScript_Running');
     var Adresse = wgServer + wgScript + "?title=" + wgPageName.replace(/&/g, "%26") + '&oldid='+wgCurRevisionId+'&action=raw';
     var RequeteEdition = sajax_init_object();
     RequeteEdition.open("GET", Adresse, true);
     RequeteEdition.onreadystatechange = function() {
          if( RequeteEdition.readyState != 4 )  return;
          var Resultat = RequeteEdition.responseText;
          if((Resultat.indexOf(DeveloppementJavaScript_CommStart)==-1)||(Resultat.indexOf(DeveloppementJavaScript_CommEnd)==-1)){
               alert("Mise à jour impossible\nLes commentaires recherchés ne sont pas présents");
               return;
          }
          var NewScript = "";
          var Script = false;
          var Lines = Resultat.split('\n');
          var Position = 0;
          var Line;
          while(Position<Lines.length){
               Line = Lines[Position] + '\n';
               if((Line.indexOf(DeveloppementJavaScript_CommScript)!=-1 && Script == true) || Line.indexOf(DeveloppementJavaScript_CommEnd)!=-1){
                    break;
               }else if(Line.indexOf(DeveloppementJavaScript_CommScript)!=-1 && Line.indexOf(ScriptName)!=-1){
                    Script = true;
               }else if(Script==true){
                    NewScript = NewScript + Line ;
               }
               Position++            
          }
          if(Script == false){
               alert("Impossible de trouver le script demandé");
               return;
          }
          NewScript = NewScript.replace(/^\/n/g, "");
          NewScript = NewScript.replace(/\/n$/g, "");

          DeveloppementJavaScript_UpdateSharedScript(ScriptName, NewScript);   
     }
     RequeteEdition.send(null);
}

function DeveloppementJavaScript_UpdateSharedScript(ScriptName, NewScript){
     var ControlElement = document.getElementById('DeveloppementJavaScript_Running');
     ControlElement.innerHTML += '<b>* '+DeveloppementJavaScript_Text_Edit + ScriptName.replace(/_/g, " ") + '</b><br/>';
     var Adresse = wgServer + wgScript + "?title=" + ScriptName.replace(/&/g, "%26") + '&action=edit';
     var RequeteEdition = sajax_init_object(); 
     RequeteEdition.open("GET", Adresse, true);
     RequeteEdition.onreadystatechange = function() {
          if( RequeteEdition.readyState != 4 )  return;
          var Temp = document.createElement('div');
          Temp.style.display = 'none';
          document.body.insertBefore(Temp, document.body.firstChild);
          Temp.innerHTML = RequeteEdition.responseText;
          var TexteFinal = NewScript;
          ControlElement.innerHTML += '<b>* '+ DeveloppementJavaScript_Text_Save + ScriptName.replace(/_/g, " ") + '</b><br/>';
          var AdressePublication = document.getElementById("editform").action; 
          var boundary = '--------123xyz';
          var data = '';
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpTextbox1"\n\n' 
                + TexteFinal + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSummary"\n\n' 
                + DeveloppementJavaScript_Resume + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSection"\n\n' 
                + document.editform.wpSection.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpStarttime"\n\n' 
                + document.editform.wpStarttime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEdittime"\n\n' 
                + document.editform.wpEdittime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEditToken"\n\n' 
                + document.editform.wpEditToken.value + '\n'
          var RequetePublication = sajax_init_object();
          RequetePublication.open('POST', AdressePublication, true);
          RequetePublication.setRequestHeader('Content-Type', 'multipart/form-data; boundary='+boundary);
          RequetePublication.onreadystatechange = function(){
               if (RequetePublication.readyState != 4) return;
               Temp.innerHTML = RequetePublication.responseText;                     
               if(!Temp.getElementsByTagName('textarea')[0]){
                    ControlElement.innerHTML += '<b><big>'+DeveloppementJavaScript_Text_OK+'</big></b>';
                    window.location.reload();
               }else{
                    DeveloppementJavaScript_UpdateSharedScript(ScriptName, NewScript);
              }
          }
          RequetePublication.send(data + '--' + boundary);
     }
     RequeteEdition.send(null);
}


////////////////////////// MASQUAGE/AFFICHAGE TABLEAU DE SÉLECTION

function DeveloppementJavaScript_Toggle(){
     var Link = document.getElementById("DeveloppementJavaScript_ToggleLink");
     var Liste = document.getElementById("DeveloppementJavaScript_ScriptList");
     if((!Link)||(!Liste)) return;
     if(Link.innerHTML == DeveloppementJavaScript_Text_Hide){
          Liste.style.display = "none";
          Link.innerHTML = DeveloppementJavaScript_Text_Show;
     }else{
          Liste.style.display = "block";
          Link.innerHTML = DeveloppementJavaScript_Text_Hide;
     }
}


////////////////////////// SÉLECTION/DÉSÉLECTION DE TOUTE UNE SECTION

function DeveloppementJavaScript_CheckAll(ID, Check){

     var HeadLine = document.getElementById("DJS_headline_"+ID);
     if(!HeadLine) return;
     var Limit = HeadLine.tagName.toLowerCase();
     var Element = HeadLine.nextSibling;
     while(Element){
          if(Element.tagName){
               if(Element.tagName.toLowerCase()==Limit) break;
               if(Element.tagName.toLowerCase()=='input'){
                    if(Element.type == 'checkbox'){
                         if(Check){
                              Element.checked = "checked";
                         }else{
                              Element.checked = false;                        
                         }
                    }
               }
          }
          Element = Element.nextSibling
     }
}

////////////////////////// DÉCODAGE TIMESTAMP

function DeveloppementJavaScript_ManageTimestamp(TimeStamp){
     if(!TimeStamp) return false;
     var DateUgly = TimeStamp.replace(/Z/g, "").split("T")[0];
     var Time = TimeStamp.split("T")[1].replace(/Z/g, "");
     var Date = DateUgly.split("-");
     var Year = Date[0];
     var Month = Date[1];
     var Day = Date[2];
     var Text = Day + "/" + Month + "/" + Year + " à " + Time;
     return Text;
}


// </nowiki></pre>