/* <source lang="javascript"> */

(function ()
{
var triplets = [
['aa', 'Afar', 'Afar'],
['ab', 'Abkhaze', 'Аҧсуа'],
['af', 'Afrikaans', 'Afrikaans'],
['ak', 'Akan', 'Akan'],
['als', 'Albanais tosk', 'Alemannisch'],
['am', 'Amharique', 'አማርኛ'],
['an', 'Aragonais', 'Aragonés'],
['ang', 'Anglo-saxon', 'Anglo-Saxon'],
['ar', 'Arabe', 'العربية'],
['as', 'Assamais', 'অসমীয়া'],
['ast', 'Asturien', 'Asturianu'],
['av', 'Avar', 'Авар'],
['ay', 'Aymara', 'Aymar'],
['az', 'Azéri', 'Azərbaycan'],
['ba', 'Bachkir', 'Башҡорт'],
['be', 'Biélorusse', 'Беларуская'],
['bg', 'Bulgare', 'Български'],
['bh', 'Bihari', 'भोजपुरी'],
['bi', 'Bichlamar', 'Bislama'],
['bm', 'Bambara', 'Bamanankan'],
['bn', 'Bengali', 'বাংলা'],
['bo', 'Tibétain', 'བོད་ཡིག'],
['br', 'Breton', 'Brezhoneg'],
['bs', 'Bosniaque', 'Bosanski'],
['ca', 'Catalan', 'Català'],
['ch', 'Chamorro', 'Chamoru'],
['chr', 'Chérokî', 'ᏣᎳᎩ'],
['co', 'Corse', 'Corsu'],
['cr', 'Cri', 'Nēhiyawēwin / ᓀᐦᐃᔭᐍᐏᐣ'],
['cs', 'Tchèque', 'Česky'],
['csb', 'Kachoube', 'Kaszëbsczi'],
['cy', 'Gallois', 'Cymraeg'],
['da', 'Danois', 'Dansk'],
['de', 'Allemand', 'Deutsch'],
['dv', 'Divehi', 'ދިވެހިބަސް'],
['dz', 'Dzongkha', 'ཇོང་ཁ'],
['el', 'Grec', 'Ελληνικά'],
['en', 'Anglais', 'English'],
['eo', 'Espéranto', 'Esperanto'],
['es', 'Espagnol', 'Español'],
['et', 'Estonien', 'Eesti'],
['eu', 'Basque', 'Euskara'],
['fa', 'Perse', 'فارسی'],
['fi', 'Finnois', 'Suomi'],
['fj', 'Fidjien', 'Na Vosa Vakaviti'],
['fo', 'Féroïen', 'Føroyskt'],
['fr', 'Français', 'Français'],
['fy', 'Frison occidental', 'Frysk'],
['ga', 'Irlandais', 'Gaeilge'],
['gd', 'Gaélique écossais', 'Gàidhlig'],
['gl', 'Galicien', 'Galego'],
['gn', 'Guarani', "Avañe'ẽ"],
['gu', 'Gujarati', 'ગુજરાતી'],
['gv', 'Mannois', 'Gaelg'],
['ha', 'Haoussa', 'هَوُسَ'],
['he', 'Hébreu', 'עברית'],
['hi', 'Hindi', 'हिन्दी'],
['hr', 'Croate', 'Hrvatski'],
['hsb', 'Haut-sorabe', 'Hornjoserbsce'],
['ht', 'Haïtien créole', 'Kreyòl ayisyen'],
['hu', 'Hongrois', 'Magyar'],
['hy', 'Arménien', 'Հայերեն'],
['ia', 'Interlingua', 'Interlingua'],
['id', 'Indonésien', 'Bahasa Indonesia'],
['ie', 'Interlingue', 'Interlingue'],
['ik', 'Inupiaq', 'Iñupiak'],
['io', 'Ido', 'Ido'],
['is', 'Islandais', 'Íslenska'],
['it', 'Italien', 'Italiano'],
['iu', 'Inuktitut', 'ᐃᓄᒃᑎᑐᑦ/inuktitut'],
['ja', 'Japonais', '日本語'],
['jbo', 'Lojban', 'Lojban'],
['jv', 'Javanais', 'Basa Jawa'],
['ka', 'Géorgien', 'ქართული'],
['kk', 'Kazakh', 'Қазақша'],
['kl', 'Kalaallisut', 'Kalaallisut'],
['km', 'Khmer', 'ភាសាខ្មែរ'],
['kn', 'Kannada', 'ಕನ್ನಡ'],
['ko', 'Coréen', '한국어'],
['ks', 'Kashmiri', 'कश्मीरी - (كشميري)'],
['ku', 'Kurde', 'Kurdî / كوردی'],
['kw', 'Cornique', 'Kernewek'],
['ky', 'Kirghiz', 'Кыргызча'],
['la', 'Latin', 'Latina'],
['lb', 'Luxembourgeois', 'Lëtzebuergesch'],
['li', 'Limbourgeois', 'Limburgs'],
['ln', 'Lingala', 'Lingála'],
['lo', 'Laotien', 'ລາວ'],
['lt', 'Lituanien', 'Lietuvių'],
['lv', 'Letton', 'Latviešu'],
['mg', 'Malgache', 'Malagasy'],
['mh', 'Marshallais', 'Ebon'],
['mi', 'Maori', 'Māori'],
['mk', 'Macédonien', 'Македонски'],
['ml', 'Malayalam', 'മലയാളം'],
['mn', 'Mongole', 'Монгол'],
['mo', 'Moldave', 'Молдовеняскэ'],
['mr', 'Marathe', 'मराठी'],
['ms', 'Malais', 'Bahasa Melayu'],
['mt', 'Maltais', 'Malti'],
['my', 'Birman', 'Myanmasa'],
['na', 'Nauruan', 'Ekakairũ Naoero'],
['nah', 'Nahuatl', 'Nahuatl'],
['nb', 'Norvégien (bokmål)', '‪Norsk (bokmål)‬'],
['nds', 'Bas-saxon', 'Plattdüütsch'],
['ne', 'Népalais', 'नेपाली'],
['nl', 'Néerlandais', 'Nederlands'],
['nn', 'Norvégien (nynorsk)', '‪Norsk (nynorsk)‬'],
['no', 'Norvégien', '‪Norsk'],
['oc', 'Occitan', 'Occitan'],
['om', 'Oromo', 'Oromoo'],
['or', 'Oriya', 'ଓଡ଼ିଆ'],
['pa', 'Pendjabi', 'ਪੰਜਾਬੀ'],
['pi', 'Pali', 'पािऴ'],
['pl', 'Polonais', 'Polski'],
['ps', 'Pachto', 'پښتو'],
['pt', 'Portugais', 'Português'],
['qu', 'Quechua', 'Runa Simi'],
['rm', 'Romanche', 'Rumantsch'],
['rn', 'Kirundi', 'Kirundi'],
['ro', 'Roumain', 'Română'],
['roa', 'Langues romanes ', '?'],
['ru', 'Russe', 'Русский'],
['rw', 'Rinyarwanda', 'Kinyarwanda'],
['sa', 'Sanskrit', 'संस्कृत'],
['sc', 'Sarde', 'Sardu'],
['scn', 'Sicilien', 'Sicilianu'],
['sd', 'Sindhi', 'سنڌي'],
['sg', 'Sango', 'Sängö'],
['sh', 'Serbo-croate', 'Srpskohrvatski / Српскохрватски'],
['si', 'Cingalais', 'සිංහල'],
['simple', 'Simple anglais', 'Simple English'],
['sk', 'Slovaque', 'Slovenčina'],
['sl', 'Slovène', 'Slovenščina'],
['sm', 'Samoan', 'Gagana Samoa'],
['sn', 'Shona', 'chiShona'],
['so', 'Somali', 'Soomaaliga'],
['sq', 'Albanais', 'Shqip'],
['sr', 'Serbe', 'Српски / Srpski'],
['ss', 'Swazi', 'SiSwati'],
['st', 'Sotho du Sud', 'Sesotho'],
['su', 'Sundanese', 'Basa Sunda'],
['sv', 'Suédois', 'Svenska'],
['sw', 'Swahili', 'Kiswahili'],
['ta', 'Tamil', 'தமிழ்'],
['te', 'Télougou', 'తెలుగు'],
['tg', 'Tadjik', 'Тоҷикӣ/tojikī'],
['th', 'Thaï', 'ไทย'],
['ti', 'Tigrigna', 'ትግርኛ'],
['tk', 'Turkmène', 'Türkmen'],
['tl', 'Tagalog', 'Tagalog'],
['tn', 'Tswana', 'Setswana'],
['to', 'Tongien', 'faka-Tonga'],
['tokipona', 'Tokipona', 'Toki Pona'],
['tpi', 'Tok pisin', 'Tok Pisin'],
['tr', 'Turque', 'Türkçe'],
['ts', 'Tsonga', 'Xitsonga'],
['tt', 'Tatar', 'Tatarça/Татарча'],
['tw', 'Twi', 'Twi'],
['ug', 'Ouïghour', 'Uyghurche‎ / ئۇيغۇرچە'],
['uk', 'Ukrainien', 'Українська'],
['ur', 'Ourdou', 'اردو'],
['uz', 'Ouzbek', "O'zbek"],
['vi', 'Vietnamien', 'Tiếng Việt'],
['vo', 'Volapük', 'Volapük'],
['wa', 'Wallon', 'Walon'],
['wo', 'Wolof', 'Wolof'],
['xh', 'Xhosa', 'isiXhosa'],
['yi', 'Yiddish', 'ייִדיש'],
['yo', 'Yoruba', 'Yorùbá'],
['za', 'Zhuang', '(Cuengh)'],
['zh', 'Chinois (mandarin)', '中文'],
['zh-min-nan', 'Minnan', '?'],
['zh-yue', 'Cantonais', '?'],
['zu', 'Zoulou', 'isiZulu']
];

var code2nametable = new Object();
var code2FLnametable = new Object();
var name2codetable = new Object();
var FLname2codetable = new Object();

for(var i = 0; i < triplets.length; ++i)
{
 code2nametable[triplets[i][0]] = triplets[i][1];
 code2FLnametable[triplets[i][0]] = triplets[i][2];
 name2codetable[triplets[i][1]] = triplets[i][0];
 FLname2codetable[triplets[i][2]] = triplets[i][0];
}

langcode2name = function(code) { return code2nametable[code]; };
langcode2FLname = function(code) { return code2FLnametable[code]; };
langname2code = function(name) { return name2codetable[name]; };
FLname2code = function(FLname) { return FLname2codetable[FLname]; };
})();

if( document.callbacks_langcode ){
  for(var callback in document.callbacks_langcode){
    document.callbacks_langcode[callback]();
  }
}
/* </source> */