//<noinclude>{{Projet:JavaScript/Script|BandeauxEbauches}}</noinclude>

// Documentation : [[Projet:JavaScript/Notices/BandeauxEbauches]]

//<source lang=javascript>
//<pre><nowiki>


////////////////////////////////////////////////////////////////////////////////////////// VARIABLES PERSONNALISABLES

var BandeauxEbauches_MaxParams = 6; // Nombre maximum de paramètres pour le modèle {{Ébauche}}

if(typeof(BandeauxEbauches_AutoEdit)=='undefined') var BandeauxEbauches_AutoEdit = true;         // Publication automatique
 
if(typeof(BandeauxEbauches_MinorEdit)=='undefined') var BandeauxEbauches_MinorEdit = true;       // Modification mineure
 
if(typeof(BandeauxEbauches_TailleListe)=='undefined') var BandeauxEbauches_TailleListe = 5;      // Nombre de suggestions
 
if(typeof(BandeauxEbauches_ListeBas)=='undefined') var BandeauxEbauches_ListeBas = true;         // Affichage des suggestions vers le bas
 
if(typeof(BandeauxEbauches_KeyboardDelay)=='undefined') var BandeauxEbauches_KeyboardDelay = 5;  // Délai (en secondes) lors de la sélection d'une suggestion au clavier


////////////////////////////////////////////////////////////////////////////////////////// LANCEMENT

if(((wgAction=="view")||(wgAction=="purge"))&&(wgNamespaceNumber == 0)){
      addOnloadHook(BandeauxEbauches);
}

function BandeauxEbauches(){
      var EbaucheCount = -1;
      var AllDivs = document.getElementsByTagName('div');
      for(var a=0;a<AllDivs.length;a++){
            if(hasClass(AllDivs[a], "bandeau-niveau-ebauche")){
                  EbaucheCount++
                  var BandeauTable = AllDivs[a].getElementsByTagName('table')[0];
                  BandeauTable.id = 'TableBandeau_'+EbaucheCount;
                  var StrongText = AllDivs[a].getElementsByTagName('strong')[0];
                  StrongText.innerHTML += ' (<a href="javascript:BandeauxEbauches_GetBandeaux(\''+EbaucheCount+'\');" title="Modifier le bandeau d\'ébauche">modifier</a>)';
            }
      }
      if(EbaucheCount<0){
            var Cactions = document.getElementById('p-cactions');
            if(Cactions){
                  Cactions.getElementsByTagName('ul')[0].innerHTML += '<li><a href="javascript:BandeauxEbauches_CreateBandeau();" title="Ajouter un bandeau d\'ébauche">Ébauche</a></li>';
                  removeClass(Cactions, "emptyPortlet");
            }
      }
}


////////////////////////////////////////////////////////////////////////////////////////// RECHERCHE DES PARAMÈTRES DU BANDEAU ACTUEL

function BandeauxEbauches_GetBandeaux(BandeauCount){
      var url = wgServer + wgScript + '?title=' + wgPageName +'&action=edit&section=0';
      var BandeauxEbauches_Request = sajax_init_object();
      BandeauxEbauches_Request.open("GET", url, true);
      BandeauxEbauches_Request.send(null);
      BandeauxEbauches_Request.onreadystatechange = function() {
           if(BandeauxEbauches_Request.readyState == 4 && BandeauxEbauches_Request.status == 200) {
                  var Temp = document.createElement('div');
                  //document.body.insertBefore(Temp, document.body.firstChild);
                  Temp.innerHTML = BandeauxEbauches_Request.responseText;
                  
                  var OldText = Temp.getElementsByTagName('textarea')[0].value;
                  OldText = OldText.replace(/\{\{ébauche/g, "\{\{Ébauche");
                  OldText = OldText.replace(/\{\{Ébauche /g, "\{\{Ébauche\|");
               
                  var BeforeModele = OldText.substring(0, OldText.indexOf('{{Ébauche'));
                  var Modele = OldText.split(BeforeModele + '{{Ébauche').join('');
                  while(Modele.indexOf('}}')!=-1){
                        Modele = Modele.substring(0, Modele.indexOf('}}'));
                        if(Modele.indexOf('}}')!=-1) break;
                  }
                  //alert(Modele);
                  if(Modele!='') Modele = Modele + '|';
                  var ListeBandeaux = new Array();
                  var ListeBandeauxCount = -1;
                  while(Modele.indexOf('|')!=-1){
                        var Param = Modele.split('|')[1].split('|')[0];
                        //alert(Param);
                        ListeBandeauxCount++
                        ListeBandeaux[ListeBandeauxCount] = Param; 
                        Modele = Modele.split('|'+Param).join('');
                  }
                  BandeauxEbauches_ModifyBandeau(BandeauCount, ListeBandeaux)
            }
      }
}
 

////////////////////////////////////////////////////////////////////////////////////////// FORMULAIRE

function BandeauxEbauches_CreateBandeau(){
      var Content = document.getElementById('bodyContent');
      if(!Content) Content = document.getElementById('mw_contentholder');
      if(!Content) Content = document.getElementById('article');
      if(!Content) return;      
      var ListeBandeaux = new Array();
      var NewBandeau = document.createElement('div');
      NewBandeau.className = "plainlinks bandeau-niveau-ebauche bandeau";
      NewBandeau.innerHTML = '<table id="TableBandeau_0" style="background-color: transparent; display: block;"></table>';
      if( (skin=="monobook")||(skin=="chick")||(skin=="myskin")||(skin=="simple")||(skin=="vector") ){
            var ContentSub = document.getElementById('contentSub');
            Content.insertBefore(NewBandeau, ContentSub.nextSibling);
      }else if(skin=="modern"){ 
            var ContentSub = Content.firstChild;
            Content.insertBefore(NewBandeau, ContentSub.nextSibling);
      }else if(skin=="cologneblue"){
            var ContentSub = Content.getElementsByTagName('p')[0];
            Content.insertBefore(NewBandeau, ContentSub.nextSibling);
      }else if(skin=="standard"){
            var ContentSub = document.getElementById('catlinks');
            Content.insertBefore(NewBandeau, ContentSub.nextSibling);
      }else if(skin=="nostalgia"){
            Content.insertBefore(NewBandeau, Content.firstChild);
      }
      BandeauxEbauches_ModifyBandeau(0, ListeBandeaux);
}

function BandeauxEbauches_ModifyBandeau(BandeauCount, ListeBandeaux){
      var Table = document.getElementById('TableBandeau_'+BandeauCount);
      Table.style.display = "none";
      var NewDivBandeau = document.createElement('div');
      NewDivBandeau.id = 'DivBandeau_'+BandeauCount;
      Table.parentNode.insertBefore(NewDivBandeau, Table);
      var Liste = ''      
      var AllBandeaux = new Array();
      for(var a=0;a<BandeauxEbauches_MaxParams;a++){
            if(ListeBandeaux[a]){
                  AllBandeaux[a] = ListeBandeaux[a];
                  Liste += 'SPLIT'+ ListeBandeaux[a];
            }else{
                  AllBandeaux[a] = '';
            }
      }
      Liste = encodeURIComponent(Liste.replace(/'/g, "ZAPOSTROPHE"));
      var Boutons = '<input type="button" onclick="BandeauxEbauches_Edit(\''+BandeauCount+'\',\''+Liste+'\');" onselect="BandeauxEbauches_Edit(\''+BandeauCount+'\',\''+Liste+'\');" value="Valider"/>'
                  + '<input type="button" onclick="BandeauxEbauches_Cancel(\''+BandeauCount+'\',\''+Liste+'\')" onselect="BandeauxEbauches_Cancel(\''+BandeauCount+'\')" value="Annuler"/>';
      var Explication = '<strong><label for"FormBandeau_'+BandeauCount+'">Sélectionner les bandeaux d\'ébauche à apposer.</label></strong>';
      if(BandeauxEbauches_ListeBas){ 
            var TopForme = Explication + '&nbsp;&nbsp;' + Boutons;
            var BottomForme = '';
      }else{
            var TopForme = '';
            var BottomForme = Explication + '&nbsp;&nbsp;' + Boutons;
      }
      var NewDivBandeauHTML = '<form id="FormBandeau_'+BandeauCount+'">';
      NewDivBandeauHTML += TopForme + '<br/>';
      for(var a=0;a<BandeauxEbauches_MaxParams;a++){
           NewDivBandeauHTML += '<select id="SelectBandeau_'+BandeauCount+'_'+a+'" style="display:none;" title="Suggestions de bandeaux" />'
                              + '<input id="InputBandeau_'+BandeauCount+'_'+a+'" type="text" value="'+AllBandeaux[a]+'" onkeyup="BandeauxEbauches_TextChanged('+BandeauCount+','+a+')" />';
      }
      NewDivBandeauHTML += '<br/>' + BottomForme ;
      NewDivBandeauHTML += '</form>';
      NewDivBandeau.innerHTML = NewDivBandeauHTML;
      document.getElementById('InputBandeau_0_0').focus();
      for(var a=0;a<ListeBandeaux.length;a++){
            BandeauxEbauches_TextChanged(BandeauCount,a);
      }
}

function BandeauxEbauches_Cancel(id, Liste){
      var BandeauTable = document.getElementById('TableBandeau_'+id);
      BandeauTable.style.display = 'block';
      var BandeauDiv = document.getElementById('DivBandeau_'+id);
      BandeauDiv.parentNode.removeChild(BandeauDiv);
      if(Liste=='')BandeauTable.parentNode.parentNode.removeChild(BandeauTable.parentNode);
}


////////////////////////////////////////////////////////////////////////////////////////// SUGGESTIONS

var BandeauxEbauches_TextChanged_running = new Array ;
for(var run=0;run<BandeauxEbauches_MaxParams;run++){
     BandeauxEbauches_TextChanged_running[run] = 0;
}
var  BandeauxEbauches_Edit_running = 0;

function BandeauxEbauches_TextChanged(id1, id2){
     if( ( BandeauxEbauches_TextChanged_running[id2])||(BandeauxEbauches_Edit_running) ) return ;
     var idSelect= 'SelectBandeau_' + id1 + '_' + id2;
     var idInput = 'InputBandeau_' + id1 + '_' + id2;
     var Select = document.getElementById(idSelect ) ;
     var Input = document.getElementById(idInput) ;
     if((!Input)||(!Select)) return;     
     var Value = Input.value;
     if(Value==''){ Select.style.display = 'none'; return; }
     BandeauxEbauches_TextChanged_running[id2] = 1; 
     var url = wgServer + '/w/api.php?action=query&list=allpages&apnamespace=10&aplimit='+BandeauxEbauches_TailleListe+'&apfrom=Ébauche/paramètres%20'+Value; 
     var BandeauxEbauches_Request = sajax_init_object();
     BandeauxEbauches_Request.open("GET", url, true);
     BandeauxEbauches_Request.send(null);
     BandeauxEbauches_Request.onreadystatechange = function() {
          if(BandeauxEbauches_Request.readyState == 4 && BandeauxEbauches_Request.status == 200) {
               Select.innerHTML = ''; 
               var Temp = document.createElement('div');
               //document.body.insertBefore(Temp, document.body.firstChild);
               Temp.innerHTML = BandeauxEbauches_Request.responseText;
               var Infos = Temp.getElementsByTagName('span');
               var NbOptions = 0;
               for(var a=0;a<Infos.length;a++){
                    Info = Infos[a].innerHTML;
                    if(Info.indexOf('title=')!=-1){
                         var TitrePage = Info.split('Ébauche/paramètres')[1].split('"')[0];
                         TitrePage = TitrePage.replace(/^ /,'');
                         while(TitrePage.indexOf('&amp;')!=-1){
                              TitrePage = TitrePage.split('&amp;').join("&");
                              if(TitrePage.indexOf('&amp;')==-1) break;
                         }
                         while(TitrePage.indexOf('&#039;')!=-1){
                              TitrePage = TitrePage.split('&#039;').join("'");
                              if(TitrePage.indexOf('&#039;')==-1) break;
                         }
                         TitrePageEncode = TitrePage.replace(/'/g,"ZAPOSTROPHE");
                         Select.innerHTML +=  '<option value="'+TitrePage+'" '
                                             +'onclick="BandeauxEbauches_TextChanged_Set(\''+idInput+'\', \''+TitrePageEncode+'\'); '
                                             +'BandeauxEbauches_TextChanged(\''+id1+'\',\''+id2+'\');" '
                                             +'>'+TitrePage+'</option>';
                         NbOptions++
                    }
               }
               if(NbOptions>0){
                    Select.onchange = function(){
                         var Selected = this.getElementsByTagName('option');
                         for(var a=0;a<Selected.length;a++){
                               if(Selected[a].selected){
                                     var TextSelected = Selected[a].value;
                                     document.getElementById(idInput).value = TextSelected;
                                     //setTimeout("BandeauxEbauches_TextChanged(\''+id1+'\', \''+id2+'\');", BandeauxEbauches_KeyboardDelay*1000);
                               } 
                         }
                    } 
                    Select.size = NbOptions;
                    Select.style.display = 'inline';
                    Select.style.zIndex = 5 ;
                    Select.style.position = "absolute" ;
                    Input.style.width = Select.offsetWidth + "px" ; 
                    if(BandeauxEbauches_ListeBas){
                         Select.style.top = (parseInt(Input.offsetTop) + parseInt(Input.offsetHeight)) + 'px';
                    }else{
                         Select.style.top = (parseInt(Input.offsetTop) - Select.offsetHeight) + 'px';
                    }
                    Select.style.left = (parseInt(Input.offsetLeft ) - 1) + 'px';
               }else{
                    Select.style.display = 'none';
                    Select.innerHTML = '';
               }
               for(var a=0;a<BandeauxEbauches_MaxParams;a++){
                    var AllSelect= document.getElementById('SelectBandeau_' + id1 + '_' + a);
                    var AllInput = document.getElementById('InputBandeau_' + id1 + '_' + a); 
                    AllSelect.style.left = (parseInt(AllInput.offsetLeft ) - 1) + 'px'; 
               }
               BandeauxEbauches_TextChanged_running[id2] = 0;
          }
     }
}
 
function BandeauxEbauches_TextChanged_Set(id, text){
     text = text.replace(/ZAPOSTROPHE/g,"'");
     document.getElementById(id).value = text; 
     document.getElementById(id).focus() ;
}

////////////////////////////////////////////////////////////////////////////////////////// EDITION 

function BandeauxEbauches_Edit(id, OldListe, Supprimer){

      OldListe = decodeURIComponent(OldListe).replace(/ZAPOSTROPHE/g, "'").replace(/SPLIT/g, "|")
      OldModele = '{{Ébauche' + OldListe + '}}';
      var NewModele = '';
      if(!Supprimer){
            NewModele += '{{Ébauche';
            var BandeauForm = document.getElementById('FormBandeau_'+id);
            var Inputs = BandeauForm.getElementsByTagName('input');
            for(var a=0;a<Inputs.length;a++){
                  if(Inputs[a].type == "text"){
                        var InputValue = Inputs[a].value;
                        if(InputValue !=''){
                              NewModele += '|' + InputValue;
                        }
                  }
            }
            NewModele += '}}\n';
            if(NewModele.indexOf('|')==-1){
                   NewModele = '';
            }
      }
      var SurEtCertain = confirm(OldModele + ' -> ' + NewModele + '\n\nOK ?');
      if(!SurEtCertain){ BandeauxEbauches_Cancel(id, OldListe); return; }
      for(var run=0;run<BandeauxEbauches_MaxParams;run++){
            BandeauxEbauches_TextChanged_running[run] = 1;
      }
      BandeauxEbauches_Edit_running = 1;
      var url = wgServer + wgScript + '?title=' + wgPageName + '&action=edit&section=0';
      var BandeauxEbauches_Request = sajax_init_object();
      BandeauxEbauches_Request.open("GET", url, true);
      BandeauxEbauches_Request.send(null);
      BandeauxEbauches_Request.onreadystatechange = function() {
            if(BandeauxEbauches_Request.readyState == 4 && BandeauxEbauches_Request.status == 200) {
                  while(document.body.firstChild){ document.body.removeChild(document.body.firstChild); } 
                  document.body.innerHTML = BandeauxEbauches_Request.responseText;
                  if(BandeauxEbauches_AutoEdit) document.editform.style.display = 'none';

                  var OldText = document.getElementById('wpTextbox1').value;

                  OldText = OldText.replace(/\{\{ébauche/g, "\{\{Ébauche");
                  OldText = OldText.replace(/\{\{Ébauche /g, "\{\{Ébauche\|");
                  
                  var BeforeModele = OldText.substring(0, OldText.indexOf('{{Ébauche|'));
                  var Modele = OldText.substring(1, OldText.indexOf('{{Ébauche|'))
                  var AfterModele = OldText.split(BeforeModele).join('').split(OldModele + '\n').join('');

                  var TexteFinal = BeforeModele + NewModele + AfterModele;

                  document.getElementById('wpMinoredit').checked = BandeauxEbauches_MinorEdit;
                  document.getElementById('wpTextbox1').value = TexteFinal;
                  document.getElementById('wpSummary').value = 'Changement [[Modèle:Ébauche|{{Ébauche}}]] ; avec [[MediaWiki:Gadget-BandeauxEbauches.js|BandeauxEbauches]]';
                  if(BandeauxEbauches_AutoEdit) document.editform.submit();
            }
      }
}

//</nowiki></pre></source>