/*
  Note aux visiteurs : 
  toutes les fonctions de mon monobook (ici et dans Utilisateur:Darkoneko/commons.js) sont appelées à travers la fonction main()
  si vous souhaitez en utiliser une independamment, pensez à ajouter addOnloadHook(nomDeLaFonction) dans votre monobook/vector (avec une limitation eventuelle à un namespace ou autre), sinon elle ne sera jamais appelée :D
*/


importScript('Utilisateur:Darkoneko/divers.js') //fonctions diverses et réutilisables
importScript('Utilisateur:Darkoneko/commons.js') //fonctionalités sur lesquelles j'ai déjà blogué et/ou qui ne seront (a priori) plus modifiées

importScript('Utilisateur:Darkoneko/addStopInWatchlist.js')

//Ajout de liens internes (bistro, PàS, etc.) dans la boîte de navigation à gauche
function customizeLeftBar() {
  var ul = document.getElementById("p-navigation").getElementsByTagName("ul")[0]
  if( !ul ) return ; //fin

  ul.appendChild( createLiAdressNode( 
             new Array('/wiki/Wikipédia:Le_bistro', '/wiki/Wikipédia:Bulletin des administrateurs', 
                       '/wiki/Wikipédia:Bulletin des bureaucrates' ), 
             new Array('Bistro', 'B.A.', 'B.B.')
  ) ) 

  ul.appendChild( createLiAdressNode( 
             new Array('/wiki/Wikipédia:Pages à supprimer', '/wiki/User:Darkoneko/outils', '/wiki/Special:Blockip' ), 
             new Array('PàS', 'outils', 'block')
  ) )




  li = document.createElement('li')
  li.appendChild( document.createTextNode( 'Loveless (' ) )
  li.appendChild( createAdressNode('/wiki/Utilisateur:Loveless', 'u') )
  li.appendChild( document.createTextNode( ', ' ) )
  li.appendChild( createAdressNode('/wiki/Special:Contributions/Loveless', 'c') )
  li.appendChild( document.createTextNode( ')' ) )
  ul.appendChild( li )



  var li = document.createElement('li')
  li.appendChild( createAdressNode('/wiki/Portail:Animation et bande dessinée asiatiques', 'Portail') )
  li.appendChild( document.createTextNode( ' - ' ) )
  li.appendChild( createAdressNode('/wiki/Projet:Animation et bande dessinée asiatiques', 'Projet') )
  li.appendChild( document.createTextNode( ' (' ) )
  li.appendChild( createAdressNode('/wiki/Discussion Projet:Animation et bande dessinée asiatiques', 'd') )
  li.appendChild( document.createTextNode( ')' ) )
  ul.appendChild( li )

  mw.util.addPortletLink( 'p-navigation', mw.util.wikiGetlink('wp:Bot/Requêtes/Mensuel'), 'Requêtes bot' );
  mw.util.addPortletLink( 'p-navigation', mw.util.wikiGetlink('special:prefixindex/user:Darkoneko/modèle sans smiley à la con'), 'templates' );

  ul.appendChild( createLiAdressNode( 
             new Array('http://meta.wikimedia.org/wiki/Special:CentralAuth', 'http://meta.wikimedia.org/wiki/Special:GlobalBlock'), 
             new Array('CentralAuth', 'lock')
  ) )

  ul.appendChild( createLiAdressNode( 
             new Array('http://meta.wikimedia.org/wiki/Special:UserRights', 'http://toolserver.org/~luxo/contributions/contributions.php'), 
             new Array('U.R.', 'globalEdit')
  ) )

  document.getElementById("n-portal").getElementsByTagName("a")[0].firstChild.nodeValue = "wp:Accueil"
  document.getElementById("n-recentchanges").getElementsByTagName("a")[0].firstChild.nodeValue = "RC"
}
  

function customizeTopBar() {

   var mytalk = document.getElementById('pt-mytalk');
   var topBarUl = mytalk.parentNode

   //ajouter un lien vers la page user:darkoneko lorsque connecté depuis un autre compte
   if( mw.config.get('wgUser') != 'Darkoneko' ) {
         mw.util.addPortletLink( 'p-personal', '/wiki/User:Darkoneko', '-Darkoneko-', 'pt-userpage');
   }   

   //ajouter "js" a gauche de discussion
   mw.util.addPortletLink( 'p-personal', mw.util.wikiGetlink('user:'+mw.config.get('wgUserName')+'/'+skin+'.js'), 'js', 'pt-mytalk');

   //ajouter "js2" a gauche de discussion
   mw.util.addPortletLink( 'p-personal', mw.util.wikiGetlink('user:Darkoneko/commons.js'), 'js2', 'pt-mytalk');
 
   //ajouter "css" a gauche de discussion, donc il sera entre "js" et "discut'"
   mw.util.addPortletLink( 'p-personal', mw.util.wikiGetlink('user:'+mw.config.get('wgUserName')+'/'+skin+'.css'), 'css', 'pt-mytalk');

   //changer l'en tete pour "Page de discussion"
   mytalk.getElementsByTagName("a")[0].firstChild.nodeValue = "Discut"

   //changer l'en tete pour "Préférences"
   document.getElementById('pt-preferences').getElementsByTagName("a")[0].firstChild.nodeValue = "prefs"

   //changer l'en tete pour "Liste de suivi"
   document.getElementById('pt-watchlist').getElementsByTagName("a")[0].firstChild.nodeValue = "watchlist"

   //changer l'en tete pour "Contributions"
   document.getElementById('pt-mycontris').getElementsByTagName("a")[0].firstChild.nodeValue = "contribs"

   //ajouter "log" a gauche de déconnexion
   mw.util.addPortletLink( 'p-personal', '/w/index.php?title=Special:Journal&user='+mw.config.get('wgUserName'), 'log', "pt-logout");

   //changer l'en tete pour "Deconnexion"
   var logout = document.getElementById("pt-logout")
   logout.getElementsByTagName("a")[0].firstChild.nodeValue = "X"
}



function main() {
   switch( mw.config.get('wgNamespaceNumber') ) {
      case -1 :
         switch( mw.config.get('wgCanonicalSpecialPageName') ) {
            case "Whatlinkshere": addDeleteLinkFromWhatLinksHere(); break;
            case "Contributions": addContribLinkNearTalkPageInContributions(); break;
         }
         break;
 
      case 0 : 
         addHistoryLinkToInterwikis()
         break;

      case 2 :
          if ( mw.config.get('wgPageName')  == "Utilisateur:Darkoneko" ) ongletsPageUser();
          break;
   }
   keyboardShortcuts()
  
   customizeLeftBar()
   customizeTopBar()

   youHaveANewInsultingMessage()
   //ImplementToogleOnclick()
}

addOnloadHook(main)

//petite fonction pour raccourcir l'ajout d'un bouton dans la barre d'édition
function addBandeauEditBouton( nom_modele, nom, img ) {
  addCustomButton(
    img,  nom,
    '\{\{subst:user:Darkoneko/modèle sans smiley à la con/'+nom_modele+'}} \n~~\~~',
    '', '',  ''
  );
}

addBandeauEditBouton( "compte page publicitaire", "pub", "");
addBandeauEditBouton( "compte spammeur", "spam", "");


importScript('Utilisateur:Darkoneko/nekotb_fc_1.1.js')