/* 
{{Utilisateur:Dr Brains/onglets}}

<big>'''[[Utilisateur:Dr Brains/DeleteDeluxe.js]]'''</big> est un code javascript qui s'active lors du renommage d'une page.

== Fonctions ==
Le script fournit deux choses : 
# La possibilité d'avoir des résumés de modification prédéfinis (personnalisables, voir plus bas)
# La possibilité de connaître le nombre de pages liées à la page en cours.

{{Image panoramique|Demo DeleteDeluxe.png|800|Aperçu.}}

== Installation ==
Pour installer ces fonctions, ajouter à votre [[Special:Mypage/monobook.js|monobook.js]] (ou autre suivant l'habillage sélectionné dans les préférences) le code suivant

<div style="margin:0.5em;padding:0.5em;border:1px dashed green;">
<source lang=javascript>
importScript('Utilisateur:Dr Brains/DeleteDeluxe.js');
</source>
</div>

== Personnalisation ==

Il est possible de fournir d'autres résumés de modification que ceux par défaut, pour ce faire, il faut les déclarer '''avant''' l'appel de la fonction. Ils intégreront le menu au dessus des résumés fournis par défaut.

Ces résumés doivent être en wikitexte.

===Exemple de personnalisation ===

<div style="margin:0.5em;padding:0.5em;border:1px dashed green;">
<source lang=javascript>
var DeleteDeluxe_Reason = new Array();
var DeleteDeluxe_ReasonCount = 0;

DeleteDeluxe_Reason[DeleteDeluxe_ReasonCount++] = "Parce que ça fait plaisir";
DeleteDeluxe_Reason[DeleteDeluxe_ReasonCount++] = "Et pourquoi pas d'abord ?";


importScript('Utilisateur:Dr Brains/DeleteDeluxe.js');
</source>
</div>

== CODE SOURCE ==

{{Boîte déroulante début|titre=DeleteDeluxe.js}}<!--
*/
// --><source lang=javascript>
//<pre><nowiki>

if(wgUserGroups!=null){
     if((document.URL.indexOf("&action=delete")!=-1)&&(wgUserGroups.indexOf("sysop")!=-1)){ 

          if(typeof(DeleteDeluxe_Reason)=='undefined'){

////////////////////////////////////////////// PARTIE PERSONNALISABLE ///////////////////////////////////

var DeleteDeluxe_Reason = new Array();


DeleteDeluxe_Reason.push("Sous-page personnelle");


////////////////////////////////////////////// FIN DE LA PARTIE PERSONNALISABLE ///////////////////////////////////

          }
          addOnloadHook(DeleteDeluxe);
     }
}

function DeleteDeluxe(){
     var DeleteForm = document.getElementById('deleteconfirm');
     if(!DeleteForm) return;  

// Résumé de suppression
     var TextArea = document.getElementById('wpDeleteReasonList');
     if(TextArea) DeleteDeluxe_GetReasons();


//Pages liées
     var Page = document.getElementById('contentSub');
     if(!Page) return;
     var TitrePage = wgPageName.replace(/_/g," ");
     if(!TitrePage) return;
     var Recapitulatif = document.createElement('div');
     Recapitulatif.innerHTML = '<h2>Pages liées</h2><span id="DeletePageRecap">0</span> pages sont liées à la page « '+TitrePage + ' » : <a href="'+wgServer + '/wiki/Special:Whatlinkshere/' + TitrePage + '" target="_blank" title="Voir les pages liées (nouvel onglet)">Détails</a>';
     DeleteForm.parentNode.insertBefore(Recapitulatif, DeleteForm.nexSibling );
     DeleteDeluxe_GetPages(TitrePage, '');

}


//////////////////////////////////////////////////////////////////// Résumé de renommage 

function DeleteDeluxe_GetReasons(){
     if(DeleteDeluxe_Reason.length<1) return;

     var NewMenu = document.createElement('optgroup');
     NewMenu.label = "Motifs personnalisés";
     var MenuContent = '';
     for(var a=0;a<DeleteDeluxe_Reason.length;a++){
          MenuContent += '<option value="' + DeleteDeluxe_Reason[a] + '" '
                       + '>' + DeleteDeluxe_Reason[a] + '</option>';

     }

     NewMenu.innerHTML = MenuContent;

     var Select = document.getElementById('wpDeleteReasonList');
     var FirstMenu = Select.getElementsByTagName('optgroup')[0];
     if(FirstMenu) Select.insertBefore(NewMenu, FirstMenu);
}


//////////////////////////////////////////////////////////////////// Compteur de pages liées 

var DeleteDeluxe_PagesCount = 0;

function DeleteDeluxe_GetPages(TitrePage, RequeteContinue){
     if(!RequeteContinue) RequeteContinue ='';
     var APILimit = 499;
     if((wgUserGroups.indexOf("sysop")!=-1)||(wgUserGroups.indexOf("bot")!=-1)){
          APILimit = 4999;
     }
     var AdresseRequete = wgServer + '/w/api.php?action=query&list=backlinks&bllimit='+APILimit+'&blnamespace=0|1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|100|101|102|103|104|105&bltitle=' + TitrePage + RequeteContinue;
     var NouvelleRequete = sajax_init_object();
     NouvelleRequete.open("GET", AdresseRequete, true);
     NouvelleRequete.send(null);
     NouvelleRequete.onreadystatechange = function() {
            if(NouvelleRequete.readyState == 4 && NouvelleRequete.status == 200) {
                  var ElementTraitement = document.createElement('div');
                  ElementTraitement.innerHTML = NouvelleRequete.responseText; 
                  //document.body.appendChild(ElementTraitement);
                  var Informations = ElementTraitement.getElementsByTagName('span');
                  var AutreRequeteNecessaire = false;
                  for(var a=0;a<Informations.length;a++){
                        var ContenuInformation = Informations[a].innerHTML;
                        if(ContenuInformation.indexOf('title=')!=-1){
                              DeleteDeluxe_PagesCount++
                        }
                        if(ContenuInformation.indexOf('blcontinue=')!=-1){
                              AutreRequeteNecessaire = true;
                              var AutreRequeteContinue = '&blcontinue=' + ContenuInformation.split('blcontinue="')[1].split('"')[0];
                        }
                  } 
                  var Recap = document.getElementById("DeletePageRecap");
                  if(AutreRequeteNecessaire==true){
                        Recap.innerHTML = DeleteDeluxe_PagesCount;
                        DeleteDeluxe_GetPages(TitrePage, AutreRequeteContinue);
                  }else{
                        Recap.innerHTML = '<b>'+DeleteDeluxe_PagesCount+'</b>';
                  }
            }
      }
}


//</nowiki></pre></source>{{Boîte déroulante fin}}