//<source lang=javascript>
//<pre><nowiki>
/*
Fonction : traduire les liens d'un article à partir des correspondances interwiki.

*/

// ---------------------------- VARIABLES ----------------------------------- //

var LinkTranslate_SubPagePath = "/Traduction/Encours"

var LinkTranslate_AllLanguages = new Array();
LinkTranslate_AllLanguages.push("de");
LinkTranslate_AllLanguages.push("en");
LinkTranslate_AllLanguages.push("es");
LinkTranslate_AllLanguages.push("fr");
LinkTranslate_AllLanguages.push("it");
LinkTranslate_AllLanguages.push("pt");
LinkTranslate_AllLanguages.push("ru");

var LinkTranslate_DefaultLanguage = "fr";

// ---------------------------- FONCTIONS ----------------------------------- //

///////////////// LANCEMENT ////////////////////////////////////

if((wgNamespaceNumber>-1)&&((wgAction=="view")||(wgAction=="purge"))){
     addOnloadHook(LinkTranslate_AddLink);
}

///////////////// CREATION LIEN ////////////////////////////////////

function LinkTranslate_AddLink(){
     var Titre = document.getElementById("firstHeading");
     if(!Titre) Titre = document.getElementsByTagName('h1')[0];
     if(!Titre) return;

     if(typeof(LinkTranslate_UserCustom)=="function") LinkTranslate_UserCustom();

     var Small = document.createElement("small");
     var Link = document.createElement("a");
     Link.title="Afficher le menu de traduction";
     Link.href="javascript:LinkTranslate_MakeMenu();";
     Link.innerHTML = "Traduire";
     Small.setAttribute("style", "text-size:50% !important");
     Small.appendChild(Link);     
     Titre.appendChild(document.createTextNode(" "));
     Titre.appendChild(Small);
}

///////////////// CREATION MENU ////////////////////////////////////

function LinkTranslate_MakeMenu(){
     if(document.getElementById("LinkTranslate_Menu")) return;

     var Titre = document.getElementById("firstHeading");
     if(!Titre) Titre = document.getElementsByTagName('h1')[0];
     if(!Titre) return;

     var MenuPages = document.createElement('div');
     MenuPages.id = "LinkTranslate_Menu";

     var CurrentLanguage = document.getElementsByTagName('html')[0].getAttribute('lang');

     var LangToTranslate = document.createElement("select");
     LangToTranslate.id = "LangToTranslate_Select";
     LangToTranslate.title = "Langue d'origine";
     var LangToTranslateOption = document.createElement('option');
     LangToTranslateOption.value = CurrentLanguage;
     LangToTranslateOption.innerHTML = CurrentLanguage;
     LangToTranslateOption.disabled = "disabled";
     LangToTranslateOption.selected = "selected";
     LangToTranslate.appendChild(LangToTranslateOption);


     var PageToTranslate = document.createElement("input");
     PageToTranslate.type = "text";
     PageToTranslate.size = 50;
     PageToTranslate.id = "PageToTranslate_Input";
     PageToTranslate.title = "Page d'origine";
     PageToTranslate.value = wgPageName.replace(/_/g, " ");
     PageToTranslate.onkeyup = function(){
          LinkTranslate_GetSuggest();
     }

     var TranslatedLang = document.createElement("select");
     TranslatedLang.id = "TranslatedLang_Select";
     TranslatedLang.title = "Langue d'arrivée";
     for(var a=0;a<LinkTranslate_AllLanguages.length;a++){
          if(LinkTranslate_AllLanguages[a]!=CurrentLanguage){
               var NewOption = document.createElement('option');
               NewOption.value = LinkTranslate_AllLanguages[a];
               NewOption.innerHTML = LinkTranslate_AllLanguages[a];
               if(LinkTranslate_AllLanguages[a]==LinkTranslate_DefaultLanguage) NewOption.selected = "selected";
               TranslatedLang.appendChild(NewOption);
          }
     }


     var TranslatedPage = document.createElement("input");
     TranslatedPage.type = "text";
     TranslatedPage.size = 50;
     TranslatedPage.id = "TranslatedPage_Input";
     TranslatedPage.title = "Page d'arrivée";
     TranslatedPage.value = wgFormattedNamespaces[2]+":"+wgUserName+LinkTranslate_SubPagePath

     var OKInput = document.createElement("input");
     OKInput.type = "button";
     OKInput.value = "Valider";
     OKInput.onclick = function(){ LinkTranslate_CheckMenu(); };
     OKInput.onselect = function(){ LinkTranslate_CheckMenu(); };

     var CancelInput = document.createElement("input");
     CancelInput.type = "button";
     CancelInput.value = "Annuler";
     CancelInput.onclick = function(){ LinkTranslate_HideMenu(); };
     CancelInput.onselect = function(){ LinkTranslate_HideMenu(); };


     var ControlPanel = document.createElement("div");
     ControlPanel.id = "MenuControlPanel"

     MenuPages.appendChild(LangToTranslate);
     MenuPages.appendChild(PageToTranslate);
     MenuPages.appendChild(document.createElement("br"));
     MenuPages.appendChild(TranslatedLang);
     MenuPages.appendChild(TranslatedPage);
     MenuPages.appendChild(document.createElement("br"));
     MenuPages.appendChild(OKInput);
     MenuPages.appendChild(CancelInput);
     MenuPages.appendChild(ControlPanel);

     Titre.parentNode.insertBefore(MenuPages, Titre.nextSibling);
     PageToTranslate.focus();
}

function LinkTranslate_HideMenu(){
     var MenuPages = document.getElementById("LinkTranslate_Menu");
     if(MenuPages) MenuPages.parentNode.removeChild(MenuPages);
}

///////////////// VERIF MENU ////////////////////////////////////

function LinkTranslate_CheckMenu(){
     var PageToTranslateElement = document.getElementById('PageToTranslate_Input');
     var LangToTranslateElement = document.getElementById('LangToTranslate_Select');
     var TranslatedPageElement = document.getElementById('TranslatedPage_Input');
     var TranslatedLangElement = document.getElementById('TranslatedLang_Select');
     if((!PageToTranslateElement)||(!LangToTranslateElement)||(!TranslatedPageElement)||(!TranslatedLangElement)) return;

     var PageToTranslate = PageToTranslateElement.value;
     var LangToTranslate = LangToTranslateElement.value;
     var TranslatedPage = TranslatedPageElement.value;
     var TranslatedLang = TranslatedLangElement.value;

     var Confirmation = confirm('Page à traduire : '+PageToTranslate
                              + '\nLangue à traduire : '+LangToTranslate
                              + '\nPage traduite : '+TranslatedPage
                              + '\nLangue finale : '+TranslatedLang
                                );
     if(Confirmation){
          for(var Type in LinkTranslate_Lists){
               LinkTranslate_GetAllLinks(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, Type);
          }
     }
}

var LinkTranslate_Lists = [
  "Links"      : {generator:"links",      limit:"gpllimit", tag:"page", continueparam:"gplcontinue", iwList:new Array() },
  "Categories" : {generator:"categories", limit:"gcllimit", continueparam:"gclcontinue", iwList:new Array() },
  "Templates"  : {generator:"templates",  limit:"gtllimit", continueparam:"gtlcontinue", iwList:new Array() }
];

///////////////// LISTAGE LIENS ////////////////////////////////////

function LinkTranslate_GetAllLinks(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, Type, ContinueValue){
      if(!ContinueValue) ContinueValue = "";     
      var ControlPanel = document.getElementById("MenuControlPanel");
      if(ControlPanel) ControlPanel.innerHTML = "Listage : " + Type;
      var APILimit = ( (wgUserGroups.indexOf("bot")!=-1||wgUserGroups.indexOf("sysop")!=-1) ? 4999 ? 499);

      var NouvelleRequete = sajax_init_object()
      var AdresseRequete = wgServer + wgScriptPath + '/api.php?format=xml&action=query'
                         + '&generator='+LinkTranslate_Lists[Type].generator
                         + '&'+LinkTranslate_Lists[Type].limit+'=' + APILimit 
                         + ContinueValue
                         + '&titles='+encodeURIComponent(PageToTranslate);
      NouvelleRequete.open("GET", AdresseRequete, true);
      NouvelleRequete.onreadystatechange = function() {
            if(NouvelleRequete.readyState == 4) {
                  var ObjetXML = NouvelleRequete.responseXML; 
                  if(!ObjetXML){
                        alert('La requête API a échoué :\n'+AdresseRequete);
                        return;
                  }
                  var Tags = ObjetXML.getElementsByTagName(LinkTranslate_Lists[Type].tag);
                  for(var a=0;a<Tags.length;a++){
                        var Title = Tags[a].getAttribute('title');
                        var ThisLinkIsRed = Tags[a].getAttribute('missing');
                        if(!ThisLinkIsRed) AllLinks.push(ThisLink);
                  }
                  var MustContinue = document.getElementsByTagName('query-continue')[0];
                  if(MustContinue){
                        var LinkContinue = "&"+LinkTranslate_Lists[Type].continueparam+"="
                            + encodeURIComponent(MustContinue.firstChild.getAttribute(LinkTranslate_Lists[Type].continueparam));
                        LinkTranslate_GetAllLinks(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks, Type, LinkContinue)
                  }else{
                        LinkTranslate_GetPageInterwiki(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks);
                  }
            }
      }
      NouvelleRequete.send(null);
}


///////////////// RECHERCHE INTERWIKI ////////////////////////////////////

function LinkTranslate_GetPageInterwiki(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks, position, AllInterwikis){
      if(!position) position = 0;
      if(!AllInterwikis) AllInterwikis = new Array();
      var Page = AllLinks[position];
      if(!Page){
            LinkTranslate_DoTranslation(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks, AllInterwikis);
            return;
      }

      var ControlPanel = document.getElementById("MenuControlPanel");
      if(ControlPanel&&position==0) ControlPanel.innerHTML = "Recherche des interwikis : "

      if(ControlPanel) ControlPanel.innerHTML += "<br/>* " + Page;

      var APILimit = 499;
      if((wgUserGroups=="bot")||(wgUserGroups=="sysop")) APILimit = 4999;

      var NouvelleRequete = sajax_init_object()
      var AdresseRequete = wgServer + wgScriptPath + '/api.php?format=xml&action=query&prop=langlinks&lllimit='+APILimit+'&titles='+Page+'&redirects';
      NouvelleRequete.open("GET", AdresseRequete, true);
      NouvelleRequete.onreadystatechange = function() {
            if(NouvelleRequete.readyState == 4) {
                  var ObjetXML = NouvelleRequete.responseXML; 
                  if(!ObjetXML){
                        alert('La requête API a échoué :\n'+AdresseRequete);
                        return;
                  }
                  var TheLangLink = false;
                  var LangLinks = ObjetXML.getElementsByTagName('ll');
                  for(var a=0;a<LangLinks.length;a++){
                        var ThisLang = LangLinks[a].getAttribute("lang");
                        if(ThisLang == TranslatedLang){
                              TheLangLink = LangLinks[a].firstChild.nodeValue;
                        }
                  }
                  if(ControlPanel) ControlPanel.innerHTML += " : "+TheLangLink;
                  AllInterwikis.push(TheLangLink);
                  LinkTranslate_GetPageInterwiki(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks, (position+1), AllInterwikis)
            }
      }
      NouvelleRequete.send(null);
}


///////////////// TRADUCTION DES LIENS ////////////////////////////////////

function LinkTranslate_DoTranslation(PageToTranslate, LangToTranslate, TranslatedPage, TranslatedLang, AllLinks, AllInterwikis){

      var ControlPanel = document.getElementById("MenuControlPanel");
      if(ControlPanel) ControlPanel.innerHTML = "Traduction";

      var NouvelleRequete_1 = sajax_init_object()
      var AdresseRequete_1 = wgServer + wgScript + '?title='+PageToTranslate.replace(/&/g, "%26")+'&action=raw';
      NouvelleRequete_1.open("GET", AdresseRequete_1, true);
      NouvelleRequete_1.onreadystatechange = function() {
            if(NouvelleRequete_1.readyState == 4) {
                  var PageToTranslateContent = NouvelleRequete_1.responseText; 
                  for(var a=0;a<AllLinks.length;a++){
                        if(AllInterwikis[a]){
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].ucFirst()+"|").join("[["+AllInterwikis[a].ucFirst()+"|");
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].lcFirst()+"|").join("[["+AllInterwikis[a].lcFirst()+"|");
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].ucFirst()+"]]").join("[["+AllInterwikis[a].ucFirst()+"]]");
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].lcFirst()+"]]").join("[["+AllInterwikis[a].lcFirst()+"]]");
                        }else{
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].ucFirst()+"]]").join("{{Lien|"+AllLinks[a].ucFirst() + (LangToTranslate!="en" ? "|lang="+LangToTranslate : "") +  "}}");
                              PageToTranslateContent = PageToTranslateContent.split("[["+AllLinks[a].lcFirst()+"]]").join("{{Lien|"+AllLinks[a].lcFirst() + (LangToTranslate!="en" ? "|lang="+LangToTranslate : "") + "}}");
                              var LinkRegExp = new RegExp("\\[\\["+AllLinks[a]+"[^\\]]+\\]\\]", "ig");
                              var Links = PageToTranslateContent.match(LinkRegExp);
                              if(Links!=null){
                                    for(var b=0;b<Links.length;b++){
                                          var ThisLink = Links[b];
                                          var ThisLinkContent = ThisLink.split('[[').join('').split(']]').join('');
                                          //alert("Match :\n"+ ThisLink);
                                          var TextLink = ThisLinkContent.replace(/.*\|/g, "");
                                          var PageLink = ThisLinkContent.replace(/\|.*/g, "");
                                          var ReplacedLink =  ThisLink.split("[["+ThisLinkContent+"]]").join("{{Lien|" +PageLink + (TextLink!="" ? "|texte="+TextLink : "") + "|trad="+ PageLink + (LangToTranslate!="en" ? "|lang="+LangToTranslate : "") +  "}}");
                                          //alert("Replace :\n" + ThisLink + " -> " + ReplacedLink);
                                          PageToTranslateContent = PageToTranslateContent.replace(ThisLink, ReplacedLink);
                                    }
                              }
                        }
                  }
                  var NouvelleRequete_2 = sajax_init_object()
                  var AdresseRequete_2 = wgServer + wgScript + '?title='+TranslatedPage.replace(/&/g, "%26")+'&action=edit';
                  NouvelleRequete_2.open("GET", AdresseRequete_2, true);
                  NouvelleRequete_2.onreadystatechange = function() {
                        if(NouvelleRequete_2.readyState == 4) {
                              while(document.body.firstChild){ document.body.removeChild(document.body.firstChild); }
                              document.body.innerHTML = NouvelleRequete_2.responseText; 
                              var TextArea = document.getElementById("wpTextbox1");
                              if(!TextArea){ alert('Pas trouvé la zone d\'édition'); return; }
                              TextArea.value = PageToTranslateContent;
                              document.getElementById("wpSummary").value = "Traduction [["+PageToTranslate+"]] : "+LangToTranslate+" -> "+TranslatedLang;
                        }
                  }
                  NouvelleRequete_2.send(null);
            }
      }
      NouvelleRequete_1.send(null);
}

///////////////// PREMIÈRE LETTRE EN MAJUSCULE ////////////////////////////////////
 
String.prototype.ucFirst = function () {
    return this.substr(0,1).toUpperCase() + this.substr(1,this.length);
}
 
///////////////// PREMIÈRE LETTRE EN MINUSCULE ////////////////////////////////////
 
String.prototype.lcFirst = function () {
    return this.substr(0,1).toLowerCase() + this.substr(1,this.length);
}

///////////////// SUGGESTIONS API ////////////////////////////////////

var LinkTranslate_Suggest_Size = 5


function LinkTranslate_GetSuggest(){
    var Input = document.getElementById("PageToTranslate_Input");
    if(!Input) return;
    var ApNamespace = 0;
    var APNamespaceName = "";
    var Value = Input.value;
    for(var NS in wgFormattedNamespaces){
        var NamespaceName = wgFormattedNamespaces[NS];
        if((NS>0)&&(Value.indexOf(NamespaceName+":")!=-1)){
            APNamespaceName = NamespaceName+":";
            ApNamespace = NS;
            Value = Value.split(APNamespaceName).join('');
        }
    }
    var Adresse = wgServer + wgScriptPath+ '/api.php?format=xml&action=query&list=allpages&apfilterredir=nonredirects&aplimit='+LinkTranslate_Suggest_Size+'&apnamespace='+ApNamespace+'&apprefix='+Value;
    //alert(Adresse);
    var NouvelleRequete = sajax_init_object()
    NouvelleRequete.open("GET", Adresse, true);
    NouvelleRequete.onreadystatechange = function() {
        if(NouvelleRequete.readyState != 4) return;
        var ObjetXML = NouvelleRequete.responseXML;
        var PageNames = new Array();
        var Pages = ObjetXML.getElementsByTagName('p');
        for(var a=0;a<Pages.length;a++){
            var PageName = Pages[a].getAttribute('title')
            PageNames.push(PageName);
        }
        LinkTranslate_ShowSuggest(Input, PageNames);
    }
    NouvelleRequete.send(null);
}

function LinkTranslate_ShowSuggest(Input, PageNames){
    var LastSelect = document.getElementById("Translate_Suggest");
    if(LastSelect) LastSelect.parentNode.removeChild(LastSelect);
    if(PageNames.length==0) return;

    var Size = LinkTranslate_Suggest_Size
    if (PageNames.length < LinkTranslate_Suggest_Size) {
        Size = PageNames.length;
    }
    var listh = Size * 20 ;

    var nl = parseInt ( Input.offsetLeft ) - 1 ;
    var nt = parseInt(Input.offsetTop) - listh ;


    var NewSelect = document.createElement('select');
    NewSelect.id = "Translate_Suggest";
    NewSelect.size = Size ;
    NewSelect.style.align = "left" ;
    NewSelect.style.zIndex = 5 ;
    NewSelect.style.position = "absolute" ;
    NewSelect.style.top = nt + "px" ;
    NewSelect.style.width = Input.offsetWidth + "px" ;
    NewSelect.style.height = listh + "px" ;
    NewSelect.style.left = nl + "px" ;
    NewSelect.onkeyup = LinkTranslate_KeypressedOnSuggest;
    NewSelect.onchange = LinkTranslate_ReplaceSuggest;
    NewSelect.style.display = "block" ;
    for ( var i = 0 ; i < PageNames.length ; i++ ) {
        var opt = document.createElement ( "option" ) ;
        var ot = document.createTextNode ( PageNames[i] ) ;
        opt.appendChild ( ot ) ;
        opt.value = PageNames[i];
        NewSelect.appendChild ( opt ) ;
    }  
    Input.parentNode.insertBefore(NewSelect,Input);
}

function LinkTranslate_KeypressedOnSuggest(e){
    if (!e) var e = window.event;
    if (e.keyCode != 13) return;
    LinkTranslate_ReplaceSuggest();
}
 
// REMPLACEMENT DU CHAMP DE TEXTE PAR UNE SUGGESTION
 
function LinkTranslate_ReplaceSuggest(){
    var Text = document.getElementById("PageToTranslate_Input");
    var TextValue = Text.value;
    var List = document.getElementById("Translate_Suggest");
    var Options = List.getElementsByTagName('option');
    for(var a=0;a<Options.length;a++){
        if(Options[a].selected){
            var ListValue = Options[a].value;
            Text.value = ListValue;
            LinkTranslate_GetSuggest() ;
            Text.focus();
            return;
        }
    }
}




//</nowiki></pre></source>