/*
== Code JavaScript ==
 
* Licence : Domaine public

{{Projet:JavaScript/Script}} 

{{Boîte déroulante début|titre=Maintenance catégorie}}<!--
*/
// --><source lang=javascript>
// <nowiki>

//////////////////////////////////////////////////////////////////////// VARIABLES ////////////////////////////////////////////////////

/* Tableau de statistiques */

var CatMaintenance_DebutModeleStats = '<!-- Ce tableau est créé automatiquement par un robot. Maintenance de catégorie Statistiques DEBUT -->\n';

var CatMaintenance_TableauStats = '{| class="wikitable centre"\n'
                                 +'|-\n'
                                 +'! Pages sans bandeau d\'ébauche || {{Avancement|{{#expr:($1)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages sans bandeaux d\'avertissement || {{Avancement|{{#expr:($2)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec bandeau de portail || {{Avancement|{{#expr:($3)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec images || {{Avancement|{{#expr:($4)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages sans liens rouges || {{Avancement|{{#expr:($5)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec catégories || {{Avancement|{{#expr:($6)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec liens inter-langues || {{Avancement|{{#expr:($7)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec liens inter-projets || {{Avancement|{{#expr:($8)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|-\n'
                                 +'! Pages avec références || {{Avancement|{{#expr:($9)/(TOTAL)*100 round 0}}|||||||1}}\n'
                                 +'|}\n'

var CatMaintenance_FinModeleStats = '<!-- Ce tableau est créé automatiquement par un robot. Maintenance de catégorie Statistiques FIN -->\n';

/* Modèle ajouté par défaut : début et fin de cadre défilant */

var CatMaintenance_ModeleDefautDebut = '{{Maintenance de catégorie\n'
                  + '|portail=$1\n'
                  + '|page=$2\n'
                  + '|catégorie=$3\n'
                  + '|défilant=oui\n'
                  + '|hauteur=250\n'
                  + '}}\n'

var CatMaintenance_ModeleDefautFin = '{{Maintenance de catégorie fin}}\n';


/* Tableau de statistiques détaillées */

var  CatMaintenance_DebutModele = '<!-- Ce tableau est créé automatiquement par un robot. Maintenance de catégorie DEBUT -->\n';

var CatMaintenance_DebutTableauTriable = '{| class="wikitable centre sortable" width="100%"\n'
                                       + '|+ \'\'Catégorie : \'\'\'[[:$1|$2]]\'\'\' - $3 pages - Tableau [[Modèle:Maintenance de catégorie/Documentation|mis à jour]] le $4/$5/$6 à $7:$8\'\'\n'
                                       + '|-\n'
                                       + '! Page<br/>\n'
                                       + '! Ébauche<br/>\n'
                                       + '! Bandeaux d\'avertissement<br/>\n'
                                       + '! Bandeaux de portail<br/>\n'
                                       + '! Images<br/>\n'
                                       + '! Liens rouges<br/>\n'
                                       + '! Catégories<br/>\n'
                                       + '! Inter-langues<br/>\n'
                                       + '! Inter-projets<br/>\n'
                                       + '! Références<br/>\n'

var CatMaintenance_FinModele = '<!-- Ce tableau est créé automatiquement par un robot. Maintenance de catégorie FIN -->\n';

/* Résumé de modification */

var CatMaintenance_ResumeModif = 'Mise à jour du modèle {{Maintenance de catégorie}} - Catégorie : [[:$1]]';


var CatMaintenance_StartButton = '<img height="50" width="50" src="http://upload.wikimedia.org/wikipedia/commons/thumb/4/4a/Crystal_Clear_action_exit.svg/50px-Crystal_Clear_action_exit.svg.png" alt="Lancer la mise à jour">';
 
var CatMaintenance_WorkingButton = '<img height="50" width="50" src="http://upload.wikimedia.org/wikipedia/commons/d/de/Ajax-loader.gif" alt="Mise à jour en cours">';



//////////////////////////////////////////////////////////////////////// FIN DES VARIABLES ////////////////////////////////////////////////////

/* ************************************************************************************************************************************ 
Lancement 
*/

if( (wgAction!="edit")&&(wgAction!="submit") ){
     addOnloadHook(CatMaintenance_makeUpdateLinks);
}

/* ************************************************************************************************************************************ 
1- recherche des modèles {{Maintenance de catégorie}} de la page courante
2- ajout des liens de mise à jour
*/

function CatMaintenance_makeUpdateLinks(){
     var count=-1;
     var Cadres = document.getElementsByTagName('div');
     for(s=0;s<Cadres.length;s++){
            if( hasClass(Cadres[s], 'categoryMaintenance') ){          
                  count++
                  Cadres[s].id = 'categoryMaintenance_'+count;
                  var ParamCategorie = Cadres[s].firstChild.innerHTML;
                  var ParamPage = Cadres[s].firstChild.title;
                  var NewButton = '<a id="categoryMaintenanceLink_'+count+'" href="javascript:CatMaintenance_GetParams('+count+');" title="Cliquer pour  mettre à jour l\'analyse de la catégorie ' + ParamCategorie + ' sur la page '+ParamPage+'" >'+CatMaintenance_StartButton+'</a>' ;
                  Cadres[s].innerHTML += NewButton ;
            }
     }
}

function CatMaintenance_GetParams(index){
     var Modele = document.getElementById('categoryMaintenance_'+index);
     if(!Modele) return;
     var Cadre = Modele.firstChild;
     if(!Cadre) return;
     var ParamCategorie = Cadre.innerHTML;
     var ParamPage = Cadre.title;
     var ParamPortail = Cadre.className;
     if(ParamPortail!='') ParamPortail = "Portail:" + ParamPortail.replace(/_/g, " ");
     var Pop = 'Catégorie à vérifier :\n'
             + '* '+ParamCategorie+'\n\n'
             + 'Page à mettre à jour :\n'
             + '* '+ParamPage+'\n\n'
             + 'Projet de référence :\n'
             + '* '+ParamPortail+'\n\n'
             + 'Continuer ?';
     var SurEtCertain = confirm(Pop);
     if(SurEtCertain){
          Modele.innerHTML += '<br /><span id="WorkingFunction" ></span><br /><span id="WorkingPage" ></span>';
          CatMaintenance_CheckCategory(ParamPage, ParamCategorie, ParamPortail);
          var Lien = document.getElementById('categoryMaintenanceLink_'+index)
          if(Lien){
               Lien.innerHTML = CatMaintenance_WorkingButton ;
               Lien.title = "Arrêter la mise à jour" ;
               Lien.href = "javascript:window.location.reload();";
               Lien.blur();
          }
     }
}

// ///////////////////////////////////////////////////// REQUÊTE PAGES DE LA CATÉGORIE /////////////////////////
 
function CatMaintenance_CheckCategory(ParamPage, ParamCategorie, ParamPortail, ParamContinue, PageList){
      if(!PageList) PageList = new Array();
      if(!ParamContinue) ParamContinue='';
      if( (wgUserGroups.indexOf("sysop")!=-1)||(wgUserGroups.indexOf("bot")!=-1) ){
           var APILimit=4999;
      }else{
           var APILimit=499;
      }
 
      document.getElementById('WorkingFunction').innerHTML = "Listage des pages";
      document.getElementById('WorkingPage').innerHTML = ParamCategorie;
      var NouvelleRequete = sajax_init_object()
      var AdresseRequete = wgServer + '/w/api.php?action=query&list=categorymembers&cmlimit='+APILimit+'&cmtitle=' + ParamCategorie.replace(/&/g,"%26") + '&cmcontinue=' + ParamContinue;
      //alert(AdresseRequete);
      NouvelleRequete.open("GET", AdresseRequete, true);
      NouvelleRequete.onreadystatechange = function() {
            if(NouvelleRequete.readyState != 4 || NouvelleRequete.status != 200) return;
            var ElementTraitement = document.createElement('div');
            ElementTraitement.innerHTML = NouvelleRequete.responseText; 
            var Informations = ElementTraitement.getElementsByTagName('span');
            var AutreRequeteNecessaire = false;
            for(a=0;a<Informations.length;a++){
                  var ContenuInformation = Informations[a].innerHTML;
                  if((ContenuInformation.indexOf('ns="0"')!=-1)||(ContenuInformation.indexOf('ns="1"')!=-1)){
                        var TitrePage = ContenuInformation.split('title="')[1].split('"')[0];
                        TitrePage = CatMaintenance_Clean(TitrePage);
                        PageList.push(TitrePage);
                  }
                  if(ContenuInformation.indexOf('cmcontinue=')!=-1){
                        AutreRequeteNecessaire = true;
                        var AutreRequeteContinue = ContenuInformation.split('cmcontinue="')[1].split('"')[0];
                        AutreRequeteContinue = CatMaintenance_Clean(AutreRequeteContinue);
                  }
            } 
            if(AutreRequeteNecessaire==true){
                  CatMaintenance_CheckCategory(ParamPage, ParamCategorie, ParamPortail, AutreRequeteContinue, PageList);
            }else{
                  CatMaintenance_CheckPage(0, ParamPage, ParamCategorie, ParamPortail, PageList);
            }
      }
      NouvelleRequete.send(null);
}


/* ************************************************************************************************************************************ 
Analyse de la page : 
1- requête ajax, 
2- recopie les infos recherchées dans le tableau de bord sous chaque lien
3- lancement de l'analyse de la page suivante
4- si la page n'existe pas, lancement de la fonction d'édition
*/

var CatMaintenance_checkedPage = -1;
var CatMaintenance_Result = new Array();

var CatMaintenance_NBPageEbauche = 0;
var CatMaintenance_NBPageAvert = 0;
var CatMaintenance_NBPagePortail = 0;
var CatMaintenance_NBPageImage = 0;
var CatMaintenance_NBPageLiensRouges = 0;
var CatMaintenance_NBPageCat = 0;
var CatMaintenance_NBPageInterwiki = 0;
var CatMaintenance_NBPageInterProjets = 0;
var CatMaintenance_NBPageReferences = 0;

function CatMaintenance_CheckPage(Position, ParamPage, ParamCategorie, ParamPortail, PageList){

      var TitrePage = PageList[Position];
      if(!TitrePage){
            CatMaintenance_EditPage(ParamPage, ParamCategorie, ParamPortail, PageList);
      }
      TitrePage = TitrePage.split(wgFormattedNamespaces[1]+":").join(""); 

      document.getElementById('WorkingFunction').innerHTML = "Analyse des pages";
      document.getElementById('WorkingPage').innerHTML = TitrePage;
      var ajaxRequest = sajax_init_object();
      var AdresseRequete = wgServer + wgScript + '?title=' + TitrePage.replace(/&/g, "%26") + '' ;
      //alert(AdresseRequete);
      ajaxRequest.open("GET", AdresseRequete, true);
      ajaxRequest.onreadystatechange = function() {
            if(ajaxRequest.readyState != 4 || ajaxRequest.status != 200) return;
            var CatMaintenance_PageRequete = document.createElement('div');    
            CatMaintenance_PageRequete.style.display = 'none';
            CatMaintenance_PageRequete.innerHTML = ajaxRequest.responseText;
            CatMaintenance_checkedPage++
            CatMaintenance_Result[CatMaintenance_checkedPage] = '|-------------------------------- <!-- ***** '
                                                              + decodeURIComponent(TitrePage)+' ***** -->\n'
                                                              + '| valign="top" | [['+decodeURIComponent(TitrePage)+']]';

            var Content = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'bodyContent');
            if(!Content) Content = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'mw_contentholder');
            if(!Content) Content = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'article');
            if(!Content) Content = CatMaintenance_PageRequete;
// Recherche de bandeaux d'avertissement ------------------------------------------------------------------------------------------------------------

            bandeau = 'green';
            Listebandeaux = '';
            Ebauche = '\n| valign="top" align="center" | non\n';
            NbBandeaux = 0;
            var Bandeaux = Content.getElementsByTagName('div'); 
            for(b=0;b<Bandeaux.length;b++){
                  if( hasClass(Bandeaux[b], "bandeau-niveau-grave") ){ 
                        NbBandeaux++
                        bandeau = 'red';
                        var BandeauLinkTitle = getTextContent(Bandeaux[b].getElementsByTagName('strong')[0]); 
                        Listebandeaux += '\n* \'\'\'{{Citation|{{Coloré|red|'+BandeauLinkTitle+'}}}}\'\'\'';
                  }
                  if( hasClass(Bandeaux[b], "bandeau-niveau-modere") ){
                        NbBandeaux++
                        if(bandeau!='red') bandeau = '#cb8500';
                        var BandeauLinkTitle = getTextContent(Bandeaux[b].getElementsByTagName('strong')[0]); 
                        Listebandeaux += '\n* \'\'\'{{Citation|{{Coloré|#cb8500|'+BandeauLinkTitle+'}}}}\'\'\'';
                  }
                  if( hasClass(Bandeaux[b], "bandeau-niveau-ebauche") ){
                        var BandeauLinkTitle = getTextContent(Bandeaux[b].getElementsByTagName('strong')[0]); 
                        Ebauche = '\n| valign="top" align="center" | [[File:Panneau travaux.svg|15px|'+BandeauLinkTitle+']]\n';
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += Ebauche+'| valign="top" align="left" | '+Listebandeaux+'\n\n';

            if(Ebauche=='\n| valign="top" align="center" | non\n') CatMaintenance_NBPageEbauche++
            if(Listebandeaux == '') CatMaintenance_NBPageAvert++

// Recherche du bandeau de portail ------------------------------------------------------------------------------------------------------------

            bandeau = "red";
            Listebandeaux = "";
            NbBandeaux = 0;
            var Bandeaux = Content.getElementsByTagName('span'); 
            for(b=0;b<Bandeaux.length;b++){
                  if( hasClass(Bandeaux[b], "bandeau-portail-texte") ){ 
                        NbBandeaux++
                        var BandeauLinkTitle = Bandeaux[b].firstChild.title; 
                        if( BandeauLinkTitle.indexOf(ParamPortail) != -1  ){
                              bandeau = 'green';
                              Listebandeaux += '\n* \'\'\'⇨ [['+BandeauLinkTitle+']]\'\'\'';
                        }else{
                              Listebandeaux += '\n* <small>[['+BandeauLinkTitle+']]</small>';
                        }
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="left" | '+Listebandeaux+'\n';
            if(NbBandeaux!=0) CatMaintenance_NBPagePortail++

// Recherche des images ------------------------------------------------------------------------------------------------------------

            image = "red";
            NbImages = 0;
            var TousImages = Content.getElementsByTagName('img');
            for(a=0;a<TousImages.length;a++){                                     
                  var ImageLinkHref = decodeURIComponent(TousImages[a].parentNode.href);              
                  var ImageLinkTitle = TousImages[a].alt;              
                  var ImageLink = ImageLinkHref.split(wgServer + '/wiki/').join('');  
                  if( hasClass(TousImages[a].parentNode, "image") ){
                        var ImageWidth = parseInt(TousImages[a].width);
                        if(ImageWidth>101){
                              image = "green";
                              NbImages++
                        }
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+image+'|'+NbImages+'}}\'\'\'\n'
            if(NbImages!=0) CatMaintenance_NBPageImage++

// Recherche des liens rouges ------------------------------------------------------------------------------------------------------------

            RedLink="green";
            NbRedLink = 0;
            var TousLiens = Content.getElementsByTagName('a');
            for(a=0;a<TousLiens.length;a++){
                  if( hasClass(TousLiens[a], "new") || (TousLiens[a].title.indexOf("(page inexistante)")!=-1) || (TousLiens[a].href.indexOf("&redlink=1")!=-1) ){
                        var WantedPageLink = TousLiens[a];
                        var WantedPageLinkTitle = WantedPageLink.title.split(' (page inexistante)').join(''); 
                        if( (WantedPageLinkTitle.indexOf(wgFormattedNamespaces[11])==-1) ){
                              NbRedLink++
                              RedLink="red";
                              if( (WantedPageLinkTitle.indexOf(wgFormattedNamespaces[6])!=-1)||(WantedPageLinkTitle.indexOf(wgFormattedNamespaces[14])!=-1)){
                                    WantedPageLinkTitle = ':' + WantedPageLinkTitle;
                              }
                        }
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+RedLink+'|'+NbRedLink+'}}\'\'\'\n'
            if(NbRedLink == 0) CatMaintenance_NBPageLiensRouges++

// Recherche des catégories ------------------------------------------------------------------------------------------------------------

            Cat="red";
            NbCat = 0;
            var CategorieNonCachees = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'mw-normal-catlinks'); // Catégories non-cachées seulement
            if(CategorieNonCachees){
                  var TousLiensCat = CategorieNonCachees.getElementsByTagName('a'); 
                  for(a=1;a<TousLiensCat.length;a++){
                        var LienHTML = TousLiensCat[a].innerHTML;
                        var LienTitle = TousLiensCat[a].title;
                        if( (LienHTML!='[+]') && (LienHTML!='(–)') && (LienHTML!='(±)') && (LienHTML!='(+)') ){   // Evitons les liens "catégories cachées" et "HotCats.js"
                              Cat="green";
                              NbCat++
                        }
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+Cat+'|'+NbCat+'}}\'\'\'\n'
            if(NbCat!=0) CatMaintenance_NBPageCat++

// Recherche des liens interlangues ------------------------------------------------------------------------------------------------------------

            Interwiki ="red";
            NbInterwiki = 0;
            var PanneauInterwiki = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'p-lang');
            if(PanneauInterwiki){
                  var TousLiensInterwiki = PanneauInterwiki.getElementsByTagName('a'); 
                  for(a=0;a<TousLiensInterwiki.length;a++){
                        var LienHTML = TousLiensInterwiki[a].innerHTML;
                        var LienHref = decodeURIComponent(TousLiensInterwiki[a].href);
                        Interwiki="green";
                        NbInterwiki++
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+Interwiki+'|'+NbInterwiki+'}}\'\'\'\n'
            if(NbInterwiki!=0) CatMaintenance_NBPageInterwiki++

// Recherche des liens inter-projet ------------------------------------------------------------------------------------------------------------

            Interprojet ="red";
            NbInterprojet = 0;
            var LiensCommons = Content.getElementsByTagName('div');
            for(a=0;a<LiensCommons.length;a++){
                  if( hasClass(LiensCommons[a], "wikilien_alternatif") ){
                        Interprojet="#cb8500";
                        NbInterprojet++
                  }
            }
            var PanneauAutresProjets = CatMaintenance_getElementWithId(CatMaintenance_PageRequete, 'div', 'autres_projets');
            if(PanneauAutresProjets){
                  var TousLiensInterprojet = PanneauAutresProjets.getElementsByTagName('a'); 
                  for(a=0;a<TousLiensInterprojet.length;a++){
                        var LienHTML = TousLiensInterprojet[a].innerHTML;
                        var LienHref = TousLiensInterprojet[a].href;
                        var LienClassName = TousLiensInterprojet[a].parentNode.className;
                        Interprojet="green";
                        NbInterprojet++
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+Interprojet+'|'+NbInterprojet+'}}\'\'\'\n'
            if(Interprojet=="green") CatMaintenance_NBPageInterProjets++


// Recherche références ------------------------------------------------------------------------------------------------------------
 
            NBReference = 0;
            ColorReference = "red";
                                
            var Ols = Content.getElementsByTagName('ol');
            if(Ols){
                  for(b=0;b<Ols.length;b++){
                        if(hasClass( Ols[b], 'references') ){ 
                              //alert('Trouvé références');
                              var ReferenceOl = Ols[b];
                              var NewReferences = ReferenceOl.getElementsByTagName('li');
                              if(NewReferences){
                                    NBReference = (NBReference + NewReferences.length);
                                    if(NBReference>0) ColorReference = "green";
                                    //alert(NBReference + ' - ' + ColorReference);
                              }
                        }
                  }
            }
            CatMaintenance_Result[CatMaintenance_checkedPage] += '| valign="top" align="center" | \'\'\'{{Coloré|'+ColorReference+'|'+NBReference+'}}\'\'\'\n'
            if(ColorReference=="green") CatMaintenance_NBPageReferences++

// Fin de l'analyse de la page ------------------------------------------------------------------------------------------------------------

            CatMaintenance_CheckPage((Position+1), ParamPage, ParamCategorie, ParamPortail, PageList);
      } 
      ajaxRequest.send(null);
}

/*******************************************************************************************************************
Édition de la page : 
1- crée les tableaux
1- cherche la présence des tableau précédents
3- remplacement ou ajout des tableaux existants
*/

function  CatMaintenance_EditPage(ParamPage, ParamCategorie, ParamPortail, PageList){
      document.getElementById('WorkingFunction').innerHTML = "Édition de la page";
      document.getElementById('WorkingPage').innerHTML = ParamPage;
      var ajaxRequest = sajax_init_object();
      var AdresseRequete = wgServer + wgScript + '?title=' + ParamPage.replace(/&/g, "%26") + '&action=edit';
      //alert(AdresseRequete);
      ajaxRequest.open("GET", AdresseRequete, true);
      ajaxRequest.onreadystatechange = function() {
            if(ajaxRequest.readyState != 4 ) return;
            while(document.body.firstChild){document.body.removeChild(document.body.firstChild);} 
            document.body.innerHTML = ajaxRequest.responseText;
            var ContenuPage = document.getElementById("wpTextbox1").value;

            var Aujourdhui = new Date();
            var Minutes   = Aujourdhui.getMinutes()
            if(Minutes<10){ var ZeroMinutes = "0" ; }else{ var ZeroMinutes = "";}
            var Heures   = Aujourdhui.getHours()
            if(Heures<10){ var ZeroHeures = "0" ; }else{ var ZeroHeures = "";}
            var Jour   = Aujourdhui.getDate();
            if(Jour<10){ var ZeroJour = "0" ; }else{ var ZeroJour = "";}
            var Mois = Aujourdhui.getMonth() + 1;
            if(Mois<10){ var ZeroMois = "0" ; }else{ var ZeroMois = "";}
            var Annee  = Aujourdhui.getYear();
            if (Annee < 2000){
                  Annee = Annee + 1900;
            }

/* Création du tableau de statistiques */

            var TableauStats = CatMaintenance_DebutModeleStats + CatMaintenance_TableauStats + CatMaintenance_FinModeleStats;
            TableauStats = TableauStats.split('$1').join(CatMaintenance_NBPageEbauche);
            TableauStats = TableauStats.split('$2').join(CatMaintenance_NBPageAvert);
            TableauStats = TableauStats.split('$3').join(CatMaintenance_NBPagePortail);
            TableauStats = TableauStats.split('$4').join(CatMaintenance_NBPageImage);
            TableauStats = TableauStats.split('$5').join(CatMaintenance_NBPageLiensRouges);
            TableauStats = TableauStats.split('$6').join(CatMaintenance_NBPageCat);
            TableauStats = TableauStats.split('$7').join(CatMaintenance_NBPageInterwiki);
            TableauStats = TableauStats.split('$8').join(CatMaintenance_NBPageInterProjets);
            TableauStats = TableauStats.split('$9').join(CatMaintenance_NBPageReferences);
            TableauStats = TableauStats.replace(/TOTAL/g, PageList.length);
                                
/* Création du tableau de statistiques détaillées */

            var TableauTriable = CatMaintenance_DebutModele + CatMaintenance_DebutTableauTriable;
            TableauTriable = TableauTriable.split('$1').join(ParamCategorie);
            TableauTriable = TableauTriable.split('$2').join(ParamCategorie.split('Catégorie:').join(''));
            TableauTriable = TableauTriable.split('$3').join(PageList.length);
            TableauTriable = TableauTriable.split('$4').join(ZeroJour + Jour);
            TableauTriable = TableauTriable.split('$5').join(ZeroMois + Mois);
            TableauTriable = TableauTriable.split('$6').join(Annee);
            TableauTriable = TableauTriable.split('$7').join(ZeroHeures + Heures);
            TableauTriable = TableauTriable.split('$8').join(ZeroMinutes + Minutes);
            for(a=0;a<CatMaintenance_Result.length;a++){
                  TableauTriable += CatMaintenance_Result[a];
            }
            TableauTriable += '|}\n' + CatMaintenance_FinModele;

/* Insertion tableau Triable */

            if( (ContenuPage.indexOf(CatMaintenance_DebutModele)!=-1)&&(ContenuPage.indexOf(CatMaintenance_FinModele)!=-1) ){
// Déja le tableau : remplacement
                  var debutTexte = ContenuPage.substring(0, ContenuPage.indexOf(CatMaintenance_DebutModele));
                  var AncienModele = ContenuPage.substring(0, ContenuPage.indexOf(CatMaintenance_FinModele)) + CatMaintenance_FinModele;
                  AncienModele = AncienModele.replace(debutTexte, "");       
                  var finTexte = ContenuPage.split(debutTexte).join('').split(AncienModele).join('');
                  var TexteFinal = debutTexte + TableauTriable + finTexte;
            }else{         
// Pas de tableau : ajout modèle + tableau
                  ParamPortail = ParamPortail.replace(/ /g, "_").split("Portail:").join('');
                  CatMaintenance_ModeleDefautDebut = CatMaintenance_ModeleDefautDebut.split('$1').join(ParamPortail);
                  CatMaintenance_ModeleDefautDebut = CatMaintenance_ModeleDefautDebut.split('$2').join(ParamPage);
                  CatMaintenance_ModeleDefautDebut = CatMaintenance_ModeleDefautDebut.split('$3').join(ParamCategorie);
                  var TexteFinal = CatMaintenance_ModeleDefautDebut + TableauTriable + CatMaintenance_ModeleDefautFin + ContenuPage;
            }

/* Insertion tableau Statistiques */

            if( (TexteFinal.indexOf(CatMaintenance_DebutModeleStats)!=-1)&&(TexteFinal.indexOf(CatMaintenance_FinModeleStats)!=-1) ){ 
// Déja le tableau : remplacement
                  debutTexte = TexteFinal.substring(0, TexteFinal.indexOf(CatMaintenance_DebutModeleStats));
                  AncienModele = TexteFinal.substring(0, TexteFinal.indexOf(CatMaintenance_FinModeleStats)) + CatMaintenance_FinModeleStats;
                  AncienModele = AncienModele.replace(debutTexte, "");       
                  finTexte = TexteFinal.split(debutTexte).join('').split(AncienModele).join('');
                  TexteFinal = debutTexte + TableauStats + finTexte;
            }else{         
// Pas de tableau : ajout
                  TexteFinal = TableauStats + TexteFinal;
            }

/* Publication */

            document.getElementById ("wpTextbox1").value = TexteFinal ;
            document.editform.wpSummary.value = CatMaintenance_ResumeModif.split('$1').join(ParamCategorie);
            document.editform.submit();
      }
      ajaxRequest.send(null);
}

// ///////////////////////////////////////////////////// NETTOYAGE REQUÊTES API /////////////////////////
 
function CatMaintenance_Clean(text){
      while(text.indexOf('&amp;')!=-1){
            text = text.split('&amp;').join("&");
            if(text.indexOf('&amp;')==-1) break;
      }
      while(text.indexOf('&#039;')!=-1){
            text = text.split('&#039;').join("'");
            if(text.indexOf('&#039;')==-1) break;
      }
      while(text.indexOf('&quot;')!=-1){
            text = text.split('&quot;').join('"');
            if(text.indexOf('&quot;')==-1) break;
      }
      while(text.indexOf('&nbsp;')!=-1){
            text = text.split('&nbsp;').join(' ');
            if(text.indexOf('&nbsp;')==-1) break;
      }  
      return text;
}

// ///////////////////////////////////////////////////// GET ELEMENT WITH ID /////////////////////////

function CatMaintenance_getElementWithId( elementParentNode , elementTagName , elementId ){
      if(!elementParentNode) elementParentNode = document; 
      var TheElement = false;
      var Elements = elementParentNode.getElementsByTagName(elementTagName);
      var elementcount = 0;
      while(elementcount<Elements.length){
            var Id = Elements[elementcount].id;
            if(Id){
                  if(Id.indexOf(elementId)!=-1){
                        TheElement = Elements[elementcount];
                  }
            }
            elementcount++
      }
      return TheElement;
}
// </nowiki>
//</source>{{Boîte déroulante fin}}