/*
{{Utilisateur:Dr Brains/onglets}}
MENU-ACTIONS

== Fonction ==
* Transforme les onglets en menu déroulants [[Discussion utilisateur:Dr Brains/MenuActions.js#Personnalisation|facilement personnalisables]]

Code original : [http://en.wikipedia.org/w/index.php?title=Wikipedia:WikiProject_User_scripts/Scripts/Compact_Navigation&oldid=231298438]

== Aperçu ==
{{Boîte déroulante début|couleurFondT=#aaaaaa|titre=demo}}
<gallery  perrow="6" >
Fichier:Demo MenuActions0.png|Menu de la page principale
Fichier:Demo MenuActions1.png|Menu de la page de discussion
Fichier:Demo MenuActions2.png|Menu actions
Fichier:Demo MenuActions3.png|Menu pages spéciales
Fichier:Demo MenuActions4.png|Menu recherche
Fichier:Demo MenuActions5.png|Menu favoris
</gallery>
{{message galerie}}
{{Boîte déroulante fin}}

== Installation ==
Pour installer ce menu, ajoutez à votre [[Special:Mypage/monobook.js|monobook.js]] le code suivant :
::<source lang=javascript >importScript('Utilisateur:Dr Brains/MenuActions.js');</source>

== Personnalisation ==
=== Pour ajouter un menu ===
Ajoutez à votre [[Special:Mypage/monobook.js|monobook.js]] le code suivant :
<source lang=javascript>
function nouveauMenuPerso(){
    var Cactions = document.getElementById('p-cactions').getElementsByTagName('ul')[0]; // Recherche des onglets
    addlimenu(Cactions,'TEXTE','ID','URL','POSITION');
}
addOnloadHook(nouveauMenuPerso);
</source> 
;avec : 
* TEXTE = texte de l'onglet ;
* ID = id du menu ;
* URL = adresse URL (optionnel) ;
* POSITION = place du menu (optionnel)

=== pour ajouter une entrée à un menu ===
Ajoutez à votre [[Special:Mypage/monobook.js|monobook.js]] le code suivant :
<source lang=javascript>
function nouveauLienPerso(){
     addMenuActionsLink('ID', 'URL', 'TEXTE');
}
addOnloadHook(nouveauLienPerso);
</source>
;avec : 
* ID = id du menu ; 
* URL = adresse URL de l'entrée ; 
* TEXTE = texte de l'entrée

=== pour ajouter de nombreux menus/liens ===
Créez une fonction telle que l'exemple ci-dessous
{{Boîte déroulante début|titre=exemple}}
<source lang=javascript >
function PersonaliseMenuActions(){
 
var pCactions = document.getElementById('p-cactions');
if(!pCactions)return;
var tabs = pCactions.getElementsByTagName('ul')[0];
var caMain = pCactions.getElementsByTagName('li')[0];
 
//////////////////////////////////////////// PARTIE PERSONNALISABLE ////////////////////////////////////////
 
////////////////// * nouveaux menus * //////////////////
 
MenuActions_PlusMenus = new Array();
MenuActions_PlusMenusTEXTE = new Array();
MenuActions_PlusMenusURL = new Array();
 
 
MenuActions_PlusMenus[0] = "MenuPlus1";                // Id du menu
MenuActions_PlusMenusTEXTE[0] =  "Menu Perso 1";    // Texte de l'onglet
MenuActions_PlusMenusURL[0] = "";                 // Cible de l'onglet
 
MenuActions_PlusMenus[1] = "MenuPlus2";                // Id du menu
MenuActions_PlusMenusTEXTE[1] =  "Menu Perso 2";    // Texte de l'onglet
MenuActions_PlusMenusURL[1] = "";                 // Cible de l'onglet
 
MenuActions_PlusMenus[2] = "MenuPlus3";                // Id du menu
MenuActions_PlusMenusTEXTE[2] =  "Menu Perso 3";    // Texte de l'onglet
MenuActions_PlusMenusURL[2] = "";                 // Cible de l'onglet
 
 
////////////////// * nouveaux liens * //////////////////
 
MenuActions_PlusID = new Array();
MenuActions_PlusTexte = new Array();  
MenuActions_PlusURL = new Array();
 
 
MenuActions_PlusID[0] = "MenuPlus1";                  // Id du menu
MenuActions_PlusTexte[0] = "Lien 1";             // Texte de la case
MenuActions_PlusURL[0] = "";                     // Cible de la case
 
MenuActions_PlusID[1] = "MenuPlus1";                  // Id du menu
MenuActions_PlusTexte[1] = "Lien 2";             // Texte de la case
MenuActions_PlusURL[1] = "";                     // Cible de la case
 
MenuActions_PlusID[2] = "MenuPlus3";                  // Id du menu
MenuActions_PlusTexte[2] = "Lien 3";             // Texte de la case
MenuActions_PlusURL[2] = "";                     // Cible de la case
 
MenuActions_PlusID[3] = "MenuPlus2";                  // Id du menu
MenuActions_PlusTexte[3] = "Lien 4";             // Texte de la case
MenuActions_PlusURL[3] = "";                     // Cible de la case
 
MenuActions_PlusID[4] = "MenuPlus1";                  // Id du menu
MenuActions_PlusTexte[4] = "Lien 5";             // Texte de la case
MenuActions_PlusURL[4] = "";                     // Cible de la case
 
//////////////////////////////////////////// FIN DE LA PARTIE PERSONNALISABLE ////////////////////////////////////////
 
// Ajout des onglets //
 
        for(a=0;a<MenuActions_PlusMenus.length;a++){
                if(MenuActions_PlusMenusTEXTE[a].length > 0){
                        var newMenu_1 = addlimenu(tabs,MenuActions_PlusMenusTEXTE[a],MenuActions_PlusMenus[a],MenuActions_PlusMenusURL[a]);
                        newMenu_1.className = caMain.className;
                }
        } 
 
//Ajout des liens //
 
        for(b=0;b<MenuActions_PlusID.length;b++){
                if(MenuActions_PlusTexte.length > 0){
                        addMenuActionsLink(MenuActions_PlusID[b], MenuActions_PlusURL[b], MenuActions_PlusTexte[b]); 
                }
        }   
 
}
addOnloadHook(PersonaliseMenuActions);
</source>
{{Boîte déroulante fin}}

== CODE SOURCE ==

{{Projet:JavaScript/Script}}
{{Boîte déroulante début|titre=Code source}}
<source lang=javascript>
// <nowiki>
// MENU-ACTIONS

== Fonction ==

* Transforme les onglets en menu déroulants [[Discussion utilisateur:Dr Brains/MenuActions.js#Fonction de personnalisation|Facilement personnalisables]]

Code original : [http://en.wikipedia.org/w/index.php?title=Wikipedia:WikiProject_User_scripts/Scripts/Compact_Navigation&oldid=231298438 ext]
*/

var MenuActions_navigateur =navigator.userAgent.toLowerCase();
var MenuActions_navigateur_ie = ((MenuActions_navigateur.indexOf("msie") != -1) && (MenuActions_navigateur.indexOf("opera") == -1));
 
if(!MenuActions_navigateur_ie){

//Styles

document.write('<style type="text/css">');
document.write('#p-cactions ul{overflow:visible;}');
document.write('#p-cactions li{position: relative;float: left;}');
document.write('.tabmenu ul li{display: block !important;width: 180px !important;min-width: 10em !important;border: 0px;margin: 0px;padding: .1em;border: 1px solid #aaaaaa !important;border-collapse: collapse;text-align: center;background-color: #F8FCFF !important;white-space: nowrap !important;}');
document.write('.tabmenu ul {display: none !important;width:180px;z-index: 50;position: absolute;top: 1.3em;margin: 0px;background-color: grey;}');
document.write('.tabmenu * {-moz-border-radius: 0px !important;}');
document.write('.tabmenu:hover ul {display: block !important;}');
document.write('.tabmenu ul li:hover {background-color: #e8ecef !important;}');
document.write('.tabmenu ul a {background-color: transparent !important;}');
document.write('</style>');

// Fonctions

function ULmenuOnMouseOver(id){
     var Ul = document.getElementById('limenu_'+id); 
     var Lis = Ul.getElementsByTagName('li');
     for(a=0;a<Lis.length;a++){
          Lis[a].style.display = 'block'
     }
}
function ULmenuOnMouseOut(id){
     var Ul = document.getElementById('limenu_'+id); 
     var Lis = Ul.getElementsByTagName('li');
     for(a=0;a<Lis.length;a++){
          Lis[a].style.display = 'none'
     }     
}

var Limenu_Index = -1;
function addlimenu(tabs, name, id, href, position) {
    Limenu_Index++
    var mn;
    var li;
 
    if (!id)  id = name;
    if ((!href)||(href=='')) href = '#';
 
    li = document.createElement("li");
    li.innerHTML = '<a href="'+href+'" onblur="ULmenuOnMouseOut(\''+Limenu_Index+'\')" onfocus="ULmenuOnMouseOver(\''+Limenu_Index+'\')" >'+name+'</a>';

    mn = document.createElement("ul");
    mn.id = 'limenu_'+Limenu_Index;
    li.appendChild(mn);
    if (id) li.id = id;
    li.className = 'tabmenu';
 
    if (position) {
        tabs.insertBefore(li, position);
    } else {
        tabs.appendChild(li);
    }
    return mn;  // useful because it gives us the <ul> to add <li>s to
}
//

function getElementUrl(id) {
    var url = decodeURIComponent(id.firstChild.getAttribute('href'));
    url = url.split(wgServer).join("");
    url = url.split(wgScript).join("");
    url = url.split('?title=').join("");
    url = url.split(wgArticlePath.split('$1').join('')).join("");
    url = wgServer + wgScript + '?title=' + url;
    return url;
}
 
function getElementUrlText(id) {       
    return getTextContent(id.firstChild);

}
 

// Fonction principale

addOnloadHook(MenuActions);
}


function MenuActions() {
    var pCactions = document.getElementById('p-cactions');
    if(!pCactions)return;
    var tabs = pCactions.getElementsByTagName('ul')[0];
 
    var caMain = pCactions.getElementsByTagName('li')[0];
    var caTalk = pCactions.getElementsByTagName('li')[1];
    var caSection = document.getElementById('ca-addsection');
    var caEdit = document.getElementById('ca-edit');
    var caView = document.getElementById('ca-viewsource');
    var caHistory = document.getElementById('ca-history');
    var caMove = document.getElementById('ca-move');
    var caWatch = document.getElementById('ca-watch');
    var caUnwatch = document.getElementById('ca-unwatch');
    var caProtect = document.getElementById('ca-protect');
    var caUnprotect = document.getElementById('ca-unprotect');
    var caDelete = document.getElementById('ca-delete');
    var caUndelete = document.getElementById('ca-undelete');
 
    // Hide tabs
    if (caMain) caMain.style.display = 'none';
    if (caEdit) caEdit.style.display = 'none';
    if (caView) caView.style.display = 'none';
    if (caTalk) caTalk.style.display = 'none';
    //if (caSection) caSection.style.display = 'none';
    if (caHistory) caHistory.style.display = 'none';
    if (caMove) caMove.style.display = 'none';
    if (caWatch) caWatch.style.display = 'none';
    if (caUnwatch) caUnwatch.style.display = 'none';
    if (caProtect) caProtect.style.display = 'none';
    if (caUnprotect) caUnprotect.style.display = 'none';
    if (caDelete) caDelete.style.display = 'none';
    if (caUndelete) caUndelete.style.display = 'none';
 
    // Check if page is editable
    if ( caEdit ) {
        edittxt = 'modifier';
    } else {
        edittxt = 'voir la source';
    }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu page principale ( ns ≠ spécial )

if(wgNamespaceNumber >= 0){
    if( wgPageName == "Accueil"){
        var newPage = addlimenu(tabs, "accueil", 'new-page', getElementUrl(caMain), caMain);
    } else {
        var newPage = addlimenu(tabs, getElementUrlText(caMain), 'new-page', getElementUrl(caMain), caMain);
    }
    newPage.className = caMain.className;

    if( caMain.className.search('new') == 0 ) {
        addMenuActionsLink('new-page', getElementUrl(caMain), 'créer');
    } else {
        if (caEdit)addMenuActionsLink('new-page', getElementUrl(caMain) + '&action=edit', edittxt);
        if (caView)addMenuActionsLink('new-page', getElementUrl(caMain) + '&action=view', edittxt);
        if (caEdit)addMenuActionsLink('new-page', getElementUrl(caMain) + '&action=edit&section=0', edittxt + ' en-tête');
        addMenuActionsLink('new-page', getElementUrl(caMain) + '&action=history', 'historique');
        addMenuActionsLink('new-page', getElementUrl(caMain) + '&diff=cur&oldid=prev', 'dernière');
    }
    addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Log&page=' + wgPageName, 'journal');
    if(caSection){
        addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Prefixindex/' + wgTitle + '/' + '&namespace=' + (wgNamespaceNumber-1), 'sous-pages');
    }else {
        addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Prefixindex/' + wgTitle + '/' + '&namespace=' + wgNamespaceNumber, 'sous-pages');
    } 
    ///////////////// If we're in Userspace then add additional items to show info for this user

    if (wgNamespaceNumber == 2 || wgNamespaceNumber == 3) {
        if ( wgTitle.indexOf("/") == -1 ) {
            uname = wgTitle;
        } else {
            uname = wgTitle.substring(0, wgTitle.indexOf("/"));
        }
        addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Listusers&limit=1&username=' + uname, 'statut de l\'utilisateur');
        addMenuActionsLink('new-page', wgServer + wgArticlePath.split("$1").join('Special:Contributions/' + uname), 'contributions de l\'utilisateur');
        if (caDelete) addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:DeletedContributions&target=' + uname, 'contributions supprimées');
        addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Log&user=' + uname, 'journal utilisateur');
        addMenuActionsLink('new-page', wgServer + wgScript + '?title=Special:Log&type=block&page=User:' + uname, 'blocages utilisateur');
        if (caDelete) addMenuActionsLink('new-page', wgServer + wgArticlePath.split("$1").join('Special:Blockip/' + uname), 'bloquer l\'utilisateur');
    }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu page de discussion ( ns ≠ spécial )

    var newTalk = addlimenu(tabs, getElementUrlText(caTalk), 'new-talk', getElementUrl(caTalk), caTalk);
    newTalk.className = caTalk.className;

    if( caTalk.className.search('new') == 0 ) {
        addMenuActionsLink('new-talk', getElementUrl(caTalk), 'créer');
    } else {
        if (caEdit)addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&action=edit', edittxt);
        if (caView)addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&action=view', edittxt);
        if (caEdit)addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&action=edit&section=0', edittxt + ' en-tête');
        addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&action=edit&section=new', 'nouvelle section');
        addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&action=history', 'historique');
        addMenuActionsLink('new-talk', getElementUrl(caTalk) + '&diff=cur&oldid=prev', 'dernière');
    }
    addMenuActionsLink('new-talk', wgServer + wgScript + '?title=Special:Log&page=Discussion ' + wgPageName, 'journal');

    if(caSection){
        addMenuActionsLink('new-talk', wgServer + wgScript + '?title=Special:Prefixindex/' + wgTitle + '/' + '&namespace=' + wgNamespaceNumber, 'sous-pages');
    } else {
        addMenuActionsLink('new-talk', wgServer + wgScript + '?title=Special:Prefixindex/' + wgTitle + '/' + '&namespace=' + (wgNamespaceNumber+1), 'sous-pages');
    } 


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu actions ( ns ≠ spécial )

    if (caEdit){var newLog = addlimenu(tabs, 'actions', 'new-actions', '', caEdit);}
    if (caView){var newLog = addlimenu(tabs, 'actions', 'new-actions', '', caView);}

    if (caEdit)addMenuActionsLink('new-actions', getElementUrl(caEdit), edittxt);
    if (caView)addMenuActionsLink('new-actions', getElementUrl(caView), edittxt);
    if (caHistory) addMenuActionsLink('new-actions', getElementUrl(caHistory), 'historique');
    addMenuActionsLink('new-actions', wgServer + wgScript + '?title=Special:Log&page=' + wgPageName, 'journal');
    if (caWatch) addMenuActionsLink('new-actions', getElementUrl(caWatch), 'suivre');
    if (caUnwatch) addMenuActionsLink('new-actions', getElementUrl(caUnwatch), 'ne plus suivre');
    addMenuActionsLink('new-actions', wgServer + wgScript + '?title=' + wgPageName + '&action=purge', 'purger');
    if (caMove) addMenuActionsLink('new-actions', getElementUrl(caMove), 'renommer');
    if (caProtect) addMenuActionsLink('new-actions', getElementUrl(caProtect), 'protéger');
    if (caUnprotect) addMenuActionsLink('new-actions', getElementUrl(caUnprotect), 'déprotéger');
    if (caDelete) addMenuActionsLink('new-actions', getElementUrl(caDelete), 'supprimer');
    if (caUndelete) addMenuActionsLink('new-actions', getElementUrl(caUndelete), 'restaurer');
}     

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu pages spéciales

    if(wgNamespaceNumber == -1){
        var newSpecial = addlimenu(tabs, getElementUrlText(caMain), 'new-special', wgServer + wgArticlePath.split("$1").join('Special:Specialpages'), caMain);
} else {
    if (caWatch){ var newSpecial = addlimenu(tabs, 'Pages spéciales', 'new-special', wgServer + wgArticlePath.split("$1").join('Special:Specialpages'));}
    if (caUnwatch){ var newSpecial = addlimenu(tabs, 'Pages spéciales', 'new-special', wgServer + wgArticlePath.split("$1").join('Special:Specialpages'));}
}
    newSpecial.className = caMain.className;

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Specialpages'), 'Toutes les pages spéciales');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Prefixindex'), 'Pages débutant par...');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Shortpages'), 'Pages courtes');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Deadendpages'), 'Pages en impasse');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Fewestrevisions'), 'Pages les moins modifiées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Ancientpages'), 'Pages anciennes');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Newpages'), 'Nouvelles pages');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Wantedpages'), 'Pages demandées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Longpages'), 'Pages longues');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Uncategorizedpages'), 'Pages non catégorisées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Lonelypages'), 'Pages orphelines');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Protectedpages'), 'Pages protégées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Withoutinterwiki'), 'Pages sans interwiki');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Mostlinked'), 'Pages les plus liées');

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Categories'), 'Liste des catégories');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:ArbreCategorie'), 'Arborescence des catégories');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Unusedcategories'), 'Catégories inutilisées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Wantedcategories'), 'Catégories demandées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Uncategorizedcategories'), 'Catégories non catégorisées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Mostlinkedcategories'), 'Catégories les plus liées');

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Listfiles'), 'Liste des fichiers');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Wantedfiles'), 'Fichiers demandés');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Uncategorizedfiles'), 'Fichiers non catégorisés');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Unusedfiles'), 'Fichiers inutilisées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Mostlinkedfiles'), 'Fichiers les plus liés');

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Wantedtemplates'), 'Modèles demandés');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Uncategorizedtemplates'), 'Modèles non catégorisés');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Unusedtemplates'), 'Modèles inutilisées');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Mostlinkedtemplates'), 'Modèles les plus liés');

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Listredirects'), 'Liste des redirections');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:DoubleRedirects'), 'Doubles redirections');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:BrokenRedirects'), 'Redirections cassées');

    addMenuActionsLink('new-special', '#', '-');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Disambiguations'), 'Homonymies');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:Protectedtitles'), 'Titres protégés');
    addMenuActionsLink('new-special', wgServer + wgArticlePath.split("$1").join('Special:CrossNamespaceLinks'), 'Liens entre espaces de noms');

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu Recherche
if(wgNamespaceNumber > -1){
    var newSearch = addlimenu(tabs, 'recherche', 'new-search', wgServer + wgArticlePath.split("$1").join('Special:Search'));

function GoogleQuoteSearch() {
  var result = wgPageName.replace(/_/g, "+");
  if (wgPageName.search(/\(/) == -1)
    result = "%22" + result + "%22";
  return result;
}

    //addMenuActionsLink('new-search', '' + GoogleQuoteSearch() + '', '');

    addMenuActionsLink('new-search', wgServer + wgScript + '?title=Sp%C3%A9cial:Search&fulltext=Rechercher&advanced=1&ns0=1&redirs=0&search=' + wgPageName, wgServer.split('http://').join(''));
    addMenuActionsLink('new-search', 'http://www.google.fr/search?num=100&hl=fr&safe=off&q=site%3A' + wgServer.split('http://').join('') + '+' + GoogleQuoteSearch() + '&btnG=Rechercher&meta=lr%3D&aq=f&oq=', 'Google ' + wgServer.split('http://').join(''));

    addMenuActionsLink('new-search', 'http://www.google.fr/search?hl=fr&safe=off&num=100&q=' + GoogleQuoteSearch() + '&btnG=Rechercher&meta=lr%3D&aq=f&oq=', 'Google Web');
    addMenuActionsLink('new-search', 'http://www.google.fr/search?hl=fr&safe=off&num=100&q=' + GoogleQuoteSearch() + '&btnG=Rechercher&meta=lr%3Dlang_fr&aq=f&oq=', 'Google Fr');
    addMenuActionsLink('new-search', 'http://images.google.fr/images?hl=fr&lr=&um=1&sa=1&q=' + GoogleQuoteSearch() + '&btnG=Recherche+d\'images&aq=f&oq=&start=0', 'Google Images');
    addMenuActionsLink('new-search', 'http://video.google.fr/videosearch?hl=fr&lr=&um=1&q=' + GoogleQuoteSearch() + '&ie=UTF-8&sa=N&tab=iv&start=0#', 'Google Vidéos');
    addMenuActionsLink('new-search', 'http://maps.google.fr/maps?hl=fr&lr=&um=1&q=' + GoogleQuoteSearch() + '&ie=UTF-8&sa=N&tab=vl', 'Google Maps');

    addMenuActionsLink('new-search', 'http://www.lycos.fr/?tab=web&query=' + GoogleQuoteSearch() + '&Search=Rechercher&searchArea=web', 'Lycos Web');
    addMenuActionsLink('new-search', 'http://www.lycos.fr/?tab=multi&cat=images&searchArea=web&query=' + GoogleQuoteSearch() + '', 'Lycos Images');
    addMenuActionsLink('new-search', 'http://www.lycos.fr/?tab=multi&cat=video&searchArea=web&query=' + GoogleQuoteSearch() + '', 'Lycos Vidéos');

    addMenuActionsLink('new-search', 'http://fr.search.yahoo.com/search?rd=r1&p=' + GoogleQuoteSearch() + '&toggle=1&cop=mss&ei=UTF-8&fr=yfp-t-703', 'Yahoo Web');
    addMenuActionsLink('new-search', 'http://fr.images.search.yahoo.com/search/images;_ylt=A1f4cfmLyPRK_mEBPuhjAQx.?ei=UTF-8&p=' + GoogleQuoteSearch() + '&rd=r1&fr2=tab-web&fr=yfp-t-703', 'Yahoo Images');
    addMenuActionsLink('new-search', 'http://fr.video.search.yahoo.com/search/video?ei=UTF-8&p=' + GoogleQuoteSearch() + '&rd=r1&fr2=tab-img&fr=yfp-t-703', 'Yahoo Vidéos');

    addMenuActionsLink('new-search', 'http://www.youtube.com/results?search_query=' + GoogleQuoteSearch() + '&search_type=&aq=f', 'You Tube');
    addMenuActionsLink('new-search', 'http://www.dailymotion.com/relevance/search/' + GoogleQuoteSearch() + '', 'Dailymotion');
    addMenuActionsLink('new-search', 'http://www.deezer.com/fr/#music/result/all/' + wgPageName.replace(/_/g, " ") + '', 'Deezer Music');
    addMenuActionsLink('new-search', 'http://www.flickr.com/search/?q=' + wgPageName.replace(/_/g, "+") + '&ct=0&mt=all&adv=1', 'FlickR tous');
    addMenuActionsLink('new-search', 'http://www.flickr.com/search/?q=' + wgPageName.replace(/_/g, "+") + '&l=commderiv&ct=0&mt=all&adv=1', 'FlickR libres');
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Menu  Favoris 

// * * * Fonctions pour les cookies * * *
 
// * * Mise à jour du cookie * *
 
function setActionCookie (cookieName, cookieValue, expires, path) {
document.cookie = escape(cookieName) + '=' + escape(cookieValue) + (expires ? '; EXPIRES=' + expires.toGMTString() : '') + "; PATH=/" ; 
}
 
// * * Interrogation du cookie * *
 
function getActionCookie (cookieName) {
var cookieValue = null;
var posName = document.cookie.indexOf(escape(cookieName) + '=' );
if (posName != -1) {
        var posValue = posName + (escape(cookieName) + '=' ).length;
        var endPos = document.cookie.indexOf(';', posValue) ;
        if (endPos != -1) {
                cookieValue = unescape(document.cookie.substring(posValue, endPos));
        } else {
                cookieValue = unescape(document.cookie.substring(posValue));
        }
}
return cookieValue;
}

// * * Ajout de la page courante * *
 
function storeActionPage(){
thisPage = document.location.href;
thisPageTitle = wgPageName;
var pageList = getActionCookie("pageList");
var pageListTitle = getActionCookie("pageListTitle");
var linkFound = false;
if (pageList != "" && pageList != null) {
        pSplit = pageList.split(";");
                for (a=0;a<pSplit.length;a++) {
                }
        }
if (!linkFound) {
        if (pageList == null || pageList == ";") {
                pageList = thisPage;
                pageListTitle = thisPageTitle;
        } else {
                pageList += ";" + thisPage;
                pageListTitle += ";" + thisPageTitle;
        }
}
var now = new Date();
var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
setActionCookie("pageList",pageList,nextYear);
setActionCookie("pageListTitle",pageListTitle,nextYear);
window.location.reload();
}

// * * * Créations de la liste de favoris * * *

        var FavorisMenu = addlimenu(tabs,"Favoris","FavorisID","");
        FavorisMenu.className = caMain.className;

        var pageList = getActionCookie("pageList");
        var pageListTitle = getActionCookie("pageListTitle");
        if (pageList != "" && pageList != null) {
                pSplit = pageList.split(";")
                for (a=0;a<pSplit.length;a++) {
                        if (pSplit[a] != '' && pSplit[a] != 'null') {
                                if (pageListTitle != "" && pageListTitle != null) {
                                        pSplitTitle = pageListTitle.split(";")
                                        for (a=0;a<pSplitTitle.length;a++) {
                                                if (pSplitTitle[a] != '' && pSplitTitle[a] != 'null') {
                                                       addMenuActionsLink("FavorisID", wgServer + wgArticlePath.split("$1").join(pSplitTitle[a]), pSplitTitle[a].replace(/_/g," ")); 
                                                }
                                        }
                                }
                        }
                }
        }else{
                addMenuActionsLink("FavorisID","#", "Aucun favoris"); 
        } 
        addMenuActionsLink("FavorisID","#", "---"); 
        addMenuActionsLink("FavorisID","javascript:storePage();", "Ajouter la page en cours"); 
}
 
//</nowiki></source>

function addMenuActionsLink(portlet, href, text, id, tooltip, accesskey, nextnode) {
    var root = document.getElementById(portlet);
    if ( !root ) return null;
    var node = root.getElementsByTagName( "ul" )[0];
    if ( !node ) return null;
 
    // unhide portlet if it was hidden before
    root.className = root.className.replace( /(^| )emptyPortlet( |$)/, "$2" );
 
    var span = document.createElement( "span" );
    span.appendChild( document.createTextNode( text ) );
 
    var link = document.createElement( "a" );
    link.appendChild( span );
    link.href = href;
 
    var item = document.createElement( "li" );
    item.appendChild( link );
    item.style.display = 'block';
    if ( id ) item.id = id;
 
    if ( accesskey ) {
        link.setAttribute( "accesskey", accesskey );
        tooltip += " ["+accesskey+"]";
    }
    if ( tooltip ) {
        link.setAttribute( "title", tooltip );
    }
    if ( accesskey && tooltip ) {
        updateTooltipAccessKeys( new Array( link ) );
    }
 
    if ( nextnode && nextnode.parentNode == node )
    node.insertBefore( item, nextnode );
    else
    node.appendChild( item ); // IE compatibility (?)
 
    return item;
}
//{{Boîte déroulante fin}}