/*************************************************************************************************************************
 * MENUCLICDROIT                                                                                                         *
 *                                                                                                                       *
 * *** Fonctions ***                                                                                                     *
 * # Le clic droit sur une page fait apparaître un menu contextuel contenant tous les liens nécessaires à la navigation  *
 * # Le menu contextuel comprend :                                                                                       *
 *   * trois listes déroulantes où des liens supplémentaires peuvent êtres ajoutés (dans le code ci-dessous)             *
 *   * une liste déroulante de liens favoris : deux liens permettent d'ajouter ou de retirer la page courante            *
 * # En cours d'édition, un deuxième menu permet d'insérer des caractères pré-établis (quatrième liste)                  *
 * # Un menu supplémentaire permet de modifier l'affichage (couleurs, bordures, etc...)                                  *
 * # La page s'affiche en plein écran (optionnel)                                                                        *
 *                                                                                                                       *
 *                                                                                                                       *
 * *** TESTS ***                                                                                                         *
 * * Navigateurs *                                                                                                       *
 * Mozilla Firefox 3.5 : OK                                                                                              *
 * Internet Explorer 8  : OK                                                                                             *
 * Google Chrome 3.0 : OK                                                                                                *
 * Opera 10.00 : Ne marche pas                                                                                           *
 *                                                                                                                       *
 * * Habillages *                                                                                                        *
 * Vector : OK                                                                                                           *
 * Monobook : OK                                                                                                         *
 * Modern : OK                                                                                                           *
 * MySkin : OK                                                                                                           *
 * Simple : OK                                                                                                           *
 * Chick : OK                                                                                                            *
 *                                                                                                                       *
 * Nostalgia, Standard et Cologneblue :                                                                                  *
 * Fonctionne mais certains liens ne sont pas à la bonne place.                                                          *
 * La récuppération des liens existants est problématique car ils ne sont pas regroupés dans un div.                     *
 *                                                                                                                       *
 * Documentation complète : [[Discussion utilisateur:Dr Brains/MenuClicDroit.js]]                                        *
 *                                                                                                                       *
 *           {{Projet:JavaScript/Script}}                                                                                *
 *************************************************************************************************************************/

//<source lang=javascript>//<pre>//<nowiki>
///////////////////// ////////////////////////// /////////////////////////// /////////// ///////// PARTIE PERSONNALISABLE //////// /////// ////// //////// ////// //////// /////// ///////

////////////////////////////////////////////////////////////////////////////////////////////////// Paramètres 

var UrlSite = wgServer + "/wiki/";
var UrlSiteBis = wgServer + wgScript +"?title=";
var UrlSiteTer = wgServer ;

var DoubleClicEdit = true;            // Édition par double-clic (monobook seulement, ne marche pas avec Internet Explorer)
var PopUp = true;                     // Activation des pop-up de confirmation
 
var TailleCancel = 70;     // Largeur du bouton "Annuler"     (fenêtre de suppression favoris)
var Alignt = "center";     // alignement du texte (avec IE, les menus déroulants sont toujours alignés à gauche)


//Décalages en X (largeur) et Y (hauteur) entre le coin haut gauche du menu principal et la position de la souris lors du clic droit (désactivé sur IE)
var OffsetX = 0;                      
var OffsetY = -150;                   

////////////////////////////////////////////////////////////////////////////////////////////////// Textes

////////////////////////////////////////////////////////////////////////// Menu Standard

var MenuTextMove = "DÉPLACER";
var MenuTextClose = "FERMER";
var MenuTextLast = "Page précédente";
var MenuTextNext = "Page suivante";
var MenuTextButton1 = "Lire";
var MenuTextButton2 = "Consulter";
var MenuTextspecial = "pages spéciales";
var MenuTextActions = "ACTIONS";
var MenuTextActionBis = "autres actions";
var MenuTextPerso = "LIENS PERSONNELS";
var MenuTextAdd = "Ajouter";
var MenuTextSupprAll = "RAZ";
var MenuTextSuppr1 = "Supprimer";        
var MenuTextFav = "favoris";
var MenuTextNavig = "NAVIGATION";
var MenuTextLang = "autres langues";
var MenuTextProjects = "autres projets";
var MenuTextNavigBis = "autres liens utiles";

////////////////////////////////////////////////////////////////////////// Menu Édition

var MenuEditTextEdit = "ÉDITION";
var MenuEditTextTaille = "Taille de la zone d\'édition";
var MenuEditTextTailleBis = "Nombre de lignes pour la zone d\édition ?";
var MenuEditTextTailleTer = "Cliquer pour modifier la taille de la zone d\'édition";
var MenuEditTextBalise = "Insérer Balises"
var MenuEditTextBaliseBis = "Nom de la balise ? \nExemple : ";                 
var MenuEditTextBaliseTer = "Cliquer pour insérer une balise quelconque";
var MenuEditTextSubmit = "PUBLICATION";
var MenuEditTextSubmitBis = "Ajouter dans la boîte de résumé";

////////////////////////////////////////////////////////////////////////// Pop-up Menu

var MenuTextClosePop = "Cliquer pour fermer le menu";
var MenuTextMovePop = "Cliquer pour déplacer le menu";
var MenuTextLastPop = "Revenir à la page précédente de l'historique du navigateur";
var MenuTextNextPop = "Revenir à la page suivante de l'historique du navigateur";
var MenuTextSearchPop = "Rechercher dans Wikipédia";
var MenuTextButton1Pop  = "Aller vers une page portant exactement ce nom si elle existe";
var MenuTextButton2Pop = "Rechercher les pages comportant ce texte";
var MenuTextAddPop = "Cliquer pour ajouter la page courante aux favoris";
var MenuTextSupprAllPop = "Cliquer pour vider les favoris";
var MenuTextSuppr1Pop = "Cliquer pour supprimer une page précise des favoris";

////////////////////////////////////////////////////////////////////////// Pop-up Favoris

var Suppr1Fav1 = "La liste de favoris contient les pages suivantes :";
var Suppr1Fav2 = "Quelle page souhaitez-vous supprimer de la liste ?";
var Suppr1Fav3 = "(indiquer seulement le numéro)";
var Suppr1FavNone = "Vous n\'avez aucun favoris.";
var Suppr1FavThis = "Voulez-vous vraiment supprimer des favoris la page : ";
var SupprAllFav = "Voulez-vous vraiment effacer la liste de favoris ?";

////////////////////////////////////////////////////////////////////////// Cadre options

var MenuTextOption = "Options";
var MenuTextOptionOpen = "Cliquer pour ouvrir le menu options";
var MenuTextOptionAffichage = "Affichage : ";
var MenuTextOptionPleinEcran = "Plein Écran";
var MenuTextOptionNoPleinEcran = "Normal";
var MenuTextOptionPleinEcranPop = "Cliquer pour afficher la page en plein écran";
var MenuTextOptionNoPleinEcranPop = "Cliquer pour revenir à l\'affichage normal";
var MenuTextOptionbgColor = "Fond cadres : ";
var MenuTextOptionbgColorPop = "Cliquer pour définir la couleur de fond des cadres";
var MenuTextOptionbdColor = "Bordures : ";
var MenuTextOptionbdColorPop = "Cliquer pour définir la couleur desbordures";
var MenuTextOptionTColor = "Fond titres : ";
var MenuTextOptionTColorPop = "Cliquer pour définir la couleur de fond des titres";
var MenuTextOptionTtColor = "Texte titres : ";
var MenuTextOptionTtColorPop = "Cliquer pour définir la couleur du texte des titres";
var MenuTextOptionlienColor = "Texte : ";
var MenuTextOptionlienColorPop = "Cliquer pour définir la couleur du texte";
var MenuTextOptionselColor = "Survol : ";
var MenuTextOptionselColorPop = "Cliquer pour définir la couleur des éléments survolés";
var MenuTextOptionMDColor = "Menus déroulants : ";
var MenuTextOptionMDColorPop = "Cliquer pour définir la couleur des menus déroulants";
var MenuTextOptionLineColor = "Lignes : ";
var MenuTextOptionLineColorPop = "Cliquer pour définir la couleur des lignes horizontales";
var MenuTextOptionbgTaille = "Largeur du menu principal : ";
var MenuTextOptionbgTaillePop = "Cliquer pour définir la largeur du menu principal";
var MenuTextOptionListeTaille = "Largeur du menu favoris : ";
var MenuTextOptionListeTaillePop = "Cliquer pour définir la largeur du menu favoris";
var MenuTextOptionModifTaille = "Largeur du menu d\'édition : ";
var MenuTextOptionModifTaillePop = "Cliquer pour définir la largeur du menu d\'édition";
var MenuTextOptionOptionsTaille = "Largeur du menu Options : ";
var MenuTextOptionOptionsTaillePop = "Cliquer pour définir la largeur du menu d\'options";
var MenuTextOptionTitreTaille = "Taille des titres : ";
var MenuTextOptionTitreTaillePop = "Cliquer pour définir la taille des titres";
var MenuTextOptionfontTaille = "Taille du texte : ";
var MenuTextOptionfontTaillePop = "Cliquer pour définir la taille du texte";
var MenuTextOptionbdTaille = "Taille des bordures : ";
var MenuTextOptionbdTaillePop = "Cliquer pour définir la taille des bordures";
var MenuTextOptionStylebd = "Style des bordures : ";
var MenuTextOptionStylebdPop = "Cliquer pour définir le style des bordures";
var MenuTextOptionStylepolice = "Police : ";
var MenuTextOptionStylepolicePop = "Cliquer pour définir la police";

var MenuTextOptionOpacity = "Opacité : ";
var MenuTextOptionOpacityPop = "Cliquer pour définir l\'opacité";
var MenuTextOptionRaz = "Rétablir les valeurs par défaut";
var MenuTextOptionRazPop = "Cliquer pour rétablir les valeurs par défaut";

////////////////////////////////////////////////////////////////////////// Cadre options (pop-up)

var MenuTextOptionReload = "Attention, cette action va entraîner le rechargement de la page.\nLes modifications apportées ne seront pas enregistrées.\nContinuer ?";
var bgColorDefine = "Définir la couleur de fond des cadres (sans le signe #).\nCouleur actuelle : ";
var bdColorDefine = "Définir la couleur des bordures (sans le signe #).\nCouleur actuelle : ";
var TColorDefine = "Définir la couleur de fond des titres (sans le signe #).\nCouleur actuelle : ";
var TtColorDefine = "Définir la couleur du texte des titres (sans le signe #).\nCouleur actuelle : ";
var lienColorDefine = "Définir la couleur du texte (sans le signe #).\nCouleur actuelle : ";
var selColorDefine = "Définir la couleur des éléments survolés (sans le signe #).\nCouleur actuelle : ";
var MDColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var LineColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var bgTailleDefine = "Définir la taille du menu principal (en pixels).\nTaille actuelle : ";
var ListeTailleDefine = "Définir la taille du menu favoris (en pixels).\nTaille actuelle : ";
var ModifTailleDefine = "Définir la taille du menu d\'édition (en pixels).\nTaille actuelle : ";
var OptionsTailleDefine = "Définir la taille du menu d\'options (en pixels).\nTaille actuelle : ";
var TitreTailleDefine = "Définir la taille du texte des titres (en pixels).\nTaille actuelle : ";
var fontTailleDefine = "Définir la taille du texte (en pixels).\nTaille actuelle : ";
var bdTailleDefine = "Définir la taille des bordures (en pixels).\nTaille actuelle : ";
var StylebdDefine = "Définir le style des bordures.\nStyle actuel : ";
var StylepoliceDefine = "Définir la police.\nPolice actuelle : ";
var OpacityDefine = "Définir l\'opacité des menus.\nOpacité actuelle : ";

////////////////////////////////////////////////////////////////////////////////////////////////// Variables utiles pour les liens ( encodeURIComponent() sert à gérer les caractères spéciaux )

var BASEPAGENAME    = encodeURIComponent(wgTitle);                                         // Page courante sans l'espace de noms = {{BASEPAGENAME}}
var FULLPAGENAME    = encodeURIComponent(wgPageName);                                      // Page courante = {{FULLPAGENAMEE}}
var TALKPAGENAME    = "Discussion_" + encodeURIComponent(wgPageName);                      // Page de discussion associée = {{TALKPAGENAMEE}}
var SUBJECTPAGENAME = encodeURIComponent(wgPageName.replace(/Discussion /,""));            // Page principale associée = {{SUBJECTPAGENAMEE}}
var NAMESPACENAME   = wgCanonicalNamespace;                                                // Espace de noms (en anglais) = {{NAMESPACE}}
var NAMESPACENUMBER = wgNamespaceNumber;                                                   // N° Espace de noms
var CURRENTUSER     = encodeURIComponent(wgUserName);                                      // Utilisateur Courant

if((document.getElementById("ca-delete"))||(document.getElementById("ca-undelete"))){       // Teste si l'utilisateur est sysop ( présence de l'onglet "supprimer" ou "restaurer" ). Si c'est le cas, SYSOP est vrai
      var SYSOP = true;
}else{
      var SYSOP = false;
}

var DISCUSSION      = document.getElementById("ca-addsection");                            // Teste si la page est une page de discussion ( présence de l'onglet "nouvelle section" ). Si c'est le cas, DISCUSSION est vrai

if (wgNamespaceNumber == 2 || wgNamespaceNumber == 3) {                                    // Teste si la page courante est une page utilisateur et renvoie son pseudonyme. 
      if ( wgTitle.indexOf("/") == -1 ) {                                                  // Si ce n'est pas le cas, UTILISATEUR est faux
            var UTILISATEUR = encodeURIComponent(wgTitle);
      } else {
            var UTILISATEUR = encodeURIComponent(wgTitle.substring(0, wgTitle.indexOf("/")));
      }
}else{
      var UTILISATEUR = false;
}


// * Récupération des variables personnalisées *

  document.write('<script type="text/javascript" src="' 
             + UrlSiteBis + '/index.php?title=Utilisateur:'+encodeURI(wgUserName)+'/BacASable.js' 
             + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');


////////////////////////////////////////////////////////////////////////////////////////////////// MENUS DÉROULANTS PERSONNALISABLES

/**********************************************************************************************************************************************************************************
 *   Pour ajouter une ligne, créer trois instances supplémentaires : menuMACHINtexte[x],  menuMACHINlien[x] et menuMACHINtexte[x]                                                 *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                                                                         *
 *                                                                                                                                                                                *
 * Exemple :                                                                                                                                                                      *
 *                                                                                                                                                                                *
 * menuTRUCtexte[0] = "Mon lien"                        // Texte                                                                                                                  *
 * menuTRUClien[0] = UrlSite + "Spécial:MyPage"         // Page cible (on peut utiliser UrlSite, UrlSiteBis, une des variables ci-dessus ou bien taper l'adresse complète)        *
 * menuTRUCtarget[0] = "_self"                          // Ouverture : _self = même fenêtre (défaut), _blank = nouvelle fenêtre                                                   *
 *                                                                                                                                                                                *
 * menuTRUCtexte[1] = "Ma fonction"                     // Texte                                                                                                                  *
 * menuTRUClien[1] = "javascript:MaFonction(Param);"    // fonction javascript (doit être déclarée avant le "addOnloadHook();" de la fin de cette page)                           *
 * menuTRUCtarget[1] = ""                                                                                                                                                         *
 *                                                                                                                                                                                *
 * menuTRUCtexte[2]= "Sous-titre";                                                                                                                                                *
 * menuTRUClien[2]= "";                                 // Si pas de lien, insertion d'un sous-titre                                                                              *
 * menuTRUCtarget[2]="";                                                                                                                                                          *
 *                                                                                                                                                                                *
 * menuTRUCtexte[2]= "";                                                                                                                                                          *
 * menuTRUClien[2]= "Vide";                             // Si lien, mais pas de texte, l'instance n'est pas prise en compte                                                       *
 * menuTRUCtarget[2]="";                                                                                                                                                          *
 **********************************************************************************************************************************************************************************/

//////////////////////////////////////////////////////////////////// Menu Déroulant AUTRES ACTIONS 




menuactiontexte = new Array;
menuactionlien = new Array;
menuactiontarget = new Array;


menuactiontexte[0]= "Journal";               
menuactionlien[0]= UrlSiteBis + 'Special:Log&page=' + FULLPAGENAME;                
menuactiontarget[0]="_self"; 

if(DISCUSSION){
      menuactiontexte[1]= "Sous-pages de la page principale";
      menuactionlien[1]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + (NAMESPACENUMBER-1); 
      menuactiontarget[1]= "_self";
      menuactiontexte[2]= "Sous-pages de la page de discussion";
      menuactionlien[2]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + NAMESPACENUMBER;
      menuactiontarget[2]="_self"; 
}else {
      menuactiontexte[1]= "Sous-pages de la page principale";
      menuactionlien[1]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + NAMESPACENUMBER; 
      menuactiontarget[1]="_self";
      menuactiontexte[2]= "Sous-pages de la page de discussion";
      menuactionlien[2]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + (NAMESPACENUMBER+1);
      menuactiontarget[2]="_self"; 
}               

if(UTILISATEUR){
      menuactiontexte[3]= "Statut de l\'utilisateur";
      menuactionlien[3]= UrlSite + 'Spécial:Liste_des_utilisateurs/' + UTILISATEUR; 
      menuactiontarget[3]="_self";
      menuactiontexte[4]= "Contributions de l\'utilisateur";
      menuactionlien[4]= UrlSite + 'Special:Contributions/' + UTILISATEUR; 
      menuactiontarget[4]="_self";
      menuactiontexte[5]= "Journal de l\'utilisateur";
      menuactionlien[5]= UrlSiteBis + 'Special:Log&user=' + UTILISATEUR; 
      menuactiontarget[5]="_self";
      menuactiontexte[6]= "Blocages de l\'utilisateur";
      menuactionlien[6]= UrlSiteBis + 'Special:Log&type=block&page=User:' + UTILISATEUR; 
      menuactiontarget[6]="_self";
      if(SYSOP){
            menuactiontexte[7]= "Contributions supprimées";
            menuactionlien[7]= UrlSiteBis + 'Special:DeletedContributions&target=' + UTILISATEUR; 
            menuactiontarget[7]="_self";
            menuactiontexte[8]= "Bloquer l\'utilisateur";
            menuactionlien[8]= UrlSiteBis + '/Special:Blockip/' + UTILISATEUR; 
            menuactiontarget[8]= "_self"; 
      }else{
            menuactiontexte[7]= "";
            menuactionlien[7]= "Vide"; 
            menuactiontarget[7]="";
            menuactiontexte[8]= "";
            menuactionlien[8]= "Vide"; 
            menuactiontarget[8]="";
      }
}else{
      menuactiontexte[3]= "";
      menuactionlien[3]= "Vide"; 
      menuactiontarget[3]="";
      menuactiontexte[4]= "";
      menuactionlien[4]= "Vide"; 
      menuactiontarget[4]="";
      menuactiontexte[5]= "";
      menuactionlien[5]= "Vide"; 
      menuactiontarget[5]="";
      menuactiontexte[6]= "";
      menuactionlien[6]= "Vide"; 
      menuactiontarget[6]="";
      menuactiontexte[7]= "";
      menuactionlien[7]= "Vide"; 
      menuactiontarget[7]="";
      menuactiontexte[8]= "";
      menuactionlien[8]= "Vide"; 
      menuactiontarget[8]="";
}
           


//////////////////////////////////////////////////////////////////// Menu Déroulant AUTRES LIENS UTILES
menunavigtexte = new Array;
menunaviglien = new Array;
menunavigtarget = new Array;


menunavigtexte[0]= "Bistro";
menunaviglien[0]= UrlSite + "Wikipédia:Le_Bistro";
menunavigtarget[0]="_self";
menunavigtexte[1]= "Oracle";
menunaviglien[1]= UrlSite + "Wikipédia:Oracle";
menunavigtarget[1]="_self";
menunavigtexte[2]= "Guilde des guides";
menunaviglien[2]= UrlSite + "Wikipédia:Guilde_des_guides";
menunavigtarget[2]="_self";
menunavigtexte[3]= "";
menunaviglien[3]= "";
menunavigtarget[3]="";

//////////////////////////////////////////////////////////////////// Menu Déroulant PAGES SPÉCIALES
menuspecialtexte = new Array;
menuspeciallien = new Array;
menuspecialtarget = new Array;


menuspecialtexte[0]= "Toutes les pages spéciales";
menuspeciallien[0]= UrlSite + "Spécial:Pages_spéciales";
menuspecialtarget[0]="_self";

menuspecialtexte[1]= "Articles";
menuspeciallien[1]= "";
menuspecialtarget[1]="";
menuspecialtexte[2]= "Toutes les pages"
menuspeciallien[2]= UrlSite + "Spécial:Toutes_les_pages"
menuspecialtarget[2]="_self"
menuspecialtexte[3]= "Pages débutant par..."
menuspeciallien[3]= UrlSite + "Spécial:Index"
menuspecialtarget[3]="_self"
menuspecialtexte[4]= "Pages courtes"
menuspeciallien[4]= UrlSite + "Spécial:Pages_courtes"
menuspecialtarget[4]="_self"
menuspecialtexte[5]= "Pages en impasse"
menuspeciallien[5]= UrlSite + "Spécial:Pages_en_impasse"
menuspecialtarget[5]="_self"
menuspecialtexte[6]= "Pages les moins modifiées"
menuspeciallien[6]= UrlSite + "Spécial:Pages_les_moins_modifiées"
menuspecialtarget[6]="_self"
menuspecialtexte[7]= "Pages anciennes"
menuspeciallien[7]= UrlSite + "Spécial:Pages_anciennes"
menuspecialtarget[7]="_self"
menuspecialtexte[8]= "Pages demandées"
menuspeciallien[8]= UrlSite + "Spécial:Pages_demandées"
menuspecialtarget[8]="_self"
menuspecialtexte[9]= "Pages longues"
menuspeciallien[9]= UrlSite + "Spécial:Pages_longues"
menuspecialtarget[9]="_self"
menuspecialtexte[10]= "Pages non catégorisées"
menuspeciallien[10]= UrlSite + "Spécial:Pages_non_catégorisées"
menuspecialtarget[10]="_self"
menuspecialtexte[11]= "Pages orphelines"
menuspeciallien[11]= UrlSite + "Spécial:Pages_orphelines"
menuspecialtarget[11]="_self"
menuspecialtexte[12]= "Pages protégées"
menuspeciallien[12]= UrlSite + "Spécial:Pages_protégées"
menuspecialtarget[12]="_self"
menuspecialtexte[13]= "Pages sans interwiki"
menuspeciallien[13]= UrlSite + "Spécial:Sans_interwiki"
menuspecialtarget[13]="_self"
menuspecialtexte[14]= "Pages les plus liées"
menuspeciallien[14]= UrlSite + "Spécial:Pages_les_plus_liées"
menuspecialtarget[14]="_self"
menuspecialtexte[15]= "Titres protégés"
menuspeciallien[15]= UrlSite + "Spécial:Titres_protégés"
menuspecialtarget[15]="_self"
menuspecialtexte[16]= "Pages utilisant le plus de catégories"
menuspeciallien[16]= UrlSite + "Spécial:Pages_utilisant_le_plus_de_catégories"
menuspecialtarget[16]="_self"
menuspecialtexte[17]= "Pages les plus liées"
menuspeciallien[17]= UrlSite + "Spécial:Pages_les_plus_liées"
menuspecialtarget[17]="_self"
menuspecialtexte[18]= "Pages les plus modifiées"
menuspeciallien[18]= UrlSite + "Spécial:Pages_les_plus_modifiées"
menuspecialtarget[18]="_self"
menuspecialtexte[19]= "Liens entre espaces de noms"
menuspeciallien[19]= UrlSite + "Spécial:CrossNamespaceLinks"
menuspecialtarget[19]="_self"

menuspecialtexte[20]= "Catégories";
menuspeciallien[20]= "";
menuspecialtarget[20]="";
menuspecialtexte[21]= "Liste des catégories"
menuspeciallien[21]= UrlSite + "Spécial:Categories"
menuspecialtarget[21]="_self"
menuspecialtexte[22]= "Arborescence des catégories"
menuspeciallien[22]= UrlSite + "Spécial:ArbreCategorie"
menuspecialtarget[22]="_self"
menuspecialtexte[23]= "Catégories inutilisées"
menuspeciallien[23]= UrlSite + "Spécial:Catégories_inutilisées"
menuspecialtarget[23]="_self"
menuspecialtexte[24]= "Catégories demandées"
menuspeciallien[24]= UrlSite + "Spécial:Catégories_demandées"
menuspecialtarget[24]="_self"
menuspecialtexte[25]= "Catégories non catégorisées"
menuspeciallien[25]= UrlSite + "Spécial:Catégories_non_catégorisées"
menuspecialtarget[25]="_self"
menuspecialtexte[26]= "Catégories les plus liées"
menuspeciallien[26]= UrlSite + "Spécial:Catégories_les_plus_liées"
menuspecialtarget[26]="_self"
menuspecialtexte[27]= "Catégories les plus utiliséess"
menuspeciallien[27]= UrlSite + "Spécial:Catégories_les_plus_utilisées"
menuspecialtarget[27]="_self"

menuspecialtexte[28]= "Fichiers";
menuspeciallien[28]= "";
menuspecialtarget[28]="";
menuspecialtexte[29]= "Liste des fichiers"
menuspeciallien[29]= UrlSite + "Spécial:Liste_des_fichiers"
menuspecialtarget[29]="_self"
menuspecialtexte[30]= "Fichiers demandés"
menuspeciallien[30]= UrlSite + "Spécial:Fichiers_demandés"
menuspecialtarget[30]="_self"
menuspecialtexte[31]= "Fichiers non catégorisés"
menuspeciallien[31]= UrlSite + "Spécial:Fichiers_non_catégorisés"
menuspecialtarget[31]="_self"
menuspecialtexte[32]= "Fichiers inutilisées"
menuspeciallien[32]= UrlSite + "Spécial:Fichiers_inutilisées"
menuspecialtarget[32]="_self"
menuspecialtexte[33]= "Fichiers les plus liés"
menuspeciallien[33]= UrlSite + "Spécial:Fichiers_les_plus_liés"
menuspecialtarget[33]="_self"
menuspecialtexte[34]= "Fichiers les plus utilisés"
menuspeciallien[34]= UrlSite + "Spécial:Fichiers_les_plus_utilisés"
menuspecialtarget[34]="_self"

menuspecialtexte[35]= "Modèles";
menuspeciallien[35]= "";
menuspecialtarget[35]="";
menuspecialtexte[36]= "Modèles demandés"
menuspeciallien[36]= UrlSite + "Spécial:Modèles_demandés"
menuspecialtarget[36]="_self"
menuspecialtexte[37]= "Modèles non catégorisés"
menuspeciallien[37]= UrlSite + "Spécial:Modèles_non_catégorisés"
menuspecialtarget[37]="_self"
menuspecialtexte[38]= "Modèles inutilisés"
menuspeciallien[38]= UrlSite + "Spécial:Modèles_inutilisés"
menuspecialtarget[38]="_self"
menuspecialtexte[39]= "Modèles les plus liés"
menuspeciallien[39]= UrlSite + "Spécial:Modèles_les_plus_liés"
menuspecialtarget[39]="_self"
menuspecialtexte[40]= "Modèles les plus utilisés"
menuspeciallien[40]= UrlSite + "Spécial:Modèles_les_plus_utilisés"
menuspecialtarget[40]="_self"

menuspecialtexte[41]= "Redirections";
menuspeciallien[41]= "";
menuspecialtarget[41]="";
menuspecialtexte[42]= "Liste des redirections"
menuspeciallien[42]= UrlSite + "Spécial:Liste_des_redirections"
menuspecialtarget[42]="_self"
menuspecialtexte[43]= "Doubles redirections"
menuspeciallien[43]= UrlSite + "Spécial:Doubles_redirections"
menuspecialtarget[43]="_self"
menuspecialtexte[44]= "Redirections cassées"
menuspeciallien[44]= UrlSite + "Spécial:Redirections_cassées"
menuspecialtarget[44]="_self"
menuspecialtexte[45]= "Homonymies"
menuspeciallien[45]= UrlSite + "Spécial:Homonymies"
menuspecialtarget[45]="_self"

////////////////////////////////////////////////////////////////////////////////////////////////// TOOLBAR

/********************************************************************************************************************************************
 *   Pour ajouter une icône à la barre d'outils, créer cinq instances supplémentaires comme expliqué ci-dessous                             *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                                   *
 *                                                                                                                                          *
 * menutoolbardébut[X] = "";            // Code inséré avant la sélection. Les espaces, les apostrophes ou les guillemets sont autorisés    *
 * menutoolbarfin[X] = "";              // Code inséré après la sélection                                                                   *
 * menutoolbarcomm[X] = "";             // Information au survol de la souris                                                               *
 * menutoolbarimage[X] = "";            // URL de l'image                                                                                   *
 * menutoolbarimageId[X] = "";          // Id du bouton (attention, pas d'espace ou autres caractères spéciaux)                             *
 * menutoolbarimagePosition[X] = "";    // Début ou Fin : Position de l'image par rapport à celles qui y sont déjà ( Début par défaut)      *
 *                                                                                                                                          *
 ********************************************************************************************************************************************/
menutoolbardébut = new Array;
menutoolbarfin = new Array;
menutoolbarcomm = new Array;
menutoolbarimage = new Array;
menutoolbarimageId = new Array;
menutoolbarimagePosition = new Array;


menutoolbardébut[0] = "{{subst:Bienvenu}} ~~~~";
menutoolbarfin[0] = "";
menutoolbarcomm[0] = "Bienvenue sur ta page !";
menutoolbarimage[0] = "http://upload.wikimedia.org/wikipedia/commons/1/12/Button_accueilA.png";
menutoolbarimageId[0] = "bienvenue_sur_ta_page";
menutoolbarimagePosition[0] = "";

menutoolbardébut[1] = "{{subst:Bienvenue nouveau}} ~~~~";
menutoolbarfin[1] = "";
menutoolbarcomm[1] = "Bienvenue !";
menutoolbarimage[1] = "http://upload.wikimedia.org/wikipedia/commons/e/eb/Button_accueilB.png";
menutoolbarimageId[1] = "bienvenue";
menutoolbarimagePosition[1] =  "";

menutoolbardébut[2] = "{{Vandale bloqué|1|jour}} ~~~~";
menutoolbarfin[2] = "";
menutoolbarcomm[2] = "Blocage d'un vandale";
menutoolbarimage[2] = "http://upload.wikimedia.org/wikipedia/commons/0/00/Button_vandale.png";
menutoolbarimageId[2] = "blocage_vandale";
menutoolbarimagePosition[2] =  "";

menutoolbardébut[3] = "{{subst:Vandalisme|article}} ~~~~";
menutoolbarfin[3] = "";
menutoolbarcomm[3] = "Avertissement vandalisme";
menutoolbarimage[3] = "http://upload.wikimedia.org/wikipedia/commons/a/a7/Button_smiley3.png";
menutoolbarimageId[3] = "avertissement_vandalisme";
menutoolbarimagePosition[3] = "";

menutoolbardébut[4] = "{{subst:Copieur|article|page copiée}} ~~~~";
menutoolbarfin[4] = "";
menutoolbarcomm[4] = "Avertissement copyvio";
menutoolbarimage[4] = "http://upload.wikimedia.org/wikipedia/commons/5/58/Button_black_copyright.png";
menutoolbarimageId[4] = "avertissement_copyvio";
menutoolbarimagePosition[4] = "";

menutoolbardébut[5] = "{{subst:Bienvenue spammeur|article}} ~~~~";
menutoolbarfin[5] = "";
menutoolbarcomm[5] = "Avertissement spam";
menutoolbarimage[5] = "http://upload.wikimedia.org/wikipedia/commons/f/fb/Button_spam2.png";
menutoolbarimageId[5] = "avertissement_spam";
menutoolbarimagePosition[5] = "";

menutoolbardébut[6] = "{{Fait}} ~~~~";
menutoolbarfin[6] = "";
menutoolbarcomm[6] = "Fait";
menutoolbarimage[6] = "http://upload.wikimedia.org/wikipedia/commons/d/d9/Button_trait%C3%A9.png";
menutoolbarimageId[6] = "fait";
menutoolbarimagePosition[6] = "";

//////////////////////////////////////////////////////////////////// Menu  CHARINSERT ( = [[MediaWiki:Edittools]] )
/************************************************************************************************************************************
 *   Pour ajouter un symbole, créer deux instances supplémentaires comme expliqué ci-dessous                                        *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                           *
 *   Attention, les symboles HTML ou assimilés (div, span, nowiki, includeonly, noinclude, etc...) ne sont pas toujours permis .    *
 *   Utiliser le lien "Inserer une balise" pour insérer ceux-là.                                                                    *
 *                                                                                                                                  *
 * menutoolbardébut[X] = "";    // Code inséré avant la sélection. Les espaces, les apostrophes ou les guillemets sont autorisés    *
 * menutoolbarfin[X] = "";      // Code inséré après la sélection                                                                   *
 *                                                                                                                                  *
 *   Si les deux variables sont vides, insertion d'une ligne horizontale.                                                           *
 *                                                                                                                                  *
 ************************************************************************************************************************************/
menucharinsertdébut = new Array;
menucharinsertfin = new Array;
 

menucharinsertdébut[0]= "æ"
menucharinsertfin[0]= ""
menucharinsertdébut[1]= "Æ"
menucharinsertfin[1]= ""
menucharinsertdébut[2]= "à"
menucharinsertfin[2]= ""
menucharinsertdébut[3]= "À"
menucharinsertfin[3]= ""
menucharinsertdébut[4]= "â"
menucharinsertfin[4]= ""
menucharinsertdébut[5]= "Â"
menucharinsertfin[5]= ""
menucharinsertdébut[6]= "ä"
menucharinsertfin[6]= ""
menucharinsertdébut[7]= "Ä"
menucharinsertfin[7]= ""
menucharinsertdébut[8]= "ç"
menucharinsertfin[8]= ""
menucharinsertdébut[9]= "Ç"
menucharinsertfin[9]= ""
menucharinsertdébut[10]= "é"
menucharinsertfin[10]= ""
menucharinsertdébut[11]= "É"
menucharinsertfin[11]= ""
menucharinsertdébut[12]= "è"
menucharinsertfin[12]= ""
menucharinsertdébut[13]= "È"
menucharinsertfin[13]= ""
menucharinsertdébut[14]= "ê"
menucharinsertfin[14]= ""
menucharinsertdébut[15]= "Ê"
menucharinsertfin[15]= ""
menucharinsertdébut[16]= "ë"
menucharinsertfin[16]= ""
menucharinsertdébut[17]= "Ë"
menucharinsertfin[17]= ""
menucharinsertdébut[18]= "î"
menucharinsertfin[18]= ""
menucharinsertdébut[19]= "Î"
menucharinsertfin[19]= ""
menucharinsertdébut[20]= "ï"
menucharinsertfin[20]= ""
menucharinsertdébut[21]= "Ï"
menucharinsertfin[21]= ""
menucharinsertdébut[22]= "œ"
menucharinsertfin[22]= ""
menucharinsertdébut[23]= "Œ"
menucharinsertfin[23]= ""
menucharinsertdébut[24]= "ô"
menucharinsertfin[24]= ""
menucharinsertdébut[25]= "Ô"
menucharinsertfin[25]= ""
menucharinsertdébut[26]= "ö"
menucharinsertfin[26]= ""
menucharinsertdébut[27]= "Ö"
menucharinsertfin[27]= ""
menucharinsertdébut[28]= "ù"
menucharinsertfin[28]= ""
menucharinsertdébut[29]= "Ù"
menucharinsertfin[29]= ""
menucharinsertdébut[30]= "û"
menucharinsertfin[30]= ""
menucharinsertdébut[31]= "Û"
menucharinsertfin[31]= ""
menucharinsertdébut[32]= "ü"
menucharinsertfin[32]= ""
menucharinsertdébut[33]= "Ü"
menucharinsertfin[33]= ""
menucharinsertdébut[34]= "ÿ"
menucharinsertfin[34]= ""
menucharinsertdébut[35]= "Ÿ"
menucharinsertfin[35]= ""
menucharinsertdébut[36]= "—"
menucharinsertfin[36]= ""
menucharinsertdébut[37]= "–"
menucharinsertfin[37]= ""
menucharinsertdébut[38]= "•"
menucharinsertfin[38]= ""
menucharinsertdébut[39]= "’"
menucharinsertfin[39]= ""
menucharinsertdébut[40]= "« "
menucharinsertfin[40]= " »"
menucharinsertdébut[41]= "“"
menucharinsertfin[41]= "”"
menucharinsertdébut[42]= "|"
menucharinsertfin[42]= ""
menucharinsertdébut[43]= "…"
menucharinsertfin[43]= ""
menucharinsertdébut[44]= "~"
menucharinsertfin[44]= ""
menucharinsertdébut[45]= "#"
menucharinsertfin[45]= ""
menucharinsertdébut[46]= "@"
menucharinsertfin[46]= ""
menucharinsertdébut[47]= "€"
menucharinsertfin[47]= ""
menucharinsertdébut[48]= "¹"
menucharinsertfin[48]= ""
menucharinsertdébut[49]= "²"
menucharinsertfin[49]= ""
menucharinsertdébut[50]= "³"
menucharinsertfin[50]= ""
menucharinsertdébut[51]= "⁴"
menucharinsertfin[51]= ""
menucharinsertdébut[52]= "⁵"
menucharinsertfin[52]= ""
menucharinsertdébut[53]= "⁶"
menucharinsertfin[53]= ""
menucharinsertdébut[54]= "⁷"
menucharinsertfin[54]= ""
menucharinsertdébut[55]= "⁸"
menucharinsertfin[55]= ""
menucharinsertdébut[56]= "⁹"
menucharinsertfin[56]= ""
menucharinsertdébut[57]= "⁰"
menucharinsertfin[57]= ""
menucharinsertdébut[58]= "½"
menucharinsertfin[58]= ""
menucharinsertdébut[59]= "¼"
menucharinsertfin[59]= ""
menucharinsertdébut[60]= "¾"
menucharinsertfin[60]= ""
menucharinsertdébut[61]= "‰"
menucharinsertfin[61]= ""

menucharinsertdébut[62]= ""
menucharinsertfin[62]= ""
menucharinsertdébut[63]= "{{"
menucharinsertfin[63]= "}}"
menucharinsertdébut[64]= "{{|"
menucharinsertfin[64]= "}}"
menucharinsertdébut[65]= "[["
menucharinsertfin[65]= "]]"
menucharinsertdébut[66]= "[[|"
menucharinsertfin[66]= "]]"
menucharinsertdébut[67]= "["
menucharinsertfin[67]= "]"
menucharinsertdébut[68]= "{{subst:"
menucharinsertfin[68]= "}}"
menucharinsertdébut[69]= "{{m|"
menucharinsertfin[69]= "}}"
menucharinsertdébut[70]= "{{a|"
menucharinsertfin[70]= "}}"
menucharinsertdébut[71]= "{{u|"
menucharinsertfin[71]= "}}"
menucharinsertdébut[72]= "{{DEFAULTSORT:"
menucharinsertfin[72]= "}}"
menucharinsertdébut[73]= "[[Catégorie:"
menucharinsertfin[73]= "]]"
menucharinsertdébut[74]= "[[Image:"
menucharinsertfin[74]= "]]"
menucharinsertdébut[75]= "#REDIRECTION[["
menucharinsertfin[75]= "]]"
menucharinsertdébut[76]= "[[Commons:"
menucharinsertfin[76]= "|]]"
menucharinsertdébut[77]= "[[m:"
menucharinsertfin[77]= "|]]"
menucharinsertdébut[78]= "[[n:"
menucharinsertfin[78]= "|]]"
menucharinsertdébut[79]= "[[q:"
menucharinsertfin[79]= "|]]"
menucharinsertdébut[80]= "[[s:"
menucharinsertfin[80]= "|]]"
menucharinsertdébut[81]= "[[b:"
menucharinsertfin[81]= "|]]"
menucharinsertdébut[82]= "[[wikt:"
menucharinsertfin[82]= "|]]"
menucharinsertdébut[83]= "[[v:"
menucharinsertfin[83]= "|]]"
menucharinsertdébut[84]= "{{Références|colonnes="
menucharinsertfin[84]= "}}"

menucharinsertdébut[85]= ""
menucharinsertfin[85]= ""
menucharinsertdébut[86]= "{{#if:"
menucharinsertfin[86]= "}}"
menucharinsertdébut[87]= "{{#ifeq:"
menucharinsertfin[87]= "}}"
menucharinsertdébut[88]= "{{#ifexist:"
menucharinsertfin[88]= "}}"
menucharinsertdébut[89]= "{{#ifexpr:"
menucharinsertfin[89]= "}}"
menucharinsertdébut[90]= "{{#switch:"
menucharinsertfin[90]= "}}"
menucharinsertdébut[91]= "{{#iferror:"
menucharinsertfin[91]= "}}"
menucharinsertdébut[92]= "{{#expr:"
menucharinsertfin[92]= "}}"
menucharinsertdébut[93]= "{{#time:"
menucharinsertfin[93]= "}}"
menucharinsertdébut[94]= "{{#language:"
menucharinsertfin[94]= "}}"
menucharinsertdébut[95]= "{{formatnum:"
menucharinsertfin[95]= "}}"
menucharinsertdébut[96]= "{{lc:"
menucharinsertfin[96]= "}}"
menucharinsertdébut[97]= "{{lcfirst:"
menucharinsertfin[97]= "}}"
menucharinsertdébut[98]= "{{padleft:"
menucharinsertfin[98]= "}}"
menucharinsertdébut[99]= "{{padright:"
menucharinsertfin[99]= "}}"
menucharinsertdébut[100]= "{{uc:"
menucharinsertfin[100]= "}}"
menucharinsertdébut[101]= "{{ucfirst:"
menucharinsertfin[101]= "}}"
menucharinsertdébut[102]= "{{anchorencode"
menucharinsertfin[102]= "}}"
menucharinsertdébut[103]= "{{fullurl"
menucharinsertfin[103]= "}}"
menucharinsertdébut[104]= "{{localurl:"
menucharinsertfin[104]= "}}"
menucharinsertdébut[105]= "{{ns:"
menucharinsertfin[105]= "}}"
menucharinsertdébut[106]= "{{urlencode:"
menucharinsertfin[106]= "}}"
menucharinsertdébut[107]= "{{#rel2abs:"
menucharinsertfin[107]= "}}"
menucharinsertdébut[108]= "{{#titleparts:"
menucharinsertfin[108]= "}}"
menucharinsertdébut[109]= "{{#tag:"
menucharinsertfin[109]= "}}"

menucharinsertdébut[110]= ""
menucharinsertfin[110]= ""
menucharinsertdébut[111]= "{{PAGENAME}}"
menucharinsertfin[111]= ""
menucharinsertdébut[112]= "{{SUBPAGENAME}}"
menucharinsertfin[112]= ""
menucharinsertdébut[113]= "{{BASEPAGENAME}}"
menucharinsertfin[113]= ""
menucharinsertdébut[114]= "{{FULLPAGENAME}}"
menucharinsertfin[114]= ""
menucharinsertdébut[115]= "{{TALKPAGENAME}}"
menucharinsertfin[115]= ""
menucharinsertdébut[116]= "{{SUBJECTPAGENAME}}"
menucharinsertfin[116]= ""
menucharinsertdébut[117]= "{{ARTICLEPAGENAME}}"
menucharinsertfin[117]= ""
menucharinsertdébut[118]= "{{NAMESPACE}}"
menucharinsertfin[118]= ""
menucharinsertdébut[119]= "{{TALKSPACE}}"
menucharinsertfin[119]= ""
menucharinsertdébut[120]= "{{SUBJECTSPACE}}"
menucharinsertfin[120]= ""
menucharinsertdébut[121]= "{{ARTICLESPACE}}"
menucharinsertfin[121]= ""
menucharinsertdébut[122]= "{{REVISIONID}}"
menucharinsertfin[122]= ""
menucharinsertdébut[123]= "{{REVISIONDAY}}"
menucharinsertfin[123]= ""
menucharinsertdébut[124]= "{{REVISIONMONTH}}"
menucharinsertfin[124]= ""
menucharinsertdébut[125]= "{{REVISIONYEAR}}"
menucharinsertfin[125]= ""

/*
menucharinsertdébut[126]= ""
menucharinsertfin[126]= ""
menucharinsertdébut[127]= ""
menucharinsertfin[127]= ""
menucharinsertdébut[128]= ""
menucharinsertfin[128]= "" 
menucharinsertdébut[129]= ""
menucharinsertfin[129]= ""
menucharinsertdébut[130]= ""
menucharinsertfin[130]= ""
menucharinsertdébut[131]= ""
menucharinsertfin[131]= ""
menucharinsertdébut[132]= ""
menucharinsertfin[132]= "" 
menucharinsertdébut[133]= ""
menucharinsertfin[133]= ""
menucharinsertdébut[134]= ""
menucharinsertfin[134]= ""
menucharinsertdébut[135]= ""
menucharinsertfin[135]= ""
menucharinsertdébut[136]= ""
menucharinsertfin[136]= ""
menucharinsertdébut[137]= ""
menucharinsertfin[137]= ""
menucharinsertdébut[138]= ""
menucharinsertfin[138]= ""
menucharinsertdébut[139]= ""
menucharinsertfin[139]= ""             
*/

//////////////////////////////////////////////////////////////////// Résumés de modification
/********************************************************************************
 *   Pour ajouter un résumé, créer simplement une instance supplémentaire       *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).       *
 *   A priori, tous les symboles sont autorisés .                               * 
 ********************************************************************************/
menuresumetexte = new Array();


menuresumetexte[0]="orthographe";
menuresumetexte[1]="typographie";
menuresumetexte[2]="catégorisation";
menuresumetexte[3]="interwiki";
menuresumetexte[4]="wikification";
menuresumetexte[5]="image";
menuresumetexte[6]="mise en page";
menuresumetexte[7]="redirection";
menuresumetexte[8]="relecture";
menuresumetexte[9]="style";
menuresumetexte[10]="revert";
menuresumetexte[11]="réorganisation";
menuresumetexte[12]="réponse";
menuresumetexte[13]="maintenance";
menuresumetexte[14]="évaluation Wikipédia 1.0";
menuresumetexte[15]="création homonymie";
menuresumetexte[16]="ajout de bandeau";
menuresumetexte[17]="infobox";
menuresumetexte[18]="références";
menuresumetexte[19]="retouche de la modification précédente";


///////////////////// ////////////////////////// /////////////////////////// //////////////////// FIN PARTIE PERSONNALISABLE /////// /////// //////// /////// /////// /////// /////// ///////



// * Récupération des paramètres d'affichage si ils ont été modifiés *

var PleinEcranCookie = getCookie("ClicDroitPleinEcran");
if ((PleinEcranCookie == "") || (PleinEcranCookie == null) || (PleinEcranCookie != "PleinEcran")){
        var PleinEcran = false;
}else{
        var PleinEcran = true;
}

var ClicDroitTColorCookie = getCookie("ClicDroitTColor");
if ((ClicDroitTColorCookie != "") && (ClicDroitTColorCookie != null)){
        var colorT = "#" + ClicDroitTColorCookie ;
}else{
        var colorT = "#9D9DA1";
}
var ClicDroitTtColorCookie = getCookie("ClicDroitTtColor");
if ((ClicDroitTtColorCookie != "") && (ClicDroitTtColorCookie != null)){
        var colorTt = "#" + ClicDroitTtColorCookie ;
}else{
        var colorTt = "#112233";
}
var ClicDroitbgColorCookie = getCookie("ClicDroitbgColor");
if ((ClicDroitbgColorCookie != "") && (ClicDroitbgColorCookie != null)){
        var colorbg = "#" + ClicDroitbgColorCookie ;
}else{
        var colorbg = "#CCCCCC";
}
var ClicDroitMDColorCookie = getCookie("ClicDroitMDColor");
if ((ClicDroitMDColorCookie != "") && (ClicDroitMDColorCookie != null)){
        var colorMD = "#" + ClicDroitMDColorCookie ;
}else{
        var colorMD = "#DDDDDD";
}
var ClicDroitbdColorCookie = getCookie("ClicDroitbdColor");
if ((ClicDroitbdColorCookie != "") && (ClicDroitbdColorCookie != null)){
        var colorbd = "#" + ClicDroitbdColorCookie ;
}else{
        var colorbd = "#000000";
}
var ClicDroitselColorCookie = getCookie("ClicDroitselColor");
if ((ClicDroitselColorCookie != "") && (ClicDroitselColorCookie != null)){
        var colorsel = "#" + ClicDroitselColorCookie ;
}else{
        var colorsel = "#EEEEEE";
} 
var ClicDroitLineColorCookie = getCookie("ClicDroitLineColor");
if ((ClicDroitLineColorCookie != "") && (ClicDroitLineColorCookie != null)){
        var colorLine = "#" + ClicDroitLineColorCookie ;
}else{
        var colorLine = "#1D1D11";
}
var ClicDroitlienColorCookie = getCookie("ClicDroitlienColor");
if ((ClicDroitlienColorCookie != "") && (ClicDroitlienColorCookie != null)){
        var colorlien = "#" + ClicDroitlienColorCookie ;
}else{
        var colorlien = "#0000FF";
}

var ClicDroitbgTailleCookie = getCookie("ClicDroitbgTaille");
if ((ClicDroitbgTailleCookie != "") && (ClicDroitbgTailleCookie != null)){
        var taillebg = ClicDroitbgTailleCookie ;
}else{
        var taillebg = 250;
}
var ClicDroitListeTailleCookie = getCookie("ClicDroitListeTaille");
if ((ClicDroitListeTailleCookie != "") && (ClicDroitListeTailleCookie != null)){
        var TailleListe = ClicDroitListeTailleCookie ;
}else{
        var TailleListe = 300;
}
var ClicDroitModifTailleCookie = getCookie("ClicDroitModifTaille");
if ((ClicDroitModifTailleCookie != "") && (ClicDroitModifTailleCookie != null)){
        var TailleModif = ClicDroitModifTailleCookie ;
}else{
        var TailleModif = 385;
}
var ClicDroitOptionsTailleCookie = getCookie("ClicDroitOptionsTaille");
if ((ClicDroitOptionsTailleCookie != "") && (ClicDroitOptionsTailleCookie != null)){
        var TailleOptions = ClicDroitListeTailleCookie ;
}else{
        var TailleOptions = 250;
}

var ClicDroitTitreTailleCookie = getCookie("ClicDroitTitreTaille");
if ((ClicDroitTitreTailleCookie != "") && (ClicDroitTitreTailleCookie != null)){
        var tailleTitre = ClicDroitTitreTailleCookie ;
}else{
        var tailleTitre = 12;
}
var ClicDroitfontTailleCookie = getCookie("ClicDroitfontTaille");
if ((ClicDroitfontTailleCookie != "") && (ClicDroitfontTailleCookie != null)){
        var taillefont = ClicDroitfontTailleCookie ;
}else{
        var taillefont = 10;
}
var ClicDroitbdTailleCookie = getCookie("ClicDroitbdTaille");
if ((ClicDroitbdTailleCookie != "") && (ClicDroitbdTailleCookie != null)){
        var Taillebd = ClicDroitbdTailleCookie ;
}else{
        var Taillebd = 1;
}

var ClicDroitStylebdCookie = getCookie("ClicDroitStylebd");
if ((ClicDroitStylebdCookie != "") && (ClicDroitStylebdCookie != null)){
        var Stylebd = ClicDroitStylebdCookie ;
}else{
        var Stylebd = "solid";
}

var ClicDroitpoliceCookie = getCookie("ClicDroitStylepolice");
if ((ClicDroitpoliceCookie != "") && (ClicDroitpoliceCookie != null)){
        var police = ClicDroitpoliceCookie ;
}else{
        var police = "Verdana";
}
var ClicDroitOpacityCookie = getCookie("ClicDroitOpacity");
if ((ClicDroitOpacityCookie != "") && (ClicDroitOpacityCookie != null)){
        var Opacity = ClicDroitOpacityCookie ;
}else{
        var Opacity = 0.9;
}

// * Test Navigateur * ( http://javascript.developpez.com/sources/?page=tips#browserdetect )

// convert all characters to lowercase to simplify testing
    var agt=navigator.userAgent.toLowerCase();

    // *** BROWSER VERSION ***
    // Note: On IE5, these return 4, so use is_ie5up to detect IE5.
    var is_major = parseInt(navigator.appVersion);
    var is_minor = parseFloat(navigator.appVersion);

    // Note: Opera and WebTV spoof Navigator.  We do strict client detection.
    // If you want to allow spoofing, take out the tests for opera and webtv.
    var is_nav     = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1) && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
    var is_nav2    = (is_nav && (is_major == 2));
    var is_nav3    = (is_nav && (is_major == 3));
    var is_nav4    = (is_nav && (is_major == 4));
    var is_nav4up  = (is_nav && (is_major >= 4));
    var is_navonly = (is_nav && ((agt.indexOf(";nav") != -1) || (agt.indexOf("; nav") != -1)) );
    var is_nav6    = (is_nav && (is_major == 5));
    var is_nav6up  = (is_nav && (is_major >= 5));
    var is_gecko   = (agt.indexOf('gecko') != -1);
    var is_ie      = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
    var is_ie3     = (is_ie && (is_major < 4));
    var is_ie4     = (is_ie && (is_major == 4) && (agt.indexOf("msie 4")!=-1) );
    var is_ie4up   = (is_ie && (is_major >= 4));
    var is_ie5     = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.0")!=-1) );
    var is_ie5_5   = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.5") !=-1));
    var is_ie5up   = (is_ie && !is_ie3 && !is_ie4);
    var is_ie5_5up = (is_ie && !is_ie3 && !is_ie4 && !is_ie5);
    var is_ie6     = (is_ie && (is_major == 4) && (agt.indexOf("msie 6.")!=-1) );
    var is_ie6up   = (is_ie && !is_ie3 && !is_ie4 && !is_ie5 && !is_ie5_5);

//****************************STYLES  

// * Style Plein écran ( recouvre monobook, modern et vector ) *****
if(PleinEcran==true){
document.write('<style type="text/css">'
+'#mw_contentwrapper{margin-left: 0em !important;}'
+'#mw_content{margin: 0 0 0 0 !important;}'
+'#page-base{height:0em !important;}'
+'#content{margin: 0 0 0 0 !important;}'
+'#column-content{margin: 0 0 0 0 !important;}'
+'#article{margin-left:4px;margin-right:4px;}'
+'</style>');
}

// * Style Zone de modif *****

document.write('<style type="text/css">'
+'#wpTextbox1{margin:0;border:3px double #881111;background-color:white;}'
+'#wpSummary{width:97% !important;}'
+'.editOptions{background-color:transparent;border:none;padding:0.5em;}'
+'</style>');

// * Style pour les menus *****

if(is_ie6up){     
document.write('<style type="text/css">'
+ '#menu_context hr{ display:none; }'      // Pas de lignes horizontales pour IE
+ '#menu_favoris hr{ display:none; }'      // ça donne des menus beaucoup trop longs 
+ '#menu_charinsert hr{ display:none; }'   // c'est mon avis.
+ '#menu_options hr{ display:none; }'      // Chacun est libre de les remettre.
+ '</style>'); 
}else{
document.write('<style type="text/css">'
+ '#menu_context hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+';  }'
+ '#menu_favoris hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+'; }'
+ '#menu_charinsert hr{ margin: .1em 0.1em .1em 0.1em;background-color:'+ colorLine+';  }'
+ '#menu_options hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+';  }'
+ '</style>');
}

// * Style pour la zone de suggestions (recherche) *****

document.write('<style type="text/css">'
+ '#searchInput2Suggest{ z-index:600;}'
+ '</style>');

// * Ajustement de la position du menu Édition suivant le skin et le mode d'affichage ****

if(PleinEcran==true){
          if(skin=="monobook"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="vector"){ 
                    var Decalx = 20;
                    var Decaly = 63;
          }else if(skin=="modern"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="cologneblue"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="chick"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="simple"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="nostalgia"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="standard"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="myskin"){
                    var Decalx = 5;
                    var Decaly = 0;
          }
}else{
          if(skin=="monobook"){
                    var Decalx = 165;
                    var Decaly = 35;
          }else if(skin=="vector"){ 
                    var Decalx = 180;
                    var Decaly = 143;
          }else if(skin=="modern"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="cologneblue"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="chick"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="simple"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="nostalgia"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="standard"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="myskin"){
                    var Decalx = 5;
                    var Decaly = 0;
          }
}

//****************************FONCTIONS

function supprimerElement(OldElement){



          if(is_nav4up){   //Firefox
                    if(OldElement.parentNode){document=OldElement.parentNode.removeChild(OldElement);}
          }else {
                    if(is_ie6up){  // Internet Explorer
                              OldElement.removeNode(true);
                    }
          }
}

// * Calcul position de la souris + déplacement du menu *

clickOui = false;
base_x = (taillebg/2);
base_y = (tailleTitre*3);

function position(e){
          if(e){
                    position_x = e.pageX;
                    position_y = e.pageY;
          }else{
                    var monBody = document.documentElement || document.body;
                    position_x = "" + (window.event.clientX + monBody.scrollLeft);
                    position_y = "" + (window.event.clientY + monBody.scrollTop);
          }

          if(clickOui && document.getElementById){
                    bloc_x = position_x-base_x;
                    bloc_y = position_y-base_y;
                    var Menu_principal = document.getElementById("menu_context");
                    var Menu_Edition = document.getElementById("menu_charinsert");
                    var Menu_Favoris = document.getElementById("menu_favoris");
                    var Menu_Options = document.getElementById("menu_options");
                    var Menu_Recherche = document.getElementById("searchInput2Suggest");
                    if(is_nav4up){
                              if(Menu_principal){
                                        Menu_principal.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + ";top:" + bloc_y + "px;left:" + bloc_x + "px; z-index: 500; position: absolute;width: " + taillebg + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";opacity:"+Opacity+"; cursor: default; visibility: visible;");
                              }
                              if(Menu_Edition){
                                        Menu_Edition.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 500; position: absolute;width: " + TailleModif + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top: " + (bloc_y-Decaly) + "px; left: " + ((bloc_x-TailleModif)-Decalx) + "px;"); 
                              }
                              if(Menu_Recherche){
                                        supprimerElement(Menu_Recherche);
                              }
                              if(Menu_Favoris){
                                        Menu_Favoris.style.visibility = "hidden";
                              }
                              if(Menu_Options){
                                        Menu_Options.style.visibility = "hidden";
                              }
                    }else {
                              if(is_ie6up){ 
                                        if(Menu_principal){
                                                  Menu_principal.style.left = bloc_x;
                                                  Menu_principal.style.top = bloc_y;
                                                  Menu_principal.style.visibility = "visible";
                                        }
                                        if(Menu_Edition){
                                                  Menu_Edition.style.left = ((bloc_x - TailleModif)-Decalx)
                                                  Menu_Edition.style.top = (bloc_y-Decaly);
                                                  Menu_Edition.style.visibility = "visible";
                                        }
                                        if(Menu_Recherche){
                                                  supprimerElement(Menu_Recherche);
                                        }
                                        if(Menu_Favoris){
                                                  Menu_Favoris.style.visibility = "hidden";

                                        }
                                        if(Menu_Options){
                                                  Menu_Options.style.visibility = "hidden";
                                        }
                              }
                    }
          }
}

// * Ouverture du menu *   ( menu_context + menu_charinsert )

function ouvrir_menu(){
          var MenuContext = document.getElementById("menu_context");
          var Suggestions = document.getElementById("searchInput2Suggest");
          var CharinsertForm = document.getElementById("menu_charinsert");
   
          var PosX_MenuContext = (position_x+OffsetX);
          var PosY_MenuContext = (position_y+OffsetY);

          if(is_nav4up){      // FIREFOX alert("FF" + position_x + " " + position_y);

                    MenuContext.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + ";top:" + (position_y+OffsetY) + "px;left:" + (position_x+OffsetX) + "px; z-index: 500; position: absolute;width: " + taillebg + "px; background-color:" + colorbg + "; font-family:" + police + ";opacity:"+Opacity+";color:" + colorlien + ";opacity:"+Opacity+"; cursor: default; visibility: visible;");
                    if(Suggestions){supprimerElement(Suggestions);}
                    if(CharinsertForm){ CharinsertForm.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 500; position: absolute;width: " + TailleModif + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top: " + ((position_y+OffsetY)-Decaly) + "px; left: " + (((position_x-TailleModif)-Decalx)+OffsetX) + "px;"); }
          }else {
                    if(is_ie6up){     // INTERNET EXPLORER alert("IE" + position_x + " " + position_y);

                              if(CharinsertForm){CharinsertForm.style.top = (position_y-Decaly) ;}
                              if(CharinsertForm){CharinsertForm.style.left = ((position_x - TailleModif)-Decalx);}
                              if(CharinsertForm){CharinsertForm.style.visibility = "visible"}
                              if(Suggestions){supprimerElement(Suggestions);}

                              MenuContext.style.top = position_y;
                              MenuContext.style.left = position_x;
                              MenuContext.style.visibility = "visible";
                    }
          }
          return(false);
}

// * Ouverture du menu Favoris*

function ouvrir_menuFavoris(){

          var Favoris = document.getElementById("menu_favoris");
          if(is_nav4up){  // Firefox alert("FF ");
                    if(Favoris){Favoris.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 600; position: absolute; top: " + position_y + "px; left: " + (position_x+70) + "px; background-color:" + colorbg + "; font-family:" + police + "; font-size:" + taillefont + ";opacity:"+Opacity+"; color: " + colorlien + "; cursor: default; visibility: visible;");}
          }else {
                    if(is_ie6up){  // Internet Explorer alert("IE ");
                              if(Favoris){Favoris.style.top = position_y;}
                              if(Favoris){Favoris.style.left = (position_x+70);}
                              if(Favoris){Favoris.style.visibility = "visible";}
                    }
          }
}

// * Fermeture du menu *

function fermer_menu(){
     if (document.getElementById){
          var MenuContext = document.getElementById("menu_context");
          var Suggestions = document.getElementById("searchInput2Suggest");
          if(Suggestions){supprimerElement(Suggestions);}
          MenuContext.style.top = 0;
          MenuContext.style.left = 0;
          MenuContext.style.visibility = "hidden";
          fermer_menuFavoris();
          fermer_menuEdit();
          fermer_menu_options()
     }
}

// * Fermeture du menu Favoris *

function fermer_menuEdit(){
     if (document.getElementById){
          var CharinsertForm = document.getElementById("menu_charinsert");
          if(CharinsertForm){CharinsertForm.style.top = 0;}
          if(CharinsertForm){CharinsertForm.style.left = 0;}
          if(CharinsertForm){CharinsertForm.style.visibility = "hidden";}
     }
}

// * Fermeture du menu Favoris *

function fermer_menuFavoris(){
     if (document.getElementById){
          var Favoris = document.getElementById("menu_favoris");
          if(Favoris){Favoris.style.top = 0;}
          if(Favoris){Favoris.style.left = 0;}
          if(Favoris){Favoris.style.visibility = "hidden";}
     }
}

// * Ajout d'une page à la liste (Favoris) *

function storePage(){
thisPage = document.location.href;
thisPageTitle = wgPageName;
var pageList = getCookie("pageList");
var pageListTitle = getCookie("pageListTitle");
var linkFound = false;
if (pageList != "" && pageList != null) {
        pSplit = pageList.split(";");
                for (a=0;a<pSplit.length;a++) {
                }
        }
if (!linkFound) {
        if (pageList == null || pageList == ";") {
                pageList = thisPage;
                pageListTitle = thisPageTitle;
        } else {
                pageList += ";" + thisPage;
                pageListTitle += ";" + thisPageTitle;
        }
}
var now = new Date();
var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
setCookie("pageList",pageList,nextYear);
setCookie("pageListTitle",pageListTitle,nextYear);
window.location.reload();
}
 
// * Suppression d'une page de la liste (Favoris) *
 
function removePage(url){
var pageListTitle = getCookie("pageListTitle");
var linkList = ""
if (pageListTitle != "" && pageListTitle != null) {
        pSplitTitle = pageListTitle.split(";");
        for (a=0;a<pSplitTitle.length;a++) {
                if (pSplitTitle[a] != url && pSplitTitle[a] != '') linkList += ";" + pSplitTitle[a];
        }
}
var now = new Date();
var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
setCookie("pageList",linkList,nextYear);
setCookie("pageListTitle",linkList,nextYear);
}

// ********************************* Suppression d'une page de la liste (Checkboxes Favoris) *

function removeFav(){

        var RunRemove = false;
        var CheckFavoris =document.getElementById("favForm").CheckBoxFavoris; 
        if (CheckFavoris.length > 1){ 
                //alert('plus de 1 favoris');
                for (i=0;i<CheckFavoris.length; i++){
                        var CheckType = CheckFavoris[i].getAttribute("type");
                        var CheckName = CheckFavoris[i].getAttribute("name");
                        var CheckValue = CheckFavoris[i].getAttribute("value");
                        var CheckState = CheckFavoris[i].checked;
                        if ((CheckType == "checkbox") && (CheckFavoris[i].checked)){
                                if(PopUp==true){
                                        var suretcertain = confirm( Suppr1FavThis + '\n' + CheckValue.replace(/_/g," ") );  //   texte traduit  : var Suppr1FavThis //
                                }
                                if((suretcertain) || (PopUp=false)){ 
                                        RunRemove = true;
                                        removePage(CheckValue);
                                        //alert('Page ' + CheckValue.replace(/_/g," ") + ' Supprimée');
                                }
                        }
                }
        } else {
        //alert('mois de 1 favoris');
                var CheckType = CheckFavoris.getAttribute("type");
                var CheckName = CheckFavoris.getAttribute("name");
                var CheckValue = CheckFavoris.getAttribute("value");
                var CheckState = CheckFavoris.checked;
                //alert(CheckType +' '+ CheckName +' '+ CheckValue +' '+ CheckState);
                if ((CheckType == "checkbox") && (CheckFavoris.checked)){
                        RunRemove = true;
                        if(PopUp==true){
                                var suretcertain = confirm( Suppr1FavThis + '\n' + CheckValue.replace(/_/g," ") );  //   texte traduit  : var Suppr1FavThis //
                        }
                        if((suretcertain) || (PopUp=false)){ 
                                removePage(CheckValue);
                                //alert('Page ' + CheckValue.replace(/_/g," ") + ' Supprimée');
                        }
                }
        }     
        if(RunRemove == true){
                window.location.reload();
        } else {
                fermer_menuFavoris();
        } 
}

// * Remise à zéro du cookie (Favoris) *
 
function razCookie () {
        if(PopUp==true){
                var suretcertain=confirm(SupprAllFav);   //   texte traduit : var SupprAllFav //
        }
        if((suretcertain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("pageList","",nextYear);
                setCookie("pageListTitle","",nextYear);
                window.location.reload();
        }
}

// * Mise à jour du cookie (Favoris) *
 
function setCookie (cookieName, cookieValue, expires, path) {
document.cookie = escape(cookieName) + '=' + escape(cookieValue) + (expires ? '; EXPIRES=' + expires.toGMTString() : '') + "; PATH=/" ; 
}

// * Interrogation du cookie (Favoris) *
 
function getCookie (cookieName) {
var cookieValue = null;
var posName = document.cookie.indexOf(escape(cookieName) + '=' );
if (posName != -1) {
        var posValue = posName + (escape(cookieName) + '=' ).length;
        var endPos = document.cookie.indexOf(';', posValue) ;
        if (endPos != -1) {
                cookieValue = unescape(document.cookie.substring(posValue, endPos));
        } else {
                cookieValue = unescape(document.cookie.substring(posValue));
        }
}
return cookieValue;
}

// * Insertion de balises Toolbar (Edition) *

function Toolbar(messages_d, messages_f, commentaires, images, id_images, position){
        messages_debut=messages_d.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS');
        messages_fin=messages_f.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS')
        var ImageToolbar = "";
        var ToolbarDiv = document.getElementById("toolbar")
        if (ToolbarDiv){
                if((messages_debut.length > 0)&&(messages_fin.length > 0)){
                        ImageToolbar += '<img id="mw-editbutton-';
                        ImageToolbar += id_images;
                        ImageToolbar += '" class="mw-toolbar-editbutton" height="22" border="0" width="23" src="';
                        ImageToolbar += images;
                        ImageToolbar += '" alt="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" title="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" style="cursor:pointer;" ';
                        ImageToolbar += 'onclick="';
                        ImageToolbar += "javascript:insertTags2('"+messages_debut+"','"+messages_fin+"','')";
                        ImageToolbar += ' "/>';
                }else if((messages_debut.length > 0)||(messages_fin.length > 0)){
                        ImageToolbar += '<img id="mw-editbutton-';
                        ImageToolbar += id_images;
                        ImageToolbar += '" class="mw-toolbar-editbutton" height="22" border="0" width="23" src="';
                        ImageToolbar += images;
                        ImageToolbar += '" alt="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" title="';
                        ImageToolbar += commentaires
                        ImageToolbar += '" style="cursor:pointer;" onclick=javascript:insertTags2(';
                        ImageToolbar += "'";
                        ImageToolbar += messages_debut;
                        ImageToolbar += "','','')";
                        ImageToolbar += ' "/\>';
                }
                var ToolbarContent = ToolbarDiv.innerHTML;
                if(position != "Fin"){                
                        ToolbarDiv.innerHTML = ImageToolbar + ToolbarContent;
                }else{
                        ToolbarDiv.innerHTML = ToolbarContent + ImageToolbar;
                }
        }
}

/*   ( Court-circuit de la fonction « insertTags() » de MediaWiki pour permettre d'insérer des espaces ou d'autres caractères problématiques ) 
Pour utiliser cette fonction modifiée, utiliser sur les deux variables de début et fin de tag la méthode suivante : 

         [INSERER_ICI_LA_VARIABLE].replace(" "g,/ZESPACE/).replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') 

La fonction se charge de convertir ces mots magiques à chaque occurrence.
*/

function insertTags2(tagOpenBis, tagCloseBis, sampleText) {    // Nom des variables changé
        var txtarea;
        var tagOpen = tagOpenBis.replace(/ZESPACE/g," ").replace(/ZAPOSTROPHE/g,"'").replace(/ZGUILLEMETS/g,'"');   // Ligne ajoutée : retour à la valeur d'origine
        var tagClose = tagCloseBis.replace(/ZESPACE/g," ").replace(/ZAPOSTROPHE/g,"'").replace(/ZGUILLEMETS/g,'"');   // Ligne ajoutée : retour à la valeur d'origine
        if (document.editform) {
                txtarea = currentFocused;
        } else {
// some alternate form? take the first one we can find
                var areas = document.getElementsByTagName('textarea');
                txtarea = areas[0];
        }
        var selText, isSample = false;

        if (document.selection && document.selection.createRange) { // IE/Opera

//save window scroll position
                if (document.documentElement && document.documentElement.scrollTop) var winScroll = document.documentElement.scrollTop
                else if (document.body) var winScroll = document.body.scrollTop;

//get current selection
                txtarea.focus();
                var range = document.selection.createRange();
                selText = range.text;
//insert tags
                checkSelectedText();
                range.text = tagOpen + selText + tagClose;
//mark sample text as selected
                if (isSample && range.moveStart) {
                        if (window.opera) tagClose = tagClose.replace(/\n/g,'');
                        range.moveStart('character', - tagClose.length - selText.length); 
                        range.moveEnd('character', - tagClose.length);    
                }
                range.select();
//restore window scroll position
                if (document.documentElement && document.documentElement.scrollTop) document.documentElement.scrollTop = winScroll
                else if (document.body) document.body.scrollTop = winScroll;

        } else if (txtarea.selectionStart || txtarea.selectionStart == '0') { // Mozilla

//save textarea scroll position
                var textScroll = txtarea.scrollTop;
//get current selection
                txtarea.focus();
                var startPos = txtarea.selectionStart;
                var endPos = txtarea.selectionEnd;
                selText = txtarea.value.substring(startPos, endPos);
//insert tags
                checkSelectedText();
                txtarea.value = txtarea.value.substring(0, startPos) + tagOpen + selText + tagClose + txtarea.value.substring(endPos, txtarea.value.length);
//set new selection
                if (isSample) {
                        txtarea.selectionStart = startPos + tagOpen.length;
                        txtarea.selectionEnd = startPos + tagOpen.length + selText.length;
                } else {
                        txtarea.selectionStart = startPos + tagOpen.length + selText.length + tagClose.length;
                        txtarea.selectionEnd = txtarea.selectionStart;
                }
//restore textarea scroll position
                txtarea.scrollTop = textScroll;
        }

        function checkSelectedText(){
                if (!selText) {
                        selText = sampleText;
                        isSample = true;
                } else if (selText.charAt(selText.length - 1) == ' ') { //exclude ending space char
                        selText = selText.substring(0, selText.length - 1);
                        tagClose += ' '
                }
        }
} 

// * Insertion de balises à définir (Edition) *

function onclick_balises() {
     defaultbalise = "b";
     var balise = window.prompt(MenuEditTextBaliseBis +"<" + defaultbalise + "></" + defaultbalise + ">", defaultbalise);
     if(balise != null) insertTags2('<' + balise.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + '>','</' + balise.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + '>', '');
}

// * Insertion de résumé (Edition) *

function addToSummary(str){

        var resum = document.editform.wpSummary.value;
        if(resum != 0 && resum.indexOf("*/") < resum.length - 3) {
                document.editform.wpSummary.value += " ; ";
        }
        document.editform.wpSummary.value += str;

}

function changertaille(diff) {
     var ZoneModif = document.getElementById('wpTextbox1');
     var TailleZoneModif = ZoneModif.rows;
//     alert(TailleZoneModif + ' ' + diff + ' ' + (TailleZoneModif+diff) );
     if(diff != 0) {
               ZoneModif.setAttribute('rows', (TailleZoneModif+diff) );
     } else {
          var TailleZoneModifPerso = prompt(MenuEditTextTailleBis, '30');
          if((TailleZoneModifPerso != "") && (TailleZoneModifPerso != null)){
               ZoneModif.setAttribute('rows', TailleZoneModifPerso);
          }
     }
}

// * Menus déroulants *

function menuderoulant(selection){
          window.location= selection.options[selection.selectedIndex].value;
}

// * Fonctions de survol (hover) *

function menu_sel(selec, lienmenu){
     if(selec == 1){
          lienmenu.style.background = colorsel;
     } else {
          lienmenu.style.background =colorbg;
     }
}

function titre_sel(selec, lienmenu){
     if(selec == 1){
          lienmenu.style.background = colorbg;
          lienmenu.style.color = colorlien;
     } else {
          lienmenu.style.background =colorT;
          lienmenu.style.color = colorTt;
     }
}

// **************************** Fonctions pour les options ***

function SetPleinEcran(){
        if(PleinEcran==true)return;
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var certain = confirm(MenuTextOptionReload);
        }else{
                var certain = "OK";
        }
        if((certain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitPleinEcran","PleinEcran",nextYear);
                window.location.reload();
        } 
}

function SetNoPleinEcran(){
        if(PleinEcran==false)return;
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var certain = confirm(MenuTextOptionReload);
        }else{
                var certain = "OK";
        }
        if((certain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitPleinEcran","NoPleinEcran",nextYear);
                window.location.reload();
        }
}

function SetbgColor(){
        var bgColor = prompt(bgColorDefine + colorbg, "");
        if((bgColor != "") && (bgColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbgColor",bgColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetbdColor(){
        var bdColor = prompt(bdColorDefine + colorbd, "");
        if((bdColor != "") && (bdColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbdColor",bdColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetTColor(){
        var TColor = prompt(TColorDefine + colorT, "");
        if((TColor != "") && (TColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTColor",TColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetTtColor(){
        var TtColor = prompt(TtColorDefine + colorTt, "");
        if((TtColor != "") && (TtColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTtColor",TtColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetlienColor(){
        var lienColor = prompt(lienColorDefine + colorlien, "");
        if((lienColor != "") && (lienColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitlienColor",lienColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetselColor(){
        var selColor = prompt(selColorDefine + colorsel, "");
        if((selColor != "") && (selColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitselColor",selColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetMDColor(){
        var MDColor = prompt(MDColorDefine + colorMD, "");
        if((MDColor != "") && (MDColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitMDColor",MDColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetLineColor(){
        var LineColor = prompt(LineColorDefine + colorLine, "");
        if((LineColor != "") && (LineColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitLineColor",LineColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetbgTaille(){
        var bgTaille = prompt(bgTailleDefine + taillebg, "");
        if((bgTaille != "") && (bgTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbgTaille",bgTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetListeTaille(){
        var ListeTaille = prompt(ListeTailleDefine + tailleListe, "");
        if((ListeTaille != "") && (ListeTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitListeTaille",ListeTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetModifTaille(){
        var ModifTaille = prompt(ModifTailleDefine + TailleModif, "");
        if((ModifTaille != "") && (ModifTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitModifTaille",ModifTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetOptionsTaille(){
        var OptionsTaille = prompt(OptionsTailleDefine + TailleOptions, "");
        if((OptionsTaille != "") && (OptionsTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitOptionsTaille",OptionsTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetTitreTaille(){
        var TitreTaille = prompt(TitreTailleDefine + tailleTitre, "");
        if((TitreTaille != "") && (TitreTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTitreTaille",TitreTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetfontTaille(){
        var fontTaille = prompt(fontTailleDefine + taillefont, "");
        if((fontTaille != "") && (fontTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitfontTaille",fontTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetbdTaille(){
        var bdTaille = prompt(bdTailleDefine + Taillebd, "");
        if((bdTaille != "") && (bdTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbdTaille",bdTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetStylebd(){
        var StylebdAsk = prompt(StylebdDefine + Stylebd, "");
        if((StylebdAsk != "") && (StylebdAsk != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitStylebd",StylebdAsk,nextYear);
                        window.location.reload();
                }
        }
}

function SetStylepolice(){
        var Stylepolice = prompt(StylepoliceDefine + police, "");
        if((Stylepolice != "") && (Stylepolice != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitStylepolice",Stylepolice,nextYear);
                        window.location.reload();
                }
        }
}

function SetOpacity(){
        var StyleOpacity = prompt(OpacityDefine + Opacity, "");
        if((StyleOpacity != "") && (StyleOpacity != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitOpacity",StyleOpacity,nextYear);
                        window.location.reload();
                }
        }
}
function Raz_options(){
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var suretcertain = confirm(MenuTextOptionReload);
        }else{
                var suretcertain = "OK";
        }
        if((suretcertain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitMessage","",nextYear);
                setCookie("ClicDroitPleinEcran","",nextYear);
                setCookie("ClicDroitTColor","",nextYear);
                setCookie("ClicDroitTtColor","",nextYear);
                setCookie("ClicDroitbgColor","",nextYear);
                setCookie("ClicDroitMDColor","",nextYear);
                setCookie("ClicDroitbdColor","",nextYear);
                setCookie("ClicDroitselColor","",nextYear);
                setCookie("ClicDroitLineColor","",nextYear);
                setCookie("ClicDroitlienColor","",nextYear);
                setCookie("ClicDroitbgTaille","",nextYear);
                setCookie("ClicDroitListeTaille","",nextYear);
                setCookie("ClicDroitModifTaille","",nextYear);
                setCookie("ClicDroitOptionsTaille","",nextYear);
                setCookie("ClicDroitTitreTaille","",nextYear);
                setCookie("ClicDroitfontTaille","",nextYear);
                setCookie("ClicDroitbdTaille","",nextYear);
                setCookie("ClicDroitStylebd","",nextYear);
                setCookie("ClicDroitStylepolice","",nextYear);
                setCookie("ClicDroitOpacity","",nextYear);
                window.location.reload();
        }
}

function fermer_menu_options(){
        var Options = document.getElementById("menu_options");
        if(Options){Options.style.visibility = "hidden";} 
}

function ouvrir_menu_options(){
        var Options = document.getElementById("menu_options");
        if(Options){
                if(is_nav4up){  // Firefox alert("FF ");
                        Options.setAttribute("style", "display:block;text-align:center;z-index:1000;position:absolute;top:" + position_y + "px;left:5px;width:"+TailleOptions+"px;border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; background-color:"+colorbg+";font-family:" + police + ";font-size:" + taillefont + "px;color:" + colorlien + ";cursor:default;visibility:visible;opacity:"+Opacity+";");
               }else {
                        if(is_ie6up){  // Internet Explorer alert("IE ");
                                Options.style.top = position_y;
                                Options.style.left = 5;
                                Options.style.visibility = "visible";
                        }
                }
        }
}

// **************************** Message de sécurité ***

function HideMessage(){
        var now = new Date();
        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
        setCookie("ClicDroitMessage","Hide",nextYear);
        var Message = document.getElementById("messageAlerte");
        supprimerElement(Message);
}

/* ****  ****  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** 
/////////////////////////////////////////////////////////////// CRÉATION DES CADRES /////////////////////////////////////////////
****  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** ********* */
function MenuContextuel(){

// ********************************************************************************************* MESSAGE DE SECURITE ***
        var HideAlert = "Ne plus afficher ce cadre";
        var EscapeMessage = getCookie("ClicDroitMessage");
        if ((EscapeMessage == "") || (EscapeMessage == null) || (EscapeMessage != "Hide")){
                document.write('<div id="messageAlerte" style="position:absolute;z-index:2000;top:2px;left:170px;border:1px solid black;background-color:white;" >');
                document.write('&nbsp;&nbsp;<a href="' + UrlSiteBis + 'User:' +CURRENTUSER + '/' + skin + '.js&action=edit" >' + wgUserName + '/' + skin + '.js</a> - ');
                document.write('<a href="javascript:HideMessage();" >' + HideAlert + '</a>&nbsp;&nbsp;');
                document.write('</div>');
        }

// ********************************************************************************************* Cadre options ***

     document.write('<div id="menu_options" style="display:block;text-align:center;z-index:1000;position:absolute;top:5px;left:5px;width:'+TailleOptions+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility:hidden;">');
     document.write('<div  onclick="javascript:fermer_menu_options();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextOption + '</div>');


     document.write('<div style="text-align:center;font-size:' + taillefont + 'px;" >' + MenuTextOptionAffichage + '&nbsp;&nbsp;<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetNoPleinEcran();" title="' + MenuTextOptionNoPleinEcranPop + '" style="cursor:pointer;" >' + MenuTextOptionNoPleinEcran + '</span>&nbsp;|&nbsp;<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetPleinEcran();" title="' + MenuTextOptionPleinEcranPop + '" style="cursor:pointer;" >' + MenuTextOptionPleinEcran + '</span></div>');

     document.write('<div style="font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';" >');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbgColor();" title="' + MenuTextOptionbgColorPop + '" >' + MenuTextOptionbgColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorbg + ';color:#AA55FF;" >' + colorbg + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbdColor();" title="' + MenuTextOptionbdColorPop + '" >' + MenuTextOptionbdColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorbd + ';color:#AA55FF;" >' + colorbd + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr  size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTColor();" title="' + MenuTextOptionTColorPop + '" >' + MenuTextOptionTColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorT + ';color:#AA55FF;" >' + colorT + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTtColor();" title="' + MenuTextOptionTtColorPop + '" >' + MenuTextOptionTtColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorTt + ';color:#AA55FF;" >' + colorTt + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetlienColor();" title="' + MenuTextOptionlienColorPop + '" >' + MenuTextOptionlienColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorlien + ';color:#AA55FF;" >' + colorlien + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetselColor();" title="' + MenuTextOptionselColorPop + '" >' + MenuTextOptionselColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorsel + ';color:#AA55FF;" >' + colorsel + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetMDColor();" title="' + MenuTextOptionMDColorPop + '" >' + MenuTextOptionMDColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorMD + ';color:#AA55FF;" >' + colorMD + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetLineColor();" title="' + MenuTextOptionLineColorPop + '" >' + MenuTextOptionLineColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorLine + ';color:#AA55FF;" >' + colorLine + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbgTaille();" title="' + MenuTextOptionbgTaillePop + '" >' + MenuTextOptionbgTaille + '&nbsp;&nbsp;<span style="color:red;" >' + taillebg + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetListeTaille();" title="' + MenuTextOptionListeTaillePop + '" >' + MenuTextOptionListeTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleListe + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetModifTaille();" title="' + MenuTextOptionModifTaillePop + '" >' + MenuTextOptionModifTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleModif + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetOptionsTaille();" title="' + MenuTextOptionOptionsTaillePop + '" >' + MenuTextOptionOptionsTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleOptions + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTitreTaille();" title="' + MenuTextOptionTitreTaillePop + '" >' + MenuTextOptionTitreTaille + '&nbsp;&nbsp;<span style="color:red;" >' + tailleTitre + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetfontTaille();" title="' + MenuTextOptionfontTaillePop + '" >' + MenuTextOptionfontTaille + '&nbsp;&nbsp;<span style="color:red;" >' + taillefont + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbdTaille();" title="' + MenuTextOptionbdTaillePop + '" >' + MenuTextOptionbdTaille + '&nbsp;&nbsp;<span style="color:red;" >' + Taillebd + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetStylebd();" title="' + MenuTextOptionStylebdPop + '" >' + MenuTextOptionStylebd + '&nbsp;&nbsp;<span style="color:green;" >' + Stylebd + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetStylepolice();" title="' + MenuTextOptionStylepolicePop + '" >' + MenuTextOptionStylepolice + '&nbsp;&nbsp;<span style="color:green;" >' + police + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetOpacity();" title="' + MenuTextOptionOpacityPop + '" >' + MenuTextOptionOpacity + '&nbsp;&nbsp;<span style="color:green;" >' + Opacity + '</span>&nbsp;&nbsp;</div>');

     document.write('</div>');

 document.write('<div  onclick="javascript:Raz_options();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorT + ';padding:4px;border-top:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextOptionRazPop + '">' + MenuTextOptionRaz + '</div>');


     document.write('</div>');
// ********************************************************************************************* CADRE NAVIGATION ***

     document.write('<div id="menu_context" style="display:block;text-align:center;z-index:500;position:absolute;top:0px;left:0px;width:'+taillebg+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility:hidden;">');

     document.write('<div  onclick="javascript:fermer_menu();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + '</div>');

     document.write('<div onMouseDown="javascript:clickOui=true;" onmouseup="clickOui=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

     document.write('<div  onclick="javascript:ouvrir_menu_options();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextOptionOpen + '">' + MenuTextOption + '</div>');

     document.write('<hr size="1" />');

document.write('<div id="HistoryLinks" style="text-align:center;font-size:' + taillefont + 'px;" ><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"><a href="javascript:history.go(-1)" target="_self" style="text-decoration:none;color:'+colorlien+'" title="' + MenuTextLastPop + '">\<\<\< ' + MenuTextLast + '</a></span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"><a href="javascript:history.go(1)" target="_self" style="text-decoration:none;color:'+colorlien+'" title="' + MenuTextNextPop + '">' + MenuTextNext + ' \>\>\></a></span></div>');

     document.write('<hr size="1" />');

     document.write('<div style="text-align:center;" ><form id="searchform2" action="/w/index.php"><input name="title" type="hidden" value="Spécial:Recherche"/><input name="search" title="' + MenuTextSearchPop + '" id="searchInput2" accessKey="C" autocomplete="off" /><br /><input name="go" title="' + MenuTextButton1Pop + '" class="searchButton" id="searchGoButton2" type="submit" value="' + MenuTextButton1 + '"/><input name="fulltext" title="' + MenuTextButton2Pop + '" class="searchButton" id="mw-searchButton2" type="submit" value="' + MenuTextButton2 + '"/></form></div>');

     document.onmousemove = position;
     document.oncontextmenu = ouvrir_menu;
                              
//**************************************************** Pages spéciales ***

     document.write('<form><select id="Select_special" align="center" name="menuspecial" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + ';" size="1" onChange="menuderoulant(this)"  >');
     document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextspecial + ' --</option>');
     for(a=0;a<menuspeciallien.length;a++){
          if(menuspecialtexte[a].length > 0){
               if(menuspeciallien[a].length > 0){
                //confirm(menuspeciallien[a] + ' - ' + menuspecialtexte[a]);
                document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + menuspeciallien[a] + '" value="' + menuspeciallien[a] + '" target="' + menuspecialtarget[a] + '">' + menuspecialtexte[a] + '</option>');
               } else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + menuspecialtexte[a] + ' -</option>');
               }
          }
     }
     document.write('</select></form>');

//**************************************************** Actions ***

     document.write('<div style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border-top:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';" ><b>' + MenuTextActions + '</b></div>');

     if(skin=="vector"){
          var pNamespaces = document.getElementById('p-namespaces');
          var caNamespaces = pNamespaces.getElementsByTagName('a');
          for(a=0;a<caNamespaces.length;a++){
               var LienNamespaces = caNamespaces[a].innerHTML;
               var LienNamespacesHtml = caNamespaces[a].innerHTML;
               var LienNamespacesHref = caNamespaces[a].getAttribute("href");
               var LienNamespacestitle = caNamespaces[a].getAttribute("title");
               if(LienNamespacestitle==null){LienNamespacestitle= LienNamespacesHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write("'" + LienNamespacesHref + "', '_self'");
               document.write(');" title="'+LienNamespacestitle+'">' + LienNamespacesHtml + '</div>');
          }
          var pViews = document.getElementById('p-views');
          var caViews = pViews.getElementsByTagName('a');
          for(a=0;a<caViews.length;a++){
               var LienViewHtml = caViews[a].innerHTML;
               var LienViewHref = caViews[a].getAttribute("href");
               var LienViewtitle = caViews[a].getAttribute("title");
               if(LienViewtitle==null){LienViewtitle= LienViewHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write("'" + LienViewHref + "', '_self'");
               document.write(');" title="'+LienViewtitle+'">' + LienViewHtml + '</div>');
          }
     }
     var pCactions = document.getElementById('p-cactions');
     if(pCactions){
          var caActions = pCactions.getElementsByTagName('a');
          for(a=0;a<caActions.length;a++){
               var LienActionHtml = caActions[a].innerHTML;
               var LienActionHref = caActions[a].getAttribute("href");
               var LienActiontitle = caActions[a].getAttribute("title");
               if(LienActiontitle==null){LienActiontitle= LienActionHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write("'" + LienActionHref + "', '_self'");
               document.write(');" title="'+LienActiontitle+'">' + LienActionHtml + '</div>');
          }
     }
     document.write('<form><select id="Select_action" align="center" name="menuaction" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:'+colorlien+'" size="1" onChange="menuderoulant(this)">');
document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextActionBis + ' --</option>');
     for(a=0;a<menuactionlien.length;a++){
          if(menuactiontexte[a].length > 0){
               if(menuactionlien[a].length > 0){
                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + '; font-size:' + taillefont + 'px;cursor:pointer;" style="background-color:'+colorMD+'; font-family:' + police + '; font-size:' + taillefont + 'px;" title="' + menuactionlien[a] + '" value="' + menuactionlien[a] + '" target="' + menuactiontarget[a] + '">' + menuactiontexte[a] + '</option>');
               } else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+'; font-family:' + police + ';color:'+colorTt+'" >- ' + menuactiontexte[a] + ' -</option>');
               }
          }
     }
     document.write('</select></form>');

//**************************************************** Liens personnels ***


     document.write('<div style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border-top:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';" ><b>' + MenuTextPerso + '</b></div>');
     var pPerso = document.getElementById('p-personal');
     if(pPerso){
          var caPerso = pPerso.getElementsByTagName('a');
          for(a=0;a<caPerso.length;a++){
               var LienPersoHtml = caPerso[a].innerHTML;
               var LienPersoHref = caPerso[a].getAttribute("href");
               var LienPersotitle = caPerso[a].getAttribute("title");
               if(LienPersotitle==null){LienPersotitle = LienPersoHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write( "'" + LienPersoHref + "', '_self'");
               document.write( ');" title="'+LienPersotitle+'">' + LienPersoHtml + '</div>');
          }
     }
     if((skin=="standard")||(skin=="cologneblue")||(skin=="nostalgia")){
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Mypage', '_self'");
          document.write( ');" title="' + wgUserName + '">' + wgUserName + '</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Myalk', '_self'");
          document.write( ');" title="Discussion ' + wgUserName + '">Discussion</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Preferences', '_self'");
          document.write( ');" title="références ' + wgUserName + '">Préférences</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Watchlist', '_self'");
          document.write( ');" title="Liste de suivi">Liste de suivi</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Contributions/" +wgUserName+ "', '_self'");
          document.write( ');" title="Contributions">Contributions</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Logout', '_self'");
          document.write( ');" title="Déconnexion">Déconnexion</div>');
     }


//**************************************************** Favoris ***

        document.write('<div><hr size="1" color="' + colorLine + '" /></div>');
        document.write('<div style="text-align:center;font-size:' + taillefont + 'px;" ><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:storePage()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextAddPop + '">' + MenuTextAdd + '</span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:razCookie()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextSupprAllPop + '">' + MenuTextSupprAll + '</span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:ouvrir_menuFavoris()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextSuppr1Pop + '">' + MenuTextSuppr1 + '</span></div>');
        document.write('<div><hr size="1" color="' + colorLine + '" /></div>');
        document.write('<form><select id="Select-fav" align="center" name="menufavoris" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
        document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+'; " >-- ' + MenuTextFav + ' --</option>');
        var pageList = getCookie("pageList");
        var pageListTitle = getCookie("pageListTitle");
        if (pageList != "" && pageList != null) {
                pSplit = pageList.split(";")
                for (a=0;a<pSplit.length;a++) {
                        if (pSplit[a] != '' && pSplit[a] != 'null') {
                                if (pageListTitle != "" && pageListTitle != null) {
                                        pSplitTitle = pageListTitle.split(";")
                                        for (a=0;a<pSplitTitle.length;a++) {
                                                if (pSplitTitle[a] != '' && pSplitTitle[a] != 'null') {
                                                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" " title="' + UrlSite + pSplitTitle[a] + '" value="' + UrlSite + pSplitTitle[a] + '" target="_self">' + pSplitTitle[a] + '</option>');
                                                }
                                        }
                                }
                        }
                }
        } 
        document.write('</select></form>');

//**************************************************** Navigation ***

     document.write('<div style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border-top:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';"><b>' + MenuTextNavig + '</b></div>');
     var Navig = document.getElementsByTagName("div")
     for(i=0;i<Navig.length;i++){
          if ((hasClass(Navig[i], "portlet" )) || (hasClass(Navig[i], "mw_portlet" )) || (hasClass(Navig[i], "portal" )) || (hasClass(Navig[i], "dbx-box" )) ){
               var Id_Navig = Navig[i].getAttribute("id");
               if( (Id_Navig != "p-personal" ) && (Id_Navig != "p-cactions" ) && (Id_Navig != "p-logo" ) && (Id_Navig != "p-lang" )&& (Id_Navig != "p-projects" )&& (Id_Navig != "p-fav" )){
                    var Liens = Navig[i].getElementsByTagName("a")
                    for(b=0;b<Liens.length;b++){
                         href_Lien = Liens[b].getAttribute("href");
                         content_Lien = Liens[b].innerHTML;
                         titleLien = Liens[b].getAttribute("title");
                         if(titleLien==null){titleLien = content_Lien;}
                         document.write('<div id="'+Id_Navig+'" style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
                         document.write( "'" + href_Lien + "', '_self'");
                         document.write( ');" title="' + titleLien + '">' + content_Lien + '</div>');
                    }
                    document.write('<hr size="1" />');
               }
               if (Id_Navig == "p-lang" ){
                    var Liens = Navig[i].getElementsByTagName("a")

                    document.write('<form><select id="Select-lang" align="center" name="menulang" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
                    document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+'; ">-- ' + MenuTextLang + ' --</option>');

                    for(b=0;b<Liens.length;b++){
                         href_Lien = Liens[b].getAttribute("href");
                         content_Lien = Liens[b].innerHTML;
                         document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="'+href_Lien+'" value="'+href_Lien+'" target="_self">' + content_Lien + '</option>');
                    }
                    document.write('</select></form>');
                    document.write('<div ><hr size="1" color="' + colorLine + '" /></div>');
               }
          }
     }
     var div = document.getElementById('autres_projets');
     if((div) && (wgAction=="view")){
          document.write('<form><select id="Select-projects" align="center" name="menuprojects" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
          document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextProjects + ' --</option>');
          var Liens = div.getElementsByTagName('a');
          for(b=0;b<Liens.length;b++){
               href_Lien = Liens[b].getAttribute("href");
               content_Lien = Liens[b].innerHTML;
               document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="'+href_Lien+'" value="'+href_Lien+'" target="_self">' + content_Lien + '</option>');
          }
          document.write('</select></form>');
          document.write('<div ><hr size="1" color="' + colorLine + '" /></div>');
     }
     if((skin=="cologneblue")||(skin=="nostalgia")||(skin=="standard")){
          if((skin=="cologneblue")||(skin=="standard"))var quickbarDiv = document.getElementById("quickbar");
          if(skin=="nostalgia")var quickbarDiv = document.getElementById("topbar");
          var quickbarLinks = quickbarDiv.getElementsByTagName("a");
          if(skin=="standard"){var bdebut=1;}else{var bdebut=0;}
          for(b=bdebut;b<quickbarLinks.length;b++){
               quickbarLinkHref = quickbarLinks[b].getAttribute("href");
               quickbarLinkHtml = quickbarLinks[b].innerHTML;
               quickbarLinkTitle = quickbarLinks[b].getAttribute("title");
               if(quickbarLinkTitle==null){quickbarLinkTitle = quickbarLinkHtml;}
                         document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
                         document.write( "'" + quickbarLinkHref + "', '_self'");
                         document.write( ');" title="' + quickbarLinkTitle + '">' + quickbarLinkHtml + '</div>');
          }
     }
     document.write('<form><select id="Select_navig" align="center" name="menunavig" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
     document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextNavigBis + ' --</option>');
     for(a=0;a<menunaviglien.length;a++){
          if(menunavigtexte[a].length > 0){
               if(menunaviglien[a].length > 0){
                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + menunaviglien[a] + '" value="' + menunaviglien[a] + '" target="' + menunavigtarget[a] + '">' + menunavigtexte[a] + '</option>');
                        }else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + menunavigtexte[a] + ' -</option>');
               }
          } 
     }
     document.write('</select></form>');
     document.write('</div>');

// ********************************************************************************************* CADRE FAVORIS ***

        var TailleOK = (TailleListe-TailleCancel);
        var pageListTitle = getCookie("pageListTitle");
        if (pageListTitle != "" && pageListTitle != null) {
                ListeFavoris = '<div id="menu_favoris" style="display:block;text-align:center;z-index:600;position:absolute;top:0px;left:0px;width:' + TailleListe + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility: hidden;">'
                ListeFavoris += '<div style="color:' + colorTt + ';background-color:' + colorT + ';padding:2px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';font-family:' + police + ';font-size:' + taillefont + 'px;opacity:.8;"><center><b>' + Suppr1Fav1 + '</b></center></div>'
                ListeFavoris += '<hr size="1" />';
                ListeFavoris += '<div id="CheckForm" style="text-align:left;font-family:' + police + ';font-size:' + taillefont + 'px;opacity:.8;">'
                ListeFavoris += '<form id="favForm">'
                pSplitTitle = pageListTitle.split(";")
                for (p=0;p<pSplitTitle.length;p++) {
                        if (pSplitTitle[p] != '' && pSplitTitle[p] != 'null') {
                                ListeFavoris += '<input type="checkbox" value="' + pSplitTitle[p] + '" name="CheckBoxFavoris" /><span style="cursor:pointer;text-align:' + Alignt + ';font-size:' + taillefont + 'px;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(';
                         ListeFavoris += "'" + UrlSite + pSplitTitle[p] + "', '_self'";
                         ListeFavoris +=  ');" title="' + pSplitTitle[p].replace(/_/g," ") + '">' + pSplitTitle[p].replace(/_/g," ") + '</span><br />';
                        }
                }
                ListeFavoris += '<hr size="1" />';
                ListeFavoris += '<input type="button" style="width:' + TailleOK + 'px" value="Supprimer les pages sélectionnées" onclick="removeFav();"/>'
+ '<input type="button" style="width:' +TailleCancel+ 'px" value="Annuler" onclick="fermer_menuFavoris();"/>'
+ '</form>'
+ '</div>'
+ '</div>'
                document.write(ListeFavoris);
        }

// ********************************************************************************************* CADRE EDITION ***

        if (((wgAction == "edit")||(wgAction == "submit"))&&(wgNamespaceNumber>-1)){
                document.write('<div id="menu_charinsert" style="display:block;text-align:center;z-index:500;position:absolute;top:0px;left:0px;width:'+TailleModif+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';padding:0;margin:0;cursor:default;visibility:hidden;">');

                document.write('<div style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';margin-bottom:2px;" ><b>' + MenuEditTextEdit + '</b></div>');
                document.write('<div id="menu_modif" style="text-align:center; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';" >');
                document.write('<div id="TopEdit" ><hr size="1" color="' + colorLine + '" /></div>');

//****************************************************** Taille zone d'édition ***

                var MenuTailleTitle = MenuEditTextTailleTer;
                var MenuTailleText = MenuEditTextTaille;
                document.write('<div id="menu_Taille" style="display:block;text-align:'+ Alignt+'" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTailleTitle + '"  onclick="javascript:changertaille(');
                document.write( "'0');" );
                document.write( '">' + MenuTailleText + '</div>' );

//****************************************************** Toolbar ***

                var ToolBarDiv = document.getElementById("toolbar");
                if(ToolBarDiv){
                        var PresenceToolbar = true;
                        ToolBarDiv.setAttribute("id","OldToolBar");
                }else{
                        var PresenceToolbar = false;
                }
                if(PresenceToolbar == true){
                        var OldToolBar = document.getElementById('OldToolBar');
                        var NewToolbar = document.getElementById('OldToolBar').cloneNode(true);
                        NewToolbar.setAttribute("id", "toolbar");
                        NewToolbar.setAttribute("style", 'text-align:' + Alignt+';display:block;' );
                        supprimerElement(OldToolBar);
                } else {                
                        var NewToolbar= document.createElement("div");
                        NewToolbar.setAttribute("id","toolbar");
                        NewToolbar.setAttribute("style","text-align:center;display:block;");
                }

                var ToolBarParent= document.getElementById("TopEdit");
                var ToolBarNext = ToolBarParent.firstChild;                
                ToolBarParent.insertBefore( NewToolbar, ToolBarNext );

                for(a=0;a<menutoolbarfin.length;a++){
                        if((menutoolbardébut[a].length > 0)||(menutoolbarfin[a].length > 0)){
                                Toolbar(menutoolbardébut[a], menutoolbarfin[a], menutoolbarcomm[a], menutoolbarimage[a], menutoolbarimageId[a], menutoolbarimagePosition[a]);
                        }else{
                                document.write( '</div><hr size="1" color="' + colorLine + '" /><div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;font-family:' + police + ';">');
                        }
                }

//****************************************************** Edittools ***

                document.write( '<hr size="1" />');
                document.write( '<div id="MenuEditools_Balise" style="display:block;text-align:' + Alignt + ';" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"  onclick="javascript:onclick_balises();" title="' + MenuEditTextBaliseTer + '" >'+MenuEditTextBalise+'</div>');
                var EditToolsIndex=1;
                document.write( '<hr size="1" /><div id="MenuEditools_'+EditToolsIndex+'" style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;font-family:' + police + ';">');
                for(a=0;a<menucharinsertfin.length;a++){
                        if(menucharinsertdébut[a].length > 0){
                                if(menucharinsertfin[a].length > 0){
                                        document.write( '<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:insertTags2(');
                                        document.write( "'" + menucharinsertdébut[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + "','" + menucharinsertfin[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + "','')\;");
                                        document.write( '" title="' + menucharinsertdébut[a] + ' &nabla; ' + menucharinsertfin[a] + '" >' + menucharinsertdébut[a] +  menucharinsertfin[a] + '</span> ');
                                }else {
                                        document.write( '<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:insertTags2(');
                                        document.write( "'" + menucharinsertdébut[a] + "','','')\;");
                                        document.write( '" title="' + menucharinsertdébut[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + '">' + menucharinsertdébut[a].replace(/ /g,"ESPACE") + '</span> ');
                                }
                        }else{
                        EditToolsIndex=(EditToolsIndex+1);
                        document.write( '</div><hr size="1" /><div id="MenuEditools_'+EditToolsIndex+'" style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;font-family:' + police + ';">');
                        }
                }
                document.write('</div><hr size="1" />');
                document.write('</div>');

//**************************************************** Publication ***

                var OptionsButtons = document.getElementsByTagName("div");
                for(i=0;i<OptionsButtons.length;i++){
                        if (hasClass(OptionsButtons[i],"editOptions")){
                                var OldOptionsButtons = OptionsButtons[i];
                                var OldOptionsButtonsContent = OptionsButtons[i].innerHTML;
                        }
                }
                var Inputs = document.getElementsByTagName("input");
                for(i=0;i<Inputs.length;i++){
                        var InputName = Inputs[i].getAttribute("name");
                        if(InputName  == "wpEditToken"){
                                var InputToken = Inputs[i];
                                var InputEditTokenValue = Inputs[i].getAttribute("value");
                        }else{
                        continue;                     
                        }
                } 


                var OldResumeSpan = document.getElementById("wpSummaryLabel");
                var ResumeP = document.getElementById("MediaWiki-summary");
                var ResumeSpan = document.getElementById("wpSummaryLabel");
                var NewResume = "";
                var Resume = ResumeSpan.getElementsByTagName("a");
                if((Resume)&&(ResumeP)){
                        for(a=1;a<Resume.length;a++){
                                var ThisResume = Resume[a].innerHTML;                
                                NewResume += '• <span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuEditTextSubmitBis + '" onclick="javascript:addToSummary(';
                                NewResume += "'" + ThisResume + "');";
                                NewResume += '">' + ThisResume + '</span> •';
                        }
                }
                if(ResumeP){
                        for(a=0;a<menuresumetexte.length;a++){
                                if(menuresumetexte[a].length > 0){
                                        NewResume += '• <span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuEditTextSubmitBis + '"  onclick="javascript:addToSummary(';
                                        NewResume += "'" + menuresumetexte[a] + "');";
                                        NewResume += '">' + menuresumetexte[a] + '</a></span> •';
                                }
                        }
                        ResumeSpan.innerHTML = NewResume + '<label for"wpSummary" />';
                }


                var OptionsButtons = document.getElementsByTagName("div");
                for(i=0;i<OptionsButtons.length;i++){
                        if (hasClass(OptionsButtons[i],"editOptions")){
                                var OldOptionsButtons = OptionsButtons[i];
                                var OldOptionsButtonsContent = OptionsButtons[i].innerHTML;
                        }
                }
                var Inputs = document.getElementsByTagName("input");
                for(i=0;i<Inputs.length;i++){
                        var InputName = Inputs[i].getAttribute("name");
                        if(InputName  == "wpEditToken"){
                                var InputToken = Inputs[i];
                                var InputEditTokenValue = Inputs[i].getAttribute("value");
                        }else{
                        continue;                     
                        }
                } 
                document.write('<div style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border-top:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';border-bottom:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';margin-bottom:2px;margin-top:2px;" ><b>' + MenuEditTextSubmit + '</b></div>');
                document.write( '<div id="menu_Publier" class="editOptions" style="display:block;text-align:center; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';"  >' + OldOptionsButtonsContent + '<input name="wpEditToken" type="hidden" value="'+InputEditTokenValue+'" /></div>');
                document.write('</div>');


                var InputSum = OldOptionsButtons.getElementsByTagName("input");
                for(i=0;i<InputSum.length;i++){
                        var InputName = InputSum[i].getAttribute("name");
                        if(InputName  == "wpSummary"){
                                var InputSummary = InputSum[i];
                        }else{
                                continue;                     
                        }
                }
                if((InputSummary)&&(ResumeP))supprimerElement(InputSummary);


                var SummarySpanLabel = OldOptionsButtons.getElementsByTagName("span");
                for(i=0;i<SummarySpanLabel.length;i++){
                        var SpanLabelId = SummarySpanLabel[i].getAttribute("id");
                        if(SpanLabelId == "wpSummaryLabel"){
                                var SummaryBis = SummarySpanLabel[i];
                        }                                
                }
                if((SummaryBis)&&(ResumeP))supprimerElement(SummaryBis);
                if(ResumeP) {
                        supprimerElement(ResumeP);
                }


                if(PleinEcran==true){
                        supprimerElement(OldOptionsButtons);
                        supprimerElement(InputToken);
                }

//**************************************************** Insertion du menu de modification dans la forme ***

                var MenuEdition = document.getElementById("menu_charinsert");
                var EditForme = document.getElementById("editform");
                var EditFormeChild1 = document.getElementById("editpage-copywarn");  
                EditForme.insertBefore( MenuEdition, EditFormeChild1);
        }

//********** Suppression des éléments non nécessaires ***

        if(PleinEcran==true){
                var Cactions = document.getElementById("p-cactions");
                if(Cactions){supprimerElement(Cactions);}
                var Personal = document.getElementById("p-personal");
                if(Personal){supprimerElement(Personal);}
                var ColumnOne = document.getElementById("column-one");
                if(ColumnOne){supprimerElement(ColumnOne);}
                var Sidebox = document.getElementById("sidebox");
                if(Sidebox){supprimerElement(Sidebox);}
                var MwPortlets = document.getElementById("mw_portlets");
                if(MwPortlets){supprimerElement(MwPortlets);}
                var Panel = document.getElementById("panel");
                if(Panel){supprimerElement(Panel);}
                var Head = document.getElementById("head");
                if(Head){supprimerElement(Head);}
                var QuickBar = document.getElementById("quickbar");
                if(QuickBar){supprimerElement(QuickBar);}
                var TopBar = document.getElementById("topbar");
                if(TopBar){supprimerElement(TopBar);}
                var Logo = document.getElementById("logo");
                if(Logo){supprimerElement(Logo);}
                var Footer = document.getElementById("footer");
                if(Footer){supprimerElement(Footer);}
                var Warning = document.getElementById("editpage-copywarn");
                if(Warning){supprimerElement(Warning);}
                var EditTools = document.getElementsByTagName("div");
                for(i=0;i<EditTools.length;i++){
                        if (hasClass(EditTools[i],"mw-editTools")){
                                supprimerElement(EditTools[i]);
                        }
                }

        }

//********** Edition par doubleclick ***


        if((wgAction != "edit")&&(wgAction != "submit")&&(skin=="monobook")){
                if((PleinEcran==true)||(DoubleClicEdit==true)){
                        var DoubleClicAction = "document.location='" + UrlSiteBis + FULLPAGENAME +"\x26action=edit';";
                        var DoubleClicBody = document.getElementById("globalWrapper");
                        DoubleClicBody.setAttribute("ondblclick", DoubleClicAction);
                }
        }
}
addOnloadHook(MenuContextuel);
//</nowiki></pre></source>