var WatchlistDeluxe_ajax = {
  http: function(bundle) {
    // mandatory: bundle.url
    // optional:  bundle.async
    // optional:  bundle.method
    // optional:  bundle.headers
    // optional:  bundle.data
    // optional:  bundle.onSuccess (xmlhttprequest, bundle)
    // optional:  bundle.onFailure (xmlhttprequest, bundle)
    // optional:  bundle.otherStuff OK too, passed to onSuccess and onFailure
    var xmlhttp;
    try {
      xmlhttp = new XMLHttpRequest(); 
    } catch(e) { 
      try {
        xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) { 
        try {
          xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {
          xmlhttp = false
        }
      }
    }
 
    if (xmlhttp) {
      xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4)
          WatchlistDeluxe_ajax.httpComplete(xmlhttp,bundle);
      };
      xmlhttp.open(bundle.method ? bundle.method : "GET",bundle.url,bundle.async == false ? false : true);
      if (bundle.headers) {
        for (var field in bundle.headers)
          try {
            xmlhttp.setRequestHeader(field,bundle.headers[field]);
          } catch(err) { }
      }
      xmlhttp.send(bundle.data ? bundle.data : null); 
    }
    return xmlhttp;
  }, 
  httpComplete: function(xmlhttp,bundle) {
    if (xmlhttp.status == 200 || xmlhttp.status == 302) {
      if (bundle.onSuccess)
        bundle.onSuccess(xmlhttp,bundle);
    } else if (bundle.onFailure) {
      bundle.onFailure(xmlhttp,bundle);
 
    }
  }
};
/*
if((wgCanonicalSpecialPageName == "Watchlist") && document.URL.indexOf("edit") == -1 && document.URL.indexOf("raw") == -1) {
        importStylesheetURI('http://fr.wikipedia.org/w/index.php?title=Utilisateur:Dr_Brains/WatchlistDeluxe.css&action=raw&ctype=text/css');
        addOnloadHook(WatchlistDeluxe_Init);                              
}
*/
function WatchlistDeluxe_Init(){
     var Options = document.getElementById("mw-watchlist-options");
     if(Options) WatchlistDeluxe_ManageRow(Options);
}

var WatchlistDeluxe_TableId = 0;
function WatchlistDeluxe_ManageRow(Node){
     var NextSibling = Node.nextSibling;
     while(NextSibling){
          if(NextSibling.tagName){
               if(NextSibling.tagName.toLowerCase()==="h4"){
                    WatchlistDeluxe_TableId++
                    var Table = document.createElement('table');
                    Table.className = "wikitable";
                    Table.id = "SpecialTable_" + WatchlistDeluxe_TableId;
                    NextSibling.parentNode.insertBefore(Table, NextSibling.nextSibling);
                    NextSibling = Table.nextSibling;
               }else if(NextSibling.tagName.toLowerCase()==="ul"){
                    var Ul = NextSibling;
                    var FirstLi = NextSibling.getElementsByTagName('li')[0];                 
                    if(FirstLi){
                         var TheTable = document.getElementById("SpecialTable_" + WatchlistDeluxe_TableId);
                         WatchlistDeluxe_ManageThisRow(FirstLi, TheTable);
                         FirstLi.parentNode.removeChild(FirstLi);
                    }else{                     
                         NextSibling = NextSibling.nextSibling;
                         Ul.parentNode.removeChild(Ul);
                    }
               }else{
                    NextSibling = NextSibling.nextSibling;
               }
          }else{
               NextSibling = NextSibling.nextSibling;
          }
          if(!confirm("OK ?")) break;
     }
}

function WatchlistDeluxe_ManageThisRow(Li, Table){
     var Class = Li.className.replace(/.*watchlist\-/g, "");  //(mw-line-even watchlist-0-Télévision_tunisienne_1)
     var TR = document.createElement('tr');
     var TD = document.createElement('td');
     TR.appendChild(TD);    
     Table.appendChild(TR);
     try{
          var NSNumber = parseInt(Class.replace(/\-.*/g, ""));
          var NSName = wgFormattedNamespaces[NSNumber]
          var PageTitle = Class.replace(/[^\-]*\-/, "");
          var PageName = (NSName == "" ? "" : NSName + ":") + PageTitle;
          var UserName = getElementsByClass("mw-userlink", Li, "a")[0].title.split(wgFormattedNamespaces[2]+":").join("");
          
     }catch(e){
          TD.innerHTML = Class + " -|- " + Li.innerHTML;
     }
}