if (typeof(autoTool) == 'undefined') { window.autoTool = {}; }

autoTool.correctWiki = function() {
  var obj = {};
	obj.changed = {};
  
  //autoTool.AntiHighlightBleeding(obj, true);
  
	obj.whole = {
	      'plain': [],
				'plainArray': [],
				'plainNode': [],
				'plainStart': [],
				'from': 'whole',
				'keepSel': null
			};
	//autoTool.GetInnerHTML(obj.whole, autoTool.textarea.childNodes[0]);
	obj.whole.code = obj.whole.html;
	//autoTool.RemoveHighlightingWikify(obj.whole, wikify);
	//obj.whole.plain = obj.whole.html;
	obj.whole.plain = autoTool.textarea.childNodes[0].nodeValue;
	//obj.whole.plain = obj.whole.plain.replace(/[\n ]*<br\b[^>]*>[\n ]*()/g, '\n');
	obj.whole.plain = obj.whole.plain.replace(/\xa0/g, ' ');

	autoTool.correctBasic(obj.whole);

	//	split into alternating plain text and {{lang}} template fragments (does not support nested templates)
	var fragment = [];
	var nextPos = 0;
	var regExp = /{{\s*lang\s*\|(.|\n)*?}}/gi;
	while ( (regExpMatch = regExp.exec(obj.whole.plain)) != null) {
		fragment.push(obj.whole.plain.substring(nextPos, regExpMatch.index));
		fragment.push(regExpMatch[0]);
		nextPos = regExp.lastIndex;
	}
	fragment.push(obj.whole.plain.substring(nextPos));

	// cycle through the rules
	for (var i = 0; i < autoTool.typoRulesFind.length; i ++) {

		// cycle through the fragments, jump over {{lang}} templates
		for (var j = 0; j < fragment.length; j = j + 2) {
			fragment[j] = fragment[j].replace(autoTool.typoRulesFind[i], autoTool.typoRulesReplace[i]);
		}
	}

	// re-assemble text
	obj.whole.plain = fragment.join('');
  
  if (obj.whole != null) {
    if (obj.whole.plain != null) {
				autoTool.textarea.childNodes[0].nodeValue = obj.whole.plain;
		}
  }

  addToSummary('+correction automatique');

	return;
};

autoTool.correctBasic = function(obj) {

	// non-breaking space character to normal space
	obj.plain = obj.plain.replace(/\xa0/g, ' ');

	// tab to space
	obj.plain = obj.plain.replace(/ *\t[ \t]*()/g, ' ');

	// remove trailing spaces
	obj.plain = obj.plain.replace(/(\t| |&nbsp;)+\n/g, '\n');

	// remove spaces in empty lines
	obj.plain = obj.plain.replace(/\n( |&nbsp;|\t)+\n/g, '\n\n');

	// empty line before and after headings, spaces around word (lookahead), remove bold, italics, and extra =
	obj.plain = obj.plain.replace(/(^|\n)+(=+) *(.*?) *(=+)(?=(\n|$))/g,
		function(p, p1, p2, p3, p4) {
			p3 = p3.replace(/'{2,}/g, '');
			return('\n\n' + p2 + ' ' + p3 + ' ' + p2 + '\n\n');
		}
	);


	// uppercase well known headings
	var regExp = new RegExp('\\n=+ ' + autoTool.config.text['liens externes'] + '? =+\\n', 'gi');
	obj.plain = obj.plain.replace(regExp, '\n== ' + autoTool.config.text['liens externes'] + ' ==\n');
	regExp = new RegExp('\\n=+ ' + autoTool.config.text['voir aussi'] + ' =+\\n', 'gi');
	obj.plain = obj.plain.replace(regExp, '\n== ' + autoTool.config.text['voir aussi'] + ' ==\n');
	regExp = new RegExp('\\n=+ ' + autoTool.config.text['references'] + '? =+\\n', 'gi');
	obj.plain = obj.plain.replace(regExp, '\n== ' + autoTool.config.text['references'] + ' ==\n');

	// add space after * # : ; (list) and after {| |- |+ | (table), spare #REDIRECT
	obj.plain = obj.plain.replace(/(^|\n)([\*\#\:\;]+|\{\||\|\-|\|\+|\|(?!\})) *()/g, '$1$2 ');
	obj.plain = obj.plain.replace(/(^|\n)# REDIRECT\b/gi, '$1#REDIRECT');
	obj.plain = obj.plain.replace(/ +(?=\n)/g, '');

	// empty line before and after tables
	obj.plain = obj.plain.replace(/\n+(\{\|)/g, '\n\n$1');
	obj.plain = obj.plain.replace(/(\n\|\}([^\}]|$)) *(.*)[\n|$]+/g, '$1\n\n$3\n\n');

	// empty line before and after lists
	obj.plain = obj.plain.replace(/(^|\n)([^\*\#\:\;\n].*)(?=\n[\*\#\:\;])/g, '$1$2\n\n');
	obj.plain = obj.plain.replace(/(^|\n)([\*\#\:\;].*?)(?=\n[^\*\#\:\;\n])/g, '$1$2\n\n');

	// split into lines and change single lines, used to handle tables
	var lines = obj.plain.split('\n');
	obj.plain = '';
	var tableflag = false;

	for (var i = 0; i < lines.length; i ++) {
		var line = lines[i];

		// do not change lines starting with a blank
		if (/^ /.test(line) == false) {

			// detect table
			if (line.match(/^(\{\||\!|\|[^}])/) != null) {
				tableflag = true;
			}
			else if (line.match(/^\|\}/) != null) {
				tableflag = false;
			}

			// changes only to be done in tables
			if (tableflag == true) {

				// add spaces around ||
				line = line.replace(/ *\|\| *()/g, ' || ');
			}

			// changes not to be done in tables
			if (! tableflag) {

				// empty line before and after images
				var regExp = new RegExp('^(\\[\\[(Image|Fichier|' + autoTool.config.text['wikicode image'] + '|' + autoTool.config.text['wikicode fichier'] + '):.*?\\]\\])', 'ig');
				line = line.replace(regExp, '\n$1');

				regExp = new RegExp('(\\[\\[(Image|Fichier|' + autoTool.config.text['wikicode image'] + '|' + autoTool.config.text['wikicode fichier'] + '):.*?(\\[\\[.*?\\]\\].*?)*\\]\\])$', 'ig');
				line = line.replace(regExp, '$1\n');

				// empty line before and after includes
				line = line.replace(/^(\{\{.*?\}\})/g, '\n$1');
				line = line.replace(/(\{\{.*?\}\})$/g, '$1\n');
			}
		}

		// concatenate the lines
		obj.plain += line;
		if (i < lines.length - 1) {
			obj.plain += '\n';
		}
	}

	// remove underscores in wikilinks
	obj.plain = obj.plain.replace(/\[\[(.*?)((\|.*?)|)\]\]/g,
		function (p, p1, p2, p3) {
			p1 = p1.replace(/_/g, ' ');
			return('[[' + p1 + p2 + ']]');
		}
	);

	// remove spaces in wikilinks, protect [[xxx| ]]
	obj.plain = obj.plain.replace(/\[\[ *([^\|\[\]]*?) *\| +\]\]/g, '[[$1|\x00]]');
	obj.plain = obj.plain.replace(/\[\[ *([^\|\[\]]*?) *\| *([^\[\][]*?) *\]\]/g, '[[$1|$2]]');
	obj.plain = obj.plain.replace(/\[\[ *([^\|\[\]]*) *\]\]/g, '[[$1]]');
	obj.plain = obj.plain.replace(/\x00/g, ' ');

	// remove spaces in external links
	obj.plain = obj.plain.replace(/\[ *(.*?) *\](?!\])/g, '[$1]');

	// no space around pipes before curly brackets
	obj.plain = obj.plain.replace(/ +\| +\}\}/g, '|}}');

	// no empty line between headings and includes
	obj.plain = obj.plain.replace(/\n(=+ .*? =+\n)\n+(\{\{.*?\}\})/g, '\n$1$2');

	// spaces in comments
	obj.plain = obj.plain.replace(/(&lt;!--) *(.*?) *(--&gt;)/g, '$1 $2 $3');

	// empty line before and after categories
	var regExp = new RegExp('( |\\n)*(\\[\\[(Catégorie|' + autoTool.config.text['wikicode categorie'] + ')\\s*:[^\\n]*?\\]\\])( |\\n)*', 'gi');
	obj.plain = obj.plain.replace(regExp, '\n\n$2\n\n');

	// categories not separated by empty lines (lookahead)
	regExp = new RegExp('(\\[\\[(Catégorie|' + autoTool.config.text['wikicode categorie'] + ')\\s*:[^\\n]*?\\]\\])\\n*(?=\\[\\[(Catégorie|' + autoTool.config.text['wikicode categorie'] + ')\\s*:[^\\n]*?\\]\\])', 'gi');
	obj.plain = obj.plain.replace(regExp, '$1\n');

	// single empty lines only
	obj.plain = obj.plain.replace(/\n{3,}/g, '\n\n');

	// remove leading and trailing newlines
	obj.plain = obj.plain.replace(/^\n+/, '');
	obj.plain = obj.plain.replace(/\n{2,}$/, '\n');

	return;
};

autoTool.GetInnerHTML = function(obj, currentNode) {

	// initialize string
	if (obj.html == null) {
		obj.html = '';
	}
	if (obj.plain == null) {
		obj.plain = '';
	}
	if (obj.plainArray == null) {
		obj.plainArray = [];
		obj.plainNode = [];
		obj.plainStart = [];
	}

		switch (currentNode.nodeType) {
			case currentNode.TEXT_NODE:
				var value = currentNode.nodeValue;
				value = value.replace(/\n/g, ' '); // important for pasted page content
				obj.plainArray.push(value);        // plain array contains & < > instead of &amp; &lt; &gt;
				obj.plainNode.push(currentNode);
				obj.plainStart.push(obj.plain.length);
				value = value.replace(/&/g, '&amp;');
				value = value.replace(/</g, '&lt;');
				value = value.replace(/>/g, '&gt;');
				obj.html += value;
				obj.plain += value;
				break;
			case currentNode.CDATA_SECTION_NODE:
				obj.html += '<![CDATA[' + currentNode.nodeValue + ']]>';
				break;
			case currentNode.ENTITY_REFERENCE_NODE:
				var value = '&' + currentNode.nodeName + ';';
				obj.plainArray.push(value);
				obj.plainNode.push(currentNode);
				obj.plainStart.push(obj.plain.length);
				value = value.replace(/&/g, '&amp;');
				obj.html += value;
				obj.plain += value;
				break;
	}
	if (value != null) {

	  // array of text fragments
		obj.plainArray.push(value);

		// current text length
		obj.plainLength += value.length;
	}
	return;
};

autoTool.GetStyle = function(element, styleProperty) {

	var styleDocument = element.ownerDocument;

	var style;
	if (element != null) {
		if ( (styleDocument.defaultView != null) && (styleDocument.defaultView.getComputedStyle != null) ) {
			style = styleDocument.defaultView.getComputedStyle(element, null)[styleProperty];
		}
		else {
			style = element.style[styleProperty];
		}
	}
	return(style);
};

autoTool.loadConfig = function() {
  if (typeof(autoTool.config.typoRulesUrl) == 'undefined') { autoTool.config.typoRulesUrl = 'http://fr.wikipedia.org/w/index.php?title=Wikipédia:AutoWikiBrowser/Typos&action=raw'; }
  if (typeof(autoTool.config.myTypoRulesUrl) == 'undefined') { autoTool.config.myTypoRulesUrl = 'http://fr.wikipedia.org/w/index.php?title=Discussion_utilisateur:Elemiah/automationTool.js&action=raw'; }
  if (typeof(autoTool.config.text) == 'undefined') {
    autoTool.config.text = {
      'liens externes':              'Liens externes',
      'voir aussi':                        'Voir aussi',
      'references':                  'Notes et références',
      'wikicode image':              'Image',
			'wikicode fichier':            'Fichier',
			'wikicode categorie':          'Catégorie',
			'wikicode modele':             'Modèle'
    };
  }
};

autoTool.initialisation = function() {
  autoTool.typoRulesFind = [];
  autoTool.typoRulesReplace = [];
  if (typeof(autoTool.config) == 'undefined') { autoTool.config = {}; }
  
  autoTool.loadConfig();
  autoTool.loadTypoRules();
  
  autoTool.addCorrectionBtn();
};

autoTool.loadTypoRules = function() {
  if ( autoTool.typoRulesFind.length > 0 ) return;

  var url;
  for (var i = 0; i < 2; i ++)
  {
    if (i == 1) url=autoTool.config.myTypoRulesUrl;
    else url=autoTool.config.typoRulesUrl;
    
	  autoTool.AjaxRequest('GET', url, null, 'text/plain', function(ajax) {

		  // get response
		  var rulesTxt = ajax.responseText;

		  // parse regexp rules
  		var regExp = /<(?:Typo)?\s+(?:word="(.*?)"\s+)?find="(.*?)"\s+replace="(.*?)"\s*\/?>/g;
	  	while ( (regExpMatch = regExp.exec(rulesTxt)) != null) {

        // check if this is a valid regexp
			  var regExpFind;
			  try {
				  regExpFind = new RegExp(regExpMatch[2], 'gm');
			  }
			  catch (err) {
				  mw.log( 'Invalid regex:\nfind=' + regExpMatch[2] + '\nreplace=' + regExpMatch[3]);
				  continue;
			  }
			  // save regexp and replace
			  autoTool.typoRulesFind.push(regExpFind);
			  autoTool.typoRulesReplace.push(regExpMatch[3]);
		  }
		  return;
	  });
	}
	return;
};

autoTool.addCorrectionBtn = function() {
    var root = document.getElementById('p-namespaces');
    if( !root ) return;
    var node = root.getElementsByTagName( "ul" )[0];
    if ( !node ) return null;

    var span = document.createElement( "span" ); 
    var link = document.createElement( "a" );
    span.appendChild( link );
    link.appendChild( document.createTextNode( "Corriger" ) );
    link.href = "javascript:autoTool.correctWiki();";

    var item = document.createElement( "li" );
    item.appendChild( span );
    item.id = "correctArticle";
 
    node.appendChild( item );
    return;
};

autoTool.AjaxRequest = function(requestMethod, requestUrl, postFields, overrideMimeType, ResponseHandler) {

	var request;
	var headers = {};
	var formData;

	// prepare POST request
	if (requestMethod == 'POST') {

		// assemble string body
		if (typeof(FormData) != 'function') {

			// create boundary
			var boundary = autoTool.CreateRandomString(12);

			// POST header, charset: WebKit workaround http://aautar.digital-radiation.com/blog/?p=1645
			headers['Content-Type'] = 'multipart/form-data; charset=UTF-8; boundary=' + boundary;

			// assemble body data
			formData = '';
			for (var fieldName in postFields) {
				if (postFields.hasOwnProperty(fieldName) == true) {
					formData += '--' + boundary + '\r\n';
					formData += 'Content-Disposition: form-data; name="' + fieldName + '"\r\n\r\n' +  postFields[fieldName] + '\r\n';
				}
			}
			formData += '--' + boundary + '--\r\n';
		}

		// use FormData object
		else {
			formData = new FormData();
			for (var fieldName in postFields) {
				if (postFields.hasOwnProperty(fieldName) == true) {
					formData.append(fieldName, postFields[fieldName]);
				}
			}
		}
	}

		// create new XMLHttpRequest object
		if (typeof(XMLHttpRequest) == 'function') {
			request = new XMLHttpRequest();
		}

		if (request == null) {
			return;
		}

		// open the request
		request.open(requestMethod, requestUrl, true);

		// set the headers
		for (var headerName in headers) {
			if (headers.hasOwnProperty(headerName) == true) {
				request.setRequestHeader(headerName, headers[headerName]);
			}
		}

		// set the mime type
		if ( (request.overrideMimeType != null) && (overrideMimeType != null) ) {
			request.overrideMimeType(overrideMimeType);
		}

		// send the request, catch security violations Opera 0.9.51
		try {
			request.send(formData);
		}
		catch(err) {
			return;
		}

		// wait for the data
		request.onreadystatechange = function() {
			if (request.readyState != 4) {
				return;
			}
			ResponseHandler(request);
			return;
		};
	return;
};

autoTool.CreateRandomString = function(strLength, charSet) {

	if (charSet == null) {
		charSet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789';
	}
	var str = '';
	for (var i = 0; i < strLength; i ++) {
		str += charSet.charAt(Math.floor(Math.random() * charSet.length));
	}
	return(str);
};

autoTool.lunch = function () {
  if (document.readyState == 'complete')
  {
    if (document.getElementsByName('wpTextbox1')[0])
    {
      autoTool.textarea = document.getElementsByName('wpTextbox1')[0];
      autoTool.initialisation();
    }
	}
	else {
	    window.addEventListener('load', autoTool.lunch, false);
	}
    return;
};
autoTool.lunch();