function newEntry(id, url, title) {
    return (new Array(id, url, title));
}

function newBar(id, title) {
    var bar = document.createElement('div');
    bar.setAttribute('class', 'portlet');
    bar.setAttribute('id', id);

    var header = document.createElement('h5');
    header.appendChild( document.createTextNode(title) );
    bar.appendChild(header);

    var div = document.createElement('div');
    div.setAttribute('class', 'pBody');
    bar.appendChild(div);

    return(bar);
}

function fillBar(bar, entries) {
    var divs = bar.getElementsByTagName("div");
    if (divs.length > 0) {
        var startUrl = '/w/index.php?title=';
        var endUrl = '';

	var div = divs[0];

        div.innerHTML = '<ul>';
        for (var i=0; i < entries.length; i++) {
	    var entry = entries[i];
	    div.innerHTML = div.innerHTML
	        + '<li id="' + entry[0] + '">'
	        + '<a href="' + startUrl + entry[1] + endUrl + '">'
	        + entry[2]
	        + '</a></li>';
        }
        div.innerHTML = div.innerHTML + '</ul>';
    }
}

function insertBarBefore(bar, refBarId) {
    var colOne = document.getElementById("column-one");

    if (colOne) {
	var refBar = document.getElementById(refBarId);
	if (refBar) {
	    colOne.insertBefore(bar, refBar);
	}
    }
}

function loadNavBar() {
    var navBar = document.getElementById("p-navigation");

    if (navBar) {
        fillBar(navBar, new Array(
    	    newEntry('n-mainpage', 'Accueil', 'Accueil'),
	    newEntry('n-portal', 'Wikipédia:Accueil', 'Communauté'),
	    newEntry('n-bistro', 'Wikipédia:Le_Bistro', 'Le Bistro'),
	    newEntry('n-currentevents', 'Actualités', 'Actualités'),
	    newEntry('n-special', 'Special:Specialpages', 'Pages spéciales'),
	    newEntry('n-recentchanges', 'Special:Recentchanges', 'Modifications récentes'),
	    newEntry('n-randompage', 'Special:Random', 'Une page au hasard'),
	    newEntry('n-npages', 'Special:Newpages', 'Nouvelles pages'),
	    newEntry('n-help', 'Aide:Aide', 'Aide')
	    ) );
    }
}

addLoadEvent(loadNavBar);

function loadMaintBar() {
    var bar = newBar('p-maint', 'Maintenance');

    if (bar) {
        fillBar(bar, new Array(
	    newEntry('n-pas', 'WP:PàS', 'Pages à supprimer'),
	    newEntry('n-ias', 'WP:IàS', 'Images à supprimer'),
	    newEntry('n-pcp', 'WP:PCP', 'Copyright'),
	    newEntry('n-paf', 'WP:PàF', 'Pages à fusionner'),
	    newEntry('n-lann', 'WP:LANN', 'Neutralité'),
	    newEntry('n-vandalisme', "WP:-(", 'Vandalisme'),
	    newEntry('n-radmin', 'WP:RA', 'Requêtes')
	    ) );

        insertBarBefore(bar, 'p-search');
    }
}

addLoadEvent(loadMaintBar);

function loadQuebecBar() {
    var bar = newBar('p-quebec', 'Projet Québec');

    if (bar) {
        fillBar(bar, new Array(
	    newEntry('pq-projet', 'Wikipédia:Projet/Québec', 'Projet'),
	    newEntry('pq-demandes', 'Wikipédia:Projet/Québec/Articles demandés', 'Articles demandés'),
	    newEntry('pq-categs', 'Wikipédia:Projet/Québec/Catégories', 'Catégories'),
	    newEntry('pq-belgazou', 'Wikipédia:Projet/Québec/Belgazou', 'Belgazou'),
	    newEntry('pq-categ', 'Catégorie:Québec', 'Catégorie Québec')
	    ) );

        insertBarBefore(bar, 'p-search');
    }
}

addLoadEvent(loadQuebecBar);

// auteur : Utilisateur:Dake
// version corrigée - 18.09.2005 - 13:25 
function OptimizedSuivi() {
  if (document.URL.indexOf("http://fr.wikipedia.org/wiki/Special:Watchlist") == 0 ||
      document.URL.indexOf("http://fr.wikipedia.org/w/index.php?title=Special:Watchlist") == 0) {
    var allDays = document.getElementsByTagName("ul");
    for (i=0; i<allDays.length; i++) {
      if (allDays[i].getAttribute("class") == "special") {
        var artList = allDays[i].getElementsByTagName("li");
        for (j=0; j<artList.length; j++) {
          var elem = artList[j];
          var aTag = elem.getElementsByTagName("a");
          var articleName = aTag[0].getAttribute("title");
          var stopWatch  = "/w/index.php?title=" + articleName + "&action=unwatch";

          elem.innerHTML = "(<a href=\"" + stopWatch + "\">stop</a>) " + elem.innerHTML;
        }
      }
    }
  }
}

addLoadEvent(OptimizedSuivi);