// adapté à partir de [[Utilisateur:Chphe/Gadget-Evaluation.js]] (version du 20 février 2010)
 
/* Auteur : Romainhk
 * Date : 8 février 2011
 * Notes : on ne peut pas connaitre l'existence du page d'un wiki étranger sans bidouillage avancé.
    == TODO ==
 * problème avec les noms de page contenant un ":" ; ex. "Hackers: Heroes of the Computer Revolution"
 * initialiser aussi : oldid, projet?
 * ajouter {{Traduction/Références}} ou {{Traduit de}}
 * utiliser une feuille de style
 */
 
if(wgNamespaceNumber==0 && wgAction == "view") addOnloadHook(trad_addTradTab)
//if(wgNamespaceNumber==2 && wgAction == "view") addOnloadHook(trad_addTradTab) //Test
 
//Fonction issue de [[Utilisateur:Romainhk/SuiviDeTraductionFacile.js]]
if (typeof(donnePageDeSuivi) == "undefined") {
    donnePageDeSuivi = function(page, espace) {
        if ( typeof(page) == "undefined" ) page = wgPageName;
        var pds = page.replace(espace+':', '')
        if ( typeof(espace) == "undefined" ) espace = '';
        if ( espace == 'Discussion' )        espace = '';
        if ( espace.length > 0 ) espace = " "+espace;
        var pds = 'Discussion'+espace+':'+pds+'/Traduction';
        return pds;
    };
}
 
/* ====================================
 * ===     Onglet
 * ====================================
 * */
//Ajoute l'onglet "traduire"
function trad_addTradTab() {
    var list = document.getElementById('p-cactions')
    if (!list) return
    list = list.childNodes[3].childNodes[1]
 
    var elt = document.createElement('li')
    elt.innerHTML = "<a id='ca_traduction' href='javascript:trad_launchTrad()'>Traduire</a>"
    list.appendChild(elt)
}
 
function trad_init() {
    traduction = new Object();
    traduction.interwiki = new Array();
    traduction.code = new Array();
    traduction.langue = '';             //Langue de l'article cible
 
    //Définir un nouvel InterWiki
    traduction.iwNouveau = '***';            //Chaîne pour l'option "Ajouter un interwiki"
    traduction.iwNouveauER = /\*\*\*/;            //Expression Régulière associée
    traduction.iwPage = '';             //La page à traduire
    traduction.iwCode = '';             //Code-langue ISO 639-2 de la page à traduire
 
    var lesiw = document.getElementById('p-lang');
    if (lesiw) {
        var lesiwER = new RegExp('interwiki-([^ \s]*)');
        lesiw = lesiw.childNodes[3].childNodes[1]
        for (var child = lesiw.firstChild; child; child = child.nextSibling) {
            if ( lesiwER.exec(child.className) ) {
                 var code = child.className.split("-")[1].split(" ")[0]
                 var page = child.firstChild.href.split("/wiki/")[1]
                 traduction.interwiki[code] = decodeURI(page);
                 traduction.code.push(code)
                 if ( code == "en" ) {
                    traduction.langue = "en";
                 }
            }
        }
        if ( traduction.langue == '' ) {
            if ( traduction.code.length >= 1 ) {
                traduction.langue = traduction.code[0];
            } else {
                traduction.langue = traduction.iwNouveau;
            }
        }
    } else {
        traduction.langue = traduction.iwNouveau;
    }
 
    //Article étrangé à traduire = traduction.interwiki[traduction.langue]; 
    //
    //Sous-page de traduction
    traduction.pageDeSuivi = donnePageDeSuivi( wgPageName, wgFormattedNamespaces[wgNamespaceNumber] );
    // wgFormattedNamespaces[wgNamespaceNumber] == wgPageName.replace(':'+wgTitle, '')
 
    traduction.interet = "";            //Interêt de la demande
    traduction.commentaire = "";          //Commentaire sur la traduction
    traduction.init = "";            //Contenu du « Modèle:Translation/Initialization » de base
 
    traduction.suiviExiste = false;            //La page de suivi existe-t'elle déjà ?
 
    //Liste des wikipedia supportés par le Projet:Traduction
    traduction.wikipedias = new Array('ar','bg','bn','br','bs','ca','cs','da','de','el','en','eo','es','et','eu','fa','fi','fr','gl','he','hr','hu','id','io','is','it','ja','ka','ko','la','lb','lt','lv','ms','nap','nl','nn','no','pl','pt','ro','ru','simple','sk','sl','sr','sv','te','th','tr','uk','vi','wuu','zh');
}
 
function trad_launchTrad() {
    if ( document.URL.match(/&printable/) ) { /* version imprimable */
         return; } 
    var req = new XMLHttpRequest()
    var div = document.getElementById('bodyContent')
 
    TradDiv = document.getElementById('TradDiv')
    if ( !TradDiv ) {
        TradDiv = document.createElement('div')
        TradDiv.id = "TradDiv"
        TradDiv.align = "center"
        TradDiv.style.display = "block"
        div.parentNode.insertBefore(TradDiv, div)
    } else {
        switch (TradDiv.style.display) {
            case 'none':
                  TradDiv.style.display = "block"
                  break;
            case 'block':
                  TradDiv.style.display = "none"
                  return;
        }
    }
    TradDiv.innerHTML = "Initialisation du modèle de page de suivi..."
 
    trad_init()
 
    req.onreadystatechange = function() {
        if(req.readyState == 4) {
            if(req.status==200) {    
                traduction.init = req.responseText.replace(/\<noinclude\>.*\<\/noinclude\>/g, '')
                trad_page_existe(traduction.pageDeSuivi)
            } else if(req.status==404) {
                return
            }
        }//fin readyState == 4
    };
    req.open("GET","/w/index.php?title=Modèle:Translation/Initialization&action=raw", true)
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
    req.send(null)
}
 
/* ====================================
 * ===     Formulaire
 * ====================================
 * */
//Dit si une page existe ou non
function trad_page_existe(page) {
    var req=new XMLHttpRequest()
    req.onreadystatechange = function() {
        if(req.readyState == 4) {
            if(req.status==200) {    
            req.responseText.match(/"length":([0-9]*)/)
                var length = RegExp.$1
                traduction.suiviExiste = (length==0?false:true)
                trad_drawFormulaire( traduction.suiviExiste )
            } else if(req.status==404) {
                trad_drawFormulaire(false)
            }
        }//fin readyState == 4
    };
    req.open("GET","/w/api.php?action=query&prop=info&titles="+page+"&format=json", true)
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
    req.send(null)
}
 
// Ajouter un <td>
function trad_addCell (line, html) {
    var cell = line.insertCell(-1)
    cell.innerHTML = html
    cell.style.padding = '1ex'
    return cell;
}
 
// Choisir un interwiki
function trad_changer_langue (code) {
    var intitule = document.getElementById('intitule')
 
    if ( !code.match(traduction.iwNouveauER) ) {
        trad_drawFormulaireInterwiki(false)
        traduction.langue = code;
        intitule.innerHTML = traduction.interwiki[code].replace(/_/g, ' ')
    } else {
        intitule.innerHTML = "Précisez l'interwiki ci-dessous"
        trad_drawFormulaireInterwiki(true)
    }
}
 
// Ajouter un interet prédéfini
function trad_modif_interet (val_int) {
    var input = document.getElementsByName('interet')[0]
    input.value = val_int
    traduction.interet = val_int
}
 
// Afficher le formulaire
function trad_drawFormulaire (dejasuivi) {
    var tab = document.createElement("table")
    tab.className = 'wikitable'
    tab.id = 'formDemande'
    tab.style.textAlign = 'center'
    tab.style.fontSize = '90%'
 
/* Ligne 1 */
    var line = tab.insertRow(-1)
    var cell = line.insertCell(-1)
    cell.rowSpan = 2
    cell.style.padding = '1ex'
    var lab = document.createElement("label")
    lab.for = 'interwiki'
    lab.style.fontWeight = 'bolder'
    lab.style.color = '#850200'
    lab.innerHTML = "Article d'origine :"
    cell.appendChild(lab)
 
    //Selection de l'interwiki
    var sel = document.createElement("select")
    sel.name = 'interwiki'
    sel.onchange = new Function('onchange', 'trad_changer_langue(this.value);')
    sel.style.verticalAlign = 'middle'
    sel.style.marginLeft = '1ex'
    cell.appendChild(sel)
    cell.appendChild(document.createElement("br"));
 
    //Intitulé de la page étrangère
    var intitule = document.createElement("div")
    intitule.id = 'intitule'
    intitule.style.display = 'block'
    intitule.style.marginTop = '0.5ex'
    intitule.style.fontStyle = 'italic'
    intitule.style.textAlign = 'center'
    cell.appendChild(intitule)
 
    for (var c in traduction.interwiki) {
        var opt = document.createElement("option")
        opt.value = c
        if ( c == traduction.langue ) opt.selected =true;
        opt.innerHTML = c
        sel.add(opt, null)
    }
    //Pour définir un nouveau lien interlangue
    var opt = document.createElement("option")
    opt.value = traduction.iwNouveau
    opt.innerHTML = traduction.iwNouveau
    sel.add(opt, null)
 
    //Interêt
    trad_addCell(line, 
        "<img src='http://upload.wikimedia.org/wikipedia/commons/c/c7/Fairytale_bookmark_gold.png' width='29' onClick=\"javascript:trad_modif_interet('adq')\" alt='Articel de qualité' name='Article d'origine en AdQ' style='margin-right:0.5ex; vertical-align: top;'>"
        +"<img src='http://upload.wikimedia.org/wikipedia/commons/8/8a/Fairytale_bookmark_silver_light.png' width='29' onClick=\"javascript:trad_modif_interet('ba')\" alt='Bon article' name='Article d'origine en BA' style='margin-right:0.9ex; vertical-align: top;'>"
        +"<label for='interet' style='font-weight:bolder; color:#850200'>Interêt :</label><input style='margin-left: 0.5ex;' onChange='traduction.interet=this.value' name='interet' type='textarea' size='43' maxlength='200' />")
    line.align = 'right';
 
/* Ligne 2 */
    line = tab.insertRow(-1)
    //Commentaire
    trad_addCell(line, "<label for='commentaire' style='font-weight:bolder; color:#850200'>Commentaire :</label><input style='margin-left: 0.5ex;' onChange='traduction.commentaire=this.value' name='commentaire' type='textarea' size='43' maxlength='200' />")
    line.align = 'right';
 
/* En dessous : boutton ok */
    TradDiv.innerHTML = ''
    TradDiv.appendChild(tab)
 
    var button  = document.createElement("button")
    button.textContent = "Publier une demande de traduction pour cette page"
    button.onclick = trad_setDemande
    button.id = 'TradButton'
    TradDiv.appendChild(button)
 
    if ( dejasuivi ) {
        // Prévenir que la page de suivi existe déjà
        var avert = document.createElement("div")
        avert.id = 'AvertSuivi'
        avert.innerHTML = "Attention ! <a href='http://fr.wikipedia.org/wiki/"+traduction.pageDeSuivi+"'>Un suivi de traduction</a> existe déjà pour cette page."
        avert.style.color = '#FF0020'
        avert.style.fontStyle = 'italic'
        avert.style.margin = '0.7ex 0'
        TradDiv.appendChild(avert)
    }
    trad_changer_langue(traduction.langue)
}
 
//Ajoute le formulaire de saisie d'interwiki
function trad_drawFormulaireInterwiki (bool) {
    if ( bool ) {
        var table = document.getElementById('formDemande');
        var line = table.insertRow(-1)
        line.id = 'formIw'
        var cell = line.insertCell(-1)
        cell.colSpan = 2
        cell.style.textAlign = 'left'
 
        var autres_langues = ''
        for (var c in traduction.wikipedias) {
             if ( !traduction.interwiki[traduction.wikipedias[c]] ) {
                 autres_langues += "<option value='"+traduction.wikipedias[c]+"'>"
                     +traduction.wikipedias[c]+"</option>\n"
             }
        }
        cell.innerHTML = "<span style='font-weight:bolder; float:left; width:15ex;'>Nouvel interwiki :</span><div style='margin-left: 15ex; text-align:right;'>"
            +"<label for='iwCode' style='font-weight:bolder; color:#850200;'>Code langue :</label> <select onChange='traduction.iwCode=this.value' name='iwCode' style='margin: 0.2ex 1ex 0.2ex 0.4ex;'>"+autres_langues+"</select>"
            +"<label for='iwPage' style='font-weight:bolder; color:#850200;'>Page :</label><input onChange='traduction.iwPage=this.value' name='iwPage' type='textarea' size='43' maxlength='120' style='margin: 0.2ex 0.5ex 0.2ex 0.4ex;' value=\""+traduction.iwPage+"\" />"
    } else {
        var ligne = document.getElementById('formIw')
        if ( ligne ) ligne.parentNode.removeChild(ligne)
    }
}
 
/* ====================================
 * ===     Édition
 * ====================================
 * */
// Lancer l'édition des pages
function trad_setDemande () {
    document.getElementById("TradButton").disabled = true
    if ( traduction.interet != '' ) {
        wpEditPage(traduction.pageDeSuivi, {}, trad_editTraduction, trad_saveFoo, {})
        wpEditPage(wgPageName, {}, trad_edit_article, trad_finaliser, {})
    } else {
        alert("Vous devez préciser l'interêt de la traduction, et éventuellement ajouter un commentaire.\n\n"
            +"* Interêt : pour expliquer au traducteur l’intérêt particulier qu’il y a à traduire cet article.\n"
            +"* Commentaire : permet de faire des remarques pratiques, comme par exemple les chapitres (in)intéressants à traduire, etc.");
        document.getElementById("TradButton").disabled = false
    }
}
 
// Actions avant la sauvegarde : initialisation de la sous-page de traduction
function trad_editTraduction (text, summary, doc, data) {
    summary = "Initialisation d'une demande de traduction grâce à [[Utilisateur:Romainhk/DemandeDeTraductionFacile.js|Gadget-DemandeDeTraductionFacile]]";
    if ( traduction.suiviExiste ) {
        var conf = confirm("Une page de suivi de traduction existe déjà pour cette article. Faut-il la remplacer ?")
        if ( conf ) {
            summary = summary.replace(/^Initialisation/, 'Ré-initialisation')
        } else return;
    }
    text = traduction.init;
    text = text.replace(/\<\/*includeonly\>/g, '')
    // Initialisation avec les valeurs voulues
    if ( !traduction.langue.match(traduction.iwNouveauER) ) {
        text = text.replace(/\{\{\{4\}\}\}/, traduction.langue)
        text = text.replace(/\{\{\{6\}\}\}/, traduction.interwiki[traduction.langue].replace(/_/g, ' ') )
    } else {
        text = text.replace(/\{\{\{4\}\}\}/, traduction.iwCode)
        text = text.replace(/\{\{\{6\}\}\}/, traduction.iwPage)
    }
    text = text.replace(/\{\{\{1\}\}\}/, wgPageName)
    text = text.replace(/\{\{\{8\}\}\}/, traduction.interet)
    text = text.replace(/\{\{\{10\}\}\}/, traduction.commentaire)
    text = text.replace(/\{\{\{2\}\}\}/, '[[Utilisateur:'+wgUserName+'|'+wgUserName+']]')
 
 // wgArticleId : oldid
 
    return { wpTextbox1: text, wpSummary: summary, data: data };
}
 
// Modifications sur l'article ({{Traduction}}, interwiki)
function trad_edit_article (text, summary, doc, data) {
    summary = "Ouverture d'une demande de traduction grâce à [[Utilisateur:Romainhk/DemandeDeTraductionFacile.js|Gadget-DemandeDeTraductionFacile]]";
    if ( !text.match(/\{\{Traduction\}\}/g) ) {
        text = "{{Traduction}}\n" + text;
    }
    //Ajoutons le nouvel interwiki
    if ( traduction.langue.match(traduction.iwNouveauER) ) {
      text += "[["+traduction.iwCode+':'+traduction.iwPage+"]]"
    }
    return { wpTextbox1: text, wpSummary: summary, data: data };
}
 
// Actions après la sauvegarde
function trad_saveFoo () { }
function trad_finaliser () {
    if ( document.getElementById("AvertSuivi") ) {
        document.getElementById("AvertSuivi").style.display = 'none'
    }
    document.getElementById("TradButton").textContent = 'Rafraîchissement de la page...'
    setTimeout('location.reload()', 800)
}
 
/* ====================================
 * ====================================
 * */
//définition de la méthode indexOf et map pour les versions JavaScript inférieures à 1.6
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function(elt /*, from*/)
    {
        var len = this.length;
        var from = Number(arguments[1]) || 0;
        from = (from < 0)
            ? Math.ceil(from)
            : Math.floor(from);
        if (from < 0)
            from += len;
 
        for (; from < len; from++)
        {
            if (from in this &&
                this[from] === elt)
                return from;
        }
        return -1;
    };
}
 
if (!Array.prototype.map) {
    Array.prototype.map = function(fun /*, thisp*/)
    {
        var len = this.length;
        if (typeof fun != "function"){
            throw new TypeError();
        }
        var res = new Array(len);
        var thisp = arguments[1];
        for (var i = 0; i < len; i++)
        {
            if (i in this)
                res[i] = fun.call(thisp, this[i], i, this);
        }
        return res;
    };
}
 
 
/////////////////////////////////////////////////////////from tichou
 
 
// URL encode
if (typeof(wpURLEncode) == "undefined") {
  wpURLEncode = function(string) {
     if (!string) return "";
     return string.replace(/ /g, "_").replace(/[\x00-\x2C\x3B-\x40\x5B-\x5E\x60\x7B-\uFFFF]/g,
        function (match) {
          var c = match.charCodeAt(0);
          var s = new Array();
          if (c < 0x80) s.push(c);
          else if (c < 0x0800) s.push(c >>  6 | 0xC0, c & 0x3F | 0x80);
          else if (c < 0x010000) s.push(c >> 12 | 0xE0, c >>  6 & 0x3F | 0x80, c & 0x3F | 0x80);
          else if (c < 0x110000) s.push(c >> 18 | 0xF0, c >> 12 & 0x3F | 0x80, c >>  6 & 0x3F | 0x80, c & 0x3F | 0x80);
          for (var i = 0, len = s.length; i < len; i++)
             s[i] = (s[i] < 16 ? "%0" : "%") + s[i].toString(16).toUpperCase();
          return s.join("");
        });
  }
}
 
// getElementById
if (typeof(getElementById) == "undefined") {
  getElementById = function(id) {
     var element = null;
     if (this.id == id) {
        element = this;
        element.getElementsByClassName = document.getElementsByClassName;
     }
     for (var child = this.firstChild; !element && child; child = child.nextSibling)
        if (child.nodeType == 1) {
          child.getElementById = getElementById;
          element = child.getElementById(id);
        }
     return element;
  }
}
 
// HTTP
if (typeof(httpRequest) == "undefined") {
  httpRequest = function(url, options, data) {
     var request;
     try {
        request = new XMLHttpRequest();
     } catch(e) {
        try {
          request = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
          try {
             request = new ActiveXObject("Microsoft.XMLHTTP");
          } catch (e) {
             request = false;
          }
        }
     }
 
     if (request) {
        request.onreadystatechange = function() {
          if (request.readyState == 4)
             httpComplete(request, options, data);
        };
        request.open(options.method ? options.method : "GET", url, options.async == false ? false : true);
        if (options.headers) {
          for (var field in options.headers)
             request.setRequestHeader(field, options.headers[field]);
        }
        request.send(options.content ? options.content : null);
     }
     return request;
  }
}
 
if (typeof(httpComplete) == "undefined") {
  httpComplete = function(request, options, data) {
     if (request.status >= 200 && request.status < 300) {
        if (options.onSuccess) {
          var contentType = request.getResponseHeader("Content-Type");
          var regex = new RegExp(/^([^\/]+\/[^;]+).*/);
          contentType = contentType.replace(regex, "$1");
          if (contentType == "text/html") {
             var doc = document.createElement("div");
             doc.innerHTML = request.responseText;
             doc.getElementsByClassName = document.getElementsByClassName;
             doc.getElementById = getElementById;
             options.onSuccess(doc, data);
          } else if (contentType == "text/xml") {
             var xml = null;
             if (navigator.appName == "Microsoft Internet Explorer") {
                xml = new ActiveXObject("Microsoft.XMLDOM");
                xml.async = false;
                xml.loadXML(request.responseText);
             } else if (window.DOMParser) {
                xml = new DOMParser();
                xml = xml.parseFromString(request.responseText, 'text/xml');
             }
             options.onSuccess(xml, data);
          } else {
             options.onSuccess(request, data);
          }
        }
     } else if (options.onFailure) {
        options.onFailure(request, data);
     } else {
        alert(request.statusText);
     }
  }
}
 
// Edit WP page
if (typeof(wpEditPage) == "undefined") {
  wpEditPage = function(title, params, editFunction, saveFunction, data) {
     var url = wgServer + wgScriptPath + '/index.php?title=' + wpURLEncode(title)
                + '&action=edit';
 
     for (var name in params)
        url += '&' + name + '=' + wpURLEncode(params[name]);
 
     var options = { onSuccess: wpSavePage };
 
     data.title = title;
     data.editFunction = editFunction;
     data.saveFunction = saveFunction;
 
     httpRequest(url, options, data);
  }
}
 
// Save WP page
if (typeof(wpSavePage) == "undefined") {
    wpSavePage = function(doc, data) {
        var inputs = doc.getElementById('editform').getElementsByTagName('input');
        var editform = new Array();
        for (var i = 0, len = inputs.length; i < len; i++) {
            var value = inputs[i].value
            if(inputs[i].type != "checkbox" || inputs[i].checked) 
                editform[inputs[i].name] = value;
        }
 
        var wpTextbox1 = doc.getElementById('wpTextbox1').value;
        var wpSummary = editform['wpSummary'];
 
        var regex = new RegExp(/var wgArticleId = "(\d+)";(?:\n.*)*var wgCurRevisionId = "(\d+)";/m);
        var match = regex.exec(doc.textContent);
        if (match) {
            data.pageId = match[1];
            data.curRevId = match[2];
        }
 
        var edit = data.editFunction(wpTextbox1, wpSummary, doc, data);
 
        if (typeof(edit.error) == "undefined") { 
            editform['wpTextbox1'] = edit.wpTextbox1;
            editform['wpSummary'] = edit.wpSummary;
 
            var params = [ 'wpTextbox1', 'wpSummary', 'wpSection',
                                'wpStarttime', 'wpEdittime', 'wpEditToken', 'wpSave' ];
 
            if(editform['wpWatchthis']) params.push('wpWatchthis')
            var content = params.map(function(name) { return name + '=' + encodeURIComponent(editform[name]); }).join("&");
 
            var url = wgServer + wgScriptPath + '/index.php?title=' + wpURLEncode(data.title)
                      + '&action=submit';
 
            var headers = new Array();
            headers['Content-Type'] = 'application/x-www-form-urlencoded';
 
            var options = { method: 'POST', headers: headers, content: content, onSuccess: data.saveFunction };
 
            data = edit.data;
 
            httpRequest(url, options, data);
        } else {
            edit.error(edit.data);
        }
    }
}
 
var wpfunctions = 1;