/**
 * Ajouter une nouvelle fonction à excuter au chargement de la page.
 */ 
function addLoadEvent(func) 
{
  if (window.addEventListener) 
    window.addEventListener("load", func, false);
  else if (window.attachEvent)
    window.attachEvent("onload", func);
}


function startSearch()
{
  var textsearch = document.getElementById('searchInput').value;

  var link = "http://vs.aka-online.de/cgi-bin/globalwpsearch.pl?search=";
  link = link + textsearch;
  link = link + "&timeout=120&minor=1";

  window.location = link;
}

function globalSearch()
{
  var pSearchElement = document.getElementById('searchform');

  var newElement = document.createElement("input");
  newElement.setAttribute("type", "button");
  newElement.setAttribute("name", "globalsearch");
  newElement.setAttribute("class", "searchButton");
  newElement.setAttribute("value", "Recherche globale");
  newElement.setAttribute("onClick", "startSearch()");

  pSearchElement.appendChild(newElement);
}
addLoadEvent(globalSearch);



// Auteur : Anakin
// Dernière mise à jour : 11 décembre 2005
function CategoryTree()
{
  var element = document.getElementById('ca-nstab-category');
  if (element)
  {
    var categoryname = element.firstChild.href;
    categoryname = categoryname.substring(7);

    var wikiname = categoryname.substring(0, categoryname.indexOf('.'));

    var indexofname = categoryname.indexOf(":") + 1;
    categoryname = categoryname.substring(indexofname);

    var indexofampercent = categoryname.indexOf("&");
    if (indexofampercent != -1)
      categoryname = categoryname.substring(0, indexofampercent);

    var li = document.createElement('li');
    li.id = 'ca-categorytree';

    var a = document.createElement('a');
    a.appendChild(document.createTextNode("Arborescence"));
    a.href = 'http://tools.wikimedia.de/~daniel/WikiSense/CategoryTree.php?wiki=' + wikiname + '&art=on&cat=' + categoryname;

    li.appendChild(a);

    document.getElementById('ca-nstab-category').parentNode.appendChild(li);
  }
}
addLoadEvent(CategoryTree);


// Résumé Deluxe 
// Fonction ResumeDeluxeModif
//
// Code : Dake

function ResumeDeluxeModif(content) {
    if (document.editform.wpSummary.value != 0) {
                document.editform.wpSummary.value+=' + ';
        }
        
        document.editform.wpSummary.value+=content;
}

// Résumé Deluxe 
// Fonction ResumeDeluxeModif
//
// Code : Dake

function ResumeDeluxe() {
        // vous pouvez ajouter vos messages ci-dessous - attention aux apostrophes et aux 
        // guillemets qui peuvent casser le script
        var messages = new Array()
        messages[0] = "Revert vandalisme";
        messages[1] = "Orthographe ou Grammaire";
        messages[2] = "Reformulation";
        messages[3] = "Mise en page";
        messages[4] = "Typo";
        messages[5] = "Catégories";
        messages[6] = "Interwiki";
        messages[7] = "Wikification";


        // texte dans les boutons (pour éviter de prendre trop de place)
        var labelBoutons = new Array()
        labelBoutons[0] = "Rev.vand.";
        labelBoutons[1] = "Orth/Gram";
        labelBoutons[2] = "Reform";
        labelBoutons[3] = "MeP";
        labelBoutons[4] = "Typo";
        labelBoutons[5] = "Cat";
        labelBoutons[6] = "Interwiki";
        labelBoutons[7] = "Wikif";

        
        var nombreBoutonsParLigne = 8;
        
        // ne rien toucher ci-dessous
        var mainNode = document.getElementById("wpSummaryLabel");
        if (!mainNode) {
                return;
        }
        var summaryNode = mainNode;
        
        var formButtons = document.createElement("form");
        
        for (var i=0;i<messages.length;i++) {
                if (i%nombreBoutonsParLigne==0) {
                        formButtons.appendChild(document.createElement("p"));
                }
                        
                var nodeInput = document.createElement("input");
                nodeInput.setAttribute("type", "button"); 
                nodeInput.setAttribute("value", labelBoutons[i]); 
                nodeInput.setAttribute("onClick", "ResumeDeluxeModif('" + messages[i] + "')"); 

                formButtons.appendChild(nodeInput); 
        }
        summaryNode.appendChild(formButtons);
        
}

addLoadEvent(ResumeDeluxe);





var suiviManagerAllPages = new Array();
					
function SuiviManagerRegexp(regexp)
{
	var match = new RegExp(regexp);

	for (var i=0;i<suiviManagerAllPages.length;i++) {
		var pageName = suiviManagerAllPages[i].childNodes[0].getAttribute("value");
		if (match.test(pageName)) {
			suiviManagerAllPages[i].childNodes[0].checked=true; 
		}
	}
}
		
function SuiviManagerLiensRouges()
{

	for (var i=0;i<suiviManagerAllPages.length;i++) {
		var pageClass = suiviManagerAllPages[i].childNodes[1].getAttribute("class");
		if (pageClass && pageClass=="new") {
			suiviManagerAllPages[i].childNodes[0].checked=true; 
		}
	}
}

function SuiviManagerDeselect()
{
	for (var i=0;i<suiviManagerAllPages.length;i++) {
		suiviManagerAllPages[i].childNodes[0].checked=false; 
	}
}


function SuiviManager() {
	if (document.URL.indexOf("http://fr.wikipedia.org/wiki/Special:Watchlist/edit")!=0) return; 
	
	var a=0;
	var b=0;			
	var interfaceMsg = new Array(); 
	var regexpList = new Array(); 
	
	//////////////////////////////////////////////////
	// Expressions régulières et liens de l'interface
	//
	// besoin d'aide pour les regexp ? 
	// http://www.commentcamarche.net/javascript/jsregexp.php3
	//////////////////////////////////////////////////

	interfaceMsg[a++]	= "<b>Tout cocher</b>";
	regexpList[b++]		= "^.*"; 
	
	interfaceMsg[a++]	= "Utilisateurs";
	regexpList[b++]		= "^Utilisateur:";
	
	interfaceMsg[a++]	= "Wikipédia:*"; 
	regexpList[b++]		= "^Wikipédia:";
	
	interfaceMsg[a++]	= "Sous-pages de PàS"; 
	regexpList[b++]		= "^Wikipédia:Pages à supprimer\/";

	interfaceMsg[a++]	= "Sous-pages de PàV"; 
	regexpList[b++]		= "^Wikipédia:Pages à vérifier\/";
	
	interfaceMsg[a++]	= "Pages du bistro"; 
	regexpList[b++]		= "^Wikipédia:Le Bistro\/";
	
	interfaceMsg[a++]	= "Images"; 
	regexpList[b++]		= "^Image:";
	
	interfaceMsg[a++]	= "Modèles"; 
	regexpList[b++]		= "^Modèle:";	
	
	interfaceMsg[a++]	= "Aide"; 
	regexpList[b++]		= "^Aide:"; 
	
	interfaceMsg[a++]	= "Catégories"; 
	regexpList[b++]		= "^Catégorie:";	
	
	interfaceMsg[a++]	= "Portails"; 
	regexpList[b++]		= "^Portail:";	

	//////////////////////////////////////////////////
	var topTag = document.getElementById("contentSub")
	
	// récupère toutes les pages
	var watchlist = document.getElementsByTagName("ul");

	for (u=0;u<watchlist.length;u++) {
			var entries = watchlist[u].getElementsByTagName("li"); 
			for (i=0;i<entries.length;i++) {
				suiviManagerAllPages.push(entries[i]);
			}
	}
	
	// prépare la mini-interface
	var str = "<div style=\"background-color:#8ecfe4;font-size:1px;height:8px;border:1px solid #AAAAAA;-moz-border-radius-topright:0.5em;-moz-border-radius-topleft:0.5em;\"></div>"
	+ "<div style=\"border:1px solid #6ac1de;border-top:0px solid white;padding:5px 5px 0 5px;margin-bottom:3ex;\"><p>"
	+ "<div style=\"float: left; text-align: left; white-space: nowrap;\"></div>"
	
	for (var cpt = 0; cpt < interfaceMsg.length; cpt ++) {
		str += "<a href=\"javascript:SuiviManagerRegexp('" + regexpList[cpt] + "')\">"
						+ interfaceMsg[cpt]
						+ "&nbsp;&middot;</a> "
		}
	
		str += "<a href=\"javascript:SuiviManagerLiensRouges()\">"
			+ "Retirer les liens rouges"
			+ "&nbsp;&middot;</a> "
			
		str += "<a href=\"javascript:SuiviManagerDeselect()\">"
			+ "<b>Enlever toutes les coches</b>"
			+ "&nbsp;&middot;</a> "
				
	topTag.innerHTML =	 topTag.innerHTML + "<br clear=all />" + str + "<p></div>"
		
}

addLoadEvent(SuiviManager);

obtenir("AncreTitres");

document.write('<script type="text/javascript" src="' 
            + 'http://en.wikipedia.org/w/index.php?title=User:Lupin/popups.js' 
            + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');

popupUseAPI=true;


//document.write('<script type="text/javascript" src="' 
//             + 'http://fr.wikipedia.org/w/index.php?title=Utilisateur:Guil/popupLocal.js' 
//             + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');

loadJs('Utilisateur:EDUCA33E/LiveRC.js');



//Statistiques
function addArticleTrafficStatistics()
{
  var histo = document.getElementById("ca-history");
  if(histo)
  {
    var lien = document.createElement("a");
    var today = new Date();
    var annee = today.getYear() + 1900;
    var mois = new String(today.getMonth() + 1);
    if(mois.length < 2)
    {
      mois = "0" + mois;
    }
    lien.setAttribute("href", "http://stats.grok.se/fr/" + annee + mois + "/" + wgPageName);
    lien.appendChild(document.createTextNode("Consultation"));
 
    var stats = document.createElement("li");
    stats.setAttribute("id", "ca-stats");
    stats.appendChild(lien);
 
    histo.parentNode.insertBefore(stats, histo.nextSibling);
  }
}
addOnloadHook(addArticleTrafficStatistics);

var Todo_emplacement ="à faire";
importScript('Utilisateur:Micthev/TodoRapide.js');