importScript( "Utilisateur:Deep silence/ReferencesPopup.js" );

function RedirectToCommons() {
  if (wgNamespaceNumber == 6 && document.getElementById("isOnCommons") && document.referrer.match(/http:\/\/commons\.wikimedia\.org/) == null) {
    window.location = "http://commons.wikimedia.org/wiki/File:" + wgTitle + "?uselang=fr"
  }
}

addOnloadHook(RedirectToCommons);

function change_crochet() {
  for (var i = 0; i < document.links.length; i++) {
    if (document.links[i].href.match(/#cite_note-.*/)) {
      tab_spans = document.links[i].getElementsByTagName("span");
      if(tab_spans.length != 2) continue;
      tab_spans[0].firstChild.data = "(";
      tab_spans[1].firstChild.data = ")";
    }
  }
}

addOnloadHook(change_crochet);

function change_et () {
  tab_sup = document.getElementsByTagName("sup") ;
  for(var i = 0; i < tab_sup.length; i++) {
    if (tab_sup[i].parentNode.className.match(/renvois_vers_le_texte/)) tab_sup[i].innerHTML = tab_sup[i].innerHTML.replace(/ et/,",") ;
  }
}

addOnloadHook(change_et);

function change_catlink_class_in_special_pages () {
  if (wgNamespaceNumber < 0 || document.body.className.match(/ns-talk/)) document.getElementById("catlinks").className = "catlinks catlinks-specialpage";
}

addOnloadHook(change_catlink_class_in_special_pages);

function hide_username () {
  document.getElementById("pt-userpage").firstChild.innerHTML="Page utilisateur" ;
}

addOnloadHook(hide_username);

function hide_title () {
  var expression = /(.*) - Wikipédia/;
  expression.exec(document.title);
  document.title = RegExp.$1;
}

addOnloadHook(hide_title);

function move_watchlist () {
  document.getElementById("n-recentchanges").parentNode.insertBefore(document.getElementById("pt-watchlist").cloneNode(true), document.getElementById("n-recentchanges"));
  document.getElementById("pt-watchlist").parentNode.removeChild(document.getElementById("pt-watchlist")) ; 
  document.getElementById("p-Contribuer").innerHTML = document.getElementById("p-Contribuer").innerHTML.replace(/Contribuer/,"Suivi") ;
}

addOnloadHook(move_watchlist);

function change_tools () {
  if (wgNamespaceNumber < 0 && wgTitle != "Recherche") document.getElementById("column-one").removeChild(document.getElementById("p-tb")) ;
  if (wgTitle == "Recherche") wgPageName = document.getElementById("searchText").getAttribute("value") ;
  document.getElementById("t-specialpages").parentNode.innerHTML += "<li><a href=\"/wiki/Sp%C3%A9cial:Index/" + wgPageName + "\">Index</a>" ;
  if (wgTitle != "Recherche") document.getElementById("t-specialpages").parentNode.innerHTML += "<li><a href=\"/w/index.php?title=Sp%E9cial%3ARecherche&search=" + encodeURI(wgTitle) + "&fulltext=Rechercher\">Recherche</a></li>" ;
  document.getElementById("p-tb").innerHTML = document.getElementById("p-tb").innerHTML.replace(/Boîte à outils/,"Outils pour cette page") ;
}

addOnloadHook(change_tools);

function format_footer () {
  if (document.getElementById("bandeau-portail")) document.getElementsByClassName("catlinks")[0].className += " catlinks-with-portail";

  document.getElementById("mw-normal-catlinks").getElementsByTagName("a")[0].innerHTML = '<img alt="" src="http://upload.wikimedia.org/wikipedia/commons/thumb/6/63/Nuvola_apps_window_list.png/20px-Nuvola_apps_window_list.png" width="20" height="20" />' ;

  document.getElementById("bandeau-portail").innerHTML = '<a href="/wiki/Portail:Accueil" title="Portail:Accueil"><img alt="" src="http://upload.wikimedia.org/wikipedia/commons/thumb/c/c9/Portal.svg/20px-Portal.svg.png" width="20" height="20" /></a> : '  + document.getElementById("bandeau-portail").innerHTML ;

  var portails = document.getElementsByClassName("bandeau-portail-texte");
  for (var i = 0; i < portails.length; i++) {
    var expression = /Portail:(.*)/;
    expression.exec(portails[i].firstChild.title);
    portails[i].firstChild.innerHTML = RegExp.$1;
    if (i < portails.length - 1) portails[i].className += " separator";
  }
}


addOnloadHook(format_footer);

/*
 * Rajoute un onglet vers le site de la nomenclature officielle des voies de Paris.
 * Se base sur le titre de l'article pour trouver la fiche correspondante, via Google limité au site v2asp.paris.fr qui héberge la nomenclature.
 *
 * Auteur : Herr Satz à partir de l'onglet Google, ce dernier ayant été écrit par Dake, Hégésippe, Phe
 */

function GoogleQuoteSearch() {
  var result = wgPageName.replace(/_/g, "+");
  if (wgPageName.search(/\(/) == -1)
    result = "%22" + result + "%22";
  return result;
}

function OngletGoogle() {
  var a = document.getElementById("p-cactions");
  if (a && wgNamespaceNumber >= 0) {
    b = a.getElementsByTagName("ul");
    if (b.length > 0) {
      b[0].innerHTML = b[0].innerHTML
        + '<li id="ca-nstab-user">'
        + '<a href="http://www.google.fr/search?q=site%3Av2asp.paris.fr+' + GoogleQuoteSearch() + '&btnI=I\'m_feeling_lucky">'
        + 'Nom. Paris</a>'
        + '</li>';
    }
  }
}
addOnloadHook(OngletGoogle);