/*
==LiveWP==
*Documentation : [[:fr:User:EDUCA33E/LiveRC/Documentation]]
*Authors : [[:fr:User:EDUCA33E]] & [[:fr:User:TiChou]]
*Version: 0.3.8 (beta)
*/

/*
// ///////////////////////////////////// //
== Global variables / Variables globales ==
// ///////////////////////////////////// //

*/

var lrcRCLimit       = 30;      // LiveRC default RC list size;
var lrcPreviewHeight = '250px'; // LiveRC default preview window height;
var lrcAutoCloseDiff = 0;       // LiveRC default Diff behaviour;
var lrcTZ            = '';      // Default time zone (+02:00, 02:00, -0200, -05:45, ...)

/*

// //////////////////// //
== Internationalization ==
// //////////////////// //

*/

// Category translation;
// /////////////////////
var lang_category = 'Catégorie:';

// Menu translation;
// /////////////////
var lang_menu = [ {
  PAUSE:   "Pause",
  PREVIEW: "Prévisualiser",
  LISTS:   "Listes",
  LOWDIFF: "Diff réduit",
  RCLABEL: "RC",
  NOBOTS:  "Sans Bots",
  IPONLY:  "IP seules",
  IPNEW:   "IP et débutant",
  NAMESP:  "Espace",
  XTIMES:  "fois",
  UNDORC:  "Défaire",
  REVERT:  "Révoquer",
  REASON:  "Motif",
  AVERTS:  "Avertir",
  RVMES1:  "[[User:EDUCA33E/LiveRC/Documentation|LiveRC]] : Révocation des modifications de",
  RVMES2:  "retour à la version de",
  EMPTY:   "Blanchir",
  RCSHOW:  "Edit",
  LOGSHOW: "Journaux",
  ABSHOW:  "Filtres"
} ];

var lang_log = {
  UPLOAD:  'Journal d\'import de fichiers',
  NEWUSER: 'Journal des création de comptes utilisateur',
  BLOCK:   'Journal des blocages',
  DELETE:  'Journal des suppressions de page',
  MOVE:    'Journal des renommages et déplacements',
  PROTECT: 'Journal des protections',
  REBLOCK: 'modification'
};

var lang_messages = {
  SAME_EDITOR: 'éditeur précédent identique',
  WARNING: 'Avertissement',
  ON_ARTICLE: 'sur'
};

// Comments test table (regexp format);
// ////////////////////////////////////
var commenttests = [
  { state: BLANKING  , regex: /^Résumé automatique : blanchiment|^[Bb]lanchi/ },
  { state: REPLACED  , regex: /^Résumé automatique : contenu remplacé par/ },
  { state: REVERT , regex: /(LiveRC : )?Révocation |([Bb]ot : )?[Aa]nnulation des modifications|([Bb]ot : )?[Rr]évocation de |^(Undid|Revert to( the)?) revision|^(Undoing|Reverted( \d+)?) edit|^r(e)?v(ert(ing|ed)?)?\b/ } 
];

// Categories test table (regexp format);
var categoriestests = [
  { state: LOCK      , regex: 'Page (semi-protégée|en semi-protection longue)' },
  { state: FULLLOCK  , regex: 'Page protégée' },
  { state: HOMONYMIE , regex: 'Homonymie' },
  { state: ADQ       , regex: 'Article de qualité( contesté)?' },
  { state: BA        , regex: 'Bon article' },
  { state: APDQ      , regex: 'Article potentiellement (bon|de qualité)' },
  { state: COPYRIGHT , regex: 'Article soupçonné de travail sous copyright' },
  { state: PAS       , regex: 'Page proposée à la suppression' },
  { state: FIRE      , regex: 'Wikipompiers' }
];

// LiveRC default template use;
// ////////////////////////////
var lstAvert = [
  { template: "Test 0"              , string: "Test 0"    , hasPage: false },
  { template: "Test 1"              , string: "Test 1"    , hasPage: false },
  { template: "Test 2"              , string: "Test 2"    , hasPage: false },
  { template: "Test 3"              , string: "Test 3"    , hasPage: false },
  { template: "Vandalisme"          , string: "Vandal"    , hasPage: true  },
  { template: "Spammeur"            , string: "Spam"      , hasPage: true  },
  { template: "Motivation_modif"    , string: "Résumé"    , hasPage: true  },
  { template: "Signature"           , string: "Signature" , hasPage: false },
  { template: "Bienvenue_copyright" , string: "Copyright" , hasPage: false }
];

// LiveRC default values for checkboxes
var lrcShowBotChecked   = 'checked';   // change to 'checked' to show only IPs by default
var lrcShowIPChecked   = '';   // change to 'checked' to show only IPs by default
var lrcShowIPNEWChecked   = '';   // change to 'checked' to show only IPs and non-patrolled by default (sysops only)
var lrcShowRCChecked   = 'checked';   // change to 'checked' to hide recent changes by default
var lrcShowLogChecked   = '';   // change to 'checked' to show logs by default
var lrcShowFilterChecked   = '';   // change to 'checked' to show filters by default

// User-specific parameters
importScript('User:'+wgUserName+'/LiveRCparam.js'); // Issue with IE, does not work