/**
 * AncreTitres
 *
 * Cette fonction fournit un lien vers une section de page en cliquant
 * sur le lien [ancre] à droite du titre de section.
 *
 * Auteurs : Pabix, Phe, Bayo -- Correctif apporté par Chphe
 * Date de dernière révision : 26 septembre 2009
 * {{Projet:JavaScript/Script|AncreTitres}}
 */

var AncreTitres = {
    nom_ancre : "[URL]",
    nom_lien_interne : "[[lien]]",
    description : "Obtenir une URL vers cette section",
    descinterne : "Obtenir un [[Lien#interne]]",
    linkcolor : "",
    fontSize : "xx-small",
    fontWeight : "normal",
    afficheE : true,
    afficheI : true
};
function ancrer() {
    if (!document.getElementById('content')) {
        return;
    }
    var titres = document.getElementsByTagName("span");
    var i, l;
    var titre_courant;
    if (!AncreTitres.afficheI && !AncreTitres.afficheE) {
        return;
    }
    for (i = 0, l = titres.length ; i < l ; i++) {
        titre_courant = titres[i].parentNode;
        if (!/mw-headline/gi.test(titres[i].className)) {
            continue;
        }
        var ancre_nom = titres[i].id;

        var small;
        var link;

        var span = document.createElement('span');
        if (AncreTitres.linkcolor != "") {
            span.style.color = AncreTitres.linkcolor;
        }
        span.style.fontSize = AncreTitres.fontSize;
        span.style.fontWeight = AncreTitres.fontWeight;
        span.className = 'noprint ancretitres';

        if (AncreTitres.afficheE) {
            link = document.createElement('a');
            link.innerHTML = AncreTitres.nom_ancre;
            link.title = AncreTitres.description;

            // cf. modif du gadget par Dr Brains du 21 mai 2011 à 19:49
            //link.setAttribute("ancre", wgServer + wgScript + "?title=" + wgPageName + "#" + ancre_nom); 
            // donne de plus jolies URL (/wiki/Nom_page au lieu de /w/index.php?title=Nom_page)
            link.setAttribute("ancre", wgServer + wgArticlePath.replace('$1', wgPageName) + "#" + ancre_nom);
            /*
            link.setAttribute("ancre",
                wgServer + wgArticlePath.replace('$1', encodeURIComponent(wgPageName)
                    .replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28')
                    .replace(/\)/g, '%29').replace(/\*<!-- fix fermeture inopinée commentaire JS -->/g, '%2A').replace(/~/g, '%7E')
                    .replace(/%20/g, '_').replace(/%3A/g, ':').replace(/%2F/g, '/'))
                + "#" + ancre_nom);
            */

            link.setAttribute("onclick", "window.prompt("
                + "'Lien : ', this.getAttribute('ancre'));"
            );
            link.setAttribute("href", "javascript:;");
            span.appendChild(document.createTextNode(' '));
            span.appendChild(link);
        }
        if (AncreTitres.afficheI) {
            link = document.createElement('a');
            link.innerHTML = AncreTitres.nom_lien_interne;
            link.title = AncreTitres.descinterne;

            // TODO : des caractères peuvent être décodés
            link.setAttribute("ancre", "[[" + wgPageName + "#" + ancre_nom + "]]");

            link.setAttribute("onclick", "window.prompt("
                + "'Lien : ', this.getAttribute('ancre'));"
            );
            link.setAttribute("href", "javascript:;");
            span.appendChild(document.createTextNode(' '));
            span.appendChild(link);
        }
        titre_courant.appendChild(span);
    }
}
$(ancrer);