/* {{Projet:JavaScript/Script|TagFilterDeluxe}} */

if (wgCanonicalSpecialPageName === "Recentchanges" || wgCanonicalSpecialPageName === "Newpages" || wgCanonicalSpecialPageName === "Contributions") {
    (function TagFilterDeluxe() {

        var supportLocalStorage, cachedData, lastUpdate, dateNow, dateNowUTC, filterList;

        try {
            supportLocalStorage = !!localStorage.getItem;
        } catch (e) {
            supportLocalStorage = false;
        }

        if (supportLocalStorage) {
            lastUpdate = localStorage.getItem("TagFilterDeluxe_lastUpdate");
            dateNow = new Date();
            dateNowUTC = dateNow.getTime() + dateNow.getTimezoneOffset() * 60000;
            if (lastUpdate && dateNowUTC - lastUpdate < 1000 * 3600 * 24 && dateNowUTC - lastUpdate > 0) {
                cachedData = localStorage.getItem("TagFilterDeluxe_filterList");
            }
        }

        if (cachedData) {
            filterList = cachedData.split('||');
            $(document).ready(createOptions);
        } else {
            $.get(
                wgServer + wgScriptPath + '/api.php',
                {format: "xml", action: "query", list: "tags", tglimit: 499},
                function (objetXML) {
                    var Informations = objetXML.getElementsByTagName('tag'), a, l;
                    filterList = [];
                    for (a = 0, l = Informations.length; a < l; a++) {
                        filterList[a] = Informations[a].getAttribute('name');
                    }
                    if (supportLocalStorage) {
                        localStorage.setItem("TagFilterDeluxe_filterList", filterList.join('||'));
                        localStorage.setItem("TagFilterDeluxe_lastUpdate", dateNowUTC);
                    }
                    $(document).ready(createOptions);
                }
            );
        }

        function createOptions() {
            var Inputs, a, l, cacheElm, cacheName;
            Inputs = document.getElementsByTagName('input');
            for (a = 0, l = Inputs.length; a < l; a++) {
                cacheElm = Inputs[a];
                cacheName = cacheElm.name;
                if (cacheName && cacheName === "tagfilter") {
                    modifyInput(cacheElm);
                    break;
                }
            }
        }

        function modifyInput(input) {
            var select, activeFilter, a, l, filter;
            select = '<select name="tagfilter">'
                + '<option value="">* Aucune *</option>';
            activeFilter = getActiveFilter();
            for (a = 0, l = filterList.length; a < l; a++) {
                filter = filterList[a];
                select += '<option value="' + filter + '"';
                if (filter === activeFilter) {
                    select += ' selected="selected"';
                }
                select += '>' + filter + '</option>';
            }
            select += '</select>';
            $(input).replaceWith(select);
        }

        function getActiveFilter() {
            var m = /[^#]*[&?]tagfilter=([^&#]*)/.exec(document.URL);
            if (m && m.length > 1) {
                return decodeURIComponent(m[1]).replace(/\+/g, " ");
            }
            return false;
        }

    }());
}