//------------------------------------------------------------------------------
//  Personnalisation de [[Projet:JavaScript/Notices/HotCatsMulti]]
//------------------------------------------------------------------------------
function hotcat_UserCustom() {
    window.hotcat_autocommit = false;
}


//------------------------------------------------------------------------------
//  Chargements optimisés
//------------------------------------------------------------------------------
(function () {

    function isInArray(needle, haystack) {
        return $.inArray(needle, haystack) > -1;
    }

    var currentPage = {
        ns: mw.config.get('wgNamespaceNumber'),
        fullname: mw.config.get('wgPageName'),
        action: mw.config.get('wgAction'),
        special: mw.config.get('wgCanonicalSpecialPageName')
    };
    currentPage.isView = currentPage.action === 'view' || currentPage.action === 'purge';
    currentPage.isEdit = currentPage.action === 'edit' || currentPage.action === 'submit';


    //----------------------------------------------------------
    //  [[Wikipédia:LiveRC/Documentation]]
    //----------------------------------------------------------
    if (currentPage.fullname === 'Wikipédia:LiveRC') {
        //importScript('Utilisateur:EDUCA33E/LiveRC.js');  // version en production
        importScript('Utilisateur:Dr Brains/LiveRC.js');  // version bleeding edge
    } else {
        // noter que l'on perd le lien "W" sur les pages utilisateurs (pour ajouter un utilisateur en "suivi LiveRC")
        // cf. fonction LiveWatchInitButton dans le LiveRC.js
        $(function () {
            $('#n-recentchanges').after('<li id="n-liveRC"><a href="' + mw.util.wikiGetlink('Wikipédia:LiveRC') + '">LiveRC</a></li>');
        });
    }

    //----------------------------------------------------------
    //  Fork de [[MediaWiki:Gadget-OngletPurge.js]]
    //----------------------------------------------------------
    if (currentPage.ns >= 0 && currentPage.isView) {
        $(function () {
            mw.util.addPortletLink(
                'p-cactions',
                mw.config.get('wgScript')
                    + '?title=' + mw.util.wikiUrlencode(mw.config.get('wgPageName'))
                    + '&action=purge',
                'Purger',
                'ca-purge',
                'Purger le cache de la page'
            );
            if (mw.config.get('wgAction') === 'purge') {
                $('#ca-purge').addClass('selected');
            }
        });
    }

    //----------------------------------------------------------
    //  Fork de [[MediaWiki:Gadget-OngletJournal.js]]
    //----------------------------------------------------------
    if (currentPage.ns >= 0) {
        $(function () {
            mw.util.addPortletLink(
                'p-cactions',
                mw.config.get('wgScript')
                    + '?title=Spécial:Journal&page='
                    + mw.util.wikiUrlencode(mw.config.get('wgPageName')),
                'Journal',
                'ca-log',
                "Afficher les journaux d'opérations de cette page"
            );
        });
    }

    //----------------------------------------------------------
    //  Onglet WikiBlame
    //----------------------------------------------------------
    if (currentPage.ns >= 0) {
        $(function () {
            mw.util.addPortletLink(
                'p-cactions',
                'http://wikipedia.ramselehof.de/wikiblame.php?lang=fr&article='
                    + encodeURIComponent(mw.config.get('wgPageName')).replace(/_/g, '+'),
                'WikiBlame',
                'ca-wikiblame',
                'Ouvrir WikiBlame avec cette page pré-renseignée'
            );
        });
    }

    //----------------------------------------------------------
    //  [[MediaWiki:Gadget-SousPages.js]]
    //----------------------------------------------------------
    var nsWithoutSubpages = [-1, 0, 6, 14, 104, 105];
    if (!isInArray(currentPage.ns, nsWithoutSubpages)) {
        obtenir('SousPages');
    }

    //----------------------------------------------------------
    //  [[Projet:JavaScript/Notices/BandeauxPortails]]
    //----------------------------------------------------------
    if (currentPage.ns === 0 && currentPage.isView) {
        window.BandeauxPortails_AutoEdit     = false;  // Publication automatique               (true par défaut)
        window.BandeauxPortails_MinorEdit    = false;  // Modification mineure                  (true par défaut)
        window.BandeauxPortails_Watchthis    = 0;      // Ajout liste de suivi                  (0 par défaut)
        window.BandeauxPortails_TailleListe  = 10;     // Nombre de suggestions                 (10 par défaut)
        window.BandeauxPortails_ListeBas     = false;  // Affichage des suggestions vers le bas (false par défaut)
        window.BandeauxPortails_ShowRedirect = false;  // Affichage ou non des redirections     (false par défaut)
        obtenir('BandeauxPortails');
    }

    //----------------------------------------------------------
    //  [[Utilisateur:Arkanosis/iRef.js]]
    //----------------------------------------------------------
    if (currentPage.isEdit) {
        //importScript('Utilisateur:Arkanosis/iRef.js');
        importScript('Utilisateur:Od1n/iRef.js');
    }

    //----------------------------------------------------------
    //  Boutons "fullurl" et "lien modèle"
    //----------------------------------------------------------
    if (currentPage.isEdit) {
        importScript('Utilisateur:Od1n/BoutonsHelpers.js');
    }

    //----------------------------------------------------------
    //  [[MediaWiki:Gadget-HistoryNumDiff.js]]
    //----------------------------------------------------------
    if (currentPage.action === 'history') {
        obtenir('HistoryNumDiff');
    }

    //----------------------------------------------------------
    //  Version plus avancée de [[MediaWiki:Gadget-DeluxeHistory.js]]
    //  (forké depuis [[Utilisateur:Dr Brains/HistoryDeluxe.js]])
    //----------------------------------------------------------
    if (currentPage.action === 'history' || currentPage.special) {
        importScript('Utilisateur:Od1n/HistoryDeluxe.js');
    }

    //----------------------------------------------------------
    //  [[Discussion Projet:JavaScript#Est-il possible d'améliorer le modèle classement alphabétique ?]]
    //  [[MediaWiki:Gadget-SommaireCompactCategorieDeluxe.js]]
    //----------------------------------------------------------
    if (currentPage.ns === 14 && currentPage.isView) {
        obtenir('SommaireCompactCategorieDeluxe');
    }

    //----------------------------------------------------------
    //  [[Projet:JavaScript/Notices/RenommageCategorie]]
    //----------------------------------------------------------
    if (currentPage.ns === 14) {
        obtenir('RenommageCategorie');
    }

    //----------------------------------------------------------
    //  Fork de [[MediaWiki:Gadget-TagFilterDeluxe.js]] - voir aussi [[WP:DIMS#Spécial:Nouvelles_pages]]
    //  TODO : tester et ajouter à [[Projet:JavaScript/Liste des fonctions disponibles]]
    //----------------------------------------------------------
    if (isInArray(currentPage.special, ['Recentchanges', 'Newpages', 'Contributions'])) {
        importScript('Utilisateur:Od1n/TagFilterDeluxe.js');
    }

})();


//------------------------------------------------------------------------------
//  Autres scripts
//------------------------------------------------------------------------------

//----------------------------------------------------------
//  WIP pour [[Modèle:Images]] :
//  - [[Utilisateur:Od1n/Bac à sable 5]] (modèle)
//  - [[Utilisateur:Od1n/Sandbox script Images.js]] (JavaScript)
//  - [[Utilisateur:Od1n/Bac à sable 7]] (testcase)
//----------------------------------------------------------
//importScript('Utilisateur:Od1n/Sandbox script Images.js');

//----------------------------------------------------------
//  [[WP:DIMS#MediaWiki:Gadget-AncreTitres.js]]
//----------------------------------------------------------
//importScript('Utilisateur:Od1n/Gadget-AncreTitres.js');

//----------------------------------------------------------
//  [[Projet:JavaScript/Développement]]
//  [[Discussion utilisateur:Dr Brains/Archives/21 12 2010#Espace de dev]]
//----------------------------------------------------------
//obtenir('DeveloppementJavaScript');

//----------------------------------------------------------
//  [[Projet:Articles sans portail]]
//----------------------------------------------------------
//obtenir('PagesSansBandeauDePortail');

//----------------------------------------------------------
//  [[Modèle:OngletDynamique]]
//  [[Utilisateur:Oz/Navigation onglet]]
//----------------------------------------------------------
//importScript('Utilisateur:Oz/tab.js');