/*
***************************************************************************
** iRef - Affiche les références lors de la prévisualisation même si elles
** ne sont pas présentes dans la section éditée
** Compatibilité : MediaWiki, testé avec monobook et vector
** Support : Discussion_utilisateur:Arkanosis
** Licence : MIT/X11
**
** Installation : ajouter
**  importScript('User:Arkanosis/iRef.js');
** dans le monobook.js ou vector.js
*/

function iRef() {

    var textBox = document.getElementById('wpTextbox1');
    var isIE = $.client.profile().name === 'msie';

    var EOL = isIE ? '\r\n' : '\n';
    var iRefMark = EOL + '<!--[iRef]-->== <span style="color:red">Références automatiques</span> ==' + EOL + '<references /><!--[/iRef]-->' + EOL;

    function cleanMark() {
        textBox.value = textBox.value.replace(iRefMark, '');
    }

    function iRefPreview() {
        if (!/<ref/.test(textBox.value)) {
            return;
        }
        // Firefox réinitialise la position quand un textarea.value est modifié
        var position = textBox.scrollTop;
        var source = textBox.value;
        if (isIE) {
            source = source.replace(/(?:\r\n)+$/g, '') + '\r\n';
        } else {
            source = source.replace(/\n+$/, '') + '\n';
        }
        textBox.value = source + iRefMark;
        textBox.scrollTop = position;
    }

    cleanMark(); // il faut toujours purger au chargement, pour le mode non ajax

    // compatibilité avec l'aperçu rapide (http://bits.wikimedia.org/skins-1.17/common/preview.js)
    // l'aperçu rapide est chargé avant iRef ; on peut raisonnablement estimer que cela sera toujours le cas
    if (typeof doLivePreview === 'undefined') {
        // aperçu rapide désactivé
        $('#wpPreview').click(iRefPreview);
    } else {
        // aperçu rapide activé
        $(mw).bind({
            'LivePreviewPrepare': iRefPreview,
            'LivePreviewDone': cleanMark
        });
    }

    // compatibilité avec [[MediaWiki:Gadget-QPreview.js]]
    // QPreview est actuellement chargé après iRef ; a priori, ce code fonctionnerait aussi avec l'autre ordre de chargement
    var jEditButtonsZone = $('#editform').find('div.editButtons');
    function iRefQPreview() {
        iRefPreview();
        qPreview();
        cleanMark();
    }
    function QPreviewOverride() {
        $('#btnQPreview')
            .removeAttr('onclick')
            .click(iRefQPreview);
        jEditButtonsZone.undelegate('#btnQPreview', 'focus', QPreviewOverride);
    }
    jEditButtonsZone.delegate('#btnQPreview', 'focus', QPreviewOverride);
}

if (mw.config.get('wgAction') === 'edit' || mw.config.get('wgAction') === 'submit') {
    $(document).ready(iRef);
}