//============================================================
//LiveRC
//============================================================
loadJs('User:EDUCA33E/LiveRC.js');

//============================================================
// 
// Divers
// 
//============================================================

/**
 * Transformer les pages du Bistro en page de discussion
 */
function DiscussionBistro() 
{
  if(  (document.title.search("Wikipédia:Le Bistro") != -1)
    || (document.title.search("Wikipédia:Bulletin des administrateurs") != -1))
    document.body.className = "ns-1";
}
     
addOnloadHook(DiscussionBistro);

/**
 * Transformer certaines pages en page de discussion avec le modèle {{page de discussion}}
 */
function TransformeEnDiscussion() 
{
   var transformeEnPDD = document.getElementById("transformeEnPageDeDiscussion");
   if(transformeEnPDD)
     document.body.className = "ns-1";
}

addOnloadHook(TransformeEnDiscussion);

/**
 * Ajout d'un style particulier aux liens interlangues vers des articles de qualités
 */
function LienAdQ() 
{
   var lang = document.getElementById("p-lang"); // fin language link list
   if(lang)
   {
      var span = document.getElementsByTagName("span");
      for(i=0; i<span.length; i++) // iterate over all <span>-elements
      {
         // if found a AdQ span
         if(span[i].className == "AdQ") {
            var li = lang.getElementsByTagName("li");
            for(j=0; j<li.length; j++) {
               if(li[j].className == "interwiki-" + span[i].id) { // if found a AdQ link
                  li[j].style.padding = "0 0 0 16px";
                  li[j].style.backgroundImage = "url('http://upload.wikimedia.org/wikipedia/fr/3/36/Icone_etoile.png')";
                  li[j].style.backgroundRepeat = "no-repeat";
                  li[j].title = "Lien vers un article de qualité";
               }
            }
         }
      }
   }
}

addOnloadHook(LienAdQ);

/*
 * VraiTitre : Ajout du titre réel d'un article pour lequel MediaWiki n'affiche pas correctement
 */

function VraiTitre() 
{
   var balise = document.getElementById("vrai_titre");
   if (!balise) return;
   vrai_titre = balise.childNodes[0].nodeValue;
   var titre = document.getElementsByTagName("H1")[0];
   rectificatif = titre.appendChild(document.createElement("span"));
   rectificatif.setAttribute ("style","color:#AAAAAA; font-size:0.7em; font-style:italic; display:inline;");
   rectificatif.appendChild(document.createTextNode(" ("+ vrai_titre +")"));
}
addOnloadHook(VraiTitre);

/****************************************/
function mwInsertEditButton(parent, item) {
        var image = document.createElement("img");
        image.width = 23;
        image.height = 22;
        image.src = item.imageFile;
        image.border = 0;
        image.style.cursor = "pointer";
        var ref = document.createElement("a")
        ref.setAttribute("href", "javascript:insertTags(\"" + item.tagOpen + "\",\"" + item.tagClose + "\",\"" + item.sampleText + "\");")
        ref.setAttribute("title", item.speedTip);
        ref.appendChild(image);
        
        parent.appendChild(ref);
}

/************
 * IconesDeTitre : fait en sorte que le modèle {{Icône de titre}} puisse être utilisé plusieurs fois
 */

function IconesDeTitre(){
  var icones = document.getElementsByTagName ("div");
  var icones2= new Array();
  var j = 0;
  var i = 0;
  for (i = 0; i < icones.length ; i++) {
    if (icones[i].className == "icone de titre"){
      icones2[j++] = icones[i];
    }
  }
  for (i=0 ; i < icones2.length ; i++) {
    icones2[i].style.right= (50*i+10)+"px";
  }
}
addOnloadHook(IconesDeTitre);

/*    ----------------------------------------
*     Déplacement "brute-force" des [modifier]
*     ----------------------------------------
* 
* (piqué sur de)
* Dieses Script verschiebt die Editsection-Buttons von rechts oberhalb
* der Überschriften in die Überschriften.
* Positiv getestet unter: Firefox 1.0, Opera 8.0, Internet Explorer 6.0
* Anmerkungen, Verbesserungen, Hinweise, Nörgeleien jederzeit gerne gesehen!
*
* Zum Abschalten die folgende Zeile (ohne führendes Sternchen) in die eigene
* monobook.js (zu finden unter Benutzername/monobook.js) kopieren:
* var oldEditsectionLinks = true;
*
* dbenzhuser (de:Benutzer:Dbenzhuser)
*
* Note de Jd : bon, c'est cool, mais en fait c'est un workaround en attendant de
* déplacer le style="..." des <div class="editsection"> qui force le positionnement
* en flottant à droite (impossibilité de modifier direct dans Monobook.css car c'est
* généré en dur par MediaWiki dans la source HTML des pages, à la volée :/).
*/

function moveEditsection() {
    if (typeof oldEditsectionLinks == 'undefined' || oldEditsectionLinks == false) { 
        // Sammelt alle div-Elemente der Klasse "editsection".
        var editsections = new Array();
        var divs = document.getElementById("bodyContent").getElementsByTagName("div");
        for(var i = 0; i < divs.length; i++) {
            if(divs[i].className == "editsection") {
                editsections.push(divs[i]);
            }
        }
        // Wenn die Seite Editsection-Buttons enthält.
        if (editsections.length != 0) {
            // Sucht zu jedem Editsection-Button die dazugehörige Überschrfift.
            var i = 0;
            var element, heading;
            while (editsections[i] != null) {
                element = editsections[i];
                heading = element.nextSibling;
                while(!/^H[1-6]$/.test(heading.nodeName)) {
                    heading = heading.nextSibling;
                }
                // Erstellt innerhalb der Überschrift ein per CSS formatiertes span-Element.
                // Dort hinein wird dann der Editsection-Link verschoben.
                // Anschließend werden die Reste des alten Editsection-Buttons entfernt.
                var spanElement = document.createElement("span");
                var spaceNode = document.createTextNode(" ");
                heading.appendChild(spaceNode);
                heading.appendChild(spanElement);
                
                spanElement.setAttribute("class", "editsection");
                spanElement.style.fontSize = "x-small";
                spanElement.style.fontWeight = "normal";
               
                while (element.childNodes.length != 0) {
                               spanElement.appendChild(element.childNodes[0]);
                }
                element.parentNode.removeChild(element);
                i++;
            }
        } 
    }
}
addLoadEvent(moveEditsection);

// Correction des titres qui s'affichent mal en raison de limitations dues à MediaWiki.
// Wikipedia pages h1 title rewriting
// Copyright 2006, Marc Mongenet
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// See http://www.gnu.org/licenses/gpl.html

rewritePageH1 = function() {
	try {
		var realTitleBanner = document.getElementById("RealTitleBanner");
		if (realTitleBanner) {
			if (!document.getElementById("DisableRealTitle")) {
				var realTitle = document.getElementById("RealTitle");
				var h1 = document.getElementsByTagName("h1")[0];
				if (realTitle && h1) {
					h1.innerHTML = realTitle.innerHTML;
					realTitleBanner.style.display = "none";
				}
			}
		}
	} catch (e) {
		/* Something went wrong. */
	}
}

//Cette fonction ajoute un onglet supplémentaire qui permet de modifier directement le premier paragraphe du texte sans avoir à //modifier tout le texte.

function editerPremierParagraphe() {
  var urlRegexp = /\/wiki\//;
  var url = self.location.pathname.split('&')[0].replace(urlRegexp, "/w/index.php?title=");
  var a = document.getElementById("p-cactions");
  if (a) {
    b = a.getElementsByTagName("ul");
    if(b.length > 0) {
      b[0].innerHTML = b[0].innerHTML
      + '<li><a href="' + url + '&action=edit&section=0">modifier 1er paragraphe</a></li>';  
    }
  }
}

addLoadEvent(editerPremierParagraphe);

//Ce code charge un script - en évolution - permettant lorsque l'on passe le pointeur de la souris sur un lien interne d'afficher //dans une fenêtre popups le premier paragraphe de la page concernée ainsi que des liens, entres autres, vers son historique et un //ajout dans la liste de suivi.

document.write('<script type="text/javascript" src="' 
    + 'http://fr.wikipedia.org/w/index.php?title=User:Leag/popups-strings-fr.js' 
    + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');

document.write('<script type="text/javascript" src="' 
    + 'http://en.wikipedia.org/w/index.php?title=User:Lupin/popups.js' 
    + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');

//Cette fonction ajoute un onglet "editcount" à partir de la page special:Contributions d'un utilisateur, afin d'accèder directement //au lien (site externe) des statistiques d'édition de ce contributeur.

/* Lien Editcount */
var tabAction = "p-cactions";
function addECButton()
       {
        if ( window.location.href.indexOf('Contributions') < 0) return;
        var c = document.getElementById('contentSub');
        var a = c.getElementsByTagName('a');
        name = a[0].innerHTML;
        var l = document.getElementById(tabAction);
        t = l.innerHTML;
        ind = t.toLowerCase().indexOf("</ul>");
        before = t.substring(0,ind);
        after = t.substring(ind); 
        pitem = "<li><a href='http://tools.wikimedia.de/~interiot/cgi-bin/count_edits?user="+escape(name)+"&dbname=frwiki_p'>"+
                "<div id='EditCount' style='display:inline;'>" + 
                "Editcount"  + 
                "</div></a></li>";
        l.innerHTML = before + pitem + after ;           
      }
addLoadEvent(addECButton);



function changeSummary(sampleText) {
        document.editform.wpSummary.value = sampleText;
}

addLoadEvent(DeluxeBarTun);


//popups
// [[:en:User:Lupin/popups.js]]

document.write('<script type="text/javascript" src="' 
             + 'http://en.wikipedia.org/w/index.php?title=User:Lupin/popups.js' 
             + '&action=raw&ctype=text/javascript&dontcountme=s"></script>'); 

addOnloadHook(rewritePageH1);

/*************************
---Navigation améliorée---
*************************/
function OptimizedNavig() 
{
  var a = document.getElementById("p-navigation");

  if (a) 
  {
    b = a.getElementsByTagName("ul");
    if(b.length > 0)
    { 
      var startUrl = ''
      var endUrl = ''
      var jour = ''
                         
        var aujourdhui = new Date();
   var month = aujourdhui.getMonth();                     
   if (month == 0) month = "janvier";
   else if (month == 1)  month = "février";
   else if (month == 2)  month = "mars";
   else if (month == 3)  month = "avril";
   else if (month == 4)  month = "mai";
   else if (month == 5)  month = "juin";
   else if (month == 6)  month = "juillet";
   else if (month == 7)  month = "août";
   else if (month == 8)  month = "septembre";
   else if (month == 9)  month = "octobre";
   else if (month == 10) month = "novembre";
   else month = "décembre";
   var jour = "Le Bistro/" + aujourdhui.getDate() + "_" + month + "_" + (aujourdhui.getYear() + 1900 );
tableHTML = '<table valign="top" cellspacing="0" cellpadding="0">'
        tableHTML += '<tr>'
        tableHTML += '<li><td><a href="/w/index.php?title=Wikipédia:Le Bistro">Bistro | </a></td>'
        tableHTML += '<td><a href="/w/index.php?title=Wikipedia:' + jour + '">du jour | </a></td>'
        tableHTML += '<td><a href="/w/index.php?title=Wikipédia:Oracle">Oracle</a></td></li>'
        tableHTML += '</tr>'
        tableHTML += '</table>' 
        b[0].innerHTML = b[0].innerHTML + tableHTML

      // liste des URLs
      var urls = new Array()
      urls[0] = '/w/index.php?title=Projet:Maintenance/Analyse_des_créations_sous_IP'
      urls[1] = '/w/index.php?title=User:cqui/monobook.js'
      urls[2] = 'http://commons.wikimedia.org/wiki/Accueil'
      urls[3] = 'http://fr.wiktionary.org/wiki/Wiktionnaire:Page_d%27accueil'

      var labels = new Array()
      labels[0] = 'créations IP'
      labels[1] = 'Monobk'
      labels[2] = 'Commons'
      labels[3] = 'wiktionary'

      for (var i=0;i<urls.length;i+=2) {
        tableHTML = '<table valign="top" cellspacing="0" cellpadding="0">'
        tableHTML += '<tr>'
        tableHTML += '<li><td><a href="' + startUrl + urls[i] + endUrl + '">' + labels[i] + ' | </a></td>'
        tableHTML += '<td><a href="' + startUrl + urls[i+1] + endUrl + '">' + labels[i+1] + '</a></td></li>'
        tableHTML += '</tr>'
        tableHTML += '</table>' 
        b[0].innerHTML = b[0].innerHTML + tableHTML
      }

    }
  }
}


addLoadEvent(OptimizedNavig);


// ============================================================
// BEGIN pageview counter
// 	Please talk to User:LeonWeber before changing anything or 
// 	if there are any issues with that.
 
// this should be adjusted to a good value.
// BE CAREFULL, you will break zedler if it's too low!
// And then DaB. will kill Leon :-(
 var disable_counter = 0;
 var counter_factor = 900; 
 
 function pgcounter_setup()
 {
 	if(disable_counter == 0)
 	{
 		var url = window.location.href;
 		if(Math.floor(Math.random()*counter_factor)==42)  // the probability thing
  		{
  			if(wgIsArticle==true) // do not count history pages etc.
 			{
 				var pgcountNs = wgCanonicalNamespace;
 				if(wgCanonicalNamespace=="")
 				{
 					pgcountNs = "0";
 				}
 				var cnt_url = "http://pgcount.wikimedia.de/index.png?ns=" + pgcountNs + "&title=" + encodeURI(wgTitle) + "&factor=" + counter_factor + "&wiki=frwiki";
 				var img = new Image(); 
 				img.src = cnt_url;
 			}
 		}
 	}
 }
// Do not use aOnloadFunctions[aOnloadFunctions.length] = pgcounter_setup;, some browsers don't like that.
pgcounter_setup();
 
// END pageview counter 
// ============================================================

/* </nowiki> </pre> */