if (typeof(rblOpenInNewWindow) == 'undefined') rblOpenInNewWindow = true;

String.prototype.htmlize = function() {
  var chars = new Array('&','<','>','"');
  var entities = new Array('amp','lt','gt','quot');
  var string = this;
  for (var i=0; i<chars.length; i++) {
    var regex = new RegExp(chars[i], "g");
    string = string.replace(regex, '&' + entities[i] + ';');
  }
  return string;
}

var rblAjax = {
  http: function(bundle) {
    var xmlhttp;
    try {
      xmlhttp = new XMLHttpRequest(); 
    } catch(e) { 
      try {
        xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) { 
        try {
          xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {
          xmlhttp = false
        }
      }
    }
    if (!xmlhttp) return false;
    xmlhttp.onreadystatechange = function() {
      if (xmlhttp.readyState == 4)
        rblAjax.httpComplete(xmlhttp, bundle);
    };
    xmlhttp.open(bundle.method ? bundle.method : "GET", bundle.url, true);
    if (bundle.headers) {
      for (var field in bundle.headers)
        xmlhttp.setRequestHeader(field, bundle.headers[field]);
    }
    xmlhttp.send(null); 
  },
  httpComplete: function(xmlhttp, bundle) {
    if (xmlhttp.status == 200 || xmlhttp.status == 302)
      bundle.onSuccess(xmlhttp, bundle);
    else if (bundle.onFailure)
      bundle.onFailure(xmlhttp, bundle);
  }
};

var rblURLParam = "&rblink=";
var rblFrame;
var rblAdmin = wgUserGroups && (wgUserGroups.indexOf("sysop") != -1);
var rblPage, rblTalkPage;

function rblMakeArticleLink(page) {
  var urlEdit = wgServer + wgScript + "?title=" + encodeURIComponent(page) + "&action=edit" + rblURLParam + encodeURIComponent(rblPage) + "#editform";
  var target = rblOpenInNewWindow ? " target=\"rblWindow\"" : "";
  var html = page.htmlize();
  return html + " [<a href=\"" + urlEdit + "\"" + target + ">éditer</a>]";
}

function rblMakeRedirLink(page) {
  var html = page.htmlize();
  if (rblAdmin) {
    var urlDelete = wgServer + wgScript + "?title=" + encodeURIComponent(page) +
            "&action=delete&wpReason=" + encodeURIComponent("Redirection vers la page « " +
            rblPage + " », supprimée par [[" + wgPageName + "|décision PàS]]");
    var target = rblOpenInNewWindow ? " target=\"rblWindow\"" : "";
    html += " [<a href=\"" + urlDelete + "\"" + target + ">supprimer la redirection</a>]";
  } else {
    html += " (redirection)";
  }
  return html;
}

function rblIgnoreNamespace(namespace) {
  return namespace != 0 && namespace != 10;
}

function rblReadList(xmlreq, data) {
  var blTags = xmlreq.responseXML.getElementsByTagName("backlinks");
  var eiTags = xmlreq.responseXML.getElementsByTagName("embeddedin");
  if (blTags.length == 0 || eiTags.length == 0) {
    rblFrame.innerHTML = "Erreur de chargement des pages liées.";
    return;
  }
  var html = "";
  var backlinks = blTags[0].childNodes;
  for (var i = 0; i < backlinks.length; i++) {
    var bl = backlinks[i];
    var namespace = bl.getAttribute("ns");
    if (rblIgnoreNamespace(namespace)) continue;
    var page = bl.getAttribute("title");
    if (bl.hasAttribute("redirect")) {
      var rlTags = bl.getElementsByTagName("redirlinks");
      html += rblMakeRedirLink(page) + "<br />";;
      if (rlTags.length > 0) {
        var redirlinks = rlTags[0].childNodes;
        for (var j = 0; j < redirlinks.length; j++) {
          var namespace2 = redirlinks[j].getAttribute("ns");
          if (rblIgnoreNamespace(namespace2)) continue;
          var page2 = redirlinks[j].getAttribute("title");
          html += "- " + rblMakeArticleLink(page2) + "<br />";
        }
      }
    } else {
      html += rblMakeArticleLink(page) + "<br />";
    }
  }
  var embeddedin = eiTags[0].childNodes;
  for (var i = 0; i < embeddedin.length; i++) {
  }
  if (html != "")
    html = "Liste des pages liées :<br />" + html + "[<a href=\"javascript:rblCreateList();\">rafraîchir</a>]";
  else
    html = "Il n'y a pas de pages liées";
  rblFrame.innerHTML = html;
}

function rblCreateList() {
  rblTalkPage = wgPageName.replace(/\/Suppression$/, "");
  rblPage = (wgNamespaceNumber == 1 ? "" : wgFormattedNamespaces[wgNamespaceNumber - 1] + ":") +
            wgTitle.replace(/\/Suppression$/, "");
  rblFrame = document.getElementById("rblFrame");
  if (!rblFrame) {
    rblFrame = document.createElement("div");
    rblFrame.id = "rblFrame";
    var nextElement = document.getElementById("firstHeading").nextSibling;
    nextElement.parentNode.insertBefore(rblFrame, nextElement);
  }
  rblFrame.innerHTML = "Chargement des pages liées...";
  request = wgServer + wgScriptPath + "/api.php?format=xml&action=query&list=backlinks|embeddedin&bltitle=" +
          encodeURIComponent(rblPage) + "&blredirect&bllimit=250&eititle=" +
          encodeURIComponent(rblPage) + "&eilimit=100";
  rblAjax.http({url: request, onSuccess: rblReadList});
}

// Recherche des liens sur les pages d'édition

var rblList;
var rblLastPos;

function rblNormalizeLink(s) {
  var i = s.indexOf("#");
  if (i == -1) i = s.length;
  var article = s.substr(0, i).replace(/^ +/, "").replace(/ +$/, "").replace(/ /g, "_");
  if (article == "")
    article = wgPageName;
  else if (article[0] == ":")
    article = article.substr(1);
  article = article.substr(0, 1).toUpperCase() + article.substr(1); // Ne marche que dans l'espace principal
  return article;
}

/* Rend inactif un lien javascript, de façon visible. */
function rblDisableLink(link) {
  link.href = "javascript:;";
  link.style.color = "silver";
  link.style.cursor = "default";
  link.style.textDecoration = "none";
}

/* Recherche la première occurence d'une ancre à partir d'une position donnée. */
function rblFindNext(s, link, start) {
  var i = start, j, k, pageLink;
  var linkN = rblNormalizeLink(link);
  while (true) {
    i = s.indexOf("[[", i);
    if (i == -1) return false;
    i += 2;
    j = s.indexOf("]]", i);
    if (j == -1) return false;
    pageLink = s.substr(i, j - i);
    k = pageLink.indexOf("|");
    if (k != -1)
      pageLink = pageLink.substr(0, k);
    else
      k = pageLink.length;
    if (linkN == rblNormalizeLink(pageLink))
      return [i, i + k];
    i = j + 2;
  }
}

function rblSetSelection(start, end) {
  var txt = document.getElementById('editform').getElementsByTagName('textarea')[0];
  txt.focus();
  txt.setSelectionRange(start, start);
  var evt = document.createEvent('KeyEvents');
  evt.initKeyEvent('keypress', true, true, window, false, false, false, false, 0, 32);
  txt.dispatchEvent(evt);
  evt = document.createEvent('KeyEvents');
  evt.initKeyEvent('keypress', true, true, window, false, false, false, false, 8, 0);
  txt.dispatchEvent(evt);
  txt.setSelectionRange(start, end);
}

function rblSelectLink2() {
  rblSelectLink();
}

/* Sélectionne l'occurence suivante d'une ancre brisée donnée. */
function rblSelectLink() {
  var s = document.getElementById("editform").getElementsByTagName("textarea")[0].value;
  var pos = rblFindNext(s, rblPage, rblLastPos[1]);
  var msg = document.getElementById("rblMsg");
  if (!pos) var pos = rblFindNext(s, rblPage, 0);
  if (!pos) {
    msg.innerHTML = "(non trouvé)";
    return false;
  }
  rblLastPos = pos;
  msg.innerHTML = rblFindNext(s, rblPage, pos[1]) ? "" : "[dernière occurence]";
  rblSetSelection(pos[0], pos[1]);
  return true;
}

function rblRemoveLink() {
  var textArea = document.getElementById('editform').getElementsByTagName('textarea')[0];
  var txt = textArea.value;
  var i = rblLastPos[0], j = rblLastPos[1];
  if (i != j && i >= 2 && txt.substr(i - 2, 2) == "[[" &&
      rblNormalizeLink(txt.substr(i, j - i)) == rblNormalizeLink(rblPage)) {
    if (txt.substr(j, 1) == "|") {
      var k = txt.indexOf("]]", j + 1);
      if (k == -1) k = txt.length;
      textArea.value = txt.substr(0, i - 2) + txt.substr(j + 1, k - j - 1) + txt.substr(k + 2);
      rblLastPos = [i - 2, i - 2];
      if (!rblSelectLink()) rblSetSelection(i - 2, i - 2 + k - j - 1);
    } else if (txt.substr(j, 2) == "]]") {
      textArea.value = txt.substr(0, i - 2) + txt.substr(i, j - i) + txt.substr(j + 2);
      rblLastPos = [i - 2, i - 2];
      if (!rblSelectLink()) rblSetSelection(i - 2, i - 2 + j - i);
    }
  }
}

/* Crée des liens sous la fenêtre d'édition pour chercher les différentes
   occurrences du lien dans l'article. */
function rblFormatEditPage() {
  var rblList = document.createElement("span");
  var p = document.getElementById("MediaWiki-summary");
  p.insertBefore(rblList, p.firstChild);

  var wpSummary = document.getElementById("wpSummary");
  if (wpSummary) wpSummary.value = "Retrait du lien vers la page « " + rblPage + " » supprimée par décision PàS";
  var wpMinoredit = document.getElementById("wpMinoredit");
  if (wpMinoredit) wpMinoredit.checked = true;

  var copyWarn = document.getElementById("editpage-copywarn");
  if (copyWarn) copyWarn.style.display = "none";

  rblList.innerHTML = rblPage.htmlize() +
          " (<a href=\"javascript:rblSelectLink2();\">chercher</a> | <a href=\"javascript:rblRemoveLink();\" id=\"rblRBLLink\">déwikifier</a>)" +
          " <span id=\"rblMsg\"></span><br />";
  rblLastPos = [0, 0];
  rblSelectLink();
}


function rblInit() {
  if (wgAction == "view" && wgNamespaceNumber % 2 != 0 && wgTitle.match(/\/Suppression$/)) {
    addPortletLink('p-tb', 'javascript:rblCreateList();', 'Déwikif pages liées', 'r-blinks', 'Assistant de suppression des liens vers cette page');
  } else if (wgAction == "edit" && document.URL.indexOf(rblURLParam) != -1) {
    var url = document.URL;
    var rblPos = url.indexOf(rblURLParam) + rblURLParam.length;
    var rblEnd = url.indexOf('#', rblPos);
    rblPage = decodeURIComponent(url.substr(rblPos, rblEnd - rblPos));
    rblFormatEditPage();
  }
}

addOnloadHook(rblInit);