var cpeCmlimit = 500;

String.prototype.htmlize = function() {
  var chars = new Array('&','<','>','"');
  var entities = new Array('amp','lt','gt','quot');
  var string = this;
  for (var i=0; i<chars.length; i++) {
    var regex = new RegExp(chars[i], "g");
    string = string.replace(regex, '&' + entities[i] + ';');
  }
  return string;
}

var cpeAjax = {
  http: function(bundle) {
    try {
      xmlhttp = new XMLHttpRequest(); 
    } catch(e) { 
      try {
        xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) { 
        try {
          xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {
          return false;
        }
      }
    }
    xmlhttp.onreadystatechange = function() {
      if (xmlhttp.readyState == 4)
        cpeAjax.httpComplete(xmlhttp, bundle);
    };
    xmlhttp.open("GET", bundle.url, true);
    xmlhttp.send(null); 
  },
  httpComplete: function(xmlhttp, bundle) {
    if (xmlhttp.status == 200 || xmlhttp.status == 302)
      bundle.onSuccess(xmlhttp, bundle);
    else if (bundle.onFailure)
      bundle.onFailure(xmlhttp, bundle);
  }
};

function cpeMessage(msg) {
  document.getElementById('cpeResult').textContent = msg;
}

function cpeReadCat(categ, ns, cont) {
  cpeMessage("Lecture de '" + categ + "'");
  var url = wgServer + wgScriptPath
    + '/api.php?action=query&list=categorymembers&cmtitle=' + encodeURIComponent(categ)
    + '&cmlimit=' + cpeCmlimit + '&format=xml';
  cpeAjax.http({url: url, onSuccess: cpeReadCat2, categ: categ,
                ns: ns, cont: cont, catMembers: new Array()});
}

function cpeReadCat2(xmlreq, data) {
  var nodes = xmlreq.responseXML.getElementsByTagName('cm');
  for (var i = 0; i < nodes.length; i++) {
    if (nodes[i].getAttribute('ns') == data.ns)
      data.catMembers.push(nodes[i].getAttribute('title'));
  }
  var nextQ = xmlreq.responseXML.getElementsByTagName('query-continue');
  if (nextQ.length == 0)
    data.cont(data.catMembers)
  else {
    cpeMessage("Lecture de '" + data.categ + "' (" + data.catMembers.length + " lus)");
    var cmcontinue = nextQ[0].getElementsByTagName('categorymembers')[0].getAttribute('cmcontinue');
    var url = wgServer + wgScriptPath
      + '/api.php?action=query&list=categorymembers&cmtitle=' + encodeURIComponent(data.categ)
      + '&cmlimit=' + cpeCmlimit + '&cmcontinue=' + encodeURIComponent(cmcontinue) + '&format=xml';
    cpeAjax.http({url: url, onSuccess: cpeReadCat2, categ: data.categ,
                  ns: data.ns, cont: data.cont, catMembers: data.catMembers});
  }
}

// Comparaison

var cpeImp = ["inconnue", "faible", "moyenne", "élevée", "maximum"];
var cpePortail, cpeEvalCat, cpeEvalCatIndex;
var cpeTabEvalues, cpeTabPortail;

function cpeCompute() {
  var suffix = " d'importance";
  cpePortail = document.getElementById('cpePortail').value;
  cpeEvalCat = document.getElementById('cpeProjet').value;

  if (cpePortail == "") {
    alert("Portail non défini");
    return;
  } else if (cpeEvalCat == "" || cpeEvalCat == 'Catégorie:Article XYZ d\'importance faible') {
    alert("Catégorie non définie");
    return;
  } else if (cpeEvalCat.indexOf(suffix) == -1) {
    alert("Catégorie invalide");
    return;
  }

  cpeEvalCat = cpeEvalCat.substr(0, cpeEvalCat.indexOf(suffix));
  cpeEvalCatIndex = -1;
  cpeTabEvalues = new Object();
  cpeTabPortail = new Object();  
  cpeReadCat("Catégorie:Portail:" + cpePortail + "/Articles liés", 0, cpeEvalCatCallback);
}

function cpeEvalCatCallback(catMembers) {
  if (cpeEvalCatIndex == -1) {
    if (catMembers.length == 0) {
      alert("Aucun article n'est lié à ce portail");
      return;
    }
    for (var i = 0; i < catMembers.length; i++)
      cpeTabPortail[catMembers[i]] = true;
  } else {
    for (var i = 0; i < catMembers.length; i++)
      cpeTabEvalues[catMembers[i].substr(catMembers[i].indexOf(':') + 1)] = true;
  }
  cpeEvalCatIndex++;
  if (cpeEvalCatIndex < cpeImp.length)
    cpeReadCat(cpeEvalCat + " d'importance " + cpeImp[cpeEvalCatIndex], 1, cpeEvalCatCallback);
  else
    cpePrintResult();
}

function cpeMakeLink(title) {
  return '<a href="' + wgServer + wgScriptPath + "/index.php?title=" + encodeURIComponent(title) + '">' + title.htmlize() + '</a>';
}

function cpePrintResult() {
  var txt = "<h2>Avec évaluation mais sans portail</h2><ul>";
  var isEmpty = true;
  for (var article in cpeTabEvalues) {
    isEmpty = false;
    if (!cpeTabPortail[article])
      txt += "<li>" + cpeMakeLink(article) + "</li>";
  }
  if (isEmpty) {
    alert("Aucun article n'a cette évaluation");
    return;
  }
  txt += "</ul>";
  txt += "<h2>Avec portail mais pas évalués</h2><ul>";
  for (var article in cpeTabPortail) {
    if (!cpeTabEvalues[article])
      txt += "<li>" + cpeMakeLink(article) + "</li>";
  }
  txt += "</ul>";
  document.getElementById('cpeResult').innerHTML = txt;
}

function cpeInit() {
  window.document.title = 'Comparaison portail / évaluations';
  var firstHeading = document.getElementById('firstHeading');
  if (firstHeading) firstHeading.style.display = 'none';
  var content = document.getElementById('bodyContent');
  content.innerHTML = '<h1>Comparaison portail / évaluations</h1>'
    + '<p>Ce formulaire sert à calculer la liste des articles qui ont un portail mais pas une évaluation, et réciproquement.</p>'
    + '<p>Portail (par exemple \'Chemin de fer\')<br /><input id="cpePortail" value="" size="64" /><br />'
    + 'Une catégorie liée à l\'importance (par exemple \'Catégorie:Article ferroviaire d\'importance faible\' ; les noms des autres catégories sont générés automatiquement)<br /><input id="cpeProjet" value="Catégorie:Article XYZ d\'importance faible" size="64" /><br />'
    + '<input type="button" onclick="cpeCompute();" value="Calculer" /></p><div id="cpeResult"></div>'
}

addOnloadHook(function () {
  addPortletLink('p-tb', wgServer + wgArticlePath.split('$1').join("Spécial:Portail-éval"), 'Portail-éval', 'r-cpe', 'Portail-éval');
  if (wgPageName == "Spécial:Portail-éval") cpeInit();
});