/*
==LiveRC Global parameters==
*Documentation : [[:fr:User:EDUCA33E/LiveRC/Documentation]]
*Authors : [[:fr:User:EDUCA33E]] & [[:fr:User:TiChou]]
*Version: 0.3.4 (beta)
<pre> */
var lrcConfig = {/*{{{*/
  global : {/*{{{*/
    RC_Limit : 30,                 // default RC list size
    Preview_Height : '250px',      // default preview window height
    Auto_Close_Diff : false,       // default diff behaviour
    Time_Zone : '',                // time zone (+02:00, -05:45, ...)
  }/*}}}*/
  ,
  locale : {/*{{{*/
    en : {/*{{{*/
      menu : {/*{{{*/
        PAUSE   : "Pause",
        PREVIEW : "Preview",
        LISTS   : "Lists",
        LOWDIFF : "Light diff",
        RCLABEL : "RC",
        NOBOTS  : "No bots",
        IPONLY  : "IP Only",
        NAMESP  : "Namespace",
        XTIMES  : "times",
        UNDORC  : "Undo",
        REVERT  : "Revert",
        REASON  : "Reason",
        AVERTS  : "Warn",
        RVMES1  : "LiveRC: reverted edits by <<1>> to previous version by <<2>>.",
        WNMES1 : "LiveRC: Warning following edits on [[<<1>>]]",
        WNMES2 : "LiveRC: Warning with template <<1>>",
        EMPTY   : "Empty",
	UNDONE  : "reverted <<1>> times",
	ABBRDiff : "Diff",
	ABBRHist : "Hist",
	ABBRNew : "New"
      }/*}}}*/
      ,
      commentsTests : [/*{{{*/
        { state: BLANKING  , regex: /^Résumé automatique : blanchiment|^[Bb]lanchi/ },
        { state: REPLACED  , regex: /Replaced page with/ },
        { state: REVERT    , regex: /^(LiveRC : )?Révocation |^Annulation des modifications|^(Undid|Revert to( the)?) revision|^(Undoing|Reverted( \d+)?) edit|^r(e)?v(ert(ing|ed)?)?\b/ }
      ] /*}}}*/
      ,
      categoriesTests : [/*{{{*/
        { state: LOCK      , regex: 'Semi-protected' },
        { state: FULLLOCK  , regex: 'Protected' },
        { state: HOMONYMIE , regex: 'Disambiguation' },
        { state: ADQ       , regex: 'Wikipedia featured articles' },
        { state: BA        , regex: 'Wikipedia good articles' },
        { state: APDQ      , regex: 'Wikipedia featured article candidates' },
        { state: COPYRIGHT , regex: 'Possible copyright violations' },
        { state: PAS       , regex: 'Articles for deletion' },
        { state: FIRE      , regex: 'Wikipedia controversial topics' }
      ]/*}}}*/
      ,
      warnTemplates : [/*{{{*/
        { template: "Uw-vandalism1"     , string: "Vandalism lvl-1"    , hasPage: true },
        { template: "Uw-vandalism2"     , string: "Vandalism lvl-2"    , hasPage: true },
        { template: "Uw-vandalism3"     , string: "Vandalism lvl-3"    , hasPage: true },
        { template: "Uw-vandalism4"     , string: "Vandalism lvl-4"    , hasPage: true },
        { template: "Uw-vandalism4im"   , string: "Vandalism nolvl"    , hasPage: true },
        { template: "Uw-spam1"          , string: "Spam lvl-1"         , hasPage: true },
        { template: "Uw-spam2"          , string: "Spam lvl-2"         , hasPage: true },
        { template: "Uw-spam3"          , string: "Spam lvl-3"         , hasPage: true },
        { template: "Uw-spam4"          , string: "Spam lvl-4"         , hasPage: true },
        { template: "Uw-copyright"      , string: "Copyright"          , hasPage: true }
      ]/*}}}*/
      ,
      legends : {/*{{{*/
        Disambiguity : "Disambiguity page",
        ProtectedArt : "Protected article",
	SemiPorctArt : "Semi-Protected article",
	CopyVio : "Copyright violation",
	ForDeletion : "Submitted for deletion",
	Fire : "Conflictuous article",
	Featured : "Featured article",
	Good : "Good article",
	FeaturedProposed : "Featured article candidate",
	Redirect : "Redirection",
	Bot : "Bot",
	Systop : "System operator",
	Revert : "This is a revert",
	TOR : "This IP starts with 172",
	Replaced : "Page replaced with new content"
      }/*}}}*/
      ,
      localCustoms : {/*{{{*/
        warnOnBottom : true
      }/*}}}*/
      ,
      namespaces : {/*{{{*/
        CATEGORY : "Category:"
      }/*}}}*/
    }/*}}}*/
    ,
    fr : {/*{{{*/
      menu : {/*{{{*/
        PAUSE:   "Pause",
        PREVIEW: "Prévisualiser",
        LISTS:   "Listes",
        LOWDIFF: "Diff réduit",
        RCLABEL: "RC",
        NOBOTS:  "Sans Bots",
        IPONLY:  "IP seules",
        NAMESP:  "Espace",
        XTIMES:  "fois",
        UNDORC:  "Défaire",
        REVERT:  "Révoquer",
        REASON:  "Raison",
        AVERTS:  "Avertir",
        RVMES1:  "LiveRC : Révocation des modifications de <<1>>, retour à la version de <<2>>.",
        WNMES1 : "LiveRC: Avertissment concernant des éditions sur [[<<1>>]]",
        WNMES2 : "LiveRC: Avertissment <<1>>",
        EMPTY:   "Blanchir",
	UNDONE  : "révoqué <<1>> fois",
        ABBRDiff : "Diff",
	ABBRHist : "Hist",
	ABBRNew : "Nouveau"
      }/*}}}*/
      ,
      commentsTests : [/*{{{*/
        { state: BLANKING  , regex: /^Résumé automatique : blanchiment|^[Bb]lanchi/ },
        { state: REPLACED  , regex: /^Résumé automatique : contenu remplacé par/ },
        { state: REVERT    , regex: /^(LiveRC : )?Révocation |^Annulation des modifications|^(Undid|Revert to( the)?) revision|^(Undoing|Reverted( \d+)?) edit|^r(e)?v(ert(ing|ed)?)?\b/ }
      ] /*}}}*/
      ,
      categoriesTests : [/*{{{*/
        { state: LOCK      , regex: 'Page (semi-protégée|en semi-protection longue)' },
        { state: FULLLOCK  , regex: 'Page protégée' },
        { state: HOMONYMIE , regex: 'Homonymie' },
        { state: ADQ       , regex: 'Article de qualité( contesté)?' },
        { state: BA        , regex: 'Bon article' },
        { state: APDQ      , regex: 'Article potentiellement (bon|de qualité)' },
        { state: COPYRIGHT , regex: 'Article soupçonné de travail sous copyright' },
        { state: PAS       , regex: 'Page proposée à la suppression' },
        { state: FIRE      , regex: 'Wikipompiers' }
      ]/*}}}*/
      ,
      warnTemplates : [/*{{{*/
        { template: "Test 0"              , string: "Test 0"    , hasPage: false },
        { template: "Test 1"              , string: "Test 1"    , hasPage: false },
        { template: "Test 2"              , string: "Test 2"    , hasPage: false },
        { template: "Test 3"              , string: "Test 3"    , hasPage: false },
        { template: "Vandalisme"          , string: "Vandal"    , hasPage: true  },
        { template: "Spammeur"            , string: "Spam"      , hasPage: true  },
        { template: "Motivation_modif"    , string: "Résumé"    , hasPage: true  },
        { template: "Signature"           , string: "Signature" , hasPage: false },
        { template: "Bienvenue_copyright" , string: "Copyright" , hasPage: false }
      ]/*}}}*/
      ,
      legends : {/*{{{*/
        Disambiguity : "Page d'homonymie",
        ProtectedArt : "Page protégée",
	SemiPorctArt : "Page semi-protégée",
	CopyVio : "Violation de copyright",
	ForDeletion : "Page proposée à la suppression",
	Fire : "Guerre d'édition ou feu en cours",
	Featured : "Article de qualité",
	Good : "Bon article",
	FeaturedProposed : "Article potentiellement de qualité",
	Redirect : "Redirection",
	Bot : "Bot",
	Systop : "Administrateur",
	Revert : "Cette modification est une révocation",
	TOR : "IP commençant par 172",
	Replaced : "Page remplacée par un nouveau contenu"
      }/*}}}*/
      ,
      localCustoms : {/*{{{*/
        warnOnBottom : false
      }/*}}}*/
      ,
      namespaces : {/*{{{*/
        CATEGORY : "Catégorie:"
      }/*}}}*/
    }/*}}}*/
  }/*}}}*/
  ,
  icons : {/*{{{*/
    Disambiguity : "http://upload.wikimedia.org/wikipedia/commons/thumb/7/72/Disambig.svg/16px-Disambig.svg.png",
    ProtectedArt : "http://upload.wikimedia.org/wikipedia/commons/thumb/4/48/Padlock-red.svg/16px-Padlock-red.svg.png",
    SemiProctArt : "http://upload.wikimedia.org/wikipedia/commons/thumb/e/e0/Padlock-gold.svg/16px-Padlock-gold.svg.png",
    CopyVio      : "http://upload.wikimedia.org/wikipedia/commons/thumb/b/b0/Copyright.svg/16px-Copyright.svg.png",
    ForDeletion  : "http://upload.wikimedia.org/wikipedia/commons/thumb/b/b6/Cestino_pieno_architetto_01.svg/11px-Cestino_pieno_architetto_01.svg.png",
    Fire : "http://upload.wikimedia.org/wikipedia/commons/thumb/9/99/FireIcon.svg/12px-FireIcon.svg.png",
    Featured : "http://upload.wikimedia.org/wikipedia/commons/thumb/c/c7/Fairytale_bookmark_gold.png/10px-Fairytale_bookmark_gold.png",
    Good : "http://upload.wikimedia.org/wikipedia/commons/thumb/8/8a/Fairytale_bookmark_silver_light.png/10px-Fairytale_bookmark_silver_light.png",
    FeaturedProposed : "http://upload.wikimedia.org/wikipedia/commons/thumb/9/9a/Fairytale_bookmark_light.png/10px-Fairytale_bookmark_light.png",
    Redirect : "http://upload.wikimedia.org/wikipedia/commons/thumb/b/b5/Redirectltr.png/20px-Redirectltr.png",
    Bot : "http://upload.wikimedia.org/wikipedia/commons/thumb/2/2a/Nuvola_apps_kservices.png/16px-Nuvola_apps_kservices.png",
    Sysop : "http://upload.wikimedia.org/wikipedia/commons/thumb/2/2c/Broom_icon.svg/16px-Broom_icon.svg.png",
    Revert : "http://upload.wikimedia.org/wikipedia/commons/thumb/2/2c/Nuvola_actions_undo.png/16px-Nuvola_actions_undo.png",
    TOR : "http://upload.wikimedia.org/wikipedia/commons/thumb/6/6e/Dialog-warning.svg/16px-Dialog-warning.svg.png",
    Replaced : "http://upload.wikimedia.org/wikipedia/commons/thumb/9/95/Categorie_III.svg/10px-Categorie_III.svg.png"
  }/*}}}*/
}/*}}}*/
lrcLang = lrcConfig.locale.fr;
/* </pre> */