function do_sync_request(request, type, datas)
{
    var http_request = sajax_init_object();
    url = wgServer + wgScriptPath + '/api.php?' + request;
    http_request.open(type, url, false);
    if (datas) {
       http_request.setRequestHeader("Content-length", datas.length);
       http_request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    }
    http_request.send(datas);
    return http_request;
}

function get_sync(request)
{
    return do_sync_request(request, "GET", null);
}

function post_sync(request, datas)
{
    return do_sync_request(request, "POST", datas);
}

function do_json_request(request)
{
    http_request = get_sync(request + '&format=json');
    if (typeof(JSON) != 'undefined')
        var json = JSON.parse(http_request.responseText);
    else
        var json = eval('(' + http_request.responseText + ')');
    return json;
}

function get_edit_token(pagename)
{
    var request = 'action=query&prop=info&intoken=edit&titles=' + pagename;
    var json = do_json_request(request);

    for (var page in json.query.pages) {
        if (Number(page) > 0)
            return json.query.pages[page].edittoken;
    }
    return null;
}

function read_page(pagename)
{
    var request = 'action=query&prop=revisions&rvprop=timestamp|content&titles=' + pagename;
    var json = do_json_request(request);

    for (var page in json.query.pages) {
        if (Number(page) > 0)
            return decodeURIComponent(json.query.pages[page].revisions[0]['*']);
    }
    return null;
}

function write_page(pagename, text, comment)
{
    var token = get_edit_token(pagename);
    var request = 'action=edit&token=' +  encodeURIComponent(token) + '&title=' + pagename + '&summary=' + encodeURIComponent(comment);
    result = post_sync(request, '&text=' + encodeURIComponent(text));
}

function change_page(funct)
{
    text = read_page(wgPageName);
    new_text = funct(text);
    write_page(wgPageName, new_text, 'mise à jour');
    window.location.reload();
}

function page_name_match(page_name, regexp)
{
    var index = wgPageName.indexOf(page_name);
    if (index != -1)
        index = wgPageName.search(regexp);
    return index;
}
 
/* == dist_edit et article_sans_cat == */
//------------------------------------------------------------------
// dist_edit et article_sans_cat
/* return true if the most left html tag is a red link */
function first_red_link(li)
{
    var a = li.getElementsByTagName('a');
    if (!a || a.length == 0)
        return false;
    if (a[0].className == 'new')
        return true;
    return false;
}
 
/* return true if a part of the element is striked */
function striked_element(e)
{
    return e.getElementsByTagName('s').length != 0;
}
 
function article_sans_cat_change_text(text)
{
    var content = document.getElementById('bodyContent');
    var input = content.getElementsByTagName("input");
    var li =  content.getElementsByTagName("li");
    if (li.length != input.length) {
        alert('bad li/input count ' + li.length + ' ' + input.length)
        return text;
    }
    new_text = '';
    lines = text.split('\n');
    var k = 0;
    for (var j = 0; j < lines.length; ++j) {
         if (lines[j].indexOf('#') == 0) {
               if (k >= li.length) {
                    alert('something feel bad, k >= input.length');
                    return text;
               }
               if (!input[k].disabled && !input[k].checked) {
                   new_text += lines[j] + '\n';
               }
               k++;
         } else  {
               new_text += lines[j] + '\n';
         }
    }
 
    if (k != input.length) {
         alert('k != input.length' + k + ' ' + input.length);
         return text;
    }
 
    return new_text;
}
 
 
function article_sans_cat_submit_change_step1()
{
    change_page(article_sans_cat_change_text);
}

function add_submit_button(content, funct)
{
    var submit = document.createElement('button');
    submit.type = 'submit';
    submit.innerHTML = 'submit';
    submit.onclick = funct;
    content.appendChild(submit);
}
 
function article_sans_cat()
{
    var page_name = 'Projet:Articles_sans_catégories/';
    var index = page_name_match(page_name, /gories\/([A-Z]|Autres|0-9|faune|flore|faune_et_flore|biographie)$/);
    var idx2 = wgPageName.indexOf('Utilisateur:Phe/Page_vide/');
    var idx3 = wgPageName.indexOf('Projet:Articles_les_plus_demandés/');
    var idx4 = wgPageName.indexOf('Utilisateur:Phe/Orphaned_talk');
    var idx5 = wgPageName.indexOf('Utilisateur:Phe/Nouvelle_page/');
    var idx6 = wgPageName.indexOf('Utilisateur:Phe/temp');
    if (index == -1 && idx2 == -1 && idx3 == -1 && idx4 == -1 && idx5 == -1 && idx6 == -1)
        return;
    content = document.getElementById('bodyContent');
    var li = content.getElementsByTagName("li");
    if (!li)
        return;
    for(var j = 0; j < li.length; j++) {
         input = document.createElement('input');
         input.type = 'checkbox';
         input.checked = false; //striked_element(li[j]);
         if (idx3 == -1)
             input.disabled = first_red_link(li[j]);
         else
             input.disabled = !first_red_link(li[j]);
         li[j].insertBefore(input, li[j].firstChild); 
   }

   add_submit_button(content, article_sans_cat_submit_change_step1);
}

if (wgAction == 'view' && wgArticleId != 0)
   jQuery(document).ready(article_sans_cat);
 
/* return true if the second left html tag is a red link */
function second_red_link(li)
{
    var a = li.getElementsByTagName('a');
    if (!a || a.length <= 1)
        return false;
    if (a[1].className == 'new')
        return true;
    return false;
}
 
/* return true if all a html element except two first are red link */
function other_red_link(li)
{
    var a = li.getElementsByTagName('a');
    if (!a || a.length <= 2)
        return false;
    for (var j = 2; j < a.length; j++) {
        if (a[j].className != 'new')
            return false;
    }
    return true;
}
 
function dist_edit_change_text(text)
{
    var content = document.getElementById('bodyContent');
    var input = content.getElementsByTagName("input");
    var li =  content.getElementsByTagName("li");
    if (li.length * 2 != input.length) {
        alert('bad li/input count ' + li.length + ' ' + input.length)
        return text;
    }
    new_text = '';
    lines = text.split('\n');
    var k = 0;
    for (var j = 0; j < lines.length; ++j) {
         if (lines[j].indexOf('*') == 0) {
               if (k >= li.length) {
                    alert('something feel bad, k >= input.length');
                    return text;
               }
               if (input[k*2].disabled || input[k*2+1].checked) {
               } else if (input[k*2].checked && lines[j].indexOf('<s>') == -1) {
                   new_text += '*<s>' + lines[j].slice(1) + '</s>\n';
               } else {
                   new_text += lines[j] + '\n';
               }
               k++;
         } else  {
               new_text += lines[j] + '\n';
         }
    }
 
    if (k * 2 != input.length) {
         alert('k != input.length' + k + ' ' + input.length);
         return text;
    }
 
    return new_text;
}
 
 
function dist_edit_submit_change_step1()
{
    change_page(dist_edit_change_text);
}

function is_anchor_blacklisted(li)
{
   return false; //li.innerHTML.search(/One Piece|Naruto/) != -1 ? true : false;
}

function edit_by_distance()
{
    if (typeof disable_clickodrome != 'undefined' && disable_clickodrome)
         return;
    var multiple = false;
    var lien_rouge = true;
    var broken_anchor = false;
    var page_name = 'Projet:Restauration_lien_rouge/par_distance/';
    var index = page_name_match(page_name, /par_distance\/([A-Z]|autres)$/);
    if (index == -1)
        index = page_name_match(page_name, /par_distance\/Exceptions\/([A-Z]|autres)\/[1-9]+$/);
    if (index == -1)
        index = page_name_match('Utilisateur:Phe/Projet:Restauration_lien_rouge/par_distance/', /par_distance\/([A-Z]|autres)$/);
    if (index == -1) {
        lien_rouge = false;
        page_name = 'Projet:Restauration_des_ancres_brisées/';
        index = page_name_match(page_name, /brisées\/([A-Z]|Autres|0-9|Multiple)$/);
        if (index != -1) {
            if (page_name_match(page_name, /\/Multiple$/) != -1)
                multiple = true;
            broken_anchor = true;
        }
        page_name = 'Projet:Biographie/Date_de_naissance_et_décès_manquante/';
        var idx1 = page_name_match(page_name, /manquante\/([A-Z]|Autres)$/);
        if (index == -1 && idx1 == -1)
            return;
    }
    var content = document.getElementById('bodyContent');
    var li = content.getElementsByTagName("li");
    if (!li)
        return;
    for(var j = 0; j < li.length; j++) {
         var input = document.createElement('input');
         input.type = 'checkbox';
         input.checked = striked_element(li[j]);
         input.disabled = first_red_link(li[j]);
         if (input.disabled == false && lien_rouge)
            input.disabled = !second_red_link(li[j]);
         if (input.disabled == false && broken_anchor)
            input.disabled = is_anchor_blacklisted(li[j]);
         if (input.disabled == false && lien_rouge)
            input.disabled = other_red_link(li[j]);
         var input2 = document.createElement('input');
         input2.type = 'checkbox';
         input2.checked = false;
         input2.disabled = input.disabled;
         // FIXME: ugly workaround
         if (multiple == true) {
            input.checked = false;
            input.disabled = false;
            input2.checked = false;
            input2.disabled = false;
         }
         li[j].insertBefore(input2, li[j].firstChild);
         li[j].insertBefore(input, li[j].firstChild); 
   }

   add_submit_button(content, dist_edit_submit_change_step1);
}

if (wgAction == 'view' && wgArticleId != 0)
   jQuery(document).ready(edit_by_distance)