// ==UserScript==
// @name           history
// @namespace      WP
// @include        http://fr.wikipedia.org/wiki/Wikip%C3%A9dia:Le_Bistro/3_juin_2008
// ==/UserScript==

if(wgAction=='history')
if(wgUserGroups.indexOf("sysop") != -1)
addOnloadHook(
function ()
{
	var history = document.getElementById('pagehistory');
	var button = document.createElement("input")
	var checkboxsCreated = false
	var reason, info
	var revToPurge = {}
	var timestampWrapper = {}
	var pageURI = encodeURIComponent(window["wgPageName"])
	var token
	
	button.type = "submit"
	button.value = "Démarrer une purge"
	button.className = "historysubmit"
	/*
	*/
	history.parentNode.insertBefore(button, history)
	
	function debug(txt, ok)
	{
		if(ok)
		{
			var str = info.textContent
			info.textContent = str.replace(txt,txt  + " : ok")	
		}
		else
			info.textContent += txt + '\n'
	}
	
	var createTimestampWrapper = function(startId, endId)
	{
		debug("Récupération des timestamp des versions")
		
		var url = "api.php?action=query&prop=revisions&rvprop=timestamp|ids&format=json&rvlimit=2000"
		url += "&rvstartid="+ startId +"&rvendid="+ endId +"&titles="+  pageURI
	
		var handler = function(res)
		{
			var revisions = res.query.pages[window["wgArticleId"]].revisions
			
			for(var i=0;i!=revisions.length;i++)
				timestampWrapper[revisions[i].revid] = "ts" + revisions[i].timestamp.replace(/[-:TZ]/g,"")
				
			debug("Récupération des timestamp des versions", true)
			button.disabled = false
		}
		
		button.disabled = true
		httpRequest(url, null, handler)
	}
		
	var createCheckbox = function()
	{
		history.parentNode.insertBefore(document.createElement("br"), history)
		history.parentNode.insertBefore(document.createTextNode("Commentaire"), history)
		reason = document.createElement("input")
		reason.type = "text"
		reason.style.margin = "0.2em 0.2em 0.2em 1em"
		reason.style.width = "40em"
		history.parentNode.insertBefore(reason, history)
		history.parentNode.insertBefore(document.createElement("br"), history)
		info = document.createElement("pre")
		history.parentNode.insertBefore(info, history)
	
		checkboxsCreated = true
		var lis = history.getElementsByTagName("li")
		var l = lis.length
		
		var startId, endId
		
		var startId = lis[0].getElementsByTagName("input")[0].value
		var endId = lis[l-1].getElementsByTagName("input")[0].value
		
		createTimestampWrapper(startId, endId)
		
		for(var i=0;i!=l;i++)
		{
			var checkbox = document.createElement("input")
			checkbox.type="checkbox"
			
			var namedItem = document.createAttribute("revid");
			namedItem.value = lis[i].getElementsByTagName("input")[0].value
			checkbox.attributes.setNamedItem(namedItem)
			
			checkbox.addEventListener('click', function(e)
			{
				var revid = this.attributes.getNamedItem("revid").value
				if(this.checked) revToPurge[revid] = true
				else delete revToPurge[revid]
				
			} , true);
			
			
			lis[i].insertBefore(checkbox, lis[i].firstChild)
		}
	}
	
	var httpRequest = function(url, post, handler)
	{
		var req	
		
		if(window.XMLHttpRequest) req = new XMLHttpRequest()
		else if(window.ActiveXObject)	req = new ActiveXObject("Microsoft.XMLHTTP")
		else return false
 
		req.onreadystatechange = function()
		{
			if(req.readyState == 4 && req.status == 200) 
			{
				var res = req.responseText
				
				if(url.indexOf("&format=json")!=-1)
				{
					try { res = eval("("+res+")")	}
					catch(err)
					{
						debug('ERROR : ' + err.description)
						return
					}
				}
				try{handler(res)}
				catch(e)
				{
					debug("Erreur! Veuillez copier coller tout ce log sur la page de discussion de Maloq : ")
					debug(url)
					if(post!=null) debug(post)
					if(url.indexOf("&format=json")!=-1) debug(req.responseText)
				}
			}
		}
		
		req.open(post==null?"GET":"POST", "http://fr.wikipedia.org/w/" + url, true)
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
		req.send(post)
	
	}

	var deleteInitialPage = function()
	{
		debug("Récupération du jeton")
		var url, post
		
		var handler = function(res)
		{
			for(var p in res.query.pages)
			{
				token = res.query.pages[p].deletetoken
				break
			}

			debug("Récupération du jeton", true)
			debug("suppression de la page initiale")
			deletePage(window["wgPageName"], restoreRevisionToPurge)
		}
		
		url = "api.php?action=query&prop=info&intoken=delete&format=json&titles=" + pageURI 
 		httpRequest(url, null, handler)
	
	}
	
	function restoreRevisionToPurge()
	{
		debug("suppression de la page initiale", true)
		debug("Restauration des versions à purger")
		
		restoreRevisions(revToPurge, renamePage)
	}
	
	function restoreRevisions(rev, handler)
	{
		var url = "index.php?title=Special:Restaurer&action=submit"
		var post = "wpComment=" + encodeURIComponent("[[user:Maloq/Easy purge|Easy purge]] : restauration des versions à purger");
		post += "&restore=" + encodeURIComponent("Restaurer");
		
		for(var id in rev)
		{
			if(timestampWrapper[id]!=undefined)
				post += "&" + encodeURIComponent(timestampWrapper[id]) + "=1"
		}
		
		post += "&target=" + pageURI;
		post += "&wpEditToken=" + encodeURIComponent(token);
		
		httpRequest(url, post, handler)
	}
	
	
	function renamePage(req)
	{
		debug("Restauration des versions à purger", true)
		debug("Renommage des versions à purger")
		

		var url = "index.php?title=Special:Renommer&action=submit"
		var post = "wpNewTitle=" + pageURI + encodeURIComponent("/purge")
		post+= "&wpOldTitle=" + pageURI
		post+= "&wpReason=" + encodeURIComponent("[[user:Maloq/Easy purge|Easy purge]] : " + reason.value)
		post+= "&wpWatch=1" 
		post+= "&wpConfirm=1" 
		post+= "&wpMove=" + encodeURIComponent("Renommer l'article")
		post+= "&wpEditToken=" + encodeURIComponent(token)
		
		var handler = function()
		{
			debug("Renommage des versions à purger", true)
			debug("Suppression des versions à purger")
			deletePage(window["wgPageName"]+"/purge", function()
			{
				debug("Suppression des versions à purger", true)
				debug("Restauration des version saines");
				restoreRevisions({}, undoLastRename)
			})
		}
		
		httpRequest(url, post, handler)
	}
	
	var undoLastRename = function()
	{
		debug("Restauration des version saines", true);
		debug("Dernier rétablissement");
		
		var url = "api.php?action=query&prop=revisions&rvprop=content&format=json&rvlimit=2&titles="+  pageURI
	
		var handler = function(res)
		{	
			var revisions = res.query.pages
			for(var id in revisions)
			{
				revisions = revisions[id].revisions
				break
			}
			
			var content = revisions[1]["*"]
			
			editContent(content)
		}
		
		httpRequest(url, null, handler)
	}
	
	function getInputValueFromStr(str)
	{
		var regexp = new RegExp()
		var match
		regexp.compile(/value=["']([^"']+)["']/)
	
		match = regexp.exec(str)
		if(match) return match[1]
	
		return ""
	}

	function editContent(content)
	{
		var req=new XMLHttpRequest()
	
		req.onreadystatechange = function()
		{
			if(req.readyState == 4)
			{
				if(req.status==200)
				{			
					var regexp = new RegExp()
					var match
					var wpStarttime = ""
					var wpEdittime = "" 
					var wpEditToken = ""
					var wpWatchthis = ""
	
					regexp.compile(/(<input[^>]+name="wpStarttime"[^>]+>)/)
					match=regexp.exec(req.responseText)
					if(match) wpStarttime = getInputValueFromStr(match[1])
	
					regexp.compile(/(<input[^>]+name="wpEdittime"[^>]+>)/)
					match=regexp.exec(req.responseText)
					if(match) wpEdittime = getInputValueFromStr(match[1])
	
					regexp.compile(/(<input[^>]+name="wpEditToken"[^>]+>)/)
					match=regexp.exec(req.responseText)
					if(match) wpEditToken = getInputValueFromStr(match[1])
	
					regexp.compile(/(<input[^>]+name="wpWatchthis"[^>]+>)/)
					match=regexp.exec(req.responseText)
					if(match) wpWatchthis = getInputValueFromStr(match[1])
	
					var reqSubmit=new XMLHttpRequest()
	
					var post = "wpTextbox1=" + encodeURIComponent(content)
					post = post + "&wpSummary=" + encodeURIComponent("[[user:Maloq/Easy purge|Easy purge]] : Restauration")
					post = post + "&wpStarttime=" + encodeURIComponent(wpStarttime)
					post = post + "&wpEdittime=" + encodeURIComponent(wpEdittime)
					post = post + "&wpEditToken=" + encodeURIComponent(wpEditToken)
					post = post + "&wpWatchthis=" + encodeURIComponent(wpWatchthis)
	
					reqSubmit.open("POST","/w/index.php?title=" + pageURI  + "&action=submit", false)
	
					reqSubmit.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
					reqSubmit.send(post)
					debug("Dernier rétablissement", true);
					//window.location = window.location
				}
			}
		}
	
		req.open("GET","/w/index.php?title=:" + pageURI  + "&action=edit")
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
		req.send(null)
	}
	

	var deletePage = function(page, handler)
	{
		var url, post
		
		
		url = "index.php?action=delete&title=" + encodeURIComponent(page) 
		post = "wpDeleteReasonList=" + encodeURIComponent("[[user:Maloq/Easy purge|Easy purge]]");
		post += "&wpReason=" + encodeURIComponent(reason.value);
		post += "&wpEditToken=" + encodeURIComponent(token);
		post += "&wpWatch=" + encodeURIComponent(1);
			
		httpRequest(url, post, handler)
		
	}
		
	button.addEventListener('click', function(e)
	{
	
		e.preventDefault()
		
		if(!checkboxsCreated)
		{
			createCheckbox()
			button.value = "Choississez les versions à purger, remplissez le commentaire, et cliquez ici";
		}
		else
		{
			button.disabled = true
			deleteInitialPage()
		}
	}
	, true); 
	
	//http://fr.wikipedia.org/w/
	
})