//<source lang="javascript" line>
/*
* Fonction
*
* Ajoute un bouton ou plusieurs boutons dans la barre d'outils (voir http://fr.wikipedia.org/wiki/MediaWiki:Gadget-AjoutBoutonSource.js pour un exemple d'utilisation de cette fonction)
* @param messages_debut Tableau Javascript contenant le texte devant être inséré au début du texte sélectionné
* @param messages_fin Tableau Javascript contenant le texte devant être inséré à la fin du texte sélectionné
* @param commentaires Tableau Javascript contenant le commentaire affiché dans l'infobulle lorsque l'on passe le curseur sur le bouton de la barre d'outil
* @param images Tableau Javascript contenant l'URL de l'image qui servira pour le bouton
* @param id_images Tableau Javascript contenant l'ID de l'image
* Auteur : Sanao
* Dernière révision : 22 novembre 2007
*/
function ajoutBoutonsToolbar(messages_debut, messages_fin, commentaires, images, id_images)
{
  if (document.createTextNode)
  {
    if (document.getElementById("toolbar"))
    {
      for (var cpt = 0; cpt < messages_fin.length; cpt++)
      {
        if(getVarValue(id_images[cpt], "show") != "hide")
        {
          addButton(images[cpt], commentaires[cpt], messages_debut[cpt], messages_fin[cpt], "", "mw-editbutton-" + id_images[cpt]);
        }
      }
    }
  }
}
//</source>
//<nowiki>
/*
* Deluxe Bar
*
* Barre d'outils d'édition étendue
*
* Auteur : Dake
* Modifié par : Sanao
* Dernière révision : 24 novembre 2007
*/ 
function DeluxeBar()
{
  var messages_debut = new Array();
  var messages_fin = new Array();
  var images = new Array();
  var commentaires = new Array();
  var id_images = new Array();
 
  with (messages_debut) 
  {
    push(""); //Bienvenue sur ta page !
    push(""); //Bienvenue sur Wikipédia!
    

    push(""); //Avertissement copyvio
    push(""); //Avertissement spam
    push(""); //Fait
    push(""); //Test 0
    push(""); //Test 1
    push(""); //Test 2-
    push(""); //Test 2
    push(""); //Test 2+
    push(""); //Test 3
  }
 
  with (messages_fin) 
  {
    push("{{subst:Bienvenu}} — ~~~~");
    push("{{subst:Bienvenue nouveau}} — ~~~~");


    push("{{subst:Copieur|article|page copiée}} — ~~~~");
    push("{{subst:Bienvenue spammeur|article}} — ~~~~");
    push("{{Fait}} '''Fait.''' — ~~~~");
    push("{{subst:Test 0}} — ~~~~"); //Test 0
    push("{{subst:Test 1}} — ~~~~"); //Test 1
    push("{{subst:Test 2-}} — ~~~~"); //Test 2-
    push("{{subst:Test 2}} — ~~~~"); //Test 2
    push("{{subst:Test 2+}} — ~~~~"); //Test 2+
    push("{{subst:Test 3}} — ~~~~"); //Test 3
  }
 
  with (images)
  {
    push("http://upload.wikimedia.org/wikipedia/commons/1/12/Button_accueilA.png");
    push("http://upload.wikimedia.org/wikipedia/commons/e/eb/Button_accueilB.png");


    push("http://upload.wikimedia.org/wikipedia/commons/5/58/Button_black_copyright.png");
    push("http://upload.wikimedia.org/wikipedia/commons/f/fb/Button_spam2.png");
    push("http://upload.wikimedia.org/wikipedia/commons/d/d9/Button_trait%C3%A9.png");
    push("http://img213.imageshack.us/img213/8904/bouton0yg5.jpg"); //Test 0
    push("http://img516.imageshack.us/img516/7335/bouton1zw0.jpg"); //Test 1
    push("http://img101.imageshack.us/img101/1863/bouton2dl1.jpg"); //Test 2-
    push("http://img185.imageshack.us/img185/6297/bouton2ki9.jpg"); //Test 2
    push("http://img142.imageshack.us/img142/3640/bouton2il7.jpg"); //Test 2+
    push("http://img181.imageshack.us/img181/4079/bouton3xo8.jpg"); //Test 3
  }
 
  with (commentaires)
  {
    push("Bienvenue sur ta page utilisateur !");
    push("Bienvenue sur Wikipédia !");


    push("Avertissement copyvio");
    push("Avertissement spam");
    push("Fait");
    push("Vandalisme — Niveau 0"); //Test 0
    push("Vandalisme — Niveau 1"); //Test 1
    push("Vandalisme — Niveau 2"); //Test 2-
    push("Vandalisme — Niveau 2"); //Test 2
    push("Vandalisme — Niveau 2"); //Test 2+
    push("Vandalisme — Niveau 3 — Sysop Request Soon..."); //Test 3
  }
 
  with (id_images)
  {
    push("bienvenue_sur_ta_page");
    push("bienvenue");


    push("avertissement_copyvio");
    push("avertissement_spam");
    push("fait");
    push("Vandalisme — Niveau 0"); //Test 0
    push("Vandalisme — Niveau 1"); //Test 1
    push("Vandalisme — Niveau 2"); //Test 2-
    push("Vandalisme — Niveau 2"); //Test 2
    push("Vandalisme — Niveau 2"); //Test 2+
    push("Vandalisme — Niveau 3 — Sysop Request Soon..."); //Test 3
  }
 
  ajoutBoutonsToolbar(messages_debut, messages_fin, commentaires, images, id_images);
}       
if( wgAction == 'edit' || wgAction == 'submit' ) addOnloadHook(DeluxeBar);
//</nowiki>
/*
 * Résumé Deluxe
 *
 * Ajoute des commentaires de modification prédéfinis
 *
 * Auteur : Dake
 * Contributions : Pabix, Tieno
 * Date de dernière révision : 12 novembre 2006
 * {{Catégorisation JS}}
 */
 
//////////////////////ZONE PERSONNALISABLE//////////////////////
var resumedeluxeTitles = new Array();
with (resumedeluxeTitles) {
        push("orthographe");
        push("- typographie");
        push("- redirection");
        push("- style");
        push("- ++ réponse");
        push("- ++ bandeau");
        push("- vandalisme !!!");
        push("- spam !!!");
        push("- ++ NPOV");
        push("- source ++");
}
var resumedeluxeInputs= new Array();
with (resumedeluxeInputs) {
        push("orthographe");
        push("typographie");
        push("redirection");
        push("style");
        push("++ réponse");
        push("++ bandeau");
        push("vandalisme !!!");
        push("spam !!!");
        push("++ NPOV");
        push("source ++");
}
/////////////////FIN DE LA ZONE PERSONNALISABLE/////////////////
 
function setSummary(str)
{
        document.editform.wpSummary.value = str;
}
 
function addToSummary(str)
{
        var resum = document.editform.wpSummary.value;
        if(resum != 0 && resum.indexOf("*/") < resum.length - 3) {
                document.editform.wpSummary.value += " - ";
        }
        document.editform.wpSummary.value += str;
}
 
function DeluxeSummary()
{
        if (document.URL.indexOf("&section=new") > 0) return;
        var sumLbl = document.getElementById("wpSummaryLabel");
        if(sumLbl) {
                var sumInput = document.getElementById("wpSummary");
                sumInput.style.width = "95%";
                var str = "Messages prédéfinis : ";
                for(var cpt = 0; cpt < resumedeluxeTitles.length; cpt ++) {
                        var tmp = resumedeluxeInputs[cpt];
                        str += "<a href=\"javascript:addToSummary('" + tmp.replace( /[']/g , "\\'") + "')\""
                                + " class=\"sumLink\" title=\"Ajouter dans la boîte de résumé\">"
                                + resumedeluxeTitles[cpt]
                                + "</a> ";
                }
                sumLbl.innerHTML = str + "<br />" + sumLbl.innerHTML;
        }
}
addOnloadHook(DeluxeSummary);