//<nowiki>
/**
 * Ajoute des liens après les catégories pour rapidement
 * supprimer / modifier / ajouter une catégorie sur un article.
 * Utilise Ajax et l'api MediaWiki pour rechercher une catégorie.
 * Version adaptée pour WP:fr de [[:commons:MediaWiki:HotCat.js]]
 * 
 * Auteur original : Magnus Manske
 * Adaptation pour WP:fr : Zelda
 * Adaptation édition multiple : Dr Brains
 *
 * [[Catégorie:MediaWiki:Fonction Monobook en JavaScript]]
 */
 
///////////////////////// VARIABLES ////////////////////////////////////////////////////////
 
//// VARIABLES PERSONNALISABLES ////
 
// Suggestion delay in ms
var hotcat_suggestion_delay = 200;
 
// Taille de la liste déroulante (en items)
var hotcat_list_size = 10;
 
// Nombre de categories suggérées lors de la recherche
var hotcat_list_items = 50;
 
// Permet d'enregistrer automatiquement la modif sans repasser par la fenêtre d'édition
var hotcat_autocommit = true;
 
// Permet d'afficher la liste de suggestion vers le bas
var hotcat_list_down = false;
 
//// TEXTES ////
var hotcat_text_MainCategory = "Accueil";
var hotcat_text_MainCategoryText = "Catégories";
 
var hotcat_text_RemoveLinkText = "(–)";
var hotcat_text_RemoveLinkTitle = "Supprimer la catégorie";
var hotcat_text_RemoveConfirm = "Voulez-vous vraiment supprimer la catégorie";
var hotcat_text_ModifyLinkText = "(±)";
var hotcat_text_ModifyLinkTitle = "Modifier la catégorie";
var hotcat_text_AddLinkText = "(+)";
var hotcat_text_AddLinkTitle = "Ajouter une catégorie";
 
var hotcat_text_InputOK = "OK";
var hotcat_text_InputCancel = "Annuler";
 
var hotcat_text_MultiLinkText = "(±)";
var hotcat_text_MultiLinkTitle = "Modifier plusieurs catégories (EN DÉVELOPPEMENT)";
var hotcat_text_MultiInputOK = "Valider";
var hotcat_text_MultiInputCancel = "Annuler";
 
var hotcat_text_RecapTitle = 'Récapitulatif :';
var hotcat_text_RecapRemove = 'Catégories à supprimer :';
var hotcat_text_RecapModify = 'Catégories à modifier :'
var hotcat_text_RecapAdd = 'Catégories à ajouter :'
 
var hotcat_text_ResumeModify = "Modification de la catégorie [[Catégorie:$1]] → [[Catégorie:$2]]";
var hotcat_text_ResumeRemove = "Retrait de la catégorie [[Catégorie:$1]]";
var hotcat_text_ResumeAdd = "Ajout de la catégorie [[Catégorie:$1]]";
var hotcat_text_ResumeScript = " (avec [[Utilisateur:Dr Brains/HotCatsPerso.js|HotCats]])";
 
var hotcat_text_AlertProblem1 = "Impossible de trouver la catégorie « $1 » - elle est peut-être incluse via un modèle.";
var hotcat_text_AlertProblem2 = "La catégorie « $1 » est déjà présente.";
var hotcat_text_AlertProblem3 = "Plusieurs occurrences de la catégorie « $1 » trouvées.";
 
//// VARIABLES NON PERSONNALISABLES ////
 
var hotcat_running = 0 ;
var hotcat_last_v = "" ;
var hotcat_exists_yes = "http://upload.wikimedia.org/wikipedia/commons/thumb/b/be/P_yes.svg/20px-P_yes.svg.png" ;
var hotcat_exists_no = "http://upload.wikimedia.org/wikipedia/commons/thumb/4/42/P_no.svg/20px-P_no.svg.png" ;
var hotcat_edit_id_map=[];
var hotcat_Form_Index = 1000;
var hotcat_NewCatsIndex = 1000;
 
///////////////////////// LANCEMENT ////////////////////////////////////////////////////////
 
if( wgNamespaceNumber%2 == 0 && document.URL.indexOf("printable=yes")==-1 && wgAction!="history"){ 
    importStylesheet('Utilisateur:Dr Brains/HotCatsPerso.css');
    addOnloadHook ( hotcat ) ;
}
 
// FONCTION DE TRANSFORMATION INITIALE
 
function hotcat () {
    if ( hotcat_check_action() ) return ;
    var catlinks = document.getElementById("catlinks");
    if (! catlinks) { 
        var bodyC = document.getElementById("bodyContent");
        catlinks = document.createElement("div");
        catlinks.id = "catlinks"; 
        catlinks.className = "catlinks";
        catlinks = bodyC.appendChild(catlinks);
    }else{
        removeClass(catlinks, "catlinks-allhidden");
    }
    var catline = document.getElementById ('mw-normal-catlinks');
    if( !catline ) {
        catline = catlinks.insertBefore(document.createElement("div"), catlinks.firstChild);
        catline.id = "mw-normal-catlinks";
    }  
    if ( catline == null || typeof catline == 'undefined' ) return ;
    hotcat_modify_existing ( catline ) ;
    hotcat_append_add_span ( catline ) ;
    hotcat_append_multiedit_span( catline );
}
 
// ??
 
function hotcatGetEditId(ob){
    var i;
    for(i=0;i<hotcat_edit_id_map.length;i++){
        if (hotcat_edit_id_map[i]===ob){ 
            return i;
        }
    }
    i=hotcat_edit_id_map.length;
    hotcat_edit_id_map.push(ob);
    return i;
}
 
// CRÉATION FAUSSE BARRE DE CATÉGORIES
 
function hotcat_append_add_span ( catline ) {
    var span_add = document.createElement ( "span" ) ;
    var span_sep = document.createTextNode ( " | " ) ;
    if ( catline.firstChild ){
        catline.appendChild ( span_sep ) ;
    }else {
        var a = document.createElement('a');
        a.href = wgServer+wgArticlePath.split('$1').join(wgFormattedNamespaces[14]+':'+hotcat_text_MainCategory);
        a.title = wgFormattedNamespaces[14]+':'+hotcat_text_MainCategory;
        a.appendChild(document.createTextNode(hotcat_text_MainCategoryText));
        catline.appendChild(a);
        catline.appendChild(document.createTextNode(' : '));
    }
    catline.appendChild ( span_add ) ;
    hotcat_create_span ( span_add ) ;
}
 
// MODIFICATION DE LA BARRE DE CATÉGORIES
 
function hotcat_modify_existing ( catline ) {
    var spans = catline.getElementsByTagName ( "span" ) ;
    for ( var i = 0 ; i < spans.length ; i++ ) {
        hotcat_modify_span ( spans[i] ) ;
    }
}
 
// AJOUT DES LIENS (–) ET (±)
 
function hotcat_modify_span ( span ) {
    var cat_link = span.getElementsByTagName('a')[0];
    if(!cat_link) return;
    var cat_title = cat_link.title;
    if(!cat_title) return;
    // Removing leading Category:
    cat_title = cat_title.split(wgFormattedNamespaces[14]+':').join('');
    cat_title = cat_title.replace(/ \(page inexistante\)$/, "");
    var sep1 = document.createTextNode ( " " ) ;
    var i=hotcatGetEditId(span);
    span.id = "hotcat_Span_" + i ;
    var a1 = document.createTextNode ( "(–)" ) ;
    var remove_link = document.createElement ( "a" ) ;
    var remove_id = "hotcat_remove_" + i ;
    remove_link.id = remove_id;
    remove_link.href = "javascript:hotcat_remove(\"" + cat_title + "\",\""+remove_id+"\");" ;
    remove_link.title = hotcat_text_RemoveLinkTitle+" « "+cat_title+" »";
    remove_link.appendChild ( a1 ) ;
    span.appendChild ( sep1 ) ;
    span.appendChild ( remove_link ) ;
 
    var mod_id = "hotcat_modify_" + i ;
    var sep2 = document.createTextNode ( " " ) ;
    var a2 = document.createTextNode ( "(±)" ) ;
    var modify_link = document.createElement ( "a" ) ;
    modify_link.id = mod_id ;
    modify_link.href = "javascript:hotcat_modify(\"" + mod_id + "\",\""+cat_title+"\");" ;
    modify_link.title = hotcat_text_ModifyLinkTitle+" « "+cat_title+" »";
    modify_link.appendChild ( a2 ) ;
    span.appendChild ( sep2 ) ;
    span.appendChild ( modify_link ) ;
}
 
// AJOUT DU LIEN (+)
 
function hotcat_create_span ( span_add ) {
    hotcat_clear_span ( span_add );
    var a_add = document.createElement ( "a" ) ;
    var a_text = document.createTextNode ( hotcat_text_AddLinkText ) ;
    span_add.id = "hotcat_add" ;
    a_add.id = "hotcat_addlink" ;
    a_add.href = "javascript:hotcat_add_new()" ;
    a_add.title = hotcat_text_AddLinkTitle ;
    a_add.appendChild ( a_text ) ;
    span_add.appendChild ( a_add ) ;
}
 
///////////////////////// ÉDITION SIMPLE ////////////////////////////////////////////////////////
 
// FONCTION DE RETRAIT D'UNE CATÉGORIE
 
function hotcat_remove ( cat_title ) {
    var editlk = document.getElementById('ca-edit').getElementsByTagName('a')[0].href;
    if (window.confirm(hotcat_text_RemoveConfirm+" « " + cat_title + " » ?")) {
        document.location = editlk + '&hotcat_removecat=' + encodeURIComponent(cat_title) ;
    }
}
 
// MODIFICATION D'UNE CATÉGORIE
 
function hotcat_modify ( link_id, catname ) {
    var link = document.getElementById ( link_id ) ;
    var span = link.parentNode ;
    var Links = span.getElementsByTagName('a');
    for(a=0;a<Links.length;a++){
         Links[a].style.display = "none";
    }
    span.firstChild.style.display = "none" ;
    hotcat_create_new_span ( span , catname ) ;
    hotcat_last_v = "" ;
    hotcat_text_changed();
}
 
// AJOUT D'UNE CATÉGORIE
 
function hotcat_add_new () {
    var span_add = document.getElementById ( "hotcat_add" ) ;
    span_add.getElementsByTagName('a')[0].style.display = "none";
    hotcat_last_v = "" ;
    hotcat_create_new_span ( span_add , "" ) ;
}
 
// CRÉATION DU FORMULAIRE DE MODIFICATION OU D'AJOUT D'UNE CATÉGORIE
 
function hotcat_create_new_span ( thespan , init_text ) {
    var OldForms = document.getElementById('mw-normal-catlinks').getElementsByTagName('form');
    while(OldForms[0]) OldForms[0].parentNode.removeChild(OldForms[0]);
    var CatLinks = document.getElementById('mw-normal-catlinks').getElementsByTagName('a');
    for(var a=0;a<CatLinks.length;a++){
        if(CatLinks[a].parentNode!=thespan) CatLinks[a].style.display = "";
    }
 
    var form = document.createElement ( "form" ) ;
    form.method = "post" ;
    form.onsubmit = function () { hotcat_ok(); return false; } ;
    form.id = "hotcat_form" ;
    form.style.display = "inline" ;
 
    var list = document.createElement ( "select" ) ;
    list.id = "hotcat_list" ;
    list.onclick = function () { document.getElementById("hotcat_text").value = document.getElementById("hotcat_list").value ; hotcat_text_changed() ; } ;
    list.ondblclick = function () { document.getElementById("hotcat_text").value = document.getElementById("hotcat_list").value ; hotcat_text_changed() ; hotcat_ok(); } ;
    list.style.display = "none" ;
 
    var text = document.createElement ( "input" ) ;
    text.size = 40 ;
    text.id = "hotcat_text" ;
    text.type = "text" ;
    text.value = init_text ;
    text.onkeyup = function () { window.setTimeout("hotcat_text_changed();", hotcat_suggestion_delay ); } ;
 
    var exists = document.createElement ( "img" ) ;
    exists.id = "hotcat_exists" ;
    exists.src = hotcat_exists_no ;
 
    var OK = document.createElement ( "input" ) ;
    OK.type = "button" ;
    OK.value = hotcat_text_InputOK ;
    OK.onclick = hotcat_ok ;
 
    var cancel = document.createElement ( "input" ) ;
    cancel.type = "button" ;
    cancel.value = hotcat_text_InputCancel ;
    cancel.onclick = hotcat_cancel ;
 
    form.appendChild ( list ) ;
    form.appendChild ( text ) ;
    form.appendChild ( exists ) ;
    form.appendChild ( OK ) ;
    form.appendChild ( cancel ) ;
    thespan.appendChild ( form ) ;
    text.focus () ;
}
 
// VALIDATION DU FORMULAIRE
 
function hotcat_ok () {
    var text = document.getElementById ( "hotcat_text" ) ;
    var v = text.value ;
    if ( v == "" ) {
        hotcat_cancel() ;
        return ;
    }
    var editlk = document.getElementById('ca-edit').getElementsByTagName('a')[0].href;
    var url = editlk + '&hotcat_newcat=' + encodeURIComponent( v ) ;
    var span = text.parentNode.parentNode ; // span.form.text
    if ( span.id != "hotcat_add" ) { // Not plain "addition"
        var cat_title = span.firstChild.innerHTML ;
        cat_title = cat_title.substr(cat_title.indexOf(":") + 1);
        url += '&hotcat_removecat=' + encodeURIComponent( cat_title ) ;
    }
    document.location = url ;
}
 
// ANNULATION DU FORMULAIRE
 
function hotcat_cancel () {
    var span = document.getElementById("hotcat_form").parentNode ;
    var Form = span.getElementsByTagName('form')[0];
    span.removeChild ( Form ) ;
    var Links = span.getElementsByTagName('a');
    for(a=0;a<Links.length;a++){
        Links[a].style.display = "";
    }
    span.firstChild.style.display = "" ;
}
 
// VIDAGE D'UN ÉLÉMENT <SPAN>
 
function hotcat_clear_span( span_add ) {
    while ( span_add.firstChild ) span_add.removeChild ( span_add.firstChild ) ;
}
 
// PREMIÈRE LETTRE EN MAJUSCULE
 
String.prototype.ucFirst = function () {
   return this.substr(0,1).toUpperCase() + this.substr(1,this.length);
}
 
// RÉCUPÉRATION DES PARAMÈTRES DE L'URL
 
function hotcatGetParamValue(paramName, h) {
        if (typeof h == 'undefined' ) { h = document.location.href; }
        var cmdRe=RegExp('[&?]'+paramName+'=([^&]*)');
        var m=cmdRe.exec(h);
        if (m) {
                try {
                        return decodeURIComponent(m[1]);
                } catch (someError) {}
        }
        return null;
}
 
// ÉDITION 
 
function hotcat_check_action () {
    var ret = 0 ;
    if ( wgAction != "edit" ) return ret ; // Not an edit page, so no business...
    var summary = new Array () ;
    var t = document.editform.wpTextbox1.value ;
    var prevent_autocommit = 1 ;
 
    if ( typeof hotcat_autocommit != 'undefined' && hotcat_autocommit ) prevent_autocommit = 0 ;
 
    // Remove existing category?
    var hrc = hotcatGetParamValue('hotcat_removecat') ;
   // Add new category?
    var hnc = hotcatGetParamValue('hotcat_newcat') ;
 
    if ( typeof hrc != "undefined" && hrc != null && hrc != "" ) {
        var hcre = new RegExp("(\\s*)\\[\\[ *(?:Catégorie|Category) *: *" + hrc.replace(/([\\\^\$\*\+\?\.\|\{\}\[\]\(\)])/g, "\\$1") + " *(\\|[^\\]]*)?\\]\\]", "gi");
        var matches = t.match(hcre);
        if (matches != null && matches.length == 1) { // Found one occurrence of the category - good!
            if ( typeof hnc != "undefined" && hnc != null && hnc != "" ) {
                if(hnc.indexOf('|')!=-1){
                    t = t.replace(hcre, "$1[[Catégorie:" + hnc + "]]");                    
                }else{
                    t = t.replace(hcre, "$1[[Catégorie:" + hnc + "$2]]");
                }
                summary.push ( hotcat_text_ResumeModify.split('$1').join(hrc).split('$2').join(hnc.replace(/\|.*/g, ""))) ;
            } else {
                t = t.replace(hcre, "");
                summary.push ( hotcat_text_ResumeRemove.split('$1').join(hrc) ) ;
            }
            ret = 1 ;
        } else {
            if(matches == null || matches.length < 1) alert(hotcat_text_AlertProblem1.split('$1').join(hrc));
            if(matches.length > 1) alert(hotcat_text_AlertProblem3.split('$1').join(hrc));
            prevent_autocommit = 1 ;
        }
    } else {
        // Only adding?
        if ( typeof hnc != "undefined" && hnc != null && hnc != "" ) {
            var catName = hnc.replace(/\|.*/g, "");
            var hcre = new RegExp("(\\s*)\\[\\[ *(?:Catégorie|Category) *: *" + hnc.replace(/([\\\^\$\*\+\?\.\|\{\}\[\]\(\)])/g, "\\$1") + " *(\\|[^\\]]*)?\\]\\]", "gi");
            var matches = t.match(hcre);
            if (matches != null){
                 alert(hotcat_text_AlertProblem2.split('$1').join(catName));
                 prevent_autocommit = 1 ;
            }else{
                // Looking for last cat
                var re = /\[\[(?:Catégorie|Category):[^\]]+\]\]/ig
                var index = -1;
                while (re.exec(t) != null) index = re.lastIndex;
                var txt = "[[Catégorie:" + hnc + "]]" ;
                if (index < 0) {  // no category
                    var interWiki = new RegExp('^\\s*\\[\\[([a-z][a-z].?(x?-[^\\]]+)?|simple|tokipona):([^\\]]*)\\]\\]\\s*$');
                    var blank = new RegExp('^\\s*$');
                    var lines = t.split('\n');
                    var DebutModele = '';
                    var SuiteModele = '';
                    var FoundInterwiki = false;
                    for (var lineId = lines.length - 1; lineId >= 0; --lineId){
                        if (!interWiki.exec(lines[lineId]) && !blank.exec(lines[lineId])){
                            DebutModele = lines.slice(0, lineId + 1).join('\n');
                            SuiteModele = lines.slice(lineId + 1).join('\n');
                            break;
                        }
                    }
                    DebutModele = DebutModele + '\n\n';
                    while(SuiteModele.indexOf('\n\n')!=-1){
                        SuiteModele = SuiteModele.split("\n\n").join("\n");
                    }
                    SuiteModele = SuiteModele.replace(/^\n/, "");
                    t = DebutModele + txt + '\n\n' + SuiteModele;
                } else {  // already a category
                    t = t.substring(0, index) + '\n' + txt + t.substring(index);
                }
                summary.push ( hotcat_text_ResumeAdd.split('$1').join(hnc.replace(/\|.*/g, ""))) ;
                ret = 1 ;
            }
        }
    }
    if ( ret ) {
        document.editform.wpTextbox1.value = t ;
        document.editform.wpSummary.value = summary.join( " ; " ) + hotcat_text_ResumeScript ;
        document.editform.wpMinoredit.checked = true ;
        if ( !prevent_autocommit ) {
            document.editform.submit();
            document.editform.style.display = "none" ; 
        }
    }
    return ret ;
}
 
///////////////////////// ÉDITION MULTIPLE ////////////////////////////////////////////////////////
 
// AJOUT DU LIEN (±)
 
function hotcat_append_multiedit_span( CatLine ){
    var FirstLink = CatLine.getElementsByTagName('a')[0];
    var Span = document.createElement('span');
    Span.id ='hotcat_modify_multi_span';
    var Link = document.createElement('a');
    Link.id = "hotcat_modify_multi_Link";
    Link.innerHTML = hotcat_text_MultiLinkText;
    Link.title = hotcat_text_MultiLinkTitle;
    Link.href = "javascript:hotcat_multiedit_createForm();";
    Span.appendChild(Link);
    FirstLink.parentNode.insertBefore(Span, FirstLink.nextSibling);
    FirstLink.parentNode.insertBefore(document.createTextNode(" "), FirstLink.nextSibling);
}
 
// CREATION DU FORMULAIRE "MULTI" + MODIFICATION DES LIENS, FONCTIONS ET IDS DE LA BARRE DE CATÉGORIES
 
function hotcat_multiedit_createForm(){
    var OldForms = document.getElementById('mw-normal-catlinks').getElementsByTagName('form');
    while(OldForms[0]) OldForms[0].parentNode.removeChild(OldForms[0]);
    var OldLinks = document.getElementById('mw-normal-catlinks').getElementsByTagName('a');
    for(var a=0;a<OldLinks.length;a++){
        OldLinks[a].style.display="";
    }
    var OldSpans = document.getElementById('mw-normal-catlinks').getElementsByTagName('span');
    for(var a=0;a<OldSpans.length;a++){
        OldSpans[a].style.display="";
    }
    if(!document.getElementById("hotcat_addlink")) hotcat_add_new ( document.getElementById("hotcat_add") );
 
    var Link = document.getElementById('hotcat_modify_multi_Link');
    var Span = Link.parentNode;
    var Form = document.createElement('form');
    Form.id = "hotcat_modify_multi_form";
    Form.innerHTML = '<input id="hotcat_modify_multi_InputOK" type="button" disabled="disabled" '
                   + 'value="'+hotcat_text_MultiInputOK+'" '
                   + 'onclick="hotcat_multiedit_FormOK()" onselect="hotcat_multiedit_FormOK()" />'
                   + '<input id="hotcat_modify_multi_InputCancel" type="button" '
                   + 'value="'+hotcat_text_MultiInputCancel+'" '
                   + 'onclick="hotcat_multiedit_CancelForm()" onselect="hotcat_multiedit_CancelForm()" />';
    Span.appendChild(Form);
    Link.style.display = "none";
    var CatLine = Span.parentNode;
    var CatSpans = CatLine.getElementsByTagName('span');
    for(var a=1;a<CatSpans.length;a++){
        var ThisSpan = CatSpans[a];
        var NewID = ThisSpan.id;
        var NewHTML = ThisSpan.innerHTML;
        NewID = NewID.split('hotcat_Span').join('hotcat_Multi_Span');
        NewID = NewID.split('hotcat_add').join('hotcat_Multi_add');
        ThisSpan.id = NewID;
        NewHTML = NewHTML.split('javascript:hotcat_remove').join('javascript:hotcat_Multi_remove');
        NewHTML = NewHTML.split('hotcat_modify').join('hotcat_Multi_modify');
        NewHTML = NewHTML.split('javascript:hotcat_add_new').join('javascript:hotcat_Multi_add_new');
        ThisSpan.innerHTML = NewHTML;
    }
}
 
// ANNULATION DU FORMULAIRE "MULTI" + MODIFICATION DES LIENS, FONCTIONS ET IDS DE LA BARRE DE CATÉGORIES
 
function hotcat_multiedit_CancelForm(){
    var Link = document.getElementById('hotcat_modify_multi_Link');
    var Form = document.getElementById('hotcat_modify_multi_form');
    if(Link) Link.style.display = "";
    var CatForms = document.getElementById('mw-normal-catlinks').getElementsByTagName('form');
    while(CatForms[0]){
        CatForms[0].parentNode.removeChild(CatForms[0]);
    }
    var CatSpans = document.getElementById('mw-normal-catlinks').getElementsByTagName('span');
    var SpanToRemove = new Array();
    for(var a=1;a<CatSpans.length;a++){
        var ThisSpan = CatSpans[a];
        var NewID = ThisSpan.id;
        var NewHTML = ThisSpan.innerHTML;
        NewID = NewID.split('_Multi_').join('_');
        ThisSpan.id = NewID;
        NewHTML = NewHTML.split('_Multi_').join('_');
        ThisSpan.innerHTML = NewHTML;
        ThisSpan.style.display = "";
        if(hasClass(ThisSpan, "AddedCatSpan")) SpanToRemove.push(ThisSpan);
    }
    for(var a=0;a<SpanToRemove.length;a++){    
        SpanToRemove[a].parentNode.removeChild(SpanToRemove[a]);
    }
    var CatLinks = document.getElementById('mw-normal-catlinks').getElementsByTagName('a');
    for(var a=0;a<CatLinks.length;a++){
        CatLinks[a].style.display = "";
        removeClass(CatLinks[a], "RemovedCategory");
        removeClass(CatLinks[a], "AddedCategory");
        if(hasClass(CatLinks[a], "ModifiedCategory")){
            var Parent = CatLinks[a].parentNode;
            var RemoveLink = Parent.getElementsByTagName('a')[1];
            var OldCat = RemoveLink.title.replace(/.*« /, "").replace(/ ».*/, "");
            CatLinks[a].innerHTML = OldCat;
            CatLinks[a].title = wgFormattedNamespaces[14]+':'+OldCat;
            CatLinks[a].href = wgServer+wgArticlePath.split('$1').join(wgFormattedNamespaces[14]+':'+OldCat);
            removeClass(CatLinks[a], "ModifiedCategory");
        }
    }
}
 
// VÉRIFICATION DES CHANGEMENTS EFFECTUÉS (activation du bouton OK)
 
function hotcat_Multi_CheckForChanges(){
    var CatLinks = document.getElementById('mw-normal-catlinks').getElementsByTagName('a');
    var AnythingChanged = false;
    for(var a=0;a<CatLinks.length;a++){
        var Link = CatLinks[a];
        if((hasClass(Link, "RemovedCategory"))||(hasClass(Link, "ModifiedCategory"))||(hasClass(Link, "AddedCategory"))){
            AnythingChanged = true;
        }
    }
    if(AnythingChanged){
        document.getElementById('hotcat_modify_multi_InputOK').disabled = "";
    }else{
        document.getElementById('hotcat_modify_multi_InputOK').disabled = "disabled";
    }
}
 
// VALIDATION DU FORMULAIRE "MULTI" + LISTING DES CATÉGORIES À ENLEVER/MODIFIER/AJOUTER 
 
function hotcat_multiedit_FormOK(){
    var RemovedCategories = new Array();
    var ModifiedCategories_from = new Array();
    var ModifiedCategories_to = new Array();
    var AddedCategories = new Array();
    var CatLinks = document.getElementById('mw-normal-catlinks').getElementsByTagName('a');
    for(var a=0;a<CatLinks.length;a++){
        var Link = CatLinks[a];
        if(hasClass(Link, "RemovedCategory")){
            RemovedCategories.push(Link.innerHTML);
        }
        if(hasClass(Link, "ModifiedCategory")){
            var nextLink = Link.parentNode.getElementsByTagName('a')[1];
            var From = nextLink.title;
            From = From.split('«')[1].split('»')[0];
            From = From.replace(/^ /g, "");
            From = From.replace(/ $/g, "");
            if(From!=Link.innerHTML){
                ModifiedCategories_from.push(From);
                ModifiedCategories_to.push(Link.innerHTML);
            }
        }
        if(hasClass(Link, "AddedCategory")){
            AddedCategories.push(Link.innerHTML);
        }
    }
    var TextrecapTitle = hotcat_text_RecapTitle+'\n\n'
    var TextRecap = TextrecapTitle;
    if(RemovedCategories[0]){
        TextRecap += hotcat_text_RecapRemove+'\n'
        for(var a=0;a<RemovedCategories.length;a++){
            TextRecap += '* '+RemovedCategories[a]+'\n';
        }
    }
    if(ModifiedCategories_to[0]){
        TextRecap += hotcat_text_RecapModify+'\n'
        for(var a=0;a<ModifiedCategories_to.length;a++){
            TextRecap += '* '+ModifiedCategories_from[a]+' -> '+ModifiedCategories_to[a]+'\n';
        }
    }
    if(AddedCategories[0]){
        TextRecap += hotcat_text_RecapAdd+'\n'
        for(var a=0;a<AddedCategories.length;a++){
            TextRecap += '* '+AddedCategories[a]+'\n';
        }
    }
    if(TextRecap == TextrecapTitle) return;
    var SurEtCertain = confirm(TextRecap);
    if(SurEtCertain) hotcat_Multi_Edit(RemovedCategories, ModifiedCategories_from, ModifiedCategories_to, AddedCategories);
}
 
// FONCTION CATÉGORIE À ENLEVER
 
function hotcat_Multi_remove(cat, ID){
    var Link = document.getElementById(ID);
    var OldCat = Link.title.replace(/.*« /, "").replace(/ ».*/, "");
    var Span = Link.parentNode;
    var FirstLink = Span.getElementsByTagName('a')[0];
    if(hasClass(FirstLink, "AddedCategory")){
        Span.parentNode.removeChild(Span);
    }else{
        FirstLink.innerHTML = OldCat;
        FirstLink.title = wgFormattedNamespaces[14]+':'+OldCat;
        FirstLink.href = wgServer+wgArticlePath.split('$1').join(wgFormattedNamespaces[14]+':'+OldCat);
        addClass(FirstLink, 'RemovedCategory');
        if(hasClass(FirstLink, "ModifiedCategory")){
            removeClass(FirstLink, "ModifiedCategory")
        }
    }
    hotcat_Multi_CheckForChanges();
}
 
// FONCTION CATÉGORIES À MODIFIER 
 
function hotcat_Multi_modify(id, catname){
    var link = document.getElementById ( id ) ;
    var Index = id
    Index = Index.split('hotcat_Multi_modify_').join('');
    var span = link.parentNode ;
    var Links = span.getElementsByTagName('a');
    for(a=0;a<Links.length;a++){
         Links[a].style.display = "none";
    }
    span.firstChild.style.display = "none" ;
    hotcat_Multi_create_new_span ( span , catname , Index) ;
    hotcat_last_v = "" ;
    hotcat_text_changed (Index) ; // Update icon
}
 
// CRÉATION FORMULAIRE CATÉGORIES À MODIFIER 
 
function hotcat_Multi_create_new_span( thespan , init_text, Index ){
    hotcat_Form_Index++
    var form = document.createElement ( "form" ) ;
    form.id = "hotcat_form" + Index;
    form.style.display = "inline" ;
 
    var list = document.createElement ( "select" ) ;
    list.id = "hotcat_list"+Index ;
    list.onclick = function () { 
        var Index = this.parentNode.id.split('hotcat_form').join('');
        document.getElementById("hotcat_text"+Index).value = document.getElementById("hotcat_list"+Index).value ;
        hotcat_text_changed(Index) ; 
    } ;
    list.style.display = "none" ;
 
    var text = document.createElement ( "input" ) ;
    text.size = 40 ;
    text.id = "hotcat_text"+Index ;
    text.type = "text" ;
    text.value = init_text ;
    text.onkeyup = function () { 
        var Index = this.parentNode.id.split('hotcat_form').join('');
        window.setTimeout("hotcat_text_changed("+Index+");", hotcat_suggestion_delay ); 
    } ;
    var exists = document.createElement ( "img" ) ;
    exists.id = "hotcat_exists" + Index ;
    exists.src = hotcat_exists_no ;
 
    var OK = document.createElement ( "input" ) ;
    OK.type = "button" ;
    OK.value = hotcat_text_InputOK ;
    OK.onclick = function(){
        var TheForm = this.parentNode;
        var FormIndex = TheForm.id.split('hotcat_form').join('');
        var TheSpan = TheForm.parentNode;        
        var Input = TheForm.getElementsByTagName('input')[0];
        while(Input.type!="text"){
            Input=Input.nextSibling;
            if(!Input) return;
        }
        var IfExist = TheSpan.getElementsByTagName('img')[0];
        var Exist = (IfExist.src==hotcat_exists_yes);
        var NewCatName = Input.value;
        var Links = TheSpan.getElementsByTagName('a');
        var OldCatLink = document.getElementById('hotcat_remove_'+FormIndex);
        var OldCat = OldCatLink.title.replace(/.*« /, "").replace(/ ».*/, "");
 
        Links[0].innerHTML = NewCatName;
        Links[0].title = wgFormattedNamespaces[14]+':'+NewCatName;
        Links[0].href = wgServer + wgArticlePath.split('$1').join(wgFormattedNamespaces[14]+':'+NewCatName);
        if(!Exist){
            addClass(Links[0],"new");
        }else{
            removeClass(Links[0],"new");
        }
        if((!hasClass(Links[0], "AddedCategory"))&&(!hasClass(Links[0], "ModifiedCategory"))) addClass(Links[0],"ModifiedCategory");
        var NoChange = false;
        if(OldCat==NewCatName){
            removeClass(Links[0],"ModifiedCategory");
            var NoChange = true;
        }
        removeClass(Links[0],"RemovedCategory");
        for(var a=0;a<Links.length;a++){
            Links[a].style.display = "";
        }
        TheForm.parentNode.removeChild(TheForm);
        hotcat_Multi_CheckForChanges();
    }
    var cancel = document.createElement ( "input" ) ;
    cancel.type = "button" ;
    cancel.value = hotcat_text_InputCancel ;
    cancel.onclick = function(){
        var TheForm = this.parentNode;
        var TheSpan = TheForm.parentNode;
        TheSpan.removeChild(TheForm);
        var TheLinks = TheSpan.getElementsByTagName('a');
        for(a=0;a<TheLinks.length;a++){
             TheLinks[a].style.display = "";
        }
        hotcat_Multi_CheckForChanges();
    }
    form.appendChild ( list ) ;
    form.appendChild ( text ) ;
    form.appendChild ( exists ) ;
    form.appendChild ( OK ) ;
    form.appendChild ( cancel ) ;
    thespan.appendChild ( form ) ;
    text.focus () ;
}
 
// CRÉATION FORMULAIRE CATÉGORIES À AJOUTER 
 
function hotcat_Multi_add_new(){
    var AddLink = document.getElementById("hotcat_addlink");
    var AddSpan = document.getElementById("hotcat_Multi_add");
    hotcat_Form_Index++
    var form = document.createElement ( "form" ) ;
    form.id = "hotcat_form" + hotcat_Form_Index;
    form.style.display = "inline" ;
 
    var list = document.createElement ( "select" ) ;
    list.id = "hotcat_list" + hotcat_Form_Index;
    list.onclick = function () { 
        var Index = this.id.split('hotcat_list').join('');
        document.getElementById("hotcat_text"+Index).value = document.getElementById("hotcat_list"+Index).value ;
        hotcat_text_changed(Index) ; 
    } ;
    list.style.display = "none" ;
 
    var text = document.createElement ( "input" ) ;
    text.size = 40 ;
    text.id = "hotcat_text" + hotcat_Form_Index  ;
    text.type = "text" ;
    text.value = "" ;
    text.onkeyup = function () { 
        var Index = this.id.split('hotcat_text').join('')
        window.setTimeout("hotcat_text_changed("+Index+");", hotcat_suggestion_delay ); 
    } ;
    var exists = document.createElement ( "img" ) ;
    exists.id = "hotcat_exists" + hotcat_Form_Index ;
    exists.src = hotcat_exists_no ;
 
    var OK = document.createElement ( "input" ) ;
    OK.type = "button" ;
    OK.value = hotcat_text_InputOK ;
    OK.onclick = function(){
        var TheForm = this.parentNode;
        var TheSpan = TheForm.parentNode;
        var Input = TheForm.getElementsByTagName('input')[0];
        while(Input.type!="text"){
            Input=Input.nextSibling;
            if(!Input){alert('PB : pas d\'input'); return; }
        }
        var IfExist = TheSpan.getElementsByTagName('img')[0];
        var Exist = (IfExist.src==hotcat_exists_yes);
        var NewCatName = Input.value;
 
        hotcat_NewCatsIndex++
        var NewSpan = document.createElement('span');
        NewSpan.id = "hotcat_Multi_Span_"+hotcat_NewCatsIndex;
        NewSpan.className = "AddedCatSpan";
 
        var NewLink = document.createElement('a');
        NewLink.innerHTML = NewCatName;
        NewLink.title = wgFormattedNamespaces[14]+':'+NewCatName;
        NewLink.href = wgServer + wgArticlePath.split('$1').join(wgFormattedNamespaces[14]+':'+NewCatName);
        if(!Exist){
            addClass(NewLink,"new");
        }else{
            removeClass(NewLink,"new");
        }
        addClass(NewLink,"AddedCategory");
 
        var RemoveLink = document.createElement('a');
        RemoveLink.innerHTML = hotcat_text_RemoveLinkText;
        RemoveLink.id = "hotcat_Multi_remove_"+hotcat_NewCatsIndex;
        RemoveLink.title = hotcat_text_RemoveLinkTitle+" « "+NewCatName+" »";
        RemoveLink.href = "javascript:hotcat_Multi_remove(\"" + NewCatName+ "\",\"hotcat_Multi_remove_"+hotcat_NewCatsIndex+"\");";
 
        var ModifyLink = document.createElement('a');
        ModifyLink.innerHTML = hotcat_text_ModifyLinkText;
        ModifyLink.id = "hotcat_Multi_modify_"+hotcat_NewCatsIndex;
        ModifyLink.title = hotcat_text_ModifyLinkTitle+" « "+NewCatName+" »";
        ModifyLink.href = "javascript:hotcat_Multi_modify(\"hotcat_Multi_modify_"+hotcat_NewCatsIndex + "\",\""+NewCatName+"\")";
 
        NewSpan.appendChild(NewLink);
        NewSpan.appendChild(document.createTextNode(" "));
        NewSpan.appendChild(RemoveLink);
        NewSpan.appendChild(document.createTextNode(" "));
        NewSpan.appendChild(ModifyLink);
        NewSpan.appendChild(document.createTextNode(" | "));      
 
 
        TheSpan.parentNode.insertBefore(NewSpan, TheSpan);
        TheForm.parentNode.removeChild(TheForm);
        TheSpan.style.display = "";
        TheSpan.getElementsByTagName('a')[0].style.display = "inline";
        hotcat_Multi_CheckForChanges();
 
    }
    var cancel = document.createElement ( "input" ) ;
    cancel.type = "button" ;
    cancel.value = hotcat_text_InputCancel ;
    cancel.onclick = function(){
        var TheForm = this.parentNode;
        var TheSpan = TheForm.parentNode;
        TheSpan.removeChild(TheForm);
        var TheLinks = TheSpan.getElementsByTagName('a');
        for(a=0;a<TheLinks.length;a++){
             TheLinks[a].style.display = "";
        }
        hotcat_Multi_CheckForChanges();
    }
    form.appendChild ( list ) ;
    form.appendChild ( text ) ;
    form.appendChild ( exists ) ;
    form.appendChild ( OK ) ;
    form.appendChild ( cancel ) ;
 
    AddSpan.appendChild ( form ) ;
    AddLink.style.display = "none";
    text.focus () ;
}
 
// ÉDITION 
 
function hotcat_Multi_Edit(RemovedCategories, ModifiedCategories_from, ModifiedCategories_to, AddedCategories){
 
    var URL = document.getElementById('ca-edit').getElementsByTagName('a')[0].href;
    var NouvelleRequete = sajax_init_object();
    NouvelleRequete.open("GET", URL, true);
    NouvelleRequete.onreadystatechange = function() {
        if(NouvelleRequete.readyState != 4 || NouvelleRequete.status != 200) return;
        while(document.body.firstChild){document.body.removeChild(document.body.firstChild);}
        document.body.innerHTML = NouvelleRequete.responseText;
        var prevent_autocommit = 0;
        if(hotcat_autocommit)document.editform.style.display = "none";
        var OldText = document.getElementById('wpTextbox1').value;
        var summary = new Array();
        summary.push("[[Utilisateur:Dr_Brains/HotCatsPerso.js|HotCats Multi]] : ")
        for(var a=0;a<RemovedCategories.length;a++){
            var REGEXP = new RegExp("(\\s*)\\[\\[ *(?:Catégorie|Category) *: *" + RemovedCategories[a].replace(/([\\\^\$\*\+\?\.\|\{\}\[\]\(\)])/g, "\\$1") + " *(\\|[^\\]]*)?\\]\\]", "gi");
            var matches = OldText.match(REGEXP);
            if (matches != null && matches.length == 1) {
                OldText = OldText.replace(REGEXP, "");
                summary.push( " – [[Catégorie:" + RemovedCategories[a] + "]]" ) ;
            }else{
                prevent_autocommit = 1
                if(matches == null || matches.length < 1) alert(hotcat_text_AlertProblem1.split('$1').join(RemovedCategories[a]));
                if(matches.length > 1) alert(hotcat_text_AlertProblem3.split('$1').join(RemovedCategories[a]));
            }
        }
        summary.push(" |");
        for(var a=0;a<ModifiedCategories_from.length;a++){
            var REGEXP = new RegExp("(\\s*)\\[\\[ *(?:Catégorie|Category) *: *" + ModifiedCategories_from[a].replace(/([\\\^\$\*\+\?\.\|\{\}\[\]\(\)])/g, "\\$1") + " *(\\|[^\\]]*)?\\]\\]", "gi");
            var matches = OldText.match(REGEXP);
            if (matches != null && matches.length == 1) {
 
                if(ModifiedCategories_to[a].indexOf('|')!=-1){
                    OldText = OldText.replace(REGEXP, "$1[[Catégorie:" + ModifiedCategories_to[a] + "]]");
                }else{
                    OldText = OldText.replace(REGEXP, "$1[[Catégorie:" + ModifiedCategories_to[a] + "$2]]");
                    summary.push ( " ± [[Catégorie:" + ModifiedCategories_from[a] + "]]->[[Catégorie:" + ModifiedCategories_to[a].replace(/\|.*/g, "") + "]]" ) ;
                }
            }else{
                prevent_autocommit = 1
                if(matches == null || matches.length < 1) alert(hotcat_text_AlertProblem1.split('$1').join(ModifiedCategories_from[a].replace(/\|.*/g, "")));
                if(matches.length > 1) alert(hotcat_text_AlertProblem3.split('$1').join(ModifiedCategories_from[a].replace(/\|.*/g, "")));
            }
        }
        summary.push(" |");
        for(var a=0;a<AddedCategories.length;a++){
            var REGEXP = new RegExp("(\\s*)\\[\\[ *(?:Catégorie|Category) *: *" + AddedCategories[a].replace(/([\\\^\$\*\+\?\.\|\{\}\[\]\(\)])/g, "\\$1") + " *(\\|[^\\]]*)?\\]\\]", "gi");
            var matches = OldText.match(REGEXP);
            if (matches != null){
                alert(hotcat_text_AlertProblem2.split('$1').join(AddedCategories[a].replace(/\|.*/g, ""))); 
                prevent_autocommit = 1
                continue;
            }
            var re = /\[\[(?:Catégorie|Category):[^\]]+\]\]/ig
            var index = -1;
            while (re.exec(OldText) != null) index = re.lastIndex;
            var txt = "[[Catégorie:" + AddedCategories[a] + "]]" ;
            if (index < 0) {  // no category
                var interWiki = new RegExp('^\\s*\\[\\[([a-z][a-z].?(x?-[^\\]]+)?|simple|tokipona):([^\\]]*)\\]\\]\\s*$');
                var blank = new RegExp('^\\s*$');
                var lines = OldText.split('\n');
                var DebutModele = '';
                var SuiteModele = '';
                var FoundInterwiki = false;
                for (var lineId = lines.length - 1; lineId >= 0; --lineId){
                    if (!interWiki.exec(lines[lineId]) && !blank.exec(lines[lineId])){
                        DebutModele = lines.slice(0, lineId + 1).join('\n');
                        SuiteModele = lines.slice(lineId + 1).join('\n');
                        break;
                    }
                }
                DebutModele = DebutModele + '\n\n';
                while(SuiteModele.indexOf('\n\n')!=-1){
                    SuiteModele = SuiteModele.split("\n\n").join("\n");
                }
                SuiteModele = SuiteModele.replace(/^\n/, "");
                OldText = DebutModele + txt + '\n\n' + SuiteModele;
            }else{
                OldText = OldText.substring(0, index) + '\n' + txt + OldText.substring(index);
            }
            summary.push ( " + [[Catégorie:" + AddedCategories[a].replace(/\|.*/g, "") + "]]" ) ;
        }
        summary.push (hotcat_text_ResumeScript);
        document.getElementById('wpTextbox1').value = OldText;
        document.getElementById('wpSummary').value = summary.join("");
        if((hotcat_autocommit)&&(prevent_autocommit != 1)) document.editform.submit();
        if(prevent_autocommit == 1) document.editform.style.display = "";
    }
    NouvelleRequete.send(null);
}
 
///////////////////////// SUGGESTIONS ////////////////////////////////////////////////////////
 
// REQUÊTE DE SUGGESTIONS
 
function hotcat_text_changed (FormIndex) {
    if(!FormIndex) FormIndex = '';
    if ( hotcat_running ) return ;
    var ID = "hotcat_text"+FormIndex;
    var text = document.getElementById ( ID ) ;
    if(!text){ ID = "hotcat_text"+hotcat_Form_Index; text = document.getElementById ( ID ) ; }
    if(!text){alert('PB : ' + ID); return; }
    var v = text.value.ucFirst() ;
    if ( hotcat_last_v == v ) return ; // Nothing's changed...
 
    hotcat_running = 1 ;
    hotcat_last_v = v ;
 
    if ( v != "" ) {
        var url = wgServer + "/" + wgScriptPath + "/api.php?format=xml&action=query&list=allpages&apnamespace=14&apfrom=" + encodeURIComponent( v ) + "&aplimit=" + encodeURIComponent( hotcat_list_items );
        if ( typeof ( hotcat_xmlhttp ) != "undefined" ) hotcat_xmlhttp.abort() ; // Just to make sure...
        hotcat_xmlhttp = new sajax_init_object() ;
        hotcat_xmlhttp.open('GET', url, true);
        hotcat_xmlhttp.onreadystatechange = function () {
            if ( typeof hotcat_xmlhttp == "undefined" ) return ;
            if (hotcat_xmlhttp.readyState == 4) {
                var xml = hotcat_xmlhttp.responseXML ;
                if ( xml == null ) return ;
                var pages = xml.getElementsByTagName( "p" ) ;
                var titles = new Array () ;
                for ( var i = 0 ; i < pages.length ; i++ ) {
                    var s = pages[i].getAttribute("title");
                    // Removing leading "Category:"
                    s = s.substr(s.indexOf(":") + 1);
                    if ( s.substr ( 0 , hotcat_last_v.length ) != hotcat_last_v ) break ;
                    titles.push ( s ) ;
                }
                hotcat_show_suggestions ( titles, FormIndex ) ;
            }
        };
        hotcat_xmlhttp.send(null);
    } else {
        var titles = new Array () ;
        hotcat_show_suggestions ( titles , FormIndex ) ;
    }
    hotcat_running = 0 ;
}
 
// AFFICHAGE DES SUGGESTIONS
 
function hotcat_show_suggestions ( titles, FormIndex ) {
    var text = document.getElementById ( "hotcat_text"+FormIndex ) ;
    var list = document.getElementById ( "hotcat_list"+FormIndex ) ;
    var icon = document.getElementById ( "hotcat_exists"+FormIndex ) ;
    if((!text)||(!list)||(!icon)) { alert('PB hotcat_show_suggestions : ' + FormIndex); return; }
    if ( titles.length == 0 ) {
        list.style.display = "none" ;
        icon.src = hotcat_exists_no ;
        return ;
    }
 
    var listh = hotcat_list_size * 20 ;
    if (titles.length < hotcat_list_size) {
        listh = titles.length * 20 ;
    }
    var nl = parseInt ( text.parentNode.offsetLeft ) - 1 ;
    var nt = parseInt(text.offsetTop) - listh ;
    // Parameter to show suggestion list beneath categories instead of above
    if (typeof hotcat_list_down != "undefined" && hotcat_list_down) {
        nt = text.offsetTop + text.offsetHeight;
    }
    list.size = 5 ;
    list.style.align = "left" ;
    list.style.zIndex = 5 ;
    list.style.position = "absolute" ;
    list.style.top = nt + "px" ;
    list.style.width = text.offsetWidth + "px" ;
    list.style.height = listh + "px" ;
    list.style.left = nl + "px" ;
    while ( list.firstChild ) list.removeChild ( list.firstChild ) ;
    for ( var i = 0 ; i < titles.length ; i++ ) {
        var opt = document.createElement ( "option" ) ;
        var ot = document.createTextNode ( titles[i] ) ;
        opt.appendChild ( ot ) ;
        opt.setAttribute( "value", titles[i] );
        list.appendChild ( opt ) ;
    }  
    list.style.display = "block" ;
    icon.src = hotcat_exists_yes ;
    var first_title = titles.shift () ;
    if ( first_title == hotcat_last_v ) return ;
    var suggestion = first_title;
 
    text.value = suggestion  ;
    if (text.createTextRange) {
        // IE
        var ra = text.createTextRange();
        ra.moveStart("character", hotcat_last_v.length);
        ra.moveEnd("character", suggestion.length);
        ra.select();
    } else if( text.setSelectionRange ) {
        text.setSelectionRange( hotcat_last_v.length, suggestion.length );
    } else {
        text.selectionStart = hotcat_last_v.length ;
        text.selectionEnd = suggestion.length ;
    }
}
 
//</nowiki>