//<source lang="javascript">
 
// Langue à utiliser
var wiktLang = "id";
 
// Tableau de boutons
var wiktButtons = [];
 
/**
 * Ajout d'un bouton а la toolbar d'edition
 * inspiree de insertButton()
 * @param title : titre de la fonction
 * @param image : source de l'image а afficher
 * @param href: lien a executer lors du click sur le bouton
 * @param accesskey : touche d'acces rapide (optionnel)
 */
function wiktAddButton(title, image, href, accesskey) {
	wiktButtons [wiktButtons.length] =
		{"title": title,
		 "image": image,
		 "href": href,
		 "accesskey": accesskey};
}
 
/**
 * Ajoute les boutons à la toolbar
 */
function wiktAddButtons() {
        var toolbar = document.getElementById("toolbar"); 
        if (!toolbar) return;
 
	for (var i in wiktButtons) {
		var button = wiktButtons[i];
		var img = document.createElement("img");
		img.width = 23;
		img.height = 22;
		img.src = button.image;
		img.border = 0;
		img.style.cursor = "pointer";
		img.alt = button.title;
 
		var ref = document.createElement("a");
		if (!button.flags) button.flags = "";
		ref.setAttribute("href", button.href);
		ref.setAttribute("title", button.title);
		if (button.accesskey) {
			ref.setAttribute("accesskey", button.accesskey);
		}
		ref.appendChild(img);
		toolbar.appendChild(ref);
	}
}
 
function insertEbverbe() {
  var lang = window.prompt("Quelle langue utiliser (fr, en, ...) ?");
  if (!lang) return;
  insertTags("{{=" + lang + "=}}\n{{-étym-}}\n: {{ébauche-étym|" + lang + "}}\n\n{{-verb-|" + lang + "}}\n''''''\n# [[|]], [[]].", "", "");

}
 
}
 
function insertEbadv() {
  var lang = window.prompt("Quelle langue utiliser (fr, en, ...) ?");
  if (!lang) return;
  insertTags("{{=" + lang + "=}}\n{{-étym-}}\n: {{ébauche-étym|" + lang + "}}\n\n{{-adv-|" + lang + "}}\n''''''\n# [[|]], [[]].", "", "");

}


// La variable $lang est remplacée par la variable JS wiktLang
var ebverbePattern = "{{=$lang=}}\n" +
                     "{{-étym-}}\n" +
                     ": {{ébauche-étym|$lang}}\n"+
                     "\n" +
                     "{{-verb-|$lang}}\n" +
                     "''''''\n" +
                     "# [[|]], [[]].\n";

var ebadvPattern = "{{=$lang=}}\n" +
                     "{{-étym-}}\n" +
                     ": {{ébauche-étym|$lang}}\n"+
                     "\n" +
                     "{{-adv-|$lang}}\n" +
                     "''''''\n" +
                     "# [[|]], [[]].\n";
 
// Ajout d'un bouton pour insérer dans un article un modèle d'ébauche avec la langue paramétrable
// Touche de raccourci : Alt+Shift+o sous Firefox, Ctrl+Shift+o sous IE
wiktAddButton("Ebverbe",
  "http://upload.wikimedia.org/wikipedia/commons/3/3c/Button_lienweb.png",
  "javascript:insertTags(ebverbePattern.replace(/\\$lang/g, wiktLang), '', '');",
  "O");

wiktAddButton("Ebadv",
  "http://upload.wikimedia.org/wikipedia/commons/3/3c/Button_lienweb.png",
  "javascript:insertTags(ebadvPattern.replace(/\\$lang/g, wiktLang), '', '');",
  "K");
addLoadEvent(wiktAddButtons);
 
//</source>