/* 
Gestionnaire de scripts .js
 
Documentation : [[Discussion utilisateur:Dr Brains/GlobalManager.js]]
 
 
<noinclude>{{Catégorisation JS|GlobalManager}}</noinclude>
*/
 
// <pre><nowiki>
/////////////////////////////////////////////////////////////// PARTIE PERSONNALISABLE : DÉFINITION DES SCRIPTS
 
var GlobalManager_ScriptType = new Array();
var GlobalManager_ScriptText = new Array();
var GlobalManager_ScriptPage = new Array();
var GlobalManager_ScriptId  =  new Array();
 
 /*******************************************************************************************************************
 * GlobalManager_ScriptType : 1 => script ; 2 à 6 => titre de section                                               *
 * GlobalManager_ScriptText : type 1 => description du script ; autre type => texte du titre                        *
 * GlobalManager_ScriptPage : type 1 => Page à importer ; autre type => inutilisé                                   *
 * GlobalManager_ScriptId : type 1 => ID du script (titre de la sous-page sans le ".js") ; autre type => inutilisé  *
 ********************************************************************************************************************/
 
GlobalManager_ScriptType.push(4); ////////////
GlobalManager_ScriptText.push('Bots');
GlobalManager_ScriptId.push('');
GlobalManager_ScriptPage.push('');
 
GlobalManager_ScriptType.push(5); ////////////
GlobalManager_ScriptText.push('Semi-automatiques');
GlobalManager_ScriptId.push('');
GlobalManager_ScriptPage.push('');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un modèle de lien "page au hasard" à partir des pages d\'une catégorie.');
GlobalManager_ScriptId.push('PageAuHasard');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/PageAuHasard.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un modèle de page "Lumière sur..." à partir des pages d\'une catégorie.');
GlobalManager_ScriptId.push('LumiereSur');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/LumiereSur.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un tableau triable de l\'évaluation des pages d\'une catégorie.');
GlobalManager_ScriptId.push('VerifEval');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/VerifEval.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un tableau triable avec diverses informations sur les pages d\'une catégorie.');
GlobalManager_ScriptId.push('MaintenanceCategorie');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MaintenanceCategorie.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un tableau triable des images utilisées par les pages d\'une catégorie.');
GlobalManager_ScriptId.push('ImagesUtilisees');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ImagesUtilisees.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'une liste des dernières entrées dans une catégorie.');
GlobalManager_ScriptId.push('ArticlesRecents');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ArticlesRecents.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Création automatique d\'un tableau triable des pages demandées à partir d\'une catégorie.');
GlobalManager_ScriptId.push('ArticlesManquants');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ArticlesManquants.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Redirection automatique vers <a href="'+wgServer + wgArticlePath.split('$1').join('Special:Randompage') +'">Page au Hasard</a> pour trouver des pages sans bandeaux de portail.');
GlobalManager_ScriptId.push('BandeauxPortailsAutoRedirect');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BandeauxPortailsAutoRedirect.js');
 
GlobalManager_ScriptType.push(5); ////////////
GlobalManager_ScriptText.push('Automatiques');
GlobalManager_ScriptId.push('');
GlobalManager_ScriptPage.push('');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Vidage/Renommage automatique de catégories.');
GlobalManager_ScriptId.push('RenommageCategorie');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/RenommageCategorie.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Ajout/retrait/modification automatique de bandeaux de portail aux pages d\'une catégorie et de ses sous-catégories.');
GlobalManager_ScriptId.push('BandeauxPortailsCategorieMulti');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BandeauxPortailsCategorieMulti.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Mise à jour des différents modèles {{Articles récents}} (<a href="'+wgServer + wgArticlePath.split('$1').join('Utilisateur:Dr_Bot/Scripts/Articles_récents_BOT') +'">Page de démarrage</a>).');
GlobalManager_ScriptId.push('ArticlesRecentsBOT');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ArticlesRecentsBOT.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Mise à jour de la liste des portails (<a href="'+wgServer + wgArticlePath.split('$1').join('Utilisateur:Dr_Bot/Scripts/Liste_des_Portails_BOT') +'">Page de démarrage</a>).');
GlobalManager_ScriptId.push('ListAllPortals');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ListAllPortals.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Mise à jour de la liste des portails (<a href="'+wgServer + wgArticlePath.split('$1').join('Utilisateur:Dr_Bot/Scripts/Liste_des_Portails_Ébauchés_BOT') +'">Page de démarrage</a>).');
GlobalManager_ScriptId.push('ListAllPortalsStub');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ListAllPortalsStub.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Mise à jour de la liste des projets (<a href="'+wgServer + wgArticlePath.split('$1').join('Utilisateur:Dr_Bot/Scripts/Liste_des_Projets_BOT') +'">Page de démarrage</a>).');
GlobalManager_ScriptId.push('ListAllProjects');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ListAllProjects.js');
 
GlobalManager_ScriptType.push(4); ////////////
GlobalManager_ScriptText.push('Scripts');
GlobalManager_ScriptId.push('');
GlobalManager_ScriptPage.push('');
 
GlobalManager_ScriptType.push(5); ////////////
GlobalManager_ScriptText.push('Opérationnels');
GlobalManager_ScriptId.push('');
GlobalManager_ScriptPage.push('');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Journal des filtrages en temps réel (<a href=http://fr.wikipedia.org/wiki/User:Dr_Brains/LiveAbuseLog>Page</a>).');
GlobalManager_ScriptId.push('LiveAbuseLog');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/LiveAbuseLog.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Modifications récentes en temps réel (<a href=http://fr.wikipedia.org/wiki/User:EDUCA33E/LiveRC>Page</a>).');
GlobalManager_ScriptId.push('LiveRC');
GlobalManager_ScriptPage.push('Utilisateur:EDUCA33E/LiveRC.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Arrondit les angles de l\'interface.');
GlobalManager_ScriptId.push('Arrondis');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Arrondis.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Alerte de nouveaux messages sur des pages prédéfinies autres que la page de discussion.');
GlobalManager_ScriptId.push('NewMessage');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NewMessage.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Liste de suivi globale.');
GlobalManager_ScriptId.push('GlobalWatchlist');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/GlobalWatchlist.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Ajout d\'un ou plusieurs bloc-notes sur les bords de la page.');
GlobalManager_ScriptId.push('BlocNote');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BlocNote.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Permet d\'enrouler les panneaux de la barre de navigation gauche.');
GlobalManager_ScriptId.push('CollapseSidebox');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/CollapseSidebox.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Édition améliorée.');
GlobalManager_ScriptId.push('wikEd');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/wikEd.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Divise la zone d\'édition en plusieurs parties.');
GlobalManager_ScriptId.push('Edit');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Edit.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Ajout/retrait/modification rapide de bandeaux d\'ébauche.');
GlobalManager_ScriptId.push('BandeauxEbauches');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BandeauxEbauches.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Modifie le rendu des catégories et des bandeaux de portails.');
GlobalManager_ScriptId.push('CategoriesBandeauxPortail');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/CategoriesBandeauxPortail.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Ajout/retrait/modification rapide de bandeaux de portails.');
GlobalManager_ScriptId.push('BandeauxPortails');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BandeauxPortails.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Ajout ou retrait rapide de catégories <sup>(<a href=http://fr.wikipedia.org/wiki/MediaWiki:Gadget-HotCats.js>Gadget</a>)</sup>.');
GlobalManager_ScriptId.push('HotCatsPerso');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/HotCatsPerso.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push(' MenuClicDroit, version de développement');
GlobalManager_ScriptId.push(' MenuClicDroit_Dev');
GlobalManager_ScriptPage.push(' Utilisateur:Dr_Brains/MenuClicDroit_Dev.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de prévisualiser chaque entrée de diverses <a href=http://fr.wikipedia.org/wiki/Special:Specialpages>Pages spéciales</a>.');
GlobalManager_ScriptId.push(' SpecialPagePreview'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SpecialPagePreview.js'); 
 
GlobalManager_ScriptId.push('MessageWatchlist'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MessageWatchlist.js');
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Affiche la dernière modification de la liste de suivi en haut de la page.');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de sélectionner facilement les pages à supprimer de la liste de suivi.');
GlobalManager_ScriptId.push('ListeSuivi'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ListeSuivi.js'); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de rechercher les modifications éffectuées par une plage IP dans <a href="'+wgServer+'/wiki/Spécial:Contributions">Spécial:Contributions</a> (version avec prévisualisation).');
GlobalManager_ScriptId.push('IPWatch');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/IPWatch.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de rechercher les modifications éffectuées par une plage IP dans <a href="'+wgServer+'/wiki/Spécial:Contributions">Spécial:Contributions</a> (version sans prévisualisation).');
GlobalManager_ScriptId.push('IPWatchNoPreview');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/IPWatchNoPreview.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de compter les pages liées dans <a href="'+wgServer+'/wiki/Spécial:Whatlinkshere">Spécial:Pages liées</a>.');
GlobalManager_ScriptId.push('WhatlinkshereDeluxe'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/WhatlinkshereDeluxe.js'); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de sélectionner/dé-sélectionner facilement les pages à supprimer de la page <a href="'+wgServer+'/wiki/Spécial:Nuke">Spécial:Nuke</a>.');
GlobalManager_ScriptId.push('NukeDeluxe');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NukeDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('<a href="' + wgServer + '/wiki/Special:AbuseLog" >Journal des filtrages</a> amélioré.'); 
GlobalManager_ScriptId.push('AbuseLogDeluxe'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/AbuseLogDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de sélectionner/dé-sélectionner facilement les versions à restaurer.');
GlobalManager_ScriptId.push('UndeleteDeluxe');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/UndeleteDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Améliore la page spéciale de renommage : pages liées et résumés de renommage prédéfinis.');
GlobalManager_ScriptId.push('MoveDeluxe');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MoveDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Amélioration de la page spéciale <a href="'+wgServer+'/wiki/Spécial:Newpages">Spécial:Nouvelles pages</a>.');
GlobalManager_ScriptId.push('NewPagesDeluxe');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NewPagesDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Procure des résumés de modification prédéfinis.');
GlobalManager_ScriptId.push('ResumeDeluxe');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ResumeDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Améliore les pages d\'historique.');
GlobalManager_ScriptId.push('HistoryDeluxe'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/HistoryDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Dans <a href=http://fr.wikipedia.org/wiki/Special:Blockip>Special:Blockip</a>, permet de savoir si l\'utilisateur visé est un bot pour prévenir le blocage de son IP.');
GlobalManager_ScriptId.push('NoBlockIpBots'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NoBlockIpBots.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute un onglet \"CatScan\" pour rechercher les images utilisées dans une catégorie (recherche sur les wiki liés).');
GlobalManager_ScriptId.push('CatScan');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/CatScan.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute des liens (page précédente) et (page suivante) en haut et en bas des sous-pages du <a href=http://fr.wikipedia.org/wiki/Wikipédia:Bistro>Bistro</a>.');
GlobalManager_ScriptId.push('NavigationBistro');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NavigationBistro.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute des liens (page précédente) et (page suivante) en haut et en bas des sous-pages de la <a href=http://fr.wikipedia.org/wiki/Wikipédia:Guilde_des_Guides>Guilde des Guides</a>.');
GlobalManager_ScriptId.push('NavigationGuilde');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/NavigationGuilde.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute un onglet \"Modifier\" et \"Historique\" pour la page associée.');
GlobalManager_ScriptId.push('DoubleActions'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/DoubleActions.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Transforme les onglets en menus déroulants.');
GlobalManager_ScriptId.push('MenuActions');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MenuActions.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Procure un menu contextuel complet (clic droit).');
GlobalManager_ScriptId.push('MenuClicDroit');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MenuClicDroit.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Outil de création rapide de portails d\'après modèle.');
GlobalManager_ScriptId.push('CreatePortal');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/CreatePortal.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajout d\'un bouton pour remplacer une chaîne de caractère par une autre.');
GlobalManager_ScriptId.push('Remplace');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Remplace.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute l\'ancienne barre d\'outils au\-dessus de la nouvelle (bêta Açai).');
GlobalManager_ScriptId.push('AcaiToolbar');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/AcaiToolbar.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Fixe la position de la barre de navigation gauche, des onglets et des liens personnels.');
GlobalManager_ScriptId.push('FixSidebar');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/FixSidebar.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Panneaux de la barre de navigation gauche enroulables et réorganisables (skin Monobook).');
GlobalManager_ScriptId.push('MagicSidebox');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/MagicSidebox.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Panneaux de la barre de navigation gauche enroulables et réorganisables (skin Vector).');
GlobalManager_ScriptId.push('VectorMagicSidebox');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/VectorMagicSidebox.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute un lien dans la boîte à outils permettant de vérifier les liens de la page pointant sur une page d\'homonymie.'); 
GlobalManager_ScriptId.push('verifHomon');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/verifHomon.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute un panneau avec des liens utiles pour l\'administration.');
GlobalManager_ScriptId.push('SysopPortlet');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SysopPortlet.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute un panneau dans la barre de gauche pour traduire un terme en différentes langues.');
GlobalManager_ScriptId.push('TranslatePortlet');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/TranslatePortlet.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Suivi dans un panneau de la barre de gauche des articles les plus modifiés actuellement (mise à jour à intervalle régulier (100 secondes).'); 
GlobalManager_ScriptId.push('SuiviRC');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SuiviRC.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet d\'évaluer rapidement un article.'); 
GlobalManager_ScriptId.push('Evaluation');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Evaluation.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Rend les liens cliquables à l\intérieur d\'une balise source.');
GlobalManager_ScriptId.push('SourceCliquable');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SourceCliquable.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet d\'ajouter des bandeaux au début d\'une page ou d\'une section.');
GlobalManager_ScriptId.push('BandeauxFaciles');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BandeauxFaciles.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajout de flèches pour atteindre le sommet ou le bas de la page.');
GlobalManager_ScriptId.push('Scroll'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Scroll.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajout en dessous de la zone de recherche d\'un champ pour tester l\'existence d\'une page.');
GlobalManager_ScriptId.push('TestExist'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/TestExist.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Zoom lors du passage de la souris au dessus d\'une image thumb ou galerie.');
GlobalManager_ScriptId.push('ZoomOnThumb'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ZoomOnThumb.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajout de liens permettant un zoom dans la page de description d\'une image.');
GlobalManager_ScriptId.push('ZoomOnFileDescriptionPage'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ZoomOnFileDescriptionPage.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ouverture de pop-up lors du passage de la souris au dessus d\'un lien.');
GlobalManager_ScriptId.push('Popups'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Popups.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Références en pop-up au survol de la souris.');
GlobalManager_ScriptId.push('ReferencesPopUp'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ReferencesPopUp.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajout d\'un compteur de consultation de la page courante.'); 
GlobalManager_ScriptId.push('Consult'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Consult.js');
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Permet le suivi d\'une ou plusieurs catégories.');
GlobalManager_ScriptId.push('SuiviCat'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SuiviCat.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de surligner son nom d\'utilisateur.');
GlobalManager_ScriptId.push('myName'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/myName.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute dans le footer la taille de la page courante.'); 
GlobalManager_ScriptId.push('PageSize'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/PageSize.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute une indication de la dernière modif.');
GlobalManager_ScriptId.push('LastContrib'); 
GlobalManager_ScriptPage.push('MediaWiki:Gadget-LastContrib.js'); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Jeu du démineur.'); 
GlobalManager_ScriptId.push('demineur'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/demineur.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Patrouille dans une nouvelle fenêtre.'); 
GlobalManager_ScriptId.push('WindowPatrol'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/WindowPatrol.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Divers gadgets concernant l\'affichage.');
GlobalManager_ScriptId.push('SkinManager'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/SkinManager.js'); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Colore la section visée lors du survol de la souris sur un lien de section \"modifier\".');
GlobalManager_ScriptId.push('ColorSection'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ColorSection.js'); 
 
GlobalManager_ScriptType.push(1);
GlobalManager_ScriptText.push('Remplace le logo par un clip vidéo issu de DailyMotion, YouTube ou Google.'); 
GlobalManager_ScriptId.push('Video'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Video.js'); 
 
GlobalManager_ScriptType.push(5);  ///////////////////////////////////////
GlobalManager_ScriptText.push('En test');
GlobalManager_ScriptId.push(''); 
GlobalManager_ScriptPage.push(''); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('<a href=http://fr.wikipedia.org/wiki/Utilisateur:Dr_Brains/BacASable.js>Bac à Sable</a>'); 
GlobalManager_ScriptId.push('BacASable'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/BacASable.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('<a href=http://fr.wikipedia.org/wiki/Utilisateur:Dr_Brains/Twinkle.js>Twinkle</a>'); 
GlobalManager_ScriptId.push('Twinkle'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Twinkle.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Barre d\'outils améliorée'); 
GlobalManager_ScriptId.push('ToolbarDeluxe'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/ToolbarDeluxe.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet d\'éditer la page en sélectionnant simplement du texte.');
GlobalManager_ScriptId.push('QuickEdit'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/QuickEdit.js'); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Jeux WidgetBox. (<a href=http://fr.wikipedia.org/wiki/Utilisateur:'+wgUserName.replace(/ /g,"_")+'/Jeux>Salle de jeux</a>)'); 
GlobalManager_ScriptId.push('Jeux'); 
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Jeux.js');
 
GlobalManager_ScriptType.push(5);  ///////////////////////////////////////
GlobalManager_ScriptText.push('Obsolètes ou archivés');
GlobalManager_ScriptId.push(''); 
GlobalManager_ScriptPage.push(''); 
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de basculer du mode normal au mode plein écran.'); 
GlobalManager_ScriptId.push('FullScreen');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/FullScreen.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute une boîte favoris dans la barre de gauche.'); 
GlobalManager_ScriptId.push('favoris');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/favoris.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de masquer les liens de la page.'); 
GlobalManager_ScriptId.push('CacheLiens');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/CacheLiens.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Ajoute des onglets pour effectuer une recherche Google basée sur la titre de la page courante.'); 
GlobalManager_ScriptId.push('Google');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Google.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet de moduler la taille de la zone d\'édition.');
GlobalManager_ScriptId.push('TailleEdit');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/TailleEdit.js');
 
GlobalManager_ScriptType.push(1); 
GlobalManager_ScriptText.push('Permet d\'insérer n\'importe quelle balise.');
GlobalManager_ScriptId.push('Balise');
GlobalManager_ScriptPage.push('Utilisateur:Dr_Brains/Balise.js');
 
// //////////////////////////////////////////////////////////// PARTIE PERSONNALISABLE : PARAMÈTRES
 
// Liste des skins disponibles
var GlobalManager_RunningSkins = new Array(); 
GlobalManager_RunningSkins.push('monobook');
GlobalManager_RunningSkins.push('chick');
GlobalManager_RunningSkins.push('simple');
GlobalManager_RunningSkins.push('myskin');
GlobalManager_RunningSkins.push('modern');
GlobalManager_RunningSkins.push('vector');
GlobalManager_RunningSkins.push('cologneblue');
GlobalManager_RunningSkins.push('nostalgia');
GlobalManager_RunningSkins.push('standard');
 
// Langue du wiki d'origine
var GlobalManager_LangFrom = 'fr';
 
// Adresses du wiki d'origine
var GlobalManager_URLFrom = 'http://fr.wikipedia.org/wiki/';
var GlobalManager_URLBisFrom = 'http://fr.wikipedia.org/w/index.php?title=';
 
// Page du GlobalManager
var GlobalManager_HomePage = 'User:Dr_Brains/GlobalManager.js';
 
// Résumé de modification
var GlobalManager_Resume = 'Mise à jour avec [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
 
// Commentaires d'édition
var GlobalManager_CommStart = '//DebutSectionAuto'
var GlobalManager_CommPlus = ' : Cette section est produite par le script [[:'+GlobalManager_LangFrom+':'+GlobalManager_HomePage+']]';
var GlobalManager_CommConfig = '//ConfigSectionAuto';
var GlobalManager_CommEnd = '//FinSectionAuto';
 
// //////////////////////////////////////////////////////////// FIN DE LA PARTIE PERSONNALISABLE
 
////////////////////////// VARIABLES GLOBALES NON PERSONNALISABLES
 
var GlobalManager_URLHome = wgServer + wgArticlePath.split('$1').join('');
var GlobalManager_URLBisHome = wgServer + wgScript + '?title=';
 
var GlobalManager_RunningPages = new Array();
for(var a=0;a<GlobalManager_RunningSkins.length;a++){
      GlobalManager_RunningPages.push(wgFormattedNamespaces[2] + ':' + wgUserName.replace(/ /g, "_") + '/' + GlobalManager_RunningSkins[a] + '.js');
}
var GlobalManager_CurrentRunningPage = wgFormattedNamespaces[2] + ':' + wgUserName.replace(/ /g, "_") + '/' + skin + '.js';
 
 
// //////////////////////////////////////////////////////////// FONCTIONS
 
////////////////////////// LANCEMENTS
 
addOnloadHook(GlobalManager_AddLinks);
 
if((wgAction=="view")||(wgAction=="purge")){
    for(var p=0;p<GlobalManager_RunningPages.length;p++){
        if(wgPageName == GlobalManager_RunningPages[p]) addOnloadHook(GlobalManager_GetConfig);
    }
}
 
////////////////////////// AJOUT DES LIENS
 
function GlobalManager_AddLinks(){
    if(
      (skin == "monobook")||
      (skin == "vector")||
      (skin == "modern") ||
      (skin == "chick")||
      (skin == "myskin")||
      (skin == "simple")
      ){
        var ManagerLinks = "<li id=\"ManagerLink\" >"
                         + "<a href=" + GlobalManager_URLHome + GlobalManager_HomePage + ">GlobalManager</a>"
                         + "</li>"
                         + "<li id=\"pt-jspage\" >"
                         + "<a href=" + GlobalManager_URLHome + GlobalManager_CurrentRunningPage  + ">" + skin + ".js</a>"
                         + "</li>";
       var conteneurDiv = document.getElementById("p-personal");
       if(!conteneurDiv) return;
       var conteneur = conteneurDiv.getElementsByTagName('ul')[0];
       conteneur.innerHTML = conteneur.innerHTML + ManagerLinks ;
    }else if(
      (skin == "cologneblue")||
      (skin == "standard" )||
      (skin == "nostalgia" )
      ){
        var ManagerLinks = "<small><center>"
                         + "<a href=" + GlobalManager_URLHome + GlobalManager_HomePage + ">GlobalManager</a> • "
                         + "<a href=" + GlobalManager_URLHome + GlobalManager_CurrentRunningPage  + ">" + skin + ".js</a>"
                         + "</center></small>";
        var ManagerlinkDiv = document.createElement("div");
        ManagerlinkDiv.id = "ManagerLink";
        ManagerlinkDiv.innerHTML = ManagerLinks;
        var contentNode = document.getElementById("article");
        if(!contentNode) return;
        contentNode.insertBefore(ManagerlinkDiv, contentNode.firstChild);
    }
}
 
 
////////////////////////// ANALYSE CONFIG ACTUELLE
 
var GlobalManager_InstalledScriptIds = new Array();
 
function GlobalManager_GetConfig(){
   var Adresse = GlobalManager_URLBisHome + wgPageName + '&action=raw';
   var RequeteEdition = sajax_init_object();
   RequeteEdition.open("GET", Adresse, true);
   RequeteEdition.onreadystatechange = function() {
      if( !(RequeteEdition.readyState == 4 && RequeteEdition.status == 200) )  return;
      var Resultat = RequeteEdition.responseText;
      if(Resultat.indexOf(GlobalManager_CommConfig)!=-1)
      var Configuration = Resultat.split(GlobalManager_CommConfig)[1].split('\n')[0];
      if(Configuration){
         for(var a=0;a<GlobalManager_ScriptType.length;a++){
            if(GlobalManager_ScriptType[a]==1){
               if(Configuration.indexOf('setup-'+GlobalManager_ScriptId[a]+'.js')!=-1){
                  GlobalManager_InstalledScriptIds[a] = ' checked="checked" ';
               }else{
                  GlobalManager_InstalledScriptIds[a] = '';
               }
            }else{
               GlobalManager_InstalledScriptIds[a] = '';
            }
         }
      }else{
         for(var a=0;a<GlobalManager_ScriptType.length;a++){
            GlobalManager_InstalledScriptIds[a] = '';
         }
      }
      GlobalManager_CreateForm();
   }
   RequeteEdition.send(null);
}
 
////////////////////////// CRÉATION TABLEAU DE SÉLECTION
 
function GlobalManager_CreateForm(){
   var DivRepere = document.getElementById('siteNotice');
   if(!DivRepere) return;
 
   var Form = document.createElement('div');
   DivRepere.parentNode.insertBefore(Form, DivRepere);
   DivRepere.style.display = 'none';
 
   var FormContent = '<fieldset id="GlobalManager_Fieldset" >'
                   +'<legend><span style="font-size:150%;">Sélectionner les scripts à ajouter à la page : '
                   + '<b>' + wgPageName.replace(/_/g," ") + '</b> '
                   + '<sup><small>'
                   + '<a href=http://fr.wikipedia.org/wiki/Discussion_Utilisateur:Dr_Brains/GlobalManager.js>(Aide)</a>'
                   + '</small></sup></span></legend>'
                   + '<table style=\"float:right;clear:right;\">'
                   + '<tr><td>'
                   + '<div style=\"background:#EEE;\">'
                   + '<center><h5><a href=\"http://fr.wikiversity.org/wiki/JavaScript\">Scripts JS</a></h5></center>'
                   + '<div style=\"font-size: 95%;background-color: white;color: black;border-collapse: collapse;border: 1px solid #aaa;padding: 0 .8em .3em .5em;\"><ul>'
                   + '<li><b><a href=' + GlobalManager_URLHome + GlobalManager_CurrentRunningPage + '>' + skin + '</a></b></li>';
   for(var b=0;b<GlobalManager_RunningPages.length;b++){
      if(GlobalManager_RunningPages[b]!=GlobalManager_CurrentRunningPage)
      FormContent += '<li>'
                   + '<a href=' + GlobalManager_URLFrom + GlobalManager_RunningPages[b] + '>' 
                   + GlobalManager_RunningSkins[b] 
                   + '</a>'
                   + '</li>' ;
   }
   FormContent += '</ul></div></div>'
                + '</td></tr>'
                + '</table>'
                + '<form id="GlobalManager_Form">\n';
   for(var c=0;c<GlobalManager_ScriptType.length;c++){
      if(GlobalManager_ScriptType[c] == 1){
         FormContent += '<input type=\"checkbox\" '
                      + 'id=\"'+GlobalManager_ScriptId[c]+'\" '
                      + GlobalManager_InstalledScriptIds[c]+' ></input>&nbsp;'
                      + '<b><a href=\"'+GlobalManager_URLFrom + GlobalManager_ScriptPage[c]+'\" '
                      + 'title=\"'+GlobalManager_ScriptPage[c]+'\" >'
                      + GlobalManager_ScriptId[c]
                      + '</a></b> : '+GlobalManager_ScriptText[c]+'<br\/>';
      }else{
         FormContent += '<h'+GlobalManager_ScriptType[c]+' >'
                      + '<span class="mw-headline">'
                      + GlobalManager_ScriptText[c]
                      + '</span>'
                      +'</h'+GlobalManager_ScriptType[c]+'>';
      }
   }
   FormContent += '<p>'
                + '<input type="button" '
                + 'onclick="GlobalManager_CreateNewScript();" '
                + 'onselect="GlobalManager_CreateNewScript();" '
                + 'value="Générer le script" />'
                + '</p>'
                + '</form></fieldset><div id="GlobalManager_Running"></div>';
   Form.innerHTML = FormContent;
}
 
////////////////////////// MISE A JOUR PAGE JS
 
var GlobalManager_NewScript = 'document.write(\'<script type="text/javascript" src="' + GlobalManager_URLBisFrom + GlobalManager_HomePage + '&action=raw&ctype=text/javascript"></script>\'); \n\n';
var GlobalManager_NewScriptConfig = GlobalManager_CommStart + GlobalManager_CommPlus + '\n' +GlobalManager_CommConfig;
 
function GlobalManager_CreateNewScript(){
     var Form = document.getElementById('GlobalManager_Form');
     var ControlElement = document.getElementById('GlobalManager_Running');
     if((!Form)||(!ControlElement)) return;
     ControlElement.innerHTML = '<b>* Importation des scripts : </b><br/>';
     for(var d=(GlobalManager_ScriptId.length-1);d>-1;d--){
          if(GlobalManager_ScriptId[d]=='') continue;
          var Input = document.getElementById(GlobalManager_ScriptId[d]);
          if(!Input) continue;
          if(Input.checked){
               ControlElement.innerHTML +=  GlobalManager_ScriptPage[d] + ' — ';
               GlobalManager_NewScriptConfig += ' setup-'+GlobalManager_ScriptId[d]+'.js ';
               GlobalManager_NewScript += '// Importation de [['+GlobalManager_ScriptPage[d]+']]\n\n';
               GlobalManager_NewScript += 'document.write(\'<script type="text/javascript" src="' + GlobalManager_URLBisFrom + GlobalManager_ScriptPage[d] + '&action=raw&ctype=text/javascript"></script>\'); \n\n';
          }
     }
     GlobalManager_NewScriptConfig += '\n\n';
     GlobalManager_NewScript += GlobalManager_CommEnd;
 
     ControlElement.innerHTML += '<br/><b>* Édition de la page : ' + wgPageName + '</b><br/>';
     var Adresse = GlobalManager_URLBisHome + wgPageName + '&action=edit';
     var RequeteEdition = sajax_init_object(); 
     RequeteEdition.open("GET", Adresse, true);
     RequeteEdition.onreadystatechange = function() {
          if( !(RequeteEdition.readyState == 4 && RequeteEdition.status == 200) )  return;
          var Temp = document.createElement('div');
          Temp.style.display = 'none';
          document.body.insertBefore(Temp, document.body.firstChild);
          Temp.innerHTML = RequeteEdition.responseText;  
          var ContenuTextarea = document.getElementById('wpTextbox1').value;
          if((ContenuTextarea.indexOf(GlobalManager_CommStart)!=-1)&&(ContenuTextarea.indexOf(GlobalManager_CommEnd)!=-1)){
               var Before = ContenuTextarea.split(GlobalManager_CommStart)[0];
               var After = ContenuTextarea.split(GlobalManager_CommEnd)[1];
               var TexteFinal = Before+GlobalManager_NewScriptConfig+GlobalManager_NewScript+After;
          }else{
               var TexteFinal = GlobalManager_NewScriptConfig+GlobalManager_NewScript+ContenuTextarea;
          }
 
          ControlElement.innerHTML += '<b>* Sauvegarde de la page : ' + wgPageName + '</b><br/>';
          var AdressePublication = document.getElementById("editform").action; 
          var boundary = '--------123xyz';
          var data = '';
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpTextbox1"\n\n' 
                + TexteFinal + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSection"\n\n' 
                + document.editform.wpSection.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpSummary"\n\n' 
                + GlobalManager_Resume + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpStarttime"\n\n' 
                + document.editform.wpStarttime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEdittime"\n\n' 
                + document.editform.wpEdittime.value + '\n'
          data += '--' + boundary 
                + '\nContent-Disposition: form-data; name="wpEditToken"\n\n' 
                + document.editform.wpEditToken.value + '\n'
          var RequetePublication = sajax_init_object();
          RequetePublication.open('POST', AdressePublication, true);
          RequetePublication.setRequestHeader('Content-Type', 'multipart/form-data; boundary='+boundary);
          RequetePublication.onreadystatechange = function(){
               if (RequetePublication.readyState == 4){
                    Temp.innerHTML = RequetePublication.responseText;                     
                    if(!Temp.getElementsByTagName('textarea')[0]){
                         ControlElement.innerHTML += '<b><big>OK</big></b>';
                         window.location.reload();
                    }else{
                         GlobalManager_CreateNewScript();
                    }
               }
          }
          RequetePublication.send(data + '--' + boundary);
     }
     RequeteEdition.send(null);
 
}
 
// </nowiki></pre>