/*
***************************************************************************
** purgeMessenger
** basé sur xpatrol de Arkanosis
** Auteurs : Arkanosis, Toto Azéro
** Compatibilité : frwiki uniquement
** Licence : MIT/X11
**
** Installation : ajouter
**  importScript('User:Toto Azéro/purgeMessenger.js');
** dans le common.js
*/
 
if (typeof (purgeMessengerEnableClear) == 'undefined')
  var purgeMessengerEnableClear = false;
if (typeof (purgeMessengerEnableBanner) == 'undefined')
  var purgeMessengerEnableBanner = false;
if (typeof (purgeMessengerEnablePurge) == 'undefined')
  var purgeMessengerEnablePurge = false;
if (typeof (purgeMessengerPurgeWarnEditor) == 'undefined')
  var purgeMessengerPurgeWarnEditor = false;
if (typeof (purgeMessengerWatchMain) == 'undefined')
  var purgeMessengerWatchMain = false;
if (typeof (purgeMessengerWatchOthers) == 'undefined')
  var purgeMessengerWatchOthers = false;
if (typeof (purgeMessengerSignatureRegistered) == 'undefined')
  var purgeMessengerSignatureRegistered = '~~' + '~~';
if (typeof (purgeMessengerSignatureAnonymous) == 'undefined')
  var purgeMessengerSignatureAnonymous = '~~' + '~~';
if (typeof (purgeMessengerCopyvioWarningTemplate) == 'undefined')
  var purgeMessengerCopyvioWarningTemplate = 'Copieur';
 
var purgeMessengerNonExistingPage = new RegExp('sur <a href="/w/index\\.php\\?title=[^"]+redlink=1"');
var purgeMessengerRevision = new RegExp('actu(</a>)? \\|.+?title=(.+?)&amp;diff=([0-9]+)&amp;oldid=([0-9]+)"[^>]+?>diff.+?>([0-9]{1,2} [a-zéû]+ [0-9]{4} .+?)<.*?href="/wiki/Sp%C3%A9cial:Contributions/([^"]+)".*?</span> (<abbr class="minor")?.*?\\(([+-]?[0-9]+)\\).+?(<span class="comment">\\((<span class="autocomment">(<a .+?</a>)?(.+?)(:\\s*)?</span>)?\\s*(.*?)\\)</span>)? \\(');
 
function purgeMessengerEdit(article, text, reason, button)
{
  var request = new XMLHttpRequest();
  request.open('GET', wgServer + wgScriptPath + '/index.php?title=' + encodeURIComponent(article) + '&action=edit', false);
  request.send('');
 
  var parser = new DOMParser();
  var response = parser.parseFromString(request.responseText, 'application/xhtml+xml');
 
  if (text)
  {
    var previousText = response.getElementById('wpTextbox1').value;
    text = text.replace('$$text$$', previousText);
  }
 
  var inputs = response.getElementById('editform').getElementsByTagName('input');
  for (inputId = 0; inputId < inputs.length; ++inputId)
    switch (inputs[inputId].name)
    {
      case 'wpStarttime':
        var wpStarttime = inputs[inputId].value;
        break;
      case 'wpEdittime':
        var wpEdittime = inputs[inputId].value;
        break;
      case 'wpEditToken':
        var wpEditToken = inputs[inputId].value;
        break;
      default:
        break;
    }
 
  var parameters = 'wpSave=1'
    + '&wpTextbox1=' + encodeURIComponent(text)
    + '&wpStarttime=' + encodeURIComponent(wpStarttime)
    + '&wpEdittime=' + encodeURIComponent(wpEdittime)
    + '&wpEditToken=' + encodeURIComponent(wpEditToken)
    + '&wpSummary=' + encodeURIComponent('[[Utilisateur:Toto Azéro/purgeMessenger.js|purgeMessenger]] : ' + reason);
 
  if (purgeMessengerWatchOthers || purgeMessengerWatchMain && !wgNamespaceNumber || response.getElementById('wpWatchthis').checked)
    parameters += '&wpWatchthis=on';
 
  request.open('POST', wgServer + wgScriptPath + '/index.php?title=' + encodeURIComponent(article) + '&action=submit', true);
 
  request.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
  request.setRequestHeader('Content-length', parameters.length);
  request.setRequestHeader('Connection', 'close');
 
  request.send(parameters);
 
  // TODO reload the page content instead (another AJAX request)
  if (!text)
    document.getElementById('content').removeChild(document.getElementById('bodyContent'));
 
  if (button)
  {
    link = document.getElementById(button);
    link.innerHTML = '<img src="http://upload.wikimedia.org/wikipedia/commons/thumb/f/fb/Yes_check.svg/15px-Yes_check.svg.png" /> ' + link.innerHTML;
  }
}
 
function purgeMessengerAskForPurge()
{
  alert('test')
  var url = document.getElementById('purgeMessengerPurgeUrl').value;
  var warning = document.getElementById('purgeMessengerPurgeWarning');
  if (!url)
  {
    warning.setAttribute('style', 'color: red;');
    warning.innerHTML = 'Préciser l\'adresse de la source copiée';
    return;
  }
  warning.innerHTML = '';
 
  var history = document.getElementById('pagehistory');
  var lis = document.getElementsByTagName('li');
  var firstRevisionToPurge = 0;
  var lastRevisionToPurge = 0;
  for (var liId = 0; liId < lis.length; ++liId)
  {
    var inputs = lis[liId].getElementsByTagName('input');
    if (inputs.length > 1 && inputs[1].checked)
    {
      lastRevisionToPurge = liId;
      break;
    }
  }
  var revisionsToPurge = [];
  for (var liId = lastRevisionToPurge + 1; liId < lis.length; ++liId)
  {
    revisionsToPurge.push(lis[liId].innerHTML);
    if (lis[liId].getElementsByTagName('input')[0].checked)
    {
      firstRevisionToPurge = liId;
      break;
    }
  }
  alert('test : 1')
 
  function htmlToWiki(html)
  {
    return html
      .replace(new RegExp('<a href="/wiki/([^"]+)"[^>]*?>(.+?)</a>', 'g'), '[[$1|$2]]')
      .replace(new RegExp('<a href="/w/index\\.php\\?title=([^"]+)&amp;action=edit&amp;redlink=1"[^>]*?>(.+?)</a>', 'g'), '[[$1|$2]]')
      .replace(new RegExp('<a href="(/w/index\\.php\\?title=[^"]+)"[^>]*?>(.+?)</a>', 'g'), '[' + wgServer + '$1 $2]')
      .replace(new RegExp('<a href="http://([^\\.]+)\\.wikipedia.org/wiki/([^"]+)"[^>]*?>(.+?)</a>', 'g'), '[[$1:$2|$3]]')
      .replace(new RegExp('(\\{\\{.+?\\}\\})', 'g'), '<nowiki>$1</nowiki>')
    ;
  }
 
  alert('test : 2')
  function convertRevision(revision)
  {
    var values = purgeMessengerRevision.exec(revision.replace(/&nbsp;/g, ''));
 
    if (!values)
      alert('Bravo vous avez trouvé un bug dans purgeMessenger !\nMerci de bien vouloir copier le texte suivant sur [[Discussion utilisateur:Arkanosis]]\n\n' + revision);
 
    var result = '{{Révision|'
      + decodeURIComponent(values[2]).replace(/ /g, '_') + '|' // title                                                                                                                                                                                 
      + values[4] + '|' // before                                                                                                                                                                                
      + values[3] + '|' // after                                                                                                                                                                                 
      + values[5] + '|'; // date
 
    if (typeof (values[7]) != 'undefined')
      result += 'm';
 
    result += '|' + values[8]; // size                                                                                                                                                            
 
    if (/^[0-9.]+$/.exec(values[6]))
      result += '|ip=' + values[6];
    else
      result += '|u=' + decodeURIComponent(values[6]);
 
    if (typeof (values[12]) != 'undefined')
      result += '|auto=' + htmlToWiki(values[12]);
 
    if (typeof (values[14]) != 'undefined')
      result += '|commentaire=' + htmlToWiki(values[14])
 
    result += '}}';
 
    return result;
  }
 
  alert('test : 3')
  var firstRevisionToPurgeText = convertRevision(lis[firstRevisionToPurge].innerHTML);
  var text = '== {{a-court|' + wgPageName.replace(/_/g, ' ') + '}} ==\n\nCopie de site web sans autorisation explicite. Page copiée :\n* ' + url
           + '\n\nPremier ajout de la copie :\n* ' + firstRevisionToPurgeText
           + '\n\nRetrait de la copie :\n* ' + convertRevision(lis[lastRevisionToPurge].innerHTML)
           + '\n\n' + revisionsToPurge.length + ' révision' + (revisionsToPurge.length > 1 ? 's' : '') + ' à purger.'
           + '\n\n' + purgeMessengerSignatureRegistered;
 
  var pageName = wgPageName.replace(/_/g, ' ');
  var warning = document.getElementById('purgeMessengerPurgeWarning');

  var warningMessage = '== [[' + pageName + ']] ==\n\n{{subst' + ':' + purgeMessengerCopyvioWarningTemplate + '|' + pageName + '|2=' + url + '}}' + purgeMessengerSignatureAnonymous;
 
  alert('test : 4')
  purgeMessengerEdit('Discussion utilisateur:' + editor, '$$text$$\n' + warningMessage, 'violation de droits d\'auteur sur « [[' + pageName + ']] »', 0);
  warning.innerHTML += ', contributeur « ' + editor + ' » <a href="/wiki/Discussion utilisateur:' + editor + '" title="Page de discussion du contributeur">averti</a>';
}
 
function purgeMessengerAddHistoryLinks()
{
  var purge = '<input type="submit" value="Avertir le contributeur de la demande de purge d\'historique" class="historysubmit" accesskey="p" title="Avertir le contributeur de la demande de purge d\'historique" onClick="javascript:purgeMessengerAskForPurge(); return false;" /> — <label for="purgeMessengerPurgeUrl">Source copiée</label> : <input type="text" id="purgeMessengerPurgeUrl" /><strong id="purgeMessengerPurgeWarning"></strong>';
  var form = document.getElementById('mw-history-compare');
  form.childNodes[5].innerHTML += purge;
}
 
function purgeMessenger()
{
  if (location.href.indexOf('&action=history') != -1)
      purgeMessengerAddHistoryLinks();
}
 
addOnloadHook(purgeMessenger);