/*************************************************************************************************************************
 * MENUCLICDROIT                                                                                                         *
 *                                                                                                                       *
 * *** Fonctions ***                                                                                                     *
 * # Le clic droit sur une page fait apparaître un menu contextuel contenant tous les liens nécessaires à la navigation  *
 * # Le menu contextuel comprend :                                                                                       *
 *   * trois listes déroulantes où des liens supplémentaires peuvent êtres ajoutés (dans le code ci-dessous)             *
 *   * une liste déroulante de liens favoris : deux liens permettent d'ajouter ou de retirer la page courante            *
 * # En cours d'édition, un deuxième menu permet d'insérer des caractères pré-établis (quatrième liste)                  *
 * # Un menu supplémentaire permet de modifier l'affichage (couleurs, bordures, etc...)                                  *
 * # La page s'affiche en plein écran (optionnel)                                                                        *
 *                                                                                                                       *
 *                                                                                                                       *
 * *** TESTS ***                                                                                                         *
 * * Navigateurs *                                                                                                       *
 * Mozilla Firefox 3.5 : OK                                                                                              *
 * Internet Explorer 8  : OK jusqu'à version 0.8                                                                         *
 * Google Chrome 3.0 : OK                                                                                                *
 * Opera 10.00 : Ne marche pas                                                                                           *
 *                                                                                                                       *
 * * Habillages *                                                                                                        *
 * Vector : OK                                                                                                           *
 * Monobook : OK                                                                                                         *
 * Modern : OK                                                                                                           *
 * MySkin : OK                                                                                                           *
 * Simple : OK                                                                                                           *
 * Chick : OK                                                                                                            *
 *                                                                                                                       *
 * Nostalgia, Standard et Cologneblue :                                                                                  *
 * Fonctionne mais certains liens ne sont pas à la bonne place.                                                          *
 * La récuppération des liens existants est problématique car ils ne sont pas regroupés dans un div.                     *
 *                                                                                                                       *
 * Documentation complète : [[Discussion utilisateur:Dr Brains/MenuClicDroit.js]]                                        *
 *                                                                                                                       *
 * --Catégorie:MediaWiki:Fonction Monobook en JavaScript--<nowiki>                                                       *
 *************************************************************************************************************************/

///////////////////// ////////////////////////// /////////////////////////// /////////// ///////// PARTIE PERSONNALISABLE //////// /////// ////// //////// ////// //////// /////// ///////

////////////////////////////////////////////////////////////////////////////////////////////////// Paramètres 

var UrlSite = wgServer + "/wiki/";
var UrlSiteBis = wgServer + wgScript +"?title=";
var UrlSiteTer = wgServer ;

var DoubleClicEdit = true;            // Édition par double-clic (monobook seulement, ne marche pas avec Internet Explorer)
var PopUp = true;                     // Activation des pop-up de confirmation
var OldClicDroit = true;              // Conservation du menu contextuel standard
 
var TailleCancel = 70;     // Largeur du bouton "Annuler"     (fenêtre de suppression favoris)
var Alignt = "center";     // alignement du texte (avec IE, les menus déroulants sont toujours alignés à gauche)

var Padding_Base = 2;

////////////////////////////////////////////////////////////////////////////////////////////////// Textes
 
var MenuTextHide = '[-]';
var MenuTextShow = '[+]';

////////////////////////////////////////////////////////////////////////// Menu Principal et expressions standards
 
var MenuTextClose = "FERMER";
var MenuTextClosePop = "Cliquer pour fermer le menu";
var MenuTextMove = "DÉPLACER";
var MenuTextMovePop = "Cliquer pour déplacer le menu";
var MenuTextNavig = "NAVIGATION";
var MenuTextNavigOpen = "Cliquer pour ouvrir le menu Navigation";
var MenuEditTextEdit = "ÉDITION";
var MenuTextModifOpen = "Cliquer pour ouvrir le menu Édition";
var MenuEditTextSubmit = "PUBLICATION";
var MenuTextPublierOpen = "Cliquer pour ouvrir le menu Publication";
var MenuTextOption = "OPTIONS";
var MenuTextOptionOpen = "Cliquer pour ouvrir le menu Options";
var MenuTextCloseAll = "TOUT FERMER";
var MenuTextCloseAllPop = "Cliquer pour fermer tous les menus";
var MenuTextOpenAll = "TOUT OUVRIR";
var MenuTextOpenAllPop = "Cliquer pour ouvrir tous les menus";

////////////////////////////////////////////////////////////////////////// Menu Navigation

var MenuTextLast = "Précédente";
var MenuTextLastPop = "Revenir à la page précédente de l'historique du navigateur";
var MenuTextNextPop = "Revenir à la page suivante de l'historique du navigateur";
var MenuTextNext = "Suivante";
var MenuTextSearchPop = "Rechercher dans Wikipédia";
var MenuTextButton1 = "Lire";
var MenuTextButton1Pop  = "Aller vers une page portant exactement ce nom si elle existe";
var MenuTextButton2 = "Consulter";
var MenuTextButton2Pop = "Rechercher les pages comportant ce texte";
var MenuTextspecial = "pages spéciales";
var MenuTextActions = "ACTIONS";
var MenuTextActionBis = "autres actions";
var MenuTextPerso = "LIENS PERSONNELS";
var MenuTextAdd = "Ajouter";
var MenuTextAddPop = "Cliquer pour ajouter la page courante aux favoris";
var MenuTextSupprAll = "RAZ";
var MenuTextSupprAllPop = "Cliquer pour vider les favoris";
var MenuTextSuppr1 = "Supprimer";        
var MenuTextSuppr1Pop = "Cliquer pour supprimer une page précise des favoris";
var MenuTextFav = "favoris";
var MenuTextLang = "langues";
var MenuTextProjects = "projets";
var MenuTextCategory = "Catégories";
var MenuTextHiddenCategory = "Catégories cachées";
var MenuTextNavigBis = "Liens utiles";

////////////////////////////////////////////////////////////////////////// Menu Favoris
 
var Suppr1Fav1 = "La liste de favoris contient les pages suivantes :";
var Suppr1Fav2 = "Quelle page souhaitez-vous supprimer de la liste ?";
var Suppr1Fav3 = "(indiquer seulement le numéro)";
var Suppr1FavNone = "Vous n\'avez aucun favoris.";
var Suppr1FavThis = "Voulez-vous vraiment supprimer des favoris la page : ";
var SupprAllFav = "Voulez-vous vraiment effacer la liste de favoris ?";
 
////////////////////////////////////////////////////////////////////////// Menu Édition
 

var MenuEditTextTaille = "Taille de la zone d\'édition";
var MenuEditTextTailleTer = "Cliquer pour modifier la taille de la zone d\'édition";
var MenuEditTextTailleBis = "Nombre de lignes pour la zone d\'édition ?";
var MenuEditTextBalise = "Insérer Balises"
var MenuEditTextBaliseTer = "Cliquer pour insérer une balise quelconque";
var MenuEditTextBaliseBis = "Nom de la balise ? \nExemple : ";
var MenuEditTextTemplate = "Modèles utilisés par cette page";                 
 
////////////////////////////////////////////////////////////////////////// Menu Publication
 
var MenuEditTextSubmitBis = "Ajouter dans la boîte de résumé";
 
////////////////////////////////////////////////////////////////////////// Menu Options
 
var MenuTextOptionReload = "Attention, cette action va entraîner le rechargement de la page.\nLes modifications apportées ne seront pas enregistrées.\nContinuer ?";

var MenuTextOptionAffichage = "Affichage : ";
var MenuTextOptionPleinEcran = "Plein Écran";
var MenuTextOptionPleinEcranPop = "Cliquer pour afficher la page en plein écran";
var MenuTextOptionNoPleinEcran = "Normal";
var MenuTextOptionNoPleinEcranPop = "Cliquer pour revenir à l\'affichage normal";
var MenuTextOptionbgColor = "Fond cadres : ";
var MenuTextOptionbgColorPop = "Cliquer pour définir la couleur de fond des cadres";
var bgColorDefine = "Définir la couleur de fond des cadres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionbdColor = "Bordures : ";
var MenuTextOptionbdColorPop = "Cliquer pour définir la couleur des bordures";
var bdColorDefine = "Définir la couleur des bordures (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionTColor = "Fond titres : ";
var MenuTextOptionTColorPop = "Cliquer pour définir la couleur de fond des titres";
var TColorDefine = "Définir la couleur de fond des titres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionTtColor = "Texte titres : ";
var MenuTextOptionTtColorPop = "Cliquer pour définir la couleur du texte des titres";
var TtColorDefine = "Définir la couleur du texte des titres (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionlienColor = "Texte : ";
var MenuTextOptionlienColorPop = "Cliquer pour définir la couleur du texte";
var lienColorDefine = "Définir la couleur du texte (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionselColor = "Survol : ";
var MenuTextOptionselColorPop = "Cliquer pour définir la couleur des éléments survolés";
var selColorDefine = "Définir la couleur des éléments survolés (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionMDColor = "Menus déroulants : ";
var MenuTextOptionMDColorPop = "Cliquer pour définir la couleur des menus déroulants";
var MDColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionLineColor = "Lignes : ";
var MenuTextOptionLineColorPop = "Cliquer pour définir la couleur des lignes horizontales";
var LineColorDefine = "Définir la couleur des lignes horizontales (sans le signe #).\nCouleur actuelle : ";
var MenuTextOptionBaseTaille = "Largeur du menu principal : ";
var MenuTextOptionBaseTaillePop = "Cliquer pour définir la largeur du menu principal";
var BaseTailleDefine = "Définir la taille du menu principal (en pixels).\nTaille actuelle : "; 
var MenuTextOptionbgTaille = "Largeur du menu Navigation : ";
var MenuTextOptionbgTaillePop = "Cliquer pour définir la largeur du menu Navigation";
var bgTailleDefine = "Définir la taille du menu Navigation (en pixels).\nTaille actuelle : ";
var MenuTextOptionListeTaille = "Largeur du menu Favoris : ";
var MenuTextOptionListeTaillePop = "Cliquer pour définir la largeur du menu Favoris";
var ListeTailleDefine = "Définir la taille du menu Favoris (en pixels).\nTaille actuelle : ";
var MenuTextOptionModifTaille = "Largeur du menu Édition : ";
var MenuTextOptionModifTaillePop = "Cliquer pour définir la largeur du menu Édition";
var ModifTailleDefine = "Définir la taille du menu Édition (en pixels).\nTaille actuelle : ";
var MenuTextOptionPublierTaille = "Largeur du menu Publication : ";
var MenuTextOptionPublierTaillePop = "Cliquer pour définir la largeur du menu Publication";
var PublierTailleDefine = "Définir la taille du menu Publication (en pixels).\nTaille actuelle : ";
var MenuTextOptionOptionsTaille = "Largeur du menu Options : ";
var MenuTextOptionOptionsTaillePop = "Cliquer pour définir la largeur du menu Options";
var OptionsTailleDefine = "Définir la taille du menu Options (en pixels).\nTaille actuelle : ";
var MenuTextOptionTitreTaille = "Taille des titres : ";
var MenuTextOptionTitreTaillePop = "Cliquer pour définir la taille des titres";
var TitreTailleDefine = "Définir la taille du texte des titres (en pixels).\nTaille actuelle : ";
var MenuTextOptionfontTaille = "Taille du texte : ";
var MenuTextOptionfontTaillePop = "Cliquer pour définir la taille du texte";
var fontTailleDefine = "Définir la taille du texte (en pixels).\nTaille actuelle : ";
var MenuTextOptionbdTaille = "Taille des bordures : ";
var MenuTextOptionbdTaillePop = "Cliquer pour définir la taille des bordures";
var bdTailleDefine = "Définir la taille des bordures (en pixels).\nTaille actuelle : ";
var MenuTextOptionStylebd = "Style des bordures : ";
var MenuTextOptionStylebdPop = "Cliquer pour définir le style des bordures";
var StylebdDefine = "Définir le style des bordures.\nStyle actuel : ";
var MenuTextOptionStylepolice = "Police : ";
var MenuTextOptionStylepolicePop = "Cliquer pour définir la police";
var StylepoliceDefine = "Définir la police.\nPolice actuelle : ";
var MenuTextOptionOpacity = "Opacité : ";
var MenuTextOptionOpacityPop = "Cliquer pour définir l\'opacité";
var OpacityDefine = "Définir l\'opacité des menus.\nOpacité actuelle : ";
var MenuTextOptionArrondi = "Arrondi : ";
var MenuTextOptionArrondiPop = "Cliquer pour définir l\'arrondi";
var ArrondiDefine = "Définir l\'arrondi des menus.\nArrondi actuel : ";

var MenuTextOptionFix = "Fixer les menus";
var MenuTextOptionFixPop = "Cliquer pour enregistrer la position actuelle des menus";
var MenuTextPositionFix = "Réordonner les menus";
var MenuTextPositionFixPop = "Cliquer pour revenir à la position initiale des menus";
var MenuTextOptionRaz = "Rétablir les valeurs par défaut";
var MenuTextOptionRazPop = "Cliquer pour rétablir les valeurs par défaut";

////////////////////////////////////////////////////////////////////////////////////////////////// Variables utiles pour les liens ( encodeURIComponent() sert à gérer les caractères spéciaux )

var BASEPAGENAME    = encodeURIComponent(wgTitle);                                         // Page courante sans l'espace de noms = {{BASEPAGENAME}}
var FULLPAGENAME    = encodeURIComponent(wgPageName);                                      // Page courante = {{FULLPAGENAMEE}}
var TALKPAGENAME    = "Discussion_" + encodeURIComponent(wgPageName);                      // Page de discussion associée = {{TALKPAGENAMEE}}
var SUBJECTPAGENAME = encodeURIComponent(wgPageName.replace(/Discussion /,""));            // Page principale associée = {{SUBJECTPAGENAMEE}}
var NAMESPACENAME   = wgCanonicalNamespace;                                                // Espace de noms (en anglais) = {{NAMESPACE}}
var NAMESPACENUMBER = wgNamespaceNumber;                                                   // N° Espace de noms
var CURRENTUSER     = encodeURIComponent(wgUserName);                                      // Utilisateur Courant

if((document.getElementById("ca-delete"))||(document.getElementById("ca-undelete"))){       // Teste si l'utilisateur est sysop ( présence de l'onglet "supprimer" ou "restaurer" ). Si c'est le cas, SYSOP est vrai
      var SYSOP = true;
}else{
      var SYSOP = false;
}

var DISCUSSION      = document.getElementById("ca-addsection");                            // Teste si la page est une page de discussion ( présence de l'onglet "nouvelle section" ). Si c'est le cas, DISCUSSION est vrai

if (wgNamespaceNumber == 2 || wgNamespaceNumber == 3) {                                    // Teste si la page courante est une page utilisateur et renvoie son pseudonyme. 
      if ( wgTitle.indexOf("/") == -1 ) {                                                  // Si ce n'est pas le cas, UTILISATEUR est faux
            var UTILISATEUR = encodeURIComponent(wgTitle);
      } else {
            var UTILISATEUR = encodeURIComponent(wgTitle.substring(0, wgTitle.indexOf("/")));
      }
}else{
      var UTILISATEUR = false;
}


// * Récupération des variables personnalisées *

  document.write('<script type="text/javascript" src="' 
             + UrlSiteBis + '/index.php?title=Utilisateur:'+encodeURI(wgUserName)+'/BacASable.js' 
             + '&action=raw&ctype=text/javascript&dontcountme=s"></script>');


////////////////////////////////////////////////////////////////////////////////////////////////// MENUS DÉROULANTS PERSONNALISABLES

/**********************************************************************************************************************************************************************************
 *   Pour ajouter une ligne, créer trois instances supplémentaires : menuMACHINtexte[x],  menuMACHINlien[x] et menuMACHINtexte[x]                                                 *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                                                                         *
 *                                                                                                                                                                                *
 * Exemple :                                                                                                                                                                      *
 *                                                                                                                                                                                *
 * menuTRUCtexte[0] = "Mon lien"                        // Texte                                                                                                                  *
 * menuTRUClien[0] = UrlSite + "Spécial:MyPage"         // Page cible (on peut utiliser UrlSite, UrlSiteBis, une des variables ci-dessus ou bien taper l'adresse complète)        *
 * menuTRUCtarget[0] = "_self"                          // Ouverture : _self = même fenêtre (défaut), _blank = nouvelle fenêtre                                                   *
 *                                                                                                                                                                                *
 * menuTRUCtexte[1] = "Ma fonction"                     // Texte                                                                                                                  *
 * menuTRUClien[1] = "javascript:MaFonction(Param);"    // fonction javascript (doit être déclarée avant le "addOnloadHook();" de la fin de cette page)                           *
 * menuTRUCtarget[1] = ""                                                                                                                                                         *
 *                                                                                                                                                                                *
 * menuTRUCtexte[2]= "Sous-titre";                                                                                                                                                *
 * menuTRUClien[2]= "";                                 // Si pas de lien, insertion d'un sous-titre                                                                              *
 * menuTRUCtarget[2]="";                                                                                                                                                          *
 *                                                                                                                                                                                *
 * menuTRUCtexte[2]= "";                                                                                                                                                          *
 * menuTRUClien[2]= "Vide";                             // Si lien, mais pas de texte, l'instance n'est pas prise en compte                                                       *
 * menuTRUCtarget[2]="";                                                                                                                                                          *
 **********************************************************************************************************************************************************************************/

//////////////////////////////////////////////////////////////////// Menu Déroulant AUTRES ACTIONS 




menuactiontexte = new Array;
menuactionlien = new Array;
menuactiontarget = new Array;


menuactiontexte[0]= "Journal";               
menuactionlien[0]= UrlSiteBis + 'Special:Log&page=' + FULLPAGENAME;                
menuactiontarget[0]="_self"; 

if(DISCUSSION){
      menuactiontexte[1]= "Sous-pages de la page principale";
      menuactionlien[1]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + (NAMESPACENUMBER-1); 
      menuactiontarget[1]= "_self";
      menuactiontexte[2]= "Sous-pages de la page de discussion";
      menuactionlien[2]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + NAMESPACENUMBER;
      menuactiontarget[2]="_self"; 
}else {
      menuactiontexte[1]= "Sous-pages de la page principale";
      menuactionlien[1]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + NAMESPACENUMBER; 
      menuactiontarget[1]="_self";
      menuactiontexte[2]= "Sous-pages de la page de discussion";
      menuactionlien[2]= UrlSiteBis + 'Spécial%3AIndex/' + BASEPAGENAME + '/&namespace=' + (NAMESPACENUMBER+1);
      menuactiontarget[2]="_self"; 
}               

if(UTILISATEUR){
      menuactiontexte[3]= "Statut de l\'utilisateur";
      menuactionlien[3]= UrlSite + 'Spécial:Liste_des_utilisateurs/' + UTILISATEUR; 
      menuactiontarget[3]="_self";
      menuactiontexte[4]= "Contributions de l\'utilisateur";
      menuactionlien[4]= UrlSite + 'Special:Contributions/' + UTILISATEUR; 
      menuactiontarget[4]="_self";
      menuactiontexte[5]= "Journal de l\'utilisateur";
      menuactionlien[5]= UrlSiteBis + 'Special:Log&user=' + UTILISATEUR; 
      menuactiontarget[5]="_self";
      menuactiontexte[6]= "Blocages de l\'utilisateur";
      menuactionlien[6]= UrlSiteBis + 'Special:Log&type=block&page=User:' + UTILISATEUR; 
      menuactiontarget[6]="_self";
      if(SYSOP){
            menuactiontexte[7]= "Contributions supprimées";
            menuactionlien[7]= UrlSiteBis + 'Special:DeletedContributions&target=' + UTILISATEUR; 
            menuactiontarget[7]="_self";
            menuactiontexte[8]= "Bloquer l\'utilisateur";
            menuactionlien[8]= UrlSiteBis + '/Special:Blockip/' + UTILISATEUR; 
            menuactiontarget[8]= "_self"; 
      }else{
            menuactiontexte[7]= "";
            menuactionlien[7]= "Vide"; 
            menuactiontarget[7]="";
            menuactiontexte[8]= "";
            menuactionlien[8]= "Vide"; 
            menuactiontarget[8]="";
      }
}else{
      menuactiontexte[3]= "";
      menuactionlien[3]= "Vide"; 
      menuactiontarget[3]="";
      menuactiontexte[4]= "";
      menuactionlien[4]= "Vide"; 
      menuactiontarget[4]="";
      menuactiontexte[5]= "";
      menuactionlien[5]= "Vide"; 
      menuactiontarget[5]="";
      menuactiontexte[6]= "";
      menuactionlien[6]= "Vide"; 
      menuactiontarget[6]="";
      menuactiontexte[7]= "";
      menuactionlien[7]= "Vide"; 
      menuactiontarget[7]="";
      menuactiontexte[8]= "";
      menuactionlien[8]= "Vide"; 
      menuactiontarget[8]="";
}
           


//////////////////////////////////////////////////////////////////// Menu Déroulant AUTRES LIENS UTILES
menunavigtexte = new Array;
menunaviglien = new Array;
menunavigtarget = new Array;


menunavigtexte[0]= "Bistro";
menunaviglien[0]= UrlSite + "Wikipédia:Le_Bistro";
menunavigtarget[0]="_self";
menunavigtexte[1]= "Oracle";
menunaviglien[1]= UrlSite + "Wikipédia:Oracle";
menunavigtarget[1]="_self";
menunavigtexte[2]= "Guilde des guides";
menunaviglien[2]= UrlSite + "Wikipédia:Guilde_des_guides";
menunavigtarget[2]="_self";
menunavigtexte[3]= "";
menunaviglien[3]= "";
menunavigtarget[3]="";

//////////////////////////////////////////////////////////////////// Menu Déroulant PAGES SPÉCIALES
menuspecialtexte = new Array;
menuspeciallien = new Array;
menuspecialtarget = new Array;


menuspecialtexte[0]= "Toutes les pages spéciales";
menuspeciallien[0]= UrlSite + "Spécial:Pages_spéciales";
menuspecialtarget[0]="_self";

menuspecialtexte[1]= "Articles";
menuspeciallien[1]= "";
menuspecialtarget[1]="";
menuspecialtexte[2]= "Toutes les pages"
menuspeciallien[2]= UrlSite + "Spécial:Toutes_les_pages"
menuspecialtarget[2]="_self"
menuspecialtexte[3]= "Pages débutant par..."
menuspeciallien[3]= UrlSite + "Spécial:Index"
menuspecialtarget[3]="_self"
menuspecialtexte[4]= "Pages courtes"
menuspeciallien[4]= UrlSite + "Spécial:Pages_courtes"
menuspecialtarget[4]="_self"
menuspecialtexte[5]= "Pages en impasse"
menuspeciallien[5]= UrlSite + "Spécial:Pages_en_impasse"
menuspecialtarget[5]="_self"
menuspecialtexte[6]= "Pages les moins modifiées"
menuspeciallien[6]= UrlSite + "Spécial:Pages_les_moins_modifiées"
menuspecialtarget[6]="_self"
menuspecialtexte[7]= "Pages anciennes"
menuspeciallien[7]= UrlSite + "Spécial:Pages_anciennes"
menuspecialtarget[7]="_self"
menuspecialtexte[8]= "Pages demandées"
menuspeciallien[8]= UrlSite + "Spécial:Pages_demandées"
menuspecialtarget[8]="_self"
menuspecialtexte[9]= "Pages longues"
menuspeciallien[9]= UrlSite + "Spécial:Pages_longues"
menuspecialtarget[9]="_self"
menuspecialtexte[10]= "Pages non catégorisées"
menuspeciallien[10]= UrlSite + "Spécial:Pages_non_catégorisées"
menuspecialtarget[10]="_self"
menuspecialtexte[11]= "Pages orphelines"
menuspeciallien[11]= UrlSite + "Spécial:Pages_orphelines"
menuspecialtarget[11]="_self"
menuspecialtexte[12]= "Pages protégées"
menuspeciallien[12]= UrlSite + "Spécial:Pages_protégées"
menuspecialtarget[12]="_self"
menuspecialtexte[13]= "Pages sans interwiki"
menuspeciallien[13]= UrlSite + "Spécial:Sans_interwiki"
menuspecialtarget[13]="_self"
menuspecialtexte[14]= "Pages les plus liées"
menuspeciallien[14]= UrlSite + "Spécial:Pages_les_plus_liées"
menuspecialtarget[14]="_self"
menuspecialtexte[15]= "Titres protégés"
menuspeciallien[15]= UrlSite + "Spécial:Titres_protégés"
menuspecialtarget[15]="_self"
menuspecialtexte[16]= "Pages utilisant le plus de catégories"
menuspeciallien[16]= UrlSite + "Spécial:Pages_utilisant_le_plus_de_catégories"
menuspecialtarget[16]="_self"
menuspecialtexte[17]= "Pages les plus liées"
menuspeciallien[17]= UrlSite + "Spécial:Pages_les_plus_liées"
menuspecialtarget[17]="_self"
menuspecialtexte[18]= "Pages les plus modifiées"
menuspeciallien[18]= UrlSite + "Spécial:Pages_les_plus_modifiées"
menuspecialtarget[18]="_self"
menuspecialtexte[19]= "Liens entre espaces de noms"
menuspeciallien[19]= UrlSite + "Spécial:CrossNamespaceLinks"
menuspecialtarget[19]="_self"

menuspecialtexte[20]= "Catégories";
menuspeciallien[20]= "";
menuspecialtarget[20]="";
menuspecialtexte[21]= "Liste des catégories"
menuspeciallien[21]= UrlSite + "Spécial:Categories"
menuspecialtarget[21]="_self"
menuspecialtexte[22]= "Arborescence des catégories"
menuspeciallien[22]= UrlSite + "Spécial:ArbreCategorie"
menuspecialtarget[22]="_self"
menuspecialtexte[23]= "Catégories inutilisées"
menuspeciallien[23]= UrlSite + "Spécial:Catégories_inutilisées"
menuspecialtarget[23]="_self"
menuspecialtexte[24]= "Catégories demandées"
menuspeciallien[24]= UrlSite + "Spécial:Catégories_demandées"
menuspecialtarget[24]="_self"
menuspecialtexte[25]= "Catégories non catégorisées"
menuspeciallien[25]= UrlSite + "Spécial:Catégories_non_catégorisées"
menuspecialtarget[25]="_self"
menuspecialtexte[26]= "Catégories les plus liées"
menuspeciallien[26]= UrlSite + "Spécial:Catégories_les_plus_liées"
menuspecialtarget[26]="_self"
menuspecialtexte[27]= "Catégories les plus utiliséess"
menuspeciallien[27]= UrlSite + "Spécial:Catégories_les_plus_utilisées"
menuspecialtarget[27]="_self"

menuspecialtexte[28]= "Fichiers";
menuspeciallien[28]= "";
menuspecialtarget[28]="";
menuspecialtexte[29]= "Liste des fichiers"
menuspeciallien[29]= UrlSite + "Spécial:Liste_des_fichiers"
menuspecialtarget[29]="_self"
menuspecialtexte[30]= "Fichiers demandés"
menuspeciallien[30]= UrlSite + "Spécial:Fichiers_demandés"
menuspecialtarget[30]="_self"
menuspecialtexte[31]= "Fichiers non catégorisés"
menuspeciallien[31]= UrlSite + "Spécial:Fichiers_non_catégorisés"
menuspecialtarget[31]="_self"
menuspecialtexte[32]= "Fichiers inutilisées"
menuspeciallien[32]= UrlSite + "Spécial:Fichiers_inutilisées"
menuspecialtarget[32]="_self"
menuspecialtexte[33]= "Fichiers les plus liés"
menuspeciallien[33]= UrlSite + "Spécial:Fichiers_les_plus_liés"
menuspecialtarget[33]="_self"
menuspecialtexte[34]= "Fichiers les plus utilisés"
menuspeciallien[34]= UrlSite + "Spécial:Fichiers_les_plus_utilisés"
menuspecialtarget[34]="_self"

menuspecialtexte[35]= "Modèles";
menuspeciallien[35]= "";
menuspecialtarget[35]="";
menuspecialtexte[36]= "Modèles demandés"
menuspeciallien[36]= UrlSite + "Spécial:Modèles_demandés"
menuspecialtarget[36]="_self"
menuspecialtexte[37]= "Modèles non catégorisés"
menuspeciallien[37]= UrlSite + "Spécial:Modèles_non_catégorisés"
menuspecialtarget[37]="_self"
menuspecialtexte[38]= "Modèles inutilisés"
menuspeciallien[38]= UrlSite + "Spécial:Modèles_inutilisés"
menuspecialtarget[38]="_self"
menuspecialtexte[39]= "Modèles les plus liés"
menuspeciallien[39]= UrlSite + "Spécial:Modèles_les_plus_liés"
menuspecialtarget[39]="_self"
menuspecialtexte[40]= "Modèles les plus utilisés"
menuspeciallien[40]= UrlSite + "Spécial:Modèles_les_plus_utilisés"
menuspecialtarget[40]="_self"

menuspecialtexte[41]= "Redirections";
menuspeciallien[41]= "";
menuspecialtarget[41]="";
menuspecialtexte[42]= "Liste des redirections"
menuspeciallien[42]= UrlSite + "Spécial:Liste_des_redirections"
menuspecialtarget[42]="_self"
menuspecialtexte[43]= "Doubles redirections"
menuspeciallien[43]= UrlSite + "Spécial:Doubles_redirections"
menuspecialtarget[43]="_self"
menuspecialtexte[44]= "Redirections cassées"
menuspeciallien[44]= UrlSite + "Spécial:Redirections_cassées"
menuspecialtarget[44]="_self"
menuspecialtexte[45]= "Homonymies"
menuspeciallien[45]= UrlSite + "Spécial:Homonymies"
menuspecialtarget[45]="_self"

////////////////////////////////////////////////////////////////////////////////////////////////// TOOLBAR

obtenir('getVarValue');
obtenir('getStrDateToday');

/********************************************************************************************************************************************
 *   Pour ajouter une icône à la barre d'outils, créer cinq instances supplémentaires comme expliqué ci-dessous                             *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                                   *
 *                                                                                                                                          *
 * menutoolbardébut[X] = "";            // Code inséré avant la sélection. Les espaces, les apostrophes ou les guillemets sont autorisés    *
 * menutoolbarfin[X] = "";              // Code inséré après la sélection                                                                   *
 * menutoolbarcomm[X] = "";             // Information au survol de la souris                                                               *
 * menutoolbarimage[X] = "";            // URL de l'image                                                                                   *
 * menutoolbarimageId[X] = "";          // Id du bouton (attention, pas d'espace ou autres caractères spéciaux)                             *
 * menutoolbarimagePosition[X] = "";    // Début ou Fin : Position de l'image par rapport à celles qui y sont déjà ( Début par défaut)      *
 *                                                                                                                                          *
 ********************************************************************************************************************************************/
menutoolbardébut = new Array;
menutoolbarfin = new Array;
menutoolbarcomm = new Array;
menutoolbarimage = new Array;
menutoolbarimageId = new Array;
menutoolbarimagePosition = new Array;


menutoolbardébut[0] = "{{subst:Bienvenu}} ~~~~";
menutoolbarfin[0] = "";
menutoolbarcomm[0] = "Bienvenue sur ta page !";
menutoolbarimage[0] = "http://upload.wikimedia.org/wikipedia/commons/1/12/Button_accueilA.png";
menutoolbarimageId[0] = "bienvenue_sur_ta_page";
menutoolbarimagePosition[0] = "Fin";

menutoolbardébut[1] = "{{subst:Bienvenue nouveau}} ~~~~";
menutoolbarfin[1] = "";
menutoolbarcomm[1] = "Bienvenue !";
menutoolbarimage[1] = "http://upload.wikimedia.org/wikipedia/commons/e/eb/Button_accueilB.png";
menutoolbarimageId[1] = "bienvenue";
menutoolbarimagePosition[1] =  "Fin";

menutoolbardébut[2] = "{{Vandale bloqué|1|jour}} ~~~~";
menutoolbarfin[2] = "";
menutoolbarcomm[2] = "Blocage d'un vandale";
menutoolbarimage[2] = "http://upload.wikimedia.org/wikipedia/commons/0/00/Button_vandale.png";
menutoolbarimageId[2] = "blocage_vandale";
menutoolbarimagePosition[2] =  "Fin";

menutoolbardébut[3] = "{{subst:Vandalisme|article}} ~~~~";
menutoolbarfin[3] = "";
menutoolbarcomm[3] = "Avertissement vandalisme";
menutoolbarimage[3] = "http://upload.wikimedia.org/wikipedia/commons/a/a7/Button_smiley3.png";
menutoolbarimageId[3] = "avertissement_vandalisme";
menutoolbarimagePosition[3] = "Fin";

menutoolbardébut[4] = "{{subst:Copieur|article|page copiée}} ~~~~";
menutoolbarfin[4] = "";
menutoolbarcomm[4] = "Avertissement copyvio";
menutoolbarimage[4] = "http://upload.wikimedia.org/wikipedia/commons/5/58/Button_black_copyright.png";
menutoolbarimageId[4] = "avertissement_copyvio";
menutoolbarimagePosition[4] = "Fin";

menutoolbardébut[5] = "{{subst:Bienvenue spammeur|article}} ~~~~";
menutoolbarfin[5] = "";
menutoolbarcomm[5] = "Avertissement spam";
menutoolbarimage[5] = "http://upload.wikimedia.org/wikipedia/commons/f/fb/Button_spam2.png";
menutoolbarimageId[5] = "avertissement_spam";
menutoolbarimagePosition[5] = "Fin";

menutoolbardébut[6] = "{{Fait}} ~~~~";
menutoolbarfin[6] = "";
menutoolbarcomm[6] = "Fait";
menutoolbarimage[6] = "http://upload.wikimedia.org/wikipedia/commons/d/d9/Button_trait%C3%A9.png";
menutoolbarimageId[6] = "fait";
menutoolbarimagePosition[6] = "Fin";

menutoolbardébut[7] = "{{Citation|";
menutoolbarfin[7] = "}}";
menutoolbarcomm[7] = "Citation française";
menutoolbarimage[7] = "http://upload.wikimedia.org/wikipedia/commons/2/26/Button_latinas.png";
menutoolbarimageId[7] = "citation_francaise";
menutoolbarimagePosition[7] = "Fin";

var langue = getVarValue("langue_citation_etrangere", "en");

menutoolbardébut[8] = "{{Citation étrangère|lang=" + langue + "|";
menutoolbarfin[8] = "";
menutoolbarcomm[8] = "Citation étrangère";
menutoolbarimage[8] = "http://upload.wikimedia.org/wikipedia/commons/0/05/Button_Anführung.png";
menutoolbarimageId[8] = "citation_etrangere";
menutoolbarimagePosition[8] = "Fin";

menutoolbardébut[9] = "{{Référence nécessaire|";
menutoolbarfin[9] = "|date=" + getStrDateToday("m a") + "}}";
menutoolbarcomm[9] = "Référence nécessaire";
menutoolbarimage[9] = "http://upload.wikimedia.org/wikipedia/commons/5/5c/Button_references2.png";
menutoolbarimageId[9] = "ref_nec";
menutoolbarimagePosition[9] = "Fin";

menutoolbardébut[10] = "{{à sourcer|date=" + getStrDateToday("m a");
menutoolbarfin[10] = "}}";
menutoolbarcomm[10] = "Section ou article à sourcer";
menutoolbarimage[10] = "http://upload.wikimedia.org/wikipedia/commons/3/33/Button_unreferenced.png";
menutoolbarimageId[10] = "a_sourcer";
menutoolbarimagePosition[10] = "Fin";

menutoolbardébut[11] = "{{Lien web\n|url=\n|titre=\n|id=\n|série=\n|auteur=\n|lien auteur=\n|coauteurs=\n|date=\n|année=\n|mois=\n|site=\n|éditeur=\n|page=\n|citation=\n|en ligne le=\n|consulté le=" + getStrDateToday("j m a") + "\n";
menutoolbarfin[11] = "}}";
menutoolbarcomm[11] = "Lien web";
menutoolbarimage[11] = "http://upload.wikimedia.org/wikipedia/commons/3/3c/Button_lienweb.png";
menutoolbarimageId[11] = "lien_web";
menutoolbarimagePosition[11] = "Fin";

menutoolbardébut[12] = "{{Article\n|langue=\n|prénom1=\n|nom1=\n|lien auteur1=\n|titre=\n|périodique=\n|lien périodique=\n|jour=\n|mois=\n|année=\n|volume=\n|numéro=\n|pages=\n|issn=\n|url texte=\n|consulté le=";
menutoolbarfin[12] = "\n}}";
menutoolbarcomm[12] = "Article";
menutoolbarimage[12] = "http://upload.wikimedia.org/wikipedia/commons/b/b4/Button_lienjournal.png";
menutoolbarimageId[12] = "article";
menutoolbarimagePosition[12] = "Fin";

menutoolbardébut[13] = "{{ouvrage\n|langue=\n|prénom1=\n|nom1=\n|lien auteur1=\n|titre=\n|sous-titre=\n|numéro d'édition=\n|éditeur=\n|lien éditeur=\n|lieu=\n|jour=\n|mois=\n|année=\n|volume=\n|tome=\n|pages totales=\n|passage=\n|isbn=\n|lire en ligne=\n|consulté le=";
menutoolbarfin[13] = "\n}}";
menutoolbarcomm[13] = "Livre";
menutoolbarimage[13] = "http://upload.wikimedia.org/wikipedia/commons/e/ef/Button_cite_book.png";
menutoolbarimageId[13] = "livre";
menutoolbarimagePosition[13] = "Fin";

menutoolbardébut[14] = "<gallery>\\nFichier:Exemple.jpg|[[Tournesol]]\\nFichier:Exemple1.jpg|[[La Joconde]]\\nFichier:Exemple2.jpg|Un [[hamster]]";
menutoolbarfin[14] = "\\n</gallery>\\n{{message galerie}}";
menutoolbarcomm[14] = "Galerie";
menutoolbarimage[14] = "http://upload.wikimedia.org/wikipedia/commons/9/9e/Btn_toolbar_gallery.png";
menutoolbarimageId[14] = "galerie";
menutoolbarimagePosition[14] = "";

menutoolbardébut[15] = "{|\\n|-\\n|\\n|\\n|}";
menutoolbarfin[15] = "";
menutoolbarcomm[15] = "Tableau";
menutoolbarimage[15] = "http://upload.wikimedia.org/wikipedia/commons/0/04/Button_array.png";
menutoolbarimageId[15] = "tableau";
menutoolbarimagePosition[15] = "";

menutoolbardébut[16] = "# élément 1\\n# élément 2\\n# élément 3";
menutoolbarfin[16] = "";
menutoolbarcomm[16] = "Liste numérotée";
menutoolbarimage[16] = "http://upload.wikimedia.org/wikipedia/commons/8/88/Btn_toolbar_enum.png";
menutoolbarimageId[16] = "liste";
menutoolbarimagePosition[16] = "";

menutoolbardébut[17] = "* élément A\\n* élément B\\n* élément C";
menutoolbarfin[17] = "";
menutoolbarcomm[17] = "Liste à puces";
menutoolbarimage[17] = "http://upload.wikimedia.org/wikipedia/commons/1/11/Btn_toolbar_liste.png";
menutoolbarimageId[17] = "puces";
menutoolbarimagePosition[17] = "";

menutoolbardébut[18] = "<!-- ";
menutoolbarfin[18] = " -->";
menutoolbarcomm[18] = "Commentaires";
menutoolbarimage[18] = "http://upload.wikimedia.org/wikipedia/commons/3/37/Btn_toolbar_commentaire.png";
menutoolbarimageId[18] = "comm";
menutoolbarimagePosition[18] = "";

menutoolbardébut[19] = "<source lang= >\\n";
menutoolbarfin[19] = "\\n</source>";
menutoolbarcomm[19] = "Code source";
menutoolbarimage[19] = "http://upload.wikimedia.org/wikipedia/commons/d/d2/Button_source.png";
menutoolbarimageId[19] = "source";
menutoolbarimagePosition[19] = "";

menutoolbardébut[20] = "<nowiki>";
menutoolbarfin[20] = "</nowiki>";
menutoolbarcomm[20] = "Nowiki";
menutoolbarimage[20] = "http://upload.wikimedia.org/wikipedia/commons/8/82/Nowiki_icon.png";
menutoolbarimageId[20] = "nowiki";
menutoolbarimagePosition[20] = "";

menutoolbardébut[21] = "<noinclude>";
menutoolbarfin[21] = "</noinclude>";
menutoolbarcomm[21] = "NoInclude";
menutoolbarimage[21] = "http://upload.wikimedia.org/wikipedia/commons/c/ce/Button_no_include.png";
menutoolbarimageId[21] = "noinclude";
menutoolbarimagePosition[21] = "";

menutoolbardébut[22] = "<includeonly>";
menutoolbarfin[22] = "</includeonly>";
menutoolbarcomm[22] = "IncludeOnly";
menutoolbarimage[22] = "http://upload.wikimedia.org/wikipedia/commons/7/79/Button_include.png";
menutoolbarimageId[22] = "includeonly";
menutoolbarimagePosition[22] = "";

menutoolbardébut[23] = "<tt>";
menutoolbarfin[23] = "</tt>";
menutoolbarcomm[23] = "TT";
menutoolbarimage[23] = "http://upload.wikimedia.org/wikipedia/commons/5/5f/Btn_toolbar_tt.png";
menutoolbarimageId[23] = "tt";
menutoolbarimagePosition[23] = "";

menutoolbardébut[24] = "----";
menutoolbarfin[24] = "";
menutoolbarcomm[24] = "Ligne";
menutoolbarimage[24] = "http://upload.wikimedia.org/wikipedia/commons/0/0d/Button_hr.png";
menutoolbarimageId[24] = "hr";
menutoolbarimagePosition[24] = "";

menutoolbardébut[25] = "<math>";
menutoolbarfin[25] = "</math>";
menutoolbarcomm[25] = "Math";
menutoolbarimage[25] = "http://upload.wikimedia.org/wikipedia/commons/2/2e/Button_math.png";
menutoolbarimageId[25] = "math";
menutoolbarimagePosition[25] = "";

menutoolbardébut[26] = "[[Fichier:";
menutoolbarfin[26] = "]]";
menutoolbarcomm[26] = "Media";
menutoolbarimage[26] = "http://upload.wikimedia.org/wikipedia/commons/1/19/Button_media.png";
menutoolbarimageId[26] = "media";
menutoolbarimagePosition[26] = "";

menutoolbardébut[27] = "[[Image:";
menutoolbarfin[27] = "]]";
menutoolbarcomm[27] = "Image";
menutoolbarimage[27] = "http://upload.wikimedia.org/wikipedia/commons/d/de/Button_image.png";
menutoolbarimageId[27] = "image";
menutoolbarimagePosition[27] = "";

menutoolbardébut[28] = "[";
menutoolbarfin[28] = " ]";
menutoolbarcomm[28] = "Lien externe";
menutoolbarimage[28] = "http://upload.wikimedia.org/wikipedia/commons/e/ec/Button_extlink.png";
menutoolbarimageId[28] = "L_externe";
menutoolbarimagePosition[28] = "";

menutoolbardébut[29] = "[[";
menutoolbarfin[29] = "]]";
menutoolbarcomm[29] = "Lien interne";
menutoolbarimage[29] = "http://upload.wikimedia.org/wikipedia/commons/c/c0/Button_link.png";
menutoolbarimageId[29] = "L_interne";
menutoolbarimagePosition[29] = "";


menutoolbardébut[30] = "<big>";
menutoolbarfin[30] = "</big>";
menutoolbarcomm[30] = "Big";
menutoolbarimage[30] = "http://upload.wikimedia.org/wikipedia/commons/8/89/Button_bigger.png";
menutoolbarimageId[30] = "big";
menutoolbarimagePosition[30] = "";

menutoolbardébut[31] = "<small>";
menutoolbarfin[31] = "</small";
menutoolbarcomm[31] = "Small";
menutoolbarimage[31] = "http://upload.wikimedia.org/wikipedia/commons/0/0d/Button_smaller.png";
menutoolbarimageId[31] = "small";
menutoolbarimagePosition[31] = "";

menutoolbardébut[32] = "<sub>";
menutoolbarfin[32] = "</sub>";
menutoolbarcomm[32] = "Indice";
menutoolbarimage[32] = "http://upload.wikimedia.org/wikipedia/commons/a/aa/Button_sub_letter.png";
menutoolbarimageId[32] = "indice";
menutoolbarimagePosition[32] = "";

menutoolbardébut[33] = "<sup>";
menutoolbarfin[33] = "</sup>";
menutoolbarcomm[33] = "Exposant";
menutoolbarimage[33] = "http://upload.wikimedia.org/wikipedia/commons/6/6a/Button_sup_letter.png";
menutoolbarimageId[33] = "exposant";
menutoolbarimagePosition[33] = "";

menutoolbardébut[34] = "======";
menutoolbarfin[34] = "======";
menutoolbarcomm[34] = "Section niveau 6";
menutoolbarimage[34] = "http://upload.wikimedia.org/wikipedia/commons/e/e8/Button_paragraphe_6.png";
menutoolbarimageId[34] = "section6";
menutoolbarimagePosition[34] = "";

menutoolbardébut[35] = "=====";
menutoolbarfin[35] = "=====";
menutoolbarcomm[35] = "Section niveau 5";
menutoolbarimage[35] = "http://upload.wikimedia.org/wikipedia/commons/7/79/Button_paragraphe_5.png";
menutoolbarimageId[35] = "section5";
menutoolbarimagePosition[35] = "";

menutoolbardébut[36] = "====";
menutoolbarfin[36] = "====";
menutoolbarcomm[36] = "Section niveau 4";
menutoolbarimage[36] = "http://upload.wikimedia.org/wikipedia/commons/6/61/Button_paragraphe_4.png";
menutoolbarimageId[36] = "section4";
menutoolbarimagePosition[36] = "";

menutoolbardébut[37] = "===";
menutoolbarfin[37] = "===";
menutoolbarcomm[37] = "Section niveau 3";
menutoolbarimage[37] = "http://upload.wikimedia.org/wikipedia/commons/b/ba/Button_paragraphe_3.png";
menutoolbarimageId[37] = "section3";
menutoolbarimagePosition[37] = "";

menutoolbardébut[38] = "==";
menutoolbarfin[38] = "==";
menutoolbarcomm[38] = "Section niveau 2";
menutoolbarimage[38] = "http://upload.wikimedia.org/wikipedia/commons/c/cf/Button_paragraphe_2.png";
menutoolbarimageId[38] = "section2";
menutoolbarimagePosition[38] = "";

menutoolbardébut[39] = "<h1>";
menutoolbarfin[39] = "</h1>";
menutoolbarcomm[39] = "Section niveau 1";
menutoolbarimage[39] = "http://upload.wikimedia.org/wikipedia/commons/0/03/Button_paragraphe_1.png";
menutoolbarimageId[39] = "section1";
menutoolbarimagePosition[39] = "";

menutoolbardébut[40] = "<s>";
menutoolbarfin[40] = "</s>";
menutoolbarcomm[40] = "Barré";
menutoolbarimage[40] = "http://upload.wikimedia.org/wikipedia/commons/3/30/Btn_toolbar_rayer.png";
menutoolbarimageId[40] = "barre";
menutoolbarimagePosition[40] = "";

menutoolbardébut[41] = "<u>";
menutoolbarfin[41] = "</u>";
menutoolbarcomm[41] = "Souligné";
menutoolbarimage[41] = "http://upload.wikimedia.org/wikipedia/commons/f/fd/Button_underline.png";
menutoolbarimageId[41] = "soulign";
menutoolbarimagePosition[41] = "";

menutoolbardébut[42] = "''";
menutoolbarfin[42] = "''";
menutoolbarcomm[42] = "Italique";
menutoolbarimage[42] = "http://upload.wikimedia.org/wikipedia/commons/1/1d/Button_italic.png";
menutoolbarimageId[42] = "italiq";
menutoolbarimagePosition[42] = "";

menutoolbardébut[43] = "'''";
menutoolbarfin[43] = "'''";
menutoolbarcomm[43] = "Gras";
menutoolbarimage[43] = "http://upload.wikimedia.org/wikipedia/commons/e/e2/Button_bold.png";
menutoolbarimageId[43] = "gras";
menutoolbarimagePosition[43] = "";

// Discussion + Émoticônes {{m|Alien}}
/*
menutoolbardébut[44] = "";
menutoolbarfin[44] = "";
menutoolbarcomm[44] = "";
menutoolbarimage[44] = "";
menutoolbarimageId[44] = "";
menutoolbarimagePosition[44] = "Fin";

menutoolbardébut[45] = "{{Alien|aie}}";
menutoolbarfin[45] = "";
menutoolbarcomm[45] = "Aïe !";
menutoolbarimage[45] = "http://upload.wikimedia.org/wikipedia/commons/1/1c/Smilies_Alien_huf.png";
menutoolbarimageId[45] = "Alienaie";
menutoolbarimagePosition[45] = "Fin";

menutoolbardébut[46] = "{{Alien|bave}}";
menutoolbarfin[46] = "";
menutoolbarcomm[46] = "Bave !";
menutoolbarimage[46] = "http://upload.wikimedia.org/wikipedia/commons/3/3d/Smilies_Alien_droling.png";
menutoolbarimageId[46] = "Alienbave";
menutoolbarimagePosition[46] = "Fin";
	
menutoolbardébut[47] = "{{Alien|clin}}";
menutoolbarfin[47] = "";
menutoolbarcomm[47] = "Clin d’œil !";
menutoolbarimage[47] = "http://upload.wikimedia.org/wikipedia/commons/b/bf/Smilies_Alien_wink.png";
menutoolbarimageId[47] = "Alienclin";
menutoolbarimagePosition[47] = "Fin";

menutoolbardébut[48] = "{{Alien|col}}";
menutoolbarfin[48] = "";
menutoolbarcomm[48] = "En colère !";
menutoolbarimage[48] = "http://upload.wikimedia.org/wikipedia/commons/9/9e/Smilies_Alien_unhappy.png";
menutoolbarimageId[48] = "Aliencol";
menutoolbarimagePosition[48] = "Fin";	

menutoolbardébut[49] = "{{Alien|conf}}";
menutoolbarfin[49] = "";
menutoolbarcomm[49] = "Gêne !";
menutoolbarimage[49] = "http://upload.wikimedia.org/wikipedia/commons/8/8d/Smilies_Alien_red.png";
menutoolbarimageId[49] = "Alienconf";
menutoolbarimagePosition[49] = "Fin";	

menutoolbardébut[50] = "{{Alien|cool}}";
menutoolbarfin[50] = "";
menutoolbarcomm[50] = "Cool !";
menutoolbarimage[50] = "http://upload.wikimedia.org/wikipedia/commons/4/4a/Smilies_Alien_cool.png";
menutoolbarimageId[50] = "Aliencool";
menutoolbarimagePosition[50] = "Fin";	

menutoolbardébut[51] = "{{Alien|dep}}";
menutoolbarfin[51] = "";
menutoolbarcomm[51] = "Dépression !";
menutoolbarimage[51] = "http://upload.wikimedia.org/wikipedia/commons/1/1e/Smilies_Alien_depressive.png";
menutoolbarimageId[51] = "Aliendep";
menutoolbarimagePosition[51] = "Fin";	

menutoolbardébut[52] = "{{Alien|dodo}}";
menutoolbarfin[52] = "";
menutoolbarcomm[52] = "Dort !";
menutoolbarimage[52] = "http://upload.wikimedia.org/wikipedia/commons/e/e5/Smilies_Alien_sleepy.png";
menutoolbarimageId[52] = "Alien_dodo";
menutoolbarimagePosition[52] = "Fin";

menutoolbardébut[53] = "{{Alien|dsl}}";
menutoolbarfin[53] = "";
menutoolbarcomm[53] = "Excuse !";
menutoolbarimage[53] = "http://upload.wikimedia.org/wikipedia/commons/f/f9/Smilies_Alien_sorry.png";
menutoolbarimageId[53] = "Aliendsl";
menutoolbarimagePosition[53] = "Fin";

menutoolbardébut[54] = "{{Alien|eton}}";
menutoolbarfin[54] = "";
menutoolbarcomm[54] = "Étonnement !";
menutoolbarimage[54] = "http://upload.wikimedia.org/wikipedia/commons/9/9e/Smilies_Alien_disapointed.png";
menutoolbarimageId[54] = "Alieneton";
menutoolbarimagePosition[54] = "Fin";

menutoolbardébut[55] = "{{Alien|gne}}";
menutoolbarfin[55] = "";
menutoolbarcomm[55] = "Gné ?!";
menutoolbarimage[55] = "http://upload.wikimedia.org/wikipedia/commons/7/76/Smilies_Alien_wow.png";
menutoolbarimageId[55] = "Aliengne";
menutoolbarimagePosition[55] = "Fin";

menutoolbardébut[56] = "{{Alien|grrr}}";
menutoolbarfin[56] = "";
menutoolbarcomm[56] = "GRRR !!!";
menutoolbarimage[56] = "http://upload.wikimedia.org/wikipedia/commons/6/61/Smilies_Alien_GRRR.png";
menutoolbarimageId[56] = "Aliengrrr";
menutoolbarimagePosition[56] = "Fin";

menutoolbardébut[57] = "{{Alien|hey}}";
menutoolbarfin[57] = "";
menutoolbarcomm[57] = "Hey !";
menutoolbarimage[57] = "http://upload.wikimedia.org/wikipedia/commons/c/c8/Smilies_Alien_aaah.png";
menutoolbarimageId[57] = "Alien_hey";
menutoolbarimagePosition[57] = "Fin";

menutoolbardébut[58] = "{{Alien|hu}}";
menutoolbarfin[58] = "";
menutoolbarcomm[58] = "Hu !";
menutoolbarimage[58] = "http://upload.wikimedia.org/wikipedia/commons/c/c3/Smilies_Alien_huh.png";
menutoolbarimageId[58] = "Alienhu";
menutoolbarimagePosition[58] = "Fin";

menutoolbardébut[59] = "{{Alien|KO}}";
menutoolbarfin[59] = "";
menutoolbarcomm[59] = "KO !";
menutoolbarimage[59] = "http://upload.wikimedia.org/wikipedia/commons/a/a3/Smilies_Alien_KO.png";
menutoolbarimageId[59] = "AlienKO";
menutoolbarimagePosition[59] = "Fin";

menutoolbardébut[60] = "{{Alien|mal}}";
menutoolbarfin[60] = "";
menutoolbarcomm[60] = "Malade !";
menutoolbarimage[60] = "http://upload.wikimedia.org/wikipedia/commons/3/3d/Smilies_Alien_sick.png";
menutoolbarimageId[60] = "Alien_mal";
menutoolbarimagePosition[60] = "Fin";

menutoolbardébut[61] = "{{Alien|mdr}}";
menutoolbarfin[61] = "";
menutoolbarcomm[61] = "Mort de rire !";
menutoolbarimage[61] = "http://upload.wikimedia.org/wikipedia/commons/5/51/Smilies_Alien_green.png";
menutoolbarimageId[61] = "Alienmdr";
menutoolbarimagePosition[61] = "Fin";

menutoolbardébut[62] = "{{Alien|ouin}}";
menutoolbarfin[62] = "";
menutoolbarcomm[62] = "Ouin !";
menutoolbarimage[62] = "http://upload.wikimedia.org/wikipedia/commons/b/bd/Smilies_Alien_weap.png";
menutoolbarimageId[62] = "Alienouin";
menutoolbarimagePosition[62] = "Fin";

menutoolbardébut[63] = "{{Alien|plr}}";
menutoolbarfin[63] = "";
menutoolbarcomm[63] = "Pleure !";
menutoolbarimage[63] = "http://upload.wikimedia.org/wikipedia/commons/1/1c/Smilies_Alien_cry.png";
menutoolbarimageId[63] = "Alienplr";
menutoolbarimagePosition[63] = "Fin";

menutoolbardébut[64] = "{{Alien|qu}}";
menutoolbarfin[64] = "";
menutoolbarcomm[64] = "Questionnement !";
menutoolbarimage[64] = "http://upload.wikimedia.org/wikipedia/commons/c/cb/Smilies_Alien_whatface.png";
menutoolbarimageId[64] = "Alienqu";
menutoolbarimagePosition[64] = "Fin";

menutoolbardébut[65] = "{{Alien|rire}}";
menutoolbarfin[65] = "";
menutoolbarcomm[65] = "Rire !";
menutoolbarimage[65] = "http://upload.wikimedia.org/wikipedia/commons/3/3a/Smilies_Alien_doof.png";
menutoolbarimageId[65] = "Alienrire";
menutoolbarimagePosition[65] = "Fin";

menutoolbardébut[66] = "{{Alien|tris}}";
menutoolbarfin[66] = "";
menutoolbarcomm[66] = "Triste !";
menutoolbarimage[66] = "http://upload.wikimedia.org/wikipedia/commons/d/d4/Smilies_Alien_sad.png";
menutoolbarimageId[66] = "Alientris";
menutoolbarimagePosition[66] = "Fin";

menutoolbardébut[67] = "{{Alien|wow}}";
menutoolbarfin[67] = "";
menutoolbarcomm[67] = "Whouaou !";
menutoolbarimage[67] = "http://upload.wikimedia.org/wikipedia/commons/3/35/Smilies_Alien_whaaa.png";
menutoolbarimageId[67] = "Alienwow";
menutoolbarimagePosition[67] = "Fin";

menutoolbardébut[68] = "{{Alien|yx}}";
menutoolbarfin[68] = "";
menutoolbarcomm[68] = "Gros yeux !";
menutoolbarimage[68] = "http://upload.wikimedia.org/wikipedia/commons/0/06/Smilies_Alien_big_eyes.png";
menutoolbarimageId[68] = "Alienyx";
menutoolbarimagePosition[68] = "Fin";

menutoolbardébut[69] = "~" + "~~";
menutoolbarfin[69] = "";
menutoolbarcomm[69] = "Signature";
menutoolbarimage[69] = "http://upload.wikimedia.org/wikipedia/commons/6/6d/Button_sig.png";
menutoolbarimageId[69] = "signature";
menutoolbarimagePosition[69] = "Fin";

menutoolbardébut[70] = "~~"+ "~~";
menutoolbarfin[70] = "";
menutoolbarcomm[70] = "Signature et date";
menutoolbarimage[70] = "http://upload.wikimedia.org/wikipedia/commons/d/d1/Button_mysignature.png";
menutoolbarimageId[70] = "signaturedate";
menutoolbarimagePosition[70] = "Fin";

menutoolbardébut[71] = "~" + "~~" + "~~";
menutoolbarfin[71] = "";
menutoolbarcomm[71] = "Date";
menutoolbarimage[71] = "http://upload.wikimedia.org/wikipedia/commons/3/3f/Button_attendre.png";
menutoolbarimageId[71] = "date";
menutoolbarimagePosition[71] = "Fin";
*/
//////////////////////////////////////////////////////////////////// Menu  CHARINSERT ( = [[MediaWiki:Edittools]] )
/************************************************************************************************************************************
 *   Pour ajouter un symbole, créer deux instances supplémentaires comme expliqué ci-dessous                                        *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).                                                           *
 *   Attention, les symboles HTML ou assimilés (div, span, nowiki, includeonly, noinclude, etc...) ne sont pas toujours permis .    *
 *   Utiliser le lien "Inserer une balise" pour insérer ceux-là.                                                                    *
 *                                                                                                                                  *
 * menutoolbardébut[X] = "";    // Code inséré avant la sélection. Les espaces, les apostrophes ou les guillemets sont autorisés    *
 * menutoolbarfin[X] = "";      // Code inséré après la sélection                                                                   *
 *                                                                                                                                  *
 *   Si les deux variables sont vides, insertion d'une ligne horizontale.                                                           *
 *                                                                                                                                  *
 ************************************************************************************************************************************/
menucharinsertdébut = new Array;
menucharinsertfin = new Array;
 

menucharinsertdébut[0]= "æ"
menucharinsertfin[0]= ""
menucharinsertdébut[1]= "Æ"
menucharinsertfin[1]= ""
menucharinsertdébut[2]= "à"
menucharinsertfin[2]= ""
menucharinsertdébut[3]= "À"
menucharinsertfin[3]= ""
menucharinsertdébut[4]= "â"
menucharinsertfin[4]= ""
menucharinsertdébut[5]= "Â"
menucharinsertfin[5]= ""
menucharinsertdébut[6]= "ä"
menucharinsertfin[6]= ""
menucharinsertdébut[7]= "Ä"
menucharinsertfin[7]= ""
menucharinsertdébut[8]= "ç"
menucharinsertfin[8]= ""
menucharinsertdébut[9]= "Ç"
menucharinsertfin[9]= ""
menucharinsertdébut[10]= "é"
menucharinsertfin[10]= ""
menucharinsertdébut[11]= "É"
menucharinsertfin[11]= ""
menucharinsertdébut[12]= "è"
menucharinsertfin[12]= ""
menucharinsertdébut[13]= "È"
menucharinsertfin[13]= ""
menucharinsertdébut[14]= "ê"
menucharinsertfin[14]= ""
menucharinsertdébut[15]= "Ê"
menucharinsertfin[15]= ""
menucharinsertdébut[16]= "ë"
menucharinsertfin[16]= ""
menucharinsertdébut[17]= "Ë"
menucharinsertfin[17]= ""
menucharinsertdébut[18]= "î"
menucharinsertfin[18]= ""
menucharinsertdébut[19]= "Î"
menucharinsertfin[19]= ""
menucharinsertdébut[20]= "ï"
menucharinsertfin[20]= ""
menucharinsertdébut[21]= "Ï"
menucharinsertfin[21]= ""
menucharinsertdébut[22]= "œ"
menucharinsertfin[22]= ""
menucharinsertdébut[23]= "Œ"
menucharinsertfin[23]= ""
menucharinsertdébut[24]= "ô"
menucharinsertfin[24]= ""
menucharinsertdébut[25]= "Ô"
menucharinsertfin[25]= ""
menucharinsertdébut[26]= "ö"
menucharinsertfin[26]= ""
menucharinsertdébut[27]= "Ö"
menucharinsertfin[27]= ""
menucharinsertdébut[28]= "ù"
menucharinsertfin[28]= ""
menucharinsertdébut[29]= "Ù"
menucharinsertfin[29]= ""
menucharinsertdébut[30]= "û"
menucharinsertfin[30]= ""
menucharinsertdébut[31]= "Û"
menucharinsertfin[31]= ""
menucharinsertdébut[32]= "ü"
menucharinsertfin[32]= ""
menucharinsertdébut[33]= "Ü"
menucharinsertfin[33]= ""
menucharinsertdébut[34]= "ÿ"
menucharinsertfin[34]= ""
menucharinsertdébut[35]= "Ÿ"
menucharinsertfin[35]= ""
menucharinsertdébut[36]= "—"
menucharinsertfin[36]= ""
menucharinsertdébut[37]= "–"
menucharinsertfin[37]= ""
menucharinsertdébut[38]= "•"
menucharinsertfin[38]= ""
menucharinsertdébut[39]= "’"
menucharinsertfin[39]= ""
menucharinsertdébut[40]= "« "
menucharinsertfin[40]= " »"
menucharinsertdébut[41]= "“"
menucharinsertfin[41]= "”"
menucharinsertdébut[42]= "|"
menucharinsertfin[42]= ""
menucharinsertdébut[43]= "…"
menucharinsertfin[43]= ""
menucharinsertdébut[44]= "~"
menucharinsertfin[44]= ""
menucharinsertdébut[45]= "#"
menucharinsertfin[45]= ""
menucharinsertdébut[46]= "@"
menucharinsertfin[46]= ""
menucharinsertdébut[47]= "€"
menucharinsertfin[47]= ""
menucharinsertdébut[48]= "¹"
menucharinsertfin[48]= ""
menucharinsertdébut[49]= "²"
menucharinsertfin[49]= ""
menucharinsertdébut[50]= "³"
menucharinsertfin[50]= ""
menucharinsertdébut[51]= "⁴"
menucharinsertfin[51]= ""
menucharinsertdébut[52]= "⁵"
menucharinsertfin[52]= ""
menucharinsertdébut[53]= "⁶"
menucharinsertfin[53]= ""
menucharinsertdébut[54]= "⁷"
menucharinsertfin[54]= ""
menucharinsertdébut[55]= "⁸"
menucharinsertfin[55]= ""
menucharinsertdébut[56]= "⁹"
menucharinsertfin[56]= ""
menucharinsertdébut[57]= "⁰"
menucharinsertfin[57]= ""
menucharinsertdébut[58]= "½"
menucharinsertfin[58]= ""
menucharinsertdébut[59]= "¼"
menucharinsertfin[59]= ""
menucharinsertdébut[60]= "¾"
menucharinsertfin[60]= ""
menucharinsertdébut[61]= "‰"
menucharinsertfin[61]= ""

menucharinsertdébut[62]= ""
menucharinsertfin[62]= ""
menucharinsertdébut[63]= "{{"
menucharinsertfin[63]= "}}"
menucharinsertdébut[64]= "{{|"
menucharinsertfin[64]= "}}"
menucharinsertdébut[65]= "[["
menucharinsertfin[65]= "]]"
menucharinsertdébut[66]= "[[|"
menucharinsertfin[66]= "]]"
menucharinsertdébut[67]= "["
menucharinsertfin[67]= "]"
menucharinsertdébut[68]= "{{subst:"
menucharinsertfin[68]= "}}"
menucharinsertdébut[69]= "{{m|"
menucharinsertfin[69]= "}}"
menucharinsertdébut[70]= "{{a|"
menucharinsertfin[70]= "}}"
menucharinsertdébut[71]= "{{u|"
menucharinsertfin[71]= "}}"
menucharinsertdébut[72]= "{{DEFAULTSORT:"
menucharinsertfin[72]= "}}"
menucharinsertdébut[73]= "[[Catégorie:"
menucharinsertfin[73]= "]]"
menucharinsertdébut[74]= "[[Image:"
menucharinsertfin[74]= "]]"
menucharinsertdébut[75]= "#REDIRECTION[["
menucharinsertfin[75]= "]]"
menucharinsertdébut[76]= "[[Commons:"
menucharinsertfin[76]= "|]]"
menucharinsertdébut[77]= "[[m:"
menucharinsertfin[77]= "|]]"
menucharinsertdébut[78]= "[[n:"
menucharinsertfin[78]= "|]]"
menucharinsertdébut[79]= "[[q:"
menucharinsertfin[79]= "|]]"
menucharinsertdébut[80]= "[[s:"
menucharinsertfin[80]= "|]]"
menucharinsertdébut[81]= "[[b:"
menucharinsertfin[81]= "|]]"
menucharinsertdébut[82]= "[[wikt:"
menucharinsertfin[82]= "|]]"
menucharinsertdébut[83]= "[[v:"
menucharinsertfin[83]= "|]]"
menucharinsertdébut[84]= "{{Références|colonnes="
menucharinsertfin[84]= "}}"

menucharinsertdébut[85]= ""
menucharinsertfin[85]= ""
menucharinsertdébut[86]= "{{#if:"
menucharinsertfin[86]= "}}"
menucharinsertdébut[87]= "{{#ifeq:"
menucharinsertfin[87]= "}}"
menucharinsertdébut[88]= "{{#ifexist:"
menucharinsertfin[88]= "}}"
menucharinsertdébut[89]= "{{#ifexpr:"
menucharinsertfin[89]= "}}"
menucharinsertdébut[90]= "{{#switch:"
menucharinsertfin[90]= "}}"
menucharinsertdébut[91]= "{{#iferror:"
menucharinsertfin[91]= "}}"
menucharinsertdébut[92]= "{{#expr:"
menucharinsertfin[92]= "}}"
menucharinsertdébut[93]= "{{#time:"
menucharinsertfin[93]= "}}"
menucharinsertdébut[94]= "{{#language:"
menucharinsertfin[94]= "}}"
menucharinsertdébut[95]= "{{formatnum:"
menucharinsertfin[95]= "}}"
menucharinsertdébut[96]= "{{lc:"
menucharinsertfin[96]= "}}"
menucharinsertdébut[97]= "{{lcfirst:"
menucharinsertfin[97]= "}}"
menucharinsertdébut[98]= "{{padleft:"
menucharinsertfin[98]= "}}"
menucharinsertdébut[99]= "{{padright:"
menucharinsertfin[99]= "}}"
menucharinsertdébut[100]= "{{uc:"
menucharinsertfin[100]= "}}"
menucharinsertdébut[101]= "{{ucfirst:"
menucharinsertfin[101]= "}}"
menucharinsertdébut[102]= "{{anchorencode"
menucharinsertfin[102]= "}}"
menucharinsertdébut[103]= "{{fullurl"
menucharinsertfin[103]= "}}"
menucharinsertdébut[104]= "{{localurl:"
menucharinsertfin[104]= "}}"
menucharinsertdébut[105]= "{{ns:"
menucharinsertfin[105]= "}}"
menucharinsertdébut[106]= "{{urlencode:"
menucharinsertfin[106]= "}}"
menucharinsertdébut[107]= "{{#rel2abs:"
menucharinsertfin[107]= "}}"
menucharinsertdébut[108]= "{{#titleparts:"
menucharinsertfin[108]= "}}"
menucharinsertdébut[109]= "{{#tag:"
menucharinsertfin[109]= "}}"

menucharinsertdébut[110]= ""
menucharinsertfin[110]= ""
menucharinsertdébut[111]= "{{PAGENAME}}"
menucharinsertfin[111]= ""
menucharinsertdébut[112]= "{{SUBPAGENAME}}"
menucharinsertfin[112]= ""
menucharinsertdébut[113]= "{{BASEPAGENAME}}"
menucharinsertfin[113]= ""
menucharinsertdébut[114]= "{{FULLPAGENAME}}"
menucharinsertfin[114]= ""
menucharinsertdébut[115]= "{{TALKPAGENAME}}"
menucharinsertfin[115]= ""
menucharinsertdébut[116]= "{{SUBJECTPAGENAME}}"
menucharinsertfin[116]= ""
menucharinsertdébut[117]= "{{ARTICLEPAGENAME}}"
menucharinsertfin[117]= ""
menucharinsertdébut[118]= "{{NAMESPACE}}"
menucharinsertfin[118]= ""
menucharinsertdébut[119]= "{{TALKSPACE}}"
menucharinsertfin[119]= ""
menucharinsertdébut[120]= "{{SUBJECTSPACE}}"
menucharinsertfin[120]= ""
menucharinsertdébut[121]= "{{ARTICLESPACE}}"
menucharinsertfin[121]= ""
menucharinsertdébut[122]= "{{REVISIONID}}"
menucharinsertfin[122]= ""
menucharinsertdébut[123]= "{{REVISIONDAY}}"
menucharinsertfin[123]= ""
menucharinsertdébut[124]= "{{REVISIONMONTH}}"
menucharinsertfin[124]= ""
menucharinsertdébut[125]= "{{REVISIONYEAR}}"
menucharinsertfin[125]= ""

/*
menucharinsertdébut[126]= ""
menucharinsertfin[126]= ""
menucharinsertdébut[127]= ""
menucharinsertfin[127]= ""
menucharinsertdébut[128]= ""
menucharinsertfin[128]= "" 
menucharinsertdébut[129]= ""
menucharinsertfin[129]= ""
menucharinsertdébut[130]= ""
menucharinsertfin[130]= ""
menucharinsertdébut[131]= ""
menucharinsertfin[131]= ""
menucharinsertdébut[132]= ""
menucharinsertfin[132]= "" 
menucharinsertdébut[133]= ""
menucharinsertfin[133]= ""
menucharinsertdébut[134]= ""
menucharinsertfin[134]= ""
menucharinsertdébut[135]= ""
menucharinsertfin[135]= ""
menucharinsertdébut[136]= ""
menucharinsertfin[136]= ""
menucharinsertdébut[137]= ""
menucharinsertfin[137]= ""
menucharinsertdébut[138]= ""
menucharinsertfin[138]= ""
menucharinsertdébut[139]= ""
menucharinsertfin[139]= ""             
*/

//////////////////////////////////////////////////////////////////// Résumés de modification
/********************************************************************************
 *   Pour ajouter un résumé, créer simplement une instance supplémentaire       *
 *   Il ne doit pas y avoir de "trou" dans la liste (qui commence par 0).       *
 *   A priori, tous les symboles sont autorisés .                               * 
 ********************************************************************************/
menuresumetexte = new Array();


menuresumetexte[0]="orthographe";
menuresumetexte[1]="typographie";
menuresumetexte[2]="catégorisation";
menuresumetexte[3]="interwiki";
menuresumetexte[4]="wikification";
menuresumetexte[5]="image";
menuresumetexte[6]="mise en page";
menuresumetexte[7]="redirection";
menuresumetexte[8]="relecture";
menuresumetexte[9]="style";
menuresumetexte[10]="revert";
menuresumetexte[11]="réorganisation";
menuresumetexte[12]="réponse";
menuresumetexte[13]="maintenance";
menuresumetexte[14]="évaluation Wikipédia 1.0";
menuresumetexte[15]="création homonymie";
menuresumetexte[16]="ajout de bandeau";
menuresumetexte[17]="infobox";
menuresumetexte[18]="références";
menuresumetexte[19]="retouche de la modification précédente";


///////////////////// ////////////////////////// /////////////////////////// //////////////////// FIN PARTIE PERSONNALISABLE /////// /////// //////// /////// /////// /////// /////// ///////

// * * * Test Navigateur * * * 
//Emprunté ici :( http://javascript.developpez.com/sources/?page=tips#browserdetect )

// convert all characters to lowercase to simplify testing
    var agt=navigator.userAgent.toLowerCase();

    // *** BROWSER VERSION ***
    // Note: On IE5, these return 4, so use is_ie5up to detect IE5.
    var is_major = parseInt(navigator.appVersion);
    var is_minor = parseFloat(navigator.appVersion);

    // Note: Opera and WebTV spoof Navigator.  We do strict client detection.
    // If you want to allow spoofing, take out the tests for opera and webtv.
    var is_nav     = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1) && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
    var is_nav2    = (is_nav && (is_major == 2));
    var is_nav3    = (is_nav && (is_major == 3));
    var is_nav4    = (is_nav && (is_major == 4));
    var is_nav4up  = (is_nav && (is_major >= 4));
    var is_navonly = (is_nav && ((agt.indexOf(";nav") != -1) || (agt.indexOf("; nav") != -1)) );
    var is_nav6    = (is_nav && (is_major == 5));
    var is_nav6up  = (is_nav && (is_major >= 5));
    var is_gecko   = (agt.indexOf('gecko') != -1);
    var is_ie      = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
    var is_ie3     = (is_ie && (is_major < 4));
    var is_ie4     = (is_ie && (is_major == 4) && (agt.indexOf("msie 4")!=-1) );
    var is_ie4up   = (is_ie && (is_major >= 4));
    var is_ie5     = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.0")!=-1) );
    var is_ie5_5   = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.5") !=-1));
    var is_ie5up   = (is_ie && !is_ie3 && !is_ie4);
    var is_ie5_5up = (is_ie && !is_ie3 && !is_ie4 && !is_ie5);
    var is_ie6     = (is_ie && (is_major == 4) && (agt.indexOf("msie 6.")!=-1) );
    var is_ie6up   = (is_ie && !is_ie3 && !is_ie4 && !is_ie5 && !is_ie5_5);

// * * * Récupération des paramètres d'affichage si ils ont été modifiés * * *
// * * Sinon, définition des paramètres par défaut * *

// * Mode plein écran *

var PleinEcranCookie = getCookie("ClicDroitPleinEcran");
if ((PleinEcranCookie == "") || (PleinEcranCookie == null) || (PleinEcranCookie != "PleinEcran")){
        var PleinEcran = false;
}else{
        var PleinEcran = true;
}

// * Styles *

var ClicDroitTColorCookie = getCookie("ClicDroitTColor");
if ((ClicDroitTColorCookie != "") && (ClicDroitTColorCookie != null)){
        var colorT = "#" + ClicDroitTColorCookie ;
}else{
        var colorT = "#9D9DA1";
}
var ClicDroitTtColorCookie = getCookie("ClicDroitTtColor");
if ((ClicDroitTtColorCookie != "") && (ClicDroitTtColorCookie != null)){
        var colorTt = "#" + ClicDroitTtColorCookie ;
}else{
        var colorTt = "#112233";
}
var ClicDroitbgColorCookie = getCookie("ClicDroitbgColor");
if ((ClicDroitbgColorCookie != "") && (ClicDroitbgColorCookie != null)){
        var colorbg = "#" + ClicDroitbgColorCookie ;
}else{
        var colorbg = "#CCCCCC";
}
var ClicDroitMDColorCookie = getCookie("ClicDroitMDColor");
if ((ClicDroitMDColorCookie != "") && (ClicDroitMDColorCookie != null)){
        var colorMD = "#" + ClicDroitMDColorCookie ;
}else{
        var colorMD = "#DDDDDD";
}
var ClicDroitbdColorCookie = getCookie("ClicDroitbdColor");
if ((ClicDroitbdColorCookie != "") && (ClicDroitbdColorCookie != null)){
        var colorbd = "#" + ClicDroitbdColorCookie ;
}else{
        var colorbd = "#000000";
}
var ClicDroitselColorCookie = getCookie("ClicDroitselColor");
if ((ClicDroitselColorCookie != "") && (ClicDroitselColorCookie != null)){
        var colorsel = "#" + ClicDroitselColorCookie ;
}else{
        var colorsel = "#EEEEEE";
} 
var ClicDroitLineColorCookie = getCookie("ClicDroitLineColor");
if ((ClicDroitLineColorCookie != "") && (ClicDroitLineColorCookie != null)){
        var colorLine = "#" + ClicDroitLineColorCookie ;
}else{
        var colorLine = "#1D1D11";
}
var ClicDroitlienColorCookie = getCookie("ClicDroitlienColor");
if ((ClicDroitlienColorCookie != "") && (ClicDroitlienColorCookie != null)){
        var colorlien = "#" + ClicDroitlienColorCookie ;
}else{
        var colorlien = "#0000FF";
}

var ClicDroitBaseTailleCookie = getCookie("ClicDroitBaseTaille");
if ((ClicDroitBaseTailleCookie != "") && (ClicDroitBaseTailleCookie != null)){
        var tailleBase = ClicDroitBaseTailleCookie ;
}else{
        var tailleBase = 100;
}

var ClicDroitbgTailleCookie = getCookie("ClicDroitbgTaille");
if ((ClicDroitbgTailleCookie != "") && (ClicDroitbgTailleCookie != null)){
        var taillebg = ClicDroitbgTailleCookie ;
}else{
        var taillebg = 160;
}
var ClicDroitListeTailleCookie = getCookie("ClicDroitListeTaille");
if ((ClicDroitListeTailleCookie != "") && (ClicDroitListeTailleCookie != null)){
        var TailleListe = ClicDroitListeTailleCookie ;
}else{
        var TailleListe = 300;
}
var ClicDroitModifTailleCookie = getCookie("ClicDroitModifTaille");
if ((ClicDroitModifTailleCookie != "") && (ClicDroitModifTailleCookie != null)){
        var TailleModif = ClicDroitModifTailleCookie ;
}else{
        var TailleModif = 260;
}
var ClicDroitPublierTailleCookie = getCookie("ClicDroitPublierTaille");
if ((ClicDroitModifTailleCookie != "") && (ClicDroitPublierTailleCookie != null)){
        var TaillePublier = ClicDroitPublierTailleCookie ;
}else{
        var TaillePublier = 385;
}
var ClicDroitOptionsTailleCookie = getCookie("ClicDroitOptionsTaille");
if ((ClicDroitOptionsTailleCookie != "") && (ClicDroitOptionsTailleCookie != null)){
        var TailleOptions = ClicDroitListeTailleCookie ;
}else{
        var TailleOptions = 250;
}

var ClicDroitTitreTailleCookie = getCookie("ClicDroitTitreTaille");
if ((ClicDroitTitreTailleCookie != "") && (ClicDroitTitreTailleCookie != null)){
        var tailleTitre = ClicDroitTitreTailleCookie ;
}else{
        var tailleTitre = 12;
}
var ClicDroitfontTailleCookie = getCookie("ClicDroitfontTaille");
if ((ClicDroitfontTailleCookie != "") && (ClicDroitfontTailleCookie != null)){
        var taillefont = ClicDroitfontTailleCookie ;
}else{
        var taillefont = 10;
}
var ClicDroitbdTailleCookie = getCookie("ClicDroitbdTaille");
if ((ClicDroitbdTailleCookie != "") && (ClicDroitbdTailleCookie != null)){
        var Taillebd = ClicDroitbdTailleCookie ;
}else{
        var Taillebd = 1;
}

var ClicDroitStylebdCookie = getCookie("ClicDroitStylebd");
if ((ClicDroitStylebdCookie != "") && (ClicDroitStylebdCookie != null)){
        var Stylebd = ClicDroitStylebdCookie ;
}else{
        var Stylebd = "solid";
}

var ClicDroitpoliceCookie = getCookie("ClicDroitStylepolice");
if ((ClicDroitpoliceCookie != "") && (ClicDroitpoliceCookie != null)){
        var police = ClicDroitpoliceCookie ;
}else{
        var police = "Verdana";
}
var ClicDroitOpacityCookie = getCookie("ClicDroitOpacity");
if ((ClicDroitOpacityCookie != "") && (ClicDroitOpacityCookie != null)){
        var Opacity = ClicDroitOpacityCookie ;
}else{
        var Opacity = 0.90;
}

/* Arrondis */

if((is_gecko)||(is_nav6up)){
        var ClicDroitArrondiCookie = getCookie("ClicDroitArrondi");
        if ((ClicDroitArrondiCookie != "") && (ClicDroitArrondiCookie != null)){
                var Arrondi = ClicDroitArrondiCookie ;
        }else{
                var Arrondi = 0.8;
        }
}

// * Position des menus *

var Marge = 10;
var MargeTop = 40;
var MargeLeft = 160;

var NavigX= MargeLeft;
var OptionX= ((taillebg+Marge)+MargeLeft) ;
var EditX= ((taillebg+Marge)+(TailleOptions+Marge)+MargeLeft);
var PublierX= ((taillebg+Marge)+(TailleOptions+Marge)+(TailleModif+Marge)+MargeLeft); 

var ClicDroitPositionMenuBaseXCookie = getCookie("ClicDroitPositionMenuBaseX");
if ((ClicDroitPositionMenuBaseXCookie != "") && (ClicDroitPositionMenuBaseXCookie != null)){
        var DefaultPosMenuBaseX = ClicDroitPositionMenuBaseXCookie ;
}else{
        var DefaultPosMenuBaseX= MargeLeft;
}
var ClicDroitPositionMenuBaseYCookie = getCookie("ClicDroitPositionMenuBaseY");
if ((ClicDroitPositionMenuBaseYCookie != "") && (ClicDroitPositionMenuBaseYCookie != null)){
        var DefaultPosMenuBaseY = ClicDroitPositionMenuBaseYCookie ;
}else{
        var DefaultPosMenuBaseY= MargeTop;
}

var ClicDroitPositionMenuNavigXCookie = getCookie("ClicDroitPositionMenuNavigX");
if ((ClicDroitPositionMenuNavigXCookie != "") && (ClicDroitPositionMenuNavigXCookie != null)){
        var DefaultPosMenuNavigX = ClicDroitPositionMenuNavigXCookie ;
}else{
        var DefaultPosMenuNavigX= NavigX;
}
var ClicDroitPositionMenuNavigYCookie = getCookie("ClicDroitPositionMenuNavigY");
if ((ClicDroitPositionMenuNavigYCookie != "") && (ClicDroitPositionMenuNavigYCookie != null)){
        var DefaultPosMenuNavigY = ClicDroitPositionMenuNavigYCookie ;
}else{
        var DefaultPosMenuNavigY= MargeTop;
}var ClicDroitPositionMenuOptionXCookie = getCookie("ClicDroitPositionMenuOptionX");
if ((ClicDroitPositionMenuOptionXCookie != "") && (ClicDroitPositionMenuOptionXCookie != null)){
        var DefaultPosMenuOptionX = ClicDroitPositionMenuOptionXCookie ;
}else{
        var DefaultPosMenuOptionX= OptionX;
}
var ClicDroitPositionMenuOptionYCookie = getCookie("ClicDroitPositionMenuOptionY");
if ((ClicDroitPositionMenuOptionYCookie != "") && (ClicDroitPositionMenuOptionYCookie != null)){
        var DefaultPosMenuOptionY = ClicDroitPositionMenuOptionYCookie ;
}else{
        var DefaultPosMenuOptionY= MargeTop;
}
var ClicDroitPositionMenuEditXCookie = getCookie("ClicDroitPositionMenuEditX");
if ((ClicDroitPositionMenuEditXCookie != "") && (ClicDroitPositionMenuEditXCookie != null)){
        var DefaultPosMenuEditX = ClicDroitPositionMenuEditXCookie ;
}else{
        var DefaultPosMenuEditX= EditX;
}
var ClicDroitPositionMenuEditYCookie = getCookie("ClicDroitPositionMenuEditY");
if ((ClicDroitPositionMenuEditYCookie != "") && (ClicDroitPositionMenuEditYCookie != null)){
        var DefaultPosMenuEditY = ClicDroitPositionMenuEditYCookie ;
}else{
        var DefaultPosMenuEditY= MargeTop;
}
var ClicDroitPositionMenuPublierXCookie = getCookie("ClicDroitPositionMenuPublierX");
if ((ClicDroitPositionMenuPublierXCookie != "") && (ClicDroitPositionMenuPublierXCookie != null)){
        var DefaultPosMenuPublierX = ClicDroitPositionMenuPublierXCookie ;
}else{
        var DefaultPosMenuPublierX= PublierX; 
}
var ClicDroitPositionMenuPublierYCookie = getCookie("ClicDroitPositionMenuPublierY");
if ((ClicDroitPositionMenuPublierYCookie != "") && (ClicDroitPositionMenuPublierYCookie != null)){
        var DefaultPosMenuPublierY = ClicDroitPositionMenuPublierYCookie ;
}else{
        var DefaultPosMenuPublierY= MargeTop;
}

// * État des menus *

var ClicDroitVisibleMenuBaseCookie = getCookie("ClicDroitVisibleMenuBase"); 
if ((ClicDroitVisibleMenuBaseCookie == "") || (ClicDroitVisibleMenuBaseCookie == null) || (ClicDroitVisibleMenuBaseCookie != "visible")){
        var DefaultVisibleMenuBase = "hidden";
}else {
        var DefaultVisibleMenuBase = "visible";
}
var ClicDroitVisibleMenuOptionCookie = getCookie("ClicDroitVisibleMenuOption"); 
if ((ClicDroitVisibleMenuOptionCookie == "") || (ClicDroitVisibleMenuOptionCookie == null) || (ClicDroitVisibleMenuOptionCookie != "visible")){
        var DefaultVisibleMenuOption = "hidden";
}else {
        var DefaultVisibleMenuOption = "visible";
}
var ClicDroitVisibleMenuNavigCookie = getCookie("ClicDroitVisibleMenuNavig"); 
if ((ClicDroitVisibleMenuNavigCookie == "") || (ClicDroitVisibleMenuNavigCookie == null) || (ClicDroitVisibleMenuNavigCookie != "visible")){
        var DefaultVisibleMenuNavig = "hidden";
}else {
        var DefaultVisibleMenuNavig = "visible";
}
var ClicDroitVisibleMenuEditCookie = getCookie("ClicDroitVisibleMenuEdit"); 
if ((ClicDroitVisibleMenuEditCookie == "") || (ClicDroitVisibleMenuEditCookie == null) || (ClicDroitVisibleMenuEditCookie != "visible")){
        var DefaultVisibleMenuEdit = "hidden";
}else {
        var DefaultVisibleMenuEdit = "visible";
}
var ClicDroitVisibleMenuPublierCookie = getCookie("ClicDroitVisibleMenuPublier"); 
if ((ClicDroitVisibleMenuPublierCookie == "") || (ClicDroitVisibleMenuPublierCookie == null) || (ClicDroitVisibleMenuPublierCookie != "visible")){
        var DefaultVisibleMenuPublier = "hidden";
}else {
        var DefaultVisibleMenuPublier = "visible";
}

// * * * STYLES  * * *

// * * Style Plein écran * *
if(PleinEcran==true){
document.write('<style type="text/css">'
+'#mw_contentwrapper{margin-left: 0em !important;}'
+'#mw_content{margin: 0 0 0 0 !important;}'
+'#page-base{height:0em !important;}'
+'#content{margin: 0 0 0 0 !important;}'
+'#column-content{margin: 0 0 0 0 !important;}'
+'#article{margin-left:4px;margin-right:4px;}'
+'</style>');
}

// * * Style Zone de modif * *

document.write('<style type="text/css">'
+'#wpTextbox1{margin:0;margin-right:1em;margin-bottom:0.5em;border:3px double #881111;background-color:white;}'
+'#wpSummary{width:97% !important;}'
+'.editOptions{background-color:transparent;border:none;padding:0.5em;}'
+'</style>');

// * * Style pour les menus * *

if(is_ie6up){     
          document.write('<style type="text/css">'
          + '#menu_context hr{ display:none; }'      // Pas de lignes horizontales pour IE
          + '#menu_favoris hr{ display:none; }'      // ça donne des menus beaucoup trop longs 
          + '#menu_charinsert hr{ display:none; }'   // c'est mon avis.
          + '#menu_Publier hr{ display:none; }'
          + '#menu_options hr{ display:none; }'      // Chacun est libre de les remettre.
          + '</style>'); 
}else{
          document.write('<style type="text/css">'
          + '#menu_context hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+';  }'
          + '#menu_favoris hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+'; }'
          + '#menu_charinsert hr{ margin: .1em 0.1em .1em 0.1em;background-color:'+ colorLine+';  }'
          + '#menu_Publier hr{ margin: .1em 0.1em .1em 0.1em;background-color:'+ colorLine+';  }'
          + '#menu_options hr{ margin: .1em 0.1em .1em 0.1em ;background-color:'+ colorLine+';  }'
          + '</style>');

          if((is_gecko)||(is_nav6up)){  
                    document.write('<style type="text/css">'
                    + '#menu_base { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_context { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_favoris { -moz-border-radius:'+ Arrondi+'em; }'
                    + '#menu_charinsert { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_Publier { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_options { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_base div { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_context div { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_favoris div { -moz-border-radius:'+ Arrondi+'em; }'
                    + '#menu_charinsert div { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_Publier div { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '#menu_options div { -moz-border-radius:'+ Arrondi+'em;  }'
                    + '</style>');
          }
}

// * * Style pour la zone de suggestions (recherche) *****

document.write('<style type="text/css">'
+ '#searchInput2Suggest{ z-index:600;}'
+ '</style>');

// * * Ajustement de la position du menu Édition suivant le skin et le mode d'affichage * *

if(PleinEcran==true){
          if(skin=="monobook"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="vector"){ 
                    var Decalx = 20;
                    var Decaly = 63;
          }else if(skin=="modern"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="cologneblue"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="chick"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="simple"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="nostalgia"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="standard"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="myskin"){
                    var Decalx = 5;
                    var Decaly = 0;
          }
}else{
          if(skin=="monobook"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="vector"){ 
                    var Decalx = 180;
                    var Decaly = 143;
          }else if(skin=="modern"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="cologneblue"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="chick"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="simple"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="nostalgia"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="standard"){
                    var Decalx = 5;
                    var Decaly = 0;
          }else if(skin=="myskin"){
                    var Decalx = 5;
                    var Decaly = 0;
          }
}

// * * * FONCTIONS * * *

// * Suppression d'un élément *

function supprimerElement(OldElement){
          if(!OldElement)return;
          if(is_nav4up){   //Firefox
                    if(OldElement.parentNode){document=OldElement.parentNode.removeChild(OldElement);}
          }else {
                    if(is_ie6up){  // Internet Explorer
                              OldElement.removeNode(true);
                    }
          }
}

// * Calcul position de la souris + déplacement du menu *

clickOuiBase = false;
clickOuiNavig = false;
clickOuiOption = false;
clickOuiEdit = false;
clickOuiPublier = false;

base_x_Base = (tailleBase/2);
base_y_Base = (tailleTitre*12);
base_x_Navig = (taillebg/2);
base_y_Navig = (tailleTitre*12);
base_x_Fav = -20;
base_y_Fav = (tailleTitre*12);
base_x_Option = (TailleOptions/2);
base_y_Option = (tailleTitre*12);
base_x_Edit = (TailleModif/2);
base_y_Edit = (tailleTitre*12);
base_x_Publier = (TaillePublier/2);
base_y_Publier = (tailleTitre*12);

function position(e){

// Calcul position de la souris

          if(e){
                    position_x = (e.screenX+document.body.scrollLeft);
                    position_y = (e.screenY+document.body.scrollTop);
          }else{
                    position_x = "" + (window.event.screenX+document.body.scrollLeft);
                    position_y = "" + (window.event.screenY+document.body.scrollTop);
          }
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );

// Déplacement menu de base

          if(clickOuiBase && document.getElementById){
                    blocBase_x = position_x-base_x_Base;
                    blocBase_y = position_y-base_y_Base;
                    setCookie("ClicDroitPositionMenuBaseX",blocBase_x,nextYear);
                    setCookie("ClicDroitPositionMenuBaseY",blocBase_y,nextYear);
                    var Menu_Base = document.getElementById("menu_base");
                    if(is_nav4up){
                              if(Menu_Base){
                                        Menu_Base.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + ";top:" + blocBase_y + "px;left:" + blocBase_x + "px; z-index: 500; position: fixed;width: " + tailleBase + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";opacity:"+Opacity+"; cursor: default; visibility: visible;"); 
                              }

                    }else {
                              if(is_ie6up){ 
                                        if(Menu_Base){
                                                  Menu_Base.style.left = blocBase_x;
                                                  Menu_Base.style.top = blocBase_y;
                                                  Menu_Base.style.visibility = "visible";
                                        }
                              }
                    }
          }

// Déplacement menu Navigation

          if(clickOuiNavig && document.getElementById){
                    bloc_x = position_x-base_x_Navig;
                    bloc_y = position_y-base_y_Navig;
                    setCookie("ClicDroitPositionMenuNavigX",bloc_x,nextYear);
                    setCookie("ClicDroitPositionMenuNavigY",bloc_y,nextYear);
                    var Menu_principal = document.getElementById("menu_context");
                    var Menu_Edition = document.getElementById("menu_charinsert");
                    var Menu_Favoris = document.getElementById("menu_favoris");
                    var Menu_Options = document.getElementById("menu_options");
                    var Menu_Recherche = document.getElementById("searchInput2Suggest");
                    if(is_nav4up){
                              if(Menu_principal){
                                        Menu_principal.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + ";top:" + bloc_y + "px;left:" + bloc_x + "px; z-index: 500; position: fixed;width: " + taillebg + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";opacity:"+Opacity+"; cursor: default; visibility: visible;");
                              }
                              if(Menu_Recherche){
                                        supprimerElement(Menu_Recherche);
                              }
                              if(Menu_Favoris){
                                        Menu_Favoris.style.visibility = "hidden";
                              }
                    }else {
                              if(is_ie6up){ 
                                        if(Menu_principal){
                                                  Menu_principal.style.left = bloc_x;
                                                  Menu_principal.style.top = bloc_y;
                                                  Menu_principal.style.visibility = "visible";
                                        }
                                        if(Menu_Recherche){
                                                  supprimerElement(Menu_Recherche);
                                        }
                                        if(Menu_Favoris){
                                                  Menu_Favoris.style.visibility = "hidden";

                                }
                        }
                }
        }

// Déplacement menu Options

        if(clickOuiOption && document.getElementById){
                blocOPtion_x = position_x-base_x_Option;
                blocOPtion_y = position_y-base_y_Option;
                var Options = document.getElementById("menu_options");
                if(Options){
                if(is_nav4up){  // Firefox alert("FF ");
                        Options.setAttribute("style", "display:block;text-align:center;z-index:1000;position:fixed;top:" + blocOPtion_y + "px;left:" + blocOPtion_x + "px;width:"+TailleOptions+"px;border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; background-color:"+colorbg+";font-family:" + police + ";font-size:" + taillefont + "px;color:" + colorlien + ";cursor:default;visibility:visible;opacity:"+Opacity+";");
               }else {
                        if(is_ie6up){  // Internet Explorer alert("IE ");
                                Options.style.top = position_y;
                                Options.style.left = position_x;
                                Options.style.visibility = "visible";
                        }
                }
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitVisibleMenuOption","visible",nextYear);
                setCookie("ClicDroitPositionMenuOptionX",blocOPtion_x,nextYear);
                setCookie("ClicDroitPositionMenuOptionY",blocOPtion_y,nextYear);
                }
        }

// Déplacement menu Édition

          if(clickOuiEdit && document.getElementById){
                    blocEdit_x = position_x-(base_x_Edit+Decalx);
                    blocEdit_y = position_y-(base_y_Edit+Decaly);
                    setCookie("ClicDroitPositionMenuEditX",blocEdit_x,nextYear);
                    setCookie("ClicDroitPositionMenuEditY",blocEdit_y,nextYear);
                    var Menu_Edition = document.getElementById("menu_charinsert");
                    if(is_nav4up){
                              if(Menu_Edition){
                                        Menu_Edition.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 900; position: fixed;width: " + TailleModif + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top:" + blocEdit_y + "px;left:" + blocEdit_x + "px;"); 
                              }

                    }else {
                              if(is_ie6up){ 
                                        if(Menu_Edition){
                                                  Menu_Edition.style.left = blocEdit_x;
                                                  Menu_Edition.style.top = blocEdit_y;
                                                  Menu_Edition.style.visibility = "visible";
                                        }
                              }
                    }
          }

// Déplacement menu Publier

          if(clickOuiPublier && document.getElementById){
                    blocPublier_x = position_x-(base_x_Publier+Decalx);
                    blocPublier_y = position_y-(base_y_Publier+Decaly);
                    setCookie("ClicDroitPositionMenuPublierX",blocPublier_x,nextYear);
                    setCookie("ClicDroitPositionMenuPublierY",blocPublier_y,nextYear);
                    var Menu_Publier = document.getElementById("menu_Publier");
                    if(is_nav4up){
                              if(Menu_Publier){
                                        Menu_Publier.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 900; position: fixed;width: " + TaillePublier + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top:" + blocPublier_y + "px;left:" + blocPublier_x + "px;"); 
                              }

                    }else {
                              if(is_ie6up){ 
                                        if(Menu_Publier){
                                                  Menu_Publier.style.left = blocPublier_x;
                                                  Menu_Publier.style.top = blocPublier_y;
                                                  Menu_Publier.style.visibility = "visible";
                                        }
                              }
                    }
          }
}

// * * Ouverture et fermeture des menus * *

// * Ouverture du menu Principal *

function ouvrir_menu(){


          var MenuBase = document.getElementById("menu_base");
   

          if(is_nav4up){
                    if(MenuBase){ MenuBase.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 500; position: fixed;width: " + tailleBase + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top: " + (position_y-100) + "px; left: " + (position_x-tailleBase) + "px;"); }
          }else {
                    if(is_ie6up){ 
                              if(MenuBase){MenuBase.style.top = (position_y-100) ;}
                              if(MenuBase){MenuBase.style.left = (position_x-tailleBase);}
                              if(MenuBase){MenuBase.style.visibility = "visible"}
                    }
          }
          if(MenuBase){
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
          setCookie("ClicDroitVisibleMenuBase","visible",nextYear);
          setCookie("ClicDroitPositionMenuBaseX",(position_x-tailleBase),nextYear);
          setCookie("ClicDroitPositionMenuBaseY",(position_y-100),nextYear);
          }
          if(!OldClicDroit){
                    return false;
          }          
}

// * Fermeture du menu Principal *

function fermer_menu(){
     if (document.getElementById){
          var CharinsertForm = document.getElementById("menu_base");
          if(CharinsertForm){
               setCookie("ClicDroitVisibleMenuBase","visible",nextYear);CharinsertForm.style.top = 0;
               CharinsertForm.style.left = 0;
               CharinsertForm.style.visibility = "hidden";
               var now = new Date();
               var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
               setCookie("ClicDroitVisibleMenuBase","hidden",nextYear);
          }
     }
}

// * Ouverture du menu Navigation *   

function ouvrir_menu_Navig(){
          var MenuContext = document.getElementById("menu_context");
          var Suggestions = document.getElementById("searchInput2Suggest");
   
          if(is_nav4up){      // FIREFOX alert("FF" + position_x + " " + position_y);

                    MenuContext.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + ";top:" + DefaultPosMenuNavigY + "px;left:" + DefaultPosMenuNavigX  + "px; z-index: 500; position: fixed;width: " + taillebg + "px; background-color:" + colorbg + "; font-family:" + police + ";opacity:"+Opacity+";color:" + colorlien + ";opacity:"+Opacity+"; cursor: default; visibility: visible;");
                    if(Suggestions){supprimerElement(Suggestions);}
          }else {
                    if(is_ie6up){     // INTERNET EXPLORER alert("IE" + position_x + " " + position_y);

                              if(Suggestions){supprimerElement(Suggestions);}

                              MenuContext.style.top = DefaultPosMenuNavigY;
                              MenuContext.style.left = DefaultPosMenuNavigX;
                              MenuContext.style.visibility = "visible";
                    }
          }
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
          setCookie("ClicDroitVisibleMenuNavig","visible",nextYear);
          setCookie("ClicDroitPositionMenuNavigX",DefaultPosMenuNavigX,nextYear);
          setCookie("ClicDroitPositionMenuNavigY",DefaultPosMenuNavigY,nextYear);
          //fermer_menu()
}

// * Fermeture du menu Navigation *

function fermer_menu_Navig(){
     if (document.getElementById){
          var MenuContext = document.getElementById("menu_context");
          var Suggestions = document.getElementById("searchInput2Suggest");
          if(Suggestions){supprimerElement(Suggestions);}
          MenuContext.style.top = 0;
          MenuContext.style.left = 0;
          MenuContext.style.visibility = "hidden";
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
          setCookie("ClicDroitVisibleMenuNavig","hidden",nextYear);
          //fermer_menuFavoris();
     }
}

// * Ouverture du menu Favoris*

function ouvrir_menuFavoris(){

          var Favoris = document.getElementById("menu_favoris");
          if(is_nav4up){  // Firefox alert("FF ");
                    if(Favoris){Favoris.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 600; position: fixed; top: " + (position_y-base_y_Fav) + "px; left: " + (position_x-base_x_Fav) + "px; background-color:" + colorbg + "; font-family:" + police + "; font-size:" + taillefont + ";opacity:"+Opacity+"; color: " + colorlien + "; cursor: default; visibility: visible;");}
          }else {
                    if(is_ie6up){  // Internet Explorer alert("IE ");
                              if(Favoris){Favoris.style.top = (position_y-baseFav_y);}
                              if(Favoris){Favoris.style.left = (position_x-baseFav_x);}
                              if(Favoris){Favoris.style.visibility = "visible";}
                    }
          }
}

// * Fermeture du menu Favoris *

function fermer_menuFavoris(){
     if (document.getElementById){
          var Favoris = document.getElementById("menu_favoris");
          if(Favoris){Favoris.style.top = 0;}
          if(Favoris){Favoris.style.left = 0;}
          if(Favoris){Favoris.style.visibility = "hidden";}
     }
}

// * Ouverture du menu Options * 

function ouvrir_menu_options(){
        var Options = document.getElementById("menu_options");
        if(Options){
                if(is_nav4up){  // Firefox alert("FF ");
                        Options.setAttribute("style", "display:block;text-align:center;z-index:1000;position:fixed;top:" + DefaultPosMenuOptionY + "px;left:" + DefaultPosMenuOptionX + "px;width:"+TailleOptions+"px;border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; background-color:"+colorbg+";font-family:" + police + ";font-size:" + taillefont + "px;color:" + colorlien + ";cursor:default;visibility:visible;opacity:"+Opacity+";");
               }else {
                        if(is_ie6up){  // Internet Explorer alert("IE ");
                                Options.style.top = DefaultPosMenuOptionY;
                                Options.style.left = DefaultPosMenuOptionX;
                                Options.style.visibility = "visible";
                        }
                }
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitVisibleMenuOption","visible",nextYear);
                setCookie("ClicDroitPositionMenuOptionX",DefaultPosMenuOptionX,nextYear);
                setCookie("ClicDroitPositionMenuOptionY",DefaultPosMenuOptionY,nextYear);
        }
}

// * Fermeture du menu Options *

function fermer_menu_options(){
        var Options = document.getElementById("menu_options");
        if(Options){
             Options.style.visibility = "hidden";
             var now = new Date();
             var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
             setCookie("ClicDroitVisibleMenuOption","hidden",nextYear);
        } 

}

// * Ouverture du menu Edition *

function ouvrir_menu_Edition(){

          var CharinsertForm = document.getElementById("menu_charinsert");
   

          if(is_nav4up){
                    if(CharinsertForm){ CharinsertForm.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 900; position: fixed;width: " + TailleModif + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top: " + DefaultPosMenuEditY + "px; left: " + DefaultPosMenuEditX + "px;"); }
          }else {
                    if(is_ie6up){ 
                              if(CharinsertForm){CharinsertForm.style.top = DefaultPosMenuEditY ;}
                              if(CharinsertForm){CharinsertForm.style.left = DefaultPosMenuEditX;}
                              if(CharinsertForm){CharinsertForm.style.visibility = "visible"}
                    }
          }
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
          setCookie("ClicDroitVisibleMenuEdit","visible",nextYear);
          setCookie("ClicDroitPositionMenuEditX",DefaultPosMenuEditX,nextYear);
          setCookie("ClicDroitPositionMenuEditY",DefaultPosMenuEditY,nextYear);
          //fermer_menu()
}

// * Fermeture du menu Edition *

function fermer_menu_Edition(){
     if (document.getElementById){
          var CharinsertForm = document.getElementById("menu_charinsert");
          if(CharinsertForm){
               CharinsertForm.style.top = 0;
               CharinsertForm.style.left = 0;
               CharinsertForm.style.visibility = "hidden";
          }
               var now = new Date();
               var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
               setCookie("ClicDroitVisibleMenuEdit","hidden",nextYear);
     }
}

// * Ouverture du menu Publication *

function ouvrir_menu_Publier(){

          var CharinsertForm = document.getElementById("menu_Publier");
   

          if(is_nav4up){
                    if(CharinsertForm){ CharinsertForm.setAttribute("style", "border:" + Taillebd + "px " + Stylebd + " " + colorbd + "; z-index: 900; position: fixed;width: " + TaillePublier + "px; background-color:" + colorbg + "; font-family:" + police + ";color:" + colorlien + ";padding:0;margin:0;opacity:"+Opacity+";cursor: default; visibility: visible;top: " + DefaultPosMenuPublierY + "px; left: " + DefaultPosMenuPublierX + "px;"); }
          }else {
                    if(is_ie6up){ 
                              if(CharinsertForm){CharinsertForm.style.top = DefaultPosMenuPublierY ;}
                              if(CharinsertForm){CharinsertForm.style.left = DefaultPosMenuPublierX;}
                              if(CharinsertForm){CharinsertForm.style.visibility = "visible"}
                    }
          }
          var now = new Date();
          var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
          setCookie("ClicDroitVisibleMenuPublier","visible",nextYear);
          setCookie("ClicDroitPositionMenuPublierX",DefaultPosMenuPublierX,nextYear);
          setCookie("ClicDroitPositionMenuPublierY",DefaultPosMenuPublierY,nextYear);
          //fermer_menu()
}

// * Fermeture du menu Publication *

function fermer_menu_Publier(){
     if (document.getElementById){
          var CharinsertForm = document.getElementById("menu_Publier");
          if(CharinsertForm){
               CharinsertForm.style.top = 0;
               CharinsertForm.style.left = 0;
               CharinsertForm.style.visibility = "hidden";
          }
               var now = new Date();
               var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
               setCookie("ClicDroitVisibleMenuPublier","hidden",nextYear);
     }
}

// * Ouverture de tous les menus *

function ouvrir_Tous_menu(){
     ouvrir_menu_Navig();
     ouvrir_menu_Edition();
     ouvrir_menu_Publier();
     ouvrir_menu_options();
     //ouvrir_menuFavoris();
     fermer_menu()
}

// * Fermeture de tous les menus *

function fermer_Tous_menu(){
     fermer_menu_Navig();
     fermer_menu_Edition();
     fermer_menu_Publier();
     fermer_menu_options();
     fermer_menuFavoris();
}

// * * * Fonctions pour les cookies * * *

// * * Mise à jour du cookie * *
 
function setCookie (cookieName, cookieValue, expires, path) {
document.cookie = escape(cookieName) + '=' + escape(cookieValue) + (expires ? '; EXPIRES=' + expires.toGMTString() : '') + "; PATH=/" ; 
}

// * * Interrogation du cookie * *
 
function getCookie (cookieName) {
var cookieValue = null;
var posName = document.cookie.indexOf(escape(cookieName) + '=' );
if (posName != -1) {
        var posValue = posName + (escape(cookieName) + '=' ).length;
        var endPos = document.cookie.indexOf(';', posValue) ;
        if (endPos != -1) {
                cookieValue = unescape(document.cookie.substring(posValue, endPos));
        } else {
                cookieValue = unescape(document.cookie.substring(posValue));
        }
}
return cookieValue;
}

// * * * Fonctions pour les favoris * * *

// * * Ajout de la page courante * *

function storePage(){
thisPage = document.location.href;
thisPageTitle = wgPageName;
var pageList = getCookie("pageList");
var pageListTitle = getCookie("pageListTitle");
var linkFound = false;
if (pageList != "" && pageList != null) {
        pSplit = pageList.split(";");
                for (a=0;a<pSplit.length;a++) {
                }
        }
if (!linkFound) {
        if (pageList == null || pageList == ";") {
                pageList = thisPage;
                pageListTitle = thisPageTitle;
        } else {
                pageList += ";" + thisPage;
                pageListTitle += ";" + thisPageTitle;
        }
}
var now = new Date();
var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
setCookie("pageList",pageList,nextYear);
setCookie("pageListTitle",pageListTitle,nextYear);
window.location.reload();
}
 
// * * Suppression d'une page donnée * *
 
function removePage(url){
var pageListTitle = getCookie("pageListTitle");
var linkList = ""
if (pageListTitle != "" && pageListTitle != null) {
        pSplitTitle = pageListTitle.split(";");
        for (a=0;a<pSplitTitle.length;a++) {
                if (pSplitTitle[a] != url && pSplitTitle[a] != '') linkList += ";" + pSplitTitle[a];
        }
}
var now = new Date();
var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
setCookie("pageList",linkList,nextYear);
setCookie("pageListTitle",linkList,nextYear);
}

// * * Suppression d'une page de la liste (Checkboxes) * * 

function removeFav(){

        var RunRemove = false;
        var CheckFavoris =document.getElementById("favForm").CheckBoxFavoris; 
        if (CheckFavoris.length > 1){ 
                //alert('plus de 1 favoris');
                for (i=0;i<CheckFavoris.length; i++){
                        var CheckType = CheckFavoris[i].getAttribute("type");
                        var CheckName = CheckFavoris[i].getAttribute("name");
                        var CheckValue = CheckFavoris[i].getAttribute("value");
                        var CheckState = CheckFavoris[i].checked;
                        if ((CheckType == "checkbox") && (CheckFavoris[i].checked)){
                                if(PopUp==true){
                                        var suretcertain = confirm( Suppr1FavThis + '\n' + CheckValue.replace(/_/g," ") );  //   texte traduit  : var Suppr1FavThis //
                                }
                                if((suretcertain) || (PopUp=false)){ 
                                        RunRemove = true;
                                        removePage(CheckValue);
                                        //alert('Page ' + CheckValue.replace(/_/g," ") + ' Supprimée');
                                }
                        }
                }
        } else {
        //alert('mois de 1 favoris');
                var CheckType = CheckFavoris.getAttribute("type");
                var CheckName = CheckFavoris.getAttribute("name");
                var CheckValue = CheckFavoris.getAttribute("value");
                var CheckState = CheckFavoris.checked;
                //alert(CheckType +' '+ CheckName +' '+ CheckValue +' '+ CheckState);
                if ((CheckType == "checkbox") && (CheckFavoris.checked)){
                        RunRemove = true;
                        if(PopUp==true){
                                var suretcertain = confirm( Suppr1FavThis + '\n' + CheckValue.replace(/_/g," ") );  //   texte traduit  : var Suppr1FavThis //
                        }
                        if((suretcertain) || (PopUp=false)){ 
                                removePage(CheckValue);
                                //alert('Page ' + CheckValue.replace(/_/g," ") + ' Supprimée');
                        }
                }
        }     
        if(RunRemove == true){
                window.location.reload();
        } else {
                fermer_menuFavoris();
        } 
}

// * * Remise à zéro du cookie Favoris * *
 
function razCookie () {
        if(PopUp==true){
                var suretcertain=confirm(SupprAllFav);   //   texte traduit : var SupprAllFav //
        }
        if((suretcertain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("pageList","",nextYear);
                setCookie("pageListTitle","",nextYear);
                window.location.reload();
        }
}

// * * * Fonctions du survol des différent menus * * *

// * * TOUS MENUS * *

// * Fonctions de survol (hover) *

function menu_sel(selec, lienmenu){
     if(selec == 1){
          lienmenu.style.background = colorsel;
     } else {
          lienmenu.style.background =colorbg;
     }
}

function titre_sel(selec, lienmenu){
     if(selec == 1){
          lienmenu.style.background = colorbg;
          lienmenu.style.color = colorlien;
     } else {
          lienmenu.style.background =colorT;
          lienmenu.style.color = colorTt;
     }
}


// * * NAVIGATION * * 

// * Menus déroulants *

function menuderoulant(selection){
          window.location= selection.options[selection.selectedIndex].value;
}

// * * ÉDITION * * 

// * Insertion de balises Toolbar et Edittols (Edition) *

/*   ( Court-circuit de la fonction « insertTags() » de MediaWiki pour permettre d'insérer des espaces ou d'autres caractères problématiques ) 
Pour utiliser cette fonction modifiée, utiliser sur les deux variables de début et fin de tag la méthode suivante : 

         [INSERER_ICI_LA_VARIABLE].replace(" "g,/ZESPACE/).replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') 

La fonction se charge de convertir ces mots magiques à chaque occurrence.
*/

function insertTags2(tagOpenBis, tagCloseBis, sampleText) {    // Nom des variables changé
        var txtarea;
        var tagOpen = tagOpenBis.replace(/ZESPACE/g," ").replace(/ZAPOSTROPHE/g,"'").replace(/ZGUILLEMETS/g,'"').replace(/ZETOILE/g,'*').replace(/ZDIESE/g,'#');   // Ligne ajoutée : retour à la valeur d'origine
        var tagClose = tagCloseBis.replace(/ZESPACE/g," ").replace(/ZAPOSTROPHE/g,"'").replace(/ZGUILLEMETS/g,'"').replace(/ZETOILE/g,'*').replace(/ZDIESE/g,'#');   // Ligne ajoutée : retour à la valeur d'origine
        if (document.editform) {
                txtarea = currentFocused;
        } else {
// some alternate form? take the first one we can find
                var areas = document.getElementsByTagName('textarea');
                txtarea = areas[0];
        }
        var selText, isSample = false;

        if (document.selection && document.selection.createRange) { // IE/Opera

//save window scroll position
                if (document.documentElement && document.documentElement.scrollTop) var winScroll = document.documentElement.scrollTop
                else if (document.body) var winScroll = document.body.scrollTop;

//get current selection
                txtarea.focus();
                var range = document.selection.createRange();
                selText = range.text;
//insert tags
                checkSelectedText();
                range.text = tagOpen + selText + tagClose;
//mark sample text as selected
                if (isSample && range.moveStart) {
                        if (window.opera) tagClose = tagClose.replace(/\n/g,'');
                        range.moveStart('character', - tagClose.length - selText.length); 
                        range.moveEnd('character', - tagClose.length);    
                }
                range.select();
//restore window scroll position
                if (document.documentElement && document.documentElement.scrollTop) document.documentElement.scrollTop = winScroll
                else if (document.body) document.body.scrollTop = winScroll;

        } else if (txtarea.selectionStart || txtarea.selectionStart == '0') { // Mozilla

//save textarea scroll position
                var textScroll = txtarea.scrollTop;
//get current selection
                txtarea.focus();
                var startPos = txtarea.selectionStart;
                var endPos = txtarea.selectionEnd;
                selText = txtarea.value.substring(startPos, endPos);
//insert tags
                checkSelectedText();
                txtarea.value = txtarea.value.substring(0, startPos) + tagOpen + selText + tagClose + txtarea.value.substring(endPos, txtarea.value.length);
//set new selection
                if (isSample) {
                        txtarea.selectionStart = startPos + tagOpen.length;
                        txtarea.selectionEnd = startPos + tagOpen.length + selText.length;
                } else {
                        txtarea.selectionStart = startPos + tagOpen.length + selText.length + tagClose.length;
                        txtarea.selectionEnd = txtarea.selectionStart;
                }
//restore textarea scroll position
                txtarea.scrollTop = textScroll;
        }

        function checkSelectedText(){
                if (!selText) {
                        selText = sampleText;
                        isSample = true;
                } else if (selText.charAt(selText.length - 1) == ' ') { //exclude ending space char
                        selText = selText.substring(0, selText.length - 1);
                        tagClose += ' '
                }
        }
} 

// * Ajout d'un bouton à la ToolBar *

function Toolbar(messages_d, messages_f, commentaires, images, id_images, position){
        messages_debut=messages_d.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,"ZGUILLEMETS").replace(/\*/g,"ZETOILE").replace(/\#/g,"ZDIESE");
        messages_fin=messages_f.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,"ZGUILLEMETS").replace(/\*/g,"ZETOILE").replace(/\#/g,"ZDIESE");
        var ImageToolbar = "";
        var ToolbarDiv = document.getElementById("toolbar")
        if (ToolbarDiv){
                if((messages_debut.length > 0)&&(messages_fin.length > 0)){
                        ImageToolbar += '<img id="mw-editbutton-';
                        ImageToolbar += id_images;
                        ImageToolbar += '" class="mw-toolbar-editbutton" height="22" border="0" width="23" src="';
                        ImageToolbar += images;
                        ImageToolbar += '" alt="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" title="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" style="cursor:pointer;" ';
                        ImageToolbar += 'onclick="';
                        ImageToolbar += "javascript:insertTags2('"+messages_debut+"','"+messages_fin+"','')";
                        ImageToolbar += ' "/>';
                }else if((messages_debut.length > 0)||(messages_fin.length > 0)){
                        ImageToolbar += '<img id="mw-editbutton-';
                        ImageToolbar += id_images;
                        ImageToolbar += '" class="mw-toolbar-editbutton" height="22" border="0" width="23" src="';
                        ImageToolbar += images;
                        ImageToolbar += '" alt="';
                        ImageToolbar += commentaires;
                        ImageToolbar += '" title="';
                        ImageToolbar += commentaires
                        ImageToolbar += '" style="cursor:pointer;" onclick=javascript:insertTags2(';
                        ImageToolbar += "'";
                        ImageToolbar += messages_debut;
                        ImageToolbar += "','','')";
                        ImageToolbar += ' "/\>';
                }
                var ToolbarContent = ToolbarDiv.innerHTML;
                if(position != "Fin"){                
                        ToolbarDiv.innerHTML = ImageToolbar + ToolbarContent;
                }else{
                        ToolbarDiv.innerHTML = ToolbarContent + ImageToolbar;
                }
        }
}




// * Changement de la taille de la fenêtre d'édition *

function changertaille(diff) {
     var ZoneModif = document.getElementById('wpTextbox1');
     var TailleZoneModif = ZoneModif.rows;
//     alert(TailleZoneModif + ' ' + diff + ' ' + (TailleZoneModif+diff) );
     if(diff != 0) {
               ZoneModif.setAttribute('rows', (TailleZoneModif+diff) );
     } else {
          var TailleZoneModifPerso = prompt(MenuEditTextTailleBis, '30');
          if((TailleZoneModifPerso != "") && (TailleZoneModifPerso != null)){
               ZoneModif.setAttribute('rows', TailleZoneModifPerso);
          }
     }
}

// * Insertion de balise via pop-up *

function onclick_balises() {
     defaultbalise = "b";
     var balise = window.prompt(MenuEditTextBaliseBis +"<" + defaultbalise + "></" + defaultbalise + ">", defaultbalise);
     if(balise != null) insertTags2('<' 
     + balise.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS').replace(/*/g,'ZETOILE').replace(/#/g,'ZDIESE') 
     + '>','</' 
     + balise.replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS').replace(/*/g,'ZETOILE').replace(/#/g,'ZDIESE') 
     + '>', '');
}

// * * PUBLICATION * * 

// * Insertion de résumé (Edition) *

function addToSummary(str){

        var resum = document.editform.wpSummary.value;
        if(resum != 0 && resum.indexOf("*/") < resum.length - 3) {
                document.editform.wpSummary.value += " ; ";
        }
        document.editform.wpSummary.value += str;

}

/*

var MenuTextHide = '-';
var MenuTextShow = '+';

*/

function MenuClicDroit_Toggle(ID){
   var Titre = document.getElementById(ID);
   var Lien = document.getElementById(ID+'_Link');
   if(!Titre || !Lien) return;
   if(Lien.innerHTML==MenuTextHide){
      Lien.innerHTML = MenuTextShow;
      var Display = "none";
   }else{
      Lien.innerHTML = MenuTextHide;
      var Display = "block";
   }
   var Element = Titre.nextSibling;
   while(Element){
      if(Element.className){
         if(Element.className=="StopToggle") break;
      }
      if(Element.style) 
      Element.style.display = Display;
      Element = Element.nextSibling;
   }
}





// * * OPTIONS (mise à jour cookies) * * 

function SetPleinEcran(){
        if(PleinEcran==true)return;
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var certain = confirm(MenuTextOptionReload);
        }else{
                var certain = "OK";
        }
        if((certain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitPleinEcran","PleinEcran",nextYear);
                window.location.reload();
        } 
}

function SetNoPleinEcran(){
        if(PleinEcran==false)return;
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var certain = confirm(MenuTextOptionReload);
        }else{
                var certain = "OK";
        }
        if((certain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitPleinEcran","NoPleinEcran",nextYear);
                window.location.reload();
        }
}

function SetbgColor(){
        var bgColor = prompt(bgColorDefine + colorbg, "");
        if((bgColor != "") && (bgColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbgColor",bgColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetbdColor(){
        var bdColor = prompt(bdColorDefine + colorbd, "");
        if((bdColor != "") && (bdColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbdColor",bdColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetTColor(){
        var TColor = prompt(TColorDefine + colorT, "");
        if((TColor != "") && (TColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTColor",TColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetTtColor(){
        var TtColor = prompt(TtColorDefine + colorTt, "");
        if((TtColor != "") && (TtColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTtColor",TtColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetlienColor(){
        var lienColor = prompt(lienColorDefine + colorlien, "");
        if((lienColor != "") && (lienColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitlienColor",lienColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetselColor(){
        var selColor = prompt(selColorDefine + colorsel, "");
        if((selColor != "") && (selColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitselColor",selColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetMDColor(){
        var MDColor = prompt(MDColorDefine + colorMD, "");
        if((MDColor != "") && (MDColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitMDColor",MDColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetLineColor(){
        var LineColor = prompt(LineColorDefine + colorLine, "");
        if((LineColor != "") && (LineColor != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitLineColor",LineColor,nextYear);
                        window.location.reload();
                }
        }
}

function SetBaseTaille(){
        var bgTaille = prompt(BaseTailleDefine + tailleBase, "");
        if((bgTaille != "") && (bgTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbgTaille",bgTaille,nextYear);
                        window.location.reload();
                }
        }
}



function SetbgTaille(){
        var bgTaille = prompt(bgTailleDefine + taillebg, "");
        if((bgTaille != "") && (bgTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbgTaille",bgTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetListeTaille(){
        var ListeTaille = prompt(ListeTailleDefine + tailleListe, "");
        if((ListeTaille != "") && (ListeTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitListeTaille",ListeTaille,nextYear);
                        window.location.reload();
                }
        }
}


function SetOptionsTaille(){
        var OptionsTaille = prompt(OptionsTailleDefine + TailleOptions, "");
        if((OptionsTaille != "") && (OptionsTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitOptionsTaille",OptionsTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetModifTaille(){
        var ModifTaille = prompt(ModifTailleDefine + TailleModif, "");
        if((ModifTaille != "") && (ModifTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitModifTaille",ModifTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetPublierTaille(){
        var PublierTaille = prompt(PublierTailleDefine + TaillePublier, "");
        if((PublierTaille != "") && (PublierTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitPublierTaille",PublierTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetTitreTaille(){
        var TitreTaille = prompt(TitreTailleDefine + tailleTitre, "");
        if((TitreTaille != "") && (TitreTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitTitreTaille",TitreTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetfontTaille(){
        var fontTaille = prompt(fontTailleDefine + taillefont, "");
        if((fontTaille != "") && (fontTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitfontTaille",fontTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetbdTaille(){
        var bdTaille = prompt(bdTailleDefine + Taillebd, "");
        if((bdTaille != "") && (bdTaille != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitbdTaille",bdTaille,nextYear);
                        window.location.reload();
                }
        }
}

function SetStylebd(){
        var StylebdAsk = prompt(StylebdDefine + Stylebd, "");
        if((StylebdAsk != "") && (StylebdAsk != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitStylebd",StylebdAsk,nextYear);
                        window.location.reload();
                }
        }
}

function SetStylepolice(){
        var Stylepolice = prompt(StylepoliceDefine + police, "");
        if((Stylepolice != "") && (Stylepolice != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitStylepolice",Stylepolice,nextYear);
                        window.location.reload();
                }
        }
}

function SetOpacity(){
        var StyleOpacity = prompt(OpacityDefine + Opacity, "");
        if((StyleOpacity != "") && (StyleOpacity != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitOpacity",StyleOpacity,nextYear);
                        window.location.reload();
                }
        }
}
function SetArrondi(){
        var StyleArrondi = prompt(ArrondiDefine + Arrondi, "");
        if((StyleArrondi != "") && (StyleArrondi != null)){
                if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                        var certain = confirm(MenuTextOptionReload);
                }else{
                        var certain = "OK";
                }
                if((certain) || (PopUp=false)){
                        var now = new Date();
                        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                        setCookie("ClicDroitArrondi",StyleArrondi,nextYear);
                        window.location.reload();
                }
        }
}
function Raz_options(){
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var suretcertain = confirm(MenuTextOptionReload);
        }else{
                var suretcertain = "OK";
        }
        if((suretcertain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitMessage","",nextYear);
                setCookie("ClicDroitPleinEcran","",nextYear);
                setCookie("ClicDroitTColor","",nextYear);
                setCookie("ClicDroitTtColor","",nextYear);
                setCookie("ClicDroitbgColor","",nextYear);
                setCookie("ClicDroitMDColor","",nextYear);
                setCookie("ClicDroitbdColor","",nextYear);
                setCookie("ClicDroitselColor","",nextYear);
                setCookie("ClicDroitLineColor","",nextYear);
                setCookie("ClicDroitlienColor","",nextYear);
                setCookie("ClicDroitBaseTaille","",nextYear);
                setCookie("ClicDroitbgTaille","",nextYear);
                setCookie("ClicDroitListeTaille","",nextYear);
                setCookie("ClicDroitModifTaille","",nextYear);
                setCookie("ClicDroitPublierTaille","",nextYear);
                setCookie("ClicDroitOptionsTaille","",nextYear);
                setCookie("ClicDroitTitreTaille","",nextYear);
                setCookie("ClicDroitfontTaille","",nextYear);
                setCookie("ClicDroitbdTaille","",nextYear);
                setCookie("ClicDroitStylebd","",nextYear);
                setCookie("ClicDroitStylepolice","",nextYear);
                setCookie("ClicDroitOpacity","",nextYear);
                if((is_gecko)||(is_nav6up))setCookie("ClicDroitArrondi","",nextYear);

                setCookie("ClicDroitPositionMenuBaseX","",nextYear);
                setCookie("ClicDroitPositionMenuBaseY","",nextYear);
                setCookie("ClicDroitPositionMenuNavigX", "",nextYear);
                setCookie("ClicDroitPositionMenuNavigY","",nextYear);
                setCookie("ClicDroitPositionMenuOptionX", "",nextYear);
                setCookie("ClicDroitPositionMenuOptionY","",nextYear);
                setCookie("ClicDroitPositionMenuEditX", "",nextYear);
                setCookie("ClicDroitPositionMenuEditY","",nextYear);
                setCookie("ClicDroitPositionMenuPublierX", "",nextYear);
                setCookie("ClicDroitPositionMenuPublierY","",nextYear);

                setCookie("ClicDroitVisibleMenuBase", "hidden",nextYear);
                setCookie("ClicDroitVisibleMenuNavig","hidden",nextYear);
                setCookie("ClicDroitVisibleMenuOption","hidden",nextYear);
                setCookie("ClicDroitVisibleMenuEdit","hidden",nextYear);
                setCookie("ClicDroitVisibleMenuPublier","hidden",nextYear);

                window.location.reload();
        }
}

function Raz_Positions(){
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var suretcertain = confirm(MenuTextOptionReload);
        }else{
                var suretcertain = "OK";
        }
        if((suretcertain) || (PopUp=false)){
                var now = new Date();
                var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
                setCookie("ClicDroitVisibleMenuBase", "visible",nextYear);
                setCookie("ClicDroitVisibleMenuNavig","visible",nextYear);
                setCookie("ClicDroitVisibleMenuOption","visible",nextYear);
                setCookie("ClicDroitVisibleMenuEdit","visible",nextYear);
                setCookie("ClicDroitVisibleMenuPublier","visible",nextYear);

                setCookie("ClicDroitPositionMenuNavigX", "",nextYear);
                setCookie("ClicDroitPositionMenuNavigY","",nextYear);
                setCookie("ClicDroitPositionMenuOptionX", "",nextYear);
                setCookie("ClicDroitPositionMenuOptionY","",nextYear);
                setCookie("ClicDroitPositionMenuEditX", "",nextYear);
                setCookie("ClicDroitPositionMenuEditY","",nextYear);
                setCookie("ClicDroitPositionMenuPublierX", "",nextYear);
                setCookie("ClicDroitPositionMenuPublierY","",nextYear);
                window.location.reload();
        }
}

function Fix_options(){
        if (((wgAction == "edit")||(wgAction == "submit"))&&(PopUp=true)){
                var suretcertain = confirm(MenuTextOptionReload);
        }else{
                var suretcertain = "OK";
        }
        if((suretcertain) || (PopUp=false)){
                window.location.reload();
        }
}

// * * *  Suppression du message de sécurité * * *

function HideMessage(){
        var now = new Date();
        var nextYear = new Date(now.getTime() + 1000 * 60 * 60 * 24 * 365 );
        setCookie("ClicDroitMessage","Hide",nextYear);
        var Message = document.getElementById("messageAlerte");
        supprimerElement(Message);
}

/* ****  ****  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** 
/////////////////////////////////////////////////////////////// CRÉATION DES CADRES /////////////////////////////////////////////
****  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** *********  ******* ****** ****** ***** ***** ****** ******* ****** ********* */
function MenuContextuel(){

// ********************************************************************************************* MESSAGE DE SECURITE ***
        var HideAlert = "Ne plus afficher ce cadre";
        var EscapeMessage = getCookie("ClicDroitMessage");
        if ((EscapeMessage == "") || (EscapeMessage == null) || (EscapeMessage != "Hide")){
                document.write('<div id="messageAlerte" style="position:absolute;z-index:2000;top:2px;left:170px;border:1px solid black;background-color:white;" >');
                document.write('&nbsp;&nbsp;<a href="' + UrlSiteBis + 'User:' +CURRENTUSER + '/' + skin + '.js&action=edit" >' + wgUserName + '/' + skin + '.js</a> + ');
                document.write('<a href="' + UrlSiteBis + FULLPAGENAME + '&action=edit" >' + wgPageName.replace(/Utilisateur:/, "").replace(/_/, " ") + '</a> + + ');
                document.write('<a href="' + UrlSite + 'Discussion_utilisateur:Dr Brains/MenuClicDroit.js" >(Aide)</a> + + ');
                document.write('<a href="javascript:HideMessage();" >' + HideAlert + '</a>&nbsp;&nbsp;');
                document.write('</div>');
        }

// ********************************************************************************************* Cadre options ***

     document.write('<div id="menu_options" style="display:block;text-align:center;z-index:1000;position:fixed;top:'+DefaultPosMenuOptionY+'px;left:'+DefaultPosMenuOptionX+'px;width:'+TailleOptions+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility:'+DefaultVisibleMenuOption+';opacity:'+Opacity+';">');


     document.write('<div  onclick="javascript:fermer_menu_options();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + ' ' +MenuTextOption+ '</div>');

     document.write('<div onMouseDown="javascript:clickOuiOption=true;" onmouseup="clickOuiOption=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

     document.write('<div style="text-align:center;font-size:' + taillefont + 'px;" >' + MenuTextOptionAffichage + '&nbsp;&nbsp;<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetNoPleinEcran();" title="' + MenuTextOptionNoPleinEcranPop + '" style="cursor:pointer;" >' + MenuTextOptionNoPleinEcran + '</span>&nbsp;|&nbsp;<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetPleinEcran();" title="' + MenuTextOptionPleinEcranPop + '" style="cursor:pointer;" >' + MenuTextOptionPleinEcran + '</span></div>');

     document.write('<div style="font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';" >');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbgColor();" title="' + MenuTextOptionbgColorPop + '" >' + MenuTextOptionbgColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorbg + ';color:#AA55FF;" >' + colorbg + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbdColor();" title="' + MenuTextOptionbdColorPop + '" >' + MenuTextOptionbdColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorbd + ';color:#AA55FF;" >' + colorbd + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr  size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTColor();" title="' + MenuTextOptionTColorPop + '" >' + MenuTextOptionTColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorT + ';color:#AA55FF;" >' + colorT + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTtColor();" title="' + MenuTextOptionTtColorPop + '" >' + MenuTextOptionTtColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorTt + ';color:#AA55FF;" >' + colorTt + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetlienColor();" title="' + MenuTextOptionlienColorPop + '" >' + MenuTextOptionlienColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorlien + ';color:#AA55FF;" >' + colorlien + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetselColor();" title="' + MenuTextOptionselColorPop + '" >' + MenuTextOptionselColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorsel + ';color:#AA55FF;" >' + colorsel + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetMDColor();" title="' + MenuTextOptionMDColorPop + '" >' + MenuTextOptionMDColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorMD + ';color:#AA55FF;" >' + colorMD + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetLineColor();" title="' + MenuTextOptionLineColorPop + '" >' + MenuTextOptionLineColor + '&nbsp;&nbsp;<span style="border:1px dotted black;background-color:' + colorLine + ';color:#AA55FF;" >' + colorLine + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetBaseTaille();" title="' + MenuTextOptionBaseTaillePop + '" >' + MenuTextOptionBaseTaille + '&nbsp;&nbsp;<span style="color:red;" >' + tailleBase + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbgTaille();" title="' + MenuTextOptionbgTaillePop + '" >' + MenuTextOptionbgTaille + '&nbsp;&nbsp;<span style="color:red;" >' + taillebg + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetListeTaille();" title="' + MenuTextOptionListeTaillePop + '" >' + MenuTextOptionListeTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleListe + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetOptionsTaille();" title="' + MenuTextOptionOptionsTaillePop + '" >' + MenuTextOptionOptionsTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleOptions + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetModifTaille();" title="' + MenuTextOptionModifTaillePop + '" >' + MenuTextOptionModifTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TailleModif + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetPublierTaille();" title="' + MenuTextOptionPublierTaillePop + '" >' + MenuTextOptionPublierTaille + '&nbsp;&nbsp;<span style="color:red;" >' + TaillePublier + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetTitreTaille();" title="' + MenuTextOptionTitreTaillePop + '" >' + MenuTextOptionTitreTaille + '&nbsp;&nbsp;<span style="color:red;" >' + tailleTitre + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetfontTaille();" title="' + MenuTextOptionfontTaillePop + '" >' + MenuTextOptionfontTaille + '&nbsp;&nbsp;<span style="color:red;" >' + taillefont + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetbdTaille();" title="' + MenuTextOptionbdTaillePop + '" >' + MenuTextOptionbdTaille + '&nbsp;&nbsp;<span style="color:red;" >' + Taillebd + '&nbsp;px</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetStylebd();" title="' + MenuTextOptionStylebdPop + '" >' + MenuTextOptionStylebd + '&nbsp;&nbsp;<span style="color:green;" >' + Stylebd + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetStylepolice();" title="' + MenuTextOptionStylepolicePop + '" >' + MenuTextOptionStylepolice + '&nbsp;&nbsp;<span style="color:green;" >' + police + '</span>&nbsp;&nbsp;</div>');

     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetOpacity();" title="' + MenuTextOptionOpacityPop + '" >' + MenuTextOptionOpacity + '&nbsp;&nbsp;<span style="color:green;" >' + Opacity + '</span>&nbsp;&nbsp;</div>');
     if((is_gecko)||(is_nav6up)){
     document.write('<hr size="1" />');
     document.write('<div style="text-align:right;font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:SetArrondi();" title="' + MenuTextOptionArrondiPop + '" >' + MenuTextOptionArrondi + '&nbsp;&nbsp;<span style="color:green;" >' + Arrondi + '</span>&nbsp;&nbsp;</div>');
     }
     document.write('</div>');

 document.write('<div  onclick="javascript:Raz_options();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorT + ';padding:2px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextOptionRazPop + '">' + MenuTextOptionRaz + '</div>');

 document.write('<div  onclick="javascript:Fix_options();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorT + ';padding:2px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextOptionFixPop + '">' + MenuTextOptionFix + '</div>');

 document.write('<div  onclick="javascript:Raz_Positions();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorT + ';padding:2px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextPositionFixPop + '">' + MenuTextPositionFix + '</div>');



     document.write('</div>');
// ********************************************************************************************* CADRE PRINCIPAL ***


     document.write('<div id="menu_base" style="display:block;text-align:center;z-index:500;position:fixed;top:' + DefaultPosMenuBaseY +'px;left:' + DefaultPosMenuBaseX +'px;width:'+ tailleBase + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility:' + DefaultVisibleMenuBase + ';opacity:'+Opacity+';">');

     document.write('<div  onclick="javascript:fermer_menu();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + '</div>');

     document.write('<div onMouseDown="javascript:clickOuiBase=true;" onmouseup="clickOuiBase=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

     document.write('<div  onclick="javascript:ouvrir_menu_Navig();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextNavigOpen + '">' + MenuTextNavig + '</div>');

if (((wgAction == "edit")||(wgAction == "submit"))&&(wgNamespaceNumber>-1)){
     document.write('<div  onclick="javascript:ouvrir_menu_Edition();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextModifOpen + '">' + MenuEditTextEdit + '</div>');

     document.write('<div onclick="javascript:ouvrir_menu_Publier();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextPublierOpen + '">' + MenuEditTextSubmit + '</div>');

}
     document.write('<div  onclick="javascript:ouvrir_menu_options();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextOptionOpen + '">' + MenuTextOption + '</div>');

     document.write('<div  onclick="javascript:fermer_Tous_menu();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextCloseAllPop + '">' + MenuTextCloseAll + '</div>');

     document.write('<div  onclick="javascript:ouvrir_Tous_menu();" style="text-align:center;font-weight:bold;font-size:' + taillefont + 'px;background-color:' + colorbg + ';padding:' +Padding_Base+ 'px;color:' + colorlien + ';cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTextOpenAllPop + '">' + MenuTextOpenAll + '</div>');

     document.write('</div');

// ********************************************************************************************* CADRE NAVIGATION ***

     document.write('<div id="menu_context" style="display:block;text-align:center;z-index:500;position:fixed;top:'+DefaultPosMenuNavigY+'px;left:'+DefaultPosMenuNavigX+'px;width:'+taillebg+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility:'+DefaultVisibleMenuNavig+';opacity:'+Opacity+';">');

     document.write('<div  onclick="javascript:fermer_menu_Navig();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + ' ' +MenuTextNavig+ '</div>');

     document.write('<div onMouseDown="javascript:clickOuiNavig=true;" onmouseup="clickOuiNavig=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

     document.write('<hr size="1" />');

document.write('<div id="HistoryLinks" style="text-align:center;font-size:' + taillefont + 'px;" ><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"><a href="javascript:history.go(-1)" target="_self" style="text-decoration:none;color:'+colorlien+'" title="' + MenuTextLastPop + '">' + MenuTextLast + '</a></span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"><a href="javascript:history.go(1)" target="_self" style="text-decoration:none;color:'+colorlien+'" title="' + MenuTextNextPop + '">' + MenuTextNext + '</a></span></div>');

     document.write('<hr size="1" />');

     document.write('<div style="text-align:center;" ><form id="searchform2" action="/w/index.php"><input name="title" type="hidden" value="Spécial:Recherche"/><input name="search" title="' + MenuTextSearchPop + '" id="searchInput2" accessKey="C" autocomplete="off" /><br /><input name="go" title="' + MenuTextButton1Pop + '" class="searchButton" id="searchGoButton2" type="submit" value="' + MenuTextButton1 + '"/><input name="fulltext" title="' + MenuTextButton2Pop + '" class="searchButton" id="mw-searchButton2" type="submit" value="' + MenuTextButton2 + '"/></form></div>');


     document.onmousemove = position;
     document.oncontextmenu = ouvrir_menu;           
                   
//**************************************************** Pages spéciales ***

     document.write('<form><select id="Select_special" align="center" name="menuspecial" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + ';" size="1" onChange="menuderoulant(this)"  >');
     document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextspecial + ' --</option>');
     for(a=0;a<menuspeciallien.length;a++){
          if(menuspecialtexte[a].length > 0){
               if(menuspeciallien[a].length > 0){
                //confirm(menuspeciallien[a] + ' - ' + menuspecialtexte[a]);
                document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + menuspeciallien[a] + '" value="' + menuspeciallien[a] + '" target="' + menuspecialtarget[a] + '">' + menuspecialtexte[a] + '</option>');
               } else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + menuspecialtexte[a] + ' -</option>');
               }
          }
     }
     document.write('</select></form>');

//**************************************************** Actions ***

     document.write('<div id="Actions" style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';" ><b>' + MenuTextActions + '</b><a id="Actions_Link" style="float:rigth;margin-right:0.5em;" href="javascript:MenuClicDroit_Toggle(\'Actions\');">'+MenuTextHide+'</a></div>');
     if(skin=="vector"){
          var pNamespaces = document.getElementById('p-namespaces');
          var caNamespaces = pNamespaces.getElementsByTagName('a');
          for(a=0;a<caNamespaces.length;a++){
               var LienNamespaces = caNamespaces[a].innerHTML;
               var LienNamespacesHtml = caNamespaces[a].innerHTML;
               var LienNamespacesHref = caNamespaces[a].getAttribute("href");
               var LienNamespacestitle = caNamespaces[a].getAttribute("title");
               if(LienNamespacestitle==null){LienNamespacestitle= LienNamespacesHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write("'" + LienNamespacesHref + "', '_self'");
               document.write(');" title="'+LienNamespacestitle+'">' + LienNamespacesHtml + '</div>');
          }
          var pViews = document.getElementById('p-views');
          var caViews = pViews.getElementsByTagName('a');
          for(a=0;a<caViews.length;a++){
               var LienViewHtml = caViews[a].innerHTML;
               var LienViewHref = caViews[a].getAttribute("href");
               var LienViewtitle = caViews[a].getAttribute("title");
               if(LienViewtitle==null){LienViewtitle= LienViewHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write("'" + LienViewHref + "', '_self'");
               document.write(');" title="'+LienViewtitle+'">' + LienViewHtml + '</div>');
          }
     }
     var pCactions = document.getElementById('p-cactions');
     if(pCactions){
          var caActions = pCactions.getElementsByTagName('a');
          for(a=0;a<caActions.length;a++){
               var LienActionHtml = caActions[a].innerHTML;
               var LienActionHref = caActions[a].getAttribute("href");
               var LienActiontitle = caActions[a].getAttribute("title");
               if(LienActiontitle==null){LienActiontitle= LienActionHtml;}
               if(caActions[a].parentNode.parentNode.parentNode.className.indexOf("tabmenu")==-1){
                    document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
                    document.write("'" + LienActionHref + "', '_self'");
                    document.write(');" title="'+LienActiontitle+'">' + LienActionHtml + '</div>');
               }
          }
     }
     document.write('<div style="display:none" class="StopToggle">'+MenuTextShow+'</div>');
     document.write('<form><select id="Select_action" align="center" name="menuaction" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:'+colorlien+'" size="1" onChange="menuderoulant(this)">');
document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextActionBis + ' --</option>');
     for(a=0;a<menuactionlien.length;a++){
          if(menuactiontexte[a].length > 0){
               if(menuactionlien[a].length > 0){
                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + '; font-size:' + taillefont + 'px;cursor:pointer;" style="background-color:'+colorMD+'; font-family:' + police + '; font-size:' + taillefont + 'px;" title="' + menuactionlien[a] + '" value="' + menuactionlien[a] + '" target="' + menuactiontarget[a] + '">' + menuactiontexte[a] + '</option>');
               } else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+'; font-family:' + police + ';color:'+colorTt+'" >- ' + menuactiontexte[a] + ' -</option>');
               }
          }
     }
     document.write('</select></form>');

//**************************************************** Liens personnels ***


     document.write('<div id="Persos" style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';" ><b>' + MenuTextPerso + '</b><a id="Persos_Link" style="float:rigth;margin-right:0.5em;" href="javascript:MenuClicDroit_Toggle(\'Persos\');">'+MenuTextHide+'</a></div>');
     var pPerso = document.getElementById('p-personal');
     if(pPerso){
          var caPerso = pPerso.getElementsByTagName('a');
          for(a=0;a<caPerso.length;a++){
               var LienPersoHtml = caPerso[a].innerHTML;
               var LienPersoHref = caPerso[a].getAttribute("href");
               var LienPersotitle = caPerso[a].getAttribute("title");
               if(LienPersotitle==null){LienPersotitle = LienPersoHtml;}
               document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
               document.write( "'" + LienPersoHref + "', '_self'");
               document.write( ');" title="'+LienPersotitle+'">' + LienPersoHtml + '</div>');
          }
     }
     if((skin=="standard")||(skin=="cologneblue")||(skin=="nostalgia")){
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Mypage', '_self'");
          document.write( ');" title="' + wgUserName + '">' + wgUserName + '</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Myalk', '_self'");
          document.write( ');" title="Discussion ' + wgUserName + '">Discussion</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Preferences', '_self'");
          document.write( ');" title="références ' + wgUserName + '">Préférences</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Watchlist', '_self'");
          document.write( ');" title="Liste de suivi">Liste de suivi</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Contributions/" +wgUserName+ "', '_self'");
          document.write( ');" title="Contributions">Contributions</div>');
          document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
          document.write( "'" + UrlSite + "Special:Logout', '_self'");
          document.write( ');" title="Déconnexion">Déconnexion</div>');
     }
     document.write('<div style="display:none" class="StopToggle">'+MenuTextShow+'</div>');

//**************************************************** Favoris ***

        document.write('<div><hr size="1" color="' + colorLine + '" /></div>');
        document.write('<div style="text-align:center;font-size:' + taillefont + 'px;" ><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:storePage()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextAddPop + '">' + MenuTextAdd + '</span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:razCookie()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextSupprAllPop + '">' + MenuTextSupprAll + '</span><span style="color:'+colorLine+';"> | </span><span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:ouvrir_menuFavoris()" style="text-decoration:none;color:'+colorlien+';cursor:pointer;" title="' + MenuTextSuppr1Pop + '">' + MenuTextSuppr1 + '</span></div>');
        document.write('<div><hr size="1" color="' + colorLine + '" /></div>');
        document.write('<form><select id="Select-fav" align="center" name="menufavoris" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
        document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+'; " >-- ' + MenuTextFav + ' --</option>');
        var pageList = getCookie("pageList");
        var pageListTitle = getCookie("pageListTitle");
        if (pageList != "" && pageList != null) {
                pSplit = pageList.split(";")
                for (a=0;a<pSplit.length;a++) {
                        if (pSplit[a] != '' && pSplit[a] != 'null') {
                                if (pageListTitle != "" && pageListTitle != null) {
                                        pSplitTitle = pageListTitle.split(";")
                                        for (a=0;a<pSplitTitle.length;a++) {
                                                if (pSplitTitle[a] != '' && pSplitTitle[a] != 'null') {
                                                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" " title="' + UrlSite + pSplitTitle[a] + '" value="' + UrlSite + pSplitTitle[a] + '" target="_self">' + pSplitTitle[a] + '</option>');
                                                }
                                        }
                                }
                        }
                }
        } 
        document.write('</select></form>');

//**************************************************** Navigation ***

     document.write('<div id="Navig" style="text-align:center;color:' + colorTt + ';background-color:' + colorT + ';padding:2px;font-size:' + taillefont + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';"><b>' + MenuTextNavig + '</b><a id="Navig_Link" style="float:rigth;margin-right:0.5em;" href="javascript:MenuClicDroit_Toggle(\'Navig\');">'+MenuTextHide+'</a></div>');
     var Navig = document.getElementsByTagName("div")
     for(i=0;i<Navig.length;i++){
          if ((hasClass(Navig[i], "portlet" )) || (hasClass(Navig[i], "mw_portlet" )) || (hasClass(Navig[i], "portal" )) || (hasClass(Navig[i], "dbx-box" )) ){
               var Id_Navig = Navig[i].getAttribute("id");
               if( (Id_Navig != "p-personal" ) && (Id_Navig != "p-cactions" ) && (Id_Navig != "p-logo" ) && (Id_Navig != "p-lang" )&& (Id_Navig != "p-projects" )&& (Id_Navig != "p-fav" )){
                    var Liens = Navig[i].getElementsByTagName("a")
                    for(b=0;b<Liens.length;b++){
                         href_Lien = Liens[b].getAttribute("href");
                         content_Lien = Liens[b].innerHTML;
                         titleLien = Liens[b].getAttribute("title");
                         if(titleLien==null){titleLien = content_Lien;}
                         document.write('<div id="'+Id_Navig+'_MenuClicDroit" style="text-align:' + Alignt + ';background-color:'+colorbg+';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
                         document.write( "'" + href_Lien + "', '_self'");
                         document.write( ');" title="' + titleLien + '">' + content_Lien + '</div>');
                    }
                    document.write('<hr size="1" />');
               }
               if (Id_Navig == "p-lang" ){
                    var Liens = Navig[i].getElementsByTagName("a");

                    document.write('<div style="display:none" class="StopToggle">'+MenuTextShow+'</div>');
                    document.write('<form><select id="Select-lang" align="center" name="menulang" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
                    document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+'; ">-- ' + MenuTextLang + ' --</option>');

                    for(b=0;b<Liens.length;b++){
                         href_Lien = Liens[b].getAttribute("href");
                         content_Lien = Liens[b].innerHTML;
                         document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="'+href_Lien+'" value="'+href_Lien+'" target="_self">' + content_Lien + '</option>');
                    }
                    document.write('</select></form>');
                    document.write('<div ><hr size="1" color="' + colorLine + '" /></div>');
               }
          }
     }
     var div = document.getElementById('autres_projets');
     if((div) && (wgAction=="view")){
          document.write('<div style="display:none" class="StopToggle">'+MenuTextShow+'</div>');
          document.write('<form><select id="Select-projects" align="center" name="menuprojects" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
          document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextProjects + ' --</option>');
          var Liens = div.getElementsByTagName('a');
          for(b=0;b<Liens.length;b++){
               href_Lien = Liens[b].getAttribute("href");
               content_Lien = Liens[b].innerHTML;
               document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="'+href_Lien+'" value="'+href_Lien+'" target="_self">' + content_Lien + '</option>');
          }
          document.write('</select></form>');
          document.write('<div ><hr size="1" /></div>');
     }
     if((skin=="cologneblue")||(skin=="nostalgia")||(skin=="standard")){
          if((skin=="cologneblue")||(skin=="standard"))var quickbarDiv = document.getElementById("quickbar");
          if(skin=="nostalgia")var quickbarDiv = document.getElementById("topbar");
          var quickbarLinks = quickbarDiv.getElementsByTagName("a");
          if(skin=="standard"){var bdebut=1;}else{var bdebut=0;}
          for(b=bdebut;b<quickbarLinks.length;b++){
               quickbarLinkHref = quickbarLinks[b].getAttribute("href");
               quickbarLinkHtml = quickbarLinks[b].innerHTML;
               quickbarLinkTitle = quickbarLinks[b].getAttribute("title");
               if(quickbarLinkTitle==null){quickbarLinkTitle = quickbarLinkHtml;}
                         document.write('<div style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;cursor:pointer;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(');
                         document.write( "'" + quickbarLinkHref + "', '_self'");
                         document.write( ');" title="' + quickbarLinkTitle + '">' + quickbarLinkHtml + '</div>');
          }
     }


     var CategoryDiv = document.getElementById("catlinks");
     var SearchHiddenCatsDiv = document.getElementsByTagName("div");
     for(b=0;b<SearchHiddenCatsDiv.length;b++){
          if( hasClass(SearchHiddenCatsDiv[b], "hiddencats")){
                  var HiddenCatsDiv = SearchHiddenCatsDiv[b];
          }
     }
     if((CategoryDiv)||(HiddenCatsDiv)){
          document.write('<div style="display:none" class="StopToggle">'+MenuTextShow+'</div>');
          document.write('<form><select id="Select_Cats" align="center" name="menucats" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
          document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextCategory + ' --</option>');
          if(CategoryDiv){
               var CategoryLinks = CategoryDiv.getElementsByTagName("a");
               for(b=1;b<CategoryLinks.length;b++){
                    var CategoryLinksHTML = CategoryLinks[b].innerHTML;
                    if( (CategoryLinksHTML != "(–)")&&(CategoryLinksHTML != "(±)") ){
                         if( (CategoryLinksHTML == "[+]")){
                              document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + MenuTextHiddenCategory + ' -</option>');
                         }else{
                              var CategoryLinksHref = CategoryLinks[b].getAttribute("href");                         
                              document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + CategoryLinksHref + '" value="' + CategoryLinksHref + '" >' + CategoryLinksHTML + '</option>');
                         }

                    }
               }
          } 
          if(HiddenCatsDiv){
               var HiddenCatsLinks = HiddenCatsDiv.getElementsByTagName("a");
               document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + MenuTextHiddenCategory + ' -</option>');
               for(b=1;b<HiddenCatsLinks.length;b++){
                    var HiddenCatsLinksHref = HiddenCatsLinks[b].getAttribute("href"); 
                    var HiddenCatsLinksHTML = HiddenCatsLinks[b].innerHTML;
                    document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + HiddenCatsLinksHref + '" value="' + HiddenCatsLinksHref + '" >' + HiddenCatsLinksHTML + '</option>');
               }
               if(PleinEcran){supprimerElement(HiddenCatsDiv);}
           }
           document.write('</select></form>');
           document.write('<div ><hr size="1" /></div>'); 
     }

     document.write('<form><select id="Select_navig" align="center" name="menunavig" style="width:' + taillebg + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
     document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuTextNavigBis + ' --</option>');
     for(a=0;a<menunaviglien.length;a++){
          if(menunavigtexte[a].length > 0){
               if(menunaviglien[a].length > 0){
                        document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + menunaviglien[a] + '" value="' + menunaviglien[a] + '" target="' + menunavigtarget[a] + '">' + menunavigtexte[a] + '</option>');
                        }else {
               document.write('<option disabled="disabled" style="background-color:'+colorbg+';font-family:' + police + ';color:'+colorTt+'" >- ' + menunavigtexte[a] + ' -</option>');
               }
          } 
     }
     document.write('</select></form>');
          document.write('<div ><hr size="1" /></div>'); 
     document.write('</div>');

// ********************************************************************************************* CADRE FAVORIS ***

        var TailleOK = (TailleListe-TailleCancel);
        var pageListTitle = getCookie("pageListTitle");
        if (pageListTitle != "" && pageListTitle != null) {
                ListeFavoris = '<div id="menu_favoris" style="display:block;text-align:center;z-index:600;position:fixed;top:0px;left:0px;width:' + TailleListe + 'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';cursor:default;visibility: hidden;">'
                ListeFavoris += '<div style="color:' + colorTt + ';background-color:' + colorT + ';padding:2px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';font-family:' + police + ';font-size:' + taillefont + 'px;"><center><b>' + Suppr1Fav1 + '</b></center></div>'
                ListeFavoris += '<hr size="1" />';
                ListeFavoris += '<div id="CheckForm" style="text-align:left;font-family:' + police + ';font-size:' + taillefont + 'px;opacity:.8;">'
                ListeFavoris += '<form id="favForm">'
                pSplitTitle = pageListTitle.split(";")
                for (p=0;p<pSplitTitle.length;p++) {
                        if (pSplitTitle[p] != '' && pSplitTitle[p] != 'null') {
                                ListeFavoris += '<input type="checkbox" value="' + pSplitTitle[p] + '" name="CheckBoxFavoris" /><span style="cursor:pointer;text-align:' + Alignt + ';font-size:' + taillefont + 'px;" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:window.open(';
                         ListeFavoris += "'" + UrlSite + pSplitTitle[p] + "', '_self'";
                         ListeFavoris +=  ');" title="' + pSplitTitle[p].replace(/_/g," ") + '">' + pSplitTitle[p].replace(/_/g," ") + '</span><br />';
                        }
                }
                ListeFavoris += '<hr size="1" />';
                ListeFavoris += '<input type="button" style="width:' + TailleOK + 'px" value="Supprimer les pages sélectionnées" onclick="removeFav();"/>'
+ '<input type="button" style="width:' +TailleCancel+ 'px" value="Annuler" onclick="fermer_menuFavoris();"/>'
+ '</form>'
+ '</div>'
+ '</div>'
                document.write(ListeFavoris);
        }

// ********************************************************************************************* CADRE EDITION ***

        if (((wgAction == "edit")||(wgAction == "submit"))&&(wgNamespaceNumber>-1)){
                document.write('<div id="menu_charinsert" style="display:block;text-align:center;z-index:500;position:fixed;top:' + DefaultPosMenuEditY + 'px;left:' + DefaultPosMenuEditX + 'px;width:'+TailleModif+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';padding:0;margin:0;cursor:default;visibility:' + DefaultVisibleMenuEdit + ';opacity:'+Opacity+';">');

     document.write('<div  onclick="javascript:fermer_menu_Edition();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + ' ' + MenuEditTextEdit + '</div>');

     document.write('<div onMouseDown="javascript:clickOuiEdit=true;" onMouseUp="clickOuiEdit=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

                document.write('<div id="menu_modif" style="text-align:center; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';" >');
                document.write('<div id="TopEdit" style="margin-top:2px;" ><hr size="1" color="' + colorLine + '" /></div>');

//****************************************************** Taille zone d'édition ***

                var MenuTailleTitle = MenuEditTextTailleTer;
                var MenuTailleText = MenuEditTextTaille;
                document.write('<div id="menu_Taille" style="display:block;text-align:'+ Alignt+'" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuTailleTitle + '"  onclick="javascript:changertaille(');
                document.write( "0);" );
                document.write( '">' + MenuTailleText + '</div>' );

                document.write('<div style="display:inline; border:grey solid 1px; padding:1px; background-color:#E9E9E9;margin-right:0.5em;">&nbsp;'
                           + '<a href="javascript:changertaille(-20);">–20</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(-10);">–10</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(-5);">–5</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(-1);">–1</a>' 
                           + '&nbsp;&nbsp;|&nbsp;&nbsp;'
                           + '<a href="javascript:changertaille(1);">+1</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(5);">–5</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(10);">+10</a>&nbsp;&nbsp;&nbsp;' 
                           + '<a href="javascript:changertaille(20);">+20</a>' 
                           + '</div>');

//****************************************************** Toolbar ***

                var ToolBarDiv = document.getElementById("toolbar");
                if(!ToolBarDiv){
                        var OldToolbar= document.createElement("div");
                        OldToolbar.setAttribute("id","toolbar");

                        for(a=0;a<menutoolbarfin.length;a++){
                                if((menutoolbardébut[a].length > 0)||(menutoolbarfin[a].length > 0)){
                                        Toolbar(menutoolbardébut[a], menutoolbarfin[a], menutoolbarcomm[a], menutoolbarimage[a], menutoolbarimageId[a], menutoolbarimagePosition[a]);
                                }else{
                                        OldToolbar.innerHTML += '<hr size="1" />';
                                }

                        }
                        OldToolbar.setAttribute("id","OldToolBar");

                }else {
                        for(a=0;a<menutoolbarfin.length;a++){
                                if((menutoolbardébut[a].length > 0)||(menutoolbarfin[a].length > 0)){
                                        Toolbar(menutoolbardébut[a], menutoolbarfin[a], menutoolbarcomm[a], menutoolbarimage[a], menutoolbarimageId[a], menutoolbarimagePosition[a]);
                                }else{
                                        ToolBarDiv.innerHTML += '<hr size="1" />';
                                }
                        }
                        ToolBarDiv.setAttribute("id","OldToolBar");
                        ToolBarDiv.setAttribute("style","text-align:center;display:block;");
                }
                
                var OldToolBar = document.getElementById('OldToolBar');
                var NewToolbar = document.getElementById('OldToolBar').cloneNode(true);
                NewToolbar.setAttribute("id", "NewToolBar");
                NewToolbar.setAttribute("style", 'text-align:' + Alignt+';display:block;' );
                if((OldToolBar)&&(PleinEcran==true))supprimerElement(OldToolBar);
                

                var ToolBarParent= document.getElementById("TopEdit");
                var ToolBarNext = ToolBarParent.firstChild;                
                ToolBarParent.insertBefore( NewToolbar, ToolBarNext );

//****************************************************** Edittools ***

                document.write( '<hr size="1" />');
                document.write( '<div id="MenuEditools_Balise" style="display:block;text-align:' + Alignt + ';" onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)"  onclick="javascript:onclick_balises();" title="' + MenuEditTextBaliseTer + '" >'+MenuEditTextBalise+'</div>');
                var EditToolsIndex=1;
                document.write( '<hr size="1" /><div id="MenuEditools_'+EditToolsIndex+'" style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;font-family:' + police + ';">');
                for(a=0;a<menucharinsertfin.length;a++){
                        if(menucharinsertdébut[a].length > 0){
                                if(menucharinsertfin[a].length > 0){
                                        document.write( '<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:insertTags2(');
                                        document.write( "'" + menucharinsertdébut[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + "','" + menucharinsertfin[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + "','')\;");
                                        document.write( '" title="' + menucharinsertdébut[a] + ' &nabla; ' + menucharinsertfin[a] + '" >' + menucharinsertdébut[a] +  menucharinsertfin[a] + '</span> ');
                                }else {
                                        document.write( '<span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" onclick="javascript:insertTags2(');
                                        document.write( "'" + menucharinsertdébut[a] + "','','')\;");
                                        document.write( '" title="' + menucharinsertdébut[a].replace(/ /g,"ZESPACE").replace(/'/g,"ZAPOSTROPHE").replace(/"/g,'ZGUILLEMETS') + '">' + menucharinsertdébut[a].replace(/ /g,"ESPACE") + '</span> ');
                                }
                        }else{
                        EditToolsIndex=(EditToolsIndex+1);
                        document.write( '</div><hr size="1" /><div id="MenuEditools_'+EditToolsIndex+'" style="text-align:' + Alignt + ';font-size:' + taillefont + 'px;font-family:' + police + ';">');
                        }
                }
                document.write('</div><hr size="1" />');

//****************************************************** Modèles utilisés ***

     var SearchTemplateDiv = document.getElementsByTagName("div");
     for(b=0;b<SearchTemplateDiv.length;b++){
          if( hasClass(SearchTemplateDiv[b], "templatesUsed")){
                  var TemplateDiv = SearchTemplateDiv[b];
          }
     }
     if(TemplateDiv){ 
          var TemplateLinks = TemplateDiv.getElementsByTagName("a");
          document.write('<form><select id="Select_Template" align="center" name="menucats" style="width:' + TailleModif + 'px;text-align:' + Alignt + ';font-family:' + police + '; font-size:' + taillefont + 'px;color:' + colorlien + '" size="1" onChange="menuderoulant(this)">');
          document.write('<option style="background-color:'+colorT+'; font-family:' + police + ';font-weight:bold;color:'+colorTt+';" >-- ' + MenuEditTextTemplate + ' --</option>');
          for(b=1;b<TemplateLinks.length;b++){
               var TemplateLinksHTML = TemplateLinks[b].innerHTML;
               var TemplateLinksHref = TemplateLinks[b].getAttribute("href");
               if( (TemplateLinksHTML != "voir la source")&&(TemplateLinksHTML != "modifier") ){                         
                    document.write('<option style="background-color:'+colorMD+'; font-family:' + police + ';cursor:pointer;" title="' + TemplateLinksHref + '" value="' + TemplateLinksHref + '" >' + TemplateLinksHTML + '</option>');
               }
          }
          document.write('</select></form>');
          document.write('<div ><hr size="1" /></div>'); 
          if(PleinEcran){supprimerElement(TemplateDiv);}
     }
                document.write('</div>');
                document.write('</div>');

//**************************************************** Publication ***

                var OptionsButtons = document.getElementsByTagName("div");
                for(i=0;i<OptionsButtons.length;i++){
                        if (hasClass(OptionsButtons[i],"editOptions")){
                                var OldOptionsButtons = OptionsButtons[i];
                                var OldOptionsButtonsContent = OptionsButtons[i].innerHTML;
                        }
                }
                var Inputs = document.getElementsByTagName("input");
                for(i=0;i<Inputs.length;i++){
                        var InputName = Inputs[i].getAttribute("name");
                        if(InputName  == "wpEditToken"){
                                var InputToken = Inputs[i];
                                var InputEditTokenValue = Inputs[i].getAttribute("value");
                        }else{
                        continue;                     
                        }
                } 


                var OldResumeSpan = document.getElementById("wpSummaryLabel");
                var ResumeP = document.getElementById("MediaWiki-summary");
                var ResumeSpan = document.getElementById("wpSummaryLabel");
                var NewResume = "";
                var Resume = ResumeSpan.getElementsByTagName("a");
                if((Resume)&&(ResumeP)){
                        for(a=1;a<Resume.length;a++){
                                var ThisResume = Resume[a].innerHTML;                
                                NewResume += '• <span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuEditTextSubmitBis + '" onclick="javascript:addToSummary(';
                                NewResume += "'" + ThisResume + "');";
                                NewResume += '">' + ThisResume + '</span> •';
                        }
                }
                if(ResumeP){
                        for(a=0;a<menuresumetexte.length;a++){
                                if(menuresumetexte[a].length > 0){
                                        NewResume += '• <span onMouseOver="menu_sel(1, this)" onMouseOut="menu_sel(0, this)" title="' + MenuEditTextSubmitBis + '"  onclick="javascript:addToSummary(';
                                        NewResume += "'" + menuresumetexte[a] + "');";
                                        NewResume += '">' + menuresumetexte[a] + '</a></span> •';
                                }
                        }
                        ResumeSpan.innerHTML = NewResume + '<label for"wpSummary" />';
                }


                var OptionsButtons = document.getElementsByTagName("div");
                for(i=0;i<OptionsButtons.length;i++){
                        if (hasClass(OptionsButtons[i],"editOptions")){
                                var OldOptionsButtons = OptionsButtons[i];
                                var OldOptionsButtonsContent = OptionsButtons[i].innerHTML;
                        }
                }
                var Inputs = document.getElementsByTagName("input");
                for(i=0;i<Inputs.length;i++){
                        var InputName = Inputs[i].getAttribute("name");
                        if(InputName  == "wpEditToken"){
                                var InputToken = Inputs[i];
                                var InputEditTokenValue = Inputs[i].getAttribute("value");
                        }else{
                        continue;                     
                        }
                } 
                document.write( '<div id="menu_Publier" style="display:block;text-align:center;z-index:500;position:fixed;top:' + DefaultPosMenuPublierY + 'px;left:' + DefaultPosMenuPublierX + 'px;width:'+TaillePublier+'px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + '; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';padding:0;margin:0;cursor:default;visibility:' + DefaultVisibleMenuPublier + ';opacity:'+Opacity+';">');

     document.write('<div  onclick="javascript:fermer_menu_Publier();" style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:pointer;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextClosePop + '">' + MenuTextClose + ' ' + MenuEditTextSubmit + '</div>');

     document.write('<div onMouseDown="javascript:clickOuiPublier=true;" onMouseUp="clickOuiPublier=false;"  style="text-align:center;font-weight:bold;font-size:' + tailleTitre + 'px;background-color:' + colorT + ';padding:4px;border:' + Taillebd + 'px ' + Stylebd + ' ' + colorbd + ';color:' + colorTt + ';cursor:move;" onMouseOver="titre_sel(1, this)" onMouseOut="titre_sel(0, this)" title="' + MenuTextMovePop + '">' + MenuTextMove + '</div>');

                document.write( '<div class="editOptions" style="display:block;text-align:center; background-color:'+colorbg+';font-family:' + police + ';font-size:' + taillefont + 'px;color:' + colorlien + ';"  >' + OldOptionsButtonsContent + '<input name="wpEditToken" type="hidden" value="'+InputEditTokenValue+'" /></div>');
                document.write('</div>');


                var InputSum = OldOptionsButtons.getElementsByTagName("input");
                for(i=0;i<InputSum.length;i++){
                        var InputName = InputSum[i].getAttribute("name");
                        if(InputName  == "wpSummary"){
                                var InputSummary = InputSum[i];
                        }else{
                                continue;                     
                        }
                }
                if((InputSummary)&&(ResumeP))supprimerElement(InputSummary);


                var SummarySpanLabel = OldOptionsButtons.getElementsByTagName("span");
                for(i=0;i<SummarySpanLabel.length;i++){
                        var SpanLabelId = SummarySpanLabel[i].getAttribute("id");
                        if(SpanLabelId == "wpSummaryLabel"){
                                var SummaryBis = SummarySpanLabel[i];
                        }                                
                }
                if((SummaryBis)&&(ResumeP))supprimerElement(SummaryBis);
                if(ResumeP) {
                        supprimerElement(ResumeP);
                }


                if(PleinEcran==true){
                        supprimerElement(OldOptionsButtons);
                        supprimerElement(InputToken);
                }

//**************************************************** Insertion du menu de modification dans la forme ***

                var MenuEdition = document.getElementById("menu_charinsert");
                var EditForme = document.getElementById("editform");
                var EditFormeChild1 = document.getElementById("editpage-copywarn");  
                EditForme.insertBefore( MenuEdition, EditFormeChild1);
                var MenuPublier = document.getElementById("menu_Publier");
                EditForme.insertBefore( MenuPublier, EditFormeChild1);
        }

//********** Suppression des éléments non nécessaires ***

        if(PleinEcran==true){
                var Cactions = document.getElementById("p-cactions");
                if(Cactions){supprimerElement(Cactions);}
                var Personal = document.getElementById("p-personal");
                if(Personal){supprimerElement(Personal);}
                var ColumnOne = document.getElementById("column-one");
                if(ColumnOne){supprimerElement(ColumnOne);}
                var Sidebox = document.getElementById("sidebox");
                if(Sidebox){supprimerElement(Sidebox);}
                var MwPortlets = document.getElementById("mw_portlets");
                if(MwPortlets){supprimerElement(MwPortlets);}
                var Panel = document.getElementById("panel");
                if(Panel){supprimerElement(Panel);}
                var Head = document.getElementById("head");
                if(Head){supprimerElement(Head);}
                var QuickBar = document.getElementById("quickbar");
                if(QuickBar){supprimerElement(QuickBar);}
                var TopBar = document.getElementById("topbar");
                if(TopBar){supprimerElement(TopBar);}
                var Logo = document.getElementById("logo");
                if(Logo){supprimerElement(Logo);}
                var Footer = document.getElementById("footer");
                if(Footer){supprimerElement(Footer);}
                var Warning = document.getElementById("editpage-copywarn");
                if(Warning){supprimerElement(Warning);}
                var EditTools = document.getElementsByTagName("div");
                for(i=0;i<EditTools.length;i++){
                        if (hasClass(EditTools[i],"mw-editTools")){
                                supprimerElement(EditTools[i]);
                        }
                }

        }

//********** Edition par doubleclick ***


        if((wgAction != "edit")&&(wgAction != "submit")&&(skin=="monobook")){
                if((PleinEcran==true)||(DoubleClicEdit==true)){
                        var DoubleClicAction = "document.location='" + UrlSiteBis + FULLPAGENAME +"\x26action=edit';";
                        var DoubleClicBody = document.getElementById("globalWrapper");
                        DoubleClicBody.setAttribute("ondblclick", DoubleClicAction);
                }
        }
}
addOnloadHook(MenuContextuel);
//</nowiki>